/*===- TableGen'erated file -------------------------------------*- C++ -*-===*\
|*                                                                            *|
|* Register Bank Source Fragments                                             *|
|*                                                                            *|
|* Automatically generated file, do not edit!                                 *|
|*                                                                            *|
\*===----------------------------------------------------------------------===*/

#ifdef GET_REGBANK_DECLARATIONS
#undef GET_REGBANK_DECLARATIONS
namespace llvm {
namespace BPF {
enum : unsigned {
  InvalidRegBankID = ~0u,
  GPRRegBankID = 0,
  NumRegisterBanks,
};
} // end namespace BPF
} // end namespace llvm
#endif // GET_REGBANK_DECLARATIONS

#ifdef GET_TARGET_REGBANK_CLASS
#undef GET_TARGET_REGBANK_CLASS
private:
  static const RegisterBank *RegBanks[];
  static const unsigned Sizes[];

protected:
  BPFGenRegisterBankInfo(unsigned HwMode = 0);

#endif // GET_TARGET_REGBANK_CLASS

#ifdef GET_TARGET_REGBANK_IMPL
#undef GET_TARGET_REGBANK_IMPL
namespace llvm {
namespace BPF {
const uint32_t GPRRegBankCoverageData[] = {
    // 0-31
    (1u << (BPF::GPRRegClassID - 0)) |
    (1u << (BPF::GPR32RegClassID - 0)) |
    0,
};

constexpr RegisterBank GPRRegBank(/* ID */ BPF::GPRRegBankID, /* Name */ "GPRB", /* CoveredRegClasses */ GPRRegBankCoverageData, /* NumRegClasses */ 2);
} // end namespace BPF

const RegisterBank *BPFGenRegisterBankInfo::RegBanks[] = {
    &BPF::GPRRegBank,
};

const unsigned BPFGenRegisterBankInfo::Sizes[] = {
    // Mode = 0 (Default)
    64,
};

BPFGenRegisterBankInfo::BPFGenRegisterBankInfo(unsigned HwMode)
    : RegisterBankInfo(RegBanks, BPF::NumRegisterBanks, Sizes, HwMode) {
  // Assert that RegBank indices match their ID's
#ifndef NDEBUG
  for (auto RB : enumerate(RegBanks))
    assert(RB.index() == RB.value()->getID() && "Index != ID");
#endif // NDEBUG
}
} // end namespace llvm
#endif // GET_TARGET_REGBANK_IMPL
