/*===- TableGen'erated file -------------------------------------*- C++ -*-===*\
|*                                                                            *|
|* DAG Instruction Selector for the WebAssembly target                        *|
|*                                                                            *|
|* Automatically generated file, do not edit!                                 *|
|*                                                                            *|
\*===----------------------------------------------------------------------===*/

// *** NOTE: This file is #included into the middle of the target
// *** instruction selector class.  These functions are really methods.

// If GET_DAGISEL_DECL is #defined with any value, only function
// declarations will be included when this file is included.
// If GET_DAGISEL_BODY is #defined, its value should be the name of
// the instruction selector class. Function bodies will be emitted
// and each function's name will be qualified with the name of the
// class.
//
// When neither of the GET_DAGISEL* macros is defined, the functions
// are emitted inline.

#if defined(GET_DAGISEL_DECL) && defined(GET_DAGISEL_BODY)
#error GET_DAGISEL_DECL and GET_DAGISEL_BODY cannot be both defined, undef both for inline definitions
#endif

#ifdef GET_DAGISEL_BODY
#define LOCAL_DAGISEL_STRINGIZE(X) LOCAL_DAGISEL_STRINGIZE_(X)
#define LOCAL_DAGISEL_STRINGIZE_(X) #X
static_assert(sizeof(LOCAL_DAGISEL_STRINGIZE(GET_DAGISEL_BODY)) > 1,
   "GET_DAGISEL_BODY is empty: it should be defined with the class name");
#undef LOCAL_DAGISEL_STRINGIZE_
#undef LOCAL_DAGISEL_STRINGIZE
#endif

#if !defined(GET_DAGISEL_DECL) && !defined(GET_DAGISEL_BODY)
#define DAGISEL_INLINE 1
#else
#define DAGISEL_INLINE 0
#endif

#if !DAGISEL_INLINE
#define DAGISEL_CLASS_COLONCOLON GET_DAGISEL_BODY ::
#else
#define DAGISEL_CLASS_COLONCOLON
#endif

#ifdef GET_DAGISEL_DECL
void SelectCode(SDNode *N);
#endif
#if defined(GET_DAGISEL_BODY) || DAGISEL_INLINE
void DAGISEL_CLASS_COLONCOLON SelectCode(SDNode *N)
{
  // Some target values are emitted as 2 bytes, TARGET_VAL handles
  // this.
  #define TARGET_VAL(X) X & 255, unsigned(X) >> 8
  static const unsigned char MatcherTable[] = {
/*     0*/ OPC_SwitchOpcode /*116 cases */, 44|128,9/*1196*/, TARGET_VAL(ISD::ZERO_EXTEND),// ->1201
/*     5*/  OPC_Scope, 32|128,9/*1184*/, /*->1192*/ // 2 children in Scope
/*     8*/   OPC_MoveChild0,
/*     9*/   OPC_SwitchOpcode /*9 cases */, 124, TARGET_VAL(ISD::AssertZext),// ->137
/*    13*/    OPC_MoveChild0,
/*    14*/    OPC_CheckOpcode, TARGET_VAL(ISD::ATOMIC_CMP_SWAP),
/*    17*/    OPC_RecordMemRef,
/*    18*/    OPC_RecordNode, // #0 = 'atomic_cmp_swap' chained node
/*    19*/    OPC_CheckFoldableChainNode,
/*    20*/    OPC_RecordChild1, // #1 = $AddrOps32:offset:addr
/*    21*/    OPC_Scope, 56, /*->79*/ // 2 children in Scope
/*    23*/     OPC_CheckChild1TypeI32,
/*    24*/     OPC_MoveChild2,
/*    25*/     OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/*    28*/     OPC_RecordChild0, // #2 = $exp
/*    29*/     OPC_MoveSibling3,
/*    30*/     OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/*    33*/     OPC_RecordChild0, // #3 = $new
/*    34*/     OPC_MoveParent,
/*    35*/     OPC_Scope, 20, /*->57*/ // 2 children in Scope
/*    37*/      OPC_CheckPredicate1,  // Predicate_atomic_cmp_swap_8
/*    38*/      OPC_MoveParent,
/*    39*/      OPC_MoveParent,
/*    40*/      OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*    41*/      OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #4 #5
/*    43*/      OPC_EmitMergeInputChains1_0,
/*    44*/      OPC_EmitInteger32, 0, 
/*    46*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_CMPXCHG_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 5/*#Ops*/, 6, 4, 5, 2, 3, 
                // Src: (zext:{ *:[i64] } (assertzext:{ *:[i32] } (atomic_cmp_swap:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$exp), (trunc:{ *:[i32] } i64:{ *:[i64] }:$new))<<P:Predicate_atomic_cmp_swap_8>>)) - Complexity = 25
                // Dst: (ATOMIC_RMW8_U_CMPXCHG_I64_A32:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i64] }:$exp, ?:{ *:[i64] }:$new)
/*    57*/     /*Scope*/ 20, /*->78*/
/*    58*/      OPC_CheckPredicate2,  // Predicate_atomic_cmp_swap_16
/*    59*/      OPC_MoveParent,
/*    60*/      OPC_MoveParent,
/*    61*/      OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*    62*/      OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #4 #5
/*    64*/      OPC_EmitMergeInputChains1_0,
/*    65*/      OPC_EmitInteger32, 0, 
/*    67*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_CMPXCHG_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 5/*#Ops*/, 6, 4, 5, 2, 3, 
                // Src: (zext:{ *:[i64] } (assertzext:{ *:[i32] } (atomic_cmp_swap:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$exp), (trunc:{ *:[i32] } i64:{ *:[i64] }:$new))<<P:Predicate_atomic_cmp_swap_16>>)) - Complexity = 25
                // Dst: (ATOMIC_RMW16_U_CMPXCHG_I64_A32:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i64] }:$exp, ?:{ *:[i64] }:$new)
/*    78*/     0, /*End of Scope*/
/*    79*/    /*Scope*/ 56, /*->136*/
/*    80*/     OPC_CheckChild1TypeI64,
/*    81*/     OPC_MoveChild2,
/*    82*/     OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/*    85*/     OPC_RecordChild0, // #2 = $exp
/*    86*/     OPC_MoveSibling3,
/*    87*/     OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/*    90*/     OPC_RecordChild0, // #3 = $new
/*    91*/     OPC_MoveParent,
/*    92*/     OPC_Scope, 20, /*->114*/ // 2 children in Scope
/*    94*/      OPC_CheckPredicate1,  // Predicate_atomic_cmp_swap_8
/*    95*/      OPC_MoveParent,
/*    96*/      OPC_MoveParent,
/*    97*/      OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*    98*/      OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #4 #5
/*   100*/      OPC_EmitMergeInputChains1_0,
/*   101*/      OPC_EmitInteger32, 0, 
/*   103*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_CMPXCHG_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 5/*#Ops*/, 6, 4, 5, 2, 3, 
                // Src: (zext:{ *:[i64] } (assertzext:{ *:[i32] } (atomic_cmp_swap:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$exp), (trunc:{ *:[i32] } i64:{ *:[i64] }:$new))<<P:Predicate_atomic_cmp_swap_8>>)) - Complexity = 25
                // Dst: (ATOMIC_RMW8_U_CMPXCHG_I64_A64:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i64] }:$exp, ?:{ *:[i64] }:$new)
/*   114*/     /*Scope*/ 20, /*->135*/
/*   115*/      OPC_CheckPredicate2,  // Predicate_atomic_cmp_swap_16
/*   116*/      OPC_MoveParent,
/*   117*/      OPC_MoveParent,
/*   118*/      OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*   119*/      OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #4 #5
/*   121*/      OPC_EmitMergeInputChains1_0,
/*   122*/      OPC_EmitInteger32, 0, 
/*   124*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_CMPXCHG_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 5/*#Ops*/, 6, 4, 5, 2, 3, 
                // Src: (zext:{ *:[i64] } (assertzext:{ *:[i32] } (atomic_cmp_swap:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$exp), (trunc:{ *:[i32] } i64:{ *:[i64] }:$new))<<P:Predicate_atomic_cmp_swap_16>>)) - Complexity = 25
                // Dst: (ATOMIC_RMW16_U_CMPXCHG_I64_A64:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i64] }:$exp, ?:{ *:[i64] }:$new)
/*   135*/     0, /*End of Scope*/
/*   136*/    0, /*End of Scope*/
/*   137*/   /*SwitchOpcode*/ 69, TARGET_VAL(ISD::ATOMIC_CMP_SWAP),// ->209
/*   140*/    OPC_RecordMemRef,
/*   141*/    OPC_RecordNode, // #0 = 'atomic_cmp_swap' chained node
/*   142*/    OPC_RecordChild1, // #1 = $AddrOps32:offset:addr
/*   143*/    OPC_Scope, 31, /*->176*/ // 2 children in Scope
/*   145*/     OPC_CheckChild1TypeI32,
/*   146*/     OPC_MoveChild2,
/*   147*/     OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/*   150*/     OPC_RecordChild0, // #2 = $exp
/*   151*/     OPC_MoveSibling3,
/*   152*/     OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/*   155*/     OPC_RecordChild0, // #3 = $new
/*   156*/     OPC_MoveParent,
/*   157*/     OPC_CheckPredicate3,  // Predicate_atomic_cmp_swap_32
/*   158*/     OPC_MoveParent,
/*   159*/     OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*   160*/     OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #4 #5
/*   162*/     OPC_EmitMergeInputChains1_0,
/*   163*/     OPC_EmitInteger32, 0, 
/*   165*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW32_U_CMPXCHG_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::i64, 5/*#Ops*/, 6, 4, 5, 2, 3, 
               // Src: (zext:{ *:[i64] } (atomic_cmp_swap:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$exp), (trunc:{ *:[i32] } i64:{ *:[i64] }:$new))<<P:Predicate_atomic_cmp_swap_32>>) - Complexity = 22
               // Dst: (ATOMIC_RMW32_U_CMPXCHG_I64_A32:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i64] }:$exp, ?:{ *:[i64] }:$new)
/*   176*/    /*Scope*/ 31, /*->208*/
/*   177*/     OPC_CheckChild1TypeI64,
/*   178*/     OPC_MoveChild2,
/*   179*/     OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/*   182*/     OPC_RecordChild0, // #2 = $exp
/*   183*/     OPC_MoveSibling3,
/*   184*/     OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/*   187*/     OPC_RecordChild0, // #3 = $new
/*   188*/     OPC_MoveParent,
/*   189*/     OPC_CheckPredicate3,  // Predicate_atomic_cmp_swap_32
/*   190*/     OPC_MoveParent,
/*   191*/     OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*   192*/     OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #4 #5
/*   194*/     OPC_EmitMergeInputChains1_0,
/*   195*/     OPC_EmitInteger32, 0, 
/*   197*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW32_U_CMPXCHG_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::i64, 5/*#Ops*/, 6, 4, 5, 2, 3, 
               // Src: (zext:{ *:[i64] } (atomic_cmp_swap:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$exp), (trunc:{ *:[i32] } i64:{ *:[i64] }:$new))<<P:Predicate_atomic_cmp_swap_32>>) - Complexity = 22
               // Dst: (ATOMIC_RMW32_U_CMPXCHG_I64_A64:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i64] }:$exp, ?:{ *:[i64] }:$new)
/*   208*/    0, /*End of Scope*/
/*   209*/   /*SwitchOpcode*/ 11|128,1/*139*/, TARGET_VAL(ISD::ATOMIC_LOAD_ADD),// ->352
/*   213*/    OPC_RecordMemRef,
/*   214*/    OPC_RecordNode, // #0 = 'atomic_load_add' chained node
/*   215*/    OPC_RecordChild1, // #1 = $AddrOps32:offset:addr
/*   216*/    OPC_Scope, 66, /*->284*/ // 2 children in Scope
/*   218*/     OPC_CheckChild1TypeI32,
/*   219*/     OPC_MoveChild2,
/*   220*/     OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/*   223*/     OPC_RecordChild0, // #2 = $val
/*   224*/     OPC_MoveParent,
/*   225*/     OPC_Scope, 18, /*->245*/ // 3 children in Scope
/*   227*/      OPC_CheckPredicate1,  // Predicate_atomic_load_add_8
/*   228*/      OPC_MoveParent,
/*   229*/      OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*   230*/      OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*   232*/      OPC_EmitMergeInputChains1_0,
/*   233*/      OPC_EmitInteger32, 0, 
/*   235*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_ADD_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (zext:{ *:[i64] } (atomic_load_add:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_add_8>>) - Complexity = 19
                // Dst: (ATOMIC_RMW8_U_ADD_I64_A32:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i64] }:$val)
/*   245*/     /*Scope*/ 18, /*->264*/
/*   246*/      OPC_CheckPredicate2,  // Predicate_atomic_load_add_16
/*   247*/      OPC_MoveParent,
/*   248*/      OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*   249*/      OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*   251*/      OPC_EmitMergeInputChains1_0,
/*   252*/      OPC_EmitInteger32, 0, 
/*   254*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_ADD_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (zext:{ *:[i64] } (atomic_load_add:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_add_16>>) - Complexity = 19
                // Dst: (ATOMIC_RMW16_U_ADD_I64_A32:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i64] }:$val)
/*   264*/     /*Scope*/ 18, /*->283*/
/*   265*/      OPC_CheckPredicate3,  // Predicate_atomic_load_add_32
/*   266*/      OPC_MoveParent,
/*   267*/      OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*   268*/      OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*   270*/      OPC_EmitMergeInputChains1_0,
/*   271*/      OPC_EmitInteger32, 0, 
/*   273*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW32_U_ADD_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (zext:{ *:[i64] } (atomic_load_add:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_add_32>>) - Complexity = 19
                // Dst: (ATOMIC_RMW32_U_ADD_I64_A32:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i64] }:$val)
/*   283*/     0, /*End of Scope*/
/*   284*/    /*Scope*/ 66, /*->351*/
/*   285*/     OPC_CheckChild1TypeI64,
/*   286*/     OPC_MoveChild2,
/*   287*/     OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/*   290*/     OPC_RecordChild0, // #2 = $val
/*   291*/     OPC_MoveParent,
/*   292*/     OPC_Scope, 18, /*->312*/ // 3 children in Scope
/*   294*/      OPC_CheckPredicate1,  // Predicate_atomic_load_add_8
/*   295*/      OPC_MoveParent,
/*   296*/      OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*   297*/      OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*   299*/      OPC_EmitMergeInputChains1_0,
/*   300*/      OPC_EmitInteger32, 0, 
/*   302*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_ADD_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (zext:{ *:[i64] } (atomic_load_add:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_add_8>>) - Complexity = 19
                // Dst: (ATOMIC_RMW8_U_ADD_I64_A64:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i64] }:$val)
/*   312*/     /*Scope*/ 18, /*->331*/
/*   313*/      OPC_CheckPredicate2,  // Predicate_atomic_load_add_16
/*   314*/      OPC_MoveParent,
/*   315*/      OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*   316*/      OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*   318*/      OPC_EmitMergeInputChains1_0,
/*   319*/      OPC_EmitInteger32, 0, 
/*   321*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_ADD_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (zext:{ *:[i64] } (atomic_load_add:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_add_16>>) - Complexity = 19
                // Dst: (ATOMIC_RMW16_U_ADD_I64_A64:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i64] }:$val)
/*   331*/     /*Scope*/ 18, /*->350*/
/*   332*/      OPC_CheckPredicate3,  // Predicate_atomic_load_add_32
/*   333*/      OPC_MoveParent,
/*   334*/      OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*   335*/      OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*   337*/      OPC_EmitMergeInputChains1_0,
/*   338*/      OPC_EmitInteger32, 0, 
/*   340*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW32_U_ADD_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (zext:{ *:[i64] } (atomic_load_add:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_add_32>>) - Complexity = 19
                // Dst: (ATOMIC_RMW32_U_ADD_I64_A64:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i64] }:$val)
/*   350*/     0, /*End of Scope*/
/*   351*/    0, /*End of Scope*/
/*   352*/   /*SwitchOpcode*/ 11|128,1/*139*/, TARGET_VAL(ISD::ATOMIC_LOAD_SUB),// ->495
/*   356*/    OPC_RecordMemRef,
/*   357*/    OPC_RecordNode, // #0 = 'atomic_load_sub' chained node
/*   358*/    OPC_RecordChild1, // #1 = $AddrOps32:offset:addr
/*   359*/    OPC_Scope, 66, /*->427*/ // 2 children in Scope
/*   361*/     OPC_CheckChild1TypeI32,
/*   362*/     OPC_MoveChild2,
/*   363*/     OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/*   366*/     OPC_RecordChild0, // #2 = $val
/*   367*/     OPC_MoveParent,
/*   368*/     OPC_Scope, 18, /*->388*/ // 3 children in Scope
/*   370*/      OPC_CheckPredicate1,  // Predicate_atomic_load_sub_8
/*   371*/      OPC_MoveParent,
/*   372*/      OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*   373*/      OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*   375*/      OPC_EmitMergeInputChains1_0,
/*   376*/      OPC_EmitInteger32, 0, 
/*   378*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_SUB_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (zext:{ *:[i64] } (atomic_load_sub:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_sub_8>>) - Complexity = 19
                // Dst: (ATOMIC_RMW8_U_SUB_I64_A32:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i64] }:$val)
/*   388*/     /*Scope*/ 18, /*->407*/
/*   389*/      OPC_CheckPredicate2,  // Predicate_atomic_load_sub_16
/*   390*/      OPC_MoveParent,
/*   391*/      OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*   392*/      OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*   394*/      OPC_EmitMergeInputChains1_0,
/*   395*/      OPC_EmitInteger32, 0, 
/*   397*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_SUB_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (zext:{ *:[i64] } (atomic_load_sub:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_sub_16>>) - Complexity = 19
                // Dst: (ATOMIC_RMW16_U_SUB_I64_A32:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i64] }:$val)
/*   407*/     /*Scope*/ 18, /*->426*/
/*   408*/      OPC_CheckPredicate3,  // Predicate_atomic_load_sub_32
/*   409*/      OPC_MoveParent,
/*   410*/      OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*   411*/      OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*   413*/      OPC_EmitMergeInputChains1_0,
/*   414*/      OPC_EmitInteger32, 0, 
/*   416*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW32_U_SUB_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (zext:{ *:[i64] } (atomic_load_sub:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_sub_32>>) - Complexity = 19
                // Dst: (ATOMIC_RMW32_U_SUB_I64_A32:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i64] }:$val)
/*   426*/     0, /*End of Scope*/
/*   427*/    /*Scope*/ 66, /*->494*/
/*   428*/     OPC_CheckChild1TypeI64,
/*   429*/     OPC_MoveChild2,
/*   430*/     OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/*   433*/     OPC_RecordChild0, // #2 = $val
/*   434*/     OPC_MoveParent,
/*   435*/     OPC_Scope, 18, /*->455*/ // 3 children in Scope
/*   437*/      OPC_CheckPredicate1,  // Predicate_atomic_load_sub_8
/*   438*/      OPC_MoveParent,
/*   439*/      OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*   440*/      OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*   442*/      OPC_EmitMergeInputChains1_0,
/*   443*/      OPC_EmitInteger32, 0, 
/*   445*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_SUB_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (zext:{ *:[i64] } (atomic_load_sub:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_sub_8>>) - Complexity = 19
                // Dst: (ATOMIC_RMW8_U_SUB_I64_A64:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i64] }:$val)
/*   455*/     /*Scope*/ 18, /*->474*/
/*   456*/      OPC_CheckPredicate2,  // Predicate_atomic_load_sub_16
/*   457*/      OPC_MoveParent,
/*   458*/      OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*   459*/      OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*   461*/      OPC_EmitMergeInputChains1_0,
/*   462*/      OPC_EmitInteger32, 0, 
/*   464*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_SUB_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (zext:{ *:[i64] } (atomic_load_sub:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_sub_16>>) - Complexity = 19
                // Dst: (ATOMIC_RMW16_U_SUB_I64_A64:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i64] }:$val)
/*   474*/     /*Scope*/ 18, /*->493*/
/*   475*/      OPC_CheckPredicate3,  // Predicate_atomic_load_sub_32
/*   476*/      OPC_MoveParent,
/*   477*/      OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*   478*/      OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*   480*/      OPC_EmitMergeInputChains1_0,
/*   481*/      OPC_EmitInteger32, 0, 
/*   483*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW32_U_SUB_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (zext:{ *:[i64] } (atomic_load_sub:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_sub_32>>) - Complexity = 19
                // Dst: (ATOMIC_RMW32_U_SUB_I64_A64:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i64] }:$val)
/*   493*/     0, /*End of Scope*/
/*   494*/    0, /*End of Scope*/
/*   495*/   /*SwitchOpcode*/ 11|128,1/*139*/, TARGET_VAL(ISD::ATOMIC_LOAD_AND),// ->638
/*   499*/    OPC_RecordMemRef,
/*   500*/    OPC_RecordNode, // #0 = 'atomic_load_and' chained node
/*   501*/    OPC_RecordChild1, // #1 = $AddrOps32:offset:addr
/*   502*/    OPC_Scope, 66, /*->570*/ // 2 children in Scope
/*   504*/     OPC_CheckChild1TypeI32,
/*   505*/     OPC_MoveChild2,
/*   506*/     OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/*   509*/     OPC_RecordChild0, // #2 = $val
/*   510*/     OPC_MoveParent,
/*   511*/     OPC_Scope, 18, /*->531*/ // 3 children in Scope
/*   513*/      OPC_CheckPredicate1,  // Predicate_atomic_load_and_8
/*   514*/      OPC_MoveParent,
/*   515*/      OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*   516*/      OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*   518*/      OPC_EmitMergeInputChains1_0,
/*   519*/      OPC_EmitInteger32, 0, 
/*   521*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_AND_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (zext:{ *:[i64] } (atomic_load_and:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_and_8>>) - Complexity = 19
                // Dst: (ATOMIC_RMW8_U_AND_I64_A32:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i64] }:$val)
/*   531*/     /*Scope*/ 18, /*->550*/
/*   532*/      OPC_CheckPredicate2,  // Predicate_atomic_load_and_16
/*   533*/      OPC_MoveParent,
/*   534*/      OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*   535*/      OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*   537*/      OPC_EmitMergeInputChains1_0,
/*   538*/      OPC_EmitInteger32, 0, 
/*   540*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_AND_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (zext:{ *:[i64] } (atomic_load_and:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_and_16>>) - Complexity = 19
                // Dst: (ATOMIC_RMW16_U_AND_I64_A32:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i64] }:$val)
/*   550*/     /*Scope*/ 18, /*->569*/
/*   551*/      OPC_CheckPredicate3,  // Predicate_atomic_load_and_32
/*   552*/      OPC_MoveParent,
/*   553*/      OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*   554*/      OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*   556*/      OPC_EmitMergeInputChains1_0,
/*   557*/      OPC_EmitInteger32, 0, 
/*   559*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW32_U_AND_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (zext:{ *:[i64] } (atomic_load_and:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_and_32>>) - Complexity = 19
                // Dst: (ATOMIC_RMW32_U_AND_I64_A32:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i64] }:$val)
/*   569*/     0, /*End of Scope*/
/*   570*/    /*Scope*/ 66, /*->637*/
/*   571*/     OPC_CheckChild1TypeI64,
/*   572*/     OPC_MoveChild2,
/*   573*/     OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/*   576*/     OPC_RecordChild0, // #2 = $val
/*   577*/     OPC_MoveParent,
/*   578*/     OPC_Scope, 18, /*->598*/ // 3 children in Scope
/*   580*/      OPC_CheckPredicate1,  // Predicate_atomic_load_and_8
/*   581*/      OPC_MoveParent,
/*   582*/      OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*   583*/      OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*   585*/      OPC_EmitMergeInputChains1_0,
/*   586*/      OPC_EmitInteger32, 0, 
/*   588*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_AND_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (zext:{ *:[i64] } (atomic_load_and:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_and_8>>) - Complexity = 19
                // Dst: (ATOMIC_RMW8_U_AND_I64_A64:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i64] }:$val)
/*   598*/     /*Scope*/ 18, /*->617*/
/*   599*/      OPC_CheckPredicate2,  // Predicate_atomic_load_and_16
/*   600*/      OPC_MoveParent,
/*   601*/      OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*   602*/      OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*   604*/      OPC_EmitMergeInputChains1_0,
/*   605*/      OPC_EmitInteger32, 0, 
/*   607*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_AND_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (zext:{ *:[i64] } (atomic_load_and:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_and_16>>) - Complexity = 19
                // Dst: (ATOMIC_RMW16_U_AND_I64_A64:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i64] }:$val)
/*   617*/     /*Scope*/ 18, /*->636*/
/*   618*/      OPC_CheckPredicate3,  // Predicate_atomic_load_and_32
/*   619*/      OPC_MoveParent,
/*   620*/      OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*   621*/      OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*   623*/      OPC_EmitMergeInputChains1_0,
/*   624*/      OPC_EmitInteger32, 0, 
/*   626*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW32_U_AND_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (zext:{ *:[i64] } (atomic_load_and:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_and_32>>) - Complexity = 19
                // Dst: (ATOMIC_RMW32_U_AND_I64_A64:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i64] }:$val)
/*   636*/     0, /*End of Scope*/
/*   637*/    0, /*End of Scope*/
/*   638*/   /*SwitchOpcode*/ 11|128,1/*139*/, TARGET_VAL(ISD::ATOMIC_LOAD_OR),// ->781
/*   642*/    OPC_RecordMemRef,
/*   643*/    OPC_RecordNode, // #0 = 'atomic_load_or' chained node
/*   644*/    OPC_RecordChild1, // #1 = $AddrOps32:offset:addr
/*   645*/    OPC_Scope, 66, /*->713*/ // 2 children in Scope
/*   647*/     OPC_CheckChild1TypeI32,
/*   648*/     OPC_MoveChild2,
/*   649*/     OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/*   652*/     OPC_RecordChild0, // #2 = $val
/*   653*/     OPC_MoveParent,
/*   654*/     OPC_Scope, 18, /*->674*/ // 3 children in Scope
/*   656*/      OPC_CheckPredicate1,  // Predicate_atomic_load_or_8
/*   657*/      OPC_MoveParent,
/*   658*/      OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*   659*/      OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*   661*/      OPC_EmitMergeInputChains1_0,
/*   662*/      OPC_EmitInteger32, 0, 
/*   664*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_OR_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (zext:{ *:[i64] } (atomic_load_or:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_or_8>>) - Complexity = 19
                // Dst: (ATOMIC_RMW8_U_OR_I64_A32:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i64] }:$val)
/*   674*/     /*Scope*/ 18, /*->693*/
/*   675*/      OPC_CheckPredicate2,  // Predicate_atomic_load_or_16
/*   676*/      OPC_MoveParent,
/*   677*/      OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*   678*/      OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*   680*/      OPC_EmitMergeInputChains1_0,
/*   681*/      OPC_EmitInteger32, 0, 
/*   683*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_OR_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (zext:{ *:[i64] } (atomic_load_or:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_or_16>>) - Complexity = 19
                // Dst: (ATOMIC_RMW16_U_OR_I64_A32:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i64] }:$val)
/*   693*/     /*Scope*/ 18, /*->712*/
/*   694*/      OPC_CheckPredicate3,  // Predicate_atomic_load_or_32
/*   695*/      OPC_MoveParent,
/*   696*/      OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*   697*/      OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*   699*/      OPC_EmitMergeInputChains1_0,
/*   700*/      OPC_EmitInteger32, 0, 
/*   702*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW32_U_OR_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (zext:{ *:[i64] } (atomic_load_or:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_or_32>>) - Complexity = 19
                // Dst: (ATOMIC_RMW32_U_OR_I64_A32:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i64] }:$val)
/*   712*/     0, /*End of Scope*/
/*   713*/    /*Scope*/ 66, /*->780*/
/*   714*/     OPC_CheckChild1TypeI64,
/*   715*/     OPC_MoveChild2,
/*   716*/     OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/*   719*/     OPC_RecordChild0, // #2 = $val
/*   720*/     OPC_MoveParent,
/*   721*/     OPC_Scope, 18, /*->741*/ // 3 children in Scope
/*   723*/      OPC_CheckPredicate1,  // Predicate_atomic_load_or_8
/*   724*/      OPC_MoveParent,
/*   725*/      OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*   726*/      OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*   728*/      OPC_EmitMergeInputChains1_0,
/*   729*/      OPC_EmitInteger32, 0, 
/*   731*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_OR_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (zext:{ *:[i64] } (atomic_load_or:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_or_8>>) - Complexity = 19
                // Dst: (ATOMIC_RMW8_U_OR_I64_A64:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i64] }:$val)
/*   741*/     /*Scope*/ 18, /*->760*/
/*   742*/      OPC_CheckPredicate2,  // Predicate_atomic_load_or_16
/*   743*/      OPC_MoveParent,
/*   744*/      OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*   745*/      OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*   747*/      OPC_EmitMergeInputChains1_0,
/*   748*/      OPC_EmitInteger32, 0, 
/*   750*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_OR_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (zext:{ *:[i64] } (atomic_load_or:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_or_16>>) - Complexity = 19
                // Dst: (ATOMIC_RMW16_U_OR_I64_A64:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i64] }:$val)
/*   760*/     /*Scope*/ 18, /*->779*/
/*   761*/      OPC_CheckPredicate3,  // Predicate_atomic_load_or_32
/*   762*/      OPC_MoveParent,
/*   763*/      OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*   764*/      OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*   766*/      OPC_EmitMergeInputChains1_0,
/*   767*/      OPC_EmitInteger32, 0, 
/*   769*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW32_U_OR_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (zext:{ *:[i64] } (atomic_load_or:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_or_32>>) - Complexity = 19
                // Dst: (ATOMIC_RMW32_U_OR_I64_A64:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i64] }:$val)
/*   779*/     0, /*End of Scope*/
/*   780*/    0, /*End of Scope*/
/*   781*/   /*SwitchOpcode*/ 11|128,1/*139*/, TARGET_VAL(ISD::ATOMIC_LOAD_XOR),// ->924
/*   785*/    OPC_RecordMemRef,
/*   786*/    OPC_RecordNode, // #0 = 'atomic_load_xor' chained node
/*   787*/    OPC_RecordChild1, // #1 = $AddrOps32:offset:addr
/*   788*/    OPC_Scope, 66, /*->856*/ // 2 children in Scope
/*   790*/     OPC_CheckChild1TypeI32,
/*   791*/     OPC_MoveChild2,
/*   792*/     OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/*   795*/     OPC_RecordChild0, // #2 = $val
/*   796*/     OPC_MoveParent,
/*   797*/     OPC_Scope, 18, /*->817*/ // 3 children in Scope
/*   799*/      OPC_CheckPredicate1,  // Predicate_atomic_load_xor_8
/*   800*/      OPC_MoveParent,
/*   801*/      OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*   802*/      OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*   804*/      OPC_EmitMergeInputChains1_0,
/*   805*/      OPC_EmitInteger32, 0, 
/*   807*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_XOR_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (zext:{ *:[i64] } (atomic_load_xor:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_xor_8>>) - Complexity = 19
                // Dst: (ATOMIC_RMW8_U_XOR_I64_A32:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i64] }:$val)
/*   817*/     /*Scope*/ 18, /*->836*/
/*   818*/      OPC_CheckPredicate2,  // Predicate_atomic_load_xor_16
/*   819*/      OPC_MoveParent,
/*   820*/      OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*   821*/      OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*   823*/      OPC_EmitMergeInputChains1_0,
/*   824*/      OPC_EmitInteger32, 0, 
/*   826*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_XOR_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (zext:{ *:[i64] } (atomic_load_xor:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_xor_16>>) - Complexity = 19
                // Dst: (ATOMIC_RMW16_U_XOR_I64_A32:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i64] }:$val)
/*   836*/     /*Scope*/ 18, /*->855*/
/*   837*/      OPC_CheckPredicate3,  // Predicate_atomic_load_xor_32
/*   838*/      OPC_MoveParent,
/*   839*/      OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*   840*/      OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*   842*/      OPC_EmitMergeInputChains1_0,
/*   843*/      OPC_EmitInteger32, 0, 
/*   845*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW32_U_XOR_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (zext:{ *:[i64] } (atomic_load_xor:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_xor_32>>) - Complexity = 19
                // Dst: (ATOMIC_RMW32_U_XOR_I64_A32:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i64] }:$val)
/*   855*/     0, /*End of Scope*/
/*   856*/    /*Scope*/ 66, /*->923*/
/*   857*/     OPC_CheckChild1TypeI64,
/*   858*/     OPC_MoveChild2,
/*   859*/     OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/*   862*/     OPC_RecordChild0, // #2 = $val
/*   863*/     OPC_MoveParent,
/*   864*/     OPC_Scope, 18, /*->884*/ // 3 children in Scope
/*   866*/      OPC_CheckPredicate1,  // Predicate_atomic_load_xor_8
/*   867*/      OPC_MoveParent,
/*   868*/      OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*   869*/      OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*   871*/      OPC_EmitMergeInputChains1_0,
/*   872*/      OPC_EmitInteger32, 0, 
/*   874*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_XOR_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (zext:{ *:[i64] } (atomic_load_xor:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_xor_8>>) - Complexity = 19
                // Dst: (ATOMIC_RMW8_U_XOR_I64_A64:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i64] }:$val)
/*   884*/     /*Scope*/ 18, /*->903*/
/*   885*/      OPC_CheckPredicate2,  // Predicate_atomic_load_xor_16
/*   886*/      OPC_MoveParent,
/*   887*/      OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*   888*/      OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*   890*/      OPC_EmitMergeInputChains1_0,
/*   891*/      OPC_EmitInteger32, 0, 
/*   893*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_XOR_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (zext:{ *:[i64] } (atomic_load_xor:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_xor_16>>) - Complexity = 19
                // Dst: (ATOMIC_RMW16_U_XOR_I64_A64:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i64] }:$val)
/*   903*/     /*Scope*/ 18, /*->922*/
/*   904*/      OPC_CheckPredicate3,  // Predicate_atomic_load_xor_32
/*   905*/      OPC_MoveParent,
/*   906*/      OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*   907*/      OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*   909*/      OPC_EmitMergeInputChains1_0,
/*   910*/      OPC_EmitInteger32, 0, 
/*   912*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW32_U_XOR_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (zext:{ *:[i64] } (atomic_load_xor:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_xor_32>>) - Complexity = 19
                // Dst: (ATOMIC_RMW32_U_XOR_I64_A64:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i64] }:$val)
/*   922*/     0, /*End of Scope*/
/*   923*/    0, /*End of Scope*/
/*   924*/   /*SwitchOpcode*/ 11|128,1/*139*/, TARGET_VAL(ISD::ATOMIC_SWAP),// ->1067
/*   928*/    OPC_RecordMemRef,
/*   929*/    OPC_RecordNode, // #0 = 'atomic_swap' chained node
/*   930*/    OPC_RecordChild1, // #1 = $AddrOps32:offset:addr
/*   931*/    OPC_Scope, 66, /*->999*/ // 2 children in Scope
/*   933*/     OPC_CheckChild1TypeI32,
/*   934*/     OPC_MoveChild2,
/*   935*/     OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/*   938*/     OPC_RecordChild0, // #2 = $val
/*   939*/     OPC_MoveParent,
/*   940*/     OPC_Scope, 18, /*->960*/ // 3 children in Scope
/*   942*/      OPC_CheckPredicate1,  // Predicate_atomic_swap_8
/*   943*/      OPC_MoveParent,
/*   944*/      OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*   945*/      OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*   947*/      OPC_EmitMergeInputChains1_0,
/*   948*/      OPC_EmitInteger32, 0, 
/*   950*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_XCHG_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (zext:{ *:[i64] } (atomic_swap:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_swap_8>>) - Complexity = 19
                // Dst: (ATOMIC_RMW8_U_XCHG_I64_A32:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i64] }:$val)
/*   960*/     /*Scope*/ 18, /*->979*/
/*   961*/      OPC_CheckPredicate2,  // Predicate_atomic_swap_16
/*   962*/      OPC_MoveParent,
/*   963*/      OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*   964*/      OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*   966*/      OPC_EmitMergeInputChains1_0,
/*   967*/      OPC_EmitInteger32, 0, 
/*   969*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_XCHG_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (zext:{ *:[i64] } (atomic_swap:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_swap_16>>) - Complexity = 19
                // Dst: (ATOMIC_RMW16_U_XCHG_I64_A32:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i64] }:$val)
/*   979*/     /*Scope*/ 18, /*->998*/
/*   980*/      OPC_CheckPredicate3,  // Predicate_atomic_swap_32
/*   981*/      OPC_MoveParent,
/*   982*/      OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*   983*/      OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*   985*/      OPC_EmitMergeInputChains1_0,
/*   986*/      OPC_EmitInteger32, 0, 
/*   988*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW32_U_XCHG_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (zext:{ *:[i64] } (atomic_swap:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_swap_32>>) - Complexity = 19
                // Dst: (ATOMIC_RMW32_U_XCHG_I64_A32:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i64] }:$val)
/*   998*/     0, /*End of Scope*/
/*   999*/    /*Scope*/ 66, /*->1066*/
/*  1000*/     OPC_CheckChild1TypeI64,
/*  1001*/     OPC_MoveChild2,
/*  1002*/     OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/*  1005*/     OPC_RecordChild0, // #2 = $val
/*  1006*/     OPC_MoveParent,
/*  1007*/     OPC_Scope, 18, /*->1027*/ // 3 children in Scope
/*  1009*/      OPC_CheckPredicate1,  // Predicate_atomic_swap_8
/*  1010*/      OPC_MoveParent,
/*  1011*/      OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  1012*/      OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*  1014*/      OPC_EmitMergeInputChains1_0,
/*  1015*/      OPC_EmitInteger32, 0, 
/*  1017*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_XCHG_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (zext:{ *:[i64] } (atomic_swap:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_swap_8>>) - Complexity = 19
                // Dst: (ATOMIC_RMW8_U_XCHG_I64_A64:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i64] }:$val)
/*  1027*/     /*Scope*/ 18, /*->1046*/
/*  1028*/      OPC_CheckPredicate2,  // Predicate_atomic_swap_16
/*  1029*/      OPC_MoveParent,
/*  1030*/      OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  1031*/      OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*  1033*/      OPC_EmitMergeInputChains1_0,
/*  1034*/      OPC_EmitInteger32, 0, 
/*  1036*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_XCHG_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (zext:{ *:[i64] } (atomic_swap:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_swap_16>>) - Complexity = 19
                // Dst: (ATOMIC_RMW16_U_XCHG_I64_A64:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i64] }:$val)
/*  1046*/     /*Scope*/ 18, /*->1065*/
/*  1047*/      OPC_CheckPredicate3,  // Predicate_atomic_swap_32
/*  1048*/      OPC_MoveParent,
/*  1049*/      OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  1050*/      OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*  1052*/      OPC_EmitMergeInputChains1_0,
/*  1053*/      OPC_EmitInteger32, 0, 
/*  1055*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW32_U_XCHG_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (zext:{ *:[i64] } (atomic_swap:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_swap_32>>) - Complexity = 19
                // Dst: (ATOMIC_RMW32_U_XCHG_I64_A64:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i64] }:$val)
/*  1065*/     0, /*End of Scope*/
/*  1066*/    0, /*End of Scope*/
/*  1067*/   /*SwitchOpcode*/ 121, TARGET_VAL(ISD::ATOMIC_LOAD),// ->1191
/*  1070*/    OPC_RecordMemRef,
/*  1071*/    OPC_RecordNode, // #0 = 'atomic_load' chained node
/*  1072*/    OPC_RecordChild1, // #1 = $AddrOps32:offset:addr
/*  1073*/    OPC_Scope, 57, /*->1132*/ // 2 children in Scope
/*  1075*/     OPC_CheckChild1TypeI32,
/*  1076*/     OPC_Scope, 17, /*->1095*/ // 3 children in Scope
/*  1078*/      OPC_CheckPredicate1,  // Predicate_atomic_load_8
/*  1079*/      OPC_MoveParent,
/*  1080*/      OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64())
/*  1081*/      OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #2 #3
/*  1083*/      OPC_EmitMergeInputChains1_0,
/*  1084*/      OPC_EmitInteger32, 0, 
/*  1086*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_LOAD8_U_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 3/*#Ops*/, 4, 2, 3, 
                // Src: (zext:{ *:[i64] } (atomic_load:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_atomic_load_8>>) - Complexity = 16
                // Dst: (ATOMIC_LOAD8_U_I64_A32:{ *:[i64] } 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr)
/*  1095*/     /*Scope*/ 17, /*->1113*/
/*  1096*/      OPC_CheckPredicate2,  // Predicate_atomic_load_16
/*  1097*/      OPC_MoveParent,
/*  1098*/      OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64())
/*  1099*/      OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #2 #3
/*  1101*/      OPC_EmitMergeInputChains1_0,
/*  1102*/      OPC_EmitInteger32, 0, 
/*  1104*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_LOAD16_U_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 3/*#Ops*/, 4, 2, 3, 
                // Src: (zext:{ *:[i64] } (atomic_load:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_atomic_load_16>>) - Complexity = 16
                // Dst: (ATOMIC_LOAD16_U_I64_A32:{ *:[i64] } 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr)
/*  1113*/     /*Scope*/ 17, /*->1131*/
/*  1114*/      OPC_CheckPredicate3,  // Predicate_atomic_load_32
/*  1115*/      OPC_MoveParent,
/*  1116*/      OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64())
/*  1117*/      OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #2 #3
/*  1119*/      OPC_EmitMergeInputChains1_0,
/*  1120*/      OPC_EmitInteger32, 0, 
/*  1122*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_LOAD32_U_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 3/*#Ops*/, 4, 2, 3, 
                // Src: (zext:{ *:[i64] } (atomic_load:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_atomic_load_32>>) - Complexity = 16
                // Dst: (ATOMIC_LOAD32_U_I64_A32:{ *:[i64] } 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr)
/*  1131*/     0, /*End of Scope*/
/*  1132*/    /*Scope*/ 57, /*->1190*/
/*  1133*/     OPC_CheckChild1TypeI64,
/*  1134*/     OPC_Scope, 17, /*->1153*/ // 3 children in Scope
/*  1136*/      OPC_CheckPredicate1,  // Predicate_atomic_load_8
/*  1137*/      OPC_MoveParent,
/*  1138*/      OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64())
/*  1139*/      OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #2 #3
/*  1141*/      OPC_EmitMergeInputChains1_0,
/*  1142*/      OPC_EmitInteger32, 0, 
/*  1144*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_LOAD8_U_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 3/*#Ops*/, 4, 2, 3, 
                // Src: (zext:{ *:[i64] } (atomic_load:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_atomic_load_8>>) - Complexity = 16
                // Dst: (ATOMIC_LOAD8_U_I64_A64:{ *:[i64] } 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr)
/*  1153*/     /*Scope*/ 17, /*->1171*/
/*  1154*/      OPC_CheckPredicate2,  // Predicate_atomic_load_16
/*  1155*/      OPC_MoveParent,
/*  1156*/      OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64())
/*  1157*/      OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #2 #3
/*  1159*/      OPC_EmitMergeInputChains1_0,
/*  1160*/      OPC_EmitInteger32, 0, 
/*  1162*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_LOAD16_U_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 3/*#Ops*/, 4, 2, 3, 
                // Src: (zext:{ *:[i64] } (atomic_load:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_atomic_load_16>>) - Complexity = 16
                // Dst: (ATOMIC_LOAD16_U_I64_A64:{ *:[i64] } 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr)
/*  1171*/     /*Scope*/ 17, /*->1189*/
/*  1172*/      OPC_CheckPredicate3,  // Predicate_atomic_load_32
/*  1173*/      OPC_MoveParent,
/*  1174*/      OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64())
/*  1175*/      OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #2 #3
/*  1177*/      OPC_EmitMergeInputChains1_0,
/*  1178*/      OPC_EmitInteger32, 0, 
/*  1180*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_LOAD32_U_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 3/*#Ops*/, 4, 2, 3, 
                // Src: (zext:{ *:[i64] } (atomic_load:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_atomic_load_32>>) - Complexity = 16
                // Dst: (ATOMIC_LOAD32_U_I64_A64:{ *:[i64] } 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr)
/*  1189*/     0, /*End of Scope*/
/*  1190*/    0, /*End of Scope*/
/*  1191*/   0, // EndSwitchOpcode
/*  1192*/  /*Scope*/ 7, /*->1200*/
/*  1193*/   OPC_RecordChild0, // #0 = $src
/*  1194*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::I64_EXTEND_U_I32),
                 MVT::i64, 1/*#Ops*/, 0, 
             // Src: (zext:{ *:[i64] } I32:{ *:[i32] }:$src) - Complexity = 3
             // Dst: (I64_EXTEND_U_I32:{ *:[i64] } I32:{ *:[i32] }:$src)
/*  1200*/  0, /*End of Scope*/
/*  1201*/ /*SwitchOpcode*/ 86|128,6/*854*/, TARGET_VAL(ISD::ANY_EXTEND),// ->2059
/*  1205*/  OPC_Scope, 74|128,6/*842*/, /*->2050*/ // 2 children in Scope
/*  1208*/   OPC_MoveChild0,
/*  1209*/   OPC_SwitchOpcode /*8 cases */, 124, TARGET_VAL(ISD::AssertZext),// ->1337
/*  1213*/    OPC_MoveChild0,
/*  1214*/    OPC_CheckOpcode, TARGET_VAL(ISD::ATOMIC_CMP_SWAP),
/*  1217*/    OPC_RecordMemRef,
/*  1218*/    OPC_RecordNode, // #0 = 'atomic_cmp_swap' chained node
/*  1219*/    OPC_CheckFoldableChainNode,
/*  1220*/    OPC_RecordChild1, // #1 = $AddrOps32:offset:addr
/*  1221*/    OPC_Scope, 56, /*->1279*/ // 2 children in Scope
/*  1223*/     OPC_CheckChild1TypeI32,
/*  1224*/     OPC_MoveChild2,
/*  1225*/     OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/*  1228*/     OPC_RecordChild0, // #2 = $exp
/*  1229*/     OPC_MoveSibling3,
/*  1230*/     OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/*  1233*/     OPC_RecordChild0, // #3 = $new
/*  1234*/     OPC_MoveParent,
/*  1235*/     OPC_Scope, 20, /*->1257*/ // 2 children in Scope
/*  1237*/      OPC_CheckPredicate1,  // Predicate_atomic_cmp_swap_8
/*  1238*/      OPC_MoveParent,
/*  1239*/      OPC_MoveParent,
/*  1240*/      OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  1241*/      OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #4 #5
/*  1243*/      OPC_EmitMergeInputChains1_0,
/*  1244*/      OPC_EmitInteger32, 0, 
/*  1246*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_CMPXCHG_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 5/*#Ops*/, 6, 4, 5, 2, 3, 
                // Src: (anyext:{ *:[i64] } (assertzext:{ *:[i32] } (atomic_cmp_swap:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$exp), (trunc:{ *:[i32] } i64:{ *:[i64] }:$new))<<P:Predicate_atomic_cmp_swap_8>>)) - Complexity = 25
                // Dst: (ATOMIC_RMW8_U_CMPXCHG_I64_A32:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i64] }:$exp, ?:{ *:[i64] }:$new)
/*  1257*/     /*Scope*/ 20, /*->1278*/
/*  1258*/      OPC_CheckPredicate2,  // Predicate_atomic_cmp_swap_16
/*  1259*/      OPC_MoveParent,
/*  1260*/      OPC_MoveParent,
/*  1261*/      OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  1262*/      OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #4 #5
/*  1264*/      OPC_EmitMergeInputChains1_0,
/*  1265*/      OPC_EmitInteger32, 0, 
/*  1267*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_CMPXCHG_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 5/*#Ops*/, 6, 4, 5, 2, 3, 
                // Src: (anyext:{ *:[i64] } (assertzext:{ *:[i32] } (atomic_cmp_swap:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$exp), (trunc:{ *:[i32] } i64:{ *:[i64] }:$new))<<P:Predicate_atomic_cmp_swap_16>>)) - Complexity = 25
                // Dst: (ATOMIC_RMW16_U_CMPXCHG_I64_A32:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i64] }:$exp, ?:{ *:[i64] }:$new)
/*  1278*/     0, /*End of Scope*/
/*  1279*/    /*Scope*/ 56, /*->1336*/
/*  1280*/     OPC_CheckChild1TypeI64,
/*  1281*/     OPC_MoveChild2,
/*  1282*/     OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/*  1285*/     OPC_RecordChild0, // #2 = $exp
/*  1286*/     OPC_MoveSibling3,
/*  1287*/     OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/*  1290*/     OPC_RecordChild0, // #3 = $new
/*  1291*/     OPC_MoveParent,
/*  1292*/     OPC_Scope, 20, /*->1314*/ // 2 children in Scope
/*  1294*/      OPC_CheckPredicate1,  // Predicate_atomic_cmp_swap_8
/*  1295*/      OPC_MoveParent,
/*  1296*/      OPC_MoveParent,
/*  1297*/      OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  1298*/      OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #4 #5
/*  1300*/      OPC_EmitMergeInputChains1_0,
/*  1301*/      OPC_EmitInteger32, 0, 
/*  1303*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_CMPXCHG_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 5/*#Ops*/, 6, 4, 5, 2, 3, 
                // Src: (anyext:{ *:[i64] } (assertzext:{ *:[i32] } (atomic_cmp_swap:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$exp), (trunc:{ *:[i32] } i64:{ *:[i64] }:$new))<<P:Predicate_atomic_cmp_swap_8>>)) - Complexity = 25
                // Dst: (ATOMIC_RMW8_U_CMPXCHG_I64_A64:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i64] }:$exp, ?:{ *:[i64] }:$new)
/*  1314*/     /*Scope*/ 20, /*->1335*/
/*  1315*/      OPC_CheckPredicate2,  // Predicate_atomic_cmp_swap_16
/*  1316*/      OPC_MoveParent,
/*  1317*/      OPC_MoveParent,
/*  1318*/      OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  1319*/      OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #4 #5
/*  1321*/      OPC_EmitMergeInputChains1_0,
/*  1322*/      OPC_EmitInteger32, 0, 
/*  1324*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_CMPXCHG_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 5/*#Ops*/, 6, 4, 5, 2, 3, 
                // Src: (anyext:{ *:[i64] } (assertzext:{ *:[i32] } (atomic_cmp_swap:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$exp), (trunc:{ *:[i32] } i64:{ *:[i64] }:$new))<<P:Predicate_atomic_cmp_swap_16>>)) - Complexity = 25
                // Dst: (ATOMIC_RMW16_U_CMPXCHG_I64_A64:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i64] }:$exp, ?:{ *:[i64] }:$new)
/*  1335*/     0, /*End of Scope*/
/*  1336*/    0, /*End of Scope*/
/*  1337*/   /*SwitchOpcode*/ 101, TARGET_VAL(ISD::ATOMIC_LOAD_ADD),// ->1441
/*  1340*/    OPC_RecordMemRef,
/*  1341*/    OPC_RecordNode, // #0 = 'atomic_load_add' chained node
/*  1342*/    OPC_RecordChild1, // #1 = $AddrOps32:offset:addr
/*  1343*/    OPC_Scope, 47, /*->1392*/ // 2 children in Scope
/*  1345*/     OPC_CheckChild1TypeI32,
/*  1346*/     OPC_MoveChild2,
/*  1347*/     OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/*  1350*/     OPC_RecordChild0, // #2 = $val
/*  1351*/     OPC_MoveParent,
/*  1352*/     OPC_Scope, 18, /*->1372*/ // 2 children in Scope
/*  1354*/      OPC_CheckPredicate1,  // Predicate_atomic_load_add_8
/*  1355*/      OPC_MoveParent,
/*  1356*/      OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  1357*/      OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*  1359*/      OPC_EmitMergeInputChains1_0,
/*  1360*/      OPC_EmitInteger32, 0, 
/*  1362*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_ADD_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (anyext:{ *:[i64] } (atomic_load_add:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_add_8>>) - Complexity = 19
                // Dst: (ATOMIC_RMW8_U_ADD_I64_A32:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i64] }:$val)
/*  1372*/     /*Scope*/ 18, /*->1391*/
/*  1373*/      OPC_CheckPredicate2,  // Predicate_atomic_load_add_16
/*  1374*/      OPC_MoveParent,
/*  1375*/      OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  1376*/      OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*  1378*/      OPC_EmitMergeInputChains1_0,
/*  1379*/      OPC_EmitInteger32, 0, 
/*  1381*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_ADD_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (anyext:{ *:[i64] } (atomic_load_add:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_add_16>>) - Complexity = 19
                // Dst: (ATOMIC_RMW16_U_ADD_I64_A32:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i64] }:$val)
/*  1391*/     0, /*End of Scope*/
/*  1392*/    /*Scope*/ 47, /*->1440*/
/*  1393*/     OPC_CheckChild1TypeI64,
/*  1394*/     OPC_MoveChild2,
/*  1395*/     OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/*  1398*/     OPC_RecordChild0, // #2 = $val
/*  1399*/     OPC_MoveParent,
/*  1400*/     OPC_Scope, 18, /*->1420*/ // 2 children in Scope
/*  1402*/      OPC_CheckPredicate1,  // Predicate_atomic_load_add_8
/*  1403*/      OPC_MoveParent,
/*  1404*/      OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  1405*/      OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*  1407*/      OPC_EmitMergeInputChains1_0,
/*  1408*/      OPC_EmitInteger32, 0, 
/*  1410*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_ADD_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (anyext:{ *:[i64] } (atomic_load_add:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_add_8>>) - Complexity = 19
                // Dst: (ATOMIC_RMW8_U_ADD_I64_A64:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i64] }:$val)
/*  1420*/     /*Scope*/ 18, /*->1439*/
/*  1421*/      OPC_CheckPredicate2,  // Predicate_atomic_load_add_16
/*  1422*/      OPC_MoveParent,
/*  1423*/      OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  1424*/      OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*  1426*/      OPC_EmitMergeInputChains1_0,
/*  1427*/      OPC_EmitInteger32, 0, 
/*  1429*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_ADD_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (anyext:{ *:[i64] } (atomic_load_add:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_add_16>>) - Complexity = 19
                // Dst: (ATOMIC_RMW16_U_ADD_I64_A64:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i64] }:$val)
/*  1439*/     0, /*End of Scope*/
/*  1440*/    0, /*End of Scope*/
/*  1441*/   /*SwitchOpcode*/ 101, TARGET_VAL(ISD::ATOMIC_LOAD_SUB),// ->1545
/*  1444*/    OPC_RecordMemRef,
/*  1445*/    OPC_RecordNode, // #0 = 'atomic_load_sub' chained node
/*  1446*/    OPC_RecordChild1, // #1 = $AddrOps32:offset:addr
/*  1447*/    OPC_Scope, 47, /*->1496*/ // 2 children in Scope
/*  1449*/     OPC_CheckChild1TypeI32,
/*  1450*/     OPC_MoveChild2,
/*  1451*/     OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/*  1454*/     OPC_RecordChild0, // #2 = $val
/*  1455*/     OPC_MoveParent,
/*  1456*/     OPC_Scope, 18, /*->1476*/ // 2 children in Scope
/*  1458*/      OPC_CheckPredicate1,  // Predicate_atomic_load_sub_8
/*  1459*/      OPC_MoveParent,
/*  1460*/      OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  1461*/      OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*  1463*/      OPC_EmitMergeInputChains1_0,
/*  1464*/      OPC_EmitInteger32, 0, 
/*  1466*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_SUB_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (anyext:{ *:[i64] } (atomic_load_sub:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_sub_8>>) - Complexity = 19
                // Dst: (ATOMIC_RMW8_U_SUB_I64_A32:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i64] }:$val)
/*  1476*/     /*Scope*/ 18, /*->1495*/
/*  1477*/      OPC_CheckPredicate2,  // Predicate_atomic_load_sub_16
/*  1478*/      OPC_MoveParent,
/*  1479*/      OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  1480*/      OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*  1482*/      OPC_EmitMergeInputChains1_0,
/*  1483*/      OPC_EmitInteger32, 0, 
/*  1485*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_SUB_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (anyext:{ *:[i64] } (atomic_load_sub:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_sub_16>>) - Complexity = 19
                // Dst: (ATOMIC_RMW16_U_SUB_I64_A32:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i64] }:$val)
/*  1495*/     0, /*End of Scope*/
/*  1496*/    /*Scope*/ 47, /*->1544*/
/*  1497*/     OPC_CheckChild1TypeI64,
/*  1498*/     OPC_MoveChild2,
/*  1499*/     OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/*  1502*/     OPC_RecordChild0, // #2 = $val
/*  1503*/     OPC_MoveParent,
/*  1504*/     OPC_Scope, 18, /*->1524*/ // 2 children in Scope
/*  1506*/      OPC_CheckPredicate1,  // Predicate_atomic_load_sub_8
/*  1507*/      OPC_MoveParent,
/*  1508*/      OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  1509*/      OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*  1511*/      OPC_EmitMergeInputChains1_0,
/*  1512*/      OPC_EmitInteger32, 0, 
/*  1514*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_SUB_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (anyext:{ *:[i64] } (atomic_load_sub:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_sub_8>>) - Complexity = 19
                // Dst: (ATOMIC_RMW8_U_SUB_I64_A64:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i64] }:$val)
/*  1524*/     /*Scope*/ 18, /*->1543*/
/*  1525*/      OPC_CheckPredicate2,  // Predicate_atomic_load_sub_16
/*  1526*/      OPC_MoveParent,
/*  1527*/      OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  1528*/      OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*  1530*/      OPC_EmitMergeInputChains1_0,
/*  1531*/      OPC_EmitInteger32, 0, 
/*  1533*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_SUB_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (anyext:{ *:[i64] } (atomic_load_sub:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_sub_16>>) - Complexity = 19
                // Dst: (ATOMIC_RMW16_U_SUB_I64_A64:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i64] }:$val)
/*  1543*/     0, /*End of Scope*/
/*  1544*/    0, /*End of Scope*/
/*  1545*/   /*SwitchOpcode*/ 101, TARGET_VAL(ISD::ATOMIC_LOAD_AND),// ->1649
/*  1548*/    OPC_RecordMemRef,
/*  1549*/    OPC_RecordNode, // #0 = 'atomic_load_and' chained node
/*  1550*/    OPC_RecordChild1, // #1 = $AddrOps32:offset:addr
/*  1551*/    OPC_Scope, 47, /*->1600*/ // 2 children in Scope
/*  1553*/     OPC_CheckChild1TypeI32,
/*  1554*/     OPC_MoveChild2,
/*  1555*/     OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/*  1558*/     OPC_RecordChild0, // #2 = $val
/*  1559*/     OPC_MoveParent,
/*  1560*/     OPC_Scope, 18, /*->1580*/ // 2 children in Scope
/*  1562*/      OPC_CheckPredicate1,  // Predicate_atomic_load_and_8
/*  1563*/      OPC_MoveParent,
/*  1564*/      OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  1565*/      OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*  1567*/      OPC_EmitMergeInputChains1_0,
/*  1568*/      OPC_EmitInteger32, 0, 
/*  1570*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_AND_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (anyext:{ *:[i64] } (atomic_load_and:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_and_8>>) - Complexity = 19
                // Dst: (ATOMIC_RMW8_U_AND_I64_A32:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i64] }:$val)
/*  1580*/     /*Scope*/ 18, /*->1599*/
/*  1581*/      OPC_CheckPredicate2,  // Predicate_atomic_load_and_16
/*  1582*/      OPC_MoveParent,
/*  1583*/      OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  1584*/      OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*  1586*/      OPC_EmitMergeInputChains1_0,
/*  1587*/      OPC_EmitInteger32, 0, 
/*  1589*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_AND_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (anyext:{ *:[i64] } (atomic_load_and:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_and_16>>) - Complexity = 19
                // Dst: (ATOMIC_RMW16_U_AND_I64_A32:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i64] }:$val)
/*  1599*/     0, /*End of Scope*/
/*  1600*/    /*Scope*/ 47, /*->1648*/
/*  1601*/     OPC_CheckChild1TypeI64,
/*  1602*/     OPC_MoveChild2,
/*  1603*/     OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/*  1606*/     OPC_RecordChild0, // #2 = $val
/*  1607*/     OPC_MoveParent,
/*  1608*/     OPC_Scope, 18, /*->1628*/ // 2 children in Scope
/*  1610*/      OPC_CheckPredicate1,  // Predicate_atomic_load_and_8
/*  1611*/      OPC_MoveParent,
/*  1612*/      OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  1613*/      OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*  1615*/      OPC_EmitMergeInputChains1_0,
/*  1616*/      OPC_EmitInteger32, 0, 
/*  1618*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_AND_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (anyext:{ *:[i64] } (atomic_load_and:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_and_8>>) - Complexity = 19
                // Dst: (ATOMIC_RMW8_U_AND_I64_A64:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i64] }:$val)
/*  1628*/     /*Scope*/ 18, /*->1647*/
/*  1629*/      OPC_CheckPredicate2,  // Predicate_atomic_load_and_16
/*  1630*/      OPC_MoveParent,
/*  1631*/      OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  1632*/      OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*  1634*/      OPC_EmitMergeInputChains1_0,
/*  1635*/      OPC_EmitInteger32, 0, 
/*  1637*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_AND_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (anyext:{ *:[i64] } (atomic_load_and:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_and_16>>) - Complexity = 19
                // Dst: (ATOMIC_RMW16_U_AND_I64_A64:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i64] }:$val)
/*  1647*/     0, /*End of Scope*/
/*  1648*/    0, /*End of Scope*/
/*  1649*/   /*SwitchOpcode*/ 101, TARGET_VAL(ISD::ATOMIC_LOAD_OR),// ->1753
/*  1652*/    OPC_RecordMemRef,
/*  1653*/    OPC_RecordNode, // #0 = 'atomic_load_or' chained node
/*  1654*/    OPC_RecordChild1, // #1 = $AddrOps32:offset:addr
/*  1655*/    OPC_Scope, 47, /*->1704*/ // 2 children in Scope
/*  1657*/     OPC_CheckChild1TypeI32,
/*  1658*/     OPC_MoveChild2,
/*  1659*/     OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/*  1662*/     OPC_RecordChild0, // #2 = $val
/*  1663*/     OPC_MoveParent,
/*  1664*/     OPC_Scope, 18, /*->1684*/ // 2 children in Scope
/*  1666*/      OPC_CheckPredicate1,  // Predicate_atomic_load_or_8
/*  1667*/      OPC_MoveParent,
/*  1668*/      OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  1669*/      OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*  1671*/      OPC_EmitMergeInputChains1_0,
/*  1672*/      OPC_EmitInteger32, 0, 
/*  1674*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_OR_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (anyext:{ *:[i64] } (atomic_load_or:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_or_8>>) - Complexity = 19
                // Dst: (ATOMIC_RMW8_U_OR_I64_A32:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i64] }:$val)
/*  1684*/     /*Scope*/ 18, /*->1703*/
/*  1685*/      OPC_CheckPredicate2,  // Predicate_atomic_load_or_16
/*  1686*/      OPC_MoveParent,
/*  1687*/      OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  1688*/      OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*  1690*/      OPC_EmitMergeInputChains1_0,
/*  1691*/      OPC_EmitInteger32, 0, 
/*  1693*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_OR_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (anyext:{ *:[i64] } (atomic_load_or:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_or_16>>) - Complexity = 19
                // Dst: (ATOMIC_RMW16_U_OR_I64_A32:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i64] }:$val)
/*  1703*/     0, /*End of Scope*/
/*  1704*/    /*Scope*/ 47, /*->1752*/
/*  1705*/     OPC_CheckChild1TypeI64,
/*  1706*/     OPC_MoveChild2,
/*  1707*/     OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/*  1710*/     OPC_RecordChild0, // #2 = $val
/*  1711*/     OPC_MoveParent,
/*  1712*/     OPC_Scope, 18, /*->1732*/ // 2 children in Scope
/*  1714*/      OPC_CheckPredicate1,  // Predicate_atomic_load_or_8
/*  1715*/      OPC_MoveParent,
/*  1716*/      OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  1717*/      OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*  1719*/      OPC_EmitMergeInputChains1_0,
/*  1720*/      OPC_EmitInteger32, 0, 
/*  1722*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_OR_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (anyext:{ *:[i64] } (atomic_load_or:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_or_8>>) - Complexity = 19
                // Dst: (ATOMIC_RMW8_U_OR_I64_A64:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i64] }:$val)
/*  1732*/     /*Scope*/ 18, /*->1751*/
/*  1733*/      OPC_CheckPredicate2,  // Predicate_atomic_load_or_16
/*  1734*/      OPC_MoveParent,
/*  1735*/      OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  1736*/      OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*  1738*/      OPC_EmitMergeInputChains1_0,
/*  1739*/      OPC_EmitInteger32, 0, 
/*  1741*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_OR_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (anyext:{ *:[i64] } (atomic_load_or:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_or_16>>) - Complexity = 19
                // Dst: (ATOMIC_RMW16_U_OR_I64_A64:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i64] }:$val)
/*  1751*/     0, /*End of Scope*/
/*  1752*/    0, /*End of Scope*/
/*  1753*/   /*SwitchOpcode*/ 101, TARGET_VAL(ISD::ATOMIC_LOAD_XOR),// ->1857
/*  1756*/    OPC_RecordMemRef,
/*  1757*/    OPC_RecordNode, // #0 = 'atomic_load_xor' chained node
/*  1758*/    OPC_RecordChild1, // #1 = $AddrOps32:offset:addr
/*  1759*/    OPC_Scope, 47, /*->1808*/ // 2 children in Scope
/*  1761*/     OPC_CheckChild1TypeI32,
/*  1762*/     OPC_MoveChild2,
/*  1763*/     OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/*  1766*/     OPC_RecordChild0, // #2 = $val
/*  1767*/     OPC_MoveParent,
/*  1768*/     OPC_Scope, 18, /*->1788*/ // 2 children in Scope
/*  1770*/      OPC_CheckPredicate1,  // Predicate_atomic_load_xor_8
/*  1771*/      OPC_MoveParent,
/*  1772*/      OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  1773*/      OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*  1775*/      OPC_EmitMergeInputChains1_0,
/*  1776*/      OPC_EmitInteger32, 0, 
/*  1778*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_XOR_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (anyext:{ *:[i64] } (atomic_load_xor:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_xor_8>>) - Complexity = 19
                // Dst: (ATOMIC_RMW8_U_XOR_I64_A32:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i64] }:$val)
/*  1788*/     /*Scope*/ 18, /*->1807*/
/*  1789*/      OPC_CheckPredicate2,  // Predicate_atomic_load_xor_16
/*  1790*/      OPC_MoveParent,
/*  1791*/      OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  1792*/      OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*  1794*/      OPC_EmitMergeInputChains1_0,
/*  1795*/      OPC_EmitInteger32, 0, 
/*  1797*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_XOR_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (anyext:{ *:[i64] } (atomic_load_xor:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_xor_16>>) - Complexity = 19
                // Dst: (ATOMIC_RMW16_U_XOR_I64_A32:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i64] }:$val)
/*  1807*/     0, /*End of Scope*/
/*  1808*/    /*Scope*/ 47, /*->1856*/
/*  1809*/     OPC_CheckChild1TypeI64,
/*  1810*/     OPC_MoveChild2,
/*  1811*/     OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/*  1814*/     OPC_RecordChild0, // #2 = $val
/*  1815*/     OPC_MoveParent,
/*  1816*/     OPC_Scope, 18, /*->1836*/ // 2 children in Scope
/*  1818*/      OPC_CheckPredicate1,  // Predicate_atomic_load_xor_8
/*  1819*/      OPC_MoveParent,
/*  1820*/      OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  1821*/      OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*  1823*/      OPC_EmitMergeInputChains1_0,
/*  1824*/      OPC_EmitInteger32, 0, 
/*  1826*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_XOR_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (anyext:{ *:[i64] } (atomic_load_xor:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_xor_8>>) - Complexity = 19
                // Dst: (ATOMIC_RMW8_U_XOR_I64_A64:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i64] }:$val)
/*  1836*/     /*Scope*/ 18, /*->1855*/
/*  1837*/      OPC_CheckPredicate2,  // Predicate_atomic_load_xor_16
/*  1838*/      OPC_MoveParent,
/*  1839*/      OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  1840*/      OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*  1842*/      OPC_EmitMergeInputChains1_0,
/*  1843*/      OPC_EmitInteger32, 0, 
/*  1845*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_XOR_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (anyext:{ *:[i64] } (atomic_load_xor:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_xor_16>>) - Complexity = 19
                // Dst: (ATOMIC_RMW16_U_XOR_I64_A64:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i64] }:$val)
/*  1855*/     0, /*End of Scope*/
/*  1856*/    0, /*End of Scope*/
/*  1857*/   /*SwitchOpcode*/ 101, TARGET_VAL(ISD::ATOMIC_SWAP),// ->1961
/*  1860*/    OPC_RecordMemRef,
/*  1861*/    OPC_RecordNode, // #0 = 'atomic_swap' chained node
/*  1862*/    OPC_RecordChild1, // #1 = $AddrOps32:offset:addr
/*  1863*/    OPC_Scope, 47, /*->1912*/ // 2 children in Scope
/*  1865*/     OPC_CheckChild1TypeI32,
/*  1866*/     OPC_MoveChild2,
/*  1867*/     OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/*  1870*/     OPC_RecordChild0, // #2 = $val
/*  1871*/     OPC_MoveParent,
/*  1872*/     OPC_Scope, 18, /*->1892*/ // 2 children in Scope
/*  1874*/      OPC_CheckPredicate1,  // Predicate_atomic_swap_8
/*  1875*/      OPC_MoveParent,
/*  1876*/      OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  1877*/      OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*  1879*/      OPC_EmitMergeInputChains1_0,
/*  1880*/      OPC_EmitInteger32, 0, 
/*  1882*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_XCHG_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (anyext:{ *:[i64] } (atomic_swap:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_swap_8>>) - Complexity = 19
                // Dst: (ATOMIC_RMW8_U_XCHG_I64_A32:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i64] }:$val)
/*  1892*/     /*Scope*/ 18, /*->1911*/
/*  1893*/      OPC_CheckPredicate2,  // Predicate_atomic_swap_16
/*  1894*/      OPC_MoveParent,
/*  1895*/      OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  1896*/      OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*  1898*/      OPC_EmitMergeInputChains1_0,
/*  1899*/      OPC_EmitInteger32, 0, 
/*  1901*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_XCHG_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (anyext:{ *:[i64] } (atomic_swap:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_swap_16>>) - Complexity = 19
                // Dst: (ATOMIC_RMW16_U_XCHG_I64_A32:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i64] }:$val)
/*  1911*/     0, /*End of Scope*/
/*  1912*/    /*Scope*/ 47, /*->1960*/
/*  1913*/     OPC_CheckChild1TypeI64,
/*  1914*/     OPC_MoveChild2,
/*  1915*/     OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/*  1918*/     OPC_RecordChild0, // #2 = $val
/*  1919*/     OPC_MoveParent,
/*  1920*/     OPC_Scope, 18, /*->1940*/ // 2 children in Scope
/*  1922*/      OPC_CheckPredicate1,  // Predicate_atomic_swap_8
/*  1923*/      OPC_MoveParent,
/*  1924*/      OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  1925*/      OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*  1927*/      OPC_EmitMergeInputChains1_0,
/*  1928*/      OPC_EmitInteger32, 0, 
/*  1930*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_XCHG_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (anyext:{ *:[i64] } (atomic_swap:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_swap_8>>) - Complexity = 19
                // Dst: (ATOMIC_RMW8_U_XCHG_I64_A64:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i64] }:$val)
/*  1940*/     /*Scope*/ 18, /*->1959*/
/*  1941*/      OPC_CheckPredicate2,  // Predicate_atomic_swap_16
/*  1942*/      OPC_MoveParent,
/*  1943*/      OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  1944*/      OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*  1946*/      OPC_EmitMergeInputChains1_0,
/*  1947*/      OPC_EmitInteger32, 0, 
/*  1949*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_XCHG_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (anyext:{ *:[i64] } (atomic_swap:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_swap_16>>) - Complexity = 19
                // Dst: (ATOMIC_RMW16_U_XCHG_I64_A64:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i64] }:$val)
/*  1959*/     0, /*End of Scope*/
/*  1960*/    0, /*End of Scope*/
/*  1961*/   /*SwitchOpcode*/ 85, TARGET_VAL(ISD::ATOMIC_LOAD),// ->2049
/*  1964*/    OPC_RecordMemRef,
/*  1965*/    OPC_RecordNode, // #0 = 'atomic_load' chained node
/*  1966*/    OPC_RecordChild1, // #1 = $AddrOps32:offset:addr
/*  1967*/    OPC_Scope, 39, /*->2008*/ // 2 children in Scope
/*  1969*/     OPC_CheckChild1TypeI32,
/*  1970*/     OPC_Scope, 17, /*->1989*/ // 2 children in Scope
/*  1972*/      OPC_CheckPredicate1,  // Predicate_atomic_load_8
/*  1973*/      OPC_MoveParent,
/*  1974*/      OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64())
/*  1975*/      OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #2 #3
/*  1977*/      OPC_EmitMergeInputChains1_0,
/*  1978*/      OPC_EmitInteger32, 0, 
/*  1980*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_LOAD8_U_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 3/*#Ops*/, 4, 2, 3, 
                // Src: (anyext:{ *:[i64] } (atomic_load:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_atomic_load_8>>) - Complexity = 16
                // Dst: (ATOMIC_LOAD8_U_I64_A32:{ *:[i64] } 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr)
/*  1989*/     /*Scope*/ 17, /*->2007*/
/*  1990*/      OPC_CheckPredicate2,  // Predicate_atomic_load_16
/*  1991*/      OPC_MoveParent,
/*  1992*/      OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64())
/*  1993*/      OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #2 #3
/*  1995*/      OPC_EmitMergeInputChains1_0,
/*  1996*/      OPC_EmitInteger32, 0, 
/*  1998*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_LOAD16_U_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 3/*#Ops*/, 4, 2, 3, 
                // Src: (anyext:{ *:[i64] } (atomic_load:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_atomic_load_16>>) - Complexity = 16
                // Dst: (ATOMIC_LOAD16_U_I64_A32:{ *:[i64] } 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr)
/*  2007*/     0, /*End of Scope*/
/*  2008*/    /*Scope*/ 39, /*->2048*/
/*  2009*/     OPC_CheckChild1TypeI64,
/*  2010*/     OPC_Scope, 17, /*->2029*/ // 2 children in Scope
/*  2012*/      OPC_CheckPredicate1,  // Predicate_atomic_load_8
/*  2013*/      OPC_MoveParent,
/*  2014*/      OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64())
/*  2015*/      OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #2 #3
/*  2017*/      OPC_EmitMergeInputChains1_0,
/*  2018*/      OPC_EmitInteger32, 0, 
/*  2020*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_LOAD8_U_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 3/*#Ops*/, 4, 2, 3, 
                // Src: (anyext:{ *:[i64] } (atomic_load:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_atomic_load_8>>) - Complexity = 16
                // Dst: (ATOMIC_LOAD8_U_I64_A64:{ *:[i64] } 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr)
/*  2029*/     /*Scope*/ 17, /*->2047*/
/*  2030*/      OPC_CheckPredicate2,  // Predicate_atomic_load_16
/*  2031*/      OPC_MoveParent,
/*  2032*/      OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64())
/*  2033*/      OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #2 #3
/*  2035*/      OPC_EmitMergeInputChains1_0,
/*  2036*/      OPC_EmitInteger32, 0, 
/*  2038*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_LOAD16_U_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 3/*#Ops*/, 4, 2, 3, 
                // Src: (anyext:{ *:[i64] } (atomic_load:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_atomic_load_16>>) - Complexity = 16
                // Dst: (ATOMIC_LOAD16_U_I64_A64:{ *:[i64] } 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr)
/*  2047*/     0, /*End of Scope*/
/*  2048*/    0, /*End of Scope*/
/*  2049*/   0, // EndSwitchOpcode
/*  2050*/  /*Scope*/ 7, /*->2058*/
/*  2051*/   OPC_RecordChild0, // #0 = $src
/*  2052*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::I64_EXTEND_U_I32),
                 MVT::i64, 1/*#Ops*/, 0, 
             // Src: (anyext:{ *:[i64] } I32:{ *:[i32] }:$src) - Complexity = 3
             // Dst: (I64_EXTEND_U_I32:{ *:[i64] } I32:{ *:[i32] }:$src)
/*  2058*/  0, /*End of Scope*/
/*  2059*/ /*SwitchOpcode*/ 22|128,7/*918*/, TARGET_VAL(ISD::STORE),// ->2981
/*  2063*/  OPC_RecordMemRef,
/*  2064*/  OPC_RecordNode, // #0 = 'st' chained node
/*  2065*/  OPC_Scope, 127|128,1/*255*/, /*->2323*/ // 2 children in Scope
/*  2068*/   OPC_MoveChild1,
/*  2069*/   OPC_CheckOpcode, TARGET_VAL(ISD::EXTRACT_VECTOR_ELT),
/*  2072*/   OPC_RecordChild0, // #1 = $vec
/*  2073*/   OPC_Scope, 64, /*->2139*/ // 4 children in Scope
/*  2075*/    OPC_CheckChild0Type, MVT::v16i8,
/*  2077*/    OPC_RecordChild1, // #2 = $idx
/*  2078*/    OPC_MoveChild1,
/*  2079*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/*  2082*/    OPC_CheckPredicate, 15, // Predicate_LaneIdx16
/*  2084*/    OPC_CheckTypeI32,
/*  2085*/    OPC_MoveParent,
/*  2086*/    OPC_CheckTypeI32,
/*  2087*/    OPC_MoveParent,
/*  2088*/    OPC_RecordChild2, // #3 = $AddrOps32:offset:addr
/*  2089*/    OPC_Scope, 23, /*->2114*/ // 2 children in Scope
/*  2091*/     OPC_CheckChild2TypeI32,
/*  2092*/     OPC_CheckPredicate4,  // Predicate_unindexedstore
/*  2093*/     OPC_CheckPredicate, 11, // Predicate_truncstore
/*  2095*/     OPC_CheckPredicate, 19, // Predicate_truncstorei8
/*  2097*/     OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64())
/*  2098*/     OPC_CheckComplexPat0, /*#*/3, // SelectAddrOperands32:$ #4 #5
/*  2100*/     OPC_EmitMergeInputChains1_0,
/*  2101*/     OPC_EmitInteger32, 0, 
/*  2103*/     OPC_EmitConvertToTarget2,
/*  2104*/     OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE_LANE_I8x16_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   5/*#Ops*/, 6, 4, 7, 5, 1, 
               // Src: (st (vector_extract:{ *:[i32] } V128:{ *:[v16i8] }:$vec, (imm:{ *:[i32] })<<P:Predicate_LaneIdx16>>:$idx), (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei8>> - Complexity = 21
               // Dst: (STORE_LANE_I8x16_A32 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, (imm:{ *:[i32] }):$idx, ?:{ *:[i32] }:$addr, ?:{ *:[v16i8] }:$vec)
/*  2114*/    /*Scope*/ 23, /*->2138*/
/*  2115*/     OPC_CheckChild2TypeI64,
/*  2116*/     OPC_CheckPredicate4,  // Predicate_unindexedstore
/*  2117*/     OPC_CheckPredicate, 11, // Predicate_truncstore
/*  2119*/     OPC_CheckPredicate, 19, // Predicate_truncstorei8
/*  2121*/     OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64())
/*  2122*/     OPC_CheckComplexPat1, /*#*/3, // SelectAddrOperands64:$ #4 #5
/*  2124*/     OPC_EmitMergeInputChains1_0,
/*  2125*/     OPC_EmitInteger32, 0, 
/*  2127*/     OPC_EmitConvertToTarget2,
/*  2128*/     OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE_LANE_I8x16_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   5/*#Ops*/, 6, 4, 7, 5, 1, 
               // Src: (st (vector_extract:{ *:[i32] } V128:{ *:[v16i8] }:$vec, (imm:{ *:[i32] })<<P:Predicate_LaneIdx16>>:$idx), (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei8>> - Complexity = 21
               // Dst: (STORE_LANE_I8x16_A64 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, (imm:{ *:[i32] }):$idx, ?:{ *:[i64] }:$addr, ?:{ *:[v16i8] }:$vec)
/*  2138*/    0, /*End of Scope*/
/*  2139*/   /*Scope*/ 64, /*->2204*/
/*  2140*/    OPC_CheckChild0Type, MVT::v8i16,
/*  2142*/    OPC_RecordChild1, // #2 = $idx
/*  2143*/    OPC_MoveChild1,
/*  2144*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/*  2147*/    OPC_CheckPredicate, 16, // Predicate_LaneIdx8
/*  2149*/    OPC_CheckTypeI32,
/*  2150*/    OPC_MoveParent,
/*  2151*/    OPC_CheckTypeI32,
/*  2152*/    OPC_MoveParent,
/*  2153*/    OPC_RecordChild2, // #3 = $AddrOps32:offset:addr
/*  2154*/    OPC_Scope, 23, /*->2179*/ // 2 children in Scope
/*  2156*/     OPC_CheckChild2TypeI32,
/*  2157*/     OPC_CheckPredicate4,  // Predicate_unindexedstore
/*  2158*/     OPC_CheckPredicate, 11, // Predicate_truncstore
/*  2160*/     OPC_CheckPredicate, 20, // Predicate_truncstorei16
/*  2162*/     OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64())
/*  2163*/     OPC_CheckComplexPat0, /*#*/3, // SelectAddrOperands32:$ #4 #5
/*  2165*/     OPC_EmitMergeInputChains1_0,
/*  2166*/     OPC_EmitInteger32, 0, 
/*  2168*/     OPC_EmitConvertToTarget2,
/*  2169*/     OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE_LANE_I16x8_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   5/*#Ops*/, 6, 4, 7, 5, 1, 
               // Src: (st (vector_extract:{ *:[i32] } V128:{ *:[v8i16] }:$vec, (imm:{ *:[i32] })<<P:Predicate_LaneIdx8>>:$idx), (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei16>> - Complexity = 21
               // Dst: (STORE_LANE_I16x8_A32 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, (imm:{ *:[i32] }):$idx, ?:{ *:[i32] }:$addr, ?:{ *:[v8i16] }:$vec)
/*  2179*/    /*Scope*/ 23, /*->2203*/
/*  2180*/     OPC_CheckChild2TypeI64,
/*  2181*/     OPC_CheckPredicate4,  // Predicate_unindexedstore
/*  2182*/     OPC_CheckPredicate, 11, // Predicate_truncstore
/*  2184*/     OPC_CheckPredicate, 20, // Predicate_truncstorei16
/*  2186*/     OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64())
/*  2187*/     OPC_CheckComplexPat1, /*#*/3, // SelectAddrOperands64:$ #4 #5
/*  2189*/     OPC_EmitMergeInputChains1_0,
/*  2190*/     OPC_EmitInteger32, 0, 
/*  2192*/     OPC_EmitConvertToTarget2,
/*  2193*/     OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE_LANE_I16x8_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   5/*#Ops*/, 6, 4, 7, 5, 1, 
               // Src: (st (vector_extract:{ *:[i32] } V128:{ *:[v8i16] }:$vec, (imm:{ *:[i32] })<<P:Predicate_LaneIdx8>>:$idx), (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei16>> - Complexity = 21
               // Dst: (STORE_LANE_I16x8_A64 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, (imm:{ *:[i32] }):$idx, ?:{ *:[i64] }:$addr, ?:{ *:[v8i16] }:$vec)
/*  2203*/    0, /*End of Scope*/
/*  2204*/   /*Scope*/ 58, /*->2263*/
/*  2205*/    OPC_CheckChild0Type, MVT::v4i32,
/*  2207*/    OPC_RecordChild1, // #2 = $idx
/*  2208*/    OPC_MoveChild1,
/*  2209*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/*  2212*/    OPC_CheckPredicate, 17, // Predicate_LaneIdx4
/*  2214*/    OPC_CheckTypeI32,
/*  2215*/    OPC_MoveParent,
/*  2216*/    OPC_CheckTypeI32,
/*  2217*/    OPC_MoveParent,
/*  2218*/    OPC_RecordChild2, // #3 = $AddrOps32:offset:addr
/*  2219*/    OPC_Scope, 20, /*->2241*/ // 2 children in Scope
/*  2221*/     OPC_CheckChild2TypeI32,
/*  2222*/     OPC_CheckPredicate4,  // Predicate_unindexedstore
/*  2223*/     OPC_CheckPredicate5,  // Predicate_store
/*  2224*/     OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64())
/*  2225*/     OPC_CheckComplexPat0, /*#*/3, // SelectAddrOperands32:$ #4 #5
/*  2227*/     OPC_EmitMergeInputChains1_0,
/*  2228*/     OPC_EmitInteger32, 0, 
/*  2230*/     OPC_EmitConvertToTarget2,
/*  2231*/     OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE_LANE_I32x4_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   5/*#Ops*/, 6, 4, 7, 5, 1, 
               // Src: (st (vector_extract:{ *:[i32] } V128:{ *:[v4i32] }:$vec, (imm:{ *:[i32] })<<P:Predicate_LaneIdx4>>:$idx), (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedstore>><<P:Predicate_store>> - Complexity = 21
               // Dst: (STORE_LANE_I32x4_A32 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, (imm:{ *:[i32] }):$idx, ?:{ *:[i32] }:$addr, ?:{ *:[v4i32] }:$vec)
/*  2241*/    /*Scope*/ 20, /*->2262*/
/*  2242*/     OPC_CheckChild2TypeI64,
/*  2243*/     OPC_CheckPredicate4,  // Predicate_unindexedstore
/*  2244*/     OPC_CheckPredicate5,  // Predicate_store
/*  2245*/     OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64())
/*  2246*/     OPC_CheckComplexPat1, /*#*/3, // SelectAddrOperands64:$ #4 #5
/*  2248*/     OPC_EmitMergeInputChains1_0,
/*  2249*/     OPC_EmitInteger32, 0, 
/*  2251*/     OPC_EmitConvertToTarget2,
/*  2252*/     OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE_LANE_I32x4_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   5/*#Ops*/, 6, 4, 7, 5, 1, 
               // Src: (st (vector_extract:{ *:[i32] } V128:{ *:[v4i32] }:$vec, (imm:{ *:[i32] })<<P:Predicate_LaneIdx4>>:$idx), (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedstore>><<P:Predicate_store>> - Complexity = 21
               // Dst: (STORE_LANE_I32x4_A64 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, (imm:{ *:[i32] }):$idx, ?:{ *:[i64] }:$addr, ?:{ *:[v4i32] }:$vec)
/*  2262*/    0, /*End of Scope*/
/*  2263*/   /*Scope*/ 58, /*->2322*/
/*  2264*/    OPC_CheckChild0Type, MVT::v2i64,
/*  2266*/    OPC_RecordChild1, // #2 = $idx
/*  2267*/    OPC_MoveChild1,
/*  2268*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/*  2271*/    OPC_CheckPredicate, 18, // Predicate_LaneIdx2
/*  2273*/    OPC_CheckTypeI32,
/*  2274*/    OPC_MoveParent,
/*  2275*/    OPC_CheckTypeI64,
/*  2276*/    OPC_MoveParent,
/*  2277*/    OPC_RecordChild2, // #3 = $AddrOps32:offset:addr
/*  2278*/    OPC_Scope, 20, /*->2300*/ // 2 children in Scope
/*  2280*/     OPC_CheckChild2TypeI32,
/*  2281*/     OPC_CheckPredicate4,  // Predicate_unindexedstore
/*  2282*/     OPC_CheckPredicate5,  // Predicate_store
/*  2283*/     OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64())
/*  2284*/     OPC_CheckComplexPat0, /*#*/3, // SelectAddrOperands32:$ #4 #5
/*  2286*/     OPC_EmitMergeInputChains1_0,
/*  2287*/     OPC_EmitInteger32, 0, 
/*  2289*/     OPC_EmitConvertToTarget2,
/*  2290*/     OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE_LANE_I64x2_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   5/*#Ops*/, 6, 4, 7, 5, 1, 
               // Src: (st (vector_extract:{ *:[i64] } V128:{ *:[v2i64] }:$vec, (imm:{ *:[i32] })<<P:Predicate_LaneIdx2>>:$idx), (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedstore>><<P:Predicate_store>> - Complexity = 21
               // Dst: (STORE_LANE_I64x2_A32 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, (imm:{ *:[i32] }):$idx, ?:{ *:[i32] }:$addr, ?:{ *:[v2i64] }:$vec)
/*  2300*/    /*Scope*/ 20, /*->2321*/
/*  2301*/     OPC_CheckChild2TypeI64,
/*  2302*/     OPC_CheckPredicate4,  // Predicate_unindexedstore
/*  2303*/     OPC_CheckPredicate5,  // Predicate_store
/*  2304*/     OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64())
/*  2305*/     OPC_CheckComplexPat1, /*#*/3, // SelectAddrOperands64:$ #4 #5
/*  2307*/     OPC_EmitMergeInputChains1_0,
/*  2308*/     OPC_EmitInteger32, 0, 
/*  2310*/     OPC_EmitConvertToTarget2,
/*  2311*/     OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE_LANE_I64x2_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   5/*#Ops*/, 6, 4, 7, 5, 1, 
               // Src: (st (vector_extract:{ *:[i64] } V128:{ *:[v2i64] }:$vec, (imm:{ *:[i32] })<<P:Predicate_LaneIdx2>>:$idx), (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedstore>><<P:Predicate_store>> - Complexity = 21
               // Dst: (STORE_LANE_I64x2_A64 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, (imm:{ *:[i32] }):$idx, ?:{ *:[i64] }:$addr, ?:{ *:[v2i64] }:$vec)
/*  2321*/    0, /*End of Scope*/
/*  2322*/   0, /*End of Scope*/
/*  2323*/  /*Scope*/ 15|128,5/*655*/, /*->2980*/
/*  2325*/   OPC_RecordChild1, // #1 = $val
/*  2326*/   OPC_Scope, 2|128,1/*130*/, /*->2459*/ // 10 children in Scope
/*  2329*/    OPC_CheckChild1TypeI32,
/*  2330*/    OPC_RecordChild2, // #2 = $AddrOps32:offset:addr
/*  2331*/    OPC_Scope, 62, /*->2395*/ // 2 children in Scope
/*  2333*/     OPC_CheckChild2TypeI32,
/*  2334*/     OPC_CheckPredicate4,  // Predicate_unindexedstore
/*  2335*/     OPC_Scope, 16, /*->2353*/ // 2 children in Scope
/*  2337*/      OPC_CheckPredicate5,  // Predicate_store
/*  2338*/      OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64())
/*  2339*/      OPC_CheckComplexPat0, /*#*/2, // SelectAddrOperands32:$ #3 #4
/*  2341*/      OPC_EmitMergeInputChains1_0,
/*  2342*/      OPC_EmitInteger32, 0, 
/*  2344*/      OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    4/*#Ops*/, 5, 3, 4, 1, 
                // Src: (st i32:{ *:[i32] }:$val, (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedstore>><<P:Predicate_store>> - Complexity = 13
                // Dst: (STORE_I32_A32 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr, i32:{ *:[i32] }:$val)
/*  2353*/     /*Scope*/ 40, /*->2394*/
/*  2354*/      OPC_CheckPredicate, 11, // Predicate_truncstore
/*  2356*/      OPC_Scope, 17, /*->2375*/ // 2 children in Scope
/*  2358*/       OPC_CheckPredicate, 19, // Predicate_truncstorei8
/*  2360*/       OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64())
/*  2361*/       OPC_CheckComplexPat0, /*#*/2, // SelectAddrOperands32:$ #3 #4
/*  2363*/       OPC_EmitMergeInputChains1_0,
/*  2364*/       OPC_EmitInteger32, 0, 
/*  2366*/       OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE8_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                     4/*#Ops*/, 5, 3, 4, 1, 
                 // Src: (st i32:{ *:[i32] }:$val, (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei8>> - Complexity = 13
                 // Dst: (STORE8_I32_A32 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr, i32:{ *:[i32] }:$val)
/*  2375*/      /*Scope*/ 17, /*->2393*/
/*  2376*/       OPC_CheckPredicate, 20, // Predicate_truncstorei16
/*  2378*/       OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64())
/*  2379*/       OPC_CheckComplexPat0, /*#*/2, // SelectAddrOperands32:$ #3 #4
/*  2381*/       OPC_EmitMergeInputChains1_0,
/*  2382*/       OPC_EmitInteger32, 0, 
/*  2384*/       OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE16_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                     4/*#Ops*/, 5, 3, 4, 1, 
                 // Src: (st i32:{ *:[i32] }:$val, (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei16>> - Complexity = 13
                 // Dst: (STORE16_I32_A32 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr, i32:{ *:[i32] }:$val)
/*  2393*/      0, /*End of Scope*/
/*  2394*/     0, /*End of Scope*/
/*  2395*/    /*Scope*/ 62, /*->2458*/
/*  2396*/     OPC_CheckChild2TypeI64,
/*  2397*/     OPC_CheckPredicate4,  // Predicate_unindexedstore
/*  2398*/     OPC_Scope, 16, /*->2416*/ // 2 children in Scope
/*  2400*/      OPC_CheckPredicate5,  // Predicate_store
/*  2401*/      OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64())
/*  2402*/      OPC_CheckComplexPat1, /*#*/2, // SelectAddrOperands64:$ #3 #4
/*  2404*/      OPC_EmitMergeInputChains1_0,
/*  2405*/      OPC_EmitInteger32, 0, 
/*  2407*/      OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    4/*#Ops*/, 5, 3, 4, 1, 
                // Src: (st i32:{ *:[i32] }:$val, (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedstore>><<P:Predicate_store>> - Complexity = 13
                // Dst: (STORE_I32_A64 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr, i32:{ *:[i32] }:$val)
/*  2416*/     /*Scope*/ 40, /*->2457*/
/*  2417*/      OPC_CheckPredicate, 11, // Predicate_truncstore
/*  2419*/      OPC_Scope, 17, /*->2438*/ // 2 children in Scope
/*  2421*/       OPC_CheckPredicate, 19, // Predicate_truncstorei8
/*  2423*/       OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64())
/*  2424*/       OPC_CheckComplexPat1, /*#*/2, // SelectAddrOperands64:$ #3 #4
/*  2426*/       OPC_EmitMergeInputChains1_0,
/*  2427*/       OPC_EmitInteger32, 0, 
/*  2429*/       OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE8_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                     4/*#Ops*/, 5, 3, 4, 1, 
                 // Src: (st i32:{ *:[i32] }:$val, (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei8>> - Complexity = 13
                 // Dst: (STORE8_I32_A64 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr, i32:{ *:[i32] }:$val)
/*  2438*/      /*Scope*/ 17, /*->2456*/
/*  2439*/       OPC_CheckPredicate, 20, // Predicate_truncstorei16
/*  2441*/       OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64())
/*  2442*/       OPC_CheckComplexPat1, /*#*/2, // SelectAddrOperands64:$ #3 #4
/*  2444*/       OPC_EmitMergeInputChains1_0,
/*  2445*/       OPC_EmitInteger32, 0, 
/*  2447*/       OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE16_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                     4/*#Ops*/, 5, 3, 4, 1, 
                 // Src: (st i32:{ *:[i32] }:$val, (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei16>> - Complexity = 13
                 // Dst: (STORE16_I32_A64 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr, i32:{ *:[i32] }:$val)
/*  2456*/      0, /*End of Scope*/
/*  2457*/     0, /*End of Scope*/
/*  2458*/    0, /*End of Scope*/
/*  2459*/   /*Scope*/ 38|128,1/*166*/, /*->2627*/
/*  2461*/    OPC_CheckChild1TypeI64,
/*  2462*/    OPC_RecordChild2, // #2 = $AddrOps32:offset:addr
/*  2463*/    OPC_Scope, 80, /*->2545*/ // 2 children in Scope
/*  2465*/     OPC_CheckChild2TypeI32,
/*  2466*/     OPC_CheckPredicate4,  // Predicate_unindexedstore
/*  2467*/     OPC_Scope, 16, /*->2485*/ // 2 children in Scope
/*  2469*/      OPC_CheckPredicate5,  // Predicate_store
/*  2470*/      OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64())
/*  2471*/      OPC_CheckComplexPat0, /*#*/2, // SelectAddrOperands32:$ #3 #4
/*  2473*/      OPC_EmitMergeInputChains1_0,
/*  2474*/      OPC_EmitInteger32, 0, 
/*  2476*/      OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    4/*#Ops*/, 5, 3, 4, 1, 
                // Src: (st i64:{ *:[i64] }:$val, (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedstore>><<P:Predicate_store>> - Complexity = 13
                // Dst: (STORE_I64_A32 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr, i64:{ *:[i64] }:$val)
/*  2485*/     /*Scope*/ 58, /*->2544*/
/*  2486*/      OPC_CheckPredicate, 11, // Predicate_truncstore
/*  2488*/      OPC_Scope, 17, /*->2507*/ // 3 children in Scope
/*  2490*/       OPC_CheckPredicate, 19, // Predicate_truncstorei8
/*  2492*/       OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64())
/*  2493*/       OPC_CheckComplexPat0, /*#*/2, // SelectAddrOperands32:$ #3 #4
/*  2495*/       OPC_EmitMergeInputChains1_0,
/*  2496*/       OPC_EmitInteger32, 0, 
/*  2498*/       OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE8_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                     4/*#Ops*/, 5, 3, 4, 1, 
                 // Src: (st i64:{ *:[i64] }:$val, (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei8>> - Complexity = 13
                 // Dst: (STORE8_I64_A32 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr, i64:{ *:[i64] }:$val)
/*  2507*/      /*Scope*/ 17, /*->2525*/
/*  2508*/       OPC_CheckPredicate, 20, // Predicate_truncstorei16
/*  2510*/       OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64())
/*  2511*/       OPC_CheckComplexPat0, /*#*/2, // SelectAddrOperands32:$ #3 #4
/*  2513*/       OPC_EmitMergeInputChains1_0,
/*  2514*/       OPC_EmitInteger32, 0, 
/*  2516*/       OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE16_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                     4/*#Ops*/, 5, 3, 4, 1, 
                 // Src: (st i64:{ *:[i64] }:$val, (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei16>> - Complexity = 13
                 // Dst: (STORE16_I64_A32 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr, i64:{ *:[i64] }:$val)
/*  2525*/      /*Scope*/ 17, /*->2543*/
/*  2526*/       OPC_CheckPredicate, 25, // Predicate_truncstorei32
/*  2528*/       OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64())
/*  2529*/       OPC_CheckComplexPat0, /*#*/2, // SelectAddrOperands32:$ #3 #4
/*  2531*/       OPC_EmitMergeInputChains1_0,
/*  2532*/       OPC_EmitInteger32, 0, 
/*  2534*/       OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE32_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                     4/*#Ops*/, 5, 3, 4, 1, 
                 // Src: (st i64:{ *:[i64] }:$val, (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei32>> - Complexity = 13
                 // Dst: (STORE32_I64_A32 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr, i64:{ *:[i64] }:$val)
/*  2543*/      0, /*End of Scope*/
/*  2544*/     0, /*End of Scope*/
/*  2545*/    /*Scope*/ 80, /*->2626*/
/*  2546*/     OPC_CheckChild2TypeI64,
/*  2547*/     OPC_CheckPredicate4,  // Predicate_unindexedstore
/*  2548*/     OPC_Scope, 16, /*->2566*/ // 2 children in Scope
/*  2550*/      OPC_CheckPredicate5,  // Predicate_store
/*  2551*/      OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64())
/*  2552*/      OPC_CheckComplexPat1, /*#*/2, // SelectAddrOperands64:$ #3 #4
/*  2554*/      OPC_EmitMergeInputChains1_0,
/*  2555*/      OPC_EmitInteger32, 0, 
/*  2557*/      OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    4/*#Ops*/, 5, 3, 4, 1, 
                // Src: (st i64:{ *:[i64] }:$val, (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedstore>><<P:Predicate_store>> - Complexity = 13
                // Dst: (STORE_I64_A64 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr, i64:{ *:[i64] }:$val)
/*  2566*/     /*Scope*/ 58, /*->2625*/
/*  2567*/      OPC_CheckPredicate, 11, // Predicate_truncstore
/*  2569*/      OPC_Scope, 17, /*->2588*/ // 3 children in Scope
/*  2571*/       OPC_CheckPredicate, 19, // Predicate_truncstorei8
/*  2573*/       OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64())
/*  2574*/       OPC_CheckComplexPat1, /*#*/2, // SelectAddrOperands64:$ #3 #4
/*  2576*/       OPC_EmitMergeInputChains1_0,
/*  2577*/       OPC_EmitInteger32, 0, 
/*  2579*/       OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE8_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                     4/*#Ops*/, 5, 3, 4, 1, 
                 // Src: (st i64:{ *:[i64] }:$val, (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei8>> - Complexity = 13
                 // Dst: (STORE8_I64_A64 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr, i64:{ *:[i64] }:$val)
/*  2588*/      /*Scope*/ 17, /*->2606*/
/*  2589*/       OPC_CheckPredicate, 20, // Predicate_truncstorei16
/*  2591*/       OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64())
/*  2592*/       OPC_CheckComplexPat1, /*#*/2, // SelectAddrOperands64:$ #3 #4
/*  2594*/       OPC_EmitMergeInputChains1_0,
/*  2595*/       OPC_EmitInteger32, 0, 
/*  2597*/       OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE16_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                     4/*#Ops*/, 5, 3, 4, 1, 
                 // Src: (st i64:{ *:[i64] }:$val, (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei16>> - Complexity = 13
                 // Dst: (STORE16_I64_A64 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr, i64:{ *:[i64] }:$val)
/*  2606*/      /*Scope*/ 17, /*->2624*/
/*  2607*/       OPC_CheckPredicate, 25, // Predicate_truncstorei32
/*  2609*/       OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64())
/*  2610*/       OPC_CheckComplexPat1, /*#*/2, // SelectAddrOperands64:$ #3 #4
/*  2612*/       OPC_EmitMergeInputChains1_0,
/*  2613*/       OPC_EmitInteger32, 0, 
/*  2615*/       OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE32_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                     4/*#Ops*/, 5, 3, 4, 1, 
                 // Src: (st i64:{ *:[i64] }:$val, (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei32>> - Complexity = 13
                 // Dst: (STORE32_I64_A64 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr, i64:{ *:[i64] }:$val)
/*  2624*/      0, /*End of Scope*/
/*  2625*/     0, /*End of Scope*/
/*  2626*/    0, /*End of Scope*/
/*  2627*/   /*Scope*/ 43, /*->2671*/
/*  2628*/    OPC_CheckChild1Type, MVT::f32,
/*  2630*/    OPC_RecordChild2, // #2 = $AddrOps32:offset:addr
/*  2631*/    OPC_Scope, 18, /*->2651*/ // 2 children in Scope
/*  2633*/     OPC_CheckChild2TypeI32,
/*  2634*/     OPC_CheckPredicate4,  // Predicate_unindexedstore
/*  2635*/     OPC_CheckPredicate5,  // Predicate_store
/*  2636*/     OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64())
/*  2637*/     OPC_CheckComplexPat0, /*#*/2, // SelectAddrOperands32:$ #3 #4
/*  2639*/     OPC_EmitMergeInputChains1_0,
/*  2640*/     OPC_EmitInteger32, 0, 
/*  2642*/     OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE_F32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   4/*#Ops*/, 5, 3, 4, 1, 
               // Src: (st f32:{ *:[f32] }:$val, (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedstore>><<P:Predicate_store>> - Complexity = 13
               // Dst: (STORE_F32_A32 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr, f32:{ *:[f32] }:$val)
/*  2651*/    /*Scope*/ 18, /*->2670*/
/*  2652*/     OPC_CheckChild2TypeI64,
/*  2653*/     OPC_CheckPredicate4,  // Predicate_unindexedstore
/*  2654*/     OPC_CheckPredicate5,  // Predicate_store
/*  2655*/     OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64())
/*  2656*/     OPC_CheckComplexPat1, /*#*/2, // SelectAddrOperands64:$ #3 #4
/*  2658*/     OPC_EmitMergeInputChains1_0,
/*  2659*/     OPC_EmitInteger32, 0, 
/*  2661*/     OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE_F32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   4/*#Ops*/, 5, 3, 4, 1, 
               // Src: (st f32:{ *:[f32] }:$val, (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedstore>><<P:Predicate_store>> - Complexity = 13
               // Dst: (STORE_F32_A64 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr, f32:{ *:[f32] }:$val)
/*  2670*/    0, /*End of Scope*/
/*  2671*/   /*Scope*/ 43, /*->2715*/
/*  2672*/    OPC_CheckChild1Type, MVT::f64,
/*  2674*/    OPC_RecordChild2, // #2 = $AddrOps32:offset:addr
/*  2675*/    OPC_Scope, 18, /*->2695*/ // 2 children in Scope
/*  2677*/     OPC_CheckChild2TypeI32,
/*  2678*/     OPC_CheckPredicate4,  // Predicate_unindexedstore
/*  2679*/     OPC_CheckPredicate5,  // Predicate_store
/*  2680*/     OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64())
/*  2681*/     OPC_CheckComplexPat0, /*#*/2, // SelectAddrOperands32:$ #3 #4
/*  2683*/     OPC_EmitMergeInputChains1_0,
/*  2684*/     OPC_EmitInteger32, 0, 
/*  2686*/     OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE_F64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   4/*#Ops*/, 5, 3, 4, 1, 
               // Src: (st f64:{ *:[f64] }:$val, (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedstore>><<P:Predicate_store>> - Complexity = 13
               // Dst: (STORE_F64_A32 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr, f64:{ *:[f64] }:$val)
/*  2695*/    /*Scope*/ 18, /*->2714*/
/*  2696*/     OPC_CheckChild2TypeI64,
/*  2697*/     OPC_CheckPredicate4,  // Predicate_unindexedstore
/*  2698*/     OPC_CheckPredicate5,  // Predicate_store
/*  2699*/     OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64())
/*  2700*/     OPC_CheckComplexPat1, /*#*/2, // SelectAddrOperands64:$ #3 #4
/*  2702*/     OPC_EmitMergeInputChains1_0,
/*  2703*/     OPC_EmitInteger32, 0, 
/*  2705*/     OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE_F64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   4/*#Ops*/, 5, 3, 4, 1, 
               // Src: (st f64:{ *:[f64] }:$val, (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedstore>><<P:Predicate_store>> - Complexity = 13
               // Dst: (STORE_F64_A64 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr, f64:{ *:[f64] }:$val)
/*  2714*/    0, /*End of Scope*/
/*  2715*/   /*Scope*/ 43, /*->2759*/
/*  2716*/    OPC_CheckChild1Type, MVT::v16i8,
/*  2718*/    OPC_RecordChild2, // #2 = $AddrOps32:offset:addr
/*  2719*/    OPC_Scope, 18, /*->2739*/ // 2 children in Scope
/*  2721*/     OPC_CheckChild2TypeI32,
/*  2722*/     OPC_CheckPredicate4,  // Predicate_unindexedstore
/*  2723*/     OPC_CheckPredicate5,  // Predicate_store
/*  2724*/     OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64())
/*  2725*/     OPC_CheckComplexPat0, /*#*/2, // SelectAddrOperands32:$ #3 #4
/*  2727*/     OPC_EmitMergeInputChains1_0,
/*  2728*/     OPC_EmitInteger32, 0, 
/*  2730*/     OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE_V128_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   4/*#Ops*/, 5, 3, 4, 1, 
               // Src: (st v16i8:{ *:[v16i8] }:$val, (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedstore>><<P:Predicate_store>> - Complexity = 13
               // Dst: (STORE_V128_A32 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr, v16i8:{ *:[v16i8] }:$val)
/*  2739*/    /*Scope*/ 18, /*->2758*/
/*  2740*/     OPC_CheckChild2TypeI64,
/*  2741*/     OPC_CheckPredicate4,  // Predicate_unindexedstore
/*  2742*/     OPC_CheckPredicate5,  // Predicate_store
/*  2743*/     OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64())
/*  2744*/     OPC_CheckComplexPat1, /*#*/2, // SelectAddrOperands64:$ #3 #4
/*  2746*/     OPC_EmitMergeInputChains1_0,
/*  2747*/     OPC_EmitInteger32, 0, 
/*  2749*/     OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE_V128_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   4/*#Ops*/, 5, 3, 4, 1, 
               // Src: (st v16i8:{ *:[v16i8] }:$val, (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedstore>><<P:Predicate_store>> - Complexity = 13
               // Dst: (STORE_V128_A64 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr, v16i8:{ *:[v16i8] }:$val)
/*  2758*/    0, /*End of Scope*/
/*  2759*/   /*Scope*/ 43, /*->2803*/
/*  2760*/    OPC_CheckChild1Type, MVT::v8i16,
/*  2762*/    OPC_RecordChild2, // #2 = $AddrOps32:offset:addr
/*  2763*/    OPC_Scope, 18, /*->2783*/ // 2 children in Scope
/*  2765*/     OPC_CheckChild2TypeI32,
/*  2766*/     OPC_CheckPredicate4,  // Predicate_unindexedstore
/*  2767*/     OPC_CheckPredicate5,  // Predicate_store
/*  2768*/     OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64())
/*  2769*/     OPC_CheckComplexPat0, /*#*/2, // SelectAddrOperands32:$ #3 #4
/*  2771*/     OPC_EmitMergeInputChains1_0,
/*  2772*/     OPC_EmitInteger32, 0, 
/*  2774*/     OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE_V128_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   4/*#Ops*/, 5, 3, 4, 1, 
               // Src: (st v8i16:{ *:[v8i16] }:$val, (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedstore>><<P:Predicate_store>> - Complexity = 13
               // Dst: (STORE_V128_A32 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr, v8i16:{ *:[v8i16] }:$val)
/*  2783*/    /*Scope*/ 18, /*->2802*/
/*  2784*/     OPC_CheckChild2TypeI64,
/*  2785*/     OPC_CheckPredicate4,  // Predicate_unindexedstore
/*  2786*/     OPC_CheckPredicate5,  // Predicate_store
/*  2787*/     OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64())
/*  2788*/     OPC_CheckComplexPat1, /*#*/2, // SelectAddrOperands64:$ #3 #4
/*  2790*/     OPC_EmitMergeInputChains1_0,
/*  2791*/     OPC_EmitInteger32, 0, 
/*  2793*/     OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE_V128_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   4/*#Ops*/, 5, 3, 4, 1, 
               // Src: (st v8i16:{ *:[v8i16] }:$val, (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedstore>><<P:Predicate_store>> - Complexity = 13
               // Dst: (STORE_V128_A64 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr, v8i16:{ *:[v8i16] }:$val)
/*  2802*/    0, /*End of Scope*/
/*  2803*/   /*Scope*/ 43, /*->2847*/
/*  2804*/    OPC_CheckChild1Type, MVT::v4i32,
/*  2806*/    OPC_RecordChild2, // #2 = $AddrOps32:offset:addr
/*  2807*/    OPC_Scope, 18, /*->2827*/ // 2 children in Scope
/*  2809*/     OPC_CheckChild2TypeI32,
/*  2810*/     OPC_CheckPredicate4,  // Predicate_unindexedstore
/*  2811*/     OPC_CheckPredicate5,  // Predicate_store
/*  2812*/     OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64())
/*  2813*/     OPC_CheckComplexPat0, /*#*/2, // SelectAddrOperands32:$ #3 #4
/*  2815*/     OPC_EmitMergeInputChains1_0,
/*  2816*/     OPC_EmitInteger32, 0, 
/*  2818*/     OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE_V128_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   4/*#Ops*/, 5, 3, 4, 1, 
               // Src: (st v4i32:{ *:[v4i32] }:$val, (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedstore>><<P:Predicate_store>> - Complexity = 13
               // Dst: (STORE_V128_A32 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr, v4i32:{ *:[v4i32] }:$val)
/*  2827*/    /*Scope*/ 18, /*->2846*/
/*  2828*/     OPC_CheckChild2TypeI64,
/*  2829*/     OPC_CheckPredicate4,  // Predicate_unindexedstore
/*  2830*/     OPC_CheckPredicate5,  // Predicate_store
/*  2831*/     OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64())
/*  2832*/     OPC_CheckComplexPat1, /*#*/2, // SelectAddrOperands64:$ #3 #4
/*  2834*/     OPC_EmitMergeInputChains1_0,
/*  2835*/     OPC_EmitInteger32, 0, 
/*  2837*/     OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE_V128_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   4/*#Ops*/, 5, 3, 4, 1, 
               // Src: (st v4i32:{ *:[v4i32] }:$val, (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedstore>><<P:Predicate_store>> - Complexity = 13
               // Dst: (STORE_V128_A64 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr, v4i32:{ *:[v4i32] }:$val)
/*  2846*/    0, /*End of Scope*/
/*  2847*/   /*Scope*/ 43, /*->2891*/
/*  2848*/    OPC_CheckChild1Type, MVT::v2i64,
/*  2850*/    OPC_RecordChild2, // #2 = $AddrOps32:offset:addr
/*  2851*/    OPC_Scope, 18, /*->2871*/ // 2 children in Scope
/*  2853*/     OPC_CheckChild2TypeI32,
/*  2854*/     OPC_CheckPredicate4,  // Predicate_unindexedstore
/*  2855*/     OPC_CheckPredicate5,  // Predicate_store
/*  2856*/     OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64())
/*  2857*/     OPC_CheckComplexPat0, /*#*/2, // SelectAddrOperands32:$ #3 #4
/*  2859*/     OPC_EmitMergeInputChains1_0,
/*  2860*/     OPC_EmitInteger32, 0, 
/*  2862*/     OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE_V128_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   4/*#Ops*/, 5, 3, 4, 1, 
               // Src: (st v2i64:{ *:[v2i64] }:$val, (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedstore>><<P:Predicate_store>> - Complexity = 13
               // Dst: (STORE_V128_A32 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr, v2i64:{ *:[v2i64] }:$val)
/*  2871*/    /*Scope*/ 18, /*->2890*/
/*  2872*/     OPC_CheckChild2TypeI64,
/*  2873*/     OPC_CheckPredicate4,  // Predicate_unindexedstore
/*  2874*/     OPC_CheckPredicate5,  // Predicate_store
/*  2875*/     OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64())
/*  2876*/     OPC_CheckComplexPat1, /*#*/2, // SelectAddrOperands64:$ #3 #4
/*  2878*/     OPC_EmitMergeInputChains1_0,
/*  2879*/     OPC_EmitInteger32, 0, 
/*  2881*/     OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE_V128_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   4/*#Ops*/, 5, 3, 4, 1, 
               // Src: (st v2i64:{ *:[v2i64] }:$val, (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedstore>><<P:Predicate_store>> - Complexity = 13
               // Dst: (STORE_V128_A64 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr, v2i64:{ *:[v2i64] }:$val)
/*  2890*/    0, /*End of Scope*/
/*  2891*/   /*Scope*/ 43, /*->2935*/
/*  2892*/    OPC_CheckChild1Type, MVT::v4f32,
/*  2894*/    OPC_RecordChild2, // #2 = $AddrOps32:offset:addr
/*  2895*/    OPC_Scope, 18, /*->2915*/ // 2 children in Scope
/*  2897*/     OPC_CheckChild2TypeI32,
/*  2898*/     OPC_CheckPredicate4,  // Predicate_unindexedstore
/*  2899*/     OPC_CheckPredicate5,  // Predicate_store
/*  2900*/     OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64())
/*  2901*/     OPC_CheckComplexPat0, /*#*/2, // SelectAddrOperands32:$ #3 #4
/*  2903*/     OPC_EmitMergeInputChains1_0,
/*  2904*/     OPC_EmitInteger32, 0, 
/*  2906*/     OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE_V128_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   4/*#Ops*/, 5, 3, 4, 1, 
               // Src: (st v4f32:{ *:[v4f32] }:$val, (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedstore>><<P:Predicate_store>> - Complexity = 13
               // Dst: (STORE_V128_A32 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr, v4f32:{ *:[v4f32] }:$val)
/*  2915*/    /*Scope*/ 18, /*->2934*/
/*  2916*/     OPC_CheckChild2TypeI64,
/*  2917*/     OPC_CheckPredicate4,  // Predicate_unindexedstore
/*  2918*/     OPC_CheckPredicate5,  // Predicate_store
/*  2919*/     OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64())
/*  2920*/     OPC_CheckComplexPat1, /*#*/2, // SelectAddrOperands64:$ #3 #4
/*  2922*/     OPC_EmitMergeInputChains1_0,
/*  2923*/     OPC_EmitInteger32, 0, 
/*  2925*/     OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE_V128_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   4/*#Ops*/, 5, 3, 4, 1, 
               // Src: (st v4f32:{ *:[v4f32] }:$val, (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedstore>><<P:Predicate_store>> - Complexity = 13
               // Dst: (STORE_V128_A64 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr, v4f32:{ *:[v4f32] }:$val)
/*  2934*/    0, /*End of Scope*/
/*  2935*/   /*Scope*/ 43, /*->2979*/
/*  2936*/    OPC_CheckChild1Type, MVT::v2f64,
/*  2938*/    OPC_RecordChild2, // #2 = $AddrOps32:offset:addr
/*  2939*/    OPC_Scope, 18, /*->2959*/ // 2 children in Scope
/*  2941*/     OPC_CheckChild2TypeI32,
/*  2942*/     OPC_CheckPredicate4,  // Predicate_unindexedstore
/*  2943*/     OPC_CheckPredicate5,  // Predicate_store
/*  2944*/     OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64())
/*  2945*/     OPC_CheckComplexPat0, /*#*/2, // SelectAddrOperands32:$ #3 #4
/*  2947*/     OPC_EmitMergeInputChains1_0,
/*  2948*/     OPC_EmitInteger32, 0, 
/*  2950*/     OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE_V128_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   4/*#Ops*/, 5, 3, 4, 1, 
               // Src: (st v2f64:{ *:[v2f64] }:$val, (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedstore>><<P:Predicate_store>> - Complexity = 13
               // Dst: (STORE_V128_A32 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr, v2f64:{ *:[v2f64] }:$val)
/*  2959*/    /*Scope*/ 18, /*->2978*/
/*  2960*/     OPC_CheckChild2TypeI64,
/*  2961*/     OPC_CheckPredicate4,  // Predicate_unindexedstore
/*  2962*/     OPC_CheckPredicate5,  // Predicate_store
/*  2963*/     OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64())
/*  2964*/     OPC_CheckComplexPat1, /*#*/2, // SelectAddrOperands64:$ #3 #4
/*  2966*/     OPC_EmitMergeInputChains1_0,
/*  2967*/     OPC_EmitInteger32, 0, 
/*  2969*/     OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE_V128_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   4/*#Ops*/, 5, 3, 4, 1, 
               // Src: (st v2f64:{ *:[v2f64] }:$val, (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedstore>><<P:Predicate_store>> - Complexity = 13
               // Dst: (STORE_V128_A64 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr, v2f64:{ *:[v2f64] }:$val)
/*  2978*/    0, /*End of Scope*/
/*  2979*/   0, /*End of Scope*/
/*  2980*/  0, /*End of Scope*/
/*  2981*/ /*SwitchOpcode*/ 42|128,1/*170*/, TARGET_VAL(ISD::INTRINSIC_VOID),// ->3155
/*  2985*/  OPC_RecordNode, // #0 = 'intrinsic_void' chained node
/*  2986*/  OPC_Scope, 39, /*->3027*/ // 6 children in Scope
/*  2988*/   OPC_CheckChild1Integer, 80|128,61|128,1/*24272*/, 
/*  2992*/   OPC_MoveChild2,
/*  2993*/   OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/*  2996*/   OPC_RecordChild0, // #1 = $table1
/*  2997*/   OPC_MoveChild0,
/*  2998*/   OPC_CheckOpcode, TARGET_VAL(ISD::TargetGlobalAddress),
/*  3001*/   OPC_MoveParent,
/*  3002*/   OPC_MoveSibling3,
/*  3003*/   OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/*  3006*/   OPC_RecordChild0, // #2 = $table2
/*  3007*/   OPC_MoveChild0,
/*  3008*/   OPC_CheckOpcode, TARGET_VAL(ISD::TargetGlobalAddress),
/*  3011*/   OPC_MoveParent,
/*  3012*/   OPC_MoveParent,
/*  3013*/   OPC_RecordChild4, // #3 = $d
/*  3014*/   OPC_RecordChild5, // #4 = $s
/*  3015*/   OPC_RecordChild6, // #5 = $n
/*  3016*/   OPC_CheckPatternPredicate5, // (Subtarget->hasReferenceTypes())
/*  3017*/   OPC_EmitMergeInputChains1_0,
/*  3018*/   OPC_MorphNodeTo0Chain, TARGET_VAL(WebAssembly::TABLE_COPY),
                 5/*#Ops*/, 1, 2, 3, 4, 5, 
             // Src: (intrinsic_void 12136:{ *:[iPTR] }, (WebAssemblyWrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$table1), (WebAssemblyWrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$table2), I32:{ *:[i32] }:$d, I32:{ *:[i32] }:$s, I32:{ *:[i32] }:$n) - Complexity = 20
             // Dst: (TABLE_COPY (tglobaladdr:{ *:[i32] }):$table1, (tglobaladdr:{ *:[i32] }):$table2, I32:{ *:[i32] }:$d, I32:{ *:[i32] }:$s, I32:{ *:[i32] }:$n)
/*  3027*/  /*Scope*/ 26, /*->3054*/
/*  3028*/   OPC_CheckChild1Integer, 96|128,61|128,1/*24288*/, 
/*  3032*/   OPC_MoveChild2,
/*  3033*/   OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/*  3036*/   OPC_RecordChild0, // #1 = $table
/*  3037*/   OPC_MoveChild0,
/*  3038*/   OPC_CheckOpcode, TARGET_VAL(ISD::TargetGlobalAddress),
/*  3041*/   OPC_MoveParent,
/*  3042*/   OPC_MoveParent,
/*  3043*/   OPC_RecordChild3, // #2 = $i
/*  3044*/   OPC_RecordChild4, // #3 = $val
/*  3045*/   OPC_CheckPatternPredicate5, // (Subtarget->hasReferenceTypes())
/*  3046*/   OPC_EmitMergeInputChains1_0,
/*  3047*/   OPC_MorphNodeTo0Chain, TARGET_VAL(WebAssembly::TABLE_SET_FUNCREF),
                 3/*#Ops*/, 1, 2, 3, 
             // Src: (intrinsic_void 12144:{ *:[iPTR] }, (WebAssemblyWrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$table), I32:{ *:[i32] }:$i, FUNCREF:{ *:[funcref] }:$val) - Complexity = 14
             // Dst: (TABLE_SET_FUNCREF (tglobaladdr:{ *:[i32] }):$table, I32:{ *:[i32] }:$i, FUNCREF:{ *:[funcref] }:$val)
/*  3054*/  /*Scope*/ 28, /*->3083*/
/*  3055*/   OPC_CheckChild1Integer, 84|128,61|128,1/*24276*/, 
/*  3059*/   OPC_MoveChild2,
/*  3060*/   OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/*  3063*/   OPC_RecordChild0, // #1 = $table
/*  3064*/   OPC_MoveChild0,
/*  3065*/   OPC_CheckOpcode, TARGET_VAL(ISD::TargetGlobalAddress),
/*  3068*/   OPC_MoveParent,
/*  3069*/   OPC_MoveParent,
/*  3070*/   OPC_RecordChild3, // #2 = $i
/*  3071*/   OPC_RecordChild4, // #3 = $val
/*  3072*/   OPC_RecordChild5, // #4 = $n
/*  3073*/   OPC_CheckPatternPredicate5, // (Subtarget->hasReferenceTypes())
/*  3074*/   OPC_EmitMergeInputChains1_0,
/*  3075*/   OPC_MorphNodeTo0Chain, TARGET_VAL(WebAssembly::TABLE_FILL_FUNCREF),
                 4/*#Ops*/, 1, 2, 3, 4, 
             // Src: (intrinsic_void 12138:{ *:[iPTR] }, (WebAssemblyWrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$table), I32:{ *:[i32] }:$i, FUNCREF:{ *:[funcref] }:$val, I32:{ *:[i32] }:$n) - Complexity = 14
             // Dst: (TABLE_FILL_FUNCREF (tglobaladdr:{ *:[i32] }):$table, I32:{ *:[i32] }:$i, FUNCREF:{ *:[funcref] }:$val, I32:{ *:[i32] }:$n)
/*  3083*/  /*Scope*/ 26, /*->3110*/
/*  3084*/   OPC_CheckChild1Integer, 94|128,61|128,1/*24286*/, 
/*  3088*/   OPC_MoveChild2,
/*  3089*/   OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/*  3092*/   OPC_RecordChild0, // #1 = $table
/*  3093*/   OPC_MoveChild0,
/*  3094*/   OPC_CheckOpcode, TARGET_VAL(ISD::TargetGlobalAddress),
/*  3097*/   OPC_MoveParent,
/*  3098*/   OPC_MoveParent,
/*  3099*/   OPC_RecordChild3, // #2 = $i
/*  3100*/   OPC_RecordChild4, // #3 = $val
/*  3101*/   OPC_CheckPatternPredicate5, // (Subtarget->hasReferenceTypes())
/*  3102*/   OPC_EmitMergeInputChains1_0,
/*  3103*/   OPC_MorphNodeTo0Chain, TARGET_VAL(WebAssembly::TABLE_SET_EXTERNREF),
                 3/*#Ops*/, 1, 2, 3, 
             // Src: (intrinsic_void 12143:{ *:[iPTR] }, (WebAssemblyWrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$table), I32:{ *:[i32] }:$i, EXTERNREF:{ *:[externref] }:$val) - Complexity = 14
             // Dst: (TABLE_SET_EXTERNREF (tglobaladdr:{ *:[i32] }):$table, I32:{ *:[i32] }:$i, EXTERNREF:{ *:[externref] }:$val)
/*  3110*/  /*Scope*/ 28, /*->3139*/
/*  3111*/   OPC_CheckChild1Integer, 82|128,61|128,1/*24274*/, 
/*  3115*/   OPC_MoveChild2,
/*  3116*/   OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/*  3119*/   OPC_RecordChild0, // #1 = $table
/*  3120*/   OPC_MoveChild0,
/*  3121*/   OPC_CheckOpcode, TARGET_VAL(ISD::TargetGlobalAddress),
/*  3124*/   OPC_MoveParent,
/*  3125*/   OPC_MoveParent,
/*  3126*/   OPC_RecordChild3, // #2 = $i
/*  3127*/   OPC_RecordChild4, // #3 = $val
/*  3128*/   OPC_RecordChild5, // #4 = $n
/*  3129*/   OPC_CheckPatternPredicate5, // (Subtarget->hasReferenceTypes())
/*  3130*/   OPC_EmitMergeInputChains1_0,
/*  3131*/   OPC_MorphNodeTo0Chain, TARGET_VAL(WebAssembly::TABLE_FILL_EXTERNREF),
                 4/*#Ops*/, 1, 2, 3, 4, 
             // Src: (intrinsic_void 12137:{ *:[iPTR] }, (WebAssemblyWrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$table), I32:{ *:[i32] }:$i, EXTERNREF:{ *:[externref] }:$val, I32:{ *:[i32] }:$n) - Complexity = 14
             // Dst: (TABLE_FILL_EXTERNREF (tglobaladdr:{ *:[i32] }):$table, I32:{ *:[i32] }:$i, EXTERNREF:{ *:[externref] }:$val, I32:{ *:[i32] }:$n)
/*  3139*/  /*Scope*/ 14, /*->3154*/
/*  3140*/   OPC_CheckChild1Integer, 70|128,61|128,1/*24262*/, 
/*  3144*/   OPC_CheckPatternPredicate, 13, // (Subtarget->hasExceptionHandling())
/*  3146*/   OPC_EmitMergeInputChains1_0,
/*  3147*/   OPC_EmitInteger32, 0, 
/*  3149*/   OPC_MorphNodeTo0Chain, TARGET_VAL(WebAssembly::RETHROW),
                 1/*#Ops*/, 1, 
             // Src: (intrinsic_void 12131:{ *:[iPTR] }) - Complexity = 8
             // Dst: (RETHROW 0:{ *:[i32] })
/*  3154*/  0, /*End of Scope*/
/*  3155*/ /*SwitchOpcode*/ 106|128,2/*362*/, TARGET_VAL(ISD::INTRINSIC_W_CHAIN),// ->3521
/*  3159*/  OPC_Scope, 22|128,1/*150*/, /*->3312*/ // 2 children in Scope
/*  3162*/   OPC_RecordMemRef,
/*  3163*/   OPC_RecordNode, // #0 = 'intrinsic_w_chain' chained node
/*  3164*/   OPC_Scope, 45, /*->3211*/ // 3 children in Scope
/*  3166*/    OPC_CheckChild1Integer, 14|128,61|128,1/*24206*/, 
/*  3170*/    OPC_RecordChild2, // #1 = $AddrOps32:offset:addr
/*  3171*/    OPC_Scope, 18, /*->3191*/ // 2 children in Scope
/*  3173*/     OPC_CheckChild2TypeI32,
/*  3174*/     OPC_RecordChild3, // #2 = $count
/*  3175*/     OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  3176*/     OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*  3178*/     OPC_EmitMergeInputChains1_0,
/*  3179*/     OPC_EmitInteger32, 0, 
/*  3181*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::MEMORY_ATOMIC_NOTIFY_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::i32, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (intrinsic_w_chain:{ *:[i32] } 12103:{ *:[iPTR] }, (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), I32:{ *:[i32] }:$count) - Complexity = 17
               // Dst: (MEMORY_ATOMIC_NOTIFY_A32:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i32] }:$count)
/*  3191*/    /*Scope*/ 18, /*->3210*/
/*  3192*/     OPC_CheckChild2TypeI64,
/*  3193*/     OPC_RecordChild3, // #2 = $count
/*  3194*/     OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  3195*/     OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*  3197*/     OPC_EmitMergeInputChains1_0,
/*  3198*/     OPC_EmitInteger32, 0, 
/*  3200*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::MEMORY_ATOMIC_NOTIFY_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::i32, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (intrinsic_w_chain:{ *:[i32] } 12103:{ *:[iPTR] }, (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), I32:{ *:[i32] }:$count) - Complexity = 17
               // Dst: (MEMORY_ATOMIC_NOTIFY_A64:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i32] }:$count)
/*  3210*/    0, /*End of Scope*/
/*  3211*/   /*Scope*/ 49, /*->3261*/
/*  3212*/    OPC_CheckChild1Integer, 16|128,61|128,1/*24208*/, 
/*  3216*/    OPC_RecordChild2, // #1 = $AddrOps32:offset:addr
/*  3217*/    OPC_Scope, 20, /*->3239*/ // 2 children in Scope
/*  3219*/     OPC_CheckChild2TypeI32,
/*  3220*/     OPC_RecordChild3, // #2 = $exp
/*  3221*/     OPC_RecordChild4, // #3 = $timeout
/*  3222*/     OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  3223*/     OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #4 #5
/*  3225*/     OPC_EmitMergeInputChains1_0,
/*  3226*/     OPC_EmitInteger32, 0, 
/*  3228*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::MEMORY_ATOMIC_WAIT32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::i32, 5/*#Ops*/, 6, 4, 5, 2, 3, 
               // Src: (intrinsic_w_chain:{ *:[i32] } 12104:{ *:[iPTR] }, (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), i32:{ *:[i32] }:$exp, I64:{ *:[i64] }:$timeout) - Complexity = 17
               // Dst: (MEMORY_ATOMIC_WAIT32_A32:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i32] }:$exp, ?:{ *:[i64] }:$timeout)
/*  3239*/    /*Scope*/ 20, /*->3260*/
/*  3240*/     OPC_CheckChild2TypeI64,
/*  3241*/     OPC_RecordChild3, // #2 = $exp
/*  3242*/     OPC_RecordChild4, // #3 = $timeout
/*  3243*/     OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  3244*/     OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #4 #5
/*  3246*/     OPC_EmitMergeInputChains1_0,
/*  3247*/     OPC_EmitInteger32, 0, 
/*  3249*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::MEMORY_ATOMIC_WAIT32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::i32, 5/*#Ops*/, 6, 4, 5, 2, 3, 
               // Src: (intrinsic_w_chain:{ *:[i32] } 12104:{ *:[iPTR] }, (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), i32:{ *:[i32] }:$exp, I64:{ *:[i64] }:$timeout) - Complexity = 17
               // Dst: (MEMORY_ATOMIC_WAIT32_A64:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i32] }:$exp, ?:{ *:[i64] }:$timeout)
/*  3260*/    0, /*End of Scope*/
/*  3261*/   /*Scope*/ 49, /*->3311*/
/*  3262*/    OPC_CheckChild1Integer, 18|128,61|128,1/*24210*/, 
/*  3266*/    OPC_RecordChild2, // #1 = $AddrOps32:offset:addr
/*  3267*/    OPC_Scope, 20, /*->3289*/ // 2 children in Scope
/*  3269*/     OPC_CheckChild2TypeI32,
/*  3270*/     OPC_RecordChild3, // #2 = $exp
/*  3271*/     OPC_RecordChild4, // #3 = $timeout
/*  3272*/     OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  3273*/     OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #4 #5
/*  3275*/     OPC_EmitMergeInputChains1_0,
/*  3276*/     OPC_EmitInteger32, 0, 
/*  3278*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::MEMORY_ATOMIC_WAIT64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::i32, 5/*#Ops*/, 6, 4, 5, 2, 3, 
               // Src: (intrinsic_w_chain:{ *:[i32] } 12105:{ *:[iPTR] }, (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), i64:{ *:[i64] }:$exp, I64:{ *:[i64] }:$timeout) - Complexity = 17
               // Dst: (MEMORY_ATOMIC_WAIT64_A32:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i64] }:$exp, ?:{ *:[i64] }:$timeout)
/*  3289*/    /*Scope*/ 20, /*->3310*/
/*  3290*/     OPC_CheckChild2TypeI64,
/*  3291*/     OPC_RecordChild3, // #2 = $exp
/*  3292*/     OPC_RecordChild4, // #3 = $timeout
/*  3293*/     OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  3294*/     OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #4 #5
/*  3296*/     OPC_EmitMergeInputChains1_0,
/*  3297*/     OPC_EmitInteger32, 0, 
/*  3299*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::MEMORY_ATOMIC_WAIT64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::i32, 5/*#Ops*/, 6, 4, 5, 2, 3, 
               // Src: (intrinsic_w_chain:{ *:[i32] } 12105:{ *:[iPTR] }, (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), i64:{ *:[i64] }:$exp, I64:{ *:[i64] }:$timeout) - Complexity = 17
               // Dst: (MEMORY_ATOMIC_WAIT64_A64:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i64] }:$exp, ?:{ *:[i64] }:$timeout)
/*  3310*/    0, /*End of Scope*/
/*  3311*/   0, /*End of Scope*/
/*  3312*/  /*Scope*/ 78|128,1/*206*/, /*->3520*/
/*  3314*/   OPC_RecordNode, // #0 = 'intrinsic_w_chain' chained node
/*  3315*/   OPC_Scope, 25, /*->3342*/ // 7 children in Scope
/*  3317*/    OPC_CheckChild1Integer, 88|128,61|128,1/*24280*/, 
/*  3321*/    OPC_MoveChild2,
/*  3322*/    OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/*  3325*/    OPC_RecordChild0, // #1 = $table
/*  3326*/    OPC_MoveChild0,
/*  3327*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetGlobalAddress),
/*  3330*/    OPC_MoveParent,
/*  3331*/    OPC_MoveParent,
/*  3332*/    OPC_RecordChild3, // #2 = $i
/*  3333*/    OPC_CheckPatternPredicate5, // (Subtarget->hasReferenceTypes())
/*  3334*/    OPC_EmitMergeInputChains1_0,
/*  3335*/    OPC_MorphNodeTo1Chain, TARGET_VAL(WebAssembly::TABLE_GET_FUNCREF),
                  MVT::funcref, 2/*#Ops*/, 1, 2, 
              // Src: (intrinsic_w_chain:{ *:[funcref] } 12140:{ *:[iPTR] }, (WebAssemblyWrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$table), I32:{ *:[i32] }:$i) - Complexity = 14
              // Dst: (TABLE_GET_FUNCREF:{ *:[funcref] } (tglobaladdr:{ *:[i32] }):$table, I32:{ *:[i32] }:$i)
/*  3342*/   /*Scope*/ 27, /*->3370*/
/*  3343*/    OPC_CheckChild1Integer, 92|128,61|128,1/*24284*/, 
/*  3347*/    OPC_MoveChild2,
/*  3348*/    OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/*  3351*/    OPC_RecordChild0, // #1 = $table
/*  3352*/    OPC_MoveChild0,
/*  3353*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetGlobalAddress),
/*  3356*/    OPC_MoveParent,
/*  3357*/    OPC_MoveParent,
/*  3358*/    OPC_RecordChild3, // #2 = $val
/*  3359*/    OPC_RecordChild4, // #3 = $n
/*  3360*/    OPC_CheckPatternPredicate5, // (Subtarget->hasReferenceTypes())
/*  3361*/    OPC_EmitMergeInputChains1_0,
/*  3362*/    OPC_MorphNodeTo1Chain, TARGET_VAL(WebAssembly::TABLE_GROW_FUNCREF),
                  MVT::i32, 3/*#Ops*/, 1, 2, 3, 
              // Src: (intrinsic_w_chain:{ *:[i32] } 12142:{ *:[iPTR] }, (WebAssemblyWrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$table), FUNCREF:{ *:[funcref] }:$val, I32:{ *:[i32] }:$n) - Complexity = 14
              // Dst: (TABLE_GROW_FUNCREF:{ *:[i32] } (tglobaladdr:{ *:[i32] }):$table, FUNCREF:{ *:[funcref] }:$val, I32:{ *:[i32] }:$n)
/*  3370*/   /*Scope*/ 25, /*->3396*/
/*  3371*/    OPC_CheckChild1Integer, 86|128,61|128,1/*24278*/, 
/*  3375*/    OPC_MoveChild2,
/*  3376*/    OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/*  3379*/    OPC_RecordChild0, // #1 = $table
/*  3380*/    OPC_MoveChild0,
/*  3381*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetGlobalAddress),
/*  3384*/    OPC_MoveParent,
/*  3385*/    OPC_MoveParent,
/*  3386*/    OPC_RecordChild3, // #2 = $i
/*  3387*/    OPC_CheckPatternPredicate5, // (Subtarget->hasReferenceTypes())
/*  3388*/    OPC_EmitMergeInputChains1_0,
/*  3389*/    OPC_MorphNodeTo1Chain, TARGET_VAL(WebAssembly::TABLE_GET_EXTERNREF),
                  MVT::externref, 2/*#Ops*/, 1, 2, 
              // Src: (intrinsic_w_chain:{ *:[externref] } 12139:{ *:[iPTR] }, (WebAssemblyWrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$table), I32:{ *:[i32] }:$i) - Complexity = 14
              // Dst: (TABLE_GET_EXTERNREF:{ *:[externref] } (tglobaladdr:{ *:[i32] }):$table, I32:{ *:[i32] }:$i)
/*  3396*/   /*Scope*/ 27, /*->3424*/
/*  3397*/    OPC_CheckChild1Integer, 90|128,61|128,1/*24282*/, 
/*  3401*/    OPC_MoveChild2,
/*  3402*/    OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/*  3405*/    OPC_RecordChild0, // #1 = $table
/*  3406*/    OPC_MoveChild0,
/*  3407*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetGlobalAddress),
/*  3410*/    OPC_MoveParent,
/*  3411*/    OPC_MoveParent,
/*  3412*/    OPC_RecordChild3, // #2 = $val
/*  3413*/    OPC_RecordChild4, // #3 = $n
/*  3414*/    OPC_CheckPatternPredicate5, // (Subtarget->hasReferenceTypes())
/*  3415*/    OPC_EmitMergeInputChains1_0,
/*  3416*/    OPC_MorphNodeTo1Chain, TARGET_VAL(WebAssembly::TABLE_GROW_EXTERNREF),
                  MVT::i32, 3/*#Ops*/, 1, 2, 3, 
              // Src: (intrinsic_w_chain:{ *:[i32] } 12141:{ *:[iPTR] }, (WebAssemblyWrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$table), EXTERNREF:{ *:[externref] }:$val, I32:{ *:[i32] }:$n) - Complexity = 14
              // Dst: (TABLE_GROW_EXTERNREF:{ *:[i32] } (tglobaladdr:{ *:[i32] }):$table, EXTERNREF:{ *:[externref] }:$val, I32:{ *:[i32] }:$n)
/*  3424*/   /*Scope*/ 23, /*->3448*/
/*  3425*/    OPC_CheckChild1Integer, 98|128,61|128,1/*24290*/, 
/*  3429*/    OPC_MoveChild2,
/*  3430*/    OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/*  3433*/    OPC_RecordChild0, // #1 = $table
/*  3434*/    OPC_MoveChild0,
/*  3435*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetGlobalAddress),
/*  3438*/    OPC_MoveParent,
/*  3439*/    OPC_MoveParent,
/*  3440*/    OPC_CheckPatternPredicate5, // (Subtarget->hasReferenceTypes())
/*  3441*/    OPC_EmitMergeInputChains1_0,
/*  3442*/    OPC_MorphNodeTo1Chain, TARGET_VAL(WebAssembly::TABLE_SIZE),
                  MVT::i32, 1/*#Ops*/, 1, 
              // Src: (intrinsic_w_chain:{ *:[i32] } 12145:{ *:[iPTR] }, (WebAssemblyWrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$table)) - Complexity = 14
              // Dst: (TABLE_SIZE:{ *:[i32] } (tglobaladdr:{ *:[i32] }):$table)
/*  3448*/   /*Scope*/ 32, /*->3481*/
/*  3449*/    OPC_CheckChild1Integer, 22|128,61|128,1/*24214*/, 
/*  3453*/    OPC_RecordChild2, // #1 = $flags
/*  3454*/    OPC_MoveChild2,
/*  3455*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/*  3458*/    OPC_MoveParent,
/*  3459*/    OPC_SwitchType /*2 cases */, 8, MVT::i32,// ->3470
/*  3462*/     OPC_EmitMergeInputChains1_0,
/*  3463*/     OPC_EmitConvertToTarget1,
/*  3464*/     OPC_MorphNodeTo1Chain, TARGET_VAL(WebAssembly::anonymous_7352MEMORY_SIZE_A32),
                   MVT::i32, 1/*#Ops*/, 2, 
               // Src: (intrinsic_w_chain:{ *:[i32] } 12107:{ *:[iPTR] }, (imm:{ *:[i32] }):$flags) - Complexity = 11
               // Dst: (anonymous_7352MEMORY_SIZE_A32:{ *:[i32] } (imm:{ *:[i32] }):$flags)
/*  3470*/    /*SwitchType*/ 8, MVT::i64,// ->3480
/*  3472*/     OPC_EmitMergeInputChains1_0,
/*  3473*/     OPC_EmitConvertToTarget1,
/*  3474*/     OPC_MorphNodeTo1Chain, TARGET_VAL(WebAssembly::anonymous_7353MEMORY_SIZE_A64),
                   MVT::i64, 1/*#Ops*/, 2, 
               // Src: (intrinsic_w_chain:{ *:[i64] } 12107:{ *:[iPTR] }, (imm:{ *:[i32] }):$flags) - Complexity = 11
               // Dst: (anonymous_7353MEMORY_SIZE_A64:{ *:[i64] } (imm:{ *:[i32] }):$flags)
/*  3480*/    0, // EndSwitchType
/*  3481*/   /*Scope*/ 37, /*->3519*/
/*  3482*/    OPC_CheckChild1Integer, 20|128,61|128,1/*24212*/, 
/*  3486*/    OPC_RecordChild2, // #1 = $flags
/*  3487*/    OPC_MoveChild2,
/*  3488*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/*  3491*/    OPC_MoveParent,
/*  3492*/    OPC_RecordChild3, // #2 = $delta
/*  3493*/    OPC_SwitchType /*2 cases */, 10, MVT::i32,// ->3506
/*  3496*/     OPC_CheckChild3TypeI32,
/*  3497*/     OPC_EmitMergeInputChains1_0,
/*  3498*/     OPC_EmitConvertToTarget1,
/*  3499*/     OPC_MorphNodeTo1Chain, TARGET_VAL(WebAssembly::anonymous_7352MEMORY_GROW_A32),
                   MVT::i32, 2/*#Ops*/, 3, 2, 
               // Src: (intrinsic_w_chain:{ *:[i32] } 12106:{ *:[iPTR] }, (imm:{ *:[i32] }):$flags, I32:{ *:[i32] }:$delta) - Complexity = 11
               // Dst: (anonymous_7352MEMORY_GROW_A32:{ *:[i32] } (imm:{ *:[i32] }):$flags, I32:{ *:[i32] }:$delta)
/*  3506*/    /*SwitchType*/ 10, MVT::i64,// ->3518
/*  3508*/     OPC_CheckChild3TypeI64,
/*  3509*/     OPC_EmitMergeInputChains1_0,
/*  3510*/     OPC_EmitConvertToTarget1,
/*  3511*/     OPC_MorphNodeTo1Chain, TARGET_VAL(WebAssembly::anonymous_7353MEMORY_GROW_A64),
                   MVT::i64, 2/*#Ops*/, 3, 2, 
               // Src: (intrinsic_w_chain:{ *:[i64] } 12106:{ *:[iPTR] }, (imm:{ *:[i32] }):$flags, I64:{ *:[i64] }:$delta) - Complexity = 11
               // Dst: (anonymous_7353MEMORY_GROW_A64:{ *:[i64] } (imm:{ *:[i32] }):$flags, I64:{ *:[i64] }:$delta)
/*  3518*/    0, // EndSwitchType
/*  3519*/   0, /*End of Scope*/
/*  3520*/  0, /*End of Scope*/
/*  3521*/ /*SwitchOpcode*/ 29|128,2/*285*/, TARGET_VAL(ISD::ATOMIC_STORE),// ->3810
/*  3525*/  OPC_RecordMemRef,
/*  3526*/  OPC_RecordNode, // #0 = 'atomic_store' chained node
/*  3527*/  OPC_Scope, 119, /*->3648*/ // 2 children in Scope
/*  3529*/   OPC_MoveChild1,
/*  3530*/   OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/*  3533*/   OPC_RecordChild0, // #1 = $val
/*  3534*/   OPC_MoveParent,
/*  3535*/   OPC_RecordChild2, // #2 = $AddrOps32:offset:addr
/*  3536*/   OPC_Scope, 54, /*->3592*/ // 2 children in Scope
/*  3538*/    OPC_CheckChild2TypeI32,
/*  3539*/    OPC_Scope, 16, /*->3557*/ // 3 children in Scope
/*  3541*/     OPC_CheckPredicate1,  // Predicate_atomic_store_8
/*  3542*/     OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  3543*/     OPC_CheckComplexPat0, /*#*/2, // SelectAddrOperands32:$ #3 #4
/*  3545*/     OPC_EmitMergeInputChains1_0,
/*  3546*/     OPC_EmitInteger32, 0, 
/*  3548*/     OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::ATOMIC_STORE8_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   4/*#Ops*/, 5, 3, 4, 1, 
               // Src: (atomic_store (trunc:{ *:[i32] } i64:{ *:[i64] }:$val), (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_atomic_store_8>> - Complexity = 16
               // Dst: (ATOMIC_STORE8_I64_A32 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i64] }:$val)
/*  3557*/    /*Scope*/ 16, /*->3574*/
/*  3558*/     OPC_CheckPredicate2,  // Predicate_atomic_store_16
/*  3559*/     OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  3560*/     OPC_CheckComplexPat0, /*#*/2, // SelectAddrOperands32:$ #3 #4
/*  3562*/     OPC_EmitMergeInputChains1_0,
/*  3563*/     OPC_EmitInteger32, 0, 
/*  3565*/     OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::ATOMIC_STORE16_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   4/*#Ops*/, 5, 3, 4, 1, 
               // Src: (atomic_store (trunc:{ *:[i32] } i64:{ *:[i64] }:$val), (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_atomic_store_16>> - Complexity = 16
               // Dst: (ATOMIC_STORE16_I64_A32 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i64] }:$val)
/*  3574*/    /*Scope*/ 16, /*->3591*/
/*  3575*/     OPC_CheckPredicate3,  // Predicate_atomic_store_32
/*  3576*/     OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  3577*/     OPC_CheckComplexPat0, /*#*/2, // SelectAddrOperands32:$ #3 #4
/*  3579*/     OPC_EmitMergeInputChains1_0,
/*  3580*/     OPC_EmitInteger32, 0, 
/*  3582*/     OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::ATOMIC_STORE32_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   4/*#Ops*/, 5, 3, 4, 1, 
               // Src: (atomic_store (trunc:{ *:[i32] } i64:{ *:[i64] }:$val), (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_atomic_store_32>> - Complexity = 16
               // Dst: (ATOMIC_STORE32_I64_A32 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i64] }:$val)
/*  3591*/    0, /*End of Scope*/
/*  3592*/   /*Scope*/ 54, /*->3647*/
/*  3593*/    OPC_CheckChild2TypeI64,
/*  3594*/    OPC_Scope, 16, /*->3612*/ // 3 children in Scope
/*  3596*/     OPC_CheckPredicate1,  // Predicate_atomic_store_8
/*  3597*/     OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  3598*/     OPC_CheckComplexPat1, /*#*/2, // SelectAddrOperands64:$ #3 #4
/*  3600*/     OPC_EmitMergeInputChains1_0,
/*  3601*/     OPC_EmitInteger32, 0, 
/*  3603*/     OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::ATOMIC_STORE8_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   4/*#Ops*/, 5, 3, 4, 1, 
               // Src: (atomic_store (trunc:{ *:[i32] } i64:{ *:[i64] }:$val), (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_atomic_store_8>> - Complexity = 16
               // Dst: (ATOMIC_STORE8_I64_A64 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i64] }:$val)
/*  3612*/    /*Scope*/ 16, /*->3629*/
/*  3613*/     OPC_CheckPredicate2,  // Predicate_atomic_store_16
/*  3614*/     OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  3615*/     OPC_CheckComplexPat1, /*#*/2, // SelectAddrOperands64:$ #3 #4
/*  3617*/     OPC_EmitMergeInputChains1_0,
/*  3618*/     OPC_EmitInteger32, 0, 
/*  3620*/     OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::ATOMIC_STORE16_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   4/*#Ops*/, 5, 3, 4, 1, 
               // Src: (atomic_store (trunc:{ *:[i32] } i64:{ *:[i64] }:$val), (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_atomic_store_16>> - Complexity = 16
               // Dst: (ATOMIC_STORE16_I64_A64 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i64] }:$val)
/*  3629*/    /*Scope*/ 16, /*->3646*/
/*  3630*/     OPC_CheckPredicate3,  // Predicate_atomic_store_32
/*  3631*/     OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  3632*/     OPC_CheckComplexPat1, /*#*/2, // SelectAddrOperands64:$ #3 #4
/*  3634*/     OPC_EmitMergeInputChains1_0,
/*  3635*/     OPC_EmitInteger32, 0, 
/*  3637*/     OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::ATOMIC_STORE32_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   4/*#Ops*/, 5, 3, 4, 1, 
               // Src: (atomic_store (trunc:{ *:[i32] } i64:{ *:[i64] }:$val), (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_atomic_store_32>> - Complexity = 16
               // Dst: (ATOMIC_STORE32_I64_A64 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i64] }:$val)
/*  3646*/    0, /*End of Scope*/
/*  3647*/   0, /*End of Scope*/
/*  3648*/  /*Scope*/ 31|128,1/*159*/, /*->3809*/
/*  3650*/   OPC_RecordChild1, // #1 = $val
/*  3651*/   OPC_Scope, 114, /*->3767*/ // 2 children in Scope
/*  3653*/    OPC_CheckChild1TypeI32,
/*  3654*/    OPC_RecordChild2, // #2 = $AddrOps32:offset:addr
/*  3655*/    OPC_Scope, 54, /*->3711*/ // 2 children in Scope
/*  3657*/     OPC_CheckChild2TypeI32,
/*  3658*/     OPC_Scope, 16, /*->3676*/ // 3 children in Scope
/*  3660*/      OPC_CheckPredicate3,  // Predicate_atomic_store_32
/*  3661*/      OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  3662*/      OPC_CheckComplexPat0, /*#*/2, // SelectAddrOperands32:$ #3 #4
/*  3664*/      OPC_EmitMergeInputChains1_0,
/*  3665*/      OPC_EmitInteger32, 0, 
/*  3667*/      OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::ATOMIC_STORE_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    4/*#Ops*/, 5, 3, 4, 1, 
                // Src: (atomic_store i32:{ *:[i32] }:$val, (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_atomic_store_32>> - Complexity = 13
                // Dst: (ATOMIC_STORE_I32_A32 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i32] }:$val)
/*  3676*/     /*Scope*/ 16, /*->3693*/
/*  3677*/      OPC_CheckPredicate1,  // Predicate_atomic_store_8
/*  3678*/      OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  3679*/      OPC_CheckComplexPat0, /*#*/2, // SelectAddrOperands32:$ #3 #4
/*  3681*/      OPC_EmitMergeInputChains1_0,
/*  3682*/      OPC_EmitInteger32, 0, 
/*  3684*/      OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::ATOMIC_STORE8_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    4/*#Ops*/, 5, 3, 4, 1, 
                // Src: (atomic_store i32:{ *:[i32] }:$val, (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_atomic_store_8>> - Complexity = 13
                // Dst: (ATOMIC_STORE8_I32_A32 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i32] }:$val)
/*  3693*/     /*Scope*/ 16, /*->3710*/
/*  3694*/      OPC_CheckPredicate2,  // Predicate_atomic_store_16
/*  3695*/      OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  3696*/      OPC_CheckComplexPat0, /*#*/2, // SelectAddrOperands32:$ #3 #4
/*  3698*/      OPC_EmitMergeInputChains1_0,
/*  3699*/      OPC_EmitInteger32, 0, 
/*  3701*/      OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::ATOMIC_STORE16_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    4/*#Ops*/, 5, 3, 4, 1, 
                // Src: (atomic_store i32:{ *:[i32] }:$val, (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_atomic_store_16>> - Complexity = 13
                // Dst: (ATOMIC_STORE16_I32_A32 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i32] }:$val)
/*  3710*/     0, /*End of Scope*/
/*  3711*/    /*Scope*/ 54, /*->3766*/
/*  3712*/     OPC_CheckChild2TypeI64,
/*  3713*/     OPC_Scope, 16, /*->3731*/ // 3 children in Scope
/*  3715*/      OPC_CheckPredicate3,  // Predicate_atomic_store_32
/*  3716*/      OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  3717*/      OPC_CheckComplexPat1, /*#*/2, // SelectAddrOperands64:$ #3 #4
/*  3719*/      OPC_EmitMergeInputChains1_0,
/*  3720*/      OPC_EmitInteger32, 0, 
/*  3722*/      OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::ATOMIC_STORE_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    4/*#Ops*/, 5, 3, 4, 1, 
                // Src: (atomic_store i32:{ *:[i32] }:$val, (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_atomic_store_32>> - Complexity = 13
                // Dst: (ATOMIC_STORE_I32_A64 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i32] }:$val)
/*  3731*/     /*Scope*/ 16, /*->3748*/
/*  3732*/      OPC_CheckPredicate1,  // Predicate_atomic_store_8
/*  3733*/      OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  3734*/      OPC_CheckComplexPat1, /*#*/2, // SelectAddrOperands64:$ #3 #4
/*  3736*/      OPC_EmitMergeInputChains1_0,
/*  3737*/      OPC_EmitInteger32, 0, 
/*  3739*/      OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::ATOMIC_STORE8_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    4/*#Ops*/, 5, 3, 4, 1, 
                // Src: (atomic_store i32:{ *:[i32] }:$val, (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_atomic_store_8>> - Complexity = 13
                // Dst: (ATOMIC_STORE8_I32_A64 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i32] }:$val)
/*  3748*/     /*Scope*/ 16, /*->3765*/
/*  3749*/      OPC_CheckPredicate2,  // Predicate_atomic_store_16
/*  3750*/      OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  3751*/      OPC_CheckComplexPat1, /*#*/2, // SelectAddrOperands64:$ #3 #4
/*  3753*/      OPC_EmitMergeInputChains1_0,
/*  3754*/      OPC_EmitInteger32, 0, 
/*  3756*/      OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::ATOMIC_STORE16_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    4/*#Ops*/, 5, 3, 4, 1, 
                // Src: (atomic_store i32:{ *:[i32] }:$val, (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_atomic_store_16>> - Complexity = 13
                // Dst: (ATOMIC_STORE16_I32_A64 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i32] }:$val)
/*  3765*/     0, /*End of Scope*/
/*  3766*/    0, /*End of Scope*/
/*  3767*/   /*Scope*/ 40, /*->3808*/
/*  3768*/    OPC_CheckChild1TypeI64,
/*  3769*/    OPC_RecordChild2, // #2 = $AddrOps32:offset:addr
/*  3770*/    OPC_Scope, 17, /*->3789*/ // 2 children in Scope
/*  3772*/     OPC_CheckChild2TypeI32,
/*  3773*/     OPC_CheckPredicate6,  // Predicate_atomic_store_64
/*  3774*/     OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  3775*/     OPC_CheckComplexPat0, /*#*/2, // SelectAddrOperands32:$ #3 #4
/*  3777*/     OPC_EmitMergeInputChains1_0,
/*  3778*/     OPC_EmitInteger32, 0, 
/*  3780*/     OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::ATOMIC_STORE_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   4/*#Ops*/, 5, 3, 4, 1, 
               // Src: (atomic_store i64:{ *:[i64] }:$val, (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_atomic_store_64>> - Complexity = 13
               // Dst: (ATOMIC_STORE_I64_A32 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i64] }:$val)
/*  3789*/    /*Scope*/ 17, /*->3807*/
/*  3790*/     OPC_CheckChild2TypeI64,
/*  3791*/     OPC_CheckPredicate6,  // Predicate_atomic_store_64
/*  3792*/     OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  3793*/     OPC_CheckComplexPat1, /*#*/2, // SelectAddrOperands64:$ #3 #4
/*  3795*/     OPC_EmitMergeInputChains1_0,
/*  3796*/     OPC_EmitInteger32, 0, 
/*  3798*/     OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::ATOMIC_STORE_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   4/*#Ops*/, 5, 3, 4, 1, 
               // Src: (atomic_store i64:{ *:[i64] }:$val, (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_atomic_store_64>> - Complexity = 13
               // Dst: (ATOMIC_STORE_I64_A64 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i64] }:$val)
/*  3807*/    0, /*End of Scope*/
/*  3808*/   0, /*End of Scope*/
/*  3809*/  0, /*End of Scope*/
/*  3810*/ /*SwitchOpcode*/ 90|128,2/*346*/, TARGET_VAL(ISD::AND),// ->4160
/*  3814*/  OPC_Scope, 118, /*->3934*/ // 6 children in Scope
/*  3816*/   OPC_MoveChild0,
/*  3817*/   OPC_CheckOpcode, TARGET_VAL(ISD::INTRINSIC_WO_CHAIN),
/*  3820*/   OPC_Scope, 55, /*->3877*/ // 2 children in Scope
/*  3822*/    OPC_CheckChild0Integer, 118|128,60|128,1/*24182*/, 
/*  3826*/    OPC_RecordChild1, // #0 = $x
/*  3827*/    OPC_Scope, 11, /*->3840*/ // 4 children in Scope
/*  3829*/     OPC_CheckChild1Type, MVT::v16i8,
/*  3831*/     OPC_MoveParent,
/*  3832*/     OPC_CheckChild1Integer, 2, 
/*  3834*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ANYTRUE),
                   MVT::i32, 1/*#Ops*/, 0, 
               // Src: (and:{ *:[i32] } (intrinsic_wo_chain:{ *:[i32] } 12091:{ *:[iPTR] }, V128:{ *:[v16i8] }:$x), 1:{ *:[i32] }) - Complexity = 16
               // Dst: (ANYTRUE:{ *:[i32] } ?:{ *:[v16i8] }:$x)
/*  3840*/    /*Scope*/ 11, /*->3852*/
/*  3841*/     OPC_CheckChild1Type, MVT::v8i16,
/*  3843*/     OPC_MoveParent,
/*  3844*/     OPC_CheckChild1Integer, 2, 
/*  3846*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ANYTRUE),
                   MVT::i32, 1/*#Ops*/, 0, 
               // Src: (and:{ *:[i32] } (intrinsic_wo_chain:{ *:[i32] } 12091:{ *:[iPTR] }, V128:{ *:[v8i16] }:$x), 1:{ *:[i32] }) - Complexity = 16
               // Dst: (ANYTRUE:{ *:[i32] } ?:{ *:[v8i16] }:$x)
/*  3852*/    /*Scope*/ 11, /*->3864*/
/*  3853*/     OPC_CheckChild1Type, MVT::v4i32,
/*  3855*/     OPC_MoveParent,
/*  3856*/     OPC_CheckChild1Integer, 2, 
/*  3858*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ANYTRUE),
                   MVT::i32, 1/*#Ops*/, 0, 
               // Src: (and:{ *:[i32] } (intrinsic_wo_chain:{ *:[i32] } 12091:{ *:[iPTR] }, V128:{ *:[v4i32] }:$x), 1:{ *:[i32] }) - Complexity = 16
               // Dst: (ANYTRUE:{ *:[i32] } ?:{ *:[v4i32] }:$x)
/*  3864*/    /*Scope*/ 11, /*->3876*/
/*  3865*/     OPC_CheckChild1Type, MVT::v2i64,
/*  3867*/     OPC_MoveParent,
/*  3868*/     OPC_CheckChild1Integer, 2, 
/*  3870*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ANYTRUE),
                   MVT::i32, 1/*#Ops*/, 0, 
               // Src: (and:{ *:[i32] } (intrinsic_wo_chain:{ *:[i32] } 12091:{ *:[iPTR] }, V128:{ *:[v2i64] }:$x), 1:{ *:[i32] }) - Complexity = 16
               // Dst: (ANYTRUE:{ *:[i32] } ?:{ *:[v2i64] }:$x)
/*  3876*/    0, /*End of Scope*/
/*  3877*/   /*Scope*/ 55, /*->3933*/
/*  3878*/    OPC_CheckChild0Integer, 116|128,60|128,1/*24180*/, 
/*  3882*/    OPC_RecordChild1, // #0 = $x
/*  3883*/    OPC_Scope, 11, /*->3896*/ // 4 children in Scope
/*  3885*/     OPC_CheckChild1Type, MVT::v16i8,
/*  3887*/     OPC_MoveParent,
/*  3888*/     OPC_CheckChild1Integer, 2, 
/*  3890*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ALLTRUE_I8x16),
                   MVT::i32, 1/*#Ops*/, 0, 
               // Src: (and:{ *:[i32] } (intrinsic_wo_chain:{ *:[i32] } 12090:{ *:[iPTR] }, V128:{ *:[v16i8] }:$x), 1:{ *:[i32] }) - Complexity = 16
               // Dst: (ALLTRUE_I8x16:{ *:[i32] } ?:{ *:[v16i8] }:$x)
/*  3896*/    /*Scope*/ 11, /*->3908*/
/*  3897*/     OPC_CheckChild1Type, MVT::v8i16,
/*  3899*/     OPC_MoveParent,
/*  3900*/     OPC_CheckChild1Integer, 2, 
/*  3902*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ALLTRUE_I16x8),
                   MVT::i32, 1/*#Ops*/, 0, 
               // Src: (and:{ *:[i32] } (intrinsic_wo_chain:{ *:[i32] } 12090:{ *:[iPTR] }, V128:{ *:[v8i16] }:$x), 1:{ *:[i32] }) - Complexity = 16
               // Dst: (ALLTRUE_I16x8:{ *:[i32] } ?:{ *:[v8i16] }:$x)
/*  3908*/    /*Scope*/ 11, /*->3920*/
/*  3909*/     OPC_CheckChild1Type, MVT::v4i32,
/*  3911*/     OPC_MoveParent,
/*  3912*/     OPC_CheckChild1Integer, 2, 
/*  3914*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ALLTRUE_I32x4),
                   MVT::i32, 1/*#Ops*/, 0, 
               // Src: (and:{ *:[i32] } (intrinsic_wo_chain:{ *:[i32] } 12090:{ *:[iPTR] }, V128:{ *:[v4i32] }:$x), 1:{ *:[i32] }) - Complexity = 16
               // Dst: (ALLTRUE_I32x4:{ *:[i32] } ?:{ *:[v4i32] }:$x)
/*  3920*/    /*Scope*/ 11, /*->3932*/
/*  3921*/     OPC_CheckChild1Type, MVT::v2i64,
/*  3923*/     OPC_MoveParent,
/*  3924*/     OPC_CheckChild1Integer, 2, 
/*  3926*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ALLTRUE_I64x2),
                   MVT::i32, 1/*#Ops*/, 0, 
               // Src: (and:{ *:[i32] } (intrinsic_wo_chain:{ *:[i32] } 12090:{ *:[iPTR] }, V128:{ *:[v2i64] }:$x), 1:{ *:[i32] }) - Complexity = 16
               // Dst: (ALLTRUE_I64x2:{ *:[i32] } ?:{ *:[v2i64] }:$x)
/*  3932*/    0, /*End of Scope*/
/*  3933*/   0, /*End of Scope*/
/*  3934*/  /*Scope*/ 29, /*->3964*/
/*  3935*/   OPC_CheckAndImm, 127|128,1/*255*/, 
/*  3938*/   OPC_MoveChild0,
/*  3939*/   OPC_CheckOpcode, TARGET_VAL(ISD::EXTRACT_VECTOR_ELT),
/*  3942*/   OPC_RecordChild0, // #0 = $vec
/*  3943*/   OPC_CheckChild0Type, MVT::v16i8,
/*  3945*/   OPC_RecordChild1, // #1 = $idx
/*  3946*/   OPC_MoveChild1,
/*  3947*/   OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/*  3950*/   OPC_CheckPredicate, 15, // Predicate_LaneIdx16
/*  3952*/   OPC_CheckTypeI32,
/*  3953*/   OPC_MoveParent,
/*  3954*/   OPC_MoveParent,
/*  3955*/   OPC_CheckTypeI32,
/*  3956*/   OPC_EmitConvertToTarget1,
/*  3957*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::EXTRACT_LANE_I8x16_u),
                 MVT::i32, 2/*#Ops*/, 0, 2, 
             // Src: (and:{ *:[i32] } (vector_extract:{ *:[i32] } V128:{ *:[v16i8] }:$vec, (imm:{ *:[i32] })<<P:Predicate_LaneIdx16>>:$idx), 255:{ *:[i32] }) - Complexity = 15
             // Dst: (EXTRACT_LANE_I8x16_u:{ *:[i32] } ?:{ *:[v16i8] }:$vec, (imm:{ *:[i32] }):$idx)
/*  3964*/  /*Scope*/ 30, /*->3995*/
/*  3965*/   OPC_CheckAndImm, 127|128,127|128,3/*65535*/, 
/*  3969*/   OPC_MoveChild0,
/*  3970*/   OPC_CheckOpcode, TARGET_VAL(ISD::EXTRACT_VECTOR_ELT),
/*  3973*/   OPC_RecordChild0, // #0 = $vec
/*  3974*/   OPC_CheckChild0Type, MVT::v8i16,
/*  3976*/   OPC_RecordChild1, // #1 = $idx
/*  3977*/   OPC_MoveChild1,
/*  3978*/   OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/*  3981*/   OPC_CheckPredicate, 16, // Predicate_LaneIdx8
/*  3983*/   OPC_CheckTypeI32,
/*  3984*/   OPC_MoveParent,
/*  3985*/   OPC_MoveParent,
/*  3986*/   OPC_CheckTypeI32,
/*  3987*/   OPC_EmitConvertToTarget1,
/*  3988*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::EXTRACT_LANE_I16x8_u),
                 MVT::i32, 2/*#Ops*/, 0, 2, 
             // Src: (and:{ *:[i32] } (vector_extract:{ *:[i32] } V128:{ *:[v8i16] }:$vec, (imm:{ *:[i32] })<<P:Predicate_LaneIdx8>>:$idx), 65535:{ *:[i32] }) - Complexity = 15
             // Dst: (EXTRACT_LANE_I16x8_u:{ *:[i32] } ?:{ *:[v8i16] }:$vec, (imm:{ *:[i32] }):$idx)
/*  3995*/  /*Scope*/ 73, /*->4069*/
/*  3996*/   OPC_RecordChild0, // #0 = $lhs
/*  3997*/   OPC_Scope, 21, /*->4020*/ // 2 children in Scope
/*  3999*/    OPC_RecordChild1, // #1 = $rhs
/*  4000*/    OPC_SwitchType /*2 cases */, 7, MVT::i32,// ->4010
/*  4003*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::AND_I32),
                   MVT::i32, 2/*#Ops*/, 0, 1, 
               // Src: (and:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs) - Complexity = 3
               // Dst: (AND_I32:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs)
/*  4010*/    /*SwitchType*/ 7, MVT::i64,// ->4019
/*  4012*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::AND_I64),
                   MVT::i64, 2/*#Ops*/, 0, 1, 
               // Src: (and:{ *:[i64] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs) - Complexity = 3
               // Dst: (AND_I64:{ *:[i64] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs)
/*  4019*/    0, // EndSwitchType
/*  4020*/   /*Scope*/ 47, /*->4068*/
/*  4021*/    OPC_MoveChild1,
/*  4022*/    OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/*  4025*/    OPC_RecordChild0, // #1 = $rhs
/*  4026*/    OPC_MoveChild1,
/*  4027*/    OPC_CheckImmAllOnesV,
/*  4028*/    OPC_MoveParent,
/*  4029*/    OPC_MoveParent,
/*  4030*/    OPC_SwitchType /*4 cases */, 7, MVT::v16i8,// ->4040
/*  4033*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ANDNOT),
                   MVT::v16i8, 2/*#Ops*/, 0, 1, 
               // Src: (and:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$rhs, immAllOnesV:{ *:[v16i8] })) - Complexity = 10
               // Dst: (ANDNOT:{ *:[v16i8] } ?:{ *:[v16i8] }:$lhs, ?:{ *:[v16i8] }:$rhs)
/*  4040*/    /*SwitchType*/ 7, MVT::v8i16,// ->4049
/*  4042*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ANDNOT),
                   MVT::v8i16, 2/*#Ops*/, 0, 1, 
               // Src: (and:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$rhs, immAllOnesV:{ *:[v8i16] })) - Complexity = 10
               // Dst: (ANDNOT:{ *:[v8i16] } ?:{ *:[v8i16] }:$lhs, ?:{ *:[v8i16] }:$rhs)
/*  4049*/    /*SwitchType*/ 7, MVT::v4i32,// ->4058
/*  4051*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ANDNOT),
                   MVT::v4i32, 2/*#Ops*/, 0, 1, 
               // Src: (and:{ *:[v4i32] } V128:{ *:[v4i32] }:$lhs, (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$rhs, immAllOnesV:{ *:[v4i32] })) - Complexity = 10
               // Dst: (ANDNOT:{ *:[v4i32] } ?:{ *:[v4i32] }:$lhs, ?:{ *:[v4i32] }:$rhs)
/*  4058*/    /*SwitchType*/ 7, MVT::v2i64,// ->4067
/*  4060*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ANDNOT),
                   MVT::v2i64, 2/*#Ops*/, 0, 1, 
               // Src: (and:{ *:[v2i64] } V128:{ *:[v2i64] }:$lhs, (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$rhs, immAllOnesV:{ *:[v2i64] })) - Complexity = 10
               // Dst: (ANDNOT:{ *:[v2i64] } ?:{ *:[v2i64] }:$lhs, ?:{ *:[v2i64] }:$rhs)
/*  4067*/    0, // EndSwitchType
/*  4068*/   0, /*End of Scope*/
/*  4069*/  /*Scope*/ 48, /*->4118*/
/*  4070*/   OPC_MoveChild0,
/*  4071*/   OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/*  4074*/   OPC_RecordChild0, // #0 = $rhs
/*  4075*/   OPC_MoveChild1,
/*  4076*/   OPC_CheckImmAllOnesV,
/*  4077*/   OPC_MoveParent,
/*  4078*/   OPC_MoveParent,
/*  4079*/   OPC_RecordChild1, // #1 = $lhs
/*  4080*/   OPC_SwitchType /*4 cases */, 7, MVT::v16i8,// ->4090
/*  4083*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ANDNOT),
                  MVT::v16i8, 2/*#Ops*/, 1, 0, 
              // Src: (and:{ *:[v16i8] } (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$rhs, immAllOnesV:{ *:[v16i8] }), V128:{ *:[v16i8] }:$lhs) - Complexity = 10
              // Dst: (ANDNOT:{ *:[v16i8] } ?:{ *:[v16i8] }:$lhs, ?:{ *:[v16i8] }:$rhs)
/*  4090*/   /*SwitchType*/ 7, MVT::v8i16,// ->4099
/*  4092*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ANDNOT),
                  MVT::v8i16, 2/*#Ops*/, 1, 0, 
              // Src: (and:{ *:[v8i16] } (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$rhs, immAllOnesV:{ *:[v8i16] }), V128:{ *:[v8i16] }:$lhs) - Complexity = 10
              // Dst: (ANDNOT:{ *:[v8i16] } ?:{ *:[v8i16] }:$lhs, ?:{ *:[v8i16] }:$rhs)
/*  4099*/   /*SwitchType*/ 7, MVT::v4i32,// ->4108
/*  4101*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ANDNOT),
                  MVT::v4i32, 2/*#Ops*/, 1, 0, 
              // Src: (and:{ *:[v4i32] } (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$rhs, immAllOnesV:{ *:[v4i32] }), V128:{ *:[v4i32] }:$lhs) - Complexity = 10
              // Dst: (ANDNOT:{ *:[v4i32] } ?:{ *:[v4i32] }:$lhs, ?:{ *:[v4i32] }:$rhs)
/*  4108*/   /*SwitchType*/ 7, MVT::v2i64,// ->4117
/*  4110*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ANDNOT),
                  MVT::v2i64, 2/*#Ops*/, 1, 0, 
              // Src: (and:{ *:[v2i64] } (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$rhs, immAllOnesV:{ *:[v2i64] }), V128:{ *:[v2i64] }:$lhs) - Complexity = 10
              // Dst: (ANDNOT:{ *:[v2i64] } ?:{ *:[v2i64] }:$lhs, ?:{ *:[v2i64] }:$rhs)
/*  4117*/   0, // EndSwitchType
/*  4118*/  /*Scope*/ 40, /*->4159*/
/*  4119*/   OPC_RecordChild0, // #0 = $lhs
/*  4120*/   OPC_RecordChild1, // #1 = $rhs
/*  4121*/   OPC_SwitchType /*4 cases */, 7, MVT::v16i8,// ->4131
/*  4124*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::AND),
                  MVT::v16i8, 2/*#Ops*/, 0, 1, 
              // Src: (and:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs) - Complexity = 3
              // Dst: (AND:{ *:[v16i8] } ?:{ *:[v16i8] }:$lhs, ?:{ *:[v16i8] }:$rhs)
/*  4131*/   /*SwitchType*/ 7, MVT::v8i16,// ->4140
/*  4133*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::AND),
                  MVT::v8i16, 2/*#Ops*/, 0, 1, 
              // Src: (and:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs) - Complexity = 3
              // Dst: (AND:{ *:[v8i16] } ?:{ *:[v8i16] }:$lhs, ?:{ *:[v8i16] }:$rhs)
/*  4140*/   /*SwitchType*/ 7, MVT::v4i32,// ->4149
/*  4142*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::AND),
                  MVT::v4i32, 2/*#Ops*/, 0, 1, 
              // Src: (and:{ *:[v4i32] } V128:{ *:[v4i32] }:$lhs, V128:{ *:[v4i32] }:$rhs) - Complexity = 3
              // Dst: (AND:{ *:[v4i32] } ?:{ *:[v4i32] }:$lhs, ?:{ *:[v4i32] }:$rhs)
/*  4149*/   /*SwitchType*/ 7, MVT::v2i64,// ->4158
/*  4151*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::AND),
                  MVT::v2i64, 2/*#Ops*/, 0, 1, 
              // Src: (and:{ *:[v2i64] } V128:{ *:[v2i64] }:$lhs, V128:{ *:[v2i64] }:$rhs) - Complexity = 3
              // Dst: (AND:{ *:[v2i64] } ?:{ *:[v2i64] }:$lhs, ?:{ *:[v2i64] }:$rhs)
/*  4158*/   0, // EndSwitchType
/*  4159*/  0, /*End of Scope*/
/*  4160*/ /*SwitchOpcode*/ 48|128,11/*1456*/, TARGET_VAL(ISD::SETCC),// ->5620
/*  4164*/  OPC_Scope, 126|128,1/*254*/, /*->4421*/ // 2 children in Scope
/*  4167*/   OPC_MoveChild0,
/*  4168*/   OPC_CheckOpcode, TARGET_VAL(ISD::INTRINSIC_WO_CHAIN),
/*  4171*/   OPC_Scope, 123, /*->4296*/ // 2 children in Scope
/*  4173*/    OPC_CheckChild0Integer, 118|128,60|128,1/*24182*/, 
/*  4177*/    OPC_RecordChild1, // #0 = $x
/*  4178*/    OPC_Scope, 28, /*->4208*/ // 4 children in Scope
/*  4180*/     OPC_CheckChild1Type, MVT::v16i8,
/*  4182*/     OPC_MoveParent,
/*  4183*/     OPC_CheckTypeI32,
/*  4184*/     OPC_Scope, 10, /*->4196*/ // 2 children in Scope
/*  4186*/      OPC_CheckChild1Integer, 0, 
/*  4188*/      OPC_CheckChild2CondCode, ISD::SETNE,
/*  4190*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ANYTRUE),
                    MVT::i32, 1/*#Ops*/, 0, 
                // Src: (setcc:{ *:[i32] } (intrinsic_wo_chain:{ *:[i32] } 12091:{ *:[iPTR] }, V128:{ *:[v16i8] }:$x), 0:{ *:[i32] }, SETNE:{ *:[Other] }) - Complexity = 16
                // Dst: (ANYTRUE:{ *:[i32] } ?:{ *:[v16i8] }:$x)
/*  4196*/     /*Scope*/ 10, /*->4207*/
/*  4197*/      OPC_CheckChild1Integer, 2, 
/*  4199*/      OPC_CheckChild2CondCode, ISD::SETEQ,
/*  4201*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ANYTRUE),
                    MVT::i32, 1/*#Ops*/, 0, 
                // Src: (setcc:{ *:[i32] } (intrinsic_wo_chain:{ *:[i32] } 12091:{ *:[iPTR] }, V128:{ *:[v16i8] }:$x), 1:{ *:[i32] }, SETEQ:{ *:[Other] }) - Complexity = 16
                // Dst: (ANYTRUE:{ *:[i32] } ?:{ *:[v16i8] }:$x)
/*  4207*/     0, /*End of Scope*/
/*  4208*/    /*Scope*/ 28, /*->4237*/
/*  4209*/     OPC_CheckChild1Type, MVT::v8i16,
/*  4211*/     OPC_MoveParent,
/*  4212*/     OPC_CheckTypeI32,
/*  4213*/     OPC_Scope, 10, /*->4225*/ // 2 children in Scope
/*  4215*/      OPC_CheckChild1Integer, 0, 
/*  4217*/      OPC_CheckChild2CondCode, ISD::SETNE,
/*  4219*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ANYTRUE),
                    MVT::i32, 1/*#Ops*/, 0, 
                // Src: (setcc:{ *:[i32] } (intrinsic_wo_chain:{ *:[i32] } 12091:{ *:[iPTR] }, V128:{ *:[v8i16] }:$x), 0:{ *:[i32] }, SETNE:{ *:[Other] }) - Complexity = 16
                // Dst: (ANYTRUE:{ *:[i32] } ?:{ *:[v8i16] }:$x)
/*  4225*/     /*Scope*/ 10, /*->4236*/
/*  4226*/      OPC_CheckChild1Integer, 2, 
/*  4228*/      OPC_CheckChild2CondCode, ISD::SETEQ,
/*  4230*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ANYTRUE),
                    MVT::i32, 1/*#Ops*/, 0, 
                // Src: (setcc:{ *:[i32] } (intrinsic_wo_chain:{ *:[i32] } 12091:{ *:[iPTR] }, V128:{ *:[v8i16] }:$x), 1:{ *:[i32] }, SETEQ:{ *:[Other] }) - Complexity = 16
                // Dst: (ANYTRUE:{ *:[i32] } ?:{ *:[v8i16] }:$x)
/*  4236*/     0, /*End of Scope*/
/*  4237*/    /*Scope*/ 28, /*->4266*/
/*  4238*/     OPC_CheckChild1Type, MVT::v4i32,
/*  4240*/     OPC_MoveParent,
/*  4241*/     OPC_CheckTypeI32,
/*  4242*/     OPC_Scope, 10, /*->4254*/ // 2 children in Scope
/*  4244*/      OPC_CheckChild1Integer, 0, 
/*  4246*/      OPC_CheckChild2CondCode, ISD::SETNE,
/*  4248*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ANYTRUE),
                    MVT::i32, 1/*#Ops*/, 0, 
                // Src: (setcc:{ *:[i32] } (intrinsic_wo_chain:{ *:[i32] } 12091:{ *:[iPTR] }, V128:{ *:[v4i32] }:$x), 0:{ *:[i32] }, SETNE:{ *:[Other] }) - Complexity = 16
                // Dst: (ANYTRUE:{ *:[i32] } ?:{ *:[v4i32] }:$x)
/*  4254*/     /*Scope*/ 10, /*->4265*/
/*  4255*/      OPC_CheckChild1Integer, 2, 
/*  4257*/      OPC_CheckChild2CondCode, ISD::SETEQ,
/*  4259*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ANYTRUE),
                    MVT::i32, 1/*#Ops*/, 0, 
                // Src: (setcc:{ *:[i32] } (intrinsic_wo_chain:{ *:[i32] } 12091:{ *:[iPTR] }, V128:{ *:[v4i32] }:$x), 1:{ *:[i32] }, SETEQ:{ *:[Other] }) - Complexity = 16
                // Dst: (ANYTRUE:{ *:[i32] } ?:{ *:[v4i32] }:$x)
/*  4265*/     0, /*End of Scope*/
/*  4266*/    /*Scope*/ 28, /*->4295*/
/*  4267*/     OPC_CheckChild1Type, MVT::v2i64,
/*  4269*/     OPC_MoveParent,
/*  4270*/     OPC_CheckTypeI32,
/*  4271*/     OPC_Scope, 10, /*->4283*/ // 2 children in Scope
/*  4273*/      OPC_CheckChild1Integer, 0, 
/*  4275*/      OPC_CheckChild2CondCode, ISD::SETNE,
/*  4277*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ANYTRUE),
                    MVT::i32, 1/*#Ops*/, 0, 
                // Src: (setcc:{ *:[i32] } (intrinsic_wo_chain:{ *:[i32] } 12091:{ *:[iPTR] }, V128:{ *:[v2i64] }:$x), 0:{ *:[i32] }, SETNE:{ *:[Other] }) - Complexity = 16
                // Dst: (ANYTRUE:{ *:[i32] } ?:{ *:[v2i64] }:$x)
/*  4283*/     /*Scope*/ 10, /*->4294*/
/*  4284*/      OPC_CheckChild1Integer, 2, 
/*  4286*/      OPC_CheckChild2CondCode, ISD::SETEQ,
/*  4288*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ANYTRUE),
                    MVT::i32, 1/*#Ops*/, 0, 
                // Src: (setcc:{ *:[i32] } (intrinsic_wo_chain:{ *:[i32] } 12091:{ *:[iPTR] }, V128:{ *:[v2i64] }:$x), 1:{ *:[i32] }, SETEQ:{ *:[Other] }) - Complexity = 16
                // Dst: (ANYTRUE:{ *:[i32] } ?:{ *:[v2i64] }:$x)
/*  4294*/     0, /*End of Scope*/
/*  4295*/    0, /*End of Scope*/
/*  4296*/   /*Scope*/ 123, /*->4420*/
/*  4297*/    OPC_CheckChild0Integer, 116|128,60|128,1/*24180*/, 
/*  4301*/    OPC_RecordChild1, // #0 = $x
/*  4302*/    OPC_Scope, 28, /*->4332*/ // 4 children in Scope
/*  4304*/     OPC_CheckChild1Type, MVT::v16i8,
/*  4306*/     OPC_MoveParent,
/*  4307*/     OPC_CheckTypeI32,
/*  4308*/     OPC_Scope, 10, /*->4320*/ // 2 children in Scope
/*  4310*/      OPC_CheckChild1Integer, 0, 
/*  4312*/      OPC_CheckChild2CondCode, ISD::SETNE,
/*  4314*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ALLTRUE_I8x16),
                    MVT::i32, 1/*#Ops*/, 0, 
                // Src: (setcc:{ *:[i32] } (intrinsic_wo_chain:{ *:[i32] } 12090:{ *:[iPTR] }, V128:{ *:[v16i8] }:$x), 0:{ *:[i32] }, SETNE:{ *:[Other] }) - Complexity = 16
                // Dst: (ALLTRUE_I8x16:{ *:[i32] } ?:{ *:[v16i8] }:$x)
/*  4320*/     /*Scope*/ 10, /*->4331*/
/*  4321*/      OPC_CheckChild1Integer, 2, 
/*  4323*/      OPC_CheckChild2CondCode, ISD::SETEQ,
/*  4325*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ALLTRUE_I8x16),
                    MVT::i32, 1/*#Ops*/, 0, 
                // Src: (setcc:{ *:[i32] } (intrinsic_wo_chain:{ *:[i32] } 12090:{ *:[iPTR] }, V128:{ *:[v16i8] }:$x), 1:{ *:[i32] }, SETEQ:{ *:[Other] }) - Complexity = 16
                // Dst: (ALLTRUE_I8x16:{ *:[i32] } ?:{ *:[v16i8] }:$x)
/*  4331*/     0, /*End of Scope*/
/*  4332*/    /*Scope*/ 28, /*->4361*/
/*  4333*/     OPC_CheckChild1Type, MVT::v8i16,
/*  4335*/     OPC_MoveParent,
/*  4336*/     OPC_CheckTypeI32,
/*  4337*/     OPC_Scope, 10, /*->4349*/ // 2 children in Scope
/*  4339*/      OPC_CheckChild1Integer, 0, 
/*  4341*/      OPC_CheckChild2CondCode, ISD::SETNE,
/*  4343*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ALLTRUE_I16x8),
                    MVT::i32, 1/*#Ops*/, 0, 
                // Src: (setcc:{ *:[i32] } (intrinsic_wo_chain:{ *:[i32] } 12090:{ *:[iPTR] }, V128:{ *:[v8i16] }:$x), 0:{ *:[i32] }, SETNE:{ *:[Other] }) - Complexity = 16
                // Dst: (ALLTRUE_I16x8:{ *:[i32] } ?:{ *:[v8i16] }:$x)
/*  4349*/     /*Scope*/ 10, /*->4360*/
/*  4350*/      OPC_CheckChild1Integer, 2, 
/*  4352*/      OPC_CheckChild2CondCode, ISD::SETEQ,
/*  4354*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ALLTRUE_I16x8),
                    MVT::i32, 1/*#Ops*/, 0, 
                // Src: (setcc:{ *:[i32] } (intrinsic_wo_chain:{ *:[i32] } 12090:{ *:[iPTR] }, V128:{ *:[v8i16] }:$x), 1:{ *:[i32] }, SETEQ:{ *:[Other] }) - Complexity = 16
                // Dst: (ALLTRUE_I16x8:{ *:[i32] } ?:{ *:[v8i16] }:$x)
/*  4360*/     0, /*End of Scope*/
/*  4361*/    /*Scope*/ 28, /*->4390*/
/*  4362*/     OPC_CheckChild1Type, MVT::v4i32,
/*  4364*/     OPC_MoveParent,
/*  4365*/     OPC_CheckTypeI32,
/*  4366*/     OPC_Scope, 10, /*->4378*/ // 2 children in Scope
/*  4368*/      OPC_CheckChild1Integer, 0, 
/*  4370*/      OPC_CheckChild2CondCode, ISD::SETNE,
/*  4372*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ALLTRUE_I32x4),
                    MVT::i32, 1/*#Ops*/, 0, 
                // Src: (setcc:{ *:[i32] } (intrinsic_wo_chain:{ *:[i32] } 12090:{ *:[iPTR] }, V128:{ *:[v4i32] }:$x), 0:{ *:[i32] }, SETNE:{ *:[Other] }) - Complexity = 16
                // Dst: (ALLTRUE_I32x4:{ *:[i32] } ?:{ *:[v4i32] }:$x)
/*  4378*/     /*Scope*/ 10, /*->4389*/
/*  4379*/      OPC_CheckChild1Integer, 2, 
/*  4381*/      OPC_CheckChild2CondCode, ISD::SETEQ,
/*  4383*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ALLTRUE_I32x4),
                    MVT::i32, 1/*#Ops*/, 0, 
                // Src: (setcc:{ *:[i32] } (intrinsic_wo_chain:{ *:[i32] } 12090:{ *:[iPTR] }, V128:{ *:[v4i32] }:$x), 1:{ *:[i32] }, SETEQ:{ *:[Other] }) - Complexity = 16
                // Dst: (ALLTRUE_I32x4:{ *:[i32] } ?:{ *:[v4i32] }:$x)
/*  4389*/     0, /*End of Scope*/
/*  4390*/    /*Scope*/ 28, /*->4419*/
/*  4391*/     OPC_CheckChild1Type, MVT::v2i64,
/*  4393*/     OPC_MoveParent,
/*  4394*/     OPC_CheckTypeI32,
/*  4395*/     OPC_Scope, 10, /*->4407*/ // 2 children in Scope
/*  4397*/      OPC_CheckChild1Integer, 0, 
/*  4399*/      OPC_CheckChild2CondCode, ISD::SETNE,
/*  4401*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ALLTRUE_I64x2),
                    MVT::i32, 1/*#Ops*/, 0, 
                // Src: (setcc:{ *:[i32] } (intrinsic_wo_chain:{ *:[i32] } 12090:{ *:[iPTR] }, V128:{ *:[v2i64] }:$x), 0:{ *:[i32] }, SETNE:{ *:[Other] }) - Complexity = 16
                // Dst: (ALLTRUE_I64x2:{ *:[i32] } ?:{ *:[v2i64] }:$x)
/*  4407*/     /*Scope*/ 10, /*->4418*/
/*  4408*/      OPC_CheckChild1Integer, 2, 
/*  4410*/      OPC_CheckChild2CondCode, ISD::SETEQ,
/*  4412*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ALLTRUE_I64x2),
                    MVT::i32, 1/*#Ops*/, 0, 
                // Src: (setcc:{ *:[i32] } (intrinsic_wo_chain:{ *:[i32] } 12090:{ *:[iPTR] }, V128:{ *:[v2i64] }:$x), 1:{ *:[i32] }, SETEQ:{ *:[Other] }) - Complexity = 16
                // Dst: (ALLTRUE_I64x2:{ *:[i32] } ?:{ *:[v2i64] }:$x)
/*  4418*/     0, /*End of Scope*/
/*  4419*/    0, /*End of Scope*/
/*  4420*/   0, /*End of Scope*/
/*  4421*/  /*Scope*/ 44|128,9/*1196*/, /*->5619*/
/*  4423*/   OPC_RecordChild0, // #0 = $src
/*  4424*/   OPC_SwitchType /*5 cases */, 108|128,3/*492*/, MVT::i32,// ->4920
/*  4428*/    OPC_Scope, 118, /*->4548*/ // 4 children in Scope
/*  4430*/     OPC_CheckChild0TypeI32,
/*  4431*/     OPC_Scope, 10, /*->4443*/ // 2 children in Scope
/*  4433*/      OPC_CheckChild1Integer, 0, 
/*  4435*/      OPC_CheckChild2CondCode, ISD::SETEQ,
/*  4437*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::EQZ_I32),
                    MVT::i32, 1/*#Ops*/, 0, 
                // Src: (setcc:{ *:[i32] } I32:{ *:[i32] }:$src, 0:{ *:[i32] }, SETEQ:{ *:[Other] }) - Complexity = 8
                // Dst: (EQZ_I32:{ *:[i32] } I32:{ *:[i32] }:$src)
/*  4443*/     /*Scope*/ 103, /*->4547*/
/*  4444*/      OPC_RecordChild1, // #1 = $rhs
/*  4445*/      OPC_Scope, 9, /*->4456*/ // 10 children in Scope
/*  4447*/       OPC_CheckChild2CondCode, ISD::SETEQ,
/*  4449*/       OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::EQ_I32),
                     MVT::i32, 2/*#Ops*/, 0, 1, 
                 // Src: (setcc:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs, SETEQ:{ *:[Other] }) - Complexity = 3
                 // Dst: (EQ_I32:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs)
/*  4456*/      /*Scope*/ 9, /*->4466*/
/*  4457*/       OPC_CheckChild2CondCode, ISD::SETNE,
/*  4459*/       OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::NE_I32),
                     MVT::i32, 2/*#Ops*/, 0, 1, 
                 // Src: (setcc:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs, SETNE:{ *:[Other] }) - Complexity = 3
                 // Dst: (NE_I32:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs)
/*  4466*/      /*Scope*/ 9, /*->4476*/
/*  4467*/       OPC_CheckChild2CondCode, ISD::SETLT,
/*  4469*/       OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::LT_S_I32),
                     MVT::i32, 2/*#Ops*/, 0, 1, 
                 // Src: (setcc:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs, SETLT:{ *:[Other] }) - Complexity = 3
                 // Dst: (LT_S_I32:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs)
/*  4476*/      /*Scope*/ 9, /*->4486*/
/*  4477*/       OPC_CheckChild2CondCode, ISD::SETULT,
/*  4479*/       OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::LT_U_I32),
                     MVT::i32, 2/*#Ops*/, 0, 1, 
                 // Src: (setcc:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs, SETULT:{ *:[Other] }) - Complexity = 3
                 // Dst: (LT_U_I32:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs)
/*  4486*/      /*Scope*/ 9, /*->4496*/
/*  4487*/       OPC_CheckChild2CondCode, ISD::SETGT,
/*  4489*/       OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::GT_S_I32),
                     MVT::i32, 2/*#Ops*/, 0, 1, 
                 // Src: (setcc:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs, SETGT:{ *:[Other] }) - Complexity = 3
                 // Dst: (GT_S_I32:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs)
/*  4496*/      /*Scope*/ 9, /*->4506*/
/*  4497*/       OPC_CheckChild2CondCode, ISD::SETUGT,
/*  4499*/       OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::GT_U_I32),
                     MVT::i32, 2/*#Ops*/, 0, 1, 
                 // Src: (setcc:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs, SETUGT:{ *:[Other] }) - Complexity = 3
                 // Dst: (GT_U_I32:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs)
/*  4506*/      /*Scope*/ 9, /*->4516*/
/*  4507*/       OPC_CheckChild2CondCode, ISD::SETLE,
/*  4509*/       OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::LE_S_I32),
                     MVT::i32, 2/*#Ops*/, 0, 1, 
                 // Src: (setcc:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs, SETLE:{ *:[Other] }) - Complexity = 3
                 // Dst: (LE_S_I32:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs)
/*  4516*/      /*Scope*/ 9, /*->4526*/
/*  4517*/       OPC_CheckChild2CondCode, ISD::SETULE,
/*  4519*/       OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::LE_U_I32),
                     MVT::i32, 2/*#Ops*/, 0, 1, 
                 // Src: (setcc:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs, SETULE:{ *:[Other] }) - Complexity = 3
                 // Dst: (LE_U_I32:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs)
/*  4526*/      /*Scope*/ 9, /*->4536*/
/*  4527*/       OPC_CheckChild2CondCode, ISD::SETGE,
/*  4529*/       OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::GE_S_I32),
                     MVT::i32, 2/*#Ops*/, 0, 1, 
                 // Src: (setcc:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs, SETGE:{ *:[Other] }) - Complexity = 3
                 // Dst: (GE_S_I32:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs)
/*  4536*/      /*Scope*/ 9, /*->4546*/
/*  4537*/       OPC_CheckChild2CondCode, ISD::SETUGE,
/*  4539*/       OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::GE_U_I32),
                     MVT::i32, 2/*#Ops*/, 0, 1, 
                 // Src: (setcc:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs, SETUGE:{ *:[Other] }) - Complexity = 3
                 // Dst: (GE_U_I32:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs)
/*  4546*/      0, /*End of Scope*/
/*  4547*/     0, /*End of Scope*/
/*  4548*/    /*Scope*/ 118, /*->4667*/
/*  4549*/     OPC_CheckChild0TypeI64,
/*  4550*/     OPC_Scope, 10, /*->4562*/ // 2 children in Scope
/*  4552*/      OPC_CheckChild1Integer, 0, 
/*  4554*/      OPC_CheckChild2CondCode, ISD::SETEQ,
/*  4556*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::EQZ_I64),
                    MVT::i32, 1/*#Ops*/, 0, 
                // Src: (setcc:{ *:[i32] } I64:{ *:[i64] }:$src, 0:{ *:[i64] }, SETEQ:{ *:[Other] }) - Complexity = 8
                // Dst: (EQZ_I64:{ *:[i32] } I64:{ *:[i64] }:$src)
/*  4562*/     /*Scope*/ 103, /*->4666*/
/*  4563*/      OPC_RecordChild1, // #1 = $rhs
/*  4564*/      OPC_Scope, 9, /*->4575*/ // 10 children in Scope
/*  4566*/       OPC_CheckChild2CondCode, ISD::SETEQ,
/*  4568*/       OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::EQ_I64),
                     MVT::i32, 2/*#Ops*/, 0, 1, 
                 // Src: (setcc:{ *:[i32] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs, SETEQ:{ *:[Other] }) - Complexity = 3
                 // Dst: (EQ_I64:{ *:[i32] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs)
/*  4575*/      /*Scope*/ 9, /*->4585*/
/*  4576*/       OPC_CheckChild2CondCode, ISD::SETNE,
/*  4578*/       OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::NE_I64),
                     MVT::i32, 2/*#Ops*/, 0, 1, 
                 // Src: (setcc:{ *:[i32] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs, SETNE:{ *:[Other] }) - Complexity = 3
                 // Dst: (NE_I64:{ *:[i32] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs)
/*  4585*/      /*Scope*/ 9, /*->4595*/
/*  4586*/       OPC_CheckChild2CondCode, ISD::SETLT,
/*  4588*/       OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::LT_S_I64),
                     MVT::i32, 2/*#Ops*/, 0, 1, 
                 // Src: (setcc:{ *:[i32] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs, SETLT:{ *:[Other] }) - Complexity = 3
                 // Dst: (LT_S_I64:{ *:[i32] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs)
/*  4595*/      /*Scope*/ 9, /*->4605*/
/*  4596*/       OPC_CheckChild2CondCode, ISD::SETULT,
/*  4598*/       OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::LT_U_I64),
                     MVT::i32, 2/*#Ops*/, 0, 1, 
                 // Src: (setcc:{ *:[i32] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs, SETULT:{ *:[Other] }) - Complexity = 3
                 // Dst: (LT_U_I64:{ *:[i32] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs)
/*  4605*/      /*Scope*/ 9, /*->4615*/
/*  4606*/       OPC_CheckChild2CondCode, ISD::SETGT,
/*  4608*/       OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::GT_S_I64),
                     MVT::i32, 2/*#Ops*/, 0, 1, 
                 // Src: (setcc:{ *:[i32] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs, SETGT:{ *:[Other] }) - Complexity = 3
                 // Dst: (GT_S_I64:{ *:[i32] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs)
/*  4615*/      /*Scope*/ 9, /*->4625*/
/*  4616*/       OPC_CheckChild2CondCode, ISD::SETUGT,
/*  4618*/       OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::GT_U_I64),
                     MVT::i32, 2/*#Ops*/, 0, 1, 
                 // Src: (setcc:{ *:[i32] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs, SETUGT:{ *:[Other] }) - Complexity = 3
                 // Dst: (GT_U_I64:{ *:[i32] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs)
/*  4625*/      /*Scope*/ 9, /*->4635*/
/*  4626*/       OPC_CheckChild2CondCode, ISD::SETLE,
/*  4628*/       OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::LE_S_I64),
                     MVT::i32, 2/*#Ops*/, 0, 1, 
                 // Src: (setcc:{ *:[i32] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs, SETLE:{ *:[Other] }) - Complexity = 3
                 // Dst: (LE_S_I64:{ *:[i32] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs)
/*  4635*/      /*Scope*/ 9, /*->4645*/
/*  4636*/       OPC_CheckChild2CondCode, ISD::SETULE,
/*  4638*/       OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::LE_U_I64),
                     MVT::i32, 2/*#Ops*/, 0, 1, 
                 // Src: (setcc:{ *:[i32] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs, SETULE:{ *:[Other] }) - Complexity = 3
                 // Dst: (LE_U_I64:{ *:[i32] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs)
/*  4645*/      /*Scope*/ 9, /*->4655*/
/*  4646*/       OPC_CheckChild2CondCode, ISD::SETGE,
/*  4648*/       OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::GE_S_I64),
                     MVT::i32, 2/*#Ops*/, 0, 1, 
                 // Src: (setcc:{ *:[i32] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs, SETGE:{ *:[Other] }) - Complexity = 3
                 // Dst: (GE_S_I64:{ *:[i32] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs)
/*  4655*/      /*Scope*/ 9, /*->4665*/
/*  4656*/       OPC_CheckChild2CondCode, ISD::SETUGE,
/*  4658*/       OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::GE_U_I64),
                     MVT::i32, 2/*#Ops*/, 0, 1, 
                 // Src: (setcc:{ *:[i32] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs, SETUGE:{ *:[Other] }) - Complexity = 3
                 // Dst: (GE_U_I64:{ *:[i32] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs)
/*  4665*/      0, /*End of Scope*/
/*  4666*/     0, /*End of Scope*/
/*  4667*/    /*Scope*/ 125, /*->4793*/
/*  4668*/     OPC_CheckChild0Type, MVT::f32,
/*  4670*/     OPC_RecordChild1, // #1 = $rhs
/*  4671*/     OPC_Scope, 9, /*->4682*/ // 12 children in Scope
/*  4673*/      OPC_CheckChild2CondCode, ISD::SETOEQ,
/*  4675*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::EQ_F32),
                    MVT::i32, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[i32] } F32:{ *:[f32] }:$lhs, F32:{ *:[f32] }:$rhs, SETOEQ:{ *:[Other] }) - Complexity = 3
                // Dst: (EQ_F32:{ *:[i32] } F32:{ *:[f32] }:$lhs, F32:{ *:[f32] }:$rhs)
/*  4682*/     /*Scope*/ 9, /*->4692*/
/*  4683*/      OPC_CheckChild2CondCode, ISD::SETUNE,
/*  4685*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::NE_F32),
                    MVT::i32, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[i32] } F32:{ *:[f32] }:$lhs, F32:{ *:[f32] }:$rhs, SETUNE:{ *:[Other] }) - Complexity = 3
                // Dst: (NE_F32:{ *:[i32] } F32:{ *:[f32] }:$lhs, F32:{ *:[f32] }:$rhs)
/*  4692*/     /*Scope*/ 9, /*->4702*/
/*  4693*/      OPC_CheckChild2CondCode, ISD::SETOLT,
/*  4695*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::LT_F32),
                    MVT::i32, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[i32] } F32:{ *:[f32] }:$lhs, F32:{ *:[f32] }:$rhs, SETOLT:{ *:[Other] }) - Complexity = 3
                // Dst: (LT_F32:{ *:[i32] } F32:{ *:[f32] }:$lhs, F32:{ *:[f32] }:$rhs)
/*  4702*/     /*Scope*/ 9, /*->4712*/
/*  4703*/      OPC_CheckChild2CondCode, ISD::SETOLE,
/*  4705*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::LE_F32),
                    MVT::i32, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[i32] } F32:{ *:[f32] }:$lhs, F32:{ *:[f32] }:$rhs, SETOLE:{ *:[Other] }) - Complexity = 3
                // Dst: (LE_F32:{ *:[i32] } F32:{ *:[f32] }:$lhs, F32:{ *:[f32] }:$rhs)
/*  4712*/     /*Scope*/ 9, /*->4722*/
/*  4713*/      OPC_CheckChild2CondCode, ISD::SETOGT,
/*  4715*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::GT_F32),
                    MVT::i32, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[i32] } F32:{ *:[f32] }:$lhs, F32:{ *:[f32] }:$rhs, SETOGT:{ *:[Other] }) - Complexity = 3
                // Dst: (GT_F32:{ *:[i32] } F32:{ *:[f32] }:$lhs, F32:{ *:[f32] }:$rhs)
/*  4722*/     /*Scope*/ 9, /*->4732*/
/*  4723*/      OPC_CheckChild2CondCode, ISD::SETOGE,
/*  4725*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::GE_F32),
                    MVT::i32, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[i32] } F32:{ *:[f32] }:$lhs, F32:{ *:[f32] }:$rhs, SETOGE:{ *:[Other] }) - Complexity = 3
                // Dst: (GE_F32:{ *:[i32] } F32:{ *:[f32] }:$lhs, F32:{ *:[f32] }:$rhs)
/*  4732*/     /*Scope*/ 9, /*->4742*/
/*  4733*/      OPC_CheckChild2CondCode, ISD::SETEQ,
/*  4735*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::EQ_F32),
                    MVT::i32, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[i32] } f32:{ *:[f32] }:$lhs, f32:{ *:[f32] }:$rhs, SETEQ:{ *:[Other] }) - Complexity = 3
                // Dst: (EQ_F32:{ *:[i32] } f32:{ *:[f32] }:$lhs, f32:{ *:[f32] }:$rhs)
/*  4742*/     /*Scope*/ 9, /*->4752*/
/*  4743*/      OPC_CheckChild2CondCode, ISD::SETNE,
/*  4745*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::NE_F32),
                    MVT::i32, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[i32] } f32:{ *:[f32] }:$lhs, f32:{ *:[f32] }:$rhs, SETNE:{ *:[Other] }) - Complexity = 3
                // Dst: (NE_F32:{ *:[i32] } f32:{ *:[f32] }:$lhs, f32:{ *:[f32] }:$rhs)
/*  4752*/     /*Scope*/ 9, /*->4762*/
/*  4753*/      OPC_CheckChild2CondCode, ISD::SETLT,
/*  4755*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::LT_F32),
                    MVT::i32, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[i32] } f32:{ *:[f32] }:$lhs, f32:{ *:[f32] }:$rhs, SETLT:{ *:[Other] }) - Complexity = 3
                // Dst: (LT_F32:{ *:[i32] } f32:{ *:[f32] }:$lhs, f32:{ *:[f32] }:$rhs)
/*  4762*/     /*Scope*/ 9, /*->4772*/
/*  4763*/      OPC_CheckChild2CondCode, ISD::SETLE,
/*  4765*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::LE_F32),
                    MVT::i32, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[i32] } f32:{ *:[f32] }:$lhs, f32:{ *:[f32] }:$rhs, SETLE:{ *:[Other] }) - Complexity = 3
                // Dst: (LE_F32:{ *:[i32] } f32:{ *:[f32] }:$lhs, f32:{ *:[f32] }:$rhs)
/*  4772*/     /*Scope*/ 9, /*->4782*/
/*  4773*/      OPC_CheckChild2CondCode, ISD::SETGT,
/*  4775*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::GT_F32),
                    MVT::i32, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[i32] } f32:{ *:[f32] }:$lhs, f32:{ *:[f32] }:$rhs, SETGT:{ *:[Other] }) - Complexity = 3
                // Dst: (GT_F32:{ *:[i32] } f32:{ *:[f32] }:$lhs, f32:{ *:[f32] }:$rhs)
/*  4782*/     /*Scope*/ 9, /*->4792*/
/*  4783*/      OPC_CheckChild2CondCode, ISD::SETGE,
/*  4785*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::GE_F32),
                    MVT::i32, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[i32] } f32:{ *:[f32] }:$lhs, f32:{ *:[f32] }:$rhs, SETGE:{ *:[Other] }) - Complexity = 3
                // Dst: (GE_F32:{ *:[i32] } f32:{ *:[f32] }:$lhs, f32:{ *:[f32] }:$rhs)
/*  4792*/     0, /*End of Scope*/
/*  4793*/    /*Scope*/ 125, /*->4919*/
/*  4794*/     OPC_CheckChild0Type, MVT::f64,
/*  4796*/     OPC_RecordChild1, // #1 = $rhs
/*  4797*/     OPC_Scope, 9, /*->4808*/ // 12 children in Scope
/*  4799*/      OPC_CheckChild2CondCode, ISD::SETOEQ,
/*  4801*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::EQ_F64),
                    MVT::i32, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[i32] } F64:{ *:[f64] }:$lhs, F64:{ *:[f64] }:$rhs, SETOEQ:{ *:[Other] }) - Complexity = 3
                // Dst: (EQ_F64:{ *:[i32] } F64:{ *:[f64] }:$lhs, F64:{ *:[f64] }:$rhs)
/*  4808*/     /*Scope*/ 9, /*->4818*/
/*  4809*/      OPC_CheckChild2CondCode, ISD::SETUNE,
/*  4811*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::NE_F64),
                    MVT::i32, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[i32] } F64:{ *:[f64] }:$lhs, F64:{ *:[f64] }:$rhs, SETUNE:{ *:[Other] }) - Complexity = 3
                // Dst: (NE_F64:{ *:[i32] } F64:{ *:[f64] }:$lhs, F64:{ *:[f64] }:$rhs)
/*  4818*/     /*Scope*/ 9, /*->4828*/
/*  4819*/      OPC_CheckChild2CondCode, ISD::SETOLT,
/*  4821*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::LT_F64),
                    MVT::i32, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[i32] } F64:{ *:[f64] }:$lhs, F64:{ *:[f64] }:$rhs, SETOLT:{ *:[Other] }) - Complexity = 3
                // Dst: (LT_F64:{ *:[i32] } F64:{ *:[f64] }:$lhs, F64:{ *:[f64] }:$rhs)
/*  4828*/     /*Scope*/ 9, /*->4838*/
/*  4829*/      OPC_CheckChild2CondCode, ISD::SETOLE,
/*  4831*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::LE_F64),
                    MVT::i32, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[i32] } F64:{ *:[f64] }:$lhs, F64:{ *:[f64] }:$rhs, SETOLE:{ *:[Other] }) - Complexity = 3
                // Dst: (LE_F64:{ *:[i32] } F64:{ *:[f64] }:$lhs, F64:{ *:[f64] }:$rhs)
/*  4838*/     /*Scope*/ 9, /*->4848*/
/*  4839*/      OPC_CheckChild2CondCode, ISD::SETOGT,
/*  4841*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::GT_F64),
                    MVT::i32, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[i32] } F64:{ *:[f64] }:$lhs, F64:{ *:[f64] }:$rhs, SETOGT:{ *:[Other] }) - Complexity = 3
                // Dst: (GT_F64:{ *:[i32] } F64:{ *:[f64] }:$lhs, F64:{ *:[f64] }:$rhs)
/*  4848*/     /*Scope*/ 9, /*->4858*/
/*  4849*/      OPC_CheckChild2CondCode, ISD::SETOGE,
/*  4851*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::GE_F64),
                    MVT::i32, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[i32] } F64:{ *:[f64] }:$lhs, F64:{ *:[f64] }:$rhs, SETOGE:{ *:[Other] }) - Complexity = 3
                // Dst: (GE_F64:{ *:[i32] } F64:{ *:[f64] }:$lhs, F64:{ *:[f64] }:$rhs)
/*  4858*/     /*Scope*/ 9, /*->4868*/
/*  4859*/      OPC_CheckChild2CondCode, ISD::SETEQ,
/*  4861*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::EQ_F64),
                    MVT::i32, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[i32] } f64:{ *:[f64] }:$lhs, f64:{ *:[f64] }:$rhs, SETEQ:{ *:[Other] }) - Complexity = 3
                // Dst: (EQ_F64:{ *:[i32] } f64:{ *:[f64] }:$lhs, f64:{ *:[f64] }:$rhs)
/*  4868*/     /*Scope*/ 9, /*->4878*/
/*  4869*/      OPC_CheckChild2CondCode, ISD::SETNE,
/*  4871*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::NE_F64),
                    MVT::i32, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[i32] } f64:{ *:[f64] }:$lhs, f64:{ *:[f64] }:$rhs, SETNE:{ *:[Other] }) - Complexity = 3
                // Dst: (NE_F64:{ *:[i32] } f64:{ *:[f64] }:$lhs, f64:{ *:[f64] }:$rhs)
/*  4878*/     /*Scope*/ 9, /*->4888*/
/*  4879*/      OPC_CheckChild2CondCode, ISD::SETLT,
/*  4881*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::LT_F64),
                    MVT::i32, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[i32] } f64:{ *:[f64] }:$lhs, f64:{ *:[f64] }:$rhs, SETLT:{ *:[Other] }) - Complexity = 3
                // Dst: (LT_F64:{ *:[i32] } f64:{ *:[f64] }:$lhs, f64:{ *:[f64] }:$rhs)
/*  4888*/     /*Scope*/ 9, /*->4898*/
/*  4889*/      OPC_CheckChild2CondCode, ISD::SETLE,
/*  4891*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::LE_F64),
                    MVT::i32, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[i32] } f64:{ *:[f64] }:$lhs, f64:{ *:[f64] }:$rhs, SETLE:{ *:[Other] }) - Complexity = 3
                // Dst: (LE_F64:{ *:[i32] } f64:{ *:[f64] }:$lhs, f64:{ *:[f64] }:$rhs)
/*  4898*/     /*Scope*/ 9, /*->4908*/
/*  4899*/      OPC_CheckChild2CondCode, ISD::SETGT,
/*  4901*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::GT_F64),
                    MVT::i32, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[i32] } f64:{ *:[f64] }:$lhs, f64:{ *:[f64] }:$rhs, SETGT:{ *:[Other] }) - Complexity = 3
                // Dst: (GT_F64:{ *:[i32] } f64:{ *:[f64] }:$lhs, f64:{ *:[f64] }:$rhs)
/*  4908*/     /*Scope*/ 9, /*->4918*/
/*  4909*/      OPC_CheckChild2CondCode, ISD::SETGE,
/*  4911*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::GE_F64),
                    MVT::i32, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[i32] } f64:{ *:[f64] }:$lhs, f64:{ *:[f64] }:$rhs, SETGE:{ *:[Other] }) - Complexity = 3
                // Dst: (GE_F64:{ *:[i32] } f64:{ *:[f64] }:$lhs, f64:{ *:[f64] }:$rhs)
/*  4918*/     0, /*End of Scope*/
/*  4919*/    0, /*End of Scope*/
/*  4920*/   /*SwitchType*/ 115, MVT::v16i8,// ->5037
/*  4922*/    OPC_CheckChild0Type, MVT::v16i8,
/*  4924*/    OPC_RecordChild1, // #1 = $rhs
/*  4925*/    OPC_Scope, 10, /*->4937*/ // 10 children in Scope
/*  4927*/     OPC_CheckChild2CondCode, ISD::SETEQ,
/*  4929*/     OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/*  4930*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::EQ_I8x16),
                   MVT::v16i8, 2/*#Ops*/, 0, 1, 
               // Src: (setcc:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs, SETEQ:{ *:[Other] }) - Complexity = 3
               // Dst: (EQ_I8x16:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs)
/*  4937*/    /*Scope*/ 10, /*->4948*/
/*  4938*/     OPC_CheckChild2CondCode, ISD::SETNE,
/*  4940*/     OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/*  4941*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::NE_I8x16),
                   MVT::v16i8, 2/*#Ops*/, 0, 1, 
               // Src: (setcc:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs, SETNE:{ *:[Other] }) - Complexity = 3
               // Dst: (NE_I8x16:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs)
/*  4948*/    /*Scope*/ 10, /*->4959*/
/*  4949*/     OPC_CheckChild2CondCode, ISD::SETLT,
/*  4951*/     OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/*  4952*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::LT_S_I8x16),
                   MVT::v16i8, 2/*#Ops*/, 0, 1, 
               // Src: (setcc:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs, SETLT:{ *:[Other] }) - Complexity = 3
               // Dst: (LT_S_I8x16:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs)
/*  4959*/    /*Scope*/ 10, /*->4970*/
/*  4960*/     OPC_CheckChild2CondCode, ISD::SETULT,
/*  4962*/     OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/*  4963*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::LT_U_I8x16),
                   MVT::v16i8, 2/*#Ops*/, 0, 1, 
               // Src: (setcc:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs, SETULT:{ *:[Other] }) - Complexity = 3
               // Dst: (LT_U_I8x16:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs)
/*  4970*/    /*Scope*/ 10, /*->4981*/
/*  4971*/     OPC_CheckChild2CondCode, ISD::SETGT,
/*  4973*/     OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/*  4974*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::GT_S_I8x16),
                   MVT::v16i8, 2/*#Ops*/, 0, 1, 
               // Src: (setcc:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs, SETGT:{ *:[Other] }) - Complexity = 3
               // Dst: (GT_S_I8x16:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs)
/*  4981*/    /*Scope*/ 10, /*->4992*/
/*  4982*/     OPC_CheckChild2CondCode, ISD::SETUGT,
/*  4984*/     OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/*  4985*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::GT_U_I8x16),
                   MVT::v16i8, 2/*#Ops*/, 0, 1, 
               // Src: (setcc:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs, SETUGT:{ *:[Other] }) - Complexity = 3
               // Dst: (GT_U_I8x16:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs)
/*  4992*/    /*Scope*/ 10, /*->5003*/
/*  4993*/     OPC_CheckChild2CondCode, ISD::SETLE,
/*  4995*/     OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/*  4996*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::LE_S_I8x16),
                   MVT::v16i8, 2/*#Ops*/, 0, 1, 
               // Src: (setcc:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs, SETLE:{ *:[Other] }) - Complexity = 3
               // Dst: (LE_S_I8x16:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs)
/*  5003*/    /*Scope*/ 10, /*->5014*/
/*  5004*/     OPC_CheckChild2CondCode, ISD::SETULE,
/*  5006*/     OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/*  5007*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::LE_U_I8x16),
                   MVT::v16i8, 2/*#Ops*/, 0, 1, 
               // Src: (setcc:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs, SETULE:{ *:[Other] }) - Complexity = 3
               // Dst: (LE_U_I8x16:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs)
/*  5014*/    /*Scope*/ 10, /*->5025*/
/*  5015*/     OPC_CheckChild2CondCode, ISD::SETGE,
/*  5017*/     OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/*  5018*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::GE_S_I8x16),
                   MVT::v16i8, 2/*#Ops*/, 0, 1, 
               // Src: (setcc:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs, SETGE:{ *:[Other] }) - Complexity = 3
               // Dst: (GE_S_I8x16:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs)
/*  5025*/    /*Scope*/ 10, /*->5036*/
/*  5026*/     OPC_CheckChild2CondCode, ISD::SETUGE,
/*  5028*/     OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/*  5029*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::GE_U_I8x16),
                   MVT::v16i8, 2/*#Ops*/, 0, 1, 
               // Src: (setcc:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs, SETUGE:{ *:[Other] }) - Complexity = 3
               // Dst: (GE_U_I8x16:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs)
/*  5036*/    0, /*End of Scope*/
/*  5037*/   /*SwitchType*/ 115, MVT::v8i16,// ->5154
/*  5039*/    OPC_CheckChild0Type, MVT::v8i16,
/*  5041*/    OPC_RecordChild1, // #1 = $rhs
/*  5042*/    OPC_Scope, 10, /*->5054*/ // 10 children in Scope
/*  5044*/     OPC_CheckChild2CondCode, ISD::SETEQ,
/*  5046*/     OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/*  5047*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::EQ_I16x8),
                   MVT::v8i16, 2/*#Ops*/, 0, 1, 
               // Src: (setcc:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs, SETEQ:{ *:[Other] }) - Complexity = 3
               // Dst: (EQ_I16x8:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs)
/*  5054*/    /*Scope*/ 10, /*->5065*/
/*  5055*/     OPC_CheckChild2CondCode, ISD::SETNE,
/*  5057*/     OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/*  5058*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::NE_I16x8),
                   MVT::v8i16, 2/*#Ops*/, 0, 1, 
               // Src: (setcc:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs, SETNE:{ *:[Other] }) - Complexity = 3
               // Dst: (NE_I16x8:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs)
/*  5065*/    /*Scope*/ 10, /*->5076*/
/*  5066*/     OPC_CheckChild2CondCode, ISD::SETLT,
/*  5068*/     OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/*  5069*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::LT_S_I16x8),
                   MVT::v8i16, 2/*#Ops*/, 0, 1, 
               // Src: (setcc:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs, SETLT:{ *:[Other] }) - Complexity = 3
               // Dst: (LT_S_I16x8:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs)
/*  5076*/    /*Scope*/ 10, /*->5087*/
/*  5077*/     OPC_CheckChild2CondCode, ISD::SETULT,
/*  5079*/     OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/*  5080*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::LT_U_I16x8),
                   MVT::v8i16, 2/*#Ops*/, 0, 1, 
               // Src: (setcc:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs, SETULT:{ *:[Other] }) - Complexity = 3
               // Dst: (LT_U_I16x8:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs)
/*  5087*/    /*Scope*/ 10, /*->5098*/
/*  5088*/     OPC_CheckChild2CondCode, ISD::SETGT,
/*  5090*/     OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/*  5091*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::GT_S_I16x8),
                   MVT::v8i16, 2/*#Ops*/, 0, 1, 
               // Src: (setcc:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs, SETGT:{ *:[Other] }) - Complexity = 3
               // Dst: (GT_S_I16x8:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs)
/*  5098*/    /*Scope*/ 10, /*->5109*/
/*  5099*/     OPC_CheckChild2CondCode, ISD::SETUGT,
/*  5101*/     OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/*  5102*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::GT_U_I16x8),
                   MVT::v8i16, 2/*#Ops*/, 0, 1, 
               // Src: (setcc:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs, SETUGT:{ *:[Other] }) - Complexity = 3
               // Dst: (GT_U_I16x8:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs)
/*  5109*/    /*Scope*/ 10, /*->5120*/
/*  5110*/     OPC_CheckChild2CondCode, ISD::SETLE,
/*  5112*/     OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/*  5113*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::LE_S_I16x8),
                   MVT::v8i16, 2/*#Ops*/, 0, 1, 
               // Src: (setcc:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs, SETLE:{ *:[Other] }) - Complexity = 3
               // Dst: (LE_S_I16x8:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs)
/*  5120*/    /*Scope*/ 10, /*->5131*/
/*  5121*/     OPC_CheckChild2CondCode, ISD::SETULE,
/*  5123*/     OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/*  5124*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::LE_U_I16x8),
                   MVT::v8i16, 2/*#Ops*/, 0, 1, 
               // Src: (setcc:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs, SETULE:{ *:[Other] }) - Complexity = 3
               // Dst: (LE_U_I16x8:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs)
/*  5131*/    /*Scope*/ 10, /*->5142*/
/*  5132*/     OPC_CheckChild2CondCode, ISD::SETGE,
/*  5134*/     OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/*  5135*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::GE_S_I16x8),
                   MVT::v8i16, 2/*#Ops*/, 0, 1, 
               // Src: (setcc:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs, SETGE:{ *:[Other] }) - Complexity = 3
               // Dst: (GE_S_I16x8:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs)
/*  5142*/    /*Scope*/ 10, /*->5153*/
/*  5143*/     OPC_CheckChild2CondCode, ISD::SETUGE,
/*  5145*/     OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/*  5146*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::GE_U_I16x8),
                   MVT::v8i16, 2/*#Ops*/, 0, 1, 
               // Src: (setcc:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs, SETUGE:{ *:[Other] }) - Complexity = 3
               // Dst: (GE_U_I16x8:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs)
/*  5153*/    0, /*End of Scope*/
/*  5154*/   /*SwitchType*/ 123|128,1/*251*/, MVT::v4i32,// ->5408
/*  5157*/    OPC_Scope, 115, /*->5274*/ // 2 children in Scope
/*  5159*/     OPC_CheckChild0Type, MVT::v4i32,
/*  5161*/     OPC_RecordChild1, // #1 = $rhs
/*  5162*/     OPC_Scope, 10, /*->5174*/ // 10 children in Scope
/*  5164*/      OPC_CheckChild2CondCode, ISD::SETEQ,
/*  5166*/      OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/*  5167*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::EQ_I32x4),
                    MVT::v4i32, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[v4i32] } V128:{ *:[v4i32] }:$lhs, V128:{ *:[v4i32] }:$rhs, SETEQ:{ *:[Other] }) - Complexity = 3
                // Dst: (EQ_I32x4:{ *:[v4i32] } V128:{ *:[v4i32] }:$lhs, V128:{ *:[v4i32] }:$rhs)
/*  5174*/     /*Scope*/ 10, /*->5185*/
/*  5175*/      OPC_CheckChild2CondCode, ISD::SETNE,
/*  5177*/      OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/*  5178*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::NE_I32x4),
                    MVT::v4i32, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[v4i32] } V128:{ *:[v4i32] }:$lhs, V128:{ *:[v4i32] }:$rhs, SETNE:{ *:[Other] }) - Complexity = 3
                // Dst: (NE_I32x4:{ *:[v4i32] } V128:{ *:[v4i32] }:$lhs, V128:{ *:[v4i32] }:$rhs)
/*  5185*/     /*Scope*/ 10, /*->5196*/
/*  5186*/      OPC_CheckChild2CondCode, ISD::SETLT,
/*  5188*/      OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/*  5189*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::LT_S_I32x4),
                    MVT::v4i32, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[v4i32] } V128:{ *:[v4i32] }:$lhs, V128:{ *:[v4i32] }:$rhs, SETLT:{ *:[Other] }) - Complexity = 3
                // Dst: (LT_S_I32x4:{ *:[v4i32] } V128:{ *:[v4i32] }:$lhs, V128:{ *:[v4i32] }:$rhs)
/*  5196*/     /*Scope*/ 10, /*->5207*/
/*  5197*/      OPC_CheckChild2CondCode, ISD::SETULT,
/*  5199*/      OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/*  5200*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::LT_U_I32x4),
                    MVT::v4i32, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[v4i32] } V128:{ *:[v4i32] }:$lhs, V128:{ *:[v4i32] }:$rhs, SETULT:{ *:[Other] }) - Complexity = 3
                // Dst: (LT_U_I32x4:{ *:[v4i32] } V128:{ *:[v4i32] }:$lhs, V128:{ *:[v4i32] }:$rhs)
/*  5207*/     /*Scope*/ 10, /*->5218*/
/*  5208*/      OPC_CheckChild2CondCode, ISD::SETGT,
/*  5210*/      OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/*  5211*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::GT_S_I32x4),
                    MVT::v4i32, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[v4i32] } V128:{ *:[v4i32] }:$lhs, V128:{ *:[v4i32] }:$rhs, SETGT:{ *:[Other] }) - Complexity = 3
                // Dst: (GT_S_I32x4:{ *:[v4i32] } V128:{ *:[v4i32] }:$lhs, V128:{ *:[v4i32] }:$rhs)
/*  5218*/     /*Scope*/ 10, /*->5229*/
/*  5219*/      OPC_CheckChild2CondCode, ISD::SETUGT,
/*  5221*/      OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/*  5222*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::GT_U_I32x4),
                    MVT::v4i32, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[v4i32] } V128:{ *:[v4i32] }:$lhs, V128:{ *:[v4i32] }:$rhs, SETUGT:{ *:[Other] }) - Complexity = 3
                // Dst: (GT_U_I32x4:{ *:[v4i32] } V128:{ *:[v4i32] }:$lhs, V128:{ *:[v4i32] }:$rhs)
/*  5229*/     /*Scope*/ 10, /*->5240*/
/*  5230*/      OPC_CheckChild2CondCode, ISD::SETLE,
/*  5232*/      OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/*  5233*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::LE_S_I32x4),
                    MVT::v4i32, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[v4i32] } V128:{ *:[v4i32] }:$lhs, V128:{ *:[v4i32] }:$rhs, SETLE:{ *:[Other] }) - Complexity = 3
                // Dst: (LE_S_I32x4:{ *:[v4i32] } V128:{ *:[v4i32] }:$lhs, V128:{ *:[v4i32] }:$rhs)
/*  5240*/     /*Scope*/ 10, /*->5251*/
/*  5241*/      OPC_CheckChild2CondCode, ISD::SETULE,
/*  5243*/      OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/*  5244*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::LE_U_I32x4),
                    MVT::v4i32, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[v4i32] } V128:{ *:[v4i32] }:$lhs, V128:{ *:[v4i32] }:$rhs, SETULE:{ *:[Other] }) - Complexity = 3
                // Dst: (LE_U_I32x4:{ *:[v4i32] } V128:{ *:[v4i32] }:$lhs, V128:{ *:[v4i32] }:$rhs)
/*  5251*/     /*Scope*/ 10, /*->5262*/
/*  5252*/      OPC_CheckChild2CondCode, ISD::SETGE,
/*  5254*/      OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/*  5255*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::GE_S_I32x4),
                    MVT::v4i32, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[v4i32] } V128:{ *:[v4i32] }:$lhs, V128:{ *:[v4i32] }:$rhs, SETGE:{ *:[Other] }) - Complexity = 3
                // Dst: (GE_S_I32x4:{ *:[v4i32] } V128:{ *:[v4i32] }:$lhs, V128:{ *:[v4i32] }:$rhs)
/*  5262*/     /*Scope*/ 10, /*->5273*/
/*  5263*/      OPC_CheckChild2CondCode, ISD::SETUGE,
/*  5265*/      OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/*  5266*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::GE_U_I32x4),
                    MVT::v4i32, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[v4i32] } V128:{ *:[v4i32] }:$lhs, V128:{ *:[v4i32] }:$rhs, SETUGE:{ *:[Other] }) - Complexity = 3
                // Dst: (GE_U_I32x4:{ *:[v4i32] } V128:{ *:[v4i32] }:$lhs, V128:{ *:[v4i32] }:$rhs)
/*  5273*/     0, /*End of Scope*/
/*  5274*/    /*Scope*/ 3|128,1/*131*/, /*->5407*/
/*  5276*/     OPC_CheckChild0Type, MVT::v4f32,
/*  5278*/     OPC_RecordChild1, // #1 = $rhs
/*  5279*/     OPC_Scope, 10, /*->5291*/ // 12 children in Scope
/*  5281*/      OPC_CheckChild2CondCode, ISD::SETOEQ,
/*  5283*/      OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/*  5284*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::EQ_F32x4),
                    MVT::v4i32, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[v4i32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs, SETOEQ:{ *:[Other] }) - Complexity = 3
                // Dst: (EQ_F32x4:{ *:[v4i32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs)
/*  5291*/     /*Scope*/ 10, /*->5302*/
/*  5292*/      OPC_CheckChild2CondCode, ISD::SETUNE,
/*  5294*/      OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/*  5295*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::NE_F32x4),
                    MVT::v4i32, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[v4i32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs, SETUNE:{ *:[Other] }) - Complexity = 3
                // Dst: (NE_F32x4:{ *:[v4i32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs)
/*  5302*/     /*Scope*/ 10, /*->5313*/
/*  5303*/      OPC_CheckChild2CondCode, ISD::SETOLT,
/*  5305*/      OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/*  5306*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::LT_F32x4),
                    MVT::v4i32, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[v4i32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs, SETOLT:{ *:[Other] }) - Complexity = 3
                // Dst: (LT_F32x4:{ *:[v4i32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs)
/*  5313*/     /*Scope*/ 10, /*->5324*/
/*  5314*/      OPC_CheckChild2CondCode, ISD::SETOGT,
/*  5316*/      OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/*  5317*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::GT_F32x4),
                    MVT::v4i32, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[v4i32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs, SETOGT:{ *:[Other] }) - Complexity = 3
                // Dst: (GT_F32x4:{ *:[v4i32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs)
/*  5324*/     /*Scope*/ 10, /*->5335*/
/*  5325*/      OPC_CheckChild2CondCode, ISD::SETOLE,
/*  5327*/      OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/*  5328*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::LE_F32x4),
                    MVT::v4i32, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[v4i32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs, SETOLE:{ *:[Other] }) - Complexity = 3
                // Dst: (LE_F32x4:{ *:[v4i32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs)
/*  5335*/     /*Scope*/ 10, /*->5346*/
/*  5336*/      OPC_CheckChild2CondCode, ISD::SETOGE,
/*  5338*/      OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/*  5339*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::GE_F32x4),
                    MVT::v4i32, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[v4i32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs, SETOGE:{ *:[Other] }) - Complexity = 3
                // Dst: (GE_F32x4:{ *:[v4i32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs)
/*  5346*/     /*Scope*/ 9, /*->5356*/
/*  5347*/      OPC_CheckChild2CondCode, ISD::SETEQ,
/*  5349*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::EQ_F32x4),
                    MVT::v4i32, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[v4i32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs, SETEQ:{ *:[Other] }) - Complexity = 3
                // Dst: (EQ_F32x4:{ *:[v4i32] } ?:{ *:[v4f32] }:$lhs, ?:{ *:[v4f32] }:$rhs)
/*  5356*/     /*Scope*/ 9, /*->5366*/
/*  5357*/      OPC_CheckChild2CondCode, ISD::SETNE,
/*  5359*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::NE_F32x4),
                    MVT::v4i32, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[v4i32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs, SETNE:{ *:[Other] }) - Complexity = 3
                // Dst: (NE_F32x4:{ *:[v4i32] } ?:{ *:[v4f32] }:$lhs, ?:{ *:[v4f32] }:$rhs)
/*  5366*/     /*Scope*/ 9, /*->5376*/
/*  5367*/      OPC_CheckChild2CondCode, ISD::SETLT,
/*  5369*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::LT_F32x4),
                    MVT::v4i32, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[v4i32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs, SETLT:{ *:[Other] }) - Complexity = 3
                // Dst: (LT_F32x4:{ *:[v4i32] } ?:{ *:[v4f32] }:$lhs, ?:{ *:[v4f32] }:$rhs)
/*  5376*/     /*Scope*/ 9, /*->5386*/
/*  5377*/      OPC_CheckChild2CondCode, ISD::SETGT,
/*  5379*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::GT_F32x4),
                    MVT::v4i32, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[v4i32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs, SETGT:{ *:[Other] }) - Complexity = 3
                // Dst: (GT_F32x4:{ *:[v4i32] } ?:{ *:[v4f32] }:$lhs, ?:{ *:[v4f32] }:$rhs)
/*  5386*/     /*Scope*/ 9, /*->5396*/
/*  5387*/      OPC_CheckChild2CondCode, ISD::SETLE,
/*  5389*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::LE_F32x4),
                    MVT::v4i32, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[v4i32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs, SETLE:{ *:[Other] }) - Complexity = 3
                // Dst: (LE_F32x4:{ *:[v4i32] } ?:{ *:[v4f32] }:$lhs, ?:{ *:[v4f32] }:$rhs)
/*  5396*/     /*Scope*/ 9, /*->5406*/
/*  5397*/      OPC_CheckChild2CondCode, ISD::SETGE,
/*  5399*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::GE_F32x4),
                    MVT::v4i32, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[v4i32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs, SETGE:{ *:[Other] }) - Complexity = 3
                // Dst: (GE_F32x4:{ *:[v4i32] } ?:{ *:[v4f32] }:$lhs, ?:{ *:[v4f32] }:$rhs)
/*  5406*/     0, /*End of Scope*/
/*  5407*/    0, /*End of Scope*/
/*  5408*/   /*SwitchType*/ 79|128,1/*207*/, MVT::v2i64,// ->5618
/*  5411*/    OPC_Scope, 71, /*->5484*/ // 2 children in Scope
/*  5413*/     OPC_CheckChild0Type, MVT::v2i64,
/*  5415*/     OPC_RecordChild1, // #1 = $rhs
/*  5416*/     OPC_Scope, 10, /*->5428*/ // 6 children in Scope
/*  5418*/      OPC_CheckChild2CondCode, ISD::SETEQ,
/*  5420*/      OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/*  5421*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::EQ_I64x2),
                    MVT::v2i64, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[v2i64] } V128:{ *:[v2i64] }:$lhs, V128:{ *:[v2i64] }:$rhs, SETEQ:{ *:[Other] }) - Complexity = 3
                // Dst: (EQ_I64x2:{ *:[v2i64] } V128:{ *:[v2i64] }:$lhs, V128:{ *:[v2i64] }:$rhs)
/*  5428*/     /*Scope*/ 10, /*->5439*/
/*  5429*/      OPC_CheckChild2CondCode, ISD::SETNE,
/*  5431*/      OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/*  5432*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::NE_I64x2),
                    MVT::v2i64, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[v2i64] } V128:{ *:[v2i64] }:$lhs, V128:{ *:[v2i64] }:$rhs, SETNE:{ *:[Other] }) - Complexity = 3
                // Dst: (NE_I64x2:{ *:[v2i64] } V128:{ *:[v2i64] }:$lhs, V128:{ *:[v2i64] }:$rhs)
/*  5439*/     /*Scope*/ 10, /*->5450*/
/*  5440*/      OPC_CheckChild2CondCode, ISD::SETLT,
/*  5442*/      OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/*  5443*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::LT_S_I64x2),
                    MVT::v2i64, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[v2i64] } V128:{ *:[v2i64] }:$lhs, V128:{ *:[v2i64] }:$rhs, SETLT:{ *:[Other] }) - Complexity = 3
                // Dst: (LT_S_I64x2:{ *:[v2i64] } V128:{ *:[v2i64] }:$lhs, V128:{ *:[v2i64] }:$rhs)
/*  5450*/     /*Scope*/ 10, /*->5461*/
/*  5451*/      OPC_CheckChild2CondCode, ISD::SETGT,
/*  5453*/      OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/*  5454*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::GT_S_I64x2),
                    MVT::v2i64, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[v2i64] } V128:{ *:[v2i64] }:$lhs, V128:{ *:[v2i64] }:$rhs, SETGT:{ *:[Other] }) - Complexity = 3
                // Dst: (GT_S_I64x2:{ *:[v2i64] } V128:{ *:[v2i64] }:$lhs, V128:{ *:[v2i64] }:$rhs)
/*  5461*/     /*Scope*/ 10, /*->5472*/
/*  5462*/      OPC_CheckChild2CondCode, ISD::SETLE,
/*  5464*/      OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/*  5465*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::LE_S_I64x2),
                    MVT::v2i64, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[v2i64] } V128:{ *:[v2i64] }:$lhs, V128:{ *:[v2i64] }:$rhs, SETLE:{ *:[Other] }) - Complexity = 3
                // Dst: (LE_S_I64x2:{ *:[v2i64] } V128:{ *:[v2i64] }:$lhs, V128:{ *:[v2i64] }:$rhs)
/*  5472*/     /*Scope*/ 10, /*->5483*/
/*  5473*/      OPC_CheckChild2CondCode, ISD::SETGE,
/*  5475*/      OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/*  5476*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::GE_S_I64x2),
                    MVT::v2i64, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[v2i64] } V128:{ *:[v2i64] }:$lhs, V128:{ *:[v2i64] }:$rhs, SETGE:{ *:[Other] }) - Complexity = 3
                // Dst: (GE_S_I64x2:{ *:[v2i64] } V128:{ *:[v2i64] }:$lhs, V128:{ *:[v2i64] }:$rhs)
/*  5483*/     0, /*End of Scope*/
/*  5484*/    /*Scope*/ 3|128,1/*131*/, /*->5617*/
/*  5486*/     OPC_CheckChild0Type, MVT::v2f64,
/*  5488*/     OPC_RecordChild1, // #1 = $rhs
/*  5489*/     OPC_Scope, 10, /*->5501*/ // 12 children in Scope
/*  5491*/      OPC_CheckChild2CondCode, ISD::SETOEQ,
/*  5493*/      OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/*  5494*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::EQ_F64x2),
                    MVT::v2i64, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[v2i64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs, SETOEQ:{ *:[Other] }) - Complexity = 3
                // Dst: (EQ_F64x2:{ *:[v2i64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs)
/*  5501*/     /*Scope*/ 10, /*->5512*/
/*  5502*/      OPC_CheckChild2CondCode, ISD::SETUNE,
/*  5504*/      OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/*  5505*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::NE_F64x2),
                    MVT::v2i64, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[v2i64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs, SETUNE:{ *:[Other] }) - Complexity = 3
                // Dst: (NE_F64x2:{ *:[v2i64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs)
/*  5512*/     /*Scope*/ 10, /*->5523*/
/*  5513*/      OPC_CheckChild2CondCode, ISD::SETOLT,
/*  5515*/      OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/*  5516*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::LT_F64x2),
                    MVT::v2i64, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[v2i64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs, SETOLT:{ *:[Other] }) - Complexity = 3
                // Dst: (LT_F64x2:{ *:[v2i64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs)
/*  5523*/     /*Scope*/ 10, /*->5534*/
/*  5524*/      OPC_CheckChild2CondCode, ISD::SETOGT,
/*  5526*/      OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/*  5527*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::GT_F64x2),
                    MVT::v2i64, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[v2i64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs, SETOGT:{ *:[Other] }) - Complexity = 3
                // Dst: (GT_F64x2:{ *:[v2i64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs)
/*  5534*/     /*Scope*/ 10, /*->5545*/
/*  5535*/      OPC_CheckChild2CondCode, ISD::SETOLE,
/*  5537*/      OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/*  5538*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::LE_F64x2),
                    MVT::v2i64, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[v2i64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs, SETOLE:{ *:[Other] }) - Complexity = 3
                // Dst: (LE_F64x2:{ *:[v2i64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs)
/*  5545*/     /*Scope*/ 10, /*->5556*/
/*  5546*/      OPC_CheckChild2CondCode, ISD::SETOGE,
/*  5548*/      OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/*  5549*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::GE_F64x2),
                    MVT::v2i64, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[v2i64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs, SETOGE:{ *:[Other] }) - Complexity = 3
                // Dst: (GE_F64x2:{ *:[v2i64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs)
/*  5556*/     /*Scope*/ 9, /*->5566*/
/*  5557*/      OPC_CheckChild2CondCode, ISD::SETEQ,
/*  5559*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::EQ_F64x2),
                    MVT::v2i64, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[v2i64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs, SETEQ:{ *:[Other] }) - Complexity = 3
                // Dst: (EQ_F64x2:{ *:[v2i64] } ?:{ *:[v2f64] }:$lhs, ?:{ *:[v2f64] }:$rhs)
/*  5566*/     /*Scope*/ 9, /*->5576*/
/*  5567*/      OPC_CheckChild2CondCode, ISD::SETNE,
/*  5569*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::NE_F64x2),
                    MVT::v2i64, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[v2i64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs, SETNE:{ *:[Other] }) - Complexity = 3
                // Dst: (NE_F64x2:{ *:[v2i64] } ?:{ *:[v2f64] }:$lhs, ?:{ *:[v2f64] }:$rhs)
/*  5576*/     /*Scope*/ 9, /*->5586*/
/*  5577*/      OPC_CheckChild2CondCode, ISD::SETLT,
/*  5579*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::LT_F64x2),
                    MVT::v2i64, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[v2i64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs, SETLT:{ *:[Other] }) - Complexity = 3
                // Dst: (LT_F64x2:{ *:[v2i64] } ?:{ *:[v2f64] }:$lhs, ?:{ *:[v2f64] }:$rhs)
/*  5586*/     /*Scope*/ 9, /*->5596*/
/*  5587*/      OPC_CheckChild2CondCode, ISD::SETGT,
/*  5589*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::GT_F64x2),
                    MVT::v2i64, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[v2i64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs, SETGT:{ *:[Other] }) - Complexity = 3
                // Dst: (GT_F64x2:{ *:[v2i64] } ?:{ *:[v2f64] }:$lhs, ?:{ *:[v2f64] }:$rhs)
/*  5596*/     /*Scope*/ 9, /*->5606*/
/*  5597*/      OPC_CheckChild2CondCode, ISD::SETLE,
/*  5599*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::LE_F64x2),
                    MVT::v2i64, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[v2i64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs, SETLE:{ *:[Other] }) - Complexity = 3
                // Dst: (LE_F64x2:{ *:[v2i64] } ?:{ *:[v2f64] }:$lhs, ?:{ *:[v2f64] }:$rhs)
/*  5606*/     /*Scope*/ 9, /*->5616*/
/*  5607*/      OPC_CheckChild2CondCode, ISD::SETGE,
/*  5609*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::GE_F64x2),
                    MVT::v2i64, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[v2i64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs, SETGE:{ *:[Other] }) - Complexity = 3
                // Dst: (GE_F64x2:{ *:[v2i64] } ?:{ *:[v2f64] }:$lhs, ?:{ *:[v2f64] }:$rhs)
/*  5616*/     0, /*End of Scope*/
/*  5617*/    0, /*End of Scope*/
/*  5618*/   0, // EndSwitchType
/*  5619*/  0, /*End of Scope*/
/*  5620*/ /*SwitchOpcode*/ 17|128,11/*1425*/, TARGET_VAL(ISD::LOAD),// ->7049
/*  5624*/  OPC_RecordMemRef,
/*  5625*/  OPC_RecordNode, // #0 = 'ld' chained node
/*  5626*/  OPC_RecordChild1, // #1 = $AddrOps32:offset:addr
/*  5627*/  OPC_Scope, 68|128,5/*708*/, /*->6338*/ // 2 children in Scope
/*  5630*/   OPC_CheckChild1TypeI32,
/*  5631*/   OPC_CheckPredicate, 9, // Predicate_unindexedload
/*  5633*/   OPC_Scope, 37, /*->5672*/ // 16 children in Scope
/*  5635*/    OPC_CheckPredicate7,  // Predicate_load
/*  5636*/    OPC_SwitchType /*2 cases */, 15, MVT::i32,// ->5654
/*  5639*/     OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64())
/*  5640*/     OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #2 #3
/*  5642*/     OPC_EmitMergeInputChains1_0,
/*  5643*/     OPC_EmitInteger32, 0, 
/*  5645*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::i32, 3/*#Ops*/, 4, 2, 3, 
               // Src: (ld:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_load>> - Complexity = 13
               // Dst: (LOAD_I32_A32:{ *:[i32] } 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr)
/*  5654*/    /*SwitchType*/ 15, MVT::i64,// ->5671
/*  5656*/     OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64())
/*  5657*/     OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #2 #3
/*  5659*/     OPC_EmitMergeInputChains1_0,
/*  5660*/     OPC_EmitInteger32, 0, 
/*  5662*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::i64, 3/*#Ops*/, 4, 2, 3, 
               // Src: (ld:{ *:[i64] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_load>> - Complexity = 13
               // Dst: (LOAD_I64_A32:{ *:[i64] } 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr)
/*  5671*/    0, // EndSwitchType
/*  5672*/   /*Scope*/ 97, /*->5770*/
/*  5673*/    OPC_CheckPredicate, 12, // Predicate_sextload
/*  5675*/    OPC_SwitchType /*2 cases */, 36, MVT::i32,// ->5714
/*  5678*/     OPC_Scope, 16, /*->5696*/ // 2 children in Scope
/*  5680*/      OPC_CheckPredicate1,  // Predicate_sextloadi8
/*  5681*/      OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64())
/*  5682*/      OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #2 #3
/*  5684*/      OPC_EmitMergeInputChains1_0,
/*  5685*/      OPC_EmitInteger32, 0, 
/*  5687*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD8_S_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i32, 3/*#Ops*/, 4, 2, 3, 
                // Src: (ld:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi8>> - Complexity = 13
                // Dst: (LOAD8_S_I32_A32:{ *:[i32] } 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr)
/*  5696*/     /*Scope*/ 16, /*->5713*/
/*  5697*/      OPC_CheckPredicate2,  // Predicate_sextloadi16
/*  5698*/      OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64())
/*  5699*/      OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #2 #3
/*  5701*/      OPC_EmitMergeInputChains1_0,
/*  5702*/      OPC_EmitInteger32, 0, 
/*  5704*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD16_S_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i32, 3/*#Ops*/, 4, 2, 3, 
                // Src: (ld:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi16>> - Complexity = 13
                // Dst: (LOAD16_S_I32_A32:{ *:[i32] } 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr)
/*  5713*/     0, /*End of Scope*/
/*  5714*/    /*SwitchType*/ 53, MVT::i64,// ->5769
/*  5716*/     OPC_Scope, 16, /*->5734*/ // 3 children in Scope
/*  5718*/      OPC_CheckPredicate1,  // Predicate_sextloadi8
/*  5719*/      OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64())
/*  5720*/      OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #2 #3
/*  5722*/      OPC_EmitMergeInputChains1_0,
/*  5723*/      OPC_EmitInteger32, 0, 
/*  5725*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD8_S_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 3/*#Ops*/, 4, 2, 3, 
                // Src: (ld:{ *:[i64] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi8>> - Complexity = 13
                // Dst: (LOAD8_S_I64_A32:{ *:[i64] } 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr)
/*  5734*/     /*Scope*/ 16, /*->5751*/
/*  5735*/      OPC_CheckPredicate2,  // Predicate_sextloadi16
/*  5736*/      OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64())
/*  5737*/      OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #2 #3
/*  5739*/      OPC_EmitMergeInputChains1_0,
/*  5740*/      OPC_EmitInteger32, 0, 
/*  5742*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD16_S_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 3/*#Ops*/, 4, 2, 3, 
                // Src: (ld:{ *:[i64] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi16>> - Complexity = 13
                // Dst: (LOAD16_S_I64_A32:{ *:[i64] } 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr)
/*  5751*/     /*Scope*/ 16, /*->5768*/
/*  5752*/      OPC_CheckPredicate3,  // Predicate_sextloadi32
/*  5753*/      OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64())
/*  5754*/      OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #2 #3
/*  5756*/      OPC_EmitMergeInputChains1_0,
/*  5757*/      OPC_EmitInteger32, 0, 
/*  5759*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD32_S_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 3/*#Ops*/, 4, 2, 3, 
                // Src: (ld:{ *:[i64] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi32>> - Complexity = 13
                // Dst: (LOAD32_S_I64_A32:{ *:[i64] } 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr)
/*  5768*/     0, /*End of Scope*/
/*  5769*/    0, // EndSwitchType
/*  5770*/   /*Scope*/ 97, /*->5868*/
/*  5771*/    OPC_CheckPredicate, 13, // Predicate_zextload
/*  5773*/    OPC_SwitchType /*2 cases */, 36, MVT::i32,// ->5812
/*  5776*/     OPC_Scope, 16, /*->5794*/ // 2 children in Scope
/*  5778*/      OPC_CheckPredicate1,  // Predicate_zextloadi8
/*  5779*/      OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64())
/*  5780*/      OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #2 #3
/*  5782*/      OPC_EmitMergeInputChains1_0,
/*  5783*/      OPC_EmitInteger32, 0, 
/*  5785*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD8_U_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i32, 3/*#Ops*/, 4, 2, 3, 
                // Src: (ld:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>> - Complexity = 13
                // Dst: (LOAD8_U_I32_A32:{ *:[i32] } 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr)
/*  5794*/     /*Scope*/ 16, /*->5811*/
/*  5795*/      OPC_CheckPredicate2,  // Predicate_zextloadi16
/*  5796*/      OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64())
/*  5797*/      OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #2 #3
/*  5799*/      OPC_EmitMergeInputChains1_0,
/*  5800*/      OPC_EmitInteger32, 0, 
/*  5802*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD16_U_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i32, 3/*#Ops*/, 4, 2, 3, 
                // Src: (ld:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi16>> - Complexity = 13
                // Dst: (LOAD16_U_I32_A32:{ *:[i32] } 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr)
/*  5811*/     0, /*End of Scope*/
/*  5812*/    /*SwitchType*/ 53, MVT::i64,// ->5867
/*  5814*/     OPC_Scope, 16, /*->5832*/ // 3 children in Scope
/*  5816*/      OPC_CheckPredicate1,  // Predicate_zextloadi8
/*  5817*/      OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64())
/*  5818*/      OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #2 #3
/*  5820*/      OPC_EmitMergeInputChains1_0,
/*  5821*/      OPC_EmitInteger32, 0, 
/*  5823*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD8_U_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 3/*#Ops*/, 4, 2, 3, 
                // Src: (ld:{ *:[i64] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>> - Complexity = 13
                // Dst: (LOAD8_U_I64_A32:{ *:[i64] } 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr)
/*  5832*/     /*Scope*/ 16, /*->5849*/
/*  5833*/      OPC_CheckPredicate2,  // Predicate_zextloadi16
/*  5834*/      OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64())
/*  5835*/      OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #2 #3
/*  5837*/      OPC_EmitMergeInputChains1_0,
/*  5838*/      OPC_EmitInteger32, 0, 
/*  5840*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD16_U_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 3/*#Ops*/, 4, 2, 3, 
                // Src: (ld:{ *:[i64] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi16>> - Complexity = 13
                // Dst: (LOAD16_U_I64_A32:{ *:[i64] } 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr)
/*  5849*/     /*Scope*/ 16, /*->5866*/
/*  5850*/      OPC_CheckPredicate3,  // Predicate_zextloadi32
/*  5851*/      OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64())
/*  5852*/      OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #2 #3
/*  5854*/      OPC_EmitMergeInputChains1_0,
/*  5855*/      OPC_EmitInteger32, 0, 
/*  5857*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD32_U_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 3/*#Ops*/, 4, 2, 3, 
                // Src: (ld:{ *:[i64] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi32>> - Complexity = 13
                // Dst: (LOAD32_U_I64_A32:{ *:[i64] } 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr)
/*  5866*/     0, /*End of Scope*/
/*  5867*/    0, // EndSwitchType
/*  5868*/   /*Scope*/ 97, /*->5966*/
/*  5869*/    OPC_CheckPredicate, 10, // Predicate_extload
/*  5871*/    OPC_SwitchType /*2 cases */, 36, MVT::i32,// ->5910
/*  5874*/     OPC_Scope, 16, /*->5892*/ // 2 children in Scope
/*  5876*/      OPC_CheckPredicate1,  // Predicate_extloadi8
/*  5877*/      OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64())
/*  5878*/      OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #2 #3
/*  5880*/      OPC_EmitMergeInputChains1_0,
/*  5881*/      OPC_EmitInteger32, 0, 
/*  5883*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD8_U_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i32, 3/*#Ops*/, 4, 2, 3, 
                // Src: (ld:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>> - Complexity = 13
                // Dst: (LOAD8_U_I32_A32:{ *:[i32] } 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr)
/*  5892*/     /*Scope*/ 16, /*->5909*/
/*  5893*/      OPC_CheckPredicate2,  // Predicate_extloadi16
/*  5894*/      OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64())
/*  5895*/      OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #2 #3
/*  5897*/      OPC_EmitMergeInputChains1_0,
/*  5898*/      OPC_EmitInteger32, 0, 
/*  5900*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD16_U_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i32, 3/*#Ops*/, 4, 2, 3, 
                // Src: (ld:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>> - Complexity = 13
                // Dst: (LOAD16_U_I32_A32:{ *:[i32] } 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr)
/*  5909*/     0, /*End of Scope*/
/*  5910*/    /*SwitchType*/ 53, MVT::i64,// ->5965
/*  5912*/     OPC_Scope, 16, /*->5930*/ // 3 children in Scope
/*  5914*/      OPC_CheckPredicate1,  // Predicate_extloadi8
/*  5915*/      OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64())
/*  5916*/      OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #2 #3
/*  5918*/      OPC_EmitMergeInputChains1_0,
/*  5919*/      OPC_EmitInteger32, 0, 
/*  5921*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD8_U_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 3/*#Ops*/, 4, 2, 3, 
                // Src: (ld:{ *:[i64] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>> - Complexity = 13
                // Dst: (LOAD8_U_I64_A32:{ *:[i64] } 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr)
/*  5930*/     /*Scope*/ 16, /*->5947*/
/*  5931*/      OPC_CheckPredicate2,  // Predicate_extloadi16
/*  5932*/      OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64())
/*  5933*/      OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #2 #3
/*  5935*/      OPC_EmitMergeInputChains1_0,
/*  5936*/      OPC_EmitInteger32, 0, 
/*  5938*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD16_U_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 3/*#Ops*/, 4, 2, 3, 
                // Src: (ld:{ *:[i64] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>> - Complexity = 13
                // Dst: (LOAD16_U_I64_A32:{ *:[i64] } 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr)
/*  5947*/     /*Scope*/ 16, /*->5964*/
/*  5948*/      OPC_CheckPredicate3,  // Predicate_extloadi32
/*  5949*/      OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64())
/*  5950*/      OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #2 #3
/*  5952*/      OPC_EmitMergeInputChains1_0,
/*  5953*/      OPC_EmitInteger32, 0, 
/*  5955*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD32_U_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 3/*#Ops*/, 4, 2, 3, 
                // Src: (ld:{ *:[i64] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi32>> - Complexity = 13
                // Dst: (LOAD32_U_I64_A32:{ *:[i64] } 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr)
/*  5964*/     0, /*End of Scope*/
/*  5965*/    0, // EndSwitchType
/*  5966*/   /*Scope*/ 105, /*->6072*/
/*  5967*/    OPC_CheckPredicate7,  // Predicate_load
/*  5968*/    OPC_SwitchType /*6 cases */, 15, MVT::f32,// ->5986
/*  5971*/     OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64())
/*  5972*/     OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #2 #3
/*  5974*/     OPC_EmitMergeInputChains1_0,
/*  5975*/     OPC_EmitInteger32, 0, 
/*  5977*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_F32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::f32, 3/*#Ops*/, 4, 2, 3, 
               // Src: (ld:{ *:[f32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_load>> - Complexity = 13
               // Dst: (LOAD_F32_A32:{ *:[f32] } 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr)
/*  5986*/    /*SwitchType*/ 15, MVT::f64,// ->6003
/*  5988*/     OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64())
/*  5989*/     OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #2 #3
/*  5991*/     OPC_EmitMergeInputChains1_0,
/*  5992*/     OPC_EmitInteger32, 0, 
/*  5994*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_F64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::f64, 3/*#Ops*/, 4, 2, 3, 
               // Src: (ld:{ *:[f64] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_load>> - Complexity = 13
               // Dst: (LOAD_F64_A32:{ *:[f64] } 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr)
/*  6003*/    /*SwitchType*/ 15, MVT::v16i8,// ->6020
/*  6005*/     OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64())
/*  6006*/     OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #2 #3
/*  6008*/     OPC_EmitMergeInputChains1_0,
/*  6009*/     OPC_EmitInteger32, 0, 
/*  6011*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_V128_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::v16i8, 3/*#Ops*/, 4, 2, 3, 
               // Src: (ld:{ *:[v16i8] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_load>> - Complexity = 13
               // Dst: (LOAD_V128_A32:{ *:[v16i8] } 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr)
/*  6020*/    /*SwitchType*/ 15, MVT::v8i16,// ->6037
/*  6022*/     OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64())
/*  6023*/     OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #2 #3
/*  6025*/     OPC_EmitMergeInputChains1_0,
/*  6026*/     OPC_EmitInteger32, 0, 
/*  6028*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_V128_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::v8i16, 3/*#Ops*/, 4, 2, 3, 
               // Src: (ld:{ *:[v8i16] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_load>> - Complexity = 13
               // Dst: (LOAD_V128_A32:{ *:[v8i16] } 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr)
/*  6037*/    /*SwitchType*/ 15, MVT::v4i32,// ->6054
/*  6039*/     OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64())
/*  6040*/     OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #2 #3
/*  6042*/     OPC_EmitMergeInputChains1_0,
/*  6043*/     OPC_EmitInteger32, 0, 
/*  6045*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_V128_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::v4i32, 3/*#Ops*/, 4, 2, 3, 
               // Src: (ld:{ *:[v4i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_load>> - Complexity = 13
               // Dst: (LOAD_V128_A32:{ *:[v4i32] } 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr)
/*  6054*/    /*SwitchType*/ 15, MVT::v2i64,// ->6071
/*  6056*/     OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64())
/*  6057*/     OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #2 #3
/*  6059*/     OPC_EmitMergeInputChains1_0,
/*  6060*/     OPC_EmitInteger32, 0, 
/*  6062*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_V128_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::v2i64, 3/*#Ops*/, 4, 2, 3, 
               // Src: (ld:{ *:[v2i64] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_load>> - Complexity = 13
               // Dst: (LOAD_V128_A32:{ *:[v2i64] } 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr)
/*  6071*/    0, // EndSwitchType
/*  6072*/   /*Scope*/ 21, /*->6094*/
/*  6073*/    OPC_CheckPredicate, 12, // Predicate_sextload
/*  6075*/    OPC_CheckPredicate, 21, // Predicate_sextloadvi8
/*  6077*/    OPC_CheckType, MVT::v8i16,
/*  6079*/    OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64())
/*  6080*/    OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #2 #3
/*  6082*/    OPC_EmitMergeInputChains1_0,
/*  6083*/    OPC_EmitInteger32, 0, 
/*  6085*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_EXTEND_S_I16x8_A32), 0|OPFL_Chain|OPFL_MemRefs,
                  MVT::v8i16, 3/*#Ops*/, 4, 2, 3, 
              // Src: (ld:{ *:[v8i16] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadvi8>> - Complexity = 13
              // Dst: (LOAD_EXTEND_S_I16x8_A32:{ *:[v8i16] } 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr)
/*  6094*/   /*Scope*/ 21, /*->6116*/
/*  6095*/    OPC_CheckPredicate, 13, // Predicate_zextload
/*  6097*/    OPC_CheckPredicate, 21, // Predicate_zextloadvi8
/*  6099*/    OPC_CheckType, MVT::v8i16,
/*  6101*/    OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64())
/*  6102*/    OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #2 #3
/*  6104*/    OPC_EmitMergeInputChains1_0,
/*  6105*/    OPC_EmitInteger32, 0, 
/*  6107*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_EXTEND_U_I16x8_A32), 0|OPFL_Chain|OPFL_MemRefs,
                  MVT::v8i16, 3/*#Ops*/, 4, 2, 3, 
              // Src: (ld:{ *:[v8i16] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadvi8>> - Complexity = 13
              // Dst: (LOAD_EXTEND_U_I16x8_A32:{ *:[v8i16] } 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr)
/*  6116*/   /*Scope*/ 21, /*->6138*/
/*  6117*/    OPC_CheckPredicate, 10, // Predicate_extload
/*  6119*/    OPC_CheckPredicate, 21, // Predicate_extloadvi8
/*  6121*/    OPC_CheckType, MVT::v8i16,
/*  6123*/    OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64())
/*  6124*/    OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #2 #3
/*  6126*/    OPC_EmitMergeInputChains1_0,
/*  6127*/    OPC_EmitInteger32, 0, 
/*  6129*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_EXTEND_U_I16x8_A32), 0|OPFL_Chain|OPFL_MemRefs,
                  MVT::v8i16, 3/*#Ops*/, 4, 2, 3, 
              // Src: (ld:{ *:[v8i16] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadvi8>> - Complexity = 13
              // Dst: (LOAD_EXTEND_U_I16x8_A32:{ *:[v8i16] } 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr)
/*  6138*/   /*Scope*/ 21, /*->6160*/
/*  6139*/    OPC_CheckPredicate, 12, // Predicate_sextload
/*  6141*/    OPC_CheckPredicate, 22, // Predicate_sextloadvi16
/*  6143*/    OPC_CheckType, MVT::v4i32,
/*  6145*/    OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64())
/*  6146*/    OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #2 #3
/*  6148*/    OPC_EmitMergeInputChains1_0,
/*  6149*/    OPC_EmitInteger32, 0, 
/*  6151*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_EXTEND_S_I32x4_A32), 0|OPFL_Chain|OPFL_MemRefs,
                  MVT::v4i32, 3/*#Ops*/, 4, 2, 3, 
              // Src: (ld:{ *:[v4i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadvi16>> - Complexity = 13
              // Dst: (LOAD_EXTEND_S_I32x4_A32:{ *:[v4i32] } 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr)
/*  6160*/   /*Scope*/ 21, /*->6182*/
/*  6161*/    OPC_CheckPredicate, 13, // Predicate_zextload
/*  6163*/    OPC_CheckPredicate, 22, // Predicate_zextloadvi16
/*  6165*/    OPC_CheckType, MVT::v4i32,
/*  6167*/    OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64())
/*  6168*/    OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #2 #3
/*  6170*/    OPC_EmitMergeInputChains1_0,
/*  6171*/    OPC_EmitInteger32, 0, 
/*  6173*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_EXTEND_U_I32x4_A32), 0|OPFL_Chain|OPFL_MemRefs,
                  MVT::v4i32, 3/*#Ops*/, 4, 2, 3, 
              // Src: (ld:{ *:[v4i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadvi16>> - Complexity = 13
              // Dst: (LOAD_EXTEND_U_I32x4_A32:{ *:[v4i32] } 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr)
/*  6182*/   /*Scope*/ 21, /*->6204*/
/*  6183*/    OPC_CheckPredicate, 10, // Predicate_extload
/*  6185*/    OPC_CheckPredicate, 22, // Predicate_extloadvi16
/*  6187*/    OPC_CheckType, MVT::v4i32,
/*  6189*/    OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64())
/*  6190*/    OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #2 #3
/*  6192*/    OPC_EmitMergeInputChains1_0,
/*  6193*/    OPC_EmitInteger32, 0, 
/*  6195*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_EXTEND_U_I32x4_A32), 0|OPFL_Chain|OPFL_MemRefs,
                  MVT::v4i32, 3/*#Ops*/, 4, 2, 3, 
              // Src: (ld:{ *:[v4i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadvi16>> - Complexity = 13
              // Dst: (LOAD_EXTEND_U_I32x4_A32:{ *:[v4i32] } 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr)
/*  6204*/   /*Scope*/ 21, /*->6226*/
/*  6205*/    OPC_CheckPredicate, 12, // Predicate_sextload
/*  6207*/    OPC_CheckPredicate, 23, // Predicate_sextloadvi32
/*  6209*/    OPC_CheckType, MVT::v2i64,
/*  6211*/    OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64())
/*  6212*/    OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #2 #3
/*  6214*/    OPC_EmitMergeInputChains1_0,
/*  6215*/    OPC_EmitInteger32, 0, 
/*  6217*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_EXTEND_S_I64x2_A32), 0|OPFL_Chain|OPFL_MemRefs,
                  MVT::v2i64, 3/*#Ops*/, 4, 2, 3, 
              // Src: (ld:{ *:[v2i64] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadvi32>> - Complexity = 13
              // Dst: (LOAD_EXTEND_S_I64x2_A32:{ *:[v2i64] } 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr)
/*  6226*/   /*Scope*/ 21, /*->6248*/
/*  6227*/    OPC_CheckPredicate, 13, // Predicate_zextload
/*  6229*/    OPC_CheckPredicate, 23, // Predicate_zextloadvi32
/*  6231*/    OPC_CheckType, MVT::v2i64,
/*  6233*/    OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64())
/*  6234*/    OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #2 #3
/*  6236*/    OPC_EmitMergeInputChains1_0,
/*  6237*/    OPC_EmitInteger32, 0, 
/*  6239*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_EXTEND_U_I64x2_A32), 0|OPFL_Chain|OPFL_MemRefs,
                  MVT::v2i64, 3/*#Ops*/, 4, 2, 3, 
              // Src: (ld:{ *:[v2i64] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadvi32>> - Complexity = 13
              // Dst: (LOAD_EXTEND_U_I64x2_A32:{ *:[v2i64] } 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr)
/*  6248*/   /*Scope*/ 21, /*->6270*/
/*  6249*/    OPC_CheckPredicate, 10, // Predicate_extload
/*  6251*/    OPC_CheckPredicate, 23, // Predicate_extloadvi32
/*  6253*/    OPC_CheckType, MVT::v2i64,
/*  6255*/    OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64())
/*  6256*/    OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #2 #3
/*  6258*/    OPC_EmitMergeInputChains1_0,
/*  6259*/    OPC_EmitInteger32, 0, 
/*  6261*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_EXTEND_U_I64x2_A32), 0|OPFL_Chain|OPFL_MemRefs,
                  MVT::v2i64, 3/*#Ops*/, 4, 2, 3, 
              // Src: (ld:{ *:[v2i64] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadvi32>> - Complexity = 13
              // Dst: (LOAD_EXTEND_U_I64x2_A32:{ *:[v2i64] } 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr)
/*  6270*/   /*Scope*/ 37, /*->6308*/
/*  6271*/    OPC_CheckPredicate7,  // Predicate_load
/*  6272*/    OPC_SwitchType /*2 cases */, 15, MVT::v4f32,// ->6290
/*  6275*/     OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64())
/*  6276*/     OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #2 #3
/*  6278*/     OPC_EmitMergeInputChains1_0,
/*  6279*/     OPC_EmitInteger32, 0, 
/*  6281*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_V128_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::v4f32, 3/*#Ops*/, 4, 2, 3, 
               // Src: (ld:{ *:[v4f32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_load>> - Complexity = 13
               // Dst: (LOAD_V128_A32:{ *:[v4f32] } 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr)
/*  6290*/    /*SwitchType*/ 15, MVT::v2f64,// ->6307
/*  6292*/     OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64())
/*  6293*/     OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #2 #3
/*  6295*/     OPC_EmitMergeInputChains1_0,
/*  6296*/     OPC_EmitInteger32, 0, 
/*  6298*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_V128_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::v2f64, 3/*#Ops*/, 4, 2, 3, 
               // Src: (ld:{ *:[v2f64] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_load>> - Complexity = 13
               // Dst: (LOAD_V128_A32:{ *:[v2f64] } 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr)
/*  6307*/    0, // EndSwitchType
/*  6308*/   /*Scope*/ 28, /*->6337*/
/*  6309*/    OPC_CheckPredicate, 10, // Predicate_extload
/*  6311*/    OPC_CheckType, MVT::v2f64,
/*  6313*/    OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64())
/*  6314*/    OPC_EmitMergeInputChains1_0,
/*  6315*/    OPC_EmitInteger32, 0, 
/*  6317*/    OPC_EmitInteger32, 0, 
/*  6319*/    OPC_EmitNode1, TARGET_VAL(WebAssembly::LOAD_ZERO_I64x2_A32), 0|OPFL_Chain|OPFL_MemRefs,
                  MVT::v16i8, 3/*#Ops*/, 2, 3, 1,  // Results = #4
/*  6328*/    OPC_EmitNode1None, TARGET_VAL(WebAssembly::promote_low_F64x2),
                  MVT::v2f64, 1/*#Ops*/, 4,  // Results = #5
/*  6334*/    OPC_CompleteMatch, 1, 5, 
               // Src: (ld:{ *:[v2f64] } I32:{ *:[i32] }:$addr)<<P:Predicate_unindexedload>><<P:Predicate_extload>> - Complexity = 4
               // Dst: (promote_low_F64x2:{ *:[v2f64] } (LOAD_ZERO_I64x2_A32:{ *:[v16i8] } 0:{ *:[i32] }, 0:{ *:[i32] }, I32:{ *:[i32] }:$addr))
/*  6337*/   0, /*End of Scope*/
/*  6338*/  /*Scope*/ 68|128,5/*708*/, /*->7048*/
/*  6340*/   OPC_CheckChild1TypeI64,
/*  6341*/   OPC_CheckPredicate, 9, // Predicate_unindexedload
/*  6343*/   OPC_Scope, 37, /*->6382*/ // 16 children in Scope
/*  6345*/    OPC_CheckPredicate7,  // Predicate_load
/*  6346*/    OPC_SwitchType /*2 cases */, 15, MVT::i32,// ->6364
/*  6349*/     OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64())
/*  6350*/     OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #2 #3
/*  6352*/     OPC_EmitMergeInputChains1_0,
/*  6353*/     OPC_EmitInteger32, 0, 
/*  6355*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::i32, 3/*#Ops*/, 4, 2, 3, 
               // Src: (ld:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_load>> - Complexity = 13
               // Dst: (LOAD_I32_A64:{ *:[i32] } 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr)
/*  6364*/    /*SwitchType*/ 15, MVT::i64,// ->6381
/*  6366*/     OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64())
/*  6367*/     OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #2 #3
/*  6369*/     OPC_EmitMergeInputChains1_0,
/*  6370*/     OPC_EmitInteger32, 0, 
/*  6372*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::i64, 3/*#Ops*/, 4, 2, 3, 
               // Src: (ld:{ *:[i64] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_load>> - Complexity = 13
               // Dst: (LOAD_I64_A64:{ *:[i64] } 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr)
/*  6381*/    0, // EndSwitchType
/*  6382*/   /*Scope*/ 97, /*->6480*/
/*  6383*/    OPC_CheckPredicate, 12, // Predicate_sextload
/*  6385*/    OPC_SwitchType /*2 cases */, 36, MVT::i32,// ->6424
/*  6388*/     OPC_Scope, 16, /*->6406*/ // 2 children in Scope
/*  6390*/      OPC_CheckPredicate1,  // Predicate_sextloadi8
/*  6391*/      OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64())
/*  6392*/      OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #2 #3
/*  6394*/      OPC_EmitMergeInputChains1_0,
/*  6395*/      OPC_EmitInteger32, 0, 
/*  6397*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD8_S_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i32, 3/*#Ops*/, 4, 2, 3, 
                // Src: (ld:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi8>> - Complexity = 13
                // Dst: (LOAD8_S_I32_A64:{ *:[i32] } 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr)
/*  6406*/     /*Scope*/ 16, /*->6423*/
/*  6407*/      OPC_CheckPredicate2,  // Predicate_sextloadi16
/*  6408*/      OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64())
/*  6409*/      OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #2 #3
/*  6411*/      OPC_EmitMergeInputChains1_0,
/*  6412*/      OPC_EmitInteger32, 0, 
/*  6414*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD16_S_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i32, 3/*#Ops*/, 4, 2, 3, 
                // Src: (ld:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi16>> - Complexity = 13
                // Dst: (LOAD16_S_I32_A64:{ *:[i32] } 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr)
/*  6423*/     0, /*End of Scope*/
/*  6424*/    /*SwitchType*/ 53, MVT::i64,// ->6479
/*  6426*/     OPC_Scope, 16, /*->6444*/ // 3 children in Scope
/*  6428*/      OPC_CheckPredicate1,  // Predicate_sextloadi8
/*  6429*/      OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64())
/*  6430*/      OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #2 #3
/*  6432*/      OPC_EmitMergeInputChains1_0,
/*  6433*/      OPC_EmitInteger32, 0, 
/*  6435*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD8_S_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 3/*#Ops*/, 4, 2, 3, 
                // Src: (ld:{ *:[i64] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi8>> - Complexity = 13
                // Dst: (LOAD8_S_I64_A64:{ *:[i64] } 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr)
/*  6444*/     /*Scope*/ 16, /*->6461*/
/*  6445*/      OPC_CheckPredicate2,  // Predicate_sextloadi16
/*  6446*/      OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64())
/*  6447*/      OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #2 #3
/*  6449*/      OPC_EmitMergeInputChains1_0,
/*  6450*/      OPC_EmitInteger32, 0, 
/*  6452*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD16_S_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 3/*#Ops*/, 4, 2, 3, 
                // Src: (ld:{ *:[i64] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi16>> - Complexity = 13
                // Dst: (LOAD16_S_I64_A64:{ *:[i64] } 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr)
/*  6461*/     /*Scope*/ 16, /*->6478*/
/*  6462*/      OPC_CheckPredicate3,  // Predicate_sextloadi32
/*  6463*/      OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64())
/*  6464*/      OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #2 #3
/*  6466*/      OPC_EmitMergeInputChains1_0,
/*  6467*/      OPC_EmitInteger32, 0, 
/*  6469*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD32_S_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 3/*#Ops*/, 4, 2, 3, 
                // Src: (ld:{ *:[i64] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi32>> - Complexity = 13
                // Dst: (LOAD32_S_I64_A64:{ *:[i64] } 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr)
/*  6478*/     0, /*End of Scope*/
/*  6479*/    0, // EndSwitchType
/*  6480*/   /*Scope*/ 97, /*->6578*/
/*  6481*/    OPC_CheckPredicate, 13, // Predicate_zextload
/*  6483*/    OPC_SwitchType /*2 cases */, 36, MVT::i32,// ->6522
/*  6486*/     OPC_Scope, 16, /*->6504*/ // 2 children in Scope
/*  6488*/      OPC_CheckPredicate1,  // Predicate_zextloadi8
/*  6489*/      OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64())
/*  6490*/      OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #2 #3
/*  6492*/      OPC_EmitMergeInputChains1_0,
/*  6493*/      OPC_EmitInteger32, 0, 
/*  6495*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD8_U_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i32, 3/*#Ops*/, 4, 2, 3, 
                // Src: (ld:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>> - Complexity = 13
                // Dst: (LOAD8_U_I32_A64:{ *:[i32] } 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr)
/*  6504*/     /*Scope*/ 16, /*->6521*/
/*  6505*/      OPC_CheckPredicate2,  // Predicate_zextloadi16
/*  6506*/      OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64())
/*  6507*/      OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #2 #3
/*  6509*/      OPC_EmitMergeInputChains1_0,
/*  6510*/      OPC_EmitInteger32, 0, 
/*  6512*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD16_U_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i32, 3/*#Ops*/, 4, 2, 3, 
                // Src: (ld:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi16>> - Complexity = 13
                // Dst: (LOAD16_U_I32_A64:{ *:[i32] } 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr)
/*  6521*/     0, /*End of Scope*/
/*  6522*/    /*SwitchType*/ 53, MVT::i64,// ->6577
/*  6524*/     OPC_Scope, 16, /*->6542*/ // 3 children in Scope
/*  6526*/      OPC_CheckPredicate1,  // Predicate_zextloadi8
/*  6527*/      OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64())
/*  6528*/      OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #2 #3
/*  6530*/      OPC_EmitMergeInputChains1_0,
/*  6531*/      OPC_EmitInteger32, 0, 
/*  6533*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD8_U_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 3/*#Ops*/, 4, 2, 3, 
                // Src: (ld:{ *:[i64] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>> - Complexity = 13
                // Dst: (LOAD8_U_I64_A64:{ *:[i64] } 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr)
/*  6542*/     /*Scope*/ 16, /*->6559*/
/*  6543*/      OPC_CheckPredicate2,  // Predicate_zextloadi16
/*  6544*/      OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64())
/*  6545*/      OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #2 #3
/*  6547*/      OPC_EmitMergeInputChains1_0,
/*  6548*/      OPC_EmitInteger32, 0, 
/*  6550*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD16_U_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 3/*#Ops*/, 4, 2, 3, 
                // Src: (ld:{ *:[i64] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi16>> - Complexity = 13
                // Dst: (LOAD16_U_I64_A64:{ *:[i64] } 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr)
/*  6559*/     /*Scope*/ 16, /*->6576*/
/*  6560*/      OPC_CheckPredicate3,  // Predicate_zextloadi32
/*  6561*/      OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64())
/*  6562*/      OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #2 #3
/*  6564*/      OPC_EmitMergeInputChains1_0,
/*  6565*/      OPC_EmitInteger32, 0, 
/*  6567*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD32_U_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 3/*#Ops*/, 4, 2, 3, 
                // Src: (ld:{ *:[i64] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi32>> - Complexity = 13
                // Dst: (LOAD32_U_I64_A64:{ *:[i64] } 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr)
/*  6576*/     0, /*End of Scope*/
/*  6577*/    0, // EndSwitchType
/*  6578*/   /*Scope*/ 97, /*->6676*/
/*  6579*/    OPC_CheckPredicate, 10, // Predicate_extload
/*  6581*/    OPC_SwitchType /*2 cases */, 36, MVT::i32,// ->6620
/*  6584*/     OPC_Scope, 16, /*->6602*/ // 2 children in Scope
/*  6586*/      OPC_CheckPredicate1,  // Predicate_extloadi8
/*  6587*/      OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64())
/*  6588*/      OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #2 #3
/*  6590*/      OPC_EmitMergeInputChains1_0,
/*  6591*/      OPC_EmitInteger32, 0, 
/*  6593*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD8_U_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i32, 3/*#Ops*/, 4, 2, 3, 
                // Src: (ld:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>> - Complexity = 13
                // Dst: (LOAD8_U_I32_A64:{ *:[i32] } 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr)
/*  6602*/     /*Scope*/ 16, /*->6619*/
/*  6603*/      OPC_CheckPredicate2,  // Predicate_extloadi16
/*  6604*/      OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64())
/*  6605*/      OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #2 #3
/*  6607*/      OPC_EmitMergeInputChains1_0,
/*  6608*/      OPC_EmitInteger32, 0, 
/*  6610*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD16_U_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i32, 3/*#Ops*/, 4, 2, 3, 
                // Src: (ld:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>> - Complexity = 13
                // Dst: (LOAD16_U_I32_A64:{ *:[i32] } 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr)
/*  6619*/     0, /*End of Scope*/
/*  6620*/    /*SwitchType*/ 53, MVT::i64,// ->6675
/*  6622*/     OPC_Scope, 16, /*->6640*/ // 3 children in Scope
/*  6624*/      OPC_CheckPredicate1,  // Predicate_extloadi8
/*  6625*/      OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64())
/*  6626*/      OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #2 #3
/*  6628*/      OPC_EmitMergeInputChains1_0,
/*  6629*/      OPC_EmitInteger32, 0, 
/*  6631*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD8_U_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 3/*#Ops*/, 4, 2, 3, 
                // Src: (ld:{ *:[i64] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>> - Complexity = 13
                // Dst: (LOAD8_U_I64_A64:{ *:[i64] } 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr)
/*  6640*/     /*Scope*/ 16, /*->6657*/
/*  6641*/      OPC_CheckPredicate2,  // Predicate_extloadi16
/*  6642*/      OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64())
/*  6643*/      OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #2 #3
/*  6645*/      OPC_EmitMergeInputChains1_0,
/*  6646*/      OPC_EmitInteger32, 0, 
/*  6648*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD16_U_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 3/*#Ops*/, 4, 2, 3, 
                // Src: (ld:{ *:[i64] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>> - Complexity = 13
                // Dst: (LOAD16_U_I64_A64:{ *:[i64] } 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr)
/*  6657*/     /*Scope*/ 16, /*->6674*/
/*  6658*/      OPC_CheckPredicate3,  // Predicate_extloadi32
/*  6659*/      OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64())
/*  6660*/      OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #2 #3
/*  6662*/      OPC_EmitMergeInputChains1_0,
/*  6663*/      OPC_EmitInteger32, 0, 
/*  6665*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD32_U_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 3/*#Ops*/, 4, 2, 3, 
                // Src: (ld:{ *:[i64] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi32>> - Complexity = 13
                // Dst: (LOAD32_U_I64_A64:{ *:[i64] } 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr)
/*  6674*/     0, /*End of Scope*/
/*  6675*/    0, // EndSwitchType
/*  6676*/   /*Scope*/ 105, /*->6782*/
/*  6677*/    OPC_CheckPredicate7,  // Predicate_load
/*  6678*/    OPC_SwitchType /*6 cases */, 15, MVT::f32,// ->6696
/*  6681*/     OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64())
/*  6682*/     OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #2 #3
/*  6684*/     OPC_EmitMergeInputChains1_0,
/*  6685*/     OPC_EmitInteger32, 0, 
/*  6687*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_F32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::f32, 3/*#Ops*/, 4, 2, 3, 
               // Src: (ld:{ *:[f32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_load>> - Complexity = 13
               // Dst: (LOAD_F32_A64:{ *:[f32] } 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr)
/*  6696*/    /*SwitchType*/ 15, MVT::f64,// ->6713
/*  6698*/     OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64())
/*  6699*/     OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #2 #3
/*  6701*/     OPC_EmitMergeInputChains1_0,
/*  6702*/     OPC_EmitInteger32, 0, 
/*  6704*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_F64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::f64, 3/*#Ops*/, 4, 2, 3, 
               // Src: (ld:{ *:[f64] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_load>> - Complexity = 13
               // Dst: (LOAD_F64_A64:{ *:[f64] } 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr)
/*  6713*/    /*SwitchType*/ 15, MVT::v16i8,// ->6730
/*  6715*/     OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64())
/*  6716*/     OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #2 #3
/*  6718*/     OPC_EmitMergeInputChains1_0,
/*  6719*/     OPC_EmitInteger32, 0, 
/*  6721*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_V128_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::v16i8, 3/*#Ops*/, 4, 2, 3, 
               // Src: (ld:{ *:[v16i8] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_load>> - Complexity = 13
               // Dst: (LOAD_V128_A64:{ *:[v16i8] } 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr)
/*  6730*/    /*SwitchType*/ 15, MVT::v8i16,// ->6747
/*  6732*/     OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64())
/*  6733*/     OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #2 #3
/*  6735*/     OPC_EmitMergeInputChains1_0,
/*  6736*/     OPC_EmitInteger32, 0, 
/*  6738*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_V128_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::v8i16, 3/*#Ops*/, 4, 2, 3, 
               // Src: (ld:{ *:[v8i16] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_load>> - Complexity = 13
               // Dst: (LOAD_V128_A64:{ *:[v8i16] } 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr)
/*  6747*/    /*SwitchType*/ 15, MVT::v4i32,// ->6764
/*  6749*/     OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64())
/*  6750*/     OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #2 #3
/*  6752*/     OPC_EmitMergeInputChains1_0,
/*  6753*/     OPC_EmitInteger32, 0, 
/*  6755*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_V128_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::v4i32, 3/*#Ops*/, 4, 2, 3, 
               // Src: (ld:{ *:[v4i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_load>> - Complexity = 13
               // Dst: (LOAD_V128_A64:{ *:[v4i32] } 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr)
/*  6764*/    /*SwitchType*/ 15, MVT::v2i64,// ->6781
/*  6766*/     OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64())
/*  6767*/     OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #2 #3
/*  6769*/     OPC_EmitMergeInputChains1_0,
/*  6770*/     OPC_EmitInteger32, 0, 
/*  6772*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_V128_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::v2i64, 3/*#Ops*/, 4, 2, 3, 
               // Src: (ld:{ *:[v2i64] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_load>> - Complexity = 13
               // Dst: (LOAD_V128_A64:{ *:[v2i64] } 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr)
/*  6781*/    0, // EndSwitchType
/*  6782*/   /*Scope*/ 21, /*->6804*/
/*  6783*/    OPC_CheckPredicate, 12, // Predicate_sextload
/*  6785*/    OPC_CheckPredicate, 21, // Predicate_sextloadvi8
/*  6787*/    OPC_CheckType, MVT::v8i16,
/*  6789*/    OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64())
/*  6790*/    OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #2 #3
/*  6792*/    OPC_EmitMergeInputChains1_0,
/*  6793*/    OPC_EmitInteger32, 0, 
/*  6795*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_EXTEND_S_I16x8_A64), 0|OPFL_Chain|OPFL_MemRefs,
                  MVT::v8i16, 3/*#Ops*/, 4, 2, 3, 
              // Src: (ld:{ *:[v8i16] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadvi8>> - Complexity = 13
              // Dst: (LOAD_EXTEND_S_I16x8_A64:{ *:[v8i16] } 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr)
/*  6804*/   /*Scope*/ 21, /*->6826*/
/*  6805*/    OPC_CheckPredicate, 13, // Predicate_zextload
/*  6807*/    OPC_CheckPredicate, 21, // Predicate_zextloadvi8
/*  6809*/    OPC_CheckType, MVT::v8i16,
/*  6811*/    OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64())
/*  6812*/    OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #2 #3
/*  6814*/    OPC_EmitMergeInputChains1_0,
/*  6815*/    OPC_EmitInteger32, 0, 
/*  6817*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_EXTEND_U_I16x8_A64), 0|OPFL_Chain|OPFL_MemRefs,
                  MVT::v8i16, 3/*#Ops*/, 4, 2, 3, 
              // Src: (ld:{ *:[v8i16] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadvi8>> - Complexity = 13
              // Dst: (LOAD_EXTEND_U_I16x8_A64:{ *:[v8i16] } 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr)
/*  6826*/   /*Scope*/ 21, /*->6848*/
/*  6827*/    OPC_CheckPredicate, 10, // Predicate_extload
/*  6829*/    OPC_CheckPredicate, 21, // Predicate_extloadvi8
/*  6831*/    OPC_CheckType, MVT::v8i16,
/*  6833*/    OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64())
/*  6834*/    OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #2 #3
/*  6836*/    OPC_EmitMergeInputChains1_0,
/*  6837*/    OPC_EmitInteger32, 0, 
/*  6839*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_EXTEND_U_I16x8_A64), 0|OPFL_Chain|OPFL_MemRefs,
                  MVT::v8i16, 3/*#Ops*/, 4, 2, 3, 
              // Src: (ld:{ *:[v8i16] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadvi8>> - Complexity = 13
              // Dst: (LOAD_EXTEND_U_I16x8_A64:{ *:[v8i16] } 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr)
/*  6848*/   /*Scope*/ 21, /*->6870*/
/*  6849*/    OPC_CheckPredicate, 12, // Predicate_sextload
/*  6851*/    OPC_CheckPredicate, 22, // Predicate_sextloadvi16
/*  6853*/    OPC_CheckType, MVT::v4i32,
/*  6855*/    OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64())
/*  6856*/    OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #2 #3
/*  6858*/    OPC_EmitMergeInputChains1_0,
/*  6859*/    OPC_EmitInteger32, 0, 
/*  6861*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_EXTEND_S_I32x4_A64), 0|OPFL_Chain|OPFL_MemRefs,
                  MVT::v4i32, 3/*#Ops*/, 4, 2, 3, 
              // Src: (ld:{ *:[v4i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadvi16>> - Complexity = 13
              // Dst: (LOAD_EXTEND_S_I32x4_A64:{ *:[v4i32] } 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr)
/*  6870*/   /*Scope*/ 21, /*->6892*/
/*  6871*/    OPC_CheckPredicate, 13, // Predicate_zextload
/*  6873*/    OPC_CheckPredicate, 22, // Predicate_zextloadvi16
/*  6875*/    OPC_CheckType, MVT::v4i32,
/*  6877*/    OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64())
/*  6878*/    OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #2 #3
/*  6880*/    OPC_EmitMergeInputChains1_0,
/*  6881*/    OPC_EmitInteger32, 0, 
/*  6883*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_EXTEND_U_I32x4_A64), 0|OPFL_Chain|OPFL_MemRefs,
                  MVT::v4i32, 3/*#Ops*/, 4, 2, 3, 
              // Src: (ld:{ *:[v4i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadvi16>> - Complexity = 13
              // Dst: (LOAD_EXTEND_U_I32x4_A64:{ *:[v4i32] } 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr)
/*  6892*/   /*Scope*/ 21, /*->6914*/
/*  6893*/    OPC_CheckPredicate, 10, // Predicate_extload
/*  6895*/    OPC_CheckPredicate, 22, // Predicate_extloadvi16
/*  6897*/    OPC_CheckType, MVT::v4i32,
/*  6899*/    OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64())
/*  6900*/    OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #2 #3
/*  6902*/    OPC_EmitMergeInputChains1_0,
/*  6903*/    OPC_EmitInteger32, 0, 
/*  6905*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_EXTEND_U_I32x4_A64), 0|OPFL_Chain|OPFL_MemRefs,
                  MVT::v4i32, 3/*#Ops*/, 4, 2, 3, 
              // Src: (ld:{ *:[v4i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadvi16>> - Complexity = 13
              // Dst: (LOAD_EXTEND_U_I32x4_A64:{ *:[v4i32] } 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr)
/*  6914*/   /*Scope*/ 21, /*->6936*/
/*  6915*/    OPC_CheckPredicate, 12, // Predicate_sextload
/*  6917*/    OPC_CheckPredicate, 23, // Predicate_sextloadvi32
/*  6919*/    OPC_CheckType, MVT::v2i64,
/*  6921*/    OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64())
/*  6922*/    OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #2 #3
/*  6924*/    OPC_EmitMergeInputChains1_0,
/*  6925*/    OPC_EmitInteger32, 0, 
/*  6927*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_EXTEND_S_I64x2_A64), 0|OPFL_Chain|OPFL_MemRefs,
                  MVT::v2i64, 3/*#Ops*/, 4, 2, 3, 
              // Src: (ld:{ *:[v2i64] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadvi32>> - Complexity = 13
              // Dst: (LOAD_EXTEND_S_I64x2_A64:{ *:[v2i64] } 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr)
/*  6936*/   /*Scope*/ 21, /*->6958*/
/*  6937*/    OPC_CheckPredicate, 13, // Predicate_zextload
/*  6939*/    OPC_CheckPredicate, 23, // Predicate_zextloadvi32
/*  6941*/    OPC_CheckType, MVT::v2i64,
/*  6943*/    OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64())
/*  6944*/    OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #2 #3
/*  6946*/    OPC_EmitMergeInputChains1_0,
/*  6947*/    OPC_EmitInteger32, 0, 
/*  6949*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_EXTEND_U_I64x2_A64), 0|OPFL_Chain|OPFL_MemRefs,
                  MVT::v2i64, 3/*#Ops*/, 4, 2, 3, 
              // Src: (ld:{ *:[v2i64] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadvi32>> - Complexity = 13
              // Dst: (LOAD_EXTEND_U_I64x2_A64:{ *:[v2i64] } 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr)
/*  6958*/   /*Scope*/ 21, /*->6980*/
/*  6959*/    OPC_CheckPredicate, 10, // Predicate_extload
/*  6961*/    OPC_CheckPredicate, 23, // Predicate_extloadvi32
/*  6963*/    OPC_CheckType, MVT::v2i64,
/*  6965*/    OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64())
/*  6966*/    OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #2 #3
/*  6968*/    OPC_EmitMergeInputChains1_0,
/*  6969*/    OPC_EmitInteger32, 0, 
/*  6971*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_EXTEND_U_I64x2_A64), 0|OPFL_Chain|OPFL_MemRefs,
                  MVT::v2i64, 3/*#Ops*/, 4, 2, 3, 
              // Src: (ld:{ *:[v2i64] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadvi32>> - Complexity = 13
              // Dst: (LOAD_EXTEND_U_I64x2_A64:{ *:[v2i64] } 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr)
/*  6980*/   /*Scope*/ 37, /*->7018*/
/*  6981*/    OPC_CheckPredicate7,  // Predicate_load
/*  6982*/    OPC_SwitchType /*2 cases */, 15, MVT::v4f32,// ->7000
/*  6985*/     OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64())
/*  6986*/     OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #2 #3
/*  6988*/     OPC_EmitMergeInputChains1_0,
/*  6989*/     OPC_EmitInteger32, 0, 
/*  6991*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_V128_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::v4f32, 3/*#Ops*/, 4, 2, 3, 
               // Src: (ld:{ *:[v4f32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_load>> - Complexity = 13
               // Dst: (LOAD_V128_A64:{ *:[v4f32] } 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr)
/*  7000*/    /*SwitchType*/ 15, MVT::v2f64,// ->7017
/*  7002*/     OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64())
/*  7003*/     OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #2 #3
/*  7005*/     OPC_EmitMergeInputChains1_0,
/*  7006*/     OPC_EmitInteger32, 0, 
/*  7008*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_V128_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::v2f64, 3/*#Ops*/, 4, 2, 3, 
               // Src: (ld:{ *:[v2f64] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_load>> - Complexity = 13
               // Dst: (LOAD_V128_A64:{ *:[v2f64] } 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr)
/*  7017*/    0, // EndSwitchType
/*  7018*/   /*Scope*/ 28, /*->7047*/
/*  7019*/    OPC_CheckPredicate, 10, // Predicate_extload
/*  7021*/    OPC_CheckType, MVT::v2f64,
/*  7023*/    OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64())
/*  7024*/    OPC_EmitMergeInputChains1_0,
/*  7025*/    OPC_EmitInteger32, 0, 
/*  7027*/    OPC_EmitInteger64, 0, 
/*  7029*/    OPC_EmitNode1, TARGET_VAL(WebAssembly::LOAD_ZERO_I64x2_A64), 0|OPFL_Chain|OPFL_MemRefs,
                  MVT::v16i8, 3/*#Ops*/, 2, 3, 1,  // Results = #4
/*  7038*/    OPC_EmitNode1None, TARGET_VAL(WebAssembly::promote_low_F64x2),
                  MVT::v2f64, 1/*#Ops*/, 4,  // Results = #5
/*  7044*/    OPC_CompleteMatch, 1, 5, 
               // Src: (ld:{ *:[v2f64] } I64:{ *:[i64] }:$addr)<<P:Predicate_unindexedload>><<P:Predicate_extload>> - Complexity = 4
               // Dst: (promote_low_F64x2:{ *:[v2f64] } (LOAD_ZERO_I64x2_A64:{ *:[v16i8] } 0:{ *:[i32] }, 0:{ *:[i64] }, I64:{ *:[i64] }:$addr))
/*  7047*/   0, /*End of Scope*/
/*  7048*/  0, /*End of Scope*/
/*  7049*/ /*SwitchOpcode*/ 31|128,1/*159*/, TARGET_VAL(ISD::ATOMIC_LOAD),// ->7212
/*  7053*/  OPC_RecordMemRef,
/*  7054*/  OPC_RecordNode, // #0 = 'atomic_load' chained node
/*  7055*/  OPC_RecordChild1, // #1 = $AddrOps32:offset:addr
/*  7056*/  OPC_Scope, 76, /*->7134*/ // 2 children in Scope
/*  7058*/   OPC_CheckChild1TypeI32,
/*  7059*/   OPC_SwitchType /*2 cases */, 53, MVT::i32,// ->7115
/*  7062*/    OPC_Scope, 16, /*->7080*/ // 3 children in Scope
/*  7064*/     OPC_CheckPredicate3,  // Predicate_atomic_load_32
/*  7065*/     OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64())
/*  7066*/     OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #2 #3
/*  7068*/     OPC_EmitMergeInputChains1_0,
/*  7069*/     OPC_EmitInteger32, 0, 
/*  7071*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_LOAD_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::i32, 3/*#Ops*/, 4, 2, 3, 
               // Src: (atomic_load:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_atomic_load_32>> - Complexity = 13
               // Dst: (ATOMIC_LOAD_I32_A32:{ *:[i32] } 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr)
/*  7080*/    /*Scope*/ 16, /*->7097*/
/*  7081*/     OPC_CheckPredicate1,  // Predicate_atomic_load_8
/*  7082*/     OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64())
/*  7083*/     OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #2 #3
/*  7085*/     OPC_EmitMergeInputChains1_0,
/*  7086*/     OPC_EmitInteger32, 0, 
/*  7088*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_LOAD8_U_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::i32, 3/*#Ops*/, 4, 2, 3, 
               // Src: (atomic_load:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_atomic_load_8>> - Complexity = 13
               // Dst: (ATOMIC_LOAD8_U_I32_A32:{ *:[i32] } 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr)
/*  7097*/    /*Scope*/ 16, /*->7114*/
/*  7098*/     OPC_CheckPredicate2,  // Predicate_atomic_load_16
/*  7099*/     OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64())
/*  7100*/     OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #2 #3
/*  7102*/     OPC_EmitMergeInputChains1_0,
/*  7103*/     OPC_EmitInteger32, 0, 
/*  7105*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_LOAD16_U_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::i32, 3/*#Ops*/, 4, 2, 3, 
               // Src: (atomic_load:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_atomic_load_16>> - Complexity = 13
               // Dst: (ATOMIC_LOAD16_U_I32_A32:{ *:[i32] } 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr)
/*  7114*/    0, /*End of Scope*/
/*  7115*/   /*SwitchType*/ 16, MVT::i64,// ->7133
/*  7117*/    OPC_CheckPredicate6,  // Predicate_atomic_load_64
/*  7118*/    OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64())
/*  7119*/    OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #2 #3
/*  7121*/    OPC_EmitMergeInputChains1_0,
/*  7122*/    OPC_EmitInteger32, 0, 
/*  7124*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_LOAD_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                  MVT::i64, 3/*#Ops*/, 4, 2, 3, 
              // Src: (atomic_load:{ *:[i64] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_atomic_load_64>> - Complexity = 13
              // Dst: (ATOMIC_LOAD_I64_A32:{ *:[i64] } 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr)
/*  7133*/   0, // EndSwitchType
/*  7134*/  /*Scope*/ 76, /*->7211*/
/*  7135*/   OPC_CheckChild1TypeI64,
/*  7136*/   OPC_SwitchType /*2 cases */, 53, MVT::i32,// ->7192
/*  7139*/    OPC_Scope, 16, /*->7157*/ // 3 children in Scope
/*  7141*/     OPC_CheckPredicate3,  // Predicate_atomic_load_32
/*  7142*/     OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64())
/*  7143*/     OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #2 #3
/*  7145*/     OPC_EmitMergeInputChains1_0,
/*  7146*/     OPC_EmitInteger32, 0, 
/*  7148*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_LOAD_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::i32, 3/*#Ops*/, 4, 2, 3, 
               // Src: (atomic_load:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_atomic_load_32>> - Complexity = 13
               // Dst: (ATOMIC_LOAD_I32_A64:{ *:[i32] } 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr)
/*  7157*/    /*Scope*/ 16, /*->7174*/
/*  7158*/     OPC_CheckPredicate1,  // Predicate_atomic_load_8
/*  7159*/     OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64())
/*  7160*/     OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #2 #3
/*  7162*/     OPC_EmitMergeInputChains1_0,
/*  7163*/     OPC_EmitInteger32, 0, 
/*  7165*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_LOAD8_U_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::i32, 3/*#Ops*/, 4, 2, 3, 
               // Src: (atomic_load:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_atomic_load_8>> - Complexity = 13
               // Dst: (ATOMIC_LOAD8_U_I32_A64:{ *:[i32] } 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr)
/*  7174*/    /*Scope*/ 16, /*->7191*/
/*  7175*/     OPC_CheckPredicate2,  // Predicate_atomic_load_16
/*  7176*/     OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64())
/*  7177*/     OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #2 #3
/*  7179*/     OPC_EmitMergeInputChains1_0,
/*  7180*/     OPC_EmitInteger32, 0, 
/*  7182*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_LOAD16_U_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::i32, 3/*#Ops*/, 4, 2, 3, 
               // Src: (atomic_load:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_atomic_load_16>> - Complexity = 13
               // Dst: (ATOMIC_LOAD16_U_I32_A64:{ *:[i32] } 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr)
/*  7191*/    0, /*End of Scope*/
/*  7192*/   /*SwitchType*/ 16, MVT::i64,// ->7210
/*  7194*/    OPC_CheckPredicate6,  // Predicate_atomic_load_64
/*  7195*/    OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64())
/*  7196*/    OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #2 #3
/*  7198*/    OPC_EmitMergeInputChains1_0,
/*  7199*/    OPC_EmitInteger32, 0, 
/*  7201*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_LOAD_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                  MVT::i64, 3/*#Ops*/, 4, 2, 3, 
              // Src: (atomic_load:{ *:[i64] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_atomic_load_64>> - Complexity = 13
              // Dst: (ATOMIC_LOAD_I64_A64:{ *:[i64] } 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr)
/*  7210*/   0, // EndSwitchType
/*  7211*/  0, /*End of Scope*/
/*  7212*/ /*SwitchOpcode*/ 113|128,1/*241*/, TARGET_VAL(ISD::ATOMIC_LOAD_ADD),// ->7457
/*  7216*/  OPC_RecordMemRef,
/*  7217*/  OPC_RecordNode, // #0 = 'atomic_load_add' chained node
/*  7218*/  OPC_RecordChild1, // #1 = $AddrOps32:offset:addr
/*  7219*/  OPC_Scope, 117, /*->7338*/ // 2 children in Scope
/*  7221*/   OPC_CheckChild1TypeI32,
/*  7222*/   OPC_RecordChild2, // #2 = $val
/*  7223*/   OPC_SwitchType /*2 cases */, 92, MVT::i32,// ->7318
/*  7226*/    OPC_Scope, 17, /*->7245*/ // 5 children in Scope
/*  7228*/     OPC_CheckPredicate3,  // Predicate_atomic_load_add_32
/*  7229*/     OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  7230*/     OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*  7232*/     OPC_EmitMergeInputChains1_0,
/*  7233*/     OPC_EmitInteger32, 0, 
/*  7235*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW_ADD_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::i32, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_load_add:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_add_32>> - Complexity = 13
               // Dst: (ATOMIC_RMW_ADD_I32_A32:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i32] }:$val)
/*  7245*/    /*Scope*/ 17, /*->7263*/
/*  7246*/     OPC_CheckPredicate1,  // Predicate_atomic_load_add_8
/*  7247*/     OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  7248*/     OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*  7250*/     OPC_EmitMergeInputChains1_0,
/*  7251*/     OPC_EmitInteger32, 0, 
/*  7253*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_ADD_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::i32, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_load_add:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_add_8>> - Complexity = 13
               // Dst: (ATOMIC_RMW8_U_ADD_I32_A32:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i32] }:$val)
/*  7263*/    /*Scope*/ 17, /*->7281*/
/*  7264*/     OPC_CheckPredicate2,  // Predicate_atomic_load_add_16
/*  7265*/     OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  7266*/     OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*  7268*/     OPC_EmitMergeInputChains1_0,
/*  7269*/     OPC_EmitInteger32, 0, 
/*  7271*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_ADD_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::i32, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_load_add:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_add_16>> - Complexity = 13
               // Dst: (ATOMIC_RMW16_U_ADD_I32_A32:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i32] }:$val)
/*  7281*/    /*Scope*/ 17, /*->7299*/
/*  7282*/     OPC_CheckPredicate1,  // Predicate_atomic_load_add_8
/*  7283*/     OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  7284*/     OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*  7286*/     OPC_EmitMergeInputChains1_0,
/*  7287*/     OPC_EmitInteger32, 0, 
/*  7289*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_ADD_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::i32, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_load_add:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_add_8>> - Complexity = 13
               // Dst: (ATOMIC_RMW8_U_ADD_I32_A32:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i32] }:$val)
/*  7299*/    /*Scope*/ 17, /*->7317*/
/*  7300*/     OPC_CheckPredicate2,  // Predicate_atomic_load_add_16
/*  7301*/     OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  7302*/     OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*  7304*/     OPC_EmitMergeInputChains1_0,
/*  7305*/     OPC_EmitInteger32, 0, 
/*  7307*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_ADD_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::i32, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_load_add:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_add_16>> - Complexity = 13
               // Dst: (ATOMIC_RMW16_U_ADD_I32_A32:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i32] }:$val)
/*  7317*/    0, /*End of Scope*/
/*  7318*/   /*SwitchType*/ 17, MVT::i64,// ->7337
/*  7320*/    OPC_CheckPredicate6,  // Predicate_atomic_load_add_64
/*  7321*/    OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  7322*/    OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*  7324*/    OPC_EmitMergeInputChains1_0,
/*  7325*/    OPC_EmitInteger32, 0, 
/*  7327*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW_ADD_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                  MVT::i64, 4/*#Ops*/, 5, 3, 4, 2, 
              // Src: (atomic_load_add:{ *:[i64] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), i64:{ *:[i64] }:$val)<<P:Predicate_atomic_load_add_64>> - Complexity = 13
              // Dst: (ATOMIC_RMW_ADD_I64_A32:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i64] }:$val)
/*  7337*/   0, // EndSwitchType
/*  7338*/  /*Scope*/ 117, /*->7456*/
/*  7339*/   OPC_CheckChild1TypeI64,
/*  7340*/   OPC_RecordChild2, // #2 = $val
/*  7341*/   OPC_SwitchType /*2 cases */, 92, MVT::i32,// ->7436
/*  7344*/    OPC_Scope, 17, /*->7363*/ // 5 children in Scope
/*  7346*/     OPC_CheckPredicate3,  // Predicate_atomic_load_add_32
/*  7347*/     OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  7348*/     OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*  7350*/     OPC_EmitMergeInputChains1_0,
/*  7351*/     OPC_EmitInteger32, 0, 
/*  7353*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW_ADD_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::i32, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_load_add:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_add_32>> - Complexity = 13
               // Dst: (ATOMIC_RMW_ADD_I32_A64:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i32] }:$val)
/*  7363*/    /*Scope*/ 17, /*->7381*/
/*  7364*/     OPC_CheckPredicate1,  // Predicate_atomic_load_add_8
/*  7365*/     OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  7366*/     OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*  7368*/     OPC_EmitMergeInputChains1_0,
/*  7369*/     OPC_EmitInteger32, 0, 
/*  7371*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_ADD_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::i32, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_load_add:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_add_8>> - Complexity = 13
               // Dst: (ATOMIC_RMW8_U_ADD_I32_A64:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i32] }:$val)
/*  7381*/    /*Scope*/ 17, /*->7399*/
/*  7382*/     OPC_CheckPredicate2,  // Predicate_atomic_load_add_16
/*  7383*/     OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  7384*/     OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*  7386*/     OPC_EmitMergeInputChains1_0,
/*  7387*/     OPC_EmitInteger32, 0, 
/*  7389*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_ADD_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::i32, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_load_add:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_add_16>> - Complexity = 13
               // Dst: (ATOMIC_RMW16_U_ADD_I32_A64:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i32] }:$val)
/*  7399*/    /*Scope*/ 17, /*->7417*/
/*  7400*/     OPC_CheckPredicate1,  // Predicate_atomic_load_add_8
/*  7401*/     OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  7402*/     OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*  7404*/     OPC_EmitMergeInputChains1_0,
/*  7405*/     OPC_EmitInteger32, 0, 
/*  7407*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_ADD_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::i32, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_load_add:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_add_8>> - Complexity = 13
               // Dst: (ATOMIC_RMW8_U_ADD_I32_A64:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i32] }:$val)
/*  7417*/    /*Scope*/ 17, /*->7435*/
/*  7418*/     OPC_CheckPredicate2,  // Predicate_atomic_load_add_16
/*  7419*/     OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  7420*/     OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*  7422*/     OPC_EmitMergeInputChains1_0,
/*  7423*/     OPC_EmitInteger32, 0, 
/*  7425*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_ADD_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::i32, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_load_add:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_add_16>> - Complexity = 13
               // Dst: (ATOMIC_RMW16_U_ADD_I32_A64:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i32] }:$val)
/*  7435*/    0, /*End of Scope*/
/*  7436*/   /*SwitchType*/ 17, MVT::i64,// ->7455
/*  7438*/    OPC_CheckPredicate6,  // Predicate_atomic_load_add_64
/*  7439*/    OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  7440*/    OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*  7442*/    OPC_EmitMergeInputChains1_0,
/*  7443*/    OPC_EmitInteger32, 0, 
/*  7445*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW_ADD_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                  MVT::i64, 4/*#Ops*/, 5, 3, 4, 2, 
              // Src: (atomic_load_add:{ *:[i64] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), i64:{ *:[i64] }:$val)<<P:Predicate_atomic_load_add_64>> - Complexity = 13
              // Dst: (ATOMIC_RMW_ADD_I64_A64:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i64] }:$val)
/*  7455*/   0, // EndSwitchType
/*  7456*/  0, /*End of Scope*/
/*  7457*/ /*SwitchOpcode*/ 113|128,1/*241*/, TARGET_VAL(ISD::ATOMIC_LOAD_SUB),// ->7702
/*  7461*/  OPC_RecordMemRef,
/*  7462*/  OPC_RecordNode, // #0 = 'atomic_load_sub' chained node
/*  7463*/  OPC_RecordChild1, // #1 = $AddrOps32:offset:addr
/*  7464*/  OPC_Scope, 117, /*->7583*/ // 2 children in Scope
/*  7466*/   OPC_CheckChild1TypeI32,
/*  7467*/   OPC_RecordChild2, // #2 = $val
/*  7468*/   OPC_SwitchType /*2 cases */, 92, MVT::i32,// ->7563
/*  7471*/    OPC_Scope, 17, /*->7490*/ // 5 children in Scope
/*  7473*/     OPC_CheckPredicate3,  // Predicate_atomic_load_sub_32
/*  7474*/     OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  7475*/     OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*  7477*/     OPC_EmitMergeInputChains1_0,
/*  7478*/     OPC_EmitInteger32, 0, 
/*  7480*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW_SUB_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::i32, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_load_sub:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_sub_32>> - Complexity = 13
               // Dst: (ATOMIC_RMW_SUB_I32_A32:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i32] }:$val)
/*  7490*/    /*Scope*/ 17, /*->7508*/
/*  7491*/     OPC_CheckPredicate1,  // Predicate_atomic_load_sub_8
/*  7492*/     OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  7493*/     OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*  7495*/     OPC_EmitMergeInputChains1_0,
/*  7496*/     OPC_EmitInteger32, 0, 
/*  7498*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_SUB_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::i32, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_load_sub:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_sub_8>> - Complexity = 13
               // Dst: (ATOMIC_RMW8_U_SUB_I32_A32:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i32] }:$val)
/*  7508*/    /*Scope*/ 17, /*->7526*/
/*  7509*/     OPC_CheckPredicate2,  // Predicate_atomic_load_sub_16
/*  7510*/     OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  7511*/     OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*  7513*/     OPC_EmitMergeInputChains1_0,
/*  7514*/     OPC_EmitInteger32, 0, 
/*  7516*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_SUB_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::i32, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_load_sub:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_sub_16>> - Complexity = 13
               // Dst: (ATOMIC_RMW16_U_SUB_I32_A32:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i32] }:$val)
/*  7526*/    /*Scope*/ 17, /*->7544*/
/*  7527*/     OPC_CheckPredicate1,  // Predicate_atomic_load_sub_8
/*  7528*/     OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  7529*/     OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*  7531*/     OPC_EmitMergeInputChains1_0,
/*  7532*/     OPC_EmitInteger32, 0, 
/*  7534*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_SUB_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::i32, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_load_sub:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_sub_8>> - Complexity = 13
               // Dst: (ATOMIC_RMW8_U_SUB_I32_A32:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i32] }:$val)
/*  7544*/    /*Scope*/ 17, /*->7562*/
/*  7545*/     OPC_CheckPredicate2,  // Predicate_atomic_load_sub_16
/*  7546*/     OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  7547*/     OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*  7549*/     OPC_EmitMergeInputChains1_0,
/*  7550*/     OPC_EmitInteger32, 0, 
/*  7552*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_SUB_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::i32, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_load_sub:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_sub_16>> - Complexity = 13
               // Dst: (ATOMIC_RMW16_U_SUB_I32_A32:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i32] }:$val)
/*  7562*/    0, /*End of Scope*/
/*  7563*/   /*SwitchType*/ 17, MVT::i64,// ->7582
/*  7565*/    OPC_CheckPredicate6,  // Predicate_atomic_load_sub_64
/*  7566*/    OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  7567*/    OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*  7569*/    OPC_EmitMergeInputChains1_0,
/*  7570*/    OPC_EmitInteger32, 0, 
/*  7572*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW_SUB_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                  MVT::i64, 4/*#Ops*/, 5, 3, 4, 2, 
              // Src: (atomic_load_sub:{ *:[i64] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), i64:{ *:[i64] }:$val)<<P:Predicate_atomic_load_sub_64>> - Complexity = 13
              // Dst: (ATOMIC_RMW_SUB_I64_A32:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i64] }:$val)
/*  7582*/   0, // EndSwitchType
/*  7583*/  /*Scope*/ 117, /*->7701*/
/*  7584*/   OPC_CheckChild1TypeI64,
/*  7585*/   OPC_RecordChild2, // #2 = $val
/*  7586*/   OPC_SwitchType /*2 cases */, 92, MVT::i32,// ->7681
/*  7589*/    OPC_Scope, 17, /*->7608*/ // 5 children in Scope
/*  7591*/     OPC_CheckPredicate3,  // Predicate_atomic_load_sub_32
/*  7592*/     OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  7593*/     OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*  7595*/     OPC_EmitMergeInputChains1_0,
/*  7596*/     OPC_EmitInteger32, 0, 
/*  7598*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW_SUB_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::i32, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_load_sub:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_sub_32>> - Complexity = 13
               // Dst: (ATOMIC_RMW_SUB_I32_A64:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i32] }:$val)
/*  7608*/    /*Scope*/ 17, /*->7626*/
/*  7609*/     OPC_CheckPredicate1,  // Predicate_atomic_load_sub_8
/*  7610*/     OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  7611*/     OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*  7613*/     OPC_EmitMergeInputChains1_0,
/*  7614*/     OPC_EmitInteger32, 0, 
/*  7616*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_SUB_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::i32, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_load_sub:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_sub_8>> - Complexity = 13
               // Dst: (ATOMIC_RMW8_U_SUB_I32_A64:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i32] }:$val)
/*  7626*/    /*Scope*/ 17, /*->7644*/
/*  7627*/     OPC_CheckPredicate2,  // Predicate_atomic_load_sub_16
/*  7628*/     OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  7629*/     OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*  7631*/     OPC_EmitMergeInputChains1_0,
/*  7632*/     OPC_EmitInteger32, 0, 
/*  7634*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_SUB_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::i32, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_load_sub:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_sub_16>> - Complexity = 13
               // Dst: (ATOMIC_RMW16_U_SUB_I32_A64:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i32] }:$val)
/*  7644*/    /*Scope*/ 17, /*->7662*/
/*  7645*/     OPC_CheckPredicate1,  // Predicate_atomic_load_sub_8
/*  7646*/     OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  7647*/     OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*  7649*/     OPC_EmitMergeInputChains1_0,
/*  7650*/     OPC_EmitInteger32, 0, 
/*  7652*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_SUB_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::i32, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_load_sub:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_sub_8>> - Complexity = 13
               // Dst: (ATOMIC_RMW8_U_SUB_I32_A64:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i32] }:$val)
/*  7662*/    /*Scope*/ 17, /*->7680*/
/*  7663*/     OPC_CheckPredicate2,  // Predicate_atomic_load_sub_16
/*  7664*/     OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  7665*/     OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*  7667*/     OPC_EmitMergeInputChains1_0,
/*  7668*/     OPC_EmitInteger32, 0, 
/*  7670*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_SUB_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::i32, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_load_sub:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_sub_16>> - Complexity = 13
               // Dst: (ATOMIC_RMW16_U_SUB_I32_A64:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i32] }:$val)
/*  7680*/    0, /*End of Scope*/
/*  7681*/   /*SwitchType*/ 17, MVT::i64,// ->7700
/*  7683*/    OPC_CheckPredicate6,  // Predicate_atomic_load_sub_64
/*  7684*/    OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  7685*/    OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*  7687*/    OPC_EmitMergeInputChains1_0,
/*  7688*/    OPC_EmitInteger32, 0, 
/*  7690*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW_SUB_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                  MVT::i64, 4/*#Ops*/, 5, 3, 4, 2, 
              // Src: (atomic_load_sub:{ *:[i64] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), i64:{ *:[i64] }:$val)<<P:Predicate_atomic_load_sub_64>> - Complexity = 13
              // Dst: (ATOMIC_RMW_SUB_I64_A64:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i64] }:$val)
/*  7700*/   0, // EndSwitchType
/*  7701*/  0, /*End of Scope*/
/*  7702*/ /*SwitchOpcode*/ 113|128,1/*241*/, TARGET_VAL(ISD::ATOMIC_LOAD_AND),// ->7947
/*  7706*/  OPC_RecordMemRef,
/*  7707*/  OPC_RecordNode, // #0 = 'atomic_load_and' chained node
/*  7708*/  OPC_RecordChild1, // #1 = $AddrOps32:offset:addr
/*  7709*/  OPC_Scope, 117, /*->7828*/ // 2 children in Scope
/*  7711*/   OPC_CheckChild1TypeI32,
/*  7712*/   OPC_RecordChild2, // #2 = $val
/*  7713*/   OPC_SwitchType /*2 cases */, 92, MVT::i32,// ->7808
/*  7716*/    OPC_Scope, 17, /*->7735*/ // 5 children in Scope
/*  7718*/     OPC_CheckPredicate3,  // Predicate_atomic_load_and_32
/*  7719*/     OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  7720*/     OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*  7722*/     OPC_EmitMergeInputChains1_0,
/*  7723*/     OPC_EmitInteger32, 0, 
/*  7725*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW_AND_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::i32, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_load_and:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_and_32>> - Complexity = 13
               // Dst: (ATOMIC_RMW_AND_I32_A32:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i32] }:$val)
/*  7735*/    /*Scope*/ 17, /*->7753*/
/*  7736*/     OPC_CheckPredicate1,  // Predicate_atomic_load_and_8
/*  7737*/     OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  7738*/     OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*  7740*/     OPC_EmitMergeInputChains1_0,
/*  7741*/     OPC_EmitInteger32, 0, 
/*  7743*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_AND_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::i32, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_load_and:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_and_8>> - Complexity = 13
               // Dst: (ATOMIC_RMW8_U_AND_I32_A32:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i32] }:$val)
/*  7753*/    /*Scope*/ 17, /*->7771*/
/*  7754*/     OPC_CheckPredicate2,  // Predicate_atomic_load_and_16
/*  7755*/     OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  7756*/     OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*  7758*/     OPC_EmitMergeInputChains1_0,
/*  7759*/     OPC_EmitInteger32, 0, 
/*  7761*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_AND_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::i32, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_load_and:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_and_16>> - Complexity = 13
               // Dst: (ATOMIC_RMW16_U_AND_I32_A32:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i32] }:$val)
/*  7771*/    /*Scope*/ 17, /*->7789*/
/*  7772*/     OPC_CheckPredicate1,  // Predicate_atomic_load_and_8
/*  7773*/     OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  7774*/     OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*  7776*/     OPC_EmitMergeInputChains1_0,
/*  7777*/     OPC_EmitInteger32, 0, 
/*  7779*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_AND_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::i32, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_load_and:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_and_8>> - Complexity = 13
               // Dst: (ATOMIC_RMW8_U_AND_I32_A32:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i32] }:$val)
/*  7789*/    /*Scope*/ 17, /*->7807*/
/*  7790*/     OPC_CheckPredicate2,  // Predicate_atomic_load_and_16
/*  7791*/     OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  7792*/     OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*  7794*/     OPC_EmitMergeInputChains1_0,
/*  7795*/     OPC_EmitInteger32, 0, 
/*  7797*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_AND_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::i32, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_load_and:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_and_16>> - Complexity = 13
               // Dst: (ATOMIC_RMW16_U_AND_I32_A32:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i32] }:$val)
/*  7807*/    0, /*End of Scope*/
/*  7808*/   /*SwitchType*/ 17, MVT::i64,// ->7827
/*  7810*/    OPC_CheckPredicate6,  // Predicate_atomic_load_and_64
/*  7811*/    OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  7812*/    OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*  7814*/    OPC_EmitMergeInputChains1_0,
/*  7815*/    OPC_EmitInteger32, 0, 
/*  7817*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW_AND_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                  MVT::i64, 4/*#Ops*/, 5, 3, 4, 2, 
              // Src: (atomic_load_and:{ *:[i64] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), i64:{ *:[i64] }:$val)<<P:Predicate_atomic_load_and_64>> - Complexity = 13
              // Dst: (ATOMIC_RMW_AND_I64_A32:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i64] }:$val)
/*  7827*/   0, // EndSwitchType
/*  7828*/  /*Scope*/ 117, /*->7946*/
/*  7829*/   OPC_CheckChild1TypeI64,
/*  7830*/   OPC_RecordChild2, // #2 = $val
/*  7831*/   OPC_SwitchType /*2 cases */, 92, MVT::i32,// ->7926
/*  7834*/    OPC_Scope, 17, /*->7853*/ // 5 children in Scope
/*  7836*/     OPC_CheckPredicate3,  // Predicate_atomic_load_and_32
/*  7837*/     OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  7838*/     OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*  7840*/     OPC_EmitMergeInputChains1_0,
/*  7841*/     OPC_EmitInteger32, 0, 
/*  7843*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW_AND_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::i32, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_load_and:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_and_32>> - Complexity = 13
               // Dst: (ATOMIC_RMW_AND_I32_A64:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i32] }:$val)
/*  7853*/    /*Scope*/ 17, /*->7871*/
/*  7854*/     OPC_CheckPredicate1,  // Predicate_atomic_load_and_8
/*  7855*/     OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  7856*/     OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*  7858*/     OPC_EmitMergeInputChains1_0,
/*  7859*/     OPC_EmitInteger32, 0, 
/*  7861*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_AND_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::i32, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_load_and:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_and_8>> - Complexity = 13
               // Dst: (ATOMIC_RMW8_U_AND_I32_A64:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i32] }:$val)
/*  7871*/    /*Scope*/ 17, /*->7889*/
/*  7872*/     OPC_CheckPredicate2,  // Predicate_atomic_load_and_16
/*  7873*/     OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  7874*/     OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*  7876*/     OPC_EmitMergeInputChains1_0,
/*  7877*/     OPC_EmitInteger32, 0, 
/*  7879*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_AND_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::i32, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_load_and:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_and_16>> - Complexity = 13
               // Dst: (ATOMIC_RMW16_U_AND_I32_A64:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i32] }:$val)
/*  7889*/    /*Scope*/ 17, /*->7907*/
/*  7890*/     OPC_CheckPredicate1,  // Predicate_atomic_load_and_8
/*  7891*/     OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  7892*/     OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*  7894*/     OPC_EmitMergeInputChains1_0,
/*  7895*/     OPC_EmitInteger32, 0, 
/*  7897*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_AND_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::i32, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_load_and:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_and_8>> - Complexity = 13
               // Dst: (ATOMIC_RMW8_U_AND_I32_A64:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i32] }:$val)
/*  7907*/    /*Scope*/ 17, /*->7925*/
/*  7908*/     OPC_CheckPredicate2,  // Predicate_atomic_load_and_16
/*  7909*/     OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  7910*/     OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*  7912*/     OPC_EmitMergeInputChains1_0,
/*  7913*/     OPC_EmitInteger32, 0, 
/*  7915*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_AND_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::i32, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_load_and:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_and_16>> - Complexity = 13
               // Dst: (ATOMIC_RMW16_U_AND_I32_A64:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i32] }:$val)
/*  7925*/    0, /*End of Scope*/
/*  7926*/   /*SwitchType*/ 17, MVT::i64,// ->7945
/*  7928*/    OPC_CheckPredicate6,  // Predicate_atomic_load_and_64
/*  7929*/    OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  7930*/    OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*  7932*/    OPC_EmitMergeInputChains1_0,
/*  7933*/    OPC_EmitInteger32, 0, 
/*  7935*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW_AND_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                  MVT::i64, 4/*#Ops*/, 5, 3, 4, 2, 
              // Src: (atomic_load_and:{ *:[i64] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), i64:{ *:[i64] }:$val)<<P:Predicate_atomic_load_and_64>> - Complexity = 13
              // Dst: (ATOMIC_RMW_AND_I64_A64:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i64] }:$val)
/*  7945*/   0, // EndSwitchType
/*  7946*/  0, /*End of Scope*/
/*  7947*/ /*SwitchOpcode*/ 113|128,1/*241*/, TARGET_VAL(ISD::ATOMIC_LOAD_OR),// ->8192
/*  7951*/  OPC_RecordMemRef,
/*  7952*/  OPC_RecordNode, // #0 = 'atomic_load_or' chained node
/*  7953*/  OPC_RecordChild1, // #1 = $AddrOps32:offset:addr
/*  7954*/  OPC_Scope, 117, /*->8073*/ // 2 children in Scope
/*  7956*/   OPC_CheckChild1TypeI32,
/*  7957*/   OPC_RecordChild2, // #2 = $val
/*  7958*/   OPC_SwitchType /*2 cases */, 92, MVT::i32,// ->8053
/*  7961*/    OPC_Scope, 17, /*->7980*/ // 5 children in Scope
/*  7963*/     OPC_CheckPredicate3,  // Predicate_atomic_load_or_32
/*  7964*/     OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  7965*/     OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*  7967*/     OPC_EmitMergeInputChains1_0,
/*  7968*/     OPC_EmitInteger32, 0, 
/*  7970*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW_OR_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::i32, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_load_or:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_or_32>> - Complexity = 13
               // Dst: (ATOMIC_RMW_OR_I32_A32:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i32] }:$val)
/*  7980*/    /*Scope*/ 17, /*->7998*/
/*  7981*/     OPC_CheckPredicate1,  // Predicate_atomic_load_or_8
/*  7982*/     OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  7983*/     OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*  7985*/     OPC_EmitMergeInputChains1_0,
/*  7986*/     OPC_EmitInteger32, 0, 
/*  7988*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_OR_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::i32, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_load_or:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_or_8>> - Complexity = 13
               // Dst: (ATOMIC_RMW8_U_OR_I32_A32:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i32] }:$val)
/*  7998*/    /*Scope*/ 17, /*->8016*/
/*  7999*/     OPC_CheckPredicate2,  // Predicate_atomic_load_or_16
/*  8000*/     OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  8001*/     OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*  8003*/     OPC_EmitMergeInputChains1_0,
/*  8004*/     OPC_EmitInteger32, 0, 
/*  8006*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_OR_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::i32, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_load_or:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_or_16>> - Complexity = 13
               // Dst: (ATOMIC_RMW16_U_OR_I32_A32:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i32] }:$val)
/*  8016*/    /*Scope*/ 17, /*->8034*/
/*  8017*/     OPC_CheckPredicate1,  // Predicate_atomic_load_or_8
/*  8018*/     OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  8019*/     OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*  8021*/     OPC_EmitMergeInputChains1_0,
/*  8022*/     OPC_EmitInteger32, 0, 
/*  8024*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_OR_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::i32, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_load_or:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_or_8>> - Complexity = 13
               // Dst: (ATOMIC_RMW8_U_OR_I32_A32:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i32] }:$val)
/*  8034*/    /*Scope*/ 17, /*->8052*/
/*  8035*/     OPC_CheckPredicate2,  // Predicate_atomic_load_or_16
/*  8036*/     OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  8037*/     OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*  8039*/     OPC_EmitMergeInputChains1_0,
/*  8040*/     OPC_EmitInteger32, 0, 
/*  8042*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_OR_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::i32, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_load_or:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_or_16>> - Complexity = 13
               // Dst: (ATOMIC_RMW16_U_OR_I32_A32:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i32] }:$val)
/*  8052*/    0, /*End of Scope*/
/*  8053*/   /*SwitchType*/ 17, MVT::i64,// ->8072
/*  8055*/    OPC_CheckPredicate6,  // Predicate_atomic_load_or_64
/*  8056*/    OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  8057*/    OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*  8059*/    OPC_EmitMergeInputChains1_0,
/*  8060*/    OPC_EmitInteger32, 0, 
/*  8062*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW_OR_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                  MVT::i64, 4/*#Ops*/, 5, 3, 4, 2, 
              // Src: (atomic_load_or:{ *:[i64] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), i64:{ *:[i64] }:$val)<<P:Predicate_atomic_load_or_64>> - Complexity = 13
              // Dst: (ATOMIC_RMW_OR_I64_A32:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i64] }:$val)
/*  8072*/   0, // EndSwitchType
/*  8073*/  /*Scope*/ 117, /*->8191*/
/*  8074*/   OPC_CheckChild1TypeI64,
/*  8075*/   OPC_RecordChild2, // #2 = $val
/*  8076*/   OPC_SwitchType /*2 cases */, 92, MVT::i32,// ->8171
/*  8079*/    OPC_Scope, 17, /*->8098*/ // 5 children in Scope
/*  8081*/     OPC_CheckPredicate3,  // Predicate_atomic_load_or_32
/*  8082*/     OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  8083*/     OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*  8085*/     OPC_EmitMergeInputChains1_0,
/*  8086*/     OPC_EmitInteger32, 0, 
/*  8088*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW_OR_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::i32, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_load_or:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_or_32>> - Complexity = 13
               // Dst: (ATOMIC_RMW_OR_I32_A64:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i32] }:$val)
/*  8098*/    /*Scope*/ 17, /*->8116*/
/*  8099*/     OPC_CheckPredicate1,  // Predicate_atomic_load_or_8
/*  8100*/     OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  8101*/     OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*  8103*/     OPC_EmitMergeInputChains1_0,
/*  8104*/     OPC_EmitInteger32, 0, 
/*  8106*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_OR_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::i32, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_load_or:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_or_8>> - Complexity = 13
               // Dst: (ATOMIC_RMW8_U_OR_I32_A64:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i32] }:$val)
/*  8116*/    /*Scope*/ 17, /*->8134*/
/*  8117*/     OPC_CheckPredicate2,  // Predicate_atomic_load_or_16
/*  8118*/     OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  8119*/     OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*  8121*/     OPC_EmitMergeInputChains1_0,
/*  8122*/     OPC_EmitInteger32, 0, 
/*  8124*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_OR_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::i32, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_load_or:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_or_16>> - Complexity = 13
               // Dst: (ATOMIC_RMW16_U_OR_I32_A64:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i32] }:$val)
/*  8134*/    /*Scope*/ 17, /*->8152*/
/*  8135*/     OPC_CheckPredicate1,  // Predicate_atomic_load_or_8
/*  8136*/     OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  8137*/     OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*  8139*/     OPC_EmitMergeInputChains1_0,
/*  8140*/     OPC_EmitInteger32, 0, 
/*  8142*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_OR_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::i32, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_load_or:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_or_8>> - Complexity = 13
               // Dst: (ATOMIC_RMW8_U_OR_I32_A64:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i32] }:$val)
/*  8152*/    /*Scope*/ 17, /*->8170*/
/*  8153*/     OPC_CheckPredicate2,  // Predicate_atomic_load_or_16
/*  8154*/     OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  8155*/     OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*  8157*/     OPC_EmitMergeInputChains1_0,
/*  8158*/     OPC_EmitInteger32, 0, 
/*  8160*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_OR_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::i32, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_load_or:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_or_16>> - Complexity = 13
               // Dst: (ATOMIC_RMW16_U_OR_I32_A64:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i32] }:$val)
/*  8170*/    0, /*End of Scope*/
/*  8171*/   /*SwitchType*/ 17, MVT::i64,// ->8190
/*  8173*/    OPC_CheckPredicate6,  // Predicate_atomic_load_or_64
/*  8174*/    OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  8175*/    OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*  8177*/    OPC_EmitMergeInputChains1_0,
/*  8178*/    OPC_EmitInteger32, 0, 
/*  8180*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW_OR_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                  MVT::i64, 4/*#Ops*/, 5, 3, 4, 2, 
              // Src: (atomic_load_or:{ *:[i64] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), i64:{ *:[i64] }:$val)<<P:Predicate_atomic_load_or_64>> - Complexity = 13
              // Dst: (ATOMIC_RMW_OR_I64_A64:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i64] }:$val)
/*  8190*/   0, // EndSwitchType
/*  8191*/  0, /*End of Scope*/
/*  8192*/ /*SwitchOpcode*/ 113|128,1/*241*/, TARGET_VAL(ISD::ATOMIC_LOAD_XOR),// ->8437
/*  8196*/  OPC_RecordMemRef,
/*  8197*/  OPC_RecordNode, // #0 = 'atomic_load_xor' chained node
/*  8198*/  OPC_RecordChild1, // #1 = $AddrOps32:offset:addr
/*  8199*/  OPC_Scope, 117, /*->8318*/ // 2 children in Scope
/*  8201*/   OPC_CheckChild1TypeI32,
/*  8202*/   OPC_RecordChild2, // #2 = $val
/*  8203*/   OPC_SwitchType /*2 cases */, 92, MVT::i32,// ->8298
/*  8206*/    OPC_Scope, 17, /*->8225*/ // 5 children in Scope
/*  8208*/     OPC_CheckPredicate3,  // Predicate_atomic_load_xor_32
/*  8209*/     OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  8210*/     OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*  8212*/     OPC_EmitMergeInputChains1_0,
/*  8213*/     OPC_EmitInteger32, 0, 
/*  8215*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW_XOR_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::i32, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_load_xor:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_xor_32>> - Complexity = 13
               // Dst: (ATOMIC_RMW_XOR_I32_A32:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i32] }:$val)
/*  8225*/    /*Scope*/ 17, /*->8243*/
/*  8226*/     OPC_CheckPredicate1,  // Predicate_atomic_load_xor_8
/*  8227*/     OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  8228*/     OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*  8230*/     OPC_EmitMergeInputChains1_0,
/*  8231*/     OPC_EmitInteger32, 0, 
/*  8233*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_XOR_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::i32, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_load_xor:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_xor_8>> - Complexity = 13
               // Dst: (ATOMIC_RMW8_U_XOR_I32_A32:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i32] }:$val)
/*  8243*/    /*Scope*/ 17, /*->8261*/
/*  8244*/     OPC_CheckPredicate2,  // Predicate_atomic_load_xor_16
/*  8245*/     OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  8246*/     OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*  8248*/     OPC_EmitMergeInputChains1_0,
/*  8249*/     OPC_EmitInteger32, 0, 
/*  8251*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_XOR_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::i32, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_load_xor:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_xor_16>> - Complexity = 13
               // Dst: (ATOMIC_RMW16_U_XOR_I32_A32:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i32] }:$val)
/*  8261*/    /*Scope*/ 17, /*->8279*/
/*  8262*/     OPC_CheckPredicate1,  // Predicate_atomic_load_xor_8
/*  8263*/     OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  8264*/     OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*  8266*/     OPC_EmitMergeInputChains1_0,
/*  8267*/     OPC_EmitInteger32, 0, 
/*  8269*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_XOR_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::i32, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_load_xor:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_xor_8>> - Complexity = 13
               // Dst: (ATOMIC_RMW8_U_XOR_I32_A32:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i32] }:$val)
/*  8279*/    /*Scope*/ 17, /*->8297*/
/*  8280*/     OPC_CheckPredicate2,  // Predicate_atomic_load_xor_16
/*  8281*/     OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  8282*/     OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*  8284*/     OPC_EmitMergeInputChains1_0,
/*  8285*/     OPC_EmitInteger32, 0, 
/*  8287*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_XOR_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::i32, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_load_xor:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_xor_16>> - Complexity = 13
               // Dst: (ATOMIC_RMW16_U_XOR_I32_A32:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i32] }:$val)
/*  8297*/    0, /*End of Scope*/
/*  8298*/   /*SwitchType*/ 17, MVT::i64,// ->8317
/*  8300*/    OPC_CheckPredicate6,  // Predicate_atomic_load_xor_64
/*  8301*/    OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  8302*/    OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*  8304*/    OPC_EmitMergeInputChains1_0,
/*  8305*/    OPC_EmitInteger32, 0, 
/*  8307*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW_XOR_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                  MVT::i64, 4/*#Ops*/, 5, 3, 4, 2, 
              // Src: (atomic_load_xor:{ *:[i64] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), i64:{ *:[i64] }:$val)<<P:Predicate_atomic_load_xor_64>> - Complexity = 13
              // Dst: (ATOMIC_RMW_XOR_I64_A32:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i64] }:$val)
/*  8317*/   0, // EndSwitchType
/*  8318*/  /*Scope*/ 117, /*->8436*/
/*  8319*/   OPC_CheckChild1TypeI64,
/*  8320*/   OPC_RecordChild2, // #2 = $val
/*  8321*/   OPC_SwitchType /*2 cases */, 92, MVT::i32,// ->8416
/*  8324*/    OPC_Scope, 17, /*->8343*/ // 5 children in Scope
/*  8326*/     OPC_CheckPredicate3,  // Predicate_atomic_load_xor_32
/*  8327*/     OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  8328*/     OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*  8330*/     OPC_EmitMergeInputChains1_0,
/*  8331*/     OPC_EmitInteger32, 0, 
/*  8333*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW_XOR_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::i32, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_load_xor:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_xor_32>> - Complexity = 13
               // Dst: (ATOMIC_RMW_XOR_I32_A64:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i32] }:$val)
/*  8343*/    /*Scope*/ 17, /*->8361*/
/*  8344*/     OPC_CheckPredicate1,  // Predicate_atomic_load_xor_8
/*  8345*/     OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  8346*/     OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*  8348*/     OPC_EmitMergeInputChains1_0,
/*  8349*/     OPC_EmitInteger32, 0, 
/*  8351*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_XOR_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::i32, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_load_xor:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_xor_8>> - Complexity = 13
               // Dst: (ATOMIC_RMW8_U_XOR_I32_A64:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i32] }:$val)
/*  8361*/    /*Scope*/ 17, /*->8379*/
/*  8362*/     OPC_CheckPredicate2,  // Predicate_atomic_load_xor_16
/*  8363*/     OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  8364*/     OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*  8366*/     OPC_EmitMergeInputChains1_0,
/*  8367*/     OPC_EmitInteger32, 0, 
/*  8369*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_XOR_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::i32, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_load_xor:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_xor_16>> - Complexity = 13
               // Dst: (ATOMIC_RMW16_U_XOR_I32_A64:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i32] }:$val)
/*  8379*/    /*Scope*/ 17, /*->8397*/
/*  8380*/     OPC_CheckPredicate1,  // Predicate_atomic_load_xor_8
/*  8381*/     OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  8382*/     OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*  8384*/     OPC_EmitMergeInputChains1_0,
/*  8385*/     OPC_EmitInteger32, 0, 
/*  8387*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_XOR_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::i32, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_load_xor:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_xor_8>> - Complexity = 13
               // Dst: (ATOMIC_RMW8_U_XOR_I32_A64:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i32] }:$val)
/*  8397*/    /*Scope*/ 17, /*->8415*/
/*  8398*/     OPC_CheckPredicate2,  // Predicate_atomic_load_xor_16
/*  8399*/     OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  8400*/     OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*  8402*/     OPC_EmitMergeInputChains1_0,
/*  8403*/     OPC_EmitInteger32, 0, 
/*  8405*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_XOR_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::i32, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_load_xor:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_xor_16>> - Complexity = 13
               // Dst: (ATOMIC_RMW16_U_XOR_I32_A64:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i32] }:$val)
/*  8415*/    0, /*End of Scope*/
/*  8416*/   /*SwitchType*/ 17, MVT::i64,// ->8435
/*  8418*/    OPC_CheckPredicate6,  // Predicate_atomic_load_xor_64
/*  8419*/    OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  8420*/    OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*  8422*/    OPC_EmitMergeInputChains1_0,
/*  8423*/    OPC_EmitInteger32, 0, 
/*  8425*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW_XOR_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                  MVT::i64, 4/*#Ops*/, 5, 3, 4, 2, 
              // Src: (atomic_load_xor:{ *:[i64] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), i64:{ *:[i64] }:$val)<<P:Predicate_atomic_load_xor_64>> - Complexity = 13
              // Dst: (ATOMIC_RMW_XOR_I64_A64:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i64] }:$val)
/*  8435*/   0, // EndSwitchType
/*  8436*/  0, /*End of Scope*/
/*  8437*/ /*SwitchOpcode*/ 113|128,1/*241*/, TARGET_VAL(ISD::ATOMIC_SWAP),// ->8682
/*  8441*/  OPC_RecordMemRef,
/*  8442*/  OPC_RecordNode, // #0 = 'atomic_swap' chained node
/*  8443*/  OPC_RecordChild1, // #1 = $AddrOps32:offset:addr
/*  8444*/  OPC_Scope, 117, /*->8563*/ // 2 children in Scope
/*  8446*/   OPC_CheckChild1TypeI32,
/*  8447*/   OPC_RecordChild2, // #2 = $val
/*  8448*/   OPC_SwitchType /*2 cases */, 92, MVT::i32,// ->8543
/*  8451*/    OPC_Scope, 17, /*->8470*/ // 5 children in Scope
/*  8453*/     OPC_CheckPredicate3,  // Predicate_atomic_swap_32
/*  8454*/     OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  8455*/     OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*  8457*/     OPC_EmitMergeInputChains1_0,
/*  8458*/     OPC_EmitInteger32, 0, 
/*  8460*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW_XCHG_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::i32, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_swap:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_swap_32>> - Complexity = 13
               // Dst: (ATOMIC_RMW_XCHG_I32_A32:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i32] }:$val)
/*  8470*/    /*Scope*/ 17, /*->8488*/
/*  8471*/     OPC_CheckPredicate1,  // Predicate_atomic_swap_8
/*  8472*/     OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  8473*/     OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*  8475*/     OPC_EmitMergeInputChains1_0,
/*  8476*/     OPC_EmitInteger32, 0, 
/*  8478*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_XCHG_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::i32, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_swap:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_swap_8>> - Complexity = 13
               // Dst: (ATOMIC_RMW8_U_XCHG_I32_A32:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i32] }:$val)
/*  8488*/    /*Scope*/ 17, /*->8506*/
/*  8489*/     OPC_CheckPredicate2,  // Predicate_atomic_swap_16
/*  8490*/     OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  8491*/     OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*  8493*/     OPC_EmitMergeInputChains1_0,
/*  8494*/     OPC_EmitInteger32, 0, 
/*  8496*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_XCHG_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::i32, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_swap:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_swap_16>> - Complexity = 13
               // Dst: (ATOMIC_RMW16_U_XCHG_I32_A32:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i32] }:$val)
/*  8506*/    /*Scope*/ 17, /*->8524*/
/*  8507*/     OPC_CheckPredicate1,  // Predicate_atomic_swap_8
/*  8508*/     OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  8509*/     OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*  8511*/     OPC_EmitMergeInputChains1_0,
/*  8512*/     OPC_EmitInteger32, 0, 
/*  8514*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_XCHG_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::i32, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_swap:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_swap_8>> - Complexity = 13
               // Dst: (ATOMIC_RMW8_U_XCHG_I32_A32:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i32] }:$val)
/*  8524*/    /*Scope*/ 17, /*->8542*/
/*  8525*/     OPC_CheckPredicate2,  // Predicate_atomic_swap_16
/*  8526*/     OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  8527*/     OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*  8529*/     OPC_EmitMergeInputChains1_0,
/*  8530*/     OPC_EmitInteger32, 0, 
/*  8532*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_XCHG_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::i32, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_swap:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_swap_16>> - Complexity = 13
               // Dst: (ATOMIC_RMW16_U_XCHG_I32_A32:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i32] }:$val)
/*  8542*/    0, /*End of Scope*/
/*  8543*/   /*SwitchType*/ 17, MVT::i64,// ->8562
/*  8545*/    OPC_CheckPredicate6,  // Predicate_atomic_swap_64
/*  8546*/    OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  8547*/    OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*  8549*/    OPC_EmitMergeInputChains1_0,
/*  8550*/    OPC_EmitInteger32, 0, 
/*  8552*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW_XCHG_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                  MVT::i64, 4/*#Ops*/, 5, 3, 4, 2, 
              // Src: (atomic_swap:{ *:[i64] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), i64:{ *:[i64] }:$val)<<P:Predicate_atomic_swap_64>> - Complexity = 13
              // Dst: (ATOMIC_RMW_XCHG_I64_A32:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i64] }:$val)
/*  8562*/   0, // EndSwitchType
/*  8563*/  /*Scope*/ 117, /*->8681*/
/*  8564*/   OPC_CheckChild1TypeI64,
/*  8565*/   OPC_RecordChild2, // #2 = $val
/*  8566*/   OPC_SwitchType /*2 cases */, 92, MVT::i32,// ->8661
/*  8569*/    OPC_Scope, 17, /*->8588*/ // 5 children in Scope
/*  8571*/     OPC_CheckPredicate3,  // Predicate_atomic_swap_32
/*  8572*/     OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  8573*/     OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*  8575*/     OPC_EmitMergeInputChains1_0,
/*  8576*/     OPC_EmitInteger32, 0, 
/*  8578*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW_XCHG_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::i32, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_swap:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_swap_32>> - Complexity = 13
               // Dst: (ATOMIC_RMW_XCHG_I32_A64:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i32] }:$val)
/*  8588*/    /*Scope*/ 17, /*->8606*/
/*  8589*/     OPC_CheckPredicate1,  // Predicate_atomic_swap_8
/*  8590*/     OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  8591*/     OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*  8593*/     OPC_EmitMergeInputChains1_0,
/*  8594*/     OPC_EmitInteger32, 0, 
/*  8596*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_XCHG_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::i32, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_swap:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_swap_8>> - Complexity = 13
               // Dst: (ATOMIC_RMW8_U_XCHG_I32_A64:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i32] }:$val)
/*  8606*/    /*Scope*/ 17, /*->8624*/
/*  8607*/     OPC_CheckPredicate2,  // Predicate_atomic_swap_16
/*  8608*/     OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  8609*/     OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*  8611*/     OPC_EmitMergeInputChains1_0,
/*  8612*/     OPC_EmitInteger32, 0, 
/*  8614*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_XCHG_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::i32, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_swap:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_swap_16>> - Complexity = 13
               // Dst: (ATOMIC_RMW16_U_XCHG_I32_A64:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i32] }:$val)
/*  8624*/    /*Scope*/ 17, /*->8642*/
/*  8625*/     OPC_CheckPredicate1,  // Predicate_atomic_swap_8
/*  8626*/     OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  8627*/     OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*  8629*/     OPC_EmitMergeInputChains1_0,
/*  8630*/     OPC_EmitInteger32, 0, 
/*  8632*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_XCHG_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::i32, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_swap:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_swap_8>> - Complexity = 13
               // Dst: (ATOMIC_RMW8_U_XCHG_I32_A64:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i32] }:$val)
/*  8642*/    /*Scope*/ 17, /*->8660*/
/*  8643*/     OPC_CheckPredicate2,  // Predicate_atomic_swap_16
/*  8644*/     OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  8645*/     OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*  8647*/     OPC_EmitMergeInputChains1_0,
/*  8648*/     OPC_EmitInteger32, 0, 
/*  8650*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_XCHG_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::i32, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_swap:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_swap_16>> - Complexity = 13
               // Dst: (ATOMIC_RMW16_U_XCHG_I32_A64:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i32] }:$val)
/*  8660*/    0, /*End of Scope*/
/*  8661*/   /*SwitchType*/ 17, MVT::i64,// ->8680
/*  8663*/    OPC_CheckPredicate6,  // Predicate_atomic_swap_64
/*  8664*/    OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  8665*/    OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*  8667*/    OPC_EmitMergeInputChains1_0,
/*  8668*/    OPC_EmitInteger32, 0, 
/*  8670*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW_XCHG_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                  MVT::i64, 4/*#Ops*/, 5, 3, 4, 2, 
              // Src: (atomic_swap:{ *:[i64] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), i64:{ *:[i64] }:$val)<<P:Predicate_atomic_swap_64>> - Complexity = 13
              // Dst: (ATOMIC_RMW_XCHG_I64_A64:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i64] }:$val)
/*  8680*/   0, // EndSwitchType
/*  8681*/  0, /*End of Scope*/
/*  8682*/ /*SwitchOpcode*/ 127|128,1/*255*/, TARGET_VAL(ISD::ATOMIC_CMP_SWAP),// ->8941
/*  8686*/  OPC_RecordMemRef,
/*  8687*/  OPC_RecordNode, // #0 = 'atomic_cmp_swap' chained node
/*  8688*/  OPC_RecordChild1, // #1 = $AddrOps32:offset:addr
/*  8689*/  OPC_Scope, 124, /*->8815*/ // 2 children in Scope
/*  8691*/   OPC_CheckChild1TypeI32,
/*  8692*/   OPC_RecordChild2, // #2 = $exp
/*  8693*/   OPC_RecordChild3, // #3 = $new
/*  8694*/   OPC_SwitchType /*2 cases */, 97, MVT::i32,// ->8794
/*  8697*/    OPC_Scope, 18, /*->8717*/ // 5 children in Scope
/*  8699*/     OPC_CheckPredicate3,  // Predicate_atomic_cmp_swap_32
/*  8700*/     OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  8701*/     OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #4 #5
/*  8703*/     OPC_EmitMergeInputChains1_0,
/*  8704*/     OPC_EmitInteger32, 0, 
/*  8706*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW_CMPXCHG_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::i32, 5/*#Ops*/, 6, 4, 5, 2, 3, 
               // Src: (atomic_cmp_swap:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), i32:{ *:[i32] }:$exp, i32:{ *:[i32] }:$new)<<P:Predicate_atomic_cmp_swap_32>> - Complexity = 13
               // Dst: (ATOMIC_RMW_CMPXCHG_I32_A32:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i32] }:$exp, ?:{ *:[i32] }:$new)
/*  8717*/    /*Scope*/ 18, /*->8736*/
/*  8718*/     OPC_CheckPredicate1,  // Predicate_atomic_cmp_swap_8
/*  8719*/     OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  8720*/     OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #4 #5
/*  8722*/     OPC_EmitMergeInputChains1_0,
/*  8723*/     OPC_EmitInteger32, 0, 
/*  8725*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_CMPXCHG_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::i32, 5/*#Ops*/, 6, 4, 5, 2, 3, 
               // Src: (atomic_cmp_swap:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), i32:{ *:[i32] }:$exp, i32:{ *:[i32] }:$new)<<P:Predicate_atomic_cmp_swap_8>> - Complexity = 13
               // Dst: (ATOMIC_RMW8_U_CMPXCHG_I32_A32:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i32] }:$exp, ?:{ *:[i32] }:$new)
/*  8736*/    /*Scope*/ 18, /*->8755*/
/*  8737*/     OPC_CheckPredicate2,  // Predicate_atomic_cmp_swap_16
/*  8738*/     OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  8739*/     OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #4 #5
/*  8741*/     OPC_EmitMergeInputChains1_0,
/*  8742*/     OPC_EmitInteger32, 0, 
/*  8744*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_CMPXCHG_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::i32, 5/*#Ops*/, 6, 4, 5, 2, 3, 
               // Src: (atomic_cmp_swap:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), i32:{ *:[i32] }:$exp, i32:{ *:[i32] }:$new)<<P:Predicate_atomic_cmp_swap_16>> - Complexity = 13
               // Dst: (ATOMIC_RMW16_U_CMPXCHG_I32_A32:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i32] }:$exp, ?:{ *:[i32] }:$new)
/*  8755*/    /*Scope*/ 18, /*->8774*/
/*  8756*/     OPC_CheckPredicate1,  // Predicate_atomic_cmp_swap_8
/*  8757*/     OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  8758*/     OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #4 #5
/*  8760*/     OPC_EmitMergeInputChains1_0,
/*  8761*/     OPC_EmitInteger32, 0, 
/*  8763*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_CMPXCHG_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::i32, 5/*#Ops*/, 6, 4, 5, 2, 3, 
               // Src: (atomic_cmp_swap:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), i32:{ *:[i32] }:$exp, i32:{ *:[i32] }:$new)<<P:Predicate_atomic_cmp_swap_8>> - Complexity = 13
               // Dst: (ATOMIC_RMW8_U_CMPXCHG_I32_A32:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i32] }:$exp, ?:{ *:[i32] }:$new)
/*  8774*/    /*Scope*/ 18, /*->8793*/
/*  8775*/     OPC_CheckPredicate2,  // Predicate_atomic_cmp_swap_16
/*  8776*/     OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  8777*/     OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #4 #5
/*  8779*/     OPC_EmitMergeInputChains1_0,
/*  8780*/     OPC_EmitInteger32, 0, 
/*  8782*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_CMPXCHG_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::i32, 5/*#Ops*/, 6, 4, 5, 2, 3, 
               // Src: (atomic_cmp_swap:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), i32:{ *:[i32] }:$exp, i32:{ *:[i32] }:$new)<<P:Predicate_atomic_cmp_swap_16>> - Complexity = 13
               // Dst: (ATOMIC_RMW16_U_CMPXCHG_I32_A32:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i32] }:$exp, ?:{ *:[i32] }:$new)
/*  8793*/    0, /*End of Scope*/
/*  8794*/   /*SwitchType*/ 18, MVT::i64,// ->8814
/*  8796*/    OPC_CheckPredicate6,  // Predicate_atomic_cmp_swap_64
/*  8797*/    OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  8798*/    OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #4 #5
/*  8800*/    OPC_EmitMergeInputChains1_0,
/*  8801*/    OPC_EmitInteger32, 0, 
/*  8803*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW_CMPXCHG_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                  MVT::i64, 5/*#Ops*/, 6, 4, 5, 2, 3, 
              // Src: (atomic_cmp_swap:{ *:[i64] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), i64:{ *:[i64] }:$exp, i64:{ *:[i64] }:$new)<<P:Predicate_atomic_cmp_swap_64>> - Complexity = 13
              // Dst: (ATOMIC_RMW_CMPXCHG_I64_A32:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i64] }:$exp, ?:{ *:[i64] }:$new)
/*  8814*/   0, // EndSwitchType
/*  8815*/  /*Scope*/ 124, /*->8940*/
/*  8816*/   OPC_CheckChild1TypeI64,
/*  8817*/   OPC_RecordChild2, // #2 = $exp
/*  8818*/   OPC_RecordChild3, // #3 = $new
/*  8819*/   OPC_SwitchType /*2 cases */, 97, MVT::i32,// ->8919
/*  8822*/    OPC_Scope, 18, /*->8842*/ // 5 children in Scope
/*  8824*/     OPC_CheckPredicate3,  // Predicate_atomic_cmp_swap_32
/*  8825*/     OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  8826*/     OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #4 #5
/*  8828*/     OPC_EmitMergeInputChains1_0,
/*  8829*/     OPC_EmitInteger32, 0, 
/*  8831*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW_CMPXCHG_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::i32, 5/*#Ops*/, 6, 4, 5, 2, 3, 
               // Src: (atomic_cmp_swap:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), i32:{ *:[i32] }:$exp, i32:{ *:[i32] }:$new)<<P:Predicate_atomic_cmp_swap_32>> - Complexity = 13
               // Dst: (ATOMIC_RMW_CMPXCHG_I32_A64:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i32] }:$exp, ?:{ *:[i32] }:$new)
/*  8842*/    /*Scope*/ 18, /*->8861*/
/*  8843*/     OPC_CheckPredicate1,  // Predicate_atomic_cmp_swap_8
/*  8844*/     OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  8845*/     OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #4 #5
/*  8847*/     OPC_EmitMergeInputChains1_0,
/*  8848*/     OPC_EmitInteger32, 0, 
/*  8850*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_CMPXCHG_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::i32, 5/*#Ops*/, 6, 4, 5, 2, 3, 
               // Src: (atomic_cmp_swap:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), i32:{ *:[i32] }:$exp, i32:{ *:[i32] }:$new)<<P:Predicate_atomic_cmp_swap_8>> - Complexity = 13
               // Dst: (ATOMIC_RMW8_U_CMPXCHG_I32_A64:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i32] }:$exp, ?:{ *:[i32] }:$new)
/*  8861*/    /*Scope*/ 18, /*->8880*/
/*  8862*/     OPC_CheckPredicate2,  // Predicate_atomic_cmp_swap_16
/*  8863*/     OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  8864*/     OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #4 #5
/*  8866*/     OPC_EmitMergeInputChains1_0,
/*  8867*/     OPC_EmitInteger32, 0, 
/*  8869*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_CMPXCHG_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::i32, 5/*#Ops*/, 6, 4, 5, 2, 3, 
               // Src: (atomic_cmp_swap:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), i32:{ *:[i32] }:$exp, i32:{ *:[i32] }:$new)<<P:Predicate_atomic_cmp_swap_16>> - Complexity = 13
               // Dst: (ATOMIC_RMW16_U_CMPXCHG_I32_A64:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i32] }:$exp, ?:{ *:[i32] }:$new)
/*  8880*/    /*Scope*/ 18, /*->8899*/
/*  8881*/     OPC_CheckPredicate1,  // Predicate_atomic_cmp_swap_8
/*  8882*/     OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  8883*/     OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #4 #5
/*  8885*/     OPC_EmitMergeInputChains1_0,
/*  8886*/     OPC_EmitInteger32, 0, 
/*  8888*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_CMPXCHG_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::i32, 5/*#Ops*/, 6, 4, 5, 2, 3, 
               // Src: (atomic_cmp_swap:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), i32:{ *:[i32] }:$exp, i32:{ *:[i32] }:$new)<<P:Predicate_atomic_cmp_swap_8>> - Complexity = 13
               // Dst: (ATOMIC_RMW8_U_CMPXCHG_I32_A64:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i32] }:$exp, ?:{ *:[i32] }:$new)
/*  8899*/    /*Scope*/ 18, /*->8918*/
/*  8900*/     OPC_CheckPredicate2,  // Predicate_atomic_cmp_swap_16
/*  8901*/     OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  8902*/     OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #4 #5
/*  8904*/     OPC_EmitMergeInputChains1_0,
/*  8905*/     OPC_EmitInteger32, 0, 
/*  8907*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_CMPXCHG_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::i32, 5/*#Ops*/, 6, 4, 5, 2, 3, 
               // Src: (atomic_cmp_swap:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), i32:{ *:[i32] }:$exp, i32:{ *:[i32] }:$new)<<P:Predicate_atomic_cmp_swap_16>> - Complexity = 13
               // Dst: (ATOMIC_RMW16_U_CMPXCHG_I32_A64:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i32] }:$exp, ?:{ *:[i32] }:$new)
/*  8918*/    0, /*End of Scope*/
/*  8919*/   /*SwitchType*/ 18, MVT::i64,// ->8939
/*  8921*/    OPC_CheckPredicate6,  // Predicate_atomic_cmp_swap_64
/*  8922*/    OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  8923*/    OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #4 #5
/*  8925*/    OPC_EmitMergeInputChains1_0,
/*  8926*/    OPC_EmitInteger32, 0, 
/*  8928*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW_CMPXCHG_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                  MVT::i64, 5/*#Ops*/, 6, 4, 5, 2, 3, 
              // Src: (atomic_cmp_swap:{ *:[i64] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), i64:{ *:[i64] }:$exp, i64:{ *:[i64] }:$new)<<P:Predicate_atomic_cmp_swap_64>> - Complexity = 13
              // Dst: (ATOMIC_RMW_CMPXCHG_I64_A64:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i64] }:$exp, ?:{ *:[i64] }:$new)
/*  8939*/   0, // EndSwitchType
/*  8940*/  0, /*End of Scope*/
/*  8941*/ /*SwitchOpcode*/ 89, TARGET_VAL(ISD::BRCOND),// ->9033
/*  8944*/  OPC_RecordNode, // #0 = 'brcond' chained node
/*  8945*/  OPC_Scope, 69, /*->9016*/ // 2 children in Scope
/*  8947*/   OPC_MoveChild1,
/*  8948*/   OPC_SwitchOpcode /*2 cases */, 21, TARGET_VAL(ISD::XOR),// ->8973
/*  8952*/    OPC_RecordChild0, // #1 = $cond
/*  8953*/    OPC_MoveChild0,
/*  8954*/    OPC_CheckPredicate, 26, // Predicate_bool_node
/*  8956*/    OPC_MoveParent,
/*  8957*/    OPC_CheckChild1Integer, 2, 
/*  8959*/    OPC_CheckTypeI32,
/*  8960*/    OPC_MoveSibling2,
/*  8961*/    OPC_CheckOpcode, TARGET_VAL(ISD::BasicBlock),
/*  8964*/    OPC_RecordNode, // #2 = $dst
/*  8965*/    OPC_MoveParent,
/*  8966*/    OPC_EmitMergeInputChains1_0,
/*  8967*/    OPC_MorphNodeTo0Chain, TARGET_VAL(WebAssembly::BR_UNLESS),
                  2/*#Ops*/, 2, 1, 
              // Src: (brcond (xor:{ *:[i32] } I32:{ *:[i32] }<<P:Predicate_bool_node>>:$cond, 1:{ *:[i32] }), (bb:{ *:[Other] }):$dst) - Complexity = 12
              // Dst: (BR_UNLESS bb_op:{ *:[Other] }:$dst, I32:{ *:[i32] }:$cond)
/*  8973*/   /*SwitchOpcode*/ 39, TARGET_VAL(ISD::SETCC),// ->9015
/*  8976*/    OPC_RecordChild0, // #1 = $cond
/*  8977*/    OPC_CheckChild0TypeI32,
/*  8978*/    OPC_CheckChild1Integer, 0, 
/*  8980*/    OPC_CheckTypeI32,
/*  8981*/    OPC_Scope, 15, /*->8998*/ // 2 children in Scope
/*  8983*/     OPC_CheckChild2CondCode, ISD::SETNE,
/*  8985*/     OPC_MoveSibling2,
/*  8986*/     OPC_CheckOpcode, TARGET_VAL(ISD::BasicBlock),
/*  8989*/     OPC_RecordNode, // #2 = $dst
/*  8990*/     OPC_MoveParent,
/*  8991*/     OPC_EmitMergeInputChains1_0,
/*  8992*/     OPC_MorphNodeTo0Chain, TARGET_VAL(WebAssembly::BR_IF),
                   2/*#Ops*/, 2, 1, 
               // Src: (brcond (setcc:{ *:[i32] } I32:{ *:[i32] }:$cond, 0:{ *:[i32] }, SETNE:{ *:[Other] }), (bb:{ *:[Other] }):$dst) - Complexity = 11
               // Dst: (BR_IF bb_op:{ *:[Other] }:$dst, I32:{ *:[i32] }:$cond)
/*  8998*/    /*Scope*/ 15, /*->9014*/
/*  8999*/     OPC_CheckChild2CondCode, ISD::SETEQ,
/*  9001*/     OPC_MoveSibling2,
/*  9002*/     OPC_CheckOpcode, TARGET_VAL(ISD::BasicBlock),
/*  9005*/     OPC_RecordNode, // #2 = $dst
/*  9006*/     OPC_MoveParent,
/*  9007*/     OPC_EmitMergeInputChains1_0,
/*  9008*/     OPC_MorphNodeTo0Chain, TARGET_VAL(WebAssembly::BR_UNLESS),
                   2/*#Ops*/, 2, 1, 
               // Src: (brcond (setcc:{ *:[i32] } I32:{ *:[i32] }:$cond, 0:{ *:[i32] }, SETEQ:{ *:[Other] }), (bb:{ *:[Other] }):$dst) - Complexity = 11
               // Dst: (BR_UNLESS bb_op:{ *:[Other] }:$dst, I32:{ *:[i32] }:$cond)
/*  9014*/    0, /*End of Scope*/
/*  9015*/   0, // EndSwitchOpcode
/*  9016*/  /*Scope*/ 15, /*->9032*/
/*  9017*/   OPC_RecordChild1, // #1 = $cond
/*  9018*/   OPC_CheckChild1TypeI32,
/*  9019*/   OPC_RecordChild2, // #2 = $dst
/*  9020*/   OPC_MoveChild2,
/*  9021*/   OPC_CheckOpcode, TARGET_VAL(ISD::BasicBlock),
/*  9024*/   OPC_MoveParent,
/*  9025*/   OPC_EmitMergeInputChains1_0,
/*  9026*/   OPC_MorphNodeTo0Chain, TARGET_VAL(WebAssembly::BR_IF),
                 2/*#Ops*/, 2, 1, 
             // Src: (brcond I32:{ *:[i32] }:$cond, (bb:{ *:[Other] }):$dst) - Complexity = 3
             // Dst: (BR_IF (bb:{ *:[Other] }):$dst, I32:{ *:[i32] }:$cond)
/*  9032*/  0, /*End of Scope*/
/*  9033*/ /*SwitchOpcode*/ 59, TARGET_VAL(ISD::SHL),// ->9095
/*  9036*/  OPC_RecordChild0, // #0 = $lhs
/*  9037*/  OPC_Scope, 31, /*->9070*/ // 2 children in Scope
/*  9039*/   OPC_MoveChild1,
/*  9040*/   OPC_SwitchType /*2 cases */, 12, MVT::i32,// ->9055
/*  9043*/    OPC_CheckAndImm, 31, 
/*  9045*/    OPC_RecordChild0, // #1 = $rhs
/*  9046*/    OPC_MoveParent,
/*  9047*/    OPC_CheckTypeI32,
/*  9048*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SHL_I32),
                  MVT::i32, 2/*#Ops*/, 0, 1, 
              // Src: (shl:{ *:[i32] } I32:{ *:[i32] }:$lhs, (and:{ *:[i32] } I32:{ *:[i32] }:$rhs, 31:{ *:[i32] })) - Complexity = 11
              // Dst: (SHL_I32:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs)
/*  9055*/   /*SwitchType*/ 12, MVT::i64,// ->9069
/*  9057*/    OPC_CheckAndImm, 63, 
/*  9059*/    OPC_RecordChild0, // #1 = $rhs
/*  9060*/    OPC_MoveParent,
/*  9061*/    OPC_CheckTypeI64,
/*  9062*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SHL_I64),
                  MVT::i64, 2/*#Ops*/, 0, 1, 
              // Src: (shl:{ *:[i64] } I64:{ *:[i64] }:$lhs, (and:{ *:[i64] } I64:{ *:[i64] }:$rhs, 63:{ *:[i64] })) - Complexity = 11
              // Dst: (SHL_I64:{ *:[i64] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs)
/*  9069*/   0, // EndSwitchType
/*  9070*/  /*Scope*/ 23, /*->9094*/
/*  9071*/   OPC_RecordChild1, // #1 = $rhs
/*  9072*/   OPC_SwitchType /*2 cases */, 8, MVT::i32,// ->9083
/*  9075*/    OPC_CheckChild1TypeI32,
/*  9076*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SHL_I32),
                  MVT::i32, 2/*#Ops*/, 0, 1, 
              // Src: (shl:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs) - Complexity = 3
              // Dst: (SHL_I32:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs)
/*  9083*/   /*SwitchType*/ 8, MVT::i64,// ->9093
/*  9085*/    OPC_CheckChild1TypeI64,
/*  9086*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SHL_I64),
                  MVT::i64, 2/*#Ops*/, 0, 1, 
              // Src: (shl:{ *:[i64] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs) - Complexity = 3
              // Dst: (SHL_I64:{ *:[i64] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs)
/*  9093*/   0, // EndSwitchType
/*  9094*/  0, /*End of Scope*/
/*  9095*/ /*SwitchOpcode*/ 59, TARGET_VAL(ISD::SRA),// ->9157
/*  9098*/  OPC_RecordChild0, // #0 = $lhs
/*  9099*/  OPC_Scope, 31, /*->9132*/ // 2 children in Scope
/*  9101*/   OPC_MoveChild1,
/*  9102*/   OPC_SwitchType /*2 cases */, 12, MVT::i32,// ->9117
/*  9105*/    OPC_CheckAndImm, 31, 
/*  9107*/    OPC_RecordChild0, // #1 = $rhs
/*  9108*/    OPC_MoveParent,
/*  9109*/    OPC_CheckTypeI32,
/*  9110*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SHR_S_I32),
                  MVT::i32, 2/*#Ops*/, 0, 1, 
              // Src: (sra:{ *:[i32] } I32:{ *:[i32] }:$lhs, (and:{ *:[i32] } I32:{ *:[i32] }:$rhs, 31:{ *:[i32] })) - Complexity = 11
              // Dst: (SHR_S_I32:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs)
/*  9117*/   /*SwitchType*/ 12, MVT::i64,// ->9131
/*  9119*/    OPC_CheckAndImm, 63, 
/*  9121*/    OPC_RecordChild0, // #1 = $rhs
/*  9122*/    OPC_MoveParent,
/*  9123*/    OPC_CheckTypeI64,
/*  9124*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SHR_S_I64),
                  MVT::i64, 2/*#Ops*/, 0, 1, 
              // Src: (sra:{ *:[i64] } I64:{ *:[i64] }:$lhs, (and:{ *:[i64] } I64:{ *:[i64] }:$rhs, 63:{ *:[i64] })) - Complexity = 11
              // Dst: (SHR_S_I64:{ *:[i64] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs)
/*  9131*/   0, // EndSwitchType
/*  9132*/  /*Scope*/ 23, /*->9156*/
/*  9133*/   OPC_RecordChild1, // #1 = $rhs
/*  9134*/   OPC_SwitchType /*2 cases */, 8, MVT::i32,// ->9145
/*  9137*/    OPC_CheckChild1TypeI32,
/*  9138*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SHR_S_I32),
                  MVT::i32, 2/*#Ops*/, 0, 1, 
              // Src: (sra:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs) - Complexity = 3
              // Dst: (SHR_S_I32:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs)
/*  9145*/   /*SwitchType*/ 8, MVT::i64,// ->9155
/*  9147*/    OPC_CheckChild1TypeI64,
/*  9148*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SHR_S_I64),
                  MVT::i64, 2/*#Ops*/, 0, 1, 
              // Src: (sra:{ *:[i64] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs) - Complexity = 3
              // Dst: (SHR_S_I64:{ *:[i64] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs)
/*  9155*/   0, // EndSwitchType
/*  9156*/  0, /*End of Scope*/
/*  9157*/ /*SwitchOpcode*/ 59, TARGET_VAL(ISD::SRL),// ->9219
/*  9160*/  OPC_RecordChild0, // #0 = $lhs
/*  9161*/  OPC_Scope, 31, /*->9194*/ // 2 children in Scope
/*  9163*/   OPC_MoveChild1,
/*  9164*/   OPC_SwitchType /*2 cases */, 12, MVT::i32,// ->9179
/*  9167*/    OPC_CheckAndImm, 31, 
/*  9169*/    OPC_RecordChild0, // #1 = $rhs
/*  9170*/    OPC_MoveParent,
/*  9171*/    OPC_CheckTypeI32,
/*  9172*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SHR_U_I32),
                  MVT::i32, 2/*#Ops*/, 0, 1, 
              // Src: (srl:{ *:[i32] } I32:{ *:[i32] }:$lhs, (and:{ *:[i32] } I32:{ *:[i32] }:$rhs, 31:{ *:[i32] })) - Complexity = 11
              // Dst: (SHR_U_I32:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs)
/*  9179*/   /*SwitchType*/ 12, MVT::i64,// ->9193
/*  9181*/    OPC_CheckAndImm, 63, 
/*  9183*/    OPC_RecordChild0, // #1 = $rhs
/*  9184*/    OPC_MoveParent,
/*  9185*/    OPC_CheckTypeI64,
/*  9186*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SHR_U_I64),
                  MVT::i64, 2/*#Ops*/, 0, 1, 
              // Src: (srl:{ *:[i64] } I64:{ *:[i64] }:$lhs, (and:{ *:[i64] } I64:{ *:[i64] }:$rhs, 63:{ *:[i64] })) - Complexity = 11
              // Dst: (SHR_U_I64:{ *:[i64] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs)
/*  9193*/   0, // EndSwitchType
/*  9194*/  /*Scope*/ 23, /*->9218*/
/*  9195*/   OPC_RecordChild1, // #1 = $rhs
/*  9196*/   OPC_SwitchType /*2 cases */, 8, MVT::i32,// ->9207
/*  9199*/    OPC_CheckChild1TypeI32,
/*  9200*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SHR_U_I32),
                  MVT::i32, 2/*#Ops*/, 0, 1, 
              // Src: (srl:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs) - Complexity = 3
              // Dst: (SHR_U_I32:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs)
/*  9207*/   /*SwitchType*/ 8, MVT::i64,// ->9217
/*  9209*/    OPC_CheckChild1TypeI64,
/*  9210*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SHR_U_I64),
                  MVT::i64, 2/*#Ops*/, 0, 1, 
              // Src: (srl:{ *:[i64] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs) - Complexity = 3
              // Dst: (SHR_U_I64:{ *:[i64] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs)
/*  9217*/   0, // EndSwitchType
/*  9218*/  0, /*End of Scope*/
/*  9219*/ /*SwitchOpcode*/ 59, TARGET_VAL(ISD::ROTL),// ->9281
/*  9222*/  OPC_RecordChild0, // #0 = $lhs
/*  9223*/  OPC_Scope, 31, /*->9256*/ // 2 children in Scope
/*  9225*/   OPC_MoveChild1,
/*  9226*/   OPC_SwitchType /*2 cases */, 12, MVT::i32,// ->9241
/*  9229*/    OPC_CheckAndImm, 31, 
/*  9231*/    OPC_RecordChild0, // #1 = $rhs
/*  9232*/    OPC_MoveParent,
/*  9233*/    OPC_CheckTypeI32,
/*  9234*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ROTL_I32),
                  MVT::i32, 2/*#Ops*/, 0, 1, 
              // Src: (rotl:{ *:[i32] } I32:{ *:[i32] }:$lhs, (and:{ *:[i32] } I32:{ *:[i32] }:$rhs, 31:{ *:[i32] })) - Complexity = 11
              // Dst: (ROTL_I32:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs)
/*  9241*/   /*SwitchType*/ 12, MVT::i64,// ->9255
/*  9243*/    OPC_CheckAndImm, 63, 
/*  9245*/    OPC_RecordChild0, // #1 = $rhs
/*  9246*/    OPC_MoveParent,
/*  9247*/    OPC_CheckTypeI64,
/*  9248*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ROTL_I64),
                  MVT::i64, 2/*#Ops*/, 0, 1, 
              // Src: (rotl:{ *:[i64] } I64:{ *:[i64] }:$lhs, (and:{ *:[i64] } I64:{ *:[i64] }:$rhs, 63:{ *:[i64] })) - Complexity = 11
              // Dst: (ROTL_I64:{ *:[i64] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs)
/*  9255*/   0, // EndSwitchType
/*  9256*/  /*Scope*/ 23, /*->9280*/
/*  9257*/   OPC_RecordChild1, // #1 = $rhs
/*  9258*/   OPC_SwitchType /*2 cases */, 8, MVT::i32,// ->9269
/*  9261*/    OPC_CheckChild1TypeI32,
/*  9262*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ROTL_I32),
                  MVT::i32, 2/*#Ops*/, 0, 1, 
              // Src: (rotl:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs) - Complexity = 3
              // Dst: (ROTL_I32:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs)
/*  9269*/   /*SwitchType*/ 8, MVT::i64,// ->9279
/*  9271*/    OPC_CheckChild1TypeI64,
/*  9272*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ROTL_I64),
                  MVT::i64, 2/*#Ops*/, 0, 1, 
              // Src: (rotl:{ *:[i64] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs) - Complexity = 3
              // Dst: (ROTL_I64:{ *:[i64] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs)
/*  9279*/   0, // EndSwitchType
/*  9280*/  0, /*End of Scope*/
/*  9281*/ /*SwitchOpcode*/ 59, TARGET_VAL(ISD::ROTR),// ->9343
/*  9284*/  OPC_RecordChild0, // #0 = $lhs
/*  9285*/  OPC_Scope, 31, /*->9318*/ // 2 children in Scope
/*  9287*/   OPC_MoveChild1,
/*  9288*/   OPC_SwitchType /*2 cases */, 12, MVT::i32,// ->9303
/*  9291*/    OPC_CheckAndImm, 31, 
/*  9293*/    OPC_RecordChild0, // #1 = $rhs
/*  9294*/    OPC_MoveParent,
/*  9295*/    OPC_CheckTypeI32,
/*  9296*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ROTR_I32),
                  MVT::i32, 2/*#Ops*/, 0, 1, 
              // Src: (rotr:{ *:[i32] } I32:{ *:[i32] }:$lhs, (and:{ *:[i32] } I32:{ *:[i32] }:$rhs, 31:{ *:[i32] })) - Complexity = 11
              // Dst: (ROTR_I32:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs)
/*  9303*/   /*SwitchType*/ 12, MVT::i64,// ->9317
/*  9305*/    OPC_CheckAndImm, 63, 
/*  9307*/    OPC_RecordChild0, // #1 = $rhs
/*  9308*/    OPC_MoveParent,
/*  9309*/    OPC_CheckTypeI64,
/*  9310*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ROTR_I64),
                  MVT::i64, 2/*#Ops*/, 0, 1, 
              // Src: (rotr:{ *:[i64] } I64:{ *:[i64] }:$lhs, (and:{ *:[i64] } I64:{ *:[i64] }:$rhs, 63:{ *:[i64] })) - Complexity = 11
              // Dst: (ROTR_I64:{ *:[i64] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs)
/*  9317*/   0, // EndSwitchType
/*  9318*/  /*Scope*/ 23, /*->9342*/
/*  9319*/   OPC_RecordChild1, // #1 = $rhs
/*  9320*/   OPC_SwitchType /*2 cases */, 8, MVT::i32,// ->9331
/*  9323*/    OPC_CheckChild1TypeI32,
/*  9324*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ROTR_I32),
                  MVT::i32, 2/*#Ops*/, 0, 1, 
              // Src: (rotr:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs) - Complexity = 3
              // Dst: (ROTR_I32:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs)
/*  9331*/   /*SwitchType*/ 8, MVT::i64,// ->9341
/*  9333*/    OPC_CheckChild1TypeI64,
/*  9334*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ROTR_I64),
                  MVT::i64, 2/*#Ops*/, 0, 1, 
              // Src: (rotr:{ *:[i64] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs) - Complexity = 3
              // Dst: (ROTR_I64:{ *:[i64] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs)
/*  9341*/   0, // EndSwitchType
/*  9342*/  0, /*End of Scope*/
/*  9343*/ /*SwitchOpcode*/ 120|128,3/*504*/, TARGET_VAL(ISD::SELECT),// ->9851
/*  9347*/  OPC_Scope, 107, /*->9456*/ // 8 children in Scope
/*  9349*/   OPC_MoveChild0,
/*  9350*/   OPC_CheckOpcode, TARGET_VAL(ISD::SETCC),
/*  9353*/   OPC_RecordChild0, // #0 = $cond
/*  9354*/   OPC_CheckChild0TypeI32,
/*  9355*/   OPC_CheckChild1Integer, 0, 
/*  9357*/   OPC_CheckTypeI32,
/*  9358*/   OPC_Scope, 47, /*->9407*/ // 2 children in Scope
/*  9360*/    OPC_CheckChild2CondCode, ISD::SETNE,
/*  9362*/    OPC_MoveParent,
/*  9363*/    OPC_RecordChild1, // #1 = $lhs
/*  9364*/    OPC_RecordChild2, // #2 = $rhs
/*  9365*/    OPC_SwitchType /*4 cases */, 8, MVT::i32,// ->9376
/*  9368*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SELECT_I32),
                   MVT::i32, 3/*#Ops*/, 1, 2, 0, 
               // Src: (select:{ *:[i32] } (setcc:{ *:[i32] } I32:{ *:[i32] }:$cond, 0:{ *:[i32] }, SETNE:{ *:[Other] }), I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs) - Complexity = 11
               // Dst: (SELECT_I32:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs, I32:{ *:[i32] }:$cond)
/*  9376*/    /*SwitchType*/ 8, MVT::i64,// ->9386
/*  9378*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SELECT_I64),
                   MVT::i64, 3/*#Ops*/, 1, 2, 0, 
               // Src: (select:{ *:[i64] } (setcc:{ *:[i32] } I32:{ *:[i32] }:$cond, 0:{ *:[i32] }, SETNE:{ *:[Other] }), I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs) - Complexity = 11
               // Dst: (SELECT_I64:{ *:[i64] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs, I32:{ *:[i32] }:$cond)
/*  9386*/    /*SwitchType*/ 8, MVT::funcref,// ->9396
/*  9388*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SELECT_FUNCREF),
                   MVT::funcref, 3/*#Ops*/, 1, 2, 0, 
               // Src: (select:{ *:[funcref] } (setcc:{ *:[i32] } I32:{ *:[i32] }:$cond, 0:{ *:[i32] }, SETNE:{ *:[Other] }), FUNCREF:{ *:[funcref] }:$lhs, FUNCREF:{ *:[funcref] }:$rhs) - Complexity = 11
               // Dst: (SELECT_FUNCREF:{ *:[funcref] } FUNCREF:{ *:[funcref] }:$lhs, FUNCREF:{ *:[funcref] }:$rhs, I32:{ *:[i32] }:$cond)
/*  9396*/    /*SwitchType*/ 8, MVT::externref,// ->9406
/*  9398*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SELECT_EXTERNREF),
                   MVT::externref, 3/*#Ops*/, 1, 2, 0, 
               // Src: (select:{ *:[externref] } (setcc:{ *:[i32] } I32:{ *:[i32] }:$cond, 0:{ *:[i32] }, SETNE:{ *:[Other] }), EXTERNREF:{ *:[externref] }:$lhs, EXTERNREF:{ *:[externref] }:$rhs) - Complexity = 11
               // Dst: (SELECT_EXTERNREF:{ *:[externref] } EXTERNREF:{ *:[externref] }:$lhs, EXTERNREF:{ *:[externref] }:$rhs, I32:{ *:[i32] }:$cond)
/*  9406*/    0, // EndSwitchType
/*  9407*/   /*Scope*/ 47, /*->9455*/
/*  9408*/    OPC_CheckChild2CondCode, ISD::SETEQ,
/*  9410*/    OPC_MoveParent,
/*  9411*/    OPC_RecordChild1, // #1 = $lhs
/*  9412*/    OPC_RecordChild2, // #2 = $rhs
/*  9413*/    OPC_SwitchType /*4 cases */, 8, MVT::i32,// ->9424
/*  9416*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SELECT_I32),
                   MVT::i32, 3/*#Ops*/, 2, 1, 0, 
               // Src: (select:{ *:[i32] } (setcc:{ *:[i32] } I32:{ *:[i32] }:$cond, 0:{ *:[i32] }, SETEQ:{ *:[Other] }), I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs) - Complexity = 11
               // Dst: (SELECT_I32:{ *:[i32] } I32:{ *:[i32] }:$rhs, I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$cond)
/*  9424*/    /*SwitchType*/ 8, MVT::i64,// ->9434
/*  9426*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SELECT_I64),
                   MVT::i64, 3/*#Ops*/, 2, 1, 0, 
               // Src: (select:{ *:[i64] } (setcc:{ *:[i32] } I32:{ *:[i32] }:$cond, 0:{ *:[i32] }, SETEQ:{ *:[Other] }), I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs) - Complexity = 11
               // Dst: (SELECT_I64:{ *:[i64] } I64:{ *:[i64] }:$rhs, I64:{ *:[i64] }:$lhs, I32:{ *:[i32] }:$cond)
/*  9434*/    /*SwitchType*/ 8, MVT::funcref,// ->9444
/*  9436*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SELECT_FUNCREF),
                   MVT::funcref, 3/*#Ops*/, 2, 1, 0, 
               // Src: (select:{ *:[funcref] } (setcc:{ *:[i32] } I32:{ *:[i32] }:$cond, 0:{ *:[i32] }, SETEQ:{ *:[Other] }), FUNCREF:{ *:[funcref] }:$lhs, FUNCREF:{ *:[funcref] }:$rhs) - Complexity = 11
               // Dst: (SELECT_FUNCREF:{ *:[funcref] } FUNCREF:{ *:[funcref] }:$rhs, FUNCREF:{ *:[funcref] }:$lhs, I32:{ *:[i32] }:$cond)
/*  9444*/    /*SwitchType*/ 8, MVT::externref,// ->9454
/*  9446*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SELECT_EXTERNREF),
                   MVT::externref, 3/*#Ops*/, 2, 1, 0, 
               // Src: (select:{ *:[externref] } (setcc:{ *:[i32] } I32:{ *:[i32] }:$cond, 0:{ *:[i32] }, SETEQ:{ *:[Other] }), EXTERNREF:{ *:[externref] }:$lhs, EXTERNREF:{ *:[externref] }:$rhs) - Complexity = 11
               // Dst: (SELECT_EXTERNREF:{ *:[externref] } EXTERNREF:{ *:[externref] }:$rhs, EXTERNREF:{ *:[externref] }:$lhs, I32:{ *:[i32] }:$cond)
/*  9454*/    0, // EndSwitchType
/*  9455*/   0, /*End of Scope*/
/*  9456*/  /*Scope*/ 48, /*->9505*/
/*  9457*/   OPC_RecordChild0, // #0 = $cond
/*  9458*/   OPC_CheckChild0TypeI32,
/*  9459*/   OPC_RecordChild1, // #1 = $lhs
/*  9460*/   OPC_RecordChild2, // #2 = $rhs
/*  9461*/   OPC_SwitchType /*4 cases */, 8, MVT::i32,// ->9472
/*  9464*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SELECT_I32),
                  MVT::i32, 3/*#Ops*/, 1, 2, 0, 
              // Src: (select:{ *:[i32] } I32:{ *:[i32] }:$cond, I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs) - Complexity = 3
              // Dst: (SELECT_I32:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs, I32:{ *:[i32] }:$cond)
/*  9472*/   /*SwitchType*/ 8, MVT::i64,// ->9482
/*  9474*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SELECT_I64),
                  MVT::i64, 3/*#Ops*/, 1, 2, 0, 
              // Src: (select:{ *:[i64] } I32:{ *:[i32] }:$cond, I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs) - Complexity = 3
              // Dst: (SELECT_I64:{ *:[i64] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs, I32:{ *:[i32] }:$cond)
/*  9482*/   /*SwitchType*/ 9, MVT::funcref,// ->9493
/*  9484*/    OPC_CheckPatternPredicate5, // (Subtarget->hasReferenceTypes())
/*  9485*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SELECT_FUNCREF),
                  MVT::funcref, 3/*#Ops*/, 1, 2, 0, 
              // Src: (select:{ *:[funcref] } I32:{ *:[i32] }:$cond, FUNCREF:{ *:[funcref] }:$lhs, FUNCREF:{ *:[funcref] }:$rhs) - Complexity = 3
              // Dst: (SELECT_FUNCREF:{ *:[funcref] } FUNCREF:{ *:[funcref] }:$lhs, FUNCREF:{ *:[funcref] }:$rhs, I32:{ *:[i32] }:$cond)
/*  9493*/   /*SwitchType*/ 9, MVT::externref,// ->9504
/*  9495*/    OPC_CheckPatternPredicate5, // (Subtarget->hasReferenceTypes())
/*  9496*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SELECT_EXTERNREF),
                  MVT::externref, 3/*#Ops*/, 1, 2, 0, 
              // Src: (select:{ *:[externref] } I32:{ *:[i32] }:$cond, EXTERNREF:{ *:[externref] }:$lhs, EXTERNREF:{ *:[externref] }:$rhs) - Complexity = 3
              // Dst: (SELECT_EXTERNREF:{ *:[externref] } EXTERNREF:{ *:[externref] }:$lhs, EXTERNREF:{ *:[externref] }:$rhs, I32:{ *:[i32] }:$cond)
/*  9504*/   0, // EndSwitchType
/*  9505*/  /*Scope*/ 67, /*->9573*/
/*  9506*/   OPC_MoveChild0,
/*  9507*/   OPC_CheckOpcode, TARGET_VAL(ISD::SETCC),
/*  9510*/   OPC_RecordChild0, // #0 = $cond
/*  9511*/   OPC_CheckChild0TypeI32,
/*  9512*/   OPC_CheckChild1Integer, 0, 
/*  9514*/   OPC_CheckTypeI32,
/*  9515*/   OPC_Scope, 27, /*->9544*/ // 2 children in Scope
/*  9517*/    OPC_CheckChild2CondCode, ISD::SETNE,
/*  9519*/    OPC_MoveParent,
/*  9520*/    OPC_RecordChild1, // #1 = $lhs
/*  9521*/    OPC_RecordChild2, // #2 = $rhs
/*  9522*/    OPC_SwitchType /*2 cases */, 8, MVT::f32,// ->9533
/*  9525*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SELECT_F32),
                   MVT::f32, 3/*#Ops*/, 1, 2, 0, 
               // Src: (select:{ *:[f32] } (setcc:{ *:[i32] } I32:{ *:[i32] }:$cond, 0:{ *:[i32] }, SETNE:{ *:[Other] }), F32:{ *:[f32] }:$lhs, F32:{ *:[f32] }:$rhs) - Complexity = 11
               // Dst: (SELECT_F32:{ *:[f32] } F32:{ *:[f32] }:$lhs, F32:{ *:[f32] }:$rhs, I32:{ *:[i32] }:$cond)
/*  9533*/    /*SwitchType*/ 8, MVT::f64,// ->9543
/*  9535*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SELECT_F64),
                   MVT::f64, 3/*#Ops*/, 1, 2, 0, 
               // Src: (select:{ *:[f64] } (setcc:{ *:[i32] } I32:{ *:[i32] }:$cond, 0:{ *:[i32] }, SETNE:{ *:[Other] }), F64:{ *:[f64] }:$lhs, F64:{ *:[f64] }:$rhs) - Complexity = 11
               // Dst: (SELECT_F64:{ *:[f64] } F64:{ *:[f64] }:$lhs, F64:{ *:[f64] }:$rhs, I32:{ *:[i32] }:$cond)
/*  9543*/    0, // EndSwitchType
/*  9544*/   /*Scope*/ 27, /*->9572*/
/*  9545*/    OPC_CheckChild2CondCode, ISD::SETEQ,
/*  9547*/    OPC_MoveParent,
/*  9548*/    OPC_RecordChild1, // #1 = $lhs
/*  9549*/    OPC_RecordChild2, // #2 = $rhs
/*  9550*/    OPC_SwitchType /*2 cases */, 8, MVT::f32,// ->9561
/*  9553*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SELECT_F32),
                   MVT::f32, 3/*#Ops*/, 2, 1, 0, 
               // Src: (select:{ *:[f32] } (setcc:{ *:[i32] } I32:{ *:[i32] }:$cond, 0:{ *:[i32] }, SETEQ:{ *:[Other] }), F32:{ *:[f32] }:$lhs, F32:{ *:[f32] }:$rhs) - Complexity = 11
               // Dst: (SELECT_F32:{ *:[f32] } F32:{ *:[f32] }:$rhs, F32:{ *:[f32] }:$lhs, I32:{ *:[i32] }:$cond)
/*  9561*/    /*SwitchType*/ 8, MVT::f64,// ->9571
/*  9563*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SELECT_F64),
                   MVT::f64, 3/*#Ops*/, 2, 1, 0, 
               // Src: (select:{ *:[f64] } (setcc:{ *:[i32] } I32:{ *:[i32] }:$cond, 0:{ *:[i32] }, SETEQ:{ *:[Other] }), F64:{ *:[f64] }:$lhs, F64:{ *:[f64] }:$rhs) - Complexity = 11
               // Dst: (SELECT_F64:{ *:[f64] } F64:{ *:[f64] }:$rhs, F64:{ *:[f64] }:$lhs, I32:{ *:[i32] }:$cond)
/*  9571*/    0, // EndSwitchType
/*  9572*/   0, /*End of Scope*/
/*  9573*/  /*Scope*/ 26, /*->9600*/
/*  9574*/   OPC_RecordChild0, // #0 = $cond
/*  9575*/   OPC_CheckChild0TypeI32,
/*  9576*/   OPC_RecordChild1, // #1 = $lhs
/*  9577*/   OPC_RecordChild2, // #2 = $rhs
/*  9578*/   OPC_SwitchType /*2 cases */, 8, MVT::f32,// ->9589
/*  9581*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SELECT_F32),
                  MVT::f32, 3/*#Ops*/, 1, 2, 0, 
              // Src: (select:{ *:[f32] } I32:{ *:[i32] }:$cond, F32:{ *:[f32] }:$lhs, F32:{ *:[f32] }:$rhs) - Complexity = 3
              // Dst: (SELECT_F32:{ *:[f32] } F32:{ *:[f32] }:$lhs, F32:{ *:[f32] }:$rhs, I32:{ *:[i32] }:$cond)
/*  9589*/   /*SwitchType*/ 8, MVT::f64,// ->9599
/*  9591*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SELECT_F64),
                  MVT::f64, 3/*#Ops*/, 1, 2, 0, 
              // Src: (select:{ *:[f64] } I32:{ *:[i32] }:$cond, F64:{ *:[f64] }:$lhs, F64:{ *:[f64] }:$rhs) - Complexity = 3
              // Dst: (SELECT_F64:{ *:[f64] } F64:{ *:[f64] }:$lhs, F64:{ *:[f64] }:$rhs, I32:{ *:[i32] }:$cond)
/*  9599*/   0, // EndSwitchType
/*  9600*/  /*Scope*/ 107, /*->9708*/
/*  9601*/   OPC_MoveChild0,
/*  9602*/   OPC_CheckOpcode, TARGET_VAL(ISD::SETCC),
/*  9605*/   OPC_RecordChild0, // #0 = $cond
/*  9606*/   OPC_CheckChild0TypeI32,
/*  9607*/   OPC_CheckChild1Integer, 0, 
/*  9609*/   OPC_CheckTypeI32,
/*  9610*/   OPC_Scope, 47, /*->9659*/ // 2 children in Scope
/*  9612*/    OPC_CheckChild2CondCode, ISD::SETNE,
/*  9614*/    OPC_MoveParent,
/*  9615*/    OPC_RecordChild1, // #1 = $lhs
/*  9616*/    OPC_RecordChild2, // #2 = $rhs
/*  9617*/    OPC_SwitchType /*4 cases */, 8, MVT::v16i8,// ->9628
/*  9620*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SELECT_V128),
                   MVT::v16i8, 3/*#Ops*/, 1, 2, 0, 
               // Src: (select:{ *:[v16i8] } (setcc:{ *:[i32] } I32:{ *:[i32] }:$cond, 0:{ *:[i32] }, SETNE:{ *:[Other] }), V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs) - Complexity = 11
               // Dst: (SELECT_V128:{ *:[v16i8] } ?:{ *:[v16i8] }:$lhs, ?:{ *:[v16i8] }:$rhs, ?:{ *:[i32] }:$cond)
/*  9628*/    /*SwitchType*/ 8, MVT::v8i16,// ->9638
/*  9630*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SELECT_V128),
                   MVT::v8i16, 3/*#Ops*/, 1, 2, 0, 
               // Src: (select:{ *:[v8i16] } (setcc:{ *:[i32] } I32:{ *:[i32] }:$cond, 0:{ *:[i32] }, SETNE:{ *:[Other] }), V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs) - Complexity = 11
               // Dst: (SELECT_V128:{ *:[v8i16] } ?:{ *:[v8i16] }:$lhs, ?:{ *:[v8i16] }:$rhs, ?:{ *:[i32] }:$cond)
/*  9638*/    /*SwitchType*/ 8, MVT::v4i32,// ->9648
/*  9640*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SELECT_V128),
                   MVT::v4i32, 3/*#Ops*/, 1, 2, 0, 
               // Src: (select:{ *:[v4i32] } (setcc:{ *:[i32] } I32:{ *:[i32] }:$cond, 0:{ *:[i32] }, SETNE:{ *:[Other] }), V128:{ *:[v4i32] }:$lhs, V128:{ *:[v4i32] }:$rhs) - Complexity = 11
               // Dst: (SELECT_V128:{ *:[v4i32] } ?:{ *:[v4i32] }:$lhs, ?:{ *:[v4i32] }:$rhs, ?:{ *:[i32] }:$cond)
/*  9648*/    /*SwitchType*/ 8, MVT::v2i64,// ->9658
/*  9650*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SELECT_V128),
                   MVT::v2i64, 3/*#Ops*/, 1, 2, 0, 
               // Src: (select:{ *:[v2i64] } (setcc:{ *:[i32] } I32:{ *:[i32] }:$cond, 0:{ *:[i32] }, SETNE:{ *:[Other] }), V128:{ *:[v2i64] }:$lhs, V128:{ *:[v2i64] }:$rhs) - Complexity = 11
               // Dst: (SELECT_V128:{ *:[v2i64] } ?:{ *:[v2i64] }:$lhs, ?:{ *:[v2i64] }:$rhs, ?:{ *:[i32] }:$cond)
/*  9658*/    0, // EndSwitchType
/*  9659*/   /*Scope*/ 47, /*->9707*/
/*  9660*/    OPC_CheckChild2CondCode, ISD::SETEQ,
/*  9662*/    OPC_MoveParent,
/*  9663*/    OPC_RecordChild1, // #1 = $lhs
/*  9664*/    OPC_RecordChild2, // #2 = $rhs
/*  9665*/    OPC_SwitchType /*4 cases */, 8, MVT::v16i8,// ->9676
/*  9668*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SELECT_V128),
                   MVT::v16i8, 3/*#Ops*/, 2, 1, 0, 
               // Src: (select:{ *:[v16i8] } (setcc:{ *:[i32] } I32:{ *:[i32] }:$cond, 0:{ *:[i32] }, SETEQ:{ *:[Other] }), V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs) - Complexity = 11
               // Dst: (SELECT_V128:{ *:[v16i8] } ?:{ *:[v16i8] }:$rhs, ?:{ *:[v16i8] }:$lhs, ?:{ *:[i32] }:$cond)
/*  9676*/    /*SwitchType*/ 8, MVT::v8i16,// ->9686
/*  9678*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SELECT_V128),
                   MVT::v8i16, 3/*#Ops*/, 2, 1, 0, 
               // Src: (select:{ *:[v8i16] } (setcc:{ *:[i32] } I32:{ *:[i32] }:$cond, 0:{ *:[i32] }, SETEQ:{ *:[Other] }), V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs) - Complexity = 11
               // Dst: (SELECT_V128:{ *:[v8i16] } ?:{ *:[v8i16] }:$rhs, ?:{ *:[v8i16] }:$lhs, ?:{ *:[i32] }:$cond)
/*  9686*/    /*SwitchType*/ 8, MVT::v4i32,// ->9696
/*  9688*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SELECT_V128),
                   MVT::v4i32, 3/*#Ops*/, 2, 1, 0, 
               // Src: (select:{ *:[v4i32] } (setcc:{ *:[i32] } I32:{ *:[i32] }:$cond, 0:{ *:[i32] }, SETEQ:{ *:[Other] }), V128:{ *:[v4i32] }:$lhs, V128:{ *:[v4i32] }:$rhs) - Complexity = 11
               // Dst: (SELECT_V128:{ *:[v4i32] } ?:{ *:[v4i32] }:$rhs, ?:{ *:[v4i32] }:$lhs, ?:{ *:[i32] }:$cond)
/*  9696*/    /*SwitchType*/ 8, MVT::v2i64,// ->9706
/*  9698*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SELECT_V128),
                   MVT::v2i64, 3/*#Ops*/, 2, 1, 0, 
               // Src: (select:{ *:[v2i64] } (setcc:{ *:[i32] } I32:{ *:[i32] }:$cond, 0:{ *:[i32] }, SETEQ:{ *:[Other] }), V128:{ *:[v2i64] }:$lhs, V128:{ *:[v2i64] }:$rhs) - Complexity = 11
               // Dst: (SELECT_V128:{ *:[v2i64] } ?:{ *:[v2i64] }:$rhs, ?:{ *:[v2i64] }:$lhs, ?:{ *:[i32] }:$cond)
/*  9706*/    0, // EndSwitchType
/*  9707*/   0, /*End of Scope*/
/*  9708*/  /*Scope*/ 46, /*->9755*/
/*  9709*/   OPC_RecordChild0, // #0 = $cond
/*  9710*/   OPC_CheckChild0TypeI32,
/*  9711*/   OPC_RecordChild1, // #1 = $lhs
/*  9712*/   OPC_RecordChild2, // #2 = $rhs
/*  9713*/   OPC_SwitchType /*4 cases */, 8, MVT::v16i8,// ->9724
/*  9716*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SELECT_V128),
                  MVT::v16i8, 3/*#Ops*/, 1, 2, 0, 
              // Src: (select:{ *:[v16i8] } I32:{ *:[i32] }:$cond, V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs) - Complexity = 3
              // Dst: (SELECT_V128:{ *:[v16i8] } ?:{ *:[v16i8] }:$lhs, ?:{ *:[v16i8] }:$rhs, ?:{ *:[i32] }:$cond)
/*  9724*/   /*SwitchType*/ 8, MVT::v8i16,// ->9734
/*  9726*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SELECT_V128),
                  MVT::v8i16, 3/*#Ops*/, 1, 2, 0, 
              // Src: (select:{ *:[v8i16] } I32:{ *:[i32] }:$cond, V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs) - Complexity = 3
              // Dst: (SELECT_V128:{ *:[v8i16] } ?:{ *:[v8i16] }:$lhs, ?:{ *:[v8i16] }:$rhs, ?:{ *:[i32] }:$cond)
/*  9734*/   /*SwitchType*/ 8, MVT::v4i32,// ->9744
/*  9736*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SELECT_V128),
                  MVT::v4i32, 3/*#Ops*/, 1, 2, 0, 
              // Src: (select:{ *:[v4i32] } I32:{ *:[i32] }:$cond, V128:{ *:[v4i32] }:$lhs, V128:{ *:[v4i32] }:$rhs) - Complexity = 3
              // Dst: (SELECT_V128:{ *:[v4i32] } ?:{ *:[v4i32] }:$lhs, ?:{ *:[v4i32] }:$rhs, ?:{ *:[i32] }:$cond)
/*  9744*/   /*SwitchType*/ 8, MVT::v2i64,// ->9754
/*  9746*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SELECT_V128),
                  MVT::v2i64, 3/*#Ops*/, 1, 2, 0, 
              // Src: (select:{ *:[v2i64] } I32:{ *:[i32] }:$cond, V128:{ *:[v2i64] }:$lhs, V128:{ *:[v2i64] }:$rhs) - Complexity = 3
              // Dst: (SELECT_V128:{ *:[v2i64] } ?:{ *:[v2i64] }:$lhs, ?:{ *:[v2i64] }:$rhs, ?:{ *:[i32] }:$cond)
/*  9754*/   0, // EndSwitchType
/*  9755*/  /*Scope*/ 67, /*->9823*/
/*  9756*/   OPC_MoveChild0,
/*  9757*/   OPC_CheckOpcode, TARGET_VAL(ISD::SETCC),
/*  9760*/   OPC_RecordChild0, // #0 = $cond
/*  9761*/   OPC_CheckChild0TypeI32,
/*  9762*/   OPC_CheckChild1Integer, 0, 
/*  9764*/   OPC_CheckTypeI32,
/*  9765*/   OPC_Scope, 27, /*->9794*/ // 2 children in Scope
/*  9767*/    OPC_CheckChild2CondCode, ISD::SETNE,
/*  9769*/    OPC_MoveParent,
/*  9770*/    OPC_RecordChild1, // #1 = $lhs
/*  9771*/    OPC_RecordChild2, // #2 = $rhs
/*  9772*/    OPC_SwitchType /*2 cases */, 8, MVT::v4f32,// ->9783
/*  9775*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SELECT_V128),
                   MVT::v4f32, 3/*#Ops*/, 1, 2, 0, 
               // Src: (select:{ *:[v4f32] } (setcc:{ *:[i32] } I32:{ *:[i32] }:$cond, 0:{ *:[i32] }, SETNE:{ *:[Other] }), V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs) - Complexity = 11
               // Dst: (SELECT_V128:{ *:[v4f32] } ?:{ *:[v4f32] }:$lhs, ?:{ *:[v4f32] }:$rhs, ?:{ *:[i32] }:$cond)
/*  9783*/    /*SwitchType*/ 8, MVT::v2f64,// ->9793
/*  9785*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SELECT_V128),
                   MVT::v2f64, 3/*#Ops*/, 1, 2, 0, 
               // Src: (select:{ *:[v2f64] } (setcc:{ *:[i32] } I32:{ *:[i32] }:$cond, 0:{ *:[i32] }, SETNE:{ *:[Other] }), V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs) - Complexity = 11
               // Dst: (SELECT_V128:{ *:[v2f64] } ?:{ *:[v2f64] }:$lhs, ?:{ *:[v2f64] }:$rhs, ?:{ *:[i32] }:$cond)
/*  9793*/    0, // EndSwitchType
/*  9794*/   /*Scope*/ 27, /*->9822*/
/*  9795*/    OPC_CheckChild2CondCode, ISD::SETEQ,
/*  9797*/    OPC_MoveParent,
/*  9798*/    OPC_RecordChild1, // #1 = $lhs
/*  9799*/    OPC_RecordChild2, // #2 = $rhs
/*  9800*/    OPC_SwitchType /*2 cases */, 8, MVT::v4f32,// ->9811
/*  9803*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SELECT_V128),
                   MVT::v4f32, 3/*#Ops*/, 2, 1, 0, 
               // Src: (select:{ *:[v4f32] } (setcc:{ *:[i32] } I32:{ *:[i32] }:$cond, 0:{ *:[i32] }, SETEQ:{ *:[Other] }), V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs) - Complexity = 11
               // Dst: (SELECT_V128:{ *:[v4f32] } ?:{ *:[v4f32] }:$rhs, ?:{ *:[v4f32] }:$lhs, ?:{ *:[i32] }:$cond)
/*  9811*/    /*SwitchType*/ 8, MVT::v2f64,// ->9821
/*  9813*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SELECT_V128),
                   MVT::v2f64, 3/*#Ops*/, 2, 1, 0, 
               // Src: (select:{ *:[v2f64] } (setcc:{ *:[i32] } I32:{ *:[i32] }:$cond, 0:{ *:[i32] }, SETEQ:{ *:[Other] }), V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs) - Complexity = 11
               // Dst: (SELECT_V128:{ *:[v2f64] } ?:{ *:[v2f64] }:$rhs, ?:{ *:[v2f64] }:$lhs, ?:{ *:[i32] }:$cond)
/*  9821*/    0, // EndSwitchType
/*  9822*/   0, /*End of Scope*/
/*  9823*/  /*Scope*/ 26, /*->9850*/
/*  9824*/   OPC_RecordChild0, // #0 = $cond
/*  9825*/   OPC_CheckChild0TypeI32,
/*  9826*/   OPC_RecordChild1, // #1 = $lhs
/*  9827*/   OPC_RecordChild2, // #2 = $rhs
/*  9828*/   OPC_SwitchType /*2 cases */, 8, MVT::v4f32,// ->9839
/*  9831*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SELECT_V128),
                  MVT::v4f32, 3/*#Ops*/, 1, 2, 0, 
              // Src: (select:{ *:[v4f32] } I32:{ *:[i32] }:$cond, V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs) - Complexity = 3
              // Dst: (SELECT_V128:{ *:[v4f32] } ?:{ *:[v4f32] }:$lhs, ?:{ *:[v4f32] }:$rhs, ?:{ *:[i32] }:$cond)
/*  9839*/   /*SwitchType*/ 8, MVT::v2f64,// ->9849
/*  9841*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SELECT_V128),
                  MVT::v2f64, 3/*#Ops*/, 1, 2, 0, 
              // Src: (select:{ *:[v2f64] } I32:{ *:[i32] }:$cond, V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs) - Complexity = 3
              // Dst: (SELECT_V128:{ *:[v2f64] } ?:{ *:[v2f64] }:$lhs, ?:{ *:[v2f64] }:$rhs, ?:{ *:[i32] }:$cond)
/*  9849*/   0, // EndSwitchType
/*  9850*/  0, /*End of Scope*/
/*  9851*/ /*SwitchOpcode*/ 1|128,1/*129*/, TARGET_VAL(ISD::SIGN_EXTEND_INREG),// ->9984
/*  9855*/  OPC_Scope, 57, /*->9914*/ // 2 children in Scope
/*  9857*/   OPC_MoveChild0,
/*  9858*/   OPC_CheckOpcode, TARGET_VAL(ISD::EXTRACT_VECTOR_ELT),
/*  9861*/   OPC_RecordChild0, // #0 = $vec
/*  9862*/   OPC_Scope, 24, /*->9888*/ // 2 children in Scope
/*  9864*/    OPC_CheckChild0Type, MVT::v16i8,
/*  9866*/    OPC_RecordChild1, // #1 = $idx
/*  9867*/    OPC_MoveChild1,
/*  9868*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/*  9871*/    OPC_CheckPredicate, 15, // Predicate_LaneIdx16
/*  9873*/    OPC_CheckTypeI32,
/*  9874*/    OPC_MoveParent,
/*  9875*/    OPC_MoveSibling1,
/*  9876*/    OPC_CheckValueType, MVT::i8,
/*  9878*/    OPC_MoveParent,
/*  9879*/    OPC_CheckTypeI32,
/*  9880*/    OPC_EmitConvertToTarget1,
/*  9881*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::EXTRACT_LANE_I8x16_s),
                  MVT::i32, 2/*#Ops*/, 0, 2, 
              // Src: (sext_inreg:{ *:[i32] } (vector_extract:{ *:[i32] } V128:{ *:[v16i8] }:$vec, (imm:{ *:[i32] })<<P:Predicate_LaneIdx16>>:$idx), i8:{ *:[Other] }) - Complexity = 10
              // Dst: (EXTRACT_LANE_I8x16_s:{ *:[i32] } ?:{ *:[v16i8] }:$vec, (imm:{ *:[i32] }):$idx)
/*  9888*/   /*Scope*/ 24, /*->9913*/
/*  9889*/    OPC_CheckChild0Type, MVT::v8i16,
/*  9891*/    OPC_RecordChild1, // #1 = $idx
/*  9892*/    OPC_MoveChild1,
/*  9893*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/*  9896*/    OPC_CheckPredicate, 16, // Predicate_LaneIdx8
/*  9898*/    OPC_CheckTypeI32,
/*  9899*/    OPC_MoveParent,
/*  9900*/    OPC_MoveSibling1,
/*  9901*/    OPC_CheckValueType, MVT::i16,
/*  9903*/    OPC_MoveParent,
/*  9904*/    OPC_CheckTypeI32,
/*  9905*/    OPC_EmitConvertToTarget1,
/*  9906*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::EXTRACT_LANE_I16x8_s),
                  MVT::i32, 2/*#Ops*/, 0, 2, 
              // Src: (sext_inreg:{ *:[i32] } (vector_extract:{ *:[i32] } V128:{ *:[v8i16] }:$vec, (imm:{ *:[i32] })<<P:Predicate_LaneIdx8>>:$idx), i16:{ *:[Other] }) - Complexity = 10
              // Dst: (EXTRACT_LANE_I16x8_s:{ *:[i32] } ?:{ *:[v8i16] }:$vec, (imm:{ *:[i32] }):$idx)
/*  9913*/   0, /*End of Scope*/
/*  9914*/  /*Scope*/ 68, /*->9983*/
/*  9915*/   OPC_RecordChild0, // #0 = $src
/*  9916*/   OPC_MoveChild1,
/*  9917*/   OPC_Scope, 25, /*->9944*/ // 3 children in Scope
/*  9919*/    OPC_CheckValueType, MVT::i8,
/*  9921*/    OPC_MoveParent,
/*  9922*/    OPC_SwitchType /*2 cases */, 8, MVT::i32,// ->9933
/*  9925*/     OPC_CheckPatternPredicate, 9, // (Subtarget->hasSignExt())
/*  9927*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::I32_EXTEND8_S_I32),
                   MVT::i32, 1/*#Ops*/, 0, 
               // Src: (sext_inreg:{ *:[i32] } I32:{ *:[i32] }:$src, i8:{ *:[Other] }) - Complexity = 3
               // Dst: (I32_EXTEND8_S_I32:{ *:[i32] } I32:{ *:[i32] }:$src)
/*  9933*/    /*SwitchType*/ 8, MVT::i64,// ->9943
/*  9935*/     OPC_CheckPatternPredicate, 9, // (Subtarget->hasSignExt())
/*  9937*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::I64_EXTEND8_S_I64),
                   MVT::i64, 1/*#Ops*/, 0, 
               // Src: (sext_inreg:{ *:[i64] } I64:{ *:[i64] }:$src, i8:{ *:[Other] }) - Complexity = 3
               // Dst: (I64_EXTEND8_S_I64:{ *:[i64] } I64:{ *:[i64] }:$src)
/*  9943*/    0, // EndSwitchType
/*  9944*/   /*Scope*/ 25, /*->9970*/
/*  9945*/    OPC_CheckValueType, MVT::i16,
/*  9947*/    OPC_MoveParent,
/*  9948*/    OPC_SwitchType /*2 cases */, 8, MVT::i32,// ->9959
/*  9951*/     OPC_CheckPatternPredicate, 9, // (Subtarget->hasSignExt())
/*  9953*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::I32_EXTEND16_S_I32),
                   MVT::i32, 1/*#Ops*/, 0, 
               // Src: (sext_inreg:{ *:[i32] } I32:{ *:[i32] }:$src, i16:{ *:[Other] }) - Complexity = 3
               // Dst: (I32_EXTEND16_S_I32:{ *:[i32] } I32:{ *:[i32] }:$src)
/*  9959*/    /*SwitchType*/ 8, MVT::i64,// ->9969
/*  9961*/     OPC_CheckPatternPredicate, 9, // (Subtarget->hasSignExt())
/*  9963*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::I64_EXTEND16_S_I64),
                   MVT::i64, 1/*#Ops*/, 0, 
               // Src: (sext_inreg:{ *:[i64] } I64:{ *:[i64] }:$src, i16:{ *:[Other] }) - Complexity = 3
               // Dst: (I64_EXTEND16_S_I64:{ *:[i64] } I64:{ *:[i64] }:$src)
/*  9969*/    0, // EndSwitchType
/*  9970*/   /*Scope*/ 11, /*->9982*/
/*  9971*/    OPC_CheckValueType, MVT::i32,
/*  9973*/    OPC_MoveParent,
/*  9974*/    OPC_CheckPatternPredicate, 9, // (Subtarget->hasSignExt())
/*  9976*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::I64_EXTEND32_S_I64),
                  MVT::i64, 1/*#Ops*/, 0, 
              // Src: (sext_inreg:{ *:[i64] } I64:{ *:[i64] }:$src, i32:{ *:[Other] }) - Complexity = 3
              // Dst: (I64_EXTEND32_S_I64:{ *:[i64] } I64:{ *:[i64] }:$src)
/*  9982*/   0, /*End of Scope*/
/*  9983*/  0, /*End of Scope*/
/*  9984*/ /*SwitchOpcode*/ 15|128,1/*143*/, TARGET_VAL(WebAssemblyISD::GLOBAL_GET),// ->10131
/*  9988*/  OPC_RecordMemRef,
/*  9989*/  OPC_RecordNode, // #0 = 'WebAssemblyglobal_get' chained node
/*  9990*/  OPC_MoveChild1,
/*  9991*/  OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/*  9994*/  OPC_RecordChild0, // #1 = $addr
/*  9995*/  OPC_MoveChild0,
/*  9996*/  OPC_CheckOpcode, TARGET_VAL(ISD::TargetGlobalAddress),
/*  9999*/  OPC_MoveParent,
/* 10000*/  OPC_MoveParent,
/* 10001*/  OPC_SwitchType /*12 cases */, 8, MVT::i32,// ->10012
/* 10004*/   OPC_EmitMergeInputChains1_0,
/* 10005*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::GLOBAL_GET_I32), 0|OPFL_Chain|OPFL_MemRefs,
                 MVT::i32, 1/*#Ops*/, 1, 
             // Src: (WebAssemblyglobal_get:{ *:[i32] } (WebAssemblyWrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$addr)) - Complexity = 9
             // Dst: (GLOBAL_GET_I32:{ *:[i32] } (tglobaladdr:{ *:[i32] }):$addr)
/* 10012*/  /*SwitchType*/ 8, MVT::i64,// ->10022
/* 10014*/   OPC_EmitMergeInputChains1_0,
/* 10015*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::GLOBAL_GET_I64), 0|OPFL_Chain|OPFL_MemRefs,
                 MVT::i64, 1/*#Ops*/, 1, 
             // Src: (WebAssemblyglobal_get:{ *:[i64] } (WebAssemblyWrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$addr)) - Complexity = 9
             // Dst: (GLOBAL_GET_I64:{ *:[i64] } (tglobaladdr:{ *:[i64] }):$addr)
/* 10022*/  /*SwitchType*/ 9, MVT::funcref,// ->10033
/* 10024*/   OPC_CheckPatternPredicate5, // (Subtarget->hasReferenceTypes())
/* 10025*/   OPC_EmitMergeInputChains1_0,
/* 10026*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::GLOBAL_GET_FUNCREF), 0|OPFL_Chain|OPFL_MemRefs,
                 MVT::funcref, 1/*#Ops*/, 1, 
             // Src: (WebAssemblyglobal_get:{ *:[funcref] } (WebAssemblyWrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$addr)) - Complexity = 9
             // Dst: (GLOBAL_GET_FUNCREF:{ *:[funcref] } (tglobaladdr:{ *:[i32] }):$addr)
/* 10033*/  /*SwitchType*/ 9, MVT::externref,// ->10044
/* 10035*/   OPC_CheckPatternPredicate5, // (Subtarget->hasReferenceTypes())
/* 10036*/   OPC_EmitMergeInputChains1_0,
/* 10037*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::GLOBAL_GET_EXTERNREF), 0|OPFL_Chain|OPFL_MemRefs,
                 MVT::externref, 1/*#Ops*/, 1, 
             // Src: (WebAssemblyglobal_get:{ *:[externref] } (WebAssemblyWrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$addr)) - Complexity = 9
             // Dst: (GLOBAL_GET_EXTERNREF:{ *:[externref] } (tglobaladdr:{ *:[i32] }):$addr)
/* 10044*/  /*SwitchType*/ 8, MVT::f32,// ->10054
/* 10046*/   OPC_EmitMergeInputChains1_0,
/* 10047*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::GLOBAL_GET_F32), 0|OPFL_Chain|OPFL_MemRefs,
                 MVT::f32, 1/*#Ops*/, 1, 
             // Src: (WebAssemblyglobal_get:{ *:[f32] } (WebAssemblyWrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$addr)) - Complexity = 9
             // Dst: (GLOBAL_GET_F32:{ *:[f32] } (tglobaladdr:{ *:[i32] }):$addr)
/* 10054*/  /*SwitchType*/ 8, MVT::f64,// ->10064
/* 10056*/   OPC_EmitMergeInputChains1_0,
/* 10057*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::GLOBAL_GET_F64), 0|OPFL_Chain|OPFL_MemRefs,
                 MVT::f64, 1/*#Ops*/, 1, 
             // Src: (WebAssemblyglobal_get:{ *:[f64] } (WebAssemblyWrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$addr)) - Complexity = 9
             // Dst: (GLOBAL_GET_F64:{ *:[f64] } (tglobaladdr:{ *:[i32] }):$addr)
/* 10064*/  /*SwitchType*/ 9, MVT::v2i64,// ->10075
/* 10066*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 10067*/   OPC_EmitMergeInputChains1_0,
/* 10068*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::GLOBAL_GET_V128), 0|OPFL_Chain|OPFL_MemRefs,
                 MVT::v2i64, 1/*#Ops*/, 1, 
             // Src: (WebAssemblyglobal_get:{ *:[v2i64] } (WebAssemblyWrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$addr)) - Complexity = 9
             // Dst: (GLOBAL_GET_V128:{ *:[v2i64] } (tglobaladdr:{ *:[i32] }):$addr)
/* 10075*/  /*SwitchType*/ 9, MVT::v4i32,// ->10086
/* 10077*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 10078*/   OPC_EmitMergeInputChains1_0,
/* 10079*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::GLOBAL_GET_V128), 0|OPFL_Chain|OPFL_MemRefs,
                 MVT::v4i32, 1/*#Ops*/, 1, 
             // Src: (WebAssemblyglobal_get:{ *:[v4i32] } (WebAssemblyWrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$addr)) - Complexity = 9
             // Dst: (GLOBAL_GET_V128:{ *:[v4i32] } (tglobaladdr:{ *:[i32] }):$addr)
/* 10086*/  /*SwitchType*/ 9, MVT::v16i8,// ->10097
/* 10088*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 10089*/   OPC_EmitMergeInputChains1_0,
/* 10090*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::GLOBAL_GET_V128), 0|OPFL_Chain|OPFL_MemRefs,
                 MVT::v16i8, 1/*#Ops*/, 1, 
             // Src: (WebAssemblyglobal_get:{ *:[v16i8] } (WebAssemblyWrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$addr)) - Complexity = 9
             // Dst: (GLOBAL_GET_V128:{ *:[v16i8] } (tglobaladdr:{ *:[i32] }):$addr)
/* 10097*/  /*SwitchType*/ 9, MVT::v8i16,// ->10108
/* 10099*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 10100*/   OPC_EmitMergeInputChains1_0,
/* 10101*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::GLOBAL_GET_V128), 0|OPFL_Chain|OPFL_MemRefs,
                 MVT::v8i16, 1/*#Ops*/, 1, 
             // Src: (WebAssemblyglobal_get:{ *:[v8i16] } (WebAssemblyWrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$addr)) - Complexity = 9
             // Dst: (GLOBAL_GET_V128:{ *:[v8i16] } (tglobaladdr:{ *:[i32] }):$addr)
/* 10108*/  /*SwitchType*/ 9, MVT::v4f32,// ->10119
/* 10110*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 10111*/   OPC_EmitMergeInputChains1_0,
/* 10112*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::GLOBAL_GET_V128), 0|OPFL_Chain|OPFL_MemRefs,
                 MVT::v4f32, 1/*#Ops*/, 1, 
             // Src: (WebAssemblyglobal_get:{ *:[v4f32] } (WebAssemblyWrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$addr)) - Complexity = 9
             // Dst: (GLOBAL_GET_V128:{ *:[v4f32] } (tglobaladdr:{ *:[i32] }):$addr)
/* 10119*/  /*SwitchType*/ 9, MVT::v2f64,// ->10130
/* 10121*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 10122*/   OPC_EmitMergeInputChains1_0,
/* 10123*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::GLOBAL_GET_V128), 0|OPFL_Chain|OPFL_MemRefs,
                 MVT::v2f64, 1/*#Ops*/, 1, 
             // Src: (WebAssemblyglobal_get:{ *:[v2f64] } (WebAssemblyWrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$addr)) - Complexity = 9
             // Dst: (GLOBAL_GET_V128:{ *:[v2f64] } (tglobaladdr:{ *:[i32] }):$addr)
/* 10130*/  0, // EndSwitchType
/* 10131*/ /*SwitchOpcode*/ 19|128,2/*275*/, TARGET_VAL(WebAssemblyISD::GLOBAL_SET),// ->10410
/* 10135*/  OPC_RecordMemRef,
/* 10136*/  OPC_RecordNode, // #0 = 'WebAssemblyglobal_set' chained node
/* 10137*/  OPC_RecordChild1, // #1 = $src
/* 10138*/  OPC_Scope, 20, /*->10160*/ // 12 children in Scope
/* 10140*/   OPC_CheckChild1TypeI32,
/* 10141*/   OPC_MoveChild2,
/* 10142*/   OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/* 10145*/   OPC_RecordChild0, // #2 = $addr
/* 10146*/   OPC_MoveChild0,
/* 10147*/   OPC_CheckOpcode, TARGET_VAL(ISD::TargetGlobalAddress),
/* 10150*/   OPC_MoveParent,
/* 10151*/   OPC_MoveParent,
/* 10152*/   OPC_EmitMergeInputChains1_0,
/* 10153*/   OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::GLOBAL_SET_I32), 0|OPFL_Chain|OPFL_MemRefs,
                 2/*#Ops*/, 2, 1, 
             // Src: (WebAssemblyglobal_set i32:{ *:[i32] }:$src, (WebAssemblyWrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$addr)) - Complexity = 9
             // Dst: (GLOBAL_SET_I32 (tglobaladdr:{ *:[i32] }):$addr, i32:{ *:[i32] }:$src)
/* 10160*/  /*Scope*/ 20, /*->10181*/
/* 10161*/   OPC_CheckChild1TypeI64,
/* 10162*/   OPC_MoveChild2,
/* 10163*/   OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/* 10166*/   OPC_RecordChild0, // #2 = $addr
/* 10167*/   OPC_MoveChild0,
/* 10168*/   OPC_CheckOpcode, TARGET_VAL(ISD::TargetGlobalAddress),
/* 10171*/   OPC_MoveParent,
/* 10172*/   OPC_MoveParent,
/* 10173*/   OPC_EmitMergeInputChains1_0,
/* 10174*/   OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::GLOBAL_SET_I64), 0|OPFL_Chain|OPFL_MemRefs,
                 2/*#Ops*/, 2, 1, 
             // Src: (WebAssemblyglobal_set i64:{ *:[i64] }:$src, (WebAssemblyWrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$addr)) - Complexity = 9
             // Dst: (GLOBAL_SET_I64 (tglobaladdr:{ *:[i64] }):$addr, i64:{ *:[i64] }:$src)
/* 10181*/  /*Scope*/ 21, /*->10203*/
/* 10182*/   OPC_CheckChild1Type, MVT::f32,
/* 10184*/   OPC_MoveChild2,
/* 10185*/   OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/* 10188*/   OPC_RecordChild0, // #2 = $addr
/* 10189*/   OPC_MoveChild0,
/* 10190*/   OPC_CheckOpcode, TARGET_VAL(ISD::TargetGlobalAddress),
/* 10193*/   OPC_MoveParent,
/* 10194*/   OPC_MoveParent,
/* 10195*/   OPC_EmitMergeInputChains1_0,
/* 10196*/   OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::GLOBAL_SET_F32), 0|OPFL_Chain|OPFL_MemRefs,
                 2/*#Ops*/, 2, 1, 
             // Src: (WebAssemblyglobal_set f32:{ *:[f32] }:$src, (WebAssemblyWrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$addr)) - Complexity = 9
             // Dst: (GLOBAL_SET_F32 (tglobaladdr:{ *:[i32] }):$addr, f32:{ *:[f32] }:$src)
/* 10203*/  /*Scope*/ 21, /*->10225*/
/* 10204*/   OPC_CheckChild1Type, MVT::f64,
/* 10206*/   OPC_MoveChild2,
/* 10207*/   OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/* 10210*/   OPC_RecordChild0, // #2 = $addr
/* 10211*/   OPC_MoveChild0,
/* 10212*/   OPC_CheckOpcode, TARGET_VAL(ISD::TargetGlobalAddress),
/* 10215*/   OPC_MoveParent,
/* 10216*/   OPC_MoveParent,
/* 10217*/   OPC_EmitMergeInputChains1_0,
/* 10218*/   OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::GLOBAL_SET_F64), 0|OPFL_Chain|OPFL_MemRefs,
                 2/*#Ops*/, 2, 1, 
             // Src: (WebAssemblyglobal_set f64:{ *:[f64] }:$src, (WebAssemblyWrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$addr)) - Complexity = 9
             // Dst: (GLOBAL_SET_F64 (tglobaladdr:{ *:[i32] }):$addr, f64:{ *:[f64] }:$src)
/* 10225*/  /*Scope*/ 22, /*->10248*/
/* 10226*/   OPC_CheckChild1Type, MVT::v4f32,
/* 10228*/   OPC_MoveChild2,
/* 10229*/   OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/* 10232*/   OPC_RecordChild0, // #2 = $addr
/* 10233*/   OPC_MoveChild0,
/* 10234*/   OPC_CheckOpcode, TARGET_VAL(ISD::TargetGlobalAddress),
/* 10237*/   OPC_MoveParent,
/* 10238*/   OPC_MoveParent,
/* 10239*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 10240*/   OPC_EmitMergeInputChains1_0,
/* 10241*/   OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::GLOBAL_SET_V128), 0|OPFL_Chain|OPFL_MemRefs,
                 2/*#Ops*/, 2, 1, 
             // Src: (WebAssemblyglobal_set v4f32:{ *:[v4f32] }:$src, (WebAssemblyWrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$addr)) - Complexity = 9
             // Dst: (GLOBAL_SET_V128 (tglobaladdr:{ *:[i32] }):$addr, v4f32:{ *:[v4f32] }:$src)
/* 10248*/  /*Scope*/ 22, /*->10271*/
/* 10249*/   OPC_CheckChild1Type, MVT::v2f64,
/* 10251*/   OPC_MoveChild2,
/* 10252*/   OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/* 10255*/   OPC_RecordChild0, // #2 = $addr
/* 10256*/   OPC_MoveChild0,
/* 10257*/   OPC_CheckOpcode, TARGET_VAL(ISD::TargetGlobalAddress),
/* 10260*/   OPC_MoveParent,
/* 10261*/   OPC_MoveParent,
/* 10262*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 10263*/   OPC_EmitMergeInputChains1_0,
/* 10264*/   OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::GLOBAL_SET_V128), 0|OPFL_Chain|OPFL_MemRefs,
                 2/*#Ops*/, 2, 1, 
             // Src: (WebAssemblyglobal_set v2f64:{ *:[v2f64] }:$src, (WebAssemblyWrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$addr)) - Complexity = 9
             // Dst: (GLOBAL_SET_V128 (tglobaladdr:{ *:[i32] }):$addr, v2f64:{ *:[v2f64] }:$src)
/* 10271*/  /*Scope*/ 22, /*->10294*/
/* 10272*/   OPC_CheckChild1Type, MVT::v2i64,
/* 10274*/   OPC_MoveChild2,
/* 10275*/   OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/* 10278*/   OPC_RecordChild0, // #2 = $addr
/* 10279*/   OPC_MoveChild0,
/* 10280*/   OPC_CheckOpcode, TARGET_VAL(ISD::TargetGlobalAddress),
/* 10283*/   OPC_MoveParent,
/* 10284*/   OPC_MoveParent,
/* 10285*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 10286*/   OPC_EmitMergeInputChains1_0,
/* 10287*/   OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::GLOBAL_SET_V128), 0|OPFL_Chain|OPFL_MemRefs,
                 2/*#Ops*/, 2, 1, 
             // Src: (WebAssemblyglobal_set v2i64:{ *:[v2i64] }:$src, (WebAssemblyWrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$addr)) - Complexity = 9
             // Dst: (GLOBAL_SET_V128 (tglobaladdr:{ *:[i32] }):$addr, v2i64:{ *:[v2i64] }:$src)
/* 10294*/  /*Scope*/ 22, /*->10317*/
/* 10295*/   OPC_CheckChild1Type, MVT::v4i32,
/* 10297*/   OPC_MoveChild2,
/* 10298*/   OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/* 10301*/   OPC_RecordChild0, // #2 = $addr
/* 10302*/   OPC_MoveChild0,
/* 10303*/   OPC_CheckOpcode, TARGET_VAL(ISD::TargetGlobalAddress),
/* 10306*/   OPC_MoveParent,
/* 10307*/   OPC_MoveParent,
/* 10308*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 10309*/   OPC_EmitMergeInputChains1_0,
/* 10310*/   OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::GLOBAL_SET_V128), 0|OPFL_Chain|OPFL_MemRefs,
                 2/*#Ops*/, 2, 1, 
             // Src: (WebAssemblyglobal_set v4i32:{ *:[v4i32] }:$src, (WebAssemblyWrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$addr)) - Complexity = 9
             // Dst: (GLOBAL_SET_V128 (tglobaladdr:{ *:[i32] }):$addr, v4i32:{ *:[v4i32] }:$src)
/* 10317*/  /*Scope*/ 22, /*->10340*/
/* 10318*/   OPC_CheckChild1Type, MVT::v16i8,
/* 10320*/   OPC_MoveChild2,
/* 10321*/   OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/* 10324*/   OPC_RecordChild0, // #2 = $addr
/* 10325*/   OPC_MoveChild0,
/* 10326*/   OPC_CheckOpcode, TARGET_VAL(ISD::TargetGlobalAddress),
/* 10329*/   OPC_MoveParent,
/* 10330*/   OPC_MoveParent,
/* 10331*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 10332*/   OPC_EmitMergeInputChains1_0,
/* 10333*/   OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::GLOBAL_SET_V128), 0|OPFL_Chain|OPFL_MemRefs,
                 2/*#Ops*/, 2, 1, 
             // Src: (WebAssemblyglobal_set v16i8:{ *:[v16i8] }:$src, (WebAssemblyWrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$addr)) - Complexity = 9
             // Dst: (GLOBAL_SET_V128 (tglobaladdr:{ *:[i32] }):$addr, v16i8:{ *:[v16i8] }:$src)
/* 10340*/  /*Scope*/ 22, /*->10363*/
/* 10341*/   OPC_CheckChild1Type, MVT::v8i16,
/* 10343*/   OPC_MoveChild2,
/* 10344*/   OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/* 10347*/   OPC_RecordChild0, // #2 = $addr
/* 10348*/   OPC_MoveChild0,
/* 10349*/   OPC_CheckOpcode, TARGET_VAL(ISD::TargetGlobalAddress),
/* 10352*/   OPC_MoveParent,
/* 10353*/   OPC_MoveParent,
/* 10354*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 10355*/   OPC_EmitMergeInputChains1_0,
/* 10356*/   OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::GLOBAL_SET_V128), 0|OPFL_Chain|OPFL_MemRefs,
                 2/*#Ops*/, 2, 1, 
             // Src: (WebAssemblyglobal_set v8i16:{ *:[v8i16] }:$src, (WebAssemblyWrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$addr)) - Complexity = 9
             // Dst: (GLOBAL_SET_V128 (tglobaladdr:{ *:[i32] }):$addr, v8i16:{ *:[v8i16] }:$src)
/* 10363*/  /*Scope*/ 22, /*->10386*/
/* 10364*/   OPC_CheckChild1Type, MVT::funcref,
/* 10366*/   OPC_MoveChild2,
/* 10367*/   OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/* 10370*/   OPC_RecordChild0, // #2 = $addr
/* 10371*/   OPC_MoveChild0,
/* 10372*/   OPC_CheckOpcode, TARGET_VAL(ISD::TargetGlobalAddress),
/* 10375*/   OPC_MoveParent,
/* 10376*/   OPC_MoveParent,
/* 10377*/   OPC_CheckPatternPredicate5, // (Subtarget->hasReferenceTypes())
/* 10378*/   OPC_EmitMergeInputChains1_0,
/* 10379*/   OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::GLOBAL_SET_FUNCREF), 0|OPFL_Chain|OPFL_MemRefs,
                 2/*#Ops*/, 2, 1, 
             // Src: (WebAssemblyglobal_set funcref:{ *:[funcref] }:$src, (WebAssemblyWrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$addr)) - Complexity = 9
             // Dst: (GLOBAL_SET_FUNCREF (tglobaladdr:{ *:[i32] }):$addr, funcref:{ *:[funcref] }:$src)
/* 10386*/  /*Scope*/ 22, /*->10409*/
/* 10387*/   OPC_CheckChild1Type, MVT::externref,
/* 10389*/   OPC_MoveChild2,
/* 10390*/   OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/* 10393*/   OPC_RecordChild0, // #2 = $addr
/* 10394*/   OPC_MoveChild0,
/* 10395*/   OPC_CheckOpcode, TARGET_VAL(ISD::TargetGlobalAddress),
/* 10398*/   OPC_MoveParent,
/* 10399*/   OPC_MoveParent,
/* 10400*/   OPC_CheckPatternPredicate5, // (Subtarget->hasReferenceTypes())
/* 10401*/   OPC_EmitMergeInputChains1_0,
/* 10402*/   OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::GLOBAL_SET_EXTERNREF), 0|OPFL_Chain|OPFL_MemRefs,
                 2/*#Ops*/, 2, 1, 
             // Src: (WebAssemblyglobal_set externref:{ *:[externref] }:$src, (WebAssemblyWrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$addr)) - Complexity = 9
             // Dst: (GLOBAL_SET_EXTERNREF (tglobaladdr:{ *:[i32] }):$addr, externref:{ *:[externref] }:$src)
/* 10409*/  0, /*End of Scope*/
/* 10410*/ /*SwitchOpcode*/ 21, TARGET_VAL(ISD::CALLSEQ_START),// ->10434
/* 10413*/  OPC_RecordNode, // #0 = 'WebAssemblycallseq_start' chained node
/* 10414*/  OPC_RecordChild1, // #1 = $amt
/* 10415*/  OPC_MoveChild1,
/* 10416*/  OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 10419*/  OPC_MoveSibling2,
/* 10420*/  OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 10423*/  OPC_RecordNode, // #2 = $amt2
/* 10424*/  OPC_MoveParent,
/* 10425*/  OPC_EmitMergeInputChains1_0,
/* 10426*/  OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ADJCALLSTACKDOWN), 0|OPFL_Chain|OPFL_GlueOutput,
                MVT::i32, 2/*#Ops*/, 1, 2, 
            // Src: (WebAssemblycallseq_start (timm:{ *:[iPTR] }):$amt, (timm:{ *:[iPTR] }):$amt2) - Complexity = 9
            // Dst: (ADJCALLSTACKDOWN:{ *:[i32] } (timm:{ *:[i32] }):$amt, (timm:{ *:[i32] }):$amt2)
/* 10434*/ /*SwitchOpcode*/ 22, TARGET_VAL(ISD::CALLSEQ_END),// ->10459
/* 10437*/  OPC_RecordNode, // #0 = 'WebAssemblycallseq_end' chained node
/* 10438*/  OPC_CaptureGlueInput,
/* 10439*/  OPC_RecordChild1, // #1 = $amt
/* 10440*/  OPC_MoveChild1,
/* 10441*/  OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 10444*/  OPC_MoveSibling2,
/* 10445*/  OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 10448*/  OPC_RecordNode, // #2 = $amt2
/* 10449*/  OPC_MoveParent,
/* 10450*/  OPC_EmitMergeInputChains1_0,
/* 10451*/  OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ADJCALLSTACKUP), 0|OPFL_Chain|OPFL_GlueInput|OPFL_GlueOutput,
                MVT::i32, 2/*#Ops*/, 1, 2, 
            // Src: (WebAssemblycallseq_end (timm:{ *:[iPTR] }):$amt, (timm:{ *:[iPTR] }):$amt2) - Complexity = 9
            // Dst: (ADJCALLSTACKUP:{ *:[i32] } (timm:{ *:[i32] }):$amt, (timm:{ *:[i32] }):$amt2)
/* 10459*/ /*SwitchOpcode*/ 57, TARGET_VAL(WebAssemblyISD::MEMORY_COPY),// ->10519
/* 10462*/  OPC_RecordNode, // #0 = 'wasm_memcpy' chained node
/* 10463*/  OPC_RecordChild1, // #1 = $src_idx
/* 10464*/  OPC_MoveChild1,
/* 10465*/  OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 10468*/  OPC_CheckTypeI32,
/* 10469*/  OPC_MoveSibling2,
/* 10470*/  OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 10473*/  OPC_RecordNode, // #2 = $dst_idx
/* 10474*/  OPC_CheckTypeI32,
/* 10475*/  OPC_MoveParent,
/* 10476*/  OPC_RecordChild3, // #3 = $dst
/* 10477*/  OPC_Scope, 19, /*->10498*/ // 2 children in Scope
/* 10479*/   OPC_CheckChild3TypeI32,
/* 10480*/   OPC_RecordChild4, // #4 = $src
/* 10481*/   OPC_CheckChild4TypeI32,
/* 10482*/   OPC_RecordChild5, // #5 = $len
/* 10483*/   OPC_CheckChild5TypeI32,
/* 10484*/   OPC_CheckPatternPredicate, 10, // (Subtarget->hasBulkMemory())
/* 10486*/   OPC_EmitMergeInputChains1_0,
/* 10487*/   OPC_EmitConvertToTarget1,
/* 10488*/   OPC_EmitConvertToTarget2,
/* 10489*/   OPC_MorphNodeTo0Chain, TARGET_VAL(WebAssembly::anonymous_8034MEMORY_COPY_A32),
                 5/*#Ops*/, 6, 7, 3, 4, 5, 
             // Src: (wasm_memcpy (imm:{ *:[i32] }):$src_idx, (imm:{ *:[i32] }):$dst_idx, I32:{ *:[i32] }:$dst, I32:{ *:[i32] }:$src, I32:{ *:[i32] }:$len) - Complexity = 9
             // Dst: (anonymous_8034MEMORY_COPY_A32 (imm:{ *:[i32] }):$src_idx, (imm:{ *:[i32] }):$dst_idx, I32:{ *:[i32] }:$dst, I32:{ *:[i32] }:$src, I32:{ *:[i32] }:$len)
/* 10498*/  /*Scope*/ 19, /*->10518*/
/* 10499*/   OPC_CheckChild3TypeI64,
/* 10500*/   OPC_RecordChild4, // #4 = $src
/* 10501*/   OPC_CheckChild4TypeI64,
/* 10502*/   OPC_RecordChild5, // #5 = $len
/* 10503*/   OPC_CheckChild5TypeI64,
/* 10504*/   OPC_CheckPatternPredicate, 10, // (Subtarget->hasBulkMemory())
/* 10506*/   OPC_EmitMergeInputChains1_0,
/* 10507*/   OPC_EmitConvertToTarget1,
/* 10508*/   OPC_EmitConvertToTarget2,
/* 10509*/   OPC_MorphNodeTo0Chain, TARGET_VAL(WebAssembly::anonymous_8035MEMORY_COPY_A64),
                 5/*#Ops*/, 6, 7, 3, 4, 5, 
             // Src: (wasm_memcpy (imm:{ *:[i32] }):$src_idx, (imm:{ *:[i32] }):$dst_idx, I64:{ *:[i64] }:$dst, I64:{ *:[i64] }:$src, I64:{ *:[i64] }:$len) - Complexity = 9
             // Dst: (anonymous_8035MEMORY_COPY_A64 (imm:{ *:[i32] }):$src_idx, (imm:{ *:[i32] }):$dst_idx, I64:{ *:[i64] }:$dst, I64:{ *:[i64] }:$src, I64:{ *:[i64] }:$len)
/* 10518*/  0, /*End of Scope*/
/* 10519*/ /*SwitchOpcode*/ 41, TARGET_VAL(WebAssemblyISD::TABLE_GET),// ->10563
/* 10522*/  OPC_RecordMemRef,
/* 10523*/  OPC_RecordNode, // #0 = 'WebAssemblyTableGet' chained node
/* 10524*/  OPC_MoveChild1,
/* 10525*/  OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/* 10528*/  OPC_RecordChild0, // #1 = $table
/* 10529*/  OPC_MoveChild0,
/* 10530*/  OPC_CheckOpcode, TARGET_VAL(ISD::TargetGlobalAddress),
/* 10533*/  OPC_MoveParent,
/* 10534*/  OPC_MoveParent,
/* 10535*/  OPC_RecordChild2, // #2 = $idx
/* 10536*/  OPC_CheckChild2TypeI32,
/* 10537*/  OPC_SwitchType /*2 cases */, 10, MVT::funcref,// ->10550
/* 10540*/   OPC_CheckPatternPredicate5, // (Subtarget->hasReferenceTypes())
/* 10541*/   OPC_EmitMergeInputChains1_0,
/* 10542*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::TABLE_GET_FUNCREF), 0|OPFL_Chain|OPFL_MemRefs,
                 MVT::funcref, 2/*#Ops*/, 1, 2, 
             // Src: (WebAssemblyTableGet:{ *:[funcref] } (WebAssemblyWrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$table), i32:{ *:[i32] }:$idx) - Complexity = 9
             // Dst: (TABLE_GET_FUNCREF:{ *:[funcref] } (tglobaladdr:{ *:[i32] }):$table, i32:{ *:[i32] }:$idx)
/* 10550*/  /*SwitchType*/ 10, MVT::externref,// ->10562
/* 10552*/   OPC_CheckPatternPredicate5, // (Subtarget->hasReferenceTypes())
/* 10553*/   OPC_EmitMergeInputChains1_0,
/* 10554*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::TABLE_GET_EXTERNREF), 0|OPFL_Chain|OPFL_MemRefs,
                 MVT::externref, 2/*#Ops*/, 1, 2, 
             // Src: (WebAssemblyTableGet:{ *:[externref] } (WebAssemblyWrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$table), i32:{ *:[i32] }:$idx) - Complexity = 9
             // Dst: (TABLE_GET_EXTERNREF:{ *:[externref] } (tglobaladdr:{ *:[i32] }):$table, i32:{ *:[i32] }:$idx)
/* 10562*/  0, // EndSwitchType
/* 10563*/ /*SwitchOpcode*/ 69, TARGET_VAL(WebAssemblyISD::TABLE_SET),// ->10635
/* 10566*/  OPC_RecordMemRef,
/* 10567*/  OPC_RecordNode, // #0 = 'WebAssemblyTableSet' chained node
/* 10568*/  OPC_Scope, 42, /*->10612*/ // 2 children in Scope
/* 10570*/   OPC_MoveChild1,
/* 10571*/   OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/* 10574*/   OPC_RecordChild0, // #1 = $table
/* 10575*/   OPC_MoveChild0,
/* 10576*/   OPC_CheckOpcode, TARGET_VAL(ISD::TargetGlobalAddress),
/* 10579*/   OPC_MoveParent,
/* 10580*/   OPC_MoveParent,
/* 10581*/   OPC_RecordChild2, // #2 = $idx
/* 10582*/   OPC_CheckChild2TypeI32,
/* 10583*/   OPC_RecordChild3, // #3 = $src
/* 10584*/   OPC_Scope, 12, /*->10598*/ // 2 children in Scope
/* 10586*/    OPC_CheckChild3Type, MVT::funcref,
/* 10588*/    OPC_CheckPatternPredicate5, // (Subtarget->hasReferenceTypes())
/* 10589*/    OPC_EmitMergeInputChains1_0,
/* 10590*/    OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::TABLE_SET_FUNCREF), 0|OPFL_Chain|OPFL_MemRefs,
                  3/*#Ops*/, 1, 2, 3, 
              // Src: (WebAssemblyTableSet (WebAssemblyWrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$table), i32:{ *:[i32] }:$idx, funcref:{ *:[funcref] }:$src) - Complexity = 9
              // Dst: (TABLE_SET_FUNCREF (tglobaladdr:{ *:[i32] }):$table, i32:{ *:[i32] }:$idx, funcref:{ *:[funcref] }:$src)
/* 10598*/   /*Scope*/ 12, /*->10611*/
/* 10599*/    OPC_CheckChild3Type, MVT::externref,
/* 10601*/    OPC_CheckPatternPredicate5, // (Subtarget->hasReferenceTypes())
/* 10602*/    OPC_EmitMergeInputChains1_0,
/* 10603*/    OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::TABLE_SET_EXTERNREF), 0|OPFL_Chain|OPFL_MemRefs,
                  3/*#Ops*/, 1, 2, 3, 
              // Src: (WebAssemblyTableSet (WebAssemblyWrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$table), i32:{ *:[i32] }:$idx, externref:{ *:[externref] }:$src) - Complexity = 9
              // Dst: (TABLE_SET_EXTERNREF (tglobaladdr:{ *:[i32] }):$table, i32:{ *:[i32] }:$idx, externref:{ *:[externref] }:$src)
/* 10611*/   0, /*End of Scope*/
/* 10612*/  /*Scope*/ 21, /*->10634*/
/* 10613*/   OPC_RecordChild1, // #1 = $table
/* 10614*/   OPC_MoveChild1,
/* 10615*/   OPC_CheckOpcode, TARGET_VAL(ISD::MCSymbol),
/* 10618*/   OPC_MoveParent,
/* 10619*/   OPC_RecordChild2, // #2 = $idx
/* 10620*/   OPC_CheckChild2TypeI32,
/* 10621*/   OPC_RecordChild3, // #3 = $r
/* 10622*/   OPC_CheckChild3Type, MVT::funcref,
/* 10624*/   OPC_CheckPatternPredicate5, // (Subtarget->hasReferenceTypes())
/* 10625*/   OPC_EmitMergeInputChains1_0,
/* 10626*/   OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::TABLE_SET_FUNCREF), 0|OPFL_Chain|OPFL_MemRefs,
                 3/*#Ops*/, 1, 2, 3, 
             // Src: (WebAssemblyTableSet (mcsym:{ *:[iPTR] }):$table, i32:{ *:[i32] }:$idx, funcref:{ *:[funcref] }:$r) - Complexity = 6
             // Dst: (TABLE_SET_FUNCREF (mcsym:{ *:[i32] }):$table, i32:{ *:[i32] }:$idx, funcref:{ *:[funcref] }:$r)
/* 10634*/  0, /*End of Scope*/
/* 10635*/ /*SwitchOpcode*/ 3|128,9/*1155*/, TARGET_VAL(ISD::INTRINSIC_WO_CHAIN),// ->11794
/* 10639*/  OPC_Scope, 49, /*->10690*/ // 36 children in Scope
/* 10641*/   OPC_CheckChild0Integer, 112|128,61|128,1/*24304*/, 
/* 10645*/   OPC_RecordChild1, // #0 = $src
/* 10646*/   OPC_Scope, 20, /*->10668*/ // 2 children in Scope
/* 10648*/    OPC_CheckChild1Type, MVT::f32,
/* 10650*/    OPC_SwitchType /*2 cases */, 6, MVT::i32,// ->10659
/* 10653*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::I32_TRUNC_S_F32),
                   MVT::i32, 1/*#Ops*/, 0, 
               // Src: (intrinsic_wo_chain:{ *:[i32] } 12152:{ *:[iPTR] }, F32:{ *:[f32] }:$src) - Complexity = 8
               // Dst: (I32_TRUNC_S_F32:{ *:[i32] } F32:{ *:[f32] }:$src)
/* 10659*/    /*SwitchType*/ 6, MVT::i64,// ->10667
/* 10661*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::I64_TRUNC_S_F32),
                   MVT::i64, 1/*#Ops*/, 0, 
               // Src: (intrinsic_wo_chain:{ *:[i64] } 12152:{ *:[iPTR] }, F32:{ *:[f32] }:$src) - Complexity = 8
               // Dst: (I64_TRUNC_S_F32:{ *:[i64] } F32:{ *:[f32] }:$src)
/* 10667*/    0, // EndSwitchType
/* 10668*/   /*Scope*/ 20, /*->10689*/
/* 10669*/    OPC_CheckChild1Type, MVT::f64,
/* 10671*/    OPC_SwitchType /*2 cases */, 6, MVT::i32,// ->10680
/* 10674*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::I32_TRUNC_S_F64),
                   MVT::i32, 1/*#Ops*/, 0, 
               // Src: (intrinsic_wo_chain:{ *:[i32] } 12152:{ *:[iPTR] }, F64:{ *:[f64] }:$src) - Complexity = 8
               // Dst: (I32_TRUNC_S_F64:{ *:[i32] } F64:{ *:[f64] }:$src)
/* 10680*/    /*SwitchType*/ 6, MVT::i64,// ->10688
/* 10682*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::I64_TRUNC_S_F64),
                   MVT::i64, 1/*#Ops*/, 0, 
               // Src: (intrinsic_wo_chain:{ *:[i64] } 12152:{ *:[iPTR] }, F64:{ *:[f64] }:$src) - Complexity = 8
               // Dst: (I64_TRUNC_S_F64:{ *:[i64] } F64:{ *:[f64] }:$src)
/* 10688*/    0, // EndSwitchType
/* 10689*/   0, /*End of Scope*/
/* 10690*/  /*Scope*/ 49, /*->10740*/
/* 10691*/   OPC_CheckChild0Integer, 114|128,61|128,1/*24306*/, 
/* 10695*/   OPC_RecordChild1, // #0 = $src
/* 10696*/   OPC_Scope, 20, /*->10718*/ // 2 children in Scope
/* 10698*/    OPC_CheckChild1Type, MVT::f32,
/* 10700*/    OPC_SwitchType /*2 cases */, 6, MVT::i32,// ->10709
/* 10703*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::I32_TRUNC_U_F32),
                   MVT::i32, 1/*#Ops*/, 0, 
               // Src: (intrinsic_wo_chain:{ *:[i32] } 12153:{ *:[iPTR] }, F32:{ *:[f32] }:$src) - Complexity = 8
               // Dst: (I32_TRUNC_U_F32:{ *:[i32] } F32:{ *:[f32] }:$src)
/* 10709*/    /*SwitchType*/ 6, MVT::i64,// ->10717
/* 10711*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::I64_TRUNC_U_F32),
                   MVT::i64, 1/*#Ops*/, 0, 
               // Src: (intrinsic_wo_chain:{ *:[i64] } 12153:{ *:[iPTR] }, F32:{ *:[f32] }:$src) - Complexity = 8
               // Dst: (I64_TRUNC_U_F32:{ *:[i64] } F32:{ *:[f32] }:$src)
/* 10717*/    0, // EndSwitchType
/* 10718*/   /*Scope*/ 20, /*->10739*/
/* 10719*/    OPC_CheckChild1Type, MVT::f64,
/* 10721*/    OPC_SwitchType /*2 cases */, 6, MVT::i32,// ->10730
/* 10724*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::I32_TRUNC_U_F64),
                   MVT::i32, 1/*#Ops*/, 0, 
               // Src: (intrinsic_wo_chain:{ *:[i32] } 12153:{ *:[iPTR] }, F64:{ *:[f64] }:$src) - Complexity = 8
               // Dst: (I32_TRUNC_U_F64:{ *:[i32] } F64:{ *:[f64] }:$src)
/* 10730*/    /*SwitchType*/ 6, MVT::i64,// ->10738
/* 10732*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::I64_TRUNC_U_F64),
                   MVT::i64, 1/*#Ops*/, 0, 
               // Src: (intrinsic_wo_chain:{ *:[i64] } 12153:{ *:[iPTR] }, F64:{ *:[f64] }:$src) - Complexity = 8
               // Dst: (I64_TRUNC_U_F64:{ *:[i64] } F64:{ *:[f64] }:$src)
/* 10738*/    0, // EndSwitchType
/* 10739*/   0, /*End of Scope*/
/* 10740*/  /*Scope*/ 43, /*->10784*/
/* 10741*/   OPC_CheckChild0Integer, 118|128,60|128,1/*24182*/, 
/* 10745*/   OPC_RecordChild1, // #0 = $vec
/* 10746*/   OPC_Scope, 8, /*->10756*/ // 4 children in Scope
/* 10748*/    OPC_CheckChild1Type, MVT::v16i8,
/* 10750*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ANYTRUE),
                  MVT::i32, 1/*#Ops*/, 0, 
              // Src: (intrinsic_wo_chain:{ *:[i32] } 12091:{ *:[iPTR] }, V128:{ *:[v16i8] }:$vec) - Complexity = 8
              // Dst: (ANYTRUE:{ *:[i32] } V128:{ *:[v16i8] }:$vec)
/* 10756*/   /*Scope*/ 8, /*->10765*/
/* 10757*/    OPC_CheckChild1Type, MVT::v8i16,
/* 10759*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ANYTRUE),
                  MVT::i32, 1/*#Ops*/, 0, 
              // Src: (intrinsic_wo_chain:{ *:[i32] } 12091:{ *:[iPTR] }, V128:{ *:[v8i16] }:$vec) - Complexity = 8
              // Dst: (ANYTRUE:{ *:[i32] } V128:{ *:[v8i16] }:$vec)
/* 10765*/   /*Scope*/ 8, /*->10774*/
/* 10766*/    OPC_CheckChild1Type, MVT::v4i32,
/* 10768*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ANYTRUE),
                  MVT::i32, 1/*#Ops*/, 0, 
              // Src: (intrinsic_wo_chain:{ *:[i32] } 12091:{ *:[iPTR] }, V128:{ *:[v4i32] }:$vec) - Complexity = 8
              // Dst: (ANYTRUE:{ *:[i32] } V128:{ *:[v4i32] }:$vec)
/* 10774*/   /*Scope*/ 8, /*->10783*/
/* 10775*/    OPC_CheckChild1Type, MVT::v2i64,
/* 10777*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ANYTRUE),
                  MVT::i32, 1/*#Ops*/, 0, 
              // Src: (intrinsic_wo_chain:{ *:[i32] } 12091:{ *:[iPTR] }, V128:{ *:[v2i64] }:$vec) - Complexity = 8
              // Dst: (ANYTRUE:{ *:[i32] } V128:{ *:[v2i64] }:$vec)
/* 10783*/   0, /*End of Scope*/
/* 10784*/  /*Scope*/ 47, /*->10832*/
/* 10785*/   OPC_CheckChild0Integer, 116|128,60|128,1/*24180*/, 
/* 10789*/   OPC_RecordChild1, // #0 = $vec
/* 10790*/   OPC_Scope, 9, /*->10801*/ // 4 children in Scope
/* 10792*/    OPC_CheckChild1Type, MVT::v16i8,
/* 10794*/    OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 10795*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ALLTRUE_I8x16),
                  MVT::i32, 1/*#Ops*/, 0, 
              // Src: (intrinsic_wo_chain:{ *:[i32] } 12090:{ *:[iPTR] }, V128:{ *:[v16i8] }:$vec) - Complexity = 8
              // Dst: (ALLTRUE_I8x16:{ *:[i32] } V128:{ *:[v16i8] }:$vec)
/* 10801*/   /*Scope*/ 9, /*->10811*/
/* 10802*/    OPC_CheckChild1Type, MVT::v8i16,
/* 10804*/    OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 10805*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ALLTRUE_I16x8),
                  MVT::i32, 1/*#Ops*/, 0, 
              // Src: (intrinsic_wo_chain:{ *:[i32] } 12090:{ *:[iPTR] }, V128:{ *:[v8i16] }:$vec) - Complexity = 8
              // Dst: (ALLTRUE_I16x8:{ *:[i32] } V128:{ *:[v8i16] }:$vec)
/* 10811*/   /*Scope*/ 9, /*->10821*/
/* 10812*/    OPC_CheckChild1Type, MVT::v4i32,
/* 10814*/    OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 10815*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ALLTRUE_I32x4),
                  MVT::i32, 1/*#Ops*/, 0, 
              // Src: (intrinsic_wo_chain:{ *:[i32] } 12090:{ *:[iPTR] }, V128:{ *:[v4i32] }:$vec) - Complexity = 8
              // Dst: (ALLTRUE_I32x4:{ *:[i32] } V128:{ *:[v4i32] }:$vec)
/* 10821*/   /*Scope*/ 9, /*->10831*/
/* 10822*/    OPC_CheckChild1Type, MVT::v2i64,
/* 10824*/    OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 10825*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ALLTRUE_I64x2),
                  MVT::i32, 1/*#Ops*/, 0, 
              // Src: (intrinsic_wo_chain:{ *:[i32] } 12090:{ *:[iPTR] }, V128:{ *:[v2i64] }:$vec) - Complexity = 8
              // Dst: (ALLTRUE_I64x2:{ *:[i32] } V128:{ *:[v2i64] }:$vec)
/* 10831*/   0, /*End of Scope*/
/* 10832*/  /*Scope*/ 47, /*->10880*/
/* 10833*/   OPC_CheckChild0Integer, 122|128,60|128,1/*24186*/, 
/* 10837*/   OPC_RecordChild1, // #0 = $vec
/* 10838*/   OPC_Scope, 9, /*->10849*/ // 4 children in Scope
/* 10840*/    OPC_CheckChild1Type, MVT::v16i8,
/* 10842*/    OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 10843*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITMASK_I8x16),
                  MVT::i32, 1/*#Ops*/, 0, 
              // Src: (intrinsic_wo_chain:{ *:[i32] } 12093:{ *:[iPTR] }, V128:{ *:[v16i8] }:$vec) - Complexity = 8
              // Dst: (BITMASK_I8x16:{ *:[i32] } V128:{ *:[v16i8] }:$vec)
/* 10849*/   /*Scope*/ 9, /*->10859*/
/* 10850*/    OPC_CheckChild1Type, MVT::v8i16,
/* 10852*/    OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 10853*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITMASK_I16x8),
                  MVT::i32, 1/*#Ops*/, 0, 
              // Src: (intrinsic_wo_chain:{ *:[i32] } 12093:{ *:[iPTR] }, V128:{ *:[v8i16] }:$vec) - Complexity = 8
              // Dst: (BITMASK_I16x8:{ *:[i32] } V128:{ *:[v8i16] }:$vec)
/* 10859*/   /*Scope*/ 9, /*->10869*/
/* 10860*/    OPC_CheckChild1Type, MVT::v4i32,
/* 10862*/    OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 10863*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITMASK_I32x4),
                  MVT::i32, 1/*#Ops*/, 0, 
              // Src: (intrinsic_wo_chain:{ *:[i32] } 12093:{ *:[iPTR] }, V128:{ *:[v4i32] }:$vec) - Complexity = 8
              // Dst: (BITMASK_I32x4:{ *:[i32] } V128:{ *:[v4i32] }:$vec)
/* 10869*/   /*Scope*/ 9, /*->10879*/
/* 10870*/    OPC_CheckChild1Type, MVT::v2i64,
/* 10872*/    OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 10873*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITMASK_I64x2),
                  MVT::i32, 1/*#Ops*/, 0, 
              // Src: (intrinsic_wo_chain:{ *:[i32] } 12093:{ *:[iPTR] }, V128:{ *:[v2i64] }:$vec) - Complexity = 8
              // Dst: (BITMASK_I64x2:{ *:[i32] } V128:{ *:[v2i64] }:$vec)
/* 10879*/   0, /*End of Scope*/
/* 10880*/  /*Scope*/ 10, /*->10891*/
/* 10881*/   OPC_CheckChild0Integer, 40|128,61|128,1/*24232*/, 
/* 10885*/   OPC_CheckPatternPredicate5, // (Subtarget->hasReferenceTypes())
/* 10886*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::REF_NULL_FUNCREF),
                 MVT::funcref, 0/*#Ops*/, 
             // Src: (intrinsic_wo_chain:{ *:[funcref] } 12116:{ *:[iPTR] }) - Complexity = 8
             // Dst: (REF_NULL_FUNCREF:{ *:[funcref] })
/* 10891*/  /*Scope*/ 12, /*->10904*/
/* 10892*/   OPC_CheckChild0Integer, 36|128,61|128,1/*24228*/, 
/* 10896*/   OPC_RecordChild1, // #0 = $ref
/* 10897*/   OPC_CheckPatternPredicate5, // (Subtarget->hasReferenceTypes())
/* 10898*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::REF_IS_NULL_FUNCREF),
                 MVT::i32, 1/*#Ops*/, 0, 
             // Src: (intrinsic_wo_chain:{ *:[i32] } 12114:{ *:[iPTR] }, FUNCREF:{ *:[funcref] }:$ref) - Complexity = 8
             // Dst: (REF_IS_NULL_FUNCREF:{ *:[i32] } FUNCREF:{ *:[funcref] }:$ref)
/* 10904*/  /*Scope*/ 10, /*->10915*/
/* 10905*/   OPC_CheckChild0Integer, 38|128,61|128,1/*24230*/, 
/* 10909*/   OPC_CheckPatternPredicate5, // (Subtarget->hasReferenceTypes())
/* 10910*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::REF_NULL_EXTERNREF),
                 MVT::externref, 0/*#Ops*/, 
             // Src: (intrinsic_wo_chain:{ *:[externref] } 12115:{ *:[iPTR] }) - Complexity = 8
             // Dst: (REF_NULL_EXTERNREF:{ *:[externref] })
/* 10915*/  /*Scope*/ 12, /*->10928*/
/* 10916*/   OPC_CheckChild0Integer, 34|128,61|128,1/*24226*/, 
/* 10920*/   OPC_RecordChild1, // #0 = $ref
/* 10921*/   OPC_CheckPatternPredicate5, // (Subtarget->hasReferenceTypes())
/* 10922*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::REF_IS_NULL_EXTERNREF),
                 MVT::i32, 1/*#Ops*/, 0, 
             // Src: (intrinsic_wo_chain:{ *:[i32] } 12113:{ *:[iPTR] }, EXTERNREF:{ *:[externref] }:$ref) - Complexity = 8
             // Dst: (REF_IS_NULL_EXTERNREF:{ *:[i32] } EXTERNREF:{ *:[externref] }:$ref)
/* 10928*/  /*Scope*/ 13, /*->10942*/
/* 10929*/   OPC_CheckChild0Integer, 78|128,61|128,1/*24270*/, 
/* 10933*/   OPC_RecordChild1, // #0 = $src
/* 10934*/   OPC_RecordChild2, // #1 = $mask
/* 10935*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SWIZZLE),
                 MVT::v16i8, 2/*#Ops*/, 0, 1, 
             // Src: (intrinsic_wo_chain:{ *:[v16i8] } 12135:{ *:[iPTR] }, V128:{ *:[v16i8] }:$src, V128:{ *:[v16i8] }:$mask) - Complexity = 8
             // Dst: (SWIZZLE:{ *:[v16i8] } ?:{ *:[v16i8] }:$src, ?:{ *:[v16i8] }:$mask)
/* 10942*/  /*Scope*/ 115, /*->11058*/
/* 10943*/   OPC_CheckChild0Integer, 124|128,60|128,1/*24188*/, 
/* 10947*/   OPC_RecordChild1, // #0 = $v1
/* 10948*/   OPC_SwitchType /*6 cases */, 16, MVT::v16i8,// ->10967
/* 10951*/    OPC_CheckChild1Type, MVT::v16i8,
/* 10953*/    OPC_RecordChild2, // #1 = $v2
/* 10954*/    OPC_CheckChild2Type, MVT::v16i8,
/* 10956*/    OPC_RecordChild3, // #2 = $c
/* 10957*/    OPC_CheckChild3Type, MVT::v16i8,
/* 10959*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                  MVT::v16i8, 3/*#Ops*/, 0, 1, 2, 
              // Src: (intrinsic_wo_chain:{ *:[v16i8] } 12094:{ *:[iPTR] }, V128:{ *:[v16i8] }:$v1, V128:{ *:[v16i8] }:$v2, V128:{ *:[v16i8] }:$c) - Complexity = 8
              // Dst: (BITSELECT:{ *:[v16i8] } ?:{ *:[v16i8] }:$v1, ?:{ *:[v16i8] }:$v2, ?:{ *:[v16i8] }:$c)
/* 10967*/   /*SwitchType*/ 16, MVT::v8i16,// ->10985
/* 10969*/    OPC_CheckChild1Type, MVT::v8i16,
/* 10971*/    OPC_RecordChild2, // #1 = $v2
/* 10972*/    OPC_CheckChild2Type, MVT::v8i16,
/* 10974*/    OPC_RecordChild3, // #2 = $c
/* 10975*/    OPC_CheckChild3Type, MVT::v8i16,
/* 10977*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                  MVT::v8i16, 3/*#Ops*/, 0, 1, 2, 
              // Src: (intrinsic_wo_chain:{ *:[v8i16] } 12094:{ *:[iPTR] }, V128:{ *:[v8i16] }:$v1, V128:{ *:[v8i16] }:$v2, V128:{ *:[v8i16] }:$c) - Complexity = 8
              // Dst: (BITSELECT:{ *:[v8i16] } ?:{ *:[v8i16] }:$v1, ?:{ *:[v8i16] }:$v2, ?:{ *:[v8i16] }:$c)
/* 10985*/   /*SwitchType*/ 16, MVT::v4i32,// ->11003
/* 10987*/    OPC_CheckChild1Type, MVT::v4i32,
/* 10989*/    OPC_RecordChild2, // #1 = $v2
/* 10990*/    OPC_CheckChild2Type, MVT::v4i32,
/* 10992*/    OPC_RecordChild3, // #2 = $c
/* 10993*/    OPC_CheckChild3Type, MVT::v4i32,
/* 10995*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                  MVT::v4i32, 3/*#Ops*/, 0, 1, 2, 
              // Src: (intrinsic_wo_chain:{ *:[v4i32] } 12094:{ *:[iPTR] }, V128:{ *:[v4i32] }:$v1, V128:{ *:[v4i32] }:$v2, V128:{ *:[v4i32] }:$c) - Complexity = 8
              // Dst: (BITSELECT:{ *:[v4i32] } ?:{ *:[v4i32] }:$v1, ?:{ *:[v4i32] }:$v2, ?:{ *:[v4i32] }:$c)
/* 11003*/   /*SwitchType*/ 16, MVT::v2i64,// ->11021
/* 11005*/    OPC_CheckChild1Type, MVT::v2i64,
/* 11007*/    OPC_RecordChild2, // #1 = $v2
/* 11008*/    OPC_CheckChild2Type, MVT::v2i64,
/* 11010*/    OPC_RecordChild3, // #2 = $c
/* 11011*/    OPC_CheckChild3Type, MVT::v2i64,
/* 11013*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                  MVT::v2i64, 3/*#Ops*/, 0, 1, 2, 
              // Src: (intrinsic_wo_chain:{ *:[v2i64] } 12094:{ *:[iPTR] }, V128:{ *:[v2i64] }:$v1, V128:{ *:[v2i64] }:$v2, V128:{ *:[v2i64] }:$c) - Complexity = 8
              // Dst: (BITSELECT:{ *:[v2i64] } ?:{ *:[v2i64] }:$v1, ?:{ *:[v2i64] }:$v2, ?:{ *:[v2i64] }:$c)
/* 11021*/   /*SwitchType*/ 16, MVT::v4f32,// ->11039
/* 11023*/    OPC_CheckChild1Type, MVT::v4f32,
/* 11025*/    OPC_RecordChild2, // #1 = $v2
/* 11026*/    OPC_CheckChild2Type, MVT::v4f32,
/* 11028*/    OPC_RecordChild3, // #2 = $c
/* 11029*/    OPC_CheckChild3Type, MVT::v4f32,
/* 11031*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                  MVT::v4f32, 3/*#Ops*/, 0, 1, 2, 
              // Src: (intrinsic_wo_chain:{ *:[v4f32] } 12094:{ *:[iPTR] }, V128:{ *:[v4f32] }:$v1, V128:{ *:[v4f32] }:$v2, V128:{ *:[v4f32] }:$c) - Complexity = 8
              // Dst: (BITSELECT:{ *:[v4f32] } ?:{ *:[v4f32] }:$v1, ?:{ *:[v4f32] }:$v2, ?:{ *:[v4f32] }:$c)
/* 11039*/   /*SwitchType*/ 16, MVT::v2f64,// ->11057
/* 11041*/    OPC_CheckChild1Type, MVT::v2f64,
/* 11043*/    OPC_RecordChild2, // #1 = $v2
/* 11044*/    OPC_CheckChild2Type, MVT::v2f64,
/* 11046*/    OPC_RecordChild3, // #2 = $c
/* 11047*/    OPC_CheckChild3Type, MVT::v2f64,
/* 11049*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                  MVT::v2f64, 3/*#Ops*/, 0, 1, 2, 
              // Src: (intrinsic_wo_chain:{ *:[v2f64] } 12094:{ *:[iPTR] }, V128:{ *:[v2f64] }:$v1, V128:{ *:[v2f64] }:$v2, V128:{ *:[v2f64] }:$c) - Complexity = 8
              // Dst: (BITSELECT:{ *:[v2f64] } ?:{ *:[v2f64] }:$v1, ?:{ *:[v2f64] }:$v2, ?:{ *:[v2f64] }:$c)
/* 11057*/   0, // EndSwitchType
/* 11058*/  /*Scope*/ 37, /*->11096*/
/* 11059*/   OPC_CheckChild0Integer, 74|128,61|128,1/*24266*/, 
/* 11063*/   OPC_RecordChild1, // #0 = $lhs
/* 11064*/   OPC_SwitchType /*2 cases */, 13, MVT::v16i8,// ->11080
/* 11067*/    OPC_CheckChild1Type, MVT::v16i8,
/* 11069*/    OPC_RecordChild2, // #1 = $rhs
/* 11070*/    OPC_CheckChild2Type, MVT::v16i8,
/* 11072*/    OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 11073*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SUB_SAT_S_I8x16),
                  MVT::v16i8, 2/*#Ops*/, 0, 1, 
              // Src: (intrinsic_wo_chain:{ *:[v16i8] } 12133:{ *:[iPTR] }, V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs) - Complexity = 8
              // Dst: (SUB_SAT_S_I8x16:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs)
/* 11080*/   /*SwitchType*/ 13, MVT::v8i16,// ->11095
/* 11082*/    OPC_CheckChild1Type, MVT::v8i16,
/* 11084*/    OPC_RecordChild2, // #1 = $rhs
/* 11085*/    OPC_CheckChild2Type, MVT::v8i16,
/* 11087*/    OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 11088*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SUB_SAT_S_I16x8),
                  MVT::v8i16, 2/*#Ops*/, 0, 1, 
              // Src: (intrinsic_wo_chain:{ *:[v8i16] } 12133:{ *:[iPTR] }, V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs) - Complexity = 8
              // Dst: (SUB_SAT_S_I16x8:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs)
/* 11095*/   0, // EndSwitchType
/* 11096*/  /*Scope*/ 37, /*->11134*/
/* 11097*/   OPC_CheckChild0Integer, 76|128,61|128,1/*24268*/, 
/* 11101*/   OPC_RecordChild1, // #0 = $lhs
/* 11102*/   OPC_SwitchType /*2 cases */, 13, MVT::v16i8,// ->11118
/* 11105*/    OPC_CheckChild1Type, MVT::v16i8,
/* 11107*/    OPC_RecordChild2, // #1 = $rhs
/* 11108*/    OPC_CheckChild2Type, MVT::v16i8,
/* 11110*/    OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 11111*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SUB_SAT_U_I8x16),
                  MVT::v16i8, 2/*#Ops*/, 0, 1, 
              // Src: (intrinsic_wo_chain:{ *:[v16i8] } 12134:{ *:[iPTR] }, V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs) - Complexity = 8
              // Dst: (SUB_SAT_U_I8x16:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs)
/* 11118*/   /*SwitchType*/ 13, MVT::v8i16,// ->11133
/* 11120*/    OPC_CheckChild1Type, MVT::v8i16,
/* 11122*/    OPC_RecordChild2, // #1 = $rhs
/* 11123*/    OPC_CheckChild2Type, MVT::v8i16,
/* 11125*/    OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 11126*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SUB_SAT_U_I16x8),
                  MVT::v8i16, 2/*#Ops*/, 0, 1, 
              // Src: (intrinsic_wo_chain:{ *:[v8i16] } 12134:{ *:[iPTR] }, V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs) - Complexity = 8
              // Dst: (SUB_SAT_U_I16x8:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs)
/* 11133*/   0, // EndSwitchType
/* 11134*/  /*Scope*/ 37, /*->11172*/
/* 11135*/   OPC_CheckChild0Integer, 120|128,60|128,1/*24184*/, 
/* 11139*/   OPC_RecordChild1, // #0 = $lhs
/* 11140*/   OPC_SwitchType /*2 cases */, 13, MVT::v16i8,// ->11156
/* 11143*/    OPC_CheckChild1Type, MVT::v16i8,
/* 11145*/    OPC_RecordChild2, // #1 = $rhs
/* 11146*/    OPC_CheckChild2Type, MVT::v16i8,
/* 11148*/    OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 11149*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::AVGR_U_I8x16),
                  MVT::v16i8, 2/*#Ops*/, 0, 1, 
              // Src: (intrinsic_wo_chain:{ *:[v16i8] } 12092:{ *:[iPTR] }, V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs) - Complexity = 8
              // Dst: (AVGR_U_I8x16:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs)
/* 11156*/   /*SwitchType*/ 13, MVT::v8i16,// ->11171
/* 11158*/    OPC_CheckChild1Type, MVT::v8i16,
/* 11160*/    OPC_RecordChild2, // #1 = $rhs
/* 11161*/    OPC_CheckChild2Type, MVT::v8i16,
/* 11163*/    OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 11164*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::AVGR_U_I16x8),
                  MVT::v8i16, 2/*#Ops*/, 0, 1, 
              // Src: (intrinsic_wo_chain:{ *:[v8i16] } 12092:{ *:[iPTR] }, V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs) - Complexity = 8
              // Dst: (AVGR_U_I16x8:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs)
/* 11171*/   0, // EndSwitchType
/* 11172*/  /*Scope*/ 14, /*->11187*/
/* 11173*/   OPC_CheckChild0Integer, 0|128,61|128,1/*24192*/, 
/* 11177*/   OPC_RecordChild1, // #0 = $lhs
/* 11178*/   OPC_RecordChild2, // #1 = $rhs
/* 11179*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 11180*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::DOT),
                 MVT::v4i32, 2/*#Ops*/, 0, 1, 
             // Src: (intrinsic_wo_chain:{ *:[v4i32] } 12096:{ *:[iPTR] }, V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs) - Complexity = 8
             // Dst: (DOT:{ *:[v4i32] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs)
/* 11187*/  /*Scope*/ 37, /*->11225*/
/* 11188*/   OPC_CheckChild0Integer, 24|128,61|128,1/*24216*/, 
/* 11192*/   OPC_RecordChild1, // #0 = $low
/* 11193*/   OPC_SwitchType /*2 cases */, 13, MVT::v16i8,// ->11209
/* 11196*/    OPC_CheckChild1Type, MVT::v8i16,
/* 11198*/    OPC_RecordChild2, // #1 = $high
/* 11199*/    OPC_CheckChild2Type, MVT::v8i16,
/* 11201*/    OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 11202*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::NARROW_S_I8x16),
                  MVT::v16i8, 2/*#Ops*/, 0, 1, 
              // Src: (intrinsic_wo_chain:{ *:[v16i8] } 12108:{ *:[iPTR] }, V128:{ *:[v8i16] }:$low, V128:{ *:[v8i16] }:$high) - Complexity = 8
              // Dst: (NARROW_S_I8x16:{ *:[v16i8] } V128:{ *:[v8i16] }:$low, V128:{ *:[v8i16] }:$high)
/* 11209*/   /*SwitchType*/ 13, MVT::v8i16,// ->11224
/* 11211*/    OPC_CheckChild1Type, MVT::v4i32,
/* 11213*/    OPC_RecordChild2, // #1 = $high
/* 11214*/    OPC_CheckChild2Type, MVT::v4i32,
/* 11216*/    OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 11217*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::NARROW_S_I16x8),
                  MVT::v8i16, 2/*#Ops*/, 0, 1, 
              // Src: (intrinsic_wo_chain:{ *:[v8i16] } 12108:{ *:[iPTR] }, V128:{ *:[v4i32] }:$low, V128:{ *:[v4i32] }:$high) - Complexity = 8
              // Dst: (NARROW_S_I16x8:{ *:[v8i16] } V128:{ *:[v4i32] }:$low, V128:{ *:[v4i32] }:$high)
/* 11224*/   0, // EndSwitchType
/* 11225*/  /*Scope*/ 37, /*->11263*/
/* 11226*/   OPC_CheckChild0Integer, 26|128,61|128,1/*24218*/, 
/* 11230*/   OPC_RecordChild1, // #0 = $low
/* 11231*/   OPC_SwitchType /*2 cases */, 13, MVT::v16i8,// ->11247
/* 11234*/    OPC_CheckChild1Type, MVT::v8i16,
/* 11236*/    OPC_RecordChild2, // #1 = $high
/* 11237*/    OPC_CheckChild2Type, MVT::v8i16,
/* 11239*/    OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 11240*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::NARROW_U_I8x16),
                  MVT::v16i8, 2/*#Ops*/, 0, 1, 
              // Src: (intrinsic_wo_chain:{ *:[v16i8] } 12109:{ *:[iPTR] }, V128:{ *:[v8i16] }:$low, V128:{ *:[v8i16] }:$high) - Complexity = 8
              // Dst: (NARROW_U_I8x16:{ *:[v16i8] } V128:{ *:[v8i16] }:$low, V128:{ *:[v8i16] }:$high)
/* 11247*/   /*SwitchType*/ 13, MVT::v8i16,// ->11262
/* 11249*/    OPC_CheckChild1Type, MVT::v4i32,
/* 11251*/    OPC_RecordChild2, // #1 = $high
/* 11252*/    OPC_CheckChild2Type, MVT::v4i32,
/* 11254*/    OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 11255*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::NARROW_U_I16x8),
                  MVT::v8i16, 2/*#Ops*/, 0, 1, 
              // Src: (intrinsic_wo_chain:{ *:[v8i16] } 12109:{ *:[iPTR] }, V128:{ *:[v4i32] }:$low, V128:{ *:[v4i32] }:$high) - Complexity = 8
              // Dst: (NARROW_U_I16x8:{ *:[v8i16] } V128:{ *:[v4i32] }:$low, V128:{ *:[v4i32] }:$high)
/* 11262*/   0, // EndSwitchType
/* 11263*/  /*Scope*/ 29, /*->11293*/
/* 11264*/   OPC_CheckChild0Integer, 2|128,61|128,1/*24194*/, 
/* 11268*/   OPC_RecordChild1, // #0 = $vec
/* 11269*/   OPC_SwitchType /*2 cases */, 9, MVT::v8i16,// ->11281
/* 11272*/    OPC_CheckChild1Type, MVT::v16i8,
/* 11274*/    OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 11275*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::int_wasm_extadd_pairwise_signed_I16x8),
                  MVT::v8i16, 1/*#Ops*/, 0, 
              // Src: (intrinsic_wo_chain:{ *:[v8i16] } 12097:{ *:[iPTR] }, V128:{ *:[v16i8] }:$vec) - Complexity = 8
              // Dst: (int_wasm_extadd_pairwise_signed_I16x8:{ *:[v8i16] } V128:{ *:[v16i8] }:$vec)
/* 11281*/   /*SwitchType*/ 9, MVT::v4i32,// ->11292
/* 11283*/    OPC_CheckChild1Type, MVT::v8i16,
/* 11285*/    OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 11286*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::int_wasm_extadd_pairwise_signed_I32x4),
                  MVT::v4i32, 1/*#Ops*/, 0, 
              // Src: (intrinsic_wo_chain:{ *:[v4i32] } 12097:{ *:[iPTR] }, V128:{ *:[v8i16] }:$vec) - Complexity = 8
              // Dst: (int_wasm_extadd_pairwise_signed_I32x4:{ *:[v4i32] } V128:{ *:[v8i16] }:$vec)
/* 11292*/   0, // EndSwitchType
/* 11293*/  /*Scope*/ 29, /*->11323*/
/* 11294*/   OPC_CheckChild0Integer, 4|128,61|128,1/*24196*/, 
/* 11298*/   OPC_RecordChild1, // #0 = $vec
/* 11299*/   OPC_SwitchType /*2 cases */, 9, MVT::v8i16,// ->11311
/* 11302*/    OPC_CheckChild1Type, MVT::v16i8,
/* 11304*/    OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 11305*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::int_wasm_extadd_pairwise_unsigned_I16x8),
                  MVT::v8i16, 1/*#Ops*/, 0, 
              // Src: (intrinsic_wo_chain:{ *:[v8i16] } 12098:{ *:[iPTR] }, V128:{ *:[v16i8] }:$vec) - Complexity = 8
              // Dst: (int_wasm_extadd_pairwise_unsigned_I16x8:{ *:[v8i16] } V128:{ *:[v16i8] }:$vec)
/* 11311*/   /*SwitchType*/ 9, MVT::v4i32,// ->11322
/* 11313*/    OPC_CheckChild1Type, MVT::v8i16,
/* 11315*/    OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 11316*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::int_wasm_extadd_pairwise_unsigned_I32x4),
                  MVT::v4i32, 1/*#Ops*/, 0, 
              // Src: (intrinsic_wo_chain:{ *:[v4i32] } 12098:{ *:[iPTR] }, V128:{ *:[v8i16] }:$vec) - Complexity = 8
              // Dst: (int_wasm_extadd_pairwise_unsigned_I32x4:{ *:[v4i32] } V128:{ *:[v8i16] }:$vec)
/* 11322*/   0, // EndSwitchType
/* 11323*/  /*Scope*/ 14, /*->11338*/
/* 11324*/   OPC_CheckChild0Integer, 32|128,61|128,1/*24224*/, 
/* 11328*/   OPC_RecordChild1, // #0 = $lhs
/* 11329*/   OPC_RecordChild2, // #1 = $rhs
/* 11330*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 11331*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::Q15MULR_SAT_S_I16x8),
                 MVT::v8i16, 2/*#Ops*/, 0, 1, 
             // Src: (intrinsic_wo_chain:{ *:[v8i16] } 12112:{ *:[iPTR] }, V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs) - Complexity = 8
             // Dst: (Q15MULR_SAT_S_I16x8:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs)
/* 11338*/  /*Scope*/ 14, /*->11353*/
/* 11339*/   OPC_CheckChild0Integer, 60|128,61|128,1/*24252*/, 
/* 11343*/   OPC_RecordChild1, // #0 = $src
/* 11344*/   OPC_RecordChild2, // #1 = $mask
/* 11345*/   OPC_CheckPatternPredicate6, // (Subtarget->hasRelaxedSIMD())
/* 11346*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::RELAXED_SWIZZLE),
                 MVT::v16i8, 2/*#Ops*/, 0, 1, 
             // Src: (intrinsic_wo_chain:{ *:[v16i8] } 12126:{ *:[iPTR] }, V128:{ *:[v16i8] }:$src, V128:{ *:[v16i8] }:$mask) - Complexity = 8
             // Dst: (RELAXED_SWIZZLE:{ *:[v16i8] } V128:{ *:[v16i8] }:$src, V128:{ *:[v16i8] }:$mask)
/* 11353*/  /*Scope*/ 12, /*->11366*/
/* 11354*/   OPC_CheckChild0Integer, 62|128,61|128,1/*24254*/, 
/* 11358*/   OPC_RecordChild1, // #0 = $vec
/* 11359*/   OPC_CheckPatternPredicate6, // (Subtarget->hasRelaxedSIMD())
/* 11360*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::int_wasm_relaxed_trunc_signed_I32x4),
                 MVT::v4i32, 1/*#Ops*/, 0, 
             // Src: (intrinsic_wo_chain:{ *:[v4i32] } 12127:{ *:[iPTR] }, V128:{ *:[v4f32] }:$vec) - Complexity = 8
             // Dst: (int_wasm_relaxed_trunc_signed_I32x4:{ *:[v4i32] } V128:{ *:[v4f32] }:$vec)
/* 11366*/  /*Scope*/ 12, /*->11379*/
/* 11367*/   OPC_CheckChild0Integer, 66|128,61|128,1/*24258*/, 
/* 11371*/   OPC_RecordChild1, // #0 = $vec
/* 11372*/   OPC_CheckPatternPredicate6, // (Subtarget->hasRelaxedSIMD())
/* 11373*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::int_wasm_relaxed_trunc_unsigned_I32x4),
                 MVT::v4i32, 1/*#Ops*/, 0, 
             // Src: (intrinsic_wo_chain:{ *:[v4i32] } 12129:{ *:[iPTR] }, V128:{ *:[v4f32] }:$vec) - Complexity = 8
             // Dst: (int_wasm_relaxed_trunc_unsigned_I32x4:{ *:[v4i32] } V128:{ *:[v4f32] }:$vec)
/* 11379*/  /*Scope*/ 12, /*->11392*/
/* 11380*/   OPC_CheckChild0Integer, 64|128,61|128,1/*24256*/, 
/* 11384*/   OPC_RecordChild1, // #0 = $vec
/* 11385*/   OPC_CheckPatternPredicate6, // (Subtarget->hasRelaxedSIMD())
/* 11386*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::int_wasm_relaxed_trunc_signed_zero_I32x4),
                 MVT::v4i32, 1/*#Ops*/, 0, 
             // Src: (intrinsic_wo_chain:{ *:[v4i32] } 12128:{ *:[iPTR] }, V128:{ *:[v2f64] }:$vec) - Complexity = 8
             // Dst: (int_wasm_relaxed_trunc_signed_zero_I32x4:{ *:[v4i32] } V128:{ *:[v2f64] }:$vec)
/* 11392*/  /*Scope*/ 12, /*->11405*/
/* 11393*/   OPC_CheckChild0Integer, 68|128,61|128,1/*24260*/, 
/* 11397*/   OPC_RecordChild1, // #0 = $vec
/* 11398*/   OPC_CheckPatternPredicate6, // (Subtarget->hasRelaxedSIMD())
/* 11399*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::int_wasm_relaxed_trunc_unsigned_zero_I32x4),
                 MVT::v4i32, 1/*#Ops*/, 0, 
             // Src: (intrinsic_wo_chain:{ *:[v4i32] } 12130:{ *:[iPTR] }, V128:{ *:[v2f64] }:$vec) - Complexity = 8
             // Dst: (int_wasm_relaxed_trunc_unsigned_zero_I32x4:{ *:[v4i32] } V128:{ *:[v2f64] }:$vec)
/* 11405*/  /*Scope*/ 83, /*->11489*/
/* 11406*/   OPC_CheckChild0Integer, 48|128,61|128,1/*24240*/, 
/* 11410*/   OPC_RecordChild1, // #0 = $a
/* 11411*/   OPC_SwitchType /*4 cases */, 17, MVT::v16i8,// ->11431
/* 11414*/    OPC_CheckChild1Type, MVT::v16i8,
/* 11416*/    OPC_RecordChild2, // #1 = $b
/* 11417*/    OPC_CheckChild2Type, MVT::v16i8,
/* 11419*/    OPC_RecordChild3, // #2 = $c
/* 11420*/    OPC_CheckChild3Type, MVT::v16i8,
/* 11422*/    OPC_CheckPatternPredicate6, // (Subtarget->hasRelaxedSIMD())
/* 11423*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::LANESELECT_I8x16),
                  MVT::v16i8, 3/*#Ops*/, 0, 1, 2, 
              // Src: (intrinsic_wo_chain:{ *:[v16i8] } 12120:{ *:[iPTR] }, V128:{ *:[v16i8] }:$a, V128:{ *:[v16i8] }:$b, V128:{ *:[v16i8] }:$c) - Complexity = 8
              // Dst: (LANESELECT_I8x16:{ *:[v16i8] } V128:{ *:[v16i8] }:$a, V128:{ *:[v16i8] }:$b, V128:{ *:[v16i8] }:$c)
/* 11431*/   /*SwitchType*/ 17, MVT::v8i16,// ->11450
/* 11433*/    OPC_CheckChild1Type, MVT::v8i16,
/* 11435*/    OPC_RecordChild2, // #1 = $b
/* 11436*/    OPC_CheckChild2Type, MVT::v8i16,
/* 11438*/    OPC_RecordChild3, // #2 = $c
/* 11439*/    OPC_CheckChild3Type, MVT::v8i16,
/* 11441*/    OPC_CheckPatternPredicate6, // (Subtarget->hasRelaxedSIMD())
/* 11442*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::LANESELECT_I16x8),
                  MVT::v8i16, 3/*#Ops*/, 0, 1, 2, 
              // Src: (intrinsic_wo_chain:{ *:[v8i16] } 12120:{ *:[iPTR] }, V128:{ *:[v8i16] }:$a, V128:{ *:[v8i16] }:$b, V128:{ *:[v8i16] }:$c) - Complexity = 8
              // Dst: (LANESELECT_I16x8:{ *:[v8i16] } V128:{ *:[v8i16] }:$a, V128:{ *:[v8i16] }:$b, V128:{ *:[v8i16] }:$c)
/* 11450*/   /*SwitchType*/ 17, MVT::v4i32,// ->11469
/* 11452*/    OPC_CheckChild1Type, MVT::v4i32,
/* 11454*/    OPC_RecordChild2, // #1 = $b
/* 11455*/    OPC_CheckChild2Type, MVT::v4i32,
/* 11457*/    OPC_RecordChild3, // #2 = $c
/* 11458*/    OPC_CheckChild3Type, MVT::v4i32,
/* 11460*/    OPC_CheckPatternPredicate6, // (Subtarget->hasRelaxedSIMD())
/* 11461*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::LANESELECT_I32x4),
                  MVT::v4i32, 3/*#Ops*/, 0, 1, 2, 
              // Src: (intrinsic_wo_chain:{ *:[v4i32] } 12120:{ *:[iPTR] }, V128:{ *:[v4i32] }:$a, V128:{ *:[v4i32] }:$b, V128:{ *:[v4i32] }:$c) - Complexity = 8
              // Dst: (LANESELECT_I32x4:{ *:[v4i32] } V128:{ *:[v4i32] }:$a, V128:{ *:[v4i32] }:$b, V128:{ *:[v4i32] }:$c)
/* 11469*/   /*SwitchType*/ 17, MVT::v2i64,// ->11488
/* 11471*/    OPC_CheckChild1Type, MVT::v2i64,
/* 11473*/    OPC_RecordChild2, // #1 = $b
/* 11474*/    OPC_CheckChild2Type, MVT::v2i64,
/* 11476*/    OPC_RecordChild3, // #2 = $c
/* 11477*/    OPC_CheckChild3Type, MVT::v2i64,
/* 11479*/    OPC_CheckPatternPredicate6, // (Subtarget->hasRelaxedSIMD())
/* 11480*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::LANESELECT_I64x2),
                  MVT::v2i64, 3/*#Ops*/, 0, 1, 2, 
              // Src: (intrinsic_wo_chain:{ *:[v2i64] } 12120:{ *:[iPTR] }, V128:{ *:[v2i64] }:$a, V128:{ *:[v2i64] }:$b, V128:{ *:[v2i64] }:$c) - Complexity = 8
              // Dst: (LANESELECT_I64x2:{ *:[v2i64] } V128:{ *:[v2i64] }:$a, V128:{ *:[v2i64] }:$b, V128:{ *:[v2i64] }:$c)
/* 11488*/   0, // EndSwitchType
/* 11489*/  /*Scope*/ 14, /*->11504*/
/* 11490*/   OPC_CheckChild0Integer, 58|128,61|128,1/*24250*/, 
/* 11494*/   OPC_RecordChild1, // #0 = $lhs
/* 11495*/   OPC_RecordChild2, // #1 = $rhs
/* 11496*/   OPC_CheckPatternPredicate6, // (Subtarget->hasRelaxedSIMD())
/* 11497*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::RELAXED_Q15MULR_S_I16x8),
                 MVT::v8i16, 2/*#Ops*/, 0, 1, 
             // Src: (intrinsic_wo_chain:{ *:[v8i16] } 12125:{ *:[iPTR] }, V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs) - Complexity = 8
             // Dst: (RELAXED_Q15MULR_S_I16x8:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs)
/* 11504*/  /*Scope*/ 14, /*->11519*/
/* 11505*/   OPC_CheckChild0Integer, 46|128,61|128,1/*24238*/, 
/* 11509*/   OPC_RecordChild1, // #0 = $lhs
/* 11510*/   OPC_RecordChild2, // #1 = $rhs
/* 11511*/   OPC_CheckPatternPredicate6, // (Subtarget->hasRelaxedSIMD())
/* 11512*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::RELAXED_DOT),
                 MVT::v8i16, 2/*#Ops*/, 0, 1, 
             // Src: (intrinsic_wo_chain:{ *:[v8i16] } 12119:{ *:[iPTR] }, V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs) - Complexity = 8
             // Dst: (RELAXED_DOT:{ *:[v8i16] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs)
/* 11519*/  /*Scope*/ 16, /*->11536*/
/* 11520*/   OPC_CheckChild0Integer, 44|128,61|128,1/*24236*/, 
/* 11524*/   OPC_RecordChild1, // #0 = $lhs
/* 11525*/   OPC_RecordChild2, // #1 = $rhs
/* 11526*/   OPC_RecordChild3, // #2 = $acc
/* 11527*/   OPC_CheckPatternPredicate6, // (Subtarget->hasRelaxedSIMD())
/* 11528*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::RELAXED_DOT_ADD),
                 MVT::v4i32, 3/*#Ops*/, 0, 1, 2, 
             // Src: (intrinsic_wo_chain:{ *:[v4i32] } 12118:{ *:[iPTR] }, V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs, V128:{ *:[v4i32] }:$acc) - Complexity = 8
             // Dst: (RELAXED_DOT_ADD:{ *:[v4i32] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs, V128:{ *:[v4i32] }:$acc)
/* 11536*/  /*Scope*/ 35, /*->11572*/
/* 11537*/   OPC_CheckChild0Integer, 30|128,61|128,1/*24222*/, 
/* 11541*/   OPC_RecordChild1, // #0 = $lhs
/* 11542*/   OPC_SwitchType /*2 cases */, 12, MVT::v4f32,// ->11557
/* 11545*/    OPC_CheckChild1Type, MVT::v4f32,
/* 11547*/    OPC_RecordChild2, // #1 = $rhs
/* 11548*/    OPC_CheckChild2Type, MVT::v4f32,
/* 11550*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::PMIN_F32x4),
                  MVT::v4f32, 2/*#Ops*/, 0, 1, 
              // Src: (intrinsic_wo_chain:{ *:[v4f32] } 12111:{ *:[iPTR] }, V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs) - Complexity = 8
              // Dst: (PMIN_F32x4:{ *:[v4f32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs)
/* 11557*/   /*SwitchType*/ 12, MVT::v2f64,// ->11571
/* 11559*/    OPC_CheckChild1Type, MVT::v2f64,
/* 11561*/    OPC_RecordChild2, // #1 = $rhs
/* 11562*/    OPC_CheckChild2Type, MVT::v2f64,
/* 11564*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::PMIN_F64x2),
                  MVT::v2f64, 2/*#Ops*/, 0, 1, 
              // Src: (intrinsic_wo_chain:{ *:[v2f64] } 12111:{ *:[iPTR] }, V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs) - Complexity = 8
              // Dst: (PMIN_F64x2:{ *:[v2f64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs)
/* 11571*/   0, // EndSwitchType
/* 11572*/  /*Scope*/ 35, /*->11608*/
/* 11573*/   OPC_CheckChild0Integer, 28|128,61|128,1/*24220*/, 
/* 11577*/   OPC_RecordChild1, // #0 = $lhs
/* 11578*/   OPC_SwitchType /*2 cases */, 12, MVT::v4f32,// ->11593
/* 11581*/    OPC_CheckChild1Type, MVT::v4f32,
/* 11583*/    OPC_RecordChild2, // #1 = $rhs
/* 11584*/    OPC_CheckChild2Type, MVT::v4f32,
/* 11586*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::PMAX_F32x4),
                  MVT::v4f32, 2/*#Ops*/, 0, 1, 
              // Src: (intrinsic_wo_chain:{ *:[v4f32] } 12110:{ *:[iPTR] }, V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs) - Complexity = 8
              // Dst: (PMAX_F32x4:{ *:[v4f32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs)
/* 11593*/   /*SwitchType*/ 12, MVT::v2f64,// ->11607
/* 11595*/    OPC_CheckChild1Type, MVT::v2f64,
/* 11597*/    OPC_RecordChild2, // #1 = $rhs
/* 11598*/    OPC_CheckChild2Type, MVT::v2f64,
/* 11600*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::PMAX_F64x2),
                  MVT::v2f64, 2/*#Ops*/, 0, 1, 
              // Src: (intrinsic_wo_chain:{ *:[v2f64] } 12110:{ *:[iPTR] }, V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs) - Complexity = 8
              // Dst: (PMAX_F64x2:{ *:[v2f64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs)
/* 11607*/   0, // EndSwitchType
/* 11608*/  /*Scope*/ 45, /*->11654*/
/* 11609*/   OPC_CheckChild0Integer, 50|128,61|128,1/*24242*/, 
/* 11613*/   OPC_RecordChild1, // #0 = $a
/* 11614*/   OPC_SwitchType /*2 cases */, 17, MVT::v4f32,// ->11634
/* 11617*/    OPC_CheckChild1Type, MVT::v4f32,
/* 11619*/    OPC_RecordChild2, // #1 = $b
/* 11620*/    OPC_CheckChild2Type, MVT::v4f32,
/* 11622*/    OPC_RecordChild3, // #2 = $c
/* 11623*/    OPC_CheckChild3Type, MVT::v4f32,
/* 11625*/    OPC_CheckPatternPredicate6, // (Subtarget->hasRelaxedSIMD())
/* 11626*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::MADD_F32x4),
                  MVT::v4f32, 3/*#Ops*/, 0, 1, 2, 
              // Src: (intrinsic_wo_chain:{ *:[v4f32] } 12121:{ *:[iPTR] }, V128:{ *:[v4f32] }:$a, V128:{ *:[v4f32] }:$b, V128:{ *:[v4f32] }:$c) - Complexity = 8
              // Dst: (MADD_F32x4:{ *:[v4f32] } V128:{ *:[v4f32] }:$a, V128:{ *:[v4f32] }:$b, V128:{ *:[v4f32] }:$c)
/* 11634*/   /*SwitchType*/ 17, MVT::v2f64,// ->11653
/* 11636*/    OPC_CheckChild1Type, MVT::v2f64,
/* 11638*/    OPC_RecordChild2, // #1 = $b
/* 11639*/    OPC_CheckChild2Type, MVT::v2f64,
/* 11641*/    OPC_RecordChild3, // #2 = $c
/* 11642*/    OPC_CheckChild3Type, MVT::v2f64,
/* 11644*/    OPC_CheckPatternPredicate6, // (Subtarget->hasRelaxedSIMD())
/* 11645*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::MADD_F64x2),
                  MVT::v2f64, 3/*#Ops*/, 0, 1, 2, 
              // Src: (intrinsic_wo_chain:{ *:[v2f64] } 12121:{ *:[iPTR] }, V128:{ *:[v2f64] }:$a, V128:{ *:[v2f64] }:$b, V128:{ *:[v2f64] }:$c) - Complexity = 8
              // Dst: (MADD_F64x2:{ *:[v2f64] } V128:{ *:[v2f64] }:$a, V128:{ *:[v2f64] }:$b, V128:{ *:[v2f64] }:$c)
/* 11653*/   0, // EndSwitchType
/* 11654*/  /*Scope*/ 45, /*->11700*/
/* 11655*/   OPC_CheckChild0Integer, 56|128,61|128,1/*24248*/, 
/* 11659*/   OPC_RecordChild1, // #0 = $a
/* 11660*/   OPC_SwitchType /*2 cases */, 17, MVT::v4f32,// ->11680
/* 11663*/    OPC_CheckChild1Type, MVT::v4f32,
/* 11665*/    OPC_RecordChild2, // #1 = $b
/* 11666*/    OPC_CheckChild2Type, MVT::v4f32,
/* 11668*/    OPC_RecordChild3, // #2 = $c
/* 11669*/    OPC_CheckChild3Type, MVT::v4f32,
/* 11671*/    OPC_CheckPatternPredicate6, // (Subtarget->hasRelaxedSIMD())
/* 11672*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::NMADD_F32x4),
                  MVT::v4f32, 3/*#Ops*/, 0, 1, 2, 
              // Src: (intrinsic_wo_chain:{ *:[v4f32] } 12124:{ *:[iPTR] }, V128:{ *:[v4f32] }:$a, V128:{ *:[v4f32] }:$b, V128:{ *:[v4f32] }:$c) - Complexity = 8
              // Dst: (NMADD_F32x4:{ *:[v4f32] } V128:{ *:[v4f32] }:$a, V128:{ *:[v4f32] }:$b, V128:{ *:[v4f32] }:$c)
/* 11680*/   /*SwitchType*/ 17, MVT::v2f64,// ->11699
/* 11682*/    OPC_CheckChild1Type, MVT::v2f64,
/* 11684*/    OPC_RecordChild2, // #1 = $b
/* 11685*/    OPC_CheckChild2Type, MVT::v2f64,
/* 11687*/    OPC_RecordChild3, // #2 = $c
/* 11688*/    OPC_CheckChild3Type, MVT::v2f64,
/* 11690*/    OPC_CheckPatternPredicate6, // (Subtarget->hasRelaxedSIMD())
/* 11691*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::NMADD_F64x2),
                  MVT::v2f64, 3/*#Ops*/, 0, 1, 2, 
              // Src: (intrinsic_wo_chain:{ *:[v2f64] } 12124:{ *:[iPTR] }, V128:{ *:[v2f64] }:$a, V128:{ *:[v2f64] }:$b, V128:{ *:[v2f64] }:$c) - Complexity = 8
              // Dst: (NMADD_F64x2:{ *:[v2f64] } V128:{ *:[v2f64] }:$a, V128:{ *:[v2f64] }:$b, V128:{ *:[v2f64] }:$c)
/* 11699*/   0, // EndSwitchType
/* 11700*/  /*Scope*/ 37, /*->11738*/
/* 11701*/   OPC_CheckChild0Integer, 54|128,61|128,1/*24246*/, 
/* 11705*/   OPC_RecordChild1, // #0 = $lhs
/* 11706*/   OPC_SwitchType /*2 cases */, 13, MVT::v4f32,// ->11722
/* 11709*/    OPC_CheckChild1Type, MVT::v4f32,
/* 11711*/    OPC_RecordChild2, // #1 = $rhs
/* 11712*/    OPC_CheckChild2Type, MVT::v4f32,
/* 11714*/    OPC_CheckPatternPredicate6, // (Subtarget->hasRelaxedSIMD())
/* 11715*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SIMD_RELAXED_FMIN_F32x4),
                  MVT::v4f32, 2/*#Ops*/, 0, 1, 
              // Src: (intrinsic_wo_chain:{ *:[v4f32] } 12123:{ *:[iPTR] }, V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs) - Complexity = 8
              // Dst: (SIMD_RELAXED_FMIN_F32x4:{ *:[v4f32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs)
/* 11722*/   /*SwitchType*/ 13, MVT::v2f64,// ->11737
/* 11724*/    OPC_CheckChild1Type, MVT::v2f64,
/* 11726*/    OPC_RecordChild2, // #1 = $rhs
/* 11727*/    OPC_CheckChild2Type, MVT::v2f64,
/* 11729*/    OPC_CheckPatternPredicate6, // (Subtarget->hasRelaxedSIMD())
/* 11730*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SIMD_RELAXED_FMIN_F64x2),
                  MVT::v2f64, 2/*#Ops*/, 0, 1, 
              // Src: (intrinsic_wo_chain:{ *:[v2f64] } 12123:{ *:[iPTR] }, V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs) - Complexity = 8
              // Dst: (SIMD_RELAXED_FMIN_F64x2:{ *:[v2f64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs)
/* 11737*/   0, // EndSwitchType
/* 11738*/  /*Scope*/ 37, /*->11776*/
/* 11739*/   OPC_CheckChild0Integer, 52|128,61|128,1/*24244*/, 
/* 11743*/   OPC_RecordChild1, // #0 = $lhs
/* 11744*/   OPC_SwitchType /*2 cases */, 13, MVT::v4f32,// ->11760
/* 11747*/    OPC_CheckChild1Type, MVT::v4f32,
/* 11749*/    OPC_RecordChild2, // #1 = $rhs
/* 11750*/    OPC_CheckChild2Type, MVT::v4f32,
/* 11752*/    OPC_CheckPatternPredicate6, // (Subtarget->hasRelaxedSIMD())
/* 11753*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SIMD_RELAXED_FMAX_F32x4),
                  MVT::v4f32, 2/*#Ops*/, 0, 1, 
              // Src: (intrinsic_wo_chain:{ *:[v4f32] } 12122:{ *:[iPTR] }, V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs) - Complexity = 8
              // Dst: (SIMD_RELAXED_FMAX_F32x4:{ *:[v4f32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs)
/* 11760*/   /*SwitchType*/ 13, MVT::v2f64,// ->11775
/* 11762*/    OPC_CheckChild1Type, MVT::v2f64,
/* 11764*/    OPC_RecordChild2, // #1 = $rhs
/* 11765*/    OPC_CheckChild2Type, MVT::v2f64,
/* 11767*/    OPC_CheckPatternPredicate6, // (Subtarget->hasRelaxedSIMD())
/* 11768*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SIMD_RELAXED_FMAX_F64x2),
                  MVT::v2f64, 2/*#Ops*/, 0, 1, 
              // Src: (intrinsic_wo_chain:{ *:[v2f64] } 12122:{ *:[iPTR] }, V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs) - Complexity = 8
              // Dst: (SIMD_RELAXED_FMAX_F64x2:{ *:[v2f64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs)
/* 11775*/   0, // EndSwitchType
/* 11776*/  /*Scope*/ 16, /*->11793*/
/* 11777*/   OPC_CheckChild0Integer, 42|128,61|128,1/*24234*/, 
/* 11781*/   OPC_RecordChild1, // #0 = $lhs
/* 11782*/   OPC_RecordChild2, // #1 = $rhs
/* 11783*/   OPC_RecordChild3, // #2 = $acc
/* 11784*/   OPC_CheckPatternPredicate6, // (Subtarget->hasRelaxedSIMD())
/* 11785*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::RELAXED_DOT_BFLOAT),
                 MVT::v4f32, 3/*#Ops*/, 0, 1, 2, 
             // Src: (intrinsic_wo_chain:{ *:[v4f32] } 12117:{ *:[iPTR] }, V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs, V128:{ *:[v4f32] }:$acc) - Complexity = 8
             // Dst: (RELAXED_DOT_BFLOAT:{ *:[v4f32] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs, V128:{ *:[v4f32] }:$acc)
/* 11793*/  0, /*End of Scope*/
/* 11794*/ /*SwitchOpcode*/ 3|128,1/*131*/, TARGET_VAL(ISD::EXTRACT_VECTOR_ELT),// ->11929
/* 11798*/  OPC_RecordChild0, // #0 = $vec
/* 11799*/  OPC_Scope, 20, /*->11821*/ // 6 children in Scope
/* 11801*/   OPC_CheckChild0Type, MVT::v16i8,
/* 11803*/   OPC_RecordChild1, // #1 = $idx
/* 11804*/   OPC_MoveChild1,
/* 11805*/   OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 11808*/   OPC_CheckPredicate, 15, // Predicate_LaneIdx16
/* 11810*/   OPC_CheckTypeI32,
/* 11811*/   OPC_MoveParent,
/* 11812*/   OPC_CheckTypeI32,
/* 11813*/   OPC_EmitConvertToTarget1,
/* 11814*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::EXTRACT_LANE_I8x16_u),
                 MVT::i32, 2/*#Ops*/, 0, 2, 
             // Src: (vector_extract:{ *:[i32] } V128:{ *:[v16i8] }:$vec, (imm:{ *:[i32] })<<P:Predicate_LaneIdx16>>:$idx) - Complexity = 7
             // Dst: (EXTRACT_LANE_I8x16_u:{ *:[i32] } ?:{ *:[v16i8] }:$vec, (imm:{ *:[i32] }):$idx)
/* 11821*/  /*Scope*/ 20, /*->11842*/
/* 11822*/   OPC_CheckChild0Type, MVT::v8i16,
/* 11824*/   OPC_RecordChild1, // #1 = $idx
/* 11825*/   OPC_MoveChild1,
/* 11826*/   OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 11829*/   OPC_CheckPredicate, 16, // Predicate_LaneIdx8
/* 11831*/   OPC_CheckTypeI32,
/* 11832*/   OPC_MoveParent,
/* 11833*/   OPC_CheckTypeI32,
/* 11834*/   OPC_EmitConvertToTarget1,
/* 11835*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::EXTRACT_LANE_I16x8_u),
                 MVT::i32, 2/*#Ops*/, 0, 2, 
             // Src: (vector_extract:{ *:[i32] } V128:{ *:[v8i16] }:$vec, (imm:{ *:[i32] })<<P:Predicate_LaneIdx8>>:$idx) - Complexity = 7
             // Dst: (EXTRACT_LANE_I16x8_u:{ *:[i32] } ?:{ *:[v8i16] }:$vec, (imm:{ *:[i32] }):$idx)
/* 11842*/  /*Scope*/ 20, /*->11863*/
/* 11843*/   OPC_CheckChild0Type, MVT::v4i32,
/* 11845*/   OPC_RecordChild1, // #1 = $idx
/* 11846*/   OPC_MoveChild1,
/* 11847*/   OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 11850*/   OPC_CheckPredicate, 17, // Predicate_LaneIdx4
/* 11852*/   OPC_CheckTypeI32,
/* 11853*/   OPC_MoveParent,
/* 11854*/   OPC_CheckTypeI32,
/* 11855*/   OPC_EmitConvertToTarget1,
/* 11856*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::EXTRACT_LANE_I32x4),
                 MVT::i32, 2/*#Ops*/, 0, 2, 
             // Src: (vector_extract:{ *:[i32] } V128:{ *:[v4i32] }:$vec, (imm:{ *:[i32] })<<P:Predicate_LaneIdx4>>:$idx) - Complexity = 7
             // Dst: (EXTRACT_LANE_I32x4:{ *:[i32] } ?:{ *:[v4i32] }:$vec, (imm:{ *:[i32] }):$idx)
/* 11863*/  /*Scope*/ 20, /*->11884*/
/* 11864*/   OPC_CheckChild0Type, MVT::v2i64,
/* 11866*/   OPC_RecordChild1, // #1 = $idx
/* 11867*/   OPC_MoveChild1,
/* 11868*/   OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 11871*/   OPC_CheckPredicate, 18, // Predicate_LaneIdx2
/* 11873*/   OPC_CheckTypeI32,
/* 11874*/   OPC_MoveParent,
/* 11875*/   OPC_CheckTypeI64,
/* 11876*/   OPC_EmitConvertToTarget1,
/* 11877*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::EXTRACT_LANE_I64x2),
                 MVT::i64, 2/*#Ops*/, 0, 2, 
             // Src: (vector_extract:{ *:[i64] } V128:{ *:[v2i64] }:$vec, (imm:{ *:[i32] })<<P:Predicate_LaneIdx2>>:$idx) - Complexity = 7
             // Dst: (EXTRACT_LANE_I64x2:{ *:[i64] } ?:{ *:[v2i64] }:$vec, (imm:{ *:[i32] }):$idx)
/* 11884*/  /*Scope*/ 21, /*->11906*/
/* 11885*/   OPC_CheckChild0Type, MVT::v4f32,
/* 11887*/   OPC_RecordChild1, // #1 = $idx
/* 11888*/   OPC_MoveChild1,
/* 11889*/   OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 11892*/   OPC_CheckPredicate, 17, // Predicate_LaneIdx4
/* 11894*/   OPC_CheckTypeI32,
/* 11895*/   OPC_MoveParent,
/* 11896*/   OPC_CheckType, MVT::f32,
/* 11898*/   OPC_EmitConvertToTarget1,
/* 11899*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::EXTRACT_LANE_F32x4),
                 MVT::f32, 2/*#Ops*/, 0, 2, 
             // Src: (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$vec, (imm:{ *:[i32] })<<P:Predicate_LaneIdx4>>:$idx) - Complexity = 7
             // Dst: (EXTRACT_LANE_F32x4:{ *:[f32] } ?:{ *:[v4f32] }:$vec, (imm:{ *:[i32] }):$idx)
/* 11906*/  /*Scope*/ 21, /*->11928*/
/* 11907*/   OPC_CheckChild0Type, MVT::v2f64,
/* 11909*/   OPC_RecordChild1, // #1 = $idx
/* 11910*/   OPC_MoveChild1,
/* 11911*/   OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 11914*/   OPC_CheckPredicate, 18, // Predicate_LaneIdx2
/* 11916*/   OPC_CheckTypeI32,
/* 11917*/   OPC_MoveParent,
/* 11918*/   OPC_CheckType, MVT::f64,
/* 11920*/   OPC_EmitConvertToTarget1,
/* 11921*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::EXTRACT_LANE_F64x2),
                 MVT::f64, 2/*#Ops*/, 0, 2, 
             // Src: (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$vec, (imm:{ *:[i32] })<<P:Predicate_LaneIdx2>>:$idx) - Complexity = 7
             // Dst: (EXTRACT_LANE_F64x2:{ *:[f64] } ?:{ *:[v2f64] }:$vec, (imm:{ *:[i32] }):$idx)
/* 11928*/  0, /*End of Scope*/
/* 11929*/ /*SwitchOpcode*/ 104, TARGET_VAL(WebAssemblyISD::ARGUMENT),// ->12036
/* 11932*/  OPC_RecordChild0, // #0 = $argno
/* 11933*/  OPC_MoveChild0,
/* 11934*/  OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 11937*/  OPC_MoveParent,
/* 11938*/  OPC_SwitchType /*12 cases */, 6, MVT::i32,// ->11947
/* 11941*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ARGUMENT_i32),
                 MVT::i32, 1/*#Ops*/, 0, 
             // Src: (WebAssemblyargument:{ *:[i32] } (timm:{ *:[i32] }):$argno) - Complexity = 6
             // Dst: (ARGUMENT_i32:{ *:[i32] } (timm:{ *:[i32] }):$argno)
/* 11947*/  /*SwitchType*/ 6, MVT::i64,// ->11955
/* 11949*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ARGUMENT_i64),
                 MVT::i64, 1/*#Ops*/, 0, 
             // Src: (WebAssemblyargument:{ *:[i64] } (timm:{ *:[i32] }):$argno) - Complexity = 6
             // Dst: (ARGUMENT_i64:{ *:[i64] } (timm:{ *:[i32] }):$argno)
/* 11955*/  /*SwitchType*/ 6, MVT::funcref,// ->11963
/* 11957*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ARGUMENT_funcref),
                 MVT::funcref, 1/*#Ops*/, 0, 
             // Src: (WebAssemblyargument:{ *:[funcref] } (timm:{ *:[i32] }):$argno) - Complexity = 6
             // Dst: (ARGUMENT_funcref:{ *:[funcref] } (timm:{ *:[i32] }):$argno)
/* 11963*/  /*SwitchType*/ 6, MVT::externref,// ->11971
/* 11965*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ARGUMENT_externref),
                 MVT::externref, 1/*#Ops*/, 0, 
             // Src: (WebAssemblyargument:{ *:[externref] } (timm:{ *:[i32] }):$argno) - Complexity = 6
             // Dst: (ARGUMENT_externref:{ *:[externref] } (timm:{ *:[i32] }):$argno)
/* 11971*/  /*SwitchType*/ 6, MVT::f32,// ->11979
/* 11973*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ARGUMENT_f32),
                 MVT::f32, 1/*#Ops*/, 0, 
             // Src: (WebAssemblyargument:{ *:[f32] } (timm:{ *:[i32] }):$argno) - Complexity = 6
             // Dst: (ARGUMENT_f32:{ *:[f32] } (timm:{ *:[i32] }):$argno)
/* 11979*/  /*SwitchType*/ 6, MVT::f64,// ->11987
/* 11981*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ARGUMENT_f64),
                 MVT::f64, 1/*#Ops*/, 0, 
             // Src: (WebAssemblyargument:{ *:[f64] } (timm:{ *:[i32] }):$argno) - Complexity = 6
             // Dst: (ARGUMENT_f64:{ *:[f64] } (timm:{ *:[i32] }):$argno)
/* 11987*/  /*SwitchType*/ 6, MVT::v16i8,// ->11995
/* 11989*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ARGUMENT_v16i8),
                 MVT::v16i8, 1/*#Ops*/, 0, 
             // Src: (WebAssemblyargument:{ *:[v16i8] } (timm:{ *:[i32] }):$argno) - Complexity = 6
             // Dst: (ARGUMENT_v16i8:{ *:[v16i8] } (timm:{ *:[i32] }):$argno)
/* 11995*/  /*SwitchType*/ 6, MVT::v8i16,// ->12003
/* 11997*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ARGUMENT_v8i16),
                 MVT::v8i16, 1/*#Ops*/, 0, 
             // Src: (WebAssemblyargument:{ *:[v8i16] } (timm:{ *:[i32] }):$argno) - Complexity = 6
             // Dst: (ARGUMENT_v8i16:{ *:[v8i16] } (timm:{ *:[i32] }):$argno)
/* 12003*/  /*SwitchType*/ 6, MVT::v4i32,// ->12011
/* 12005*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ARGUMENT_v4i32),
                 MVT::v4i32, 1/*#Ops*/, 0, 
             // Src: (WebAssemblyargument:{ *:[v4i32] } (timm:{ *:[i32] }):$argno) - Complexity = 6
             // Dst: (ARGUMENT_v4i32:{ *:[v4i32] } (timm:{ *:[i32] }):$argno)
/* 12011*/  /*SwitchType*/ 6, MVT::v2i64,// ->12019
/* 12013*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ARGUMENT_v2i64),
                 MVT::v2i64, 1/*#Ops*/, 0, 
             // Src: (WebAssemblyargument:{ *:[v2i64] } (timm:{ *:[i32] }):$argno) - Complexity = 6
             // Dst: (ARGUMENT_v2i64:{ *:[v2i64] } (timm:{ *:[i32] }):$argno)
/* 12019*/  /*SwitchType*/ 6, MVT::v4f32,// ->12027
/* 12021*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ARGUMENT_v4f32),
                 MVT::v4f32, 1/*#Ops*/, 0, 
             // Src: (WebAssemblyargument:{ *:[v4f32] } (timm:{ *:[i32] }):$argno) - Complexity = 6
             // Dst: (ARGUMENT_v4f32:{ *:[v4f32] } (timm:{ *:[i32] }):$argno)
/* 12027*/  /*SwitchType*/ 6, MVT::v2f64,// ->12035
/* 12029*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ARGUMENT_v2f64),
                 MVT::v2f64, 1/*#Ops*/, 0, 
             // Src: (WebAssemblyargument:{ *:[v2f64] } (timm:{ *:[i32] }):$argno) - Complexity = 6
             // Dst: (ARGUMENT_v2f64:{ *:[v2f64] } (timm:{ *:[i32] }):$argno)
/* 12035*/  0, // EndSwitchType
/* 12036*/ /*SwitchOpcode*/ 125, TARGET_VAL(WebAssemblyISD::LOCAL_GET),// ->12164
/* 12039*/  OPC_RecordNode, // #0 = 'WebAssemblylocal_get' chained node
/* 12040*/  OPC_RecordChild1, // #1 = $local
/* 12041*/  OPC_MoveChild1,
/* 12042*/  OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 12045*/  OPC_MoveParent,
/* 12046*/  OPC_SwitchType /*12 cases */, 7, MVT::i32,// ->12056
/* 12049*/   OPC_EmitMergeInputChains1_0,
/* 12050*/   OPC_MorphNodeTo1Chain, TARGET_VAL(WebAssembly::LOCAL_GET_I32),
                 MVT::i32, 1/*#Ops*/, 1, 
             // Src: (WebAssemblylocal_get:{ *:[i32] } (timm:{ *:[i32] }):$local) - Complexity = 6
             // Dst: (LOCAL_GET_I32:{ *:[i32] } (timm:{ *:[i32] }):$local)
/* 12056*/  /*SwitchType*/ 7, MVT::i64,// ->12065
/* 12058*/   OPC_EmitMergeInputChains1_0,
/* 12059*/   OPC_MorphNodeTo1Chain, TARGET_VAL(WebAssembly::LOCAL_GET_I64),
                 MVT::i64, 1/*#Ops*/, 1, 
             // Src: (WebAssemblylocal_get:{ *:[i64] } (timm:{ *:[i32] }):$local) - Complexity = 6
             // Dst: (LOCAL_GET_I64:{ *:[i64] } (timm:{ *:[i32] }):$local)
/* 12065*/  /*SwitchType*/ 8, MVT::funcref,// ->12075
/* 12067*/   OPC_CheckPatternPredicate5, // (Subtarget->hasReferenceTypes())
/* 12068*/   OPC_EmitMergeInputChains1_0,
/* 12069*/   OPC_MorphNodeTo1Chain, TARGET_VAL(WebAssembly::LOCAL_GET_FUNCREF),
                 MVT::funcref, 1/*#Ops*/, 1, 
             // Src: (WebAssemblylocal_get:{ *:[funcref] } (timm:{ *:[i32] }):$local) - Complexity = 6
             // Dst: (LOCAL_GET_FUNCREF:{ *:[funcref] } (timm:{ *:[i32] }):$local)
/* 12075*/  /*SwitchType*/ 8, MVT::externref,// ->12085
/* 12077*/   OPC_CheckPatternPredicate5, // (Subtarget->hasReferenceTypes())
/* 12078*/   OPC_EmitMergeInputChains1_0,
/* 12079*/   OPC_MorphNodeTo1Chain, TARGET_VAL(WebAssembly::LOCAL_GET_EXTERNREF),
                 MVT::externref, 1/*#Ops*/, 1, 
             // Src: (WebAssemblylocal_get:{ *:[externref] } (timm:{ *:[i32] }):$local) - Complexity = 6
             // Dst: (LOCAL_GET_EXTERNREF:{ *:[externref] } (timm:{ *:[i32] }):$local)
/* 12085*/  /*SwitchType*/ 7, MVT::f32,// ->12094
/* 12087*/   OPC_EmitMergeInputChains1_0,
/* 12088*/   OPC_MorphNodeTo1Chain, TARGET_VAL(WebAssembly::LOCAL_GET_F32),
                 MVT::f32, 1/*#Ops*/, 1, 
             // Src: (WebAssemblylocal_get:{ *:[f32] } (timm:{ *:[i32] }):$local) - Complexity = 6
             // Dst: (LOCAL_GET_F32:{ *:[f32] } (timm:{ *:[i32] }):$local)
/* 12094*/  /*SwitchType*/ 7, MVT::f64,// ->12103
/* 12096*/   OPC_EmitMergeInputChains1_0,
/* 12097*/   OPC_MorphNodeTo1Chain, TARGET_VAL(WebAssembly::LOCAL_GET_F64),
                 MVT::f64, 1/*#Ops*/, 1, 
             // Src: (WebAssemblylocal_get:{ *:[f64] } (timm:{ *:[i32] }):$local) - Complexity = 6
             // Dst: (LOCAL_GET_F64:{ *:[f64] } (timm:{ *:[i32] }):$local)
/* 12103*/  /*SwitchType*/ 8, MVT::v2i64,// ->12113
/* 12105*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 12106*/   OPC_EmitMergeInputChains1_0,
/* 12107*/   OPC_MorphNodeTo1Chain, TARGET_VAL(WebAssembly::LOCAL_GET_V128),
                 MVT::v2i64, 1/*#Ops*/, 1, 
             // Src: (WebAssemblylocal_get:{ *:[v2i64] } (timm:{ *:[i32] }):$local) - Complexity = 6
             // Dst: (LOCAL_GET_V128:{ *:[v2i64] } (timm:{ *:[i32] }):$local)
/* 12113*/  /*SwitchType*/ 8, MVT::v4i32,// ->12123
/* 12115*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 12116*/   OPC_EmitMergeInputChains1_0,
/* 12117*/   OPC_MorphNodeTo1Chain, TARGET_VAL(WebAssembly::LOCAL_GET_V128),
                 MVT::v4i32, 1/*#Ops*/, 1, 
             // Src: (WebAssemblylocal_get:{ *:[v4i32] } (timm:{ *:[i32] }):$local) - Complexity = 6
             // Dst: (LOCAL_GET_V128:{ *:[v4i32] } (timm:{ *:[i32] }):$local)
/* 12123*/  /*SwitchType*/ 8, MVT::v16i8,// ->12133
/* 12125*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 12126*/   OPC_EmitMergeInputChains1_0,
/* 12127*/   OPC_MorphNodeTo1Chain, TARGET_VAL(WebAssembly::LOCAL_GET_V128),
                 MVT::v16i8, 1/*#Ops*/, 1, 
             // Src: (WebAssemblylocal_get:{ *:[v16i8] } (timm:{ *:[i32] }):$local) - Complexity = 6
             // Dst: (LOCAL_GET_V128:{ *:[v16i8] } (timm:{ *:[i32] }):$local)
/* 12133*/  /*SwitchType*/ 8, MVT::v8i16,// ->12143
/* 12135*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 12136*/   OPC_EmitMergeInputChains1_0,
/* 12137*/   OPC_MorphNodeTo1Chain, TARGET_VAL(WebAssembly::LOCAL_GET_V128),
                 MVT::v8i16, 1/*#Ops*/, 1, 
             // Src: (WebAssemblylocal_get:{ *:[v8i16] } (timm:{ *:[i32] }):$local) - Complexity = 6
             // Dst: (LOCAL_GET_V128:{ *:[v8i16] } (timm:{ *:[i32] }):$local)
/* 12143*/  /*SwitchType*/ 8, MVT::v4f32,// ->12153
/* 12145*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 12146*/   OPC_EmitMergeInputChains1_0,
/* 12147*/   OPC_MorphNodeTo1Chain, TARGET_VAL(WebAssembly::LOCAL_GET_V128),
                 MVT::v4f32, 1/*#Ops*/, 1, 
             // Src: (WebAssemblylocal_get:{ *:[v4f32] } (timm:{ *:[i32] }):$local) - Complexity = 6
             // Dst: (LOCAL_GET_V128:{ *:[v4f32] } (timm:{ *:[i32] }):$local)
/* 12153*/  /*SwitchType*/ 8, MVT::v2f64,// ->12163
/* 12155*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 12156*/   OPC_EmitMergeInputChains1_0,
/* 12157*/   OPC_MorphNodeTo1Chain, TARGET_VAL(WebAssembly::LOCAL_GET_V128),
                 MVT::v2f64, 1/*#Ops*/, 1, 
             // Src: (WebAssemblylocal_get:{ *:[v2f64] } (timm:{ *:[i32] }):$local) - Complexity = 6
             // Dst: (LOCAL_GET_V128:{ *:[v2f64] } (timm:{ *:[i32] }):$local)
/* 12163*/  0, // EndSwitchType
/* 12164*/ /*SwitchOpcode*/ 8|128,1/*136*/, TARGET_VAL(WebAssemblyISD::LOCAL_SET),// ->12304
/* 12168*/  OPC_RecordNode, // #0 = 'WebAssemblylocal_set' chained node
/* 12169*/  OPC_RecordChild1, // #1 = $local
/* 12170*/  OPC_MoveChild1,
/* 12171*/  OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 12174*/  OPC_MoveParent,
/* 12175*/  OPC_RecordChild2, // #2 = $src
/* 12176*/  OPC_Scope, 8, /*->12186*/ // 12 children in Scope
/* 12178*/   OPC_CheckChild2TypeI32,
/* 12179*/   OPC_EmitMergeInputChains1_0,
/* 12180*/   OPC_MorphNodeTo0Chain, TARGET_VAL(WebAssembly::LOCAL_SET_I32),
                 2/*#Ops*/, 1, 2, 
             // Src: (WebAssemblylocal_set (timm:{ *:[i32] }):$local, i32:{ *:[i32] }:$src) - Complexity = 6
             // Dst: (LOCAL_SET_I32 (timm:{ *:[i32] }):$local, i32:{ *:[i32] }:$src)
/* 12186*/  /*Scope*/ 8, /*->12195*/
/* 12187*/   OPC_CheckChild2TypeI64,
/* 12188*/   OPC_EmitMergeInputChains1_0,
/* 12189*/   OPC_MorphNodeTo0Chain, TARGET_VAL(WebAssembly::LOCAL_SET_I64),
                 2/*#Ops*/, 1, 2, 
             // Src: (WebAssemblylocal_set (timm:{ *:[i32] }):$local, i64:{ *:[i64] }:$src) - Complexity = 6
             // Dst: (LOCAL_SET_I64 (timm:{ *:[i32] }):$local, i64:{ *:[i64] }:$src)
/* 12195*/  /*Scope*/ 9, /*->12205*/
/* 12196*/   OPC_CheckChild2Type, MVT::f32,
/* 12198*/   OPC_EmitMergeInputChains1_0,
/* 12199*/   OPC_MorphNodeTo0Chain, TARGET_VAL(WebAssembly::LOCAL_SET_F32),
                 2/*#Ops*/, 1, 2, 
             // Src: (WebAssemblylocal_set (timm:{ *:[i32] }):$local, f32:{ *:[f32] }:$src) - Complexity = 6
             // Dst: (LOCAL_SET_F32 (timm:{ *:[i32] }):$local, f32:{ *:[f32] }:$src)
/* 12205*/  /*Scope*/ 9, /*->12215*/
/* 12206*/   OPC_CheckChild2Type, MVT::f64,
/* 12208*/   OPC_EmitMergeInputChains1_0,
/* 12209*/   OPC_MorphNodeTo0Chain, TARGET_VAL(WebAssembly::LOCAL_SET_F64),
                 2/*#Ops*/, 1, 2, 
             // Src: (WebAssemblylocal_set (timm:{ *:[i32] }):$local, f64:{ *:[f64] }:$src) - Complexity = 6
             // Dst: (LOCAL_SET_F64 (timm:{ *:[i32] }):$local, f64:{ *:[f64] }:$src)
/* 12215*/  /*Scope*/ 10, /*->12226*/
/* 12216*/   OPC_CheckChild2Type, MVT::v4f32,
/* 12218*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 12219*/   OPC_EmitMergeInputChains1_0,
/* 12220*/   OPC_MorphNodeTo0Chain, TARGET_VAL(WebAssembly::LOCAL_SET_V128),
                 2/*#Ops*/, 1, 2, 
             // Src: (WebAssemblylocal_set (timm:{ *:[i32] }):$local, v4f32:{ *:[v4f32] }:$src) - Complexity = 6
             // Dst: (LOCAL_SET_V128 (timm:{ *:[i32] }):$local, v4f32:{ *:[v4f32] }:$src)
/* 12226*/  /*Scope*/ 10, /*->12237*/
/* 12227*/   OPC_CheckChild2Type, MVT::v2f64,
/* 12229*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 12230*/   OPC_EmitMergeInputChains1_0,
/* 12231*/   OPC_MorphNodeTo0Chain, TARGET_VAL(WebAssembly::LOCAL_SET_V128),
                 2/*#Ops*/, 1, 2, 
             // Src: (WebAssemblylocal_set (timm:{ *:[i32] }):$local, v2f64:{ *:[v2f64] }:$src) - Complexity = 6
             // Dst: (LOCAL_SET_V128 (timm:{ *:[i32] }):$local, v2f64:{ *:[v2f64] }:$src)
/* 12237*/  /*Scope*/ 10, /*->12248*/
/* 12238*/   OPC_CheckChild2Type, MVT::v2i64,
/* 12240*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 12241*/   OPC_EmitMergeInputChains1_0,
/* 12242*/   OPC_MorphNodeTo0Chain, TARGET_VAL(WebAssembly::LOCAL_SET_V128),
                 2/*#Ops*/, 1, 2, 
             // Src: (WebAssemblylocal_set (timm:{ *:[i32] }):$local, v2i64:{ *:[v2i64] }:$src) - Complexity = 6
             // Dst: (LOCAL_SET_V128 (timm:{ *:[i32] }):$local, v2i64:{ *:[v2i64] }:$src)
/* 12248*/  /*Scope*/ 10, /*->12259*/
/* 12249*/   OPC_CheckChild2Type, MVT::v4i32,
/* 12251*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 12252*/   OPC_EmitMergeInputChains1_0,
/* 12253*/   OPC_MorphNodeTo0Chain, TARGET_VAL(WebAssembly::LOCAL_SET_V128),
                 2/*#Ops*/, 1, 2, 
             // Src: (WebAssemblylocal_set (timm:{ *:[i32] }):$local, v4i32:{ *:[v4i32] }:$src) - Complexity = 6
             // Dst: (LOCAL_SET_V128 (timm:{ *:[i32] }):$local, v4i32:{ *:[v4i32] }:$src)
/* 12259*/  /*Scope*/ 10, /*->12270*/
/* 12260*/   OPC_CheckChild2Type, MVT::v16i8,
/* 12262*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 12263*/   OPC_EmitMergeInputChains1_0,
/* 12264*/   OPC_MorphNodeTo0Chain, TARGET_VAL(WebAssembly::LOCAL_SET_V128),
                 2/*#Ops*/, 1, 2, 
             // Src: (WebAssemblylocal_set (timm:{ *:[i32] }):$local, v16i8:{ *:[v16i8] }:$src) - Complexity = 6
             // Dst: (LOCAL_SET_V128 (timm:{ *:[i32] }):$local, v16i8:{ *:[v16i8] }:$src)
/* 12270*/  /*Scope*/ 10, /*->12281*/
/* 12271*/   OPC_CheckChild2Type, MVT::v8i16,
/* 12273*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 12274*/   OPC_EmitMergeInputChains1_0,
/* 12275*/   OPC_MorphNodeTo0Chain, TARGET_VAL(WebAssembly::LOCAL_SET_V128),
                 2/*#Ops*/, 1, 2, 
             // Src: (WebAssemblylocal_set (timm:{ *:[i32] }):$local, v8i16:{ *:[v8i16] }:$src) - Complexity = 6
             // Dst: (LOCAL_SET_V128 (timm:{ *:[i32] }):$local, v8i16:{ *:[v8i16] }:$src)
/* 12281*/  /*Scope*/ 10, /*->12292*/
/* 12282*/   OPC_CheckChild2Type, MVT::funcref,
/* 12284*/   OPC_CheckPatternPredicate5, // (Subtarget->hasReferenceTypes())
/* 12285*/   OPC_EmitMergeInputChains1_0,
/* 12286*/   OPC_MorphNodeTo0Chain, TARGET_VAL(WebAssembly::LOCAL_SET_FUNCREF),
                 2/*#Ops*/, 1, 2, 
             // Src: (WebAssemblylocal_set (timm:{ *:[i32] }):$local, funcref:{ *:[funcref] }:$src) - Complexity = 6
             // Dst: (LOCAL_SET_FUNCREF (timm:{ *:[i32] }):$local, funcref:{ *:[funcref] }:$src)
/* 12292*/  /*Scope*/ 10, /*->12303*/
/* 12293*/   OPC_CheckChild2Type, MVT::externref,
/* 12295*/   OPC_CheckPatternPredicate5, // (Subtarget->hasReferenceTypes())
/* 12296*/   OPC_EmitMergeInputChains1_0,
/* 12297*/   OPC_MorphNodeTo0Chain, TARGET_VAL(WebAssembly::LOCAL_SET_EXTERNREF),
                 2/*#Ops*/, 1, 2, 
             // Src: (WebAssemblylocal_set (timm:{ *:[i32] }):$local, externref:{ *:[externref] }:$src) - Complexity = 6
             // Dst: (LOCAL_SET_EXTERNREF (timm:{ *:[i32] }):$local, externref:{ *:[externref] }:$src)
/* 12303*/  0, /*End of Scope*/
/* 12304*/ /*SwitchOpcode*/ 0|128,1/*128*/, TARGET_VAL(WebAssemblyISD::Wrapper),// ->12436
/* 12308*/  OPC_RecordChild0, // #0 = $addr
/* 12309*/  OPC_MoveChild0,
/* 12310*/  OPC_SwitchOpcode /*3 cases */, 47, TARGET_VAL(ISD::TargetGlobalAddress),// ->12361
/* 12314*/   OPC_MoveParent,
/* 12315*/   OPC_SwitchType /*2 cases */, 20, MVT::i32,// ->12338
/* 12318*/    OPC_Scope, 8, /*->12328*/ // 2 children in Scope
/* 12320*/     OPC_CheckPatternPredicate, 14, // (!Subtarget->hasAddr64()) && (!TM.isPositionIndependent())
/* 12322*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::CONST_I32),
                   MVT::i32, 1/*#Ops*/, 0, 
               // Src: (WebAssemblyWrapper:{ *:[i32] } (tglobaladdr:{ *:[i32] }):$addr) - Complexity = 6
               // Dst: (CONST_I32:{ *:[i32] } (tglobaladdr:{ *:[i32] }):$addr)
/* 12328*/    /*Scope*/ 8, /*->12337*/
/* 12329*/     OPC_CheckPatternPredicate, 11, // (!Subtarget->hasAddr64()) && (TM.isPositionIndependent())
/* 12331*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::GLOBAL_GET_I32),
                   MVT::i32, 1/*#Ops*/, 0, 
               // Src: (WebAssemblyWrapper:{ *:[i32] } (tglobaladdr:{ *:[i32] }):$addr) - Complexity = 6
               // Dst: (GLOBAL_GET_I32:{ *:[i32] } (tglobaladdr:{ *:[i32] }):$addr)
/* 12337*/    0, /*End of Scope*/
/* 12338*/   /*SwitchType*/ 20, MVT::i64,// ->12360
/* 12340*/    OPC_Scope, 8, /*->12350*/ // 2 children in Scope
/* 12342*/     OPC_CheckPatternPredicate, 15, // (Subtarget->hasAddr64()) && (!TM.isPositionIndependent())
/* 12344*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::CONST_I64),
                   MVT::i64, 1/*#Ops*/, 0, 
               // Src: (WebAssemblyWrapper:{ *:[i64] } (tglobaladdr:{ *:[i64] }):$addr) - Complexity = 6
               // Dst: (CONST_I64:{ *:[i64] } (tglobaladdr:{ *:[i64] }):$addr)
/* 12350*/    /*Scope*/ 8, /*->12359*/
/* 12351*/     OPC_CheckPatternPredicate, 12, // (Subtarget->hasAddr64()) && (TM.isPositionIndependent())
/* 12353*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::GLOBAL_GET_I64),
                   MVT::i64, 1/*#Ops*/, 0, 
               // Src: (WebAssemblyWrapper:{ *:[i64] } (tglobaladdr:{ *:[i64] }):$addr) - Complexity = 6
               // Dst: (GLOBAL_GET_I64:{ *:[i64] } (tglobaladdr:{ *:[i64] }):$addr)
/* 12359*/    0, /*End of Scope*/
/* 12360*/   0, // EndSwitchType
/* 12361*/  /*SwitchOpcode*/ 21, TARGET_VAL(ISD::TargetGlobalTLSAddress),// ->12385
/* 12364*/   OPC_MoveParent,
/* 12365*/   OPC_SwitchType /*2 cases */, 7, MVT::i32,// ->12375
/* 12368*/    OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64())
/* 12369*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::GLOBAL_GET_I32),
                  MVT::i32, 1/*#Ops*/, 0, 
              // Src: (WebAssemblyWrapper:{ *:[i32] } (tglobaltlsaddr:{ *:[i32] }):$addr) - Complexity = 6
              // Dst: (GLOBAL_GET_I32:{ *:[i32] } (tglobaltlsaddr:{ *:[i32] }):$addr)
/* 12375*/   /*SwitchType*/ 7, MVT::i64,// ->12384
/* 12377*/    OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64())
/* 12378*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::GLOBAL_GET_I64),
                  MVT::i64, 1/*#Ops*/, 0, 
              // Src: (WebAssemblyWrapper:{ *:[i64] } (tglobaltlsaddr:{ *:[i64] }):$addr) - Complexity = 6
              // Dst: (GLOBAL_GET_I64:{ *:[i64] } (tglobaltlsaddr:{ *:[i64] }):$addr)
/* 12384*/   0, // EndSwitchType
/* 12385*/  /*SwitchOpcode*/ 47, TARGET_VAL(ISD::TargetExternalSymbol),// ->12435
/* 12388*/   OPC_MoveParent,
/* 12389*/   OPC_SwitchType /*2 cases */, 20, MVT::i32,// ->12412
/* 12392*/    OPC_Scope, 8, /*->12402*/ // 2 children in Scope
/* 12394*/     OPC_CheckPatternPredicate, 11, // (!Subtarget->hasAddr64()) && (TM.isPositionIndependent())
/* 12396*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::GLOBAL_GET_I32),
                   MVT::i32, 1/*#Ops*/, 0, 
               // Src: (WebAssemblyWrapper:{ *:[i32] } (texternalsym:{ *:[i32] }):$addr) - Complexity = 6
               // Dst: (GLOBAL_GET_I32:{ *:[i32] } (texternalsym:{ *:[i32] }):$addr)
/* 12402*/    /*Scope*/ 8, /*->12411*/
/* 12403*/     OPC_CheckPatternPredicate, 14, // (!Subtarget->hasAddr64()) && (!TM.isPositionIndependent())
/* 12405*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::CONST_I32),
                   MVT::i32, 1/*#Ops*/, 0, 
               // Src: (WebAssemblyWrapper:{ *:[i32] } (texternalsym:{ *:[i32] }):$addr) - Complexity = 6
               // Dst: (CONST_I32:{ *:[i32] } (texternalsym:{ *:[i32] }):$addr)
/* 12411*/    0, /*End of Scope*/
/* 12412*/   /*SwitchType*/ 20, MVT::i64,// ->12434
/* 12414*/    OPC_Scope, 8, /*->12424*/ // 2 children in Scope
/* 12416*/     OPC_CheckPatternPredicate, 12, // (Subtarget->hasAddr64()) && (TM.isPositionIndependent())
/* 12418*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::GLOBAL_GET_I64),
                   MVT::i64, 1/*#Ops*/, 0, 
               // Src: (WebAssemblyWrapper:{ *:[i64] } (texternalsym:{ *:[i64] }):$addr) - Complexity = 6
               // Dst: (GLOBAL_GET_I64:{ *:[i64] } (texternalsym:{ *:[i64] }):$addr)
/* 12424*/    /*Scope*/ 8, /*->12433*/
/* 12425*/     OPC_CheckPatternPredicate, 15, // (Subtarget->hasAddr64()) && (!TM.isPositionIndependent())
/* 12427*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::CONST_I64),
                   MVT::i64, 1/*#Ops*/, 0, 
               // Src: (WebAssemblyWrapper:{ *:[i64] } (texternalsym:{ *:[i64] }):$addr) - Complexity = 6
               // Dst: (CONST_I64:{ *:[i64] } (texternalsym:{ *:[i64] }):$addr)
/* 12433*/    0, /*End of Scope*/
/* 12434*/   0, // EndSwitchType
/* 12435*/  0, // EndSwitchOpcode
/* 12436*/ /*SwitchOpcode*/ 80, TARGET_VAL(WebAssemblyISD::WrapperREL),// ->12519
/* 12439*/  OPC_RecordChild0, // #0 = $addr
/* 12440*/  OPC_MoveChild0,
/* 12441*/  OPC_SwitchOpcode /*3 cases */, 23, TARGET_VAL(ISD::TargetGlobalAddress),// ->12468
/* 12445*/   OPC_MoveParent,
/* 12446*/   OPC_SwitchType /*2 cases */, 8, MVT::i32,// ->12457
/* 12449*/    OPC_CheckPatternPredicate, 11, // (!Subtarget->hasAddr64()) && (TM.isPositionIndependent())
/* 12451*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::CONST_I32),
                  MVT::i32, 1/*#Ops*/, 0, 
              // Src: (WebAssemblyWrapperREL:{ *:[i32] } (tglobaladdr:{ *:[i32] }):$addr) - Complexity = 6
              // Dst: (CONST_I32:{ *:[i32] } (tglobaladdr:{ *:[i32] }):$addr)
/* 12457*/   /*SwitchType*/ 8, MVT::i64,// ->12467
/* 12459*/    OPC_CheckPatternPredicate, 12, // (Subtarget->hasAddr64()) && (TM.isPositionIndependent())
/* 12461*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::CONST_I64),
                  MVT::i64, 1/*#Ops*/, 0, 
              // Src: (WebAssemblyWrapperREL:{ *:[i64] } (tglobaladdr:{ *:[i64] }):$addr) - Complexity = 6
              // Dst: (CONST_I64:{ *:[i64] } (tglobaladdr:{ *:[i64] }):$addr)
/* 12467*/   0, // EndSwitchType
/* 12468*/  /*SwitchOpcode*/ 21, TARGET_VAL(ISD::TargetGlobalTLSAddress),// ->12492
/* 12471*/   OPC_MoveParent,
/* 12472*/   OPC_SwitchType /*2 cases */, 7, MVT::i32,// ->12482
/* 12475*/    OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64())
/* 12476*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::CONST_I32),
                  MVT::i32, 1/*#Ops*/, 0, 
              // Src: (WebAssemblyWrapperREL:{ *:[i32] } (tglobaltlsaddr:{ *:[i32] }):$addr) - Complexity = 6
              // Dst: (CONST_I32:{ *:[i32] } (tglobaltlsaddr:{ *:[i32] }):$addr)
/* 12482*/   /*SwitchType*/ 7, MVT::i64,// ->12491
/* 12484*/    OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64())
/* 12485*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::CONST_I64),
                  MVT::i64, 1/*#Ops*/, 0, 
              // Src: (WebAssemblyWrapperREL:{ *:[i64] } (tglobaltlsaddr:{ *:[i64] }):$addr) - Complexity = 6
              // Dst: (CONST_I64:{ *:[i64] } (tglobaltlsaddr:{ *:[i64] }):$addr)
/* 12491*/   0, // EndSwitchType
/* 12492*/  /*SwitchOpcode*/ 23, TARGET_VAL(ISD::TargetExternalSymbol),// ->12518
/* 12495*/   OPC_MoveParent,
/* 12496*/   OPC_SwitchType /*2 cases */, 8, MVT::i32,// ->12507
/* 12499*/    OPC_CheckPatternPredicate, 11, // (!Subtarget->hasAddr64()) && (TM.isPositionIndependent())
/* 12501*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::CONST_I32),
                  MVT::i32, 1/*#Ops*/, 0, 
              // Src: (WebAssemblyWrapperREL:{ *:[i32] } (texternalsym:{ *:[i32] }):$addr) - Complexity = 6
              // Dst: (CONST_I32:{ *:[i32] } (texternalsym:{ *:[i32] }):$addr)
/* 12507*/   /*SwitchType*/ 8, MVT::i64,// ->12517
/* 12509*/    OPC_CheckPatternPredicate, 12, // (Subtarget->hasAddr64()) && (TM.isPositionIndependent())
/* 12511*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::CONST_I64),
                  MVT::i64, 1/*#Ops*/, 0, 
              // Src: (WebAssemblyWrapperREL:{ *:[i64] } (texternalsym:{ *:[i64] }):$addr) - Complexity = 6
              // Dst: (CONST_I64:{ *:[i64] } (texternalsym:{ *:[i64] }):$addr)
/* 12517*/   0, // EndSwitchType
/* 12518*/  0, // EndSwitchOpcode
/* 12519*/ /*SwitchOpcode*/ 47, TARGET_VAL(WebAssemblyISD::MEMORY_FILL),// ->12569
/* 12522*/  OPC_RecordNode, // #0 = 'wasm_memset' chained node
/* 12523*/  OPC_RecordChild1, // #1 = $idx
/* 12524*/  OPC_MoveChild1,
/* 12525*/  OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 12528*/  OPC_CheckTypeI32,
/* 12529*/  OPC_MoveParent,
/* 12530*/  OPC_RecordChild2, // #2 = $dst
/* 12531*/  OPC_Scope, 17, /*->12550*/ // 2 children in Scope
/* 12533*/   OPC_CheckChild2TypeI32,
/* 12534*/   OPC_RecordChild3, // #3 = $value
/* 12535*/   OPC_CheckChild3TypeI32,
/* 12536*/   OPC_RecordChild4, // #4 = $size
/* 12537*/   OPC_CheckChild4TypeI32,
/* 12538*/   OPC_CheckPatternPredicate, 10, // (Subtarget->hasBulkMemory())
/* 12540*/   OPC_EmitMergeInputChains1_0,
/* 12541*/   OPC_EmitConvertToTarget1,
/* 12542*/   OPC_MorphNodeTo0Chain, TARGET_VAL(WebAssembly::anonymous_8034MEMORY_FILL_A32),
                 4/*#Ops*/, 5, 2, 3, 4, 
             // Src: (wasm_memset (imm:{ *:[i32] }):$idx, I32:{ *:[i32] }:$dst, I32:{ *:[i32] }:$value, I32:{ *:[i32] }:$size) - Complexity = 6
             // Dst: (anonymous_8034MEMORY_FILL_A32 (imm:{ *:[i32] }):$idx, I32:{ *:[i32] }:$dst, I32:{ *:[i32] }:$value, I32:{ *:[i32] }:$size)
/* 12550*/  /*Scope*/ 17, /*->12568*/
/* 12551*/   OPC_CheckChild2TypeI64,
/* 12552*/   OPC_RecordChild3, // #3 = $value
/* 12553*/   OPC_CheckChild3TypeI32,
/* 12554*/   OPC_RecordChild4, // #4 = $size
/* 12555*/   OPC_CheckChild4TypeI64,
/* 12556*/   OPC_CheckPatternPredicate, 10, // (Subtarget->hasBulkMemory())
/* 12558*/   OPC_EmitMergeInputChains1_0,
/* 12559*/   OPC_EmitConvertToTarget1,
/* 12560*/   OPC_MorphNodeTo0Chain, TARGET_VAL(WebAssembly::anonymous_8035MEMORY_FILL_A64),
                 4/*#Ops*/, 5, 2, 3, 4, 
             // Src: (wasm_memset (imm:{ *:[i32] }):$idx, I64:{ *:[i64] }:$dst, I32:{ *:[i32] }:$value, I64:{ *:[i64] }:$size) - Complexity = 6
             // Dst: (anonymous_8035MEMORY_FILL_A64 (imm:{ *:[i32] }):$idx, I64:{ *:[i64] }:$dst, I32:{ *:[i32] }:$value, I64:{ *:[i64] }:$size)
/* 12568*/  0, /*End of Scope*/
/* 12569*/ /*SwitchOpcode*/ 21, TARGET_VAL(ISD::Constant),// ->12593
/* 12572*/  OPC_RecordNode, // #0 = $imm
/* 12573*/  OPC_SwitchType /*2 cases */, 7, MVT::i32,// ->12583
/* 12576*/   OPC_EmitConvertToTarget0,
/* 12577*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::CONST_I32),
                 MVT::i32, 1/*#Ops*/, 1, 
             // Src: (imm:{ *:[i32] }):$imm - Complexity = 3
             // Dst: (CONST_I32:{ *:[i32] } (imm:{ *:[i32] }):$imm)
/* 12583*/  /*SwitchType*/ 7, MVT::i64,// ->12592
/* 12585*/   OPC_EmitConvertToTarget0,
/* 12586*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::CONST_I64),
                 MVT::i64, 1/*#Ops*/, 1, 
             // Src: (imm:{ *:[i64] }):$imm - Complexity = 3
             // Dst: (CONST_I64:{ *:[i64] } (imm:{ *:[i64] }):$imm)
/* 12592*/  0, // EndSwitchType
/* 12593*/ /*SwitchOpcode*/ 13, TARGET_VAL(ISD::BR),// ->12609
/* 12596*/  OPC_RecordNode, // #0 = 'br' chained node
/* 12597*/  OPC_RecordChild1, // #1 = $dst
/* 12598*/  OPC_MoveChild1,
/* 12599*/  OPC_CheckOpcode, TARGET_VAL(ISD::BasicBlock),
/* 12602*/  OPC_MoveParent,
/* 12603*/  OPC_EmitMergeInputChains1_0,
/* 12604*/  OPC_MorphNodeTo0Chain, TARGET_VAL(WebAssembly::BR),
                1/*#Ops*/, 1, 
            // Src: (br (bb:{ *:[Other] }):$dst) - Complexity = 3
            // Dst: (BR (bb:{ *:[Other] }):$dst)
/* 12609*/ /*SwitchOpcode*/ 22, TARGET_VAL(WebAssemblyISD::BR_TABLE),// ->12634
/* 12612*/  OPC_RecordNode, // #0 = 'WebAssemblybr_table' chained node
/* 12613*/  OPC_RecordChild1, // #1 = $index
/* 12614*/  OPC_Scope, 8, /*->12624*/ // 2 children in Scope
/* 12616*/   OPC_CheckChild1TypeI32,
/* 12617*/   OPC_EmitMergeInputChains1_0,
/* 12618*/   OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::BR_TABLE_I32), 0|OPFL_Chain|OPFL_Variadic1,
                 1/*#Ops*/, 1, 
             // Src: (WebAssemblybr_table I32:{ *:[i32] }:$index) - Complexity = 3
             // Dst: (BR_TABLE_I32 I32:{ *:[i32] }:$index)
/* 12624*/  /*Scope*/ 8, /*->12633*/
/* 12625*/   OPC_CheckChild1TypeI64,
/* 12626*/   OPC_EmitMergeInputChains1_0,
/* 12627*/   OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::BR_TABLE_I64), 0|OPFL_Chain|OPFL_Variadic1,
                 1/*#Ops*/, 1, 
             // Src: (WebAssemblybr_table I64:{ *:[i64] }:$index) - Complexity = 3
             // Dst: (BR_TABLE_I64 I64:{ *:[i64] }:$index)
/* 12633*/  0, /*End of Scope*/
/* 12634*/ /*SwitchOpcode*/ 7, TARGET_VAL(WebAssemblyISD::RETURN),// ->12644
/* 12637*/  OPC_RecordNode, // #0 = 'WebAssemblyreturn' chained node
/* 12638*/  OPC_EmitMergeInputChains1_0,
/* 12639*/  OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::RETURN), 0|OPFL_Chain|OPFL_Variadic0,
                0/*#Ops*/, 
            // Src: (WebAssemblyreturn) - Complexity = 3
            // Dst: (RETURN)
/* 12644*/ /*SwitchOpcode*/ 6, TARGET_VAL(ISD::TRAP),// ->12653
/* 12647*/  OPC_RecordNode, // #0 = 'trap' chained node
/* 12648*/  OPC_EmitMergeInputChains1_0,
/* 12649*/  OPC_MorphNodeTo0Chain, TARGET_VAL(WebAssembly::UNREACHABLE),
                0/*#Ops*/, 
            // Src: (trap) - Complexity = 3
            // Dst: (UNREACHABLE)
/* 12653*/ /*SwitchOpcode*/ 6, TARGET_VAL(ISD::DEBUGTRAP),// ->12662
/* 12656*/  OPC_RecordNode, // #0 = 'debugtrap' chained node
/* 12657*/  OPC_EmitMergeInputChains1_0,
/* 12658*/  OPC_MorphNodeTo0Chain, TARGET_VAL(WebAssembly::DEBUG_UNREACHABLE),
                0/*#Ops*/, 
            // Src: (debugtrap) - Complexity = 3
            // Dst: (DEBUG_UNREACHABLE)
/* 12662*/ /*SwitchOpcode*/ 8, TARGET_VAL(ISD::CLEANUPRET),// ->12673
/* 12665*/  OPC_RecordNode, // #0 = 'cleanupret' chained node
/* 12666*/  OPC_CheckPatternPredicate, 13, // (Subtarget->hasExceptionHandling())
/* 12668*/  OPC_EmitMergeInputChains1_0,
/* 12669*/  OPC_MorphNodeTo0Chain, TARGET_VAL(WebAssembly::CLEANUPRET),
                0/*#Ops*/, 
            // Src: (cleanupret) - Complexity = 3
            // Dst: (CLEANUPRET)
/* 12673*/ /*SwitchOpcode*/ 21, TARGET_VAL(ISD::CATCHRET),// ->12697
/* 12676*/  OPC_RecordNode, // #0 = 'catchret' chained node
/* 12677*/  OPC_RecordChild1, // #1 = $dst
/* 12678*/  OPC_MoveChild1,
/* 12679*/  OPC_CheckOpcode, TARGET_VAL(ISD::BasicBlock),
/* 12682*/  OPC_MoveSibling2,
/* 12683*/  OPC_CheckOpcode, TARGET_VAL(ISD::BasicBlock),
/* 12686*/  OPC_RecordNode, // #2 = $from
/* 12687*/  OPC_MoveParent,
/* 12688*/  OPC_CheckPatternPredicate, 13, // (Subtarget->hasExceptionHandling())
/* 12690*/  OPC_EmitMergeInputChains1_0,
/* 12691*/  OPC_MorphNodeTo0Chain, TARGET_VAL(WebAssembly::CATCHRET),
                2/*#Ops*/, 1, 2, 
            // Src: (catchret (bb:{ *:[Other] }):$dst, (bb:{ *:[Other] }):$from) - Complexity = 3
            // Dst: (CATCHRET (bb:{ *:[Other] }):$dst, (bb:{ *:[Other] }):$from)
/* 12697*/ /*SwitchOpcode*/ 62, TARGET_VAL(ISD::ADD),// ->12762
/* 12700*/  OPC_RecordChild0, // #0 = $lhs
/* 12701*/  OPC_RecordChild1, // #1 = $rhs
/* 12702*/  OPC_SwitchType /*6 cases */, 7, MVT::i32,// ->12712
/* 12705*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ADD_I32),
                 MVT::i32, 2/*#Ops*/, 0, 1, 
             // Src: (add:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs) - Complexity = 3
             // Dst: (ADD_I32:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs)
/* 12712*/  /*SwitchType*/ 7, MVT::i64,// ->12721
/* 12714*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ADD_I64),
                 MVT::i64, 2/*#Ops*/, 0, 1, 
             // Src: (add:{ *:[i64] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs) - Complexity = 3
             // Dst: (ADD_I64:{ *:[i64] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs)
/* 12721*/  /*SwitchType*/ 8, MVT::v16i8,// ->12731
/* 12723*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 12724*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ADD_I8x16),
                 MVT::v16i8, 2/*#Ops*/, 0, 1, 
             // Src: (add:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs) - Complexity = 3
             // Dst: (ADD_I8x16:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs)
/* 12731*/  /*SwitchType*/ 8, MVT::v8i16,// ->12741
/* 12733*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 12734*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ADD_I16x8),
                 MVT::v8i16, 2/*#Ops*/, 0, 1, 
             // Src: (add:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs) - Complexity = 3
             // Dst: (ADD_I16x8:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs)
/* 12741*/  /*SwitchType*/ 8, MVT::v4i32,// ->12751
/* 12743*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 12744*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ADD_I32x4),
                 MVT::v4i32, 2/*#Ops*/, 0, 1, 
             // Src: (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$lhs, V128:{ *:[v4i32] }:$rhs) - Complexity = 3
             // Dst: (ADD_I32x4:{ *:[v4i32] } V128:{ *:[v4i32] }:$lhs, V128:{ *:[v4i32] }:$rhs)
/* 12751*/  /*SwitchType*/ 8, MVT::v2i64,// ->12761
/* 12753*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 12754*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ADD_I64x2),
                 MVT::v2i64, 2/*#Ops*/, 0, 1, 
             // Src: (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$lhs, V128:{ *:[v2i64] }:$rhs) - Complexity = 3
             // Dst: (ADD_I64x2:{ *:[v2i64] } V128:{ *:[v2i64] }:$lhs, V128:{ *:[v2i64] }:$rhs)
/* 12761*/  0, // EndSwitchType
/* 12762*/ /*SwitchOpcode*/ 113, TARGET_VAL(ISD::SUB),// ->12878
/* 12765*/  OPC_Scope, 22, /*->12789*/ // 3 children in Scope
/* 12767*/   OPC_RecordChild0, // #0 = $lhs
/* 12768*/   OPC_RecordChild1, // #1 = $rhs
/* 12769*/   OPC_SwitchType /*2 cases */, 7, MVT::i32,// ->12779
/* 12772*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SUB_I32),
                  MVT::i32, 2/*#Ops*/, 0, 1, 
              // Src: (sub:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs) - Complexity = 3
              // Dst: (SUB_I32:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs)
/* 12779*/   /*SwitchType*/ 7, MVT::i64,// ->12788
/* 12781*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SUB_I64),
                  MVT::i64, 2/*#Ops*/, 0, 1, 
              // Src: (sub:{ *:[i64] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs) - Complexity = 3
              // Dst: (SUB_I64:{ *:[i64] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs)
/* 12788*/   0, // EndSwitchType
/* 12789*/  /*Scope*/ 42, /*->12832*/
/* 12790*/   OPC_MoveChild0,
/* 12791*/   OPC_CheckImmAllZerosV,
/* 12792*/   OPC_MoveParent,
/* 12793*/   OPC_RecordChild1, // #0 = $v
/* 12794*/   OPC_SwitchType /*4 cases */, 7, MVT::v16i8,// ->12804
/* 12797*/    OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 12798*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::NEG_I8x16),
                  MVT::v16i8, 1/*#Ops*/, 0, 
              // Src: (sub:{ *:[v16i8] } immAllZerosV:{ *:[v16i8] }, V128:{ *:[v16i8] }:$v) - Complexity = 7
              // Dst: (NEG_I8x16:{ *:[v16i8] } V128:{ *:[v16i8] }:$v)
/* 12804*/   /*SwitchType*/ 7, MVT::v8i16,// ->12813
/* 12806*/    OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 12807*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::NEG_I16x8),
                  MVT::v8i16, 1/*#Ops*/, 0, 
              // Src: (sub:{ *:[v8i16] } immAllZerosV:{ *:[v8i16] }, V128:{ *:[v8i16] }:$v) - Complexity = 7
              // Dst: (NEG_I16x8:{ *:[v8i16] } V128:{ *:[v8i16] }:$v)
/* 12813*/   /*SwitchType*/ 7, MVT::v4i32,// ->12822
/* 12815*/    OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 12816*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::NEG_I32x4),
                  MVT::v4i32, 1/*#Ops*/, 0, 
              // Src: (sub:{ *:[v4i32] } immAllZerosV:{ *:[v4i32] }, V128:{ *:[v4i32] }:$v) - Complexity = 7
              // Dst: (NEG_I32x4:{ *:[v4i32] } V128:{ *:[v4i32] }:$v)
/* 12822*/   /*SwitchType*/ 7, MVT::v2i64,// ->12831
/* 12824*/    OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 12825*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::NEG_I64x2),
                  MVT::v2i64, 1/*#Ops*/, 0, 
              // Src: (sub:{ *:[v2i64] } immAllZerosV:{ *:[v2i64] }, V128:{ *:[v2i64] }:$v) - Complexity = 7
              // Dst: (NEG_I64x2:{ *:[v2i64] } V128:{ *:[v2i64] }:$v)
/* 12831*/   0, // EndSwitchType
/* 12832*/  /*Scope*/ 44, /*->12877*/
/* 12833*/   OPC_RecordChild0, // #0 = $lhs
/* 12834*/   OPC_RecordChild1, // #1 = $rhs
/* 12835*/   OPC_SwitchType /*4 cases */, 8, MVT::v16i8,// ->12846
/* 12838*/    OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 12839*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SUB_I8x16),
                  MVT::v16i8, 2/*#Ops*/, 0, 1, 
              // Src: (sub:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs) - Complexity = 3
              // Dst: (SUB_I8x16:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs)
/* 12846*/   /*SwitchType*/ 8, MVT::v8i16,// ->12856
/* 12848*/    OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 12849*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SUB_I16x8),
                  MVT::v8i16, 2/*#Ops*/, 0, 1, 
              // Src: (sub:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs) - Complexity = 3
              // Dst: (SUB_I16x8:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs)
/* 12856*/   /*SwitchType*/ 8, MVT::v4i32,// ->12866
/* 12858*/    OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 12859*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SUB_I32x4),
                  MVT::v4i32, 2/*#Ops*/, 0, 1, 
              // Src: (sub:{ *:[v4i32] } V128:{ *:[v4i32] }:$lhs, V128:{ *:[v4i32] }:$rhs) - Complexity = 3
              // Dst: (SUB_I32x4:{ *:[v4i32] } V128:{ *:[v4i32] }:$lhs, V128:{ *:[v4i32] }:$rhs)
/* 12866*/   /*SwitchType*/ 8, MVT::v2i64,// ->12876
/* 12868*/    OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 12869*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SUB_I64x2),
                  MVT::v2i64, 2/*#Ops*/, 0, 1, 
              // Src: (sub:{ *:[v2i64] } V128:{ *:[v2i64] }:$lhs, V128:{ *:[v2i64] }:$rhs) - Complexity = 3
              // Dst: (SUB_I64x2:{ *:[v2i64] } V128:{ *:[v2i64] }:$lhs, V128:{ *:[v2i64] }:$rhs)
/* 12876*/   0, // EndSwitchType
/* 12877*/  0, /*End of Scope*/
/* 12878*/ /*SwitchOpcode*/ 85|128,2/*341*/, TARGET_VAL(ISD::MUL),// ->13223
/* 12882*/  OPC_Scope, 22, /*->12906*/ // 3 children in Scope
/* 12884*/   OPC_RecordChild0, // #0 = $lhs
/* 12885*/   OPC_RecordChild1, // #1 = $rhs
/* 12886*/   OPC_SwitchType /*2 cases */, 7, MVT::i32,// ->12896
/* 12889*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::MUL_I32),
                  MVT::i32, 2/*#Ops*/, 0, 1, 
              // Src: (mul:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs) - Complexity = 3
              // Dst: (MUL_I32:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs)
/* 12896*/   /*SwitchType*/ 7, MVT::i64,// ->12905
/* 12898*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::MUL_I64),
                  MVT::i64, 2/*#Ops*/, 0, 1, 
              // Src: (mul:{ *:[i64] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs) - Complexity = 3
              // Dst: (MUL_I64:{ *:[i64] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs)
/* 12905*/   0, // EndSwitchType
/* 12906*/  /*Scope*/ 23|128,2/*279*/, /*->13187*/
/* 12908*/   OPC_MoveChild0,
/* 12909*/   OPC_SwitchOpcode /*4 cases */, 66, TARGET_VAL(WebAssemblyISD::EXTEND_LOW_S),// ->12979
/* 12913*/    OPC_RecordChild0, // #0 = $lhs
/* 12914*/    OPC_Scope, 20, /*->12936*/ // 3 children in Scope
/* 12916*/     OPC_CheckChild0Type, MVT::v16i8,
/* 12918*/     OPC_MoveSibling1,
/* 12919*/     OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::EXTEND_LOW_S),
/* 12922*/     OPC_RecordChild0, // #1 = $rhs
/* 12923*/     OPC_CheckChild0Type, MVT::v16i8,
/* 12925*/     OPC_MoveParent,
/* 12926*/     OPC_CheckType, MVT::v8i16,
/* 12928*/     OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 12929*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::EXTMUL_LOW_S_I16x8),
                   MVT::v8i16, 2/*#Ops*/, 0, 1, 
               // Src: (mul:{ *:[v8i16] } (extend_low_s:{ *:[v8i16] } V128:{ *:[v16i8] }:$lhs), (extend_low_s:{ *:[v8i16] } V128:{ *:[v16i8] }:$rhs)) - Complexity = 9
               // Dst: (EXTMUL_LOW_S_I16x8:{ *:[v8i16] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs)
/* 12936*/    /*Scope*/ 20, /*->12957*/
/* 12937*/     OPC_CheckChild0Type, MVT::v8i16,
/* 12939*/     OPC_MoveSibling1,
/* 12940*/     OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::EXTEND_LOW_S),
/* 12943*/     OPC_RecordChild0, // #1 = $rhs
/* 12944*/     OPC_CheckChild0Type, MVT::v8i16,
/* 12946*/     OPC_MoveParent,
/* 12947*/     OPC_CheckType, MVT::v4i32,
/* 12949*/     OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 12950*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::EXTMUL_LOW_S_I32x4),
                   MVT::v4i32, 2/*#Ops*/, 0, 1, 
               // Src: (mul:{ *:[v4i32] } (extend_low_s:{ *:[v4i32] } V128:{ *:[v8i16] }:$lhs), (extend_low_s:{ *:[v4i32] } V128:{ *:[v8i16] }:$rhs)) - Complexity = 9
               // Dst: (EXTMUL_LOW_S_I32x4:{ *:[v4i32] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs)
/* 12957*/    /*Scope*/ 20, /*->12978*/
/* 12958*/     OPC_CheckChild0Type, MVT::v4i32,
/* 12960*/     OPC_MoveSibling1,
/* 12961*/     OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::EXTEND_LOW_S),
/* 12964*/     OPC_RecordChild0, // #1 = $rhs
/* 12965*/     OPC_CheckChild0Type, MVT::v4i32,
/* 12967*/     OPC_MoveParent,
/* 12968*/     OPC_CheckType, MVT::v2i64,
/* 12970*/     OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 12971*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::EXTMUL_LOW_S_I64x2),
                   MVT::v2i64, 2/*#Ops*/, 0, 1, 
               // Src: (mul:{ *:[v2i64] } (extend_low_s:{ *:[v2i64] } V128:{ *:[v4i32] }:$lhs), (extend_low_s:{ *:[v2i64] } V128:{ *:[v4i32] }:$rhs)) - Complexity = 9
               // Dst: (EXTMUL_LOW_S_I64x2:{ *:[v2i64] } V128:{ *:[v4i32] }:$lhs, V128:{ *:[v4i32] }:$rhs)
/* 12978*/    0, /*End of Scope*/
/* 12979*/   /*SwitchOpcode*/ 66, TARGET_VAL(WebAssemblyISD::EXTEND_HIGH_S),// ->13048
/* 12982*/    OPC_RecordChild0, // #0 = $lhs
/* 12983*/    OPC_Scope, 20, /*->13005*/ // 3 children in Scope
/* 12985*/     OPC_CheckChild0Type, MVT::v16i8,
/* 12987*/     OPC_MoveSibling1,
/* 12988*/     OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::EXTEND_HIGH_S),
/* 12991*/     OPC_RecordChild0, // #1 = $rhs
/* 12992*/     OPC_CheckChild0Type, MVT::v16i8,
/* 12994*/     OPC_MoveParent,
/* 12995*/     OPC_CheckType, MVT::v8i16,
/* 12997*/     OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 12998*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::EXTMUL_HIGH_S_I16x8),
                   MVT::v8i16, 2/*#Ops*/, 0, 1, 
               // Src: (mul:{ *:[v8i16] } (extend_high_s:{ *:[v8i16] } V128:{ *:[v16i8] }:$lhs), (extend_high_s:{ *:[v8i16] } V128:{ *:[v16i8] }:$rhs)) - Complexity = 9
               // Dst: (EXTMUL_HIGH_S_I16x8:{ *:[v8i16] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs)
/* 13005*/    /*Scope*/ 20, /*->13026*/
/* 13006*/     OPC_CheckChild0Type, MVT::v8i16,
/* 13008*/     OPC_MoveSibling1,
/* 13009*/     OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::EXTEND_HIGH_S),
/* 13012*/     OPC_RecordChild0, // #1 = $rhs
/* 13013*/     OPC_CheckChild0Type, MVT::v8i16,
/* 13015*/     OPC_MoveParent,
/* 13016*/     OPC_CheckType, MVT::v4i32,
/* 13018*/     OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 13019*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::EXTMUL_HIGH_S_I32x4),
                   MVT::v4i32, 2/*#Ops*/, 0, 1, 
               // Src: (mul:{ *:[v4i32] } (extend_high_s:{ *:[v4i32] } V128:{ *:[v8i16] }:$lhs), (extend_high_s:{ *:[v4i32] } V128:{ *:[v8i16] }:$rhs)) - Complexity = 9
               // Dst: (EXTMUL_HIGH_S_I32x4:{ *:[v4i32] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs)
/* 13026*/    /*Scope*/ 20, /*->13047*/
/* 13027*/     OPC_CheckChild0Type, MVT::v4i32,
/* 13029*/     OPC_MoveSibling1,
/* 13030*/     OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::EXTEND_HIGH_S),
/* 13033*/     OPC_RecordChild0, // #1 = $rhs
/* 13034*/     OPC_CheckChild0Type, MVT::v4i32,
/* 13036*/     OPC_MoveParent,
/* 13037*/     OPC_CheckType, MVT::v2i64,
/* 13039*/     OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 13040*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::EXTMUL_HIGH_S_I64x2),
                   MVT::v2i64, 2/*#Ops*/, 0, 1, 
               // Src: (mul:{ *:[v2i64] } (extend_high_s:{ *:[v2i64] } V128:{ *:[v4i32] }:$lhs), (extend_high_s:{ *:[v2i64] } V128:{ *:[v4i32] }:$rhs)) - Complexity = 9
               // Dst: (EXTMUL_HIGH_S_I64x2:{ *:[v2i64] } V128:{ *:[v4i32] }:$lhs, V128:{ *:[v4i32] }:$rhs)
/* 13047*/    0, /*End of Scope*/
/* 13048*/   /*SwitchOpcode*/ 66, TARGET_VAL(WebAssemblyISD::EXTEND_LOW_U),// ->13117
/* 13051*/    OPC_RecordChild0, // #0 = $lhs
/* 13052*/    OPC_Scope, 20, /*->13074*/ // 3 children in Scope
/* 13054*/     OPC_CheckChild0Type, MVT::v16i8,
/* 13056*/     OPC_MoveSibling1,
/* 13057*/     OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::EXTEND_LOW_U),
/* 13060*/     OPC_RecordChild0, // #1 = $rhs
/* 13061*/     OPC_CheckChild0Type, MVT::v16i8,
/* 13063*/     OPC_MoveParent,
/* 13064*/     OPC_CheckType, MVT::v8i16,
/* 13066*/     OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 13067*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::EXTMUL_LOW_U_I16x8),
                   MVT::v8i16, 2/*#Ops*/, 0, 1, 
               // Src: (mul:{ *:[v8i16] } (extend_low_u:{ *:[v8i16] } V128:{ *:[v16i8] }:$lhs), (extend_low_u:{ *:[v8i16] } V128:{ *:[v16i8] }:$rhs)) - Complexity = 9
               // Dst: (EXTMUL_LOW_U_I16x8:{ *:[v8i16] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs)
/* 13074*/    /*Scope*/ 20, /*->13095*/
/* 13075*/     OPC_CheckChild0Type, MVT::v8i16,
/* 13077*/     OPC_MoveSibling1,
/* 13078*/     OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::EXTEND_LOW_U),
/* 13081*/     OPC_RecordChild0, // #1 = $rhs
/* 13082*/     OPC_CheckChild0Type, MVT::v8i16,
/* 13084*/     OPC_MoveParent,
/* 13085*/     OPC_CheckType, MVT::v4i32,
/* 13087*/     OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 13088*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::EXTMUL_LOW_U_I32x4),
                   MVT::v4i32, 2/*#Ops*/, 0, 1, 
               // Src: (mul:{ *:[v4i32] } (extend_low_u:{ *:[v4i32] } V128:{ *:[v8i16] }:$lhs), (extend_low_u:{ *:[v4i32] } V128:{ *:[v8i16] }:$rhs)) - Complexity = 9
               // Dst: (EXTMUL_LOW_U_I32x4:{ *:[v4i32] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs)
/* 13095*/    /*Scope*/ 20, /*->13116*/
/* 13096*/     OPC_CheckChild0Type, MVT::v4i32,
/* 13098*/     OPC_MoveSibling1,
/* 13099*/     OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::EXTEND_LOW_U),
/* 13102*/     OPC_RecordChild0, // #1 = $rhs
/* 13103*/     OPC_CheckChild0Type, MVT::v4i32,
/* 13105*/     OPC_MoveParent,
/* 13106*/     OPC_CheckType, MVT::v2i64,
/* 13108*/     OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 13109*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::EXTMUL_LOW_U_I64x2),
                   MVT::v2i64, 2/*#Ops*/, 0, 1, 
               // Src: (mul:{ *:[v2i64] } (extend_low_u:{ *:[v2i64] } V128:{ *:[v4i32] }:$lhs), (extend_low_u:{ *:[v2i64] } V128:{ *:[v4i32] }:$rhs)) - Complexity = 9
               // Dst: (EXTMUL_LOW_U_I64x2:{ *:[v2i64] } V128:{ *:[v4i32] }:$lhs, V128:{ *:[v4i32] }:$rhs)
/* 13116*/    0, /*End of Scope*/
/* 13117*/   /*SwitchOpcode*/ 66, TARGET_VAL(WebAssemblyISD::EXTEND_HIGH_U),// ->13186
/* 13120*/    OPC_RecordChild0, // #0 = $lhs
/* 13121*/    OPC_Scope, 20, /*->13143*/ // 3 children in Scope
/* 13123*/     OPC_CheckChild0Type, MVT::v16i8,
/* 13125*/     OPC_MoveSibling1,
/* 13126*/     OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::EXTEND_HIGH_U),
/* 13129*/     OPC_RecordChild0, // #1 = $rhs
/* 13130*/     OPC_CheckChild0Type, MVT::v16i8,
/* 13132*/     OPC_MoveParent,
/* 13133*/     OPC_CheckType, MVT::v8i16,
/* 13135*/     OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 13136*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::EXTMUL_HIGH_U_I16x8),
                   MVT::v8i16, 2/*#Ops*/, 0, 1, 
               // Src: (mul:{ *:[v8i16] } (extend_high_u:{ *:[v8i16] } V128:{ *:[v16i8] }:$lhs), (extend_high_u:{ *:[v8i16] } V128:{ *:[v16i8] }:$rhs)) - Complexity = 9
               // Dst: (EXTMUL_HIGH_U_I16x8:{ *:[v8i16] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs)
/* 13143*/    /*Scope*/ 20, /*->13164*/
/* 13144*/     OPC_CheckChild0Type, MVT::v8i16,
/* 13146*/     OPC_MoveSibling1,
/* 13147*/     OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::EXTEND_HIGH_U),
/* 13150*/     OPC_RecordChild0, // #1 = $rhs
/* 13151*/     OPC_CheckChild0Type, MVT::v8i16,
/* 13153*/     OPC_MoveParent,
/* 13154*/     OPC_CheckType, MVT::v4i32,
/* 13156*/     OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 13157*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::EXTMUL_HIGH_U_I32x4),
                   MVT::v4i32, 2/*#Ops*/, 0, 1, 
               // Src: (mul:{ *:[v4i32] } (extend_high_u:{ *:[v4i32] } V128:{ *:[v8i16] }:$lhs), (extend_high_u:{ *:[v4i32] } V128:{ *:[v8i16] }:$rhs)) - Complexity = 9
               // Dst: (EXTMUL_HIGH_U_I32x4:{ *:[v4i32] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs)
/* 13164*/    /*Scope*/ 20, /*->13185*/
/* 13165*/     OPC_CheckChild0Type, MVT::v4i32,
/* 13167*/     OPC_MoveSibling1,
/* 13168*/     OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::EXTEND_HIGH_U),
/* 13171*/     OPC_RecordChild0, // #1 = $rhs
/* 13172*/     OPC_CheckChild0Type, MVT::v4i32,
/* 13174*/     OPC_MoveParent,
/* 13175*/     OPC_CheckType, MVT::v2i64,
/* 13177*/     OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 13178*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::EXTMUL_HIGH_U_I64x2),
                   MVT::v2i64, 2/*#Ops*/, 0, 1, 
               // Src: (mul:{ *:[v2i64] } (extend_high_u:{ *:[v2i64] } V128:{ *:[v4i32] }:$lhs), (extend_high_u:{ *:[v2i64] } V128:{ *:[v4i32] }:$rhs)) - Complexity = 9
               // Dst: (EXTMUL_HIGH_U_I64x2:{ *:[v2i64] } V128:{ *:[v4i32] }:$lhs, V128:{ *:[v4i32] }:$rhs)
/* 13185*/    0, /*End of Scope*/
/* 13186*/   0, // EndSwitchOpcode
/* 13187*/  /*Scope*/ 34, /*->13222*/
/* 13188*/   OPC_RecordChild0, // #0 = $lhs
/* 13189*/   OPC_RecordChild1, // #1 = $rhs
/* 13190*/   OPC_SwitchType /*3 cases */, 8, MVT::v8i16,// ->13201
/* 13193*/    OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 13194*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::MUL_I16x8),
                  MVT::v8i16, 2/*#Ops*/, 0, 1, 
              // Src: (mul:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs) - Complexity = 3
              // Dst: (MUL_I16x8:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs)
/* 13201*/   /*SwitchType*/ 8, MVT::v4i32,// ->13211
/* 13203*/    OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 13204*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::MUL_I32x4),
                  MVT::v4i32, 2/*#Ops*/, 0, 1, 
              // Src: (mul:{ *:[v4i32] } V128:{ *:[v4i32] }:$lhs, V128:{ *:[v4i32] }:$rhs) - Complexity = 3
              // Dst: (MUL_I32x4:{ *:[v4i32] } V128:{ *:[v4i32] }:$lhs, V128:{ *:[v4i32] }:$rhs)
/* 13211*/   /*SwitchType*/ 8, MVT::v2i64,// ->13221
/* 13213*/    OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 13214*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::MUL_I64x2),
                  MVT::v2i64, 2/*#Ops*/, 0, 1, 
              // Src: (mul:{ *:[v2i64] } V128:{ *:[v2i64] }:$lhs, V128:{ *:[v2i64] }:$rhs) - Complexity = 3
              // Dst: (MUL_I64x2:{ *:[v2i64] } V128:{ *:[v2i64] }:$lhs, V128:{ *:[v2i64] }:$rhs)
/* 13221*/   0, // EndSwitchType
/* 13222*/  0, /*End of Scope*/
/* 13223*/ /*SwitchOpcode*/ 22, TARGET_VAL(ISD::SDIV),// ->13248
/* 13226*/  OPC_RecordChild0, // #0 = $lhs
/* 13227*/  OPC_RecordChild1, // #1 = $rhs
/* 13228*/  OPC_SwitchType /*2 cases */, 7, MVT::i32,// ->13238
/* 13231*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::DIV_S_I32),
                 MVT::i32, 2/*#Ops*/, 0, 1, 
             // Src: (sdiv:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs) - Complexity = 3
             // Dst: (DIV_S_I32:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs)
/* 13238*/  /*SwitchType*/ 7, MVT::i64,// ->13247
/* 13240*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::DIV_S_I64),
                 MVT::i64, 2/*#Ops*/, 0, 1, 
             // Src: (sdiv:{ *:[i64] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs) - Complexity = 3
             // Dst: (DIV_S_I64:{ *:[i64] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs)
/* 13247*/  0, // EndSwitchType
/* 13248*/ /*SwitchOpcode*/ 22, TARGET_VAL(ISD::UDIV),// ->13273
/* 13251*/  OPC_RecordChild0, // #0 = $lhs
/* 13252*/  OPC_RecordChild1, // #1 = $rhs
/* 13253*/  OPC_SwitchType /*2 cases */, 7, MVT::i32,// ->13263
/* 13256*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::DIV_U_I32),
                 MVT::i32, 2/*#Ops*/, 0, 1, 
             // Src: (udiv:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs) - Complexity = 3
             // Dst: (DIV_U_I32:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs)
/* 13263*/  /*SwitchType*/ 7, MVT::i64,// ->13272
/* 13265*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::DIV_U_I64),
                 MVT::i64, 2/*#Ops*/, 0, 1, 
             // Src: (udiv:{ *:[i64] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs) - Complexity = 3
             // Dst: (DIV_U_I64:{ *:[i64] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs)
/* 13272*/  0, // EndSwitchType
/* 13273*/ /*SwitchOpcode*/ 22, TARGET_VAL(ISD::SREM),// ->13298
/* 13276*/  OPC_RecordChild0, // #0 = $lhs
/* 13277*/  OPC_RecordChild1, // #1 = $rhs
/* 13278*/  OPC_SwitchType /*2 cases */, 7, MVT::i32,// ->13288
/* 13281*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::REM_S_I32),
                 MVT::i32, 2/*#Ops*/, 0, 1, 
             // Src: (srem:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs) - Complexity = 3
             // Dst: (REM_S_I32:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs)
/* 13288*/  /*SwitchType*/ 7, MVT::i64,// ->13297
/* 13290*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::REM_S_I64),
                 MVT::i64, 2/*#Ops*/, 0, 1, 
             // Src: (srem:{ *:[i64] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs) - Complexity = 3
             // Dst: (REM_S_I64:{ *:[i64] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs)
/* 13297*/  0, // EndSwitchType
/* 13298*/ /*SwitchOpcode*/ 22, TARGET_VAL(ISD::UREM),// ->13323
/* 13301*/  OPC_RecordChild0, // #0 = $lhs
/* 13302*/  OPC_RecordChild1, // #1 = $rhs
/* 13303*/  OPC_SwitchType /*2 cases */, 7, MVT::i32,// ->13313
/* 13306*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::REM_U_I32),
                 MVT::i32, 2/*#Ops*/, 0, 1, 
             // Src: (urem:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs) - Complexity = 3
             // Dst: (REM_U_I32:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs)
/* 13313*/  /*SwitchType*/ 7, MVT::i64,// ->13322
/* 13315*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::REM_U_I64),
                 MVT::i64, 2/*#Ops*/, 0, 1, 
             // Src: (urem:{ *:[i64] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs) - Complexity = 3
             // Dst: (REM_U_I64:{ *:[i64] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs)
/* 13322*/  0, // EndSwitchType
/* 13323*/ /*SwitchOpcode*/ 56|128,6/*824*/, TARGET_VAL(ISD::OR),// ->14151
/* 13327*/  OPC_Scope, 22, /*->13351*/ // 3 children in Scope
/* 13329*/   OPC_RecordChild0, // #0 = $lhs
/* 13330*/   OPC_RecordChild1, // #1 = $rhs
/* 13331*/   OPC_SwitchType /*2 cases */, 7, MVT::i32,// ->13341
/* 13334*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::OR_I32),
                  MVT::i32, 2/*#Ops*/, 0, 1, 
              // Src: (or:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs) - Complexity = 3
              // Dst: (OR_I32:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs)
/* 13341*/   /*SwitchType*/ 7, MVT::i64,// ->13350
/* 13343*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::OR_I64),
                  MVT::i64, 2/*#Ops*/, 0, 1, 
              // Src: (or:{ *:[i64] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs) - Complexity = 3
              // Dst: (OR_I64:{ *:[i64] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs)
/* 13350*/   0, // EndSwitchType
/* 13351*/  /*Scope*/ 116|128,5/*756*/, /*->14109*/
/* 13353*/   OPC_MoveChild0,
/* 13354*/   OPC_CheckOpcode, TARGET_VAL(ISD::AND),
/* 13357*/   OPC_Scope, 4|128,1/*132*/, /*->13492*/ // 9 children in Scope
/* 13360*/    OPC_RecordChild0, // #0 = $c
/* 13361*/    OPC_RecordChild1, // #1 = $v1
/* 13362*/    OPC_MoveSibling1,
/* 13363*/    OPC_CheckOpcode, TARGET_VAL(ISD::AND),
/* 13366*/    OPC_Scope, 54, /*->13422*/ // 4 children in Scope
/* 13368*/     OPC_MoveChild0,
/* 13369*/     OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 13372*/     OPC_CheckChild0Same, 0,
/* 13374*/     OPC_MoveChild1,
/* 13375*/     OPC_CheckImmAllOnesV,
/* 13376*/     OPC_MoveParent,
/* 13377*/     OPC_MoveParent,
/* 13378*/     OPC_RecordChild1, // #2 = $v2
/* 13379*/     OPC_MoveParent,
/* 13380*/     OPC_SwitchType /*4 cases */, 8, MVT::v16i8,// ->13391
/* 13383*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                    MVT::v16i8, 3/*#Ops*/, 1, 2, 0, 
                // Src: (or:{ *:[v16i8] } (and:{ *:[v16i8] } V128:{ *:[v16i8] }:$c, V128:{ *:[v16i8] }:$v1), (and:{ *:[v16i8] } (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$c, immAllOnesV:{ *:[v16i8] }), V128:{ *:[v16i8] }:$v2)) - Complexity = 16
                // Dst: (BITSELECT:{ *:[v16i8] } ?:{ *:[v16i8] }:$v1, ?:{ *:[v16i8] }:$v2, ?:{ *:[v16i8] }:$c)
/* 13391*/     /*SwitchType*/ 8, MVT::v8i16,// ->13401
/* 13393*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                    MVT::v8i16, 3/*#Ops*/, 1, 2, 0, 
                // Src: (or:{ *:[v8i16] } (and:{ *:[v8i16] } V128:{ *:[v8i16] }:$c, V128:{ *:[v8i16] }:$v1), (and:{ *:[v8i16] } (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$c, immAllOnesV:{ *:[v8i16] }), V128:{ *:[v8i16] }:$v2)) - Complexity = 16
                // Dst: (BITSELECT:{ *:[v8i16] } ?:{ *:[v8i16] }:$v1, ?:{ *:[v8i16] }:$v2, ?:{ *:[v8i16] }:$c)
/* 13401*/     /*SwitchType*/ 8, MVT::v4i32,// ->13411
/* 13403*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                    MVT::v4i32, 3/*#Ops*/, 1, 2, 0, 
                // Src: (or:{ *:[v4i32] } (and:{ *:[v4i32] } V128:{ *:[v4i32] }:$c, V128:{ *:[v4i32] }:$v1), (and:{ *:[v4i32] } (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$c, immAllOnesV:{ *:[v4i32] }), V128:{ *:[v4i32] }:$v2)) - Complexity = 16
                // Dst: (BITSELECT:{ *:[v4i32] } ?:{ *:[v4i32] }:$v1, ?:{ *:[v4i32] }:$v2, ?:{ *:[v4i32] }:$c)
/* 13411*/     /*SwitchType*/ 8, MVT::v2i64,// ->13421
/* 13413*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                    MVT::v2i64, 3/*#Ops*/, 1, 2, 0, 
                // Src: (or:{ *:[v2i64] } (and:{ *:[v2i64] } V128:{ *:[v2i64] }:$c, V128:{ *:[v2i64] }:$v1), (and:{ *:[v2i64] } (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$c, immAllOnesV:{ *:[v2i64] }), V128:{ *:[v2i64] }:$v2)) - Complexity = 16
                // Dst: (BITSELECT:{ *:[v2i64] } ?:{ *:[v2i64] }:$v1, ?:{ *:[v2i64] }:$v2, ?:{ *:[v2i64] }:$c)
/* 13421*/     0, // EndSwitchType
/* 13422*/    /*Scope*/ 22, /*->13445*/
/* 13423*/     OPC_RecordChild0, // #2 = $v2
/* 13424*/     OPC_MoveChild1,
/* 13425*/     OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 13428*/     OPC_CheckChild0Same, 0,
/* 13430*/     OPC_MoveChild1,
/* 13431*/     OPC_CheckImmAllOnesV,
/* 13432*/     OPC_MoveParent,
/* 13433*/     OPC_MoveParent,
/* 13434*/     OPC_MoveParent,
/* 13435*/     OPC_CheckType, MVT::v16i8,
/* 13437*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                   MVT::v16i8, 3/*#Ops*/, 1, 2, 0, 
               // Src: (or:{ *:[v16i8] } (and:{ *:[v16i8] } V128:{ *:[v16i8] }:$c, V128:{ *:[v16i8] }:$v1), (and:{ *:[v16i8] } V128:{ *:[v16i8] }:$v2, (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$c, immAllOnesV:{ *:[v16i8] }))) - Complexity = 16
               // Dst: (BITSELECT:{ *:[v16i8] } ?:{ *:[v16i8] }:$v1, ?:{ *:[v16i8] }:$v2, ?:{ *:[v16i8] }:$c)
/* 13445*/    /*Scope*/ 22, /*->13468*/
/* 13446*/     OPC_MoveChild0,
/* 13447*/     OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 13450*/     OPC_CheckChild0Same, 1,
/* 13452*/     OPC_MoveChild1,
/* 13453*/     OPC_CheckImmAllOnesV,
/* 13454*/     OPC_MoveParent,
/* 13455*/     OPC_MoveParent,
/* 13456*/     OPC_RecordChild1, // #2 = $v2
/* 13457*/     OPC_MoveParent,
/* 13458*/     OPC_CheckType, MVT::v16i8,
/* 13460*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                   MVT::v16i8, 3/*#Ops*/, 0, 2, 1, 
               // Src: (or:{ *:[v16i8] } (and:{ *:[v16i8] } V128:{ *:[v16i8] }:$v1, V128:{ *:[v16i8] }:$c), (and:{ *:[v16i8] } (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$c, immAllOnesV:{ *:[v16i8] }), V128:{ *:[v16i8] }:$v2)) - Complexity = 16
               // Dst: (BITSELECT:{ *:[v16i8] } ?:{ *:[v16i8] }:$v1, ?:{ *:[v16i8] }:$v2, ?:{ *:[v16i8] }:$c)
/* 13468*/    /*Scope*/ 22, /*->13491*/
/* 13469*/     OPC_RecordChild0, // #2 = $v2
/* 13470*/     OPC_MoveChild1,
/* 13471*/     OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 13474*/     OPC_CheckChild0Same, 1,
/* 13476*/     OPC_MoveChild1,
/* 13477*/     OPC_CheckImmAllOnesV,
/* 13478*/     OPC_MoveParent,
/* 13479*/     OPC_MoveParent,
/* 13480*/     OPC_MoveParent,
/* 13481*/     OPC_CheckType, MVT::v16i8,
/* 13483*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                   MVT::v16i8, 3/*#Ops*/, 0, 2, 1, 
               // Src: (or:{ *:[v16i8] } (and:{ *:[v16i8] } V128:{ *:[v16i8] }:$v1, V128:{ *:[v16i8] }:$c), (and:{ *:[v16i8] } V128:{ *:[v16i8] }:$v2, (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$c, immAllOnesV:{ *:[v16i8] }))) - Complexity = 16
               // Dst: (BITSELECT:{ *:[v16i8] } ?:{ *:[v16i8] }:$v1, ?:{ *:[v16i8] }:$v2, ?:{ *:[v16i8] }:$c)
/* 13491*/    0, /*End of Scope*/
/* 13492*/   /*Scope*/ 46, /*->13539*/
/* 13493*/    OPC_MoveChild0,
/* 13494*/    OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 13497*/    OPC_RecordChild0, // #0 = $c
/* 13498*/    OPC_MoveChild1,
/* 13499*/    OPC_CheckImmAllOnesV,
/* 13500*/    OPC_MoveParent,
/* 13501*/    OPC_MoveParent,
/* 13502*/    OPC_RecordChild1, // #1 = $v2
/* 13503*/    OPC_MoveSibling1,
/* 13504*/    OPC_CheckOpcode, TARGET_VAL(ISD::AND),
/* 13507*/    OPC_Scope, 14, /*->13523*/ // 2 children in Scope
/* 13509*/     OPC_CheckChild0Same, 0,
/* 13511*/     OPC_RecordChild1, // #2 = $v1
/* 13512*/     OPC_MoveParent,
/* 13513*/     OPC_CheckType, MVT::v16i8,
/* 13515*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                   MVT::v16i8, 3/*#Ops*/, 2, 1, 0, 
               // Src: (or:{ *:[v16i8] } (and:{ *:[v16i8] } (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$c, immAllOnesV:{ *:[v16i8] }), V128:{ *:[v16i8] }:$v2), (and:{ *:[v16i8] } V128:{ *:[v16i8] }:$c, V128:{ *:[v16i8] }:$v1)) - Complexity = 16
               // Dst: (BITSELECT:{ *:[v16i8] } ?:{ *:[v16i8] }:$v1, ?:{ *:[v16i8] }:$v2, ?:{ *:[v16i8] }:$c)
/* 13523*/    /*Scope*/ 14, /*->13538*/
/* 13524*/     OPC_RecordChild0, // #2 = $v1
/* 13525*/     OPC_CheckChild1Same, 0,
/* 13527*/     OPC_MoveParent,
/* 13528*/     OPC_CheckType, MVT::v16i8,
/* 13530*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                   MVT::v16i8, 3/*#Ops*/, 2, 1, 0, 
               // Src: (or:{ *:[v16i8] } (and:{ *:[v16i8] } (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$c, immAllOnesV:{ *:[v16i8] }), V128:{ *:[v16i8] }:$v2), (and:{ *:[v16i8] } V128:{ *:[v16i8] }:$v1, V128:{ *:[v16i8] }:$c)) - Complexity = 16
               // Dst: (BITSELECT:{ *:[v16i8] } ?:{ *:[v16i8] }:$v1, ?:{ *:[v16i8] }:$v2, ?:{ *:[v16i8] }:$c)
/* 13538*/    0, /*End of Scope*/
/* 13539*/   /*Scope*/ 126, /*->13666*/
/* 13540*/    OPC_RecordChild0, // #0 = $v2
/* 13541*/    OPC_Scope, 45, /*->13588*/ // 2 children in Scope
/* 13543*/     OPC_MoveChild1,
/* 13544*/     OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 13547*/     OPC_RecordChild0, // #1 = $c
/* 13548*/     OPC_MoveChild1,
/* 13549*/     OPC_CheckImmAllOnesV,
/* 13550*/     OPC_MoveParent,
/* 13551*/     OPC_MoveParent,
/* 13552*/     OPC_MoveSibling1,
/* 13553*/     OPC_CheckOpcode, TARGET_VAL(ISD::AND),
/* 13556*/     OPC_Scope, 14, /*->13572*/ // 2 children in Scope
/* 13558*/      OPC_CheckChild0Same, 1,
/* 13560*/      OPC_RecordChild1, // #2 = $v1
/* 13561*/      OPC_MoveParent,
/* 13562*/      OPC_CheckType, MVT::v16i8,
/* 13564*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                    MVT::v16i8, 3/*#Ops*/, 2, 0, 1, 
                // Src: (or:{ *:[v16i8] } (and:{ *:[v16i8] } V128:{ *:[v16i8] }:$v2, (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$c, immAllOnesV:{ *:[v16i8] })), (and:{ *:[v16i8] } V128:{ *:[v16i8] }:$c, V128:{ *:[v16i8] }:$v1)) - Complexity = 16
                // Dst: (BITSELECT:{ *:[v16i8] } ?:{ *:[v16i8] }:$v1, ?:{ *:[v16i8] }:$v2, ?:{ *:[v16i8] }:$c)
/* 13572*/     /*Scope*/ 14, /*->13587*/
/* 13573*/      OPC_RecordChild0, // #2 = $v1
/* 13574*/      OPC_CheckChild1Same, 1,
/* 13576*/      OPC_MoveParent,
/* 13577*/      OPC_CheckType, MVT::v16i8,
/* 13579*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                    MVT::v16i8, 3/*#Ops*/, 2, 0, 1, 
                // Src: (or:{ *:[v16i8] } (and:{ *:[v16i8] } V128:{ *:[v16i8] }:$v2, (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$c, immAllOnesV:{ *:[v16i8] })), (and:{ *:[v16i8] } V128:{ *:[v16i8] }:$v1, V128:{ *:[v16i8] }:$c)) - Complexity = 16
                // Dst: (BITSELECT:{ *:[v16i8] } ?:{ *:[v16i8] }:$v1, ?:{ *:[v16i8] }:$v2, ?:{ *:[v16i8] }:$c)
/* 13587*/     0, /*End of Scope*/
/* 13588*/    /*Scope*/ 76, /*->13665*/
/* 13589*/     OPC_RecordChild1, // #1 = $v1
/* 13590*/     OPC_MoveSibling1,
/* 13591*/     OPC_CheckOpcode, TARGET_VAL(ISD::AND),
/* 13594*/     OPC_Scope, 22, /*->13618*/ // 3 children in Scope
/* 13596*/      OPC_RecordChild0, // #2 = $v2
/* 13597*/      OPC_MoveChild1,
/* 13598*/      OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 13601*/      OPC_CheckChild0Same, 0,
/* 13603*/      OPC_MoveChild1,
/* 13604*/      OPC_CheckImmAllOnesV,
/* 13605*/      OPC_MoveParent,
/* 13606*/      OPC_MoveParent,
/* 13607*/      OPC_MoveParent,
/* 13608*/      OPC_CheckType, MVT::v8i16,
/* 13610*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                    MVT::v8i16, 3/*#Ops*/, 1, 2, 0, 
                // Src: (or:{ *:[v8i16] } (and:{ *:[v8i16] } V128:{ *:[v8i16] }:$c, V128:{ *:[v8i16] }:$v1), (and:{ *:[v8i16] } V128:{ *:[v8i16] }:$v2, (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$c, immAllOnesV:{ *:[v8i16] }))) - Complexity = 16
                // Dst: (BITSELECT:{ *:[v8i16] } ?:{ *:[v8i16] }:$v1, ?:{ *:[v8i16] }:$v2, ?:{ *:[v8i16] }:$c)
/* 13618*/     /*Scope*/ 22, /*->13641*/
/* 13619*/      OPC_MoveChild0,
/* 13620*/      OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 13623*/      OPC_CheckChild0Same, 1,
/* 13625*/      OPC_MoveChild1,
/* 13626*/      OPC_CheckImmAllOnesV,
/* 13627*/      OPC_MoveParent,
/* 13628*/      OPC_MoveParent,
/* 13629*/      OPC_RecordChild1, // #2 = $v2
/* 13630*/      OPC_MoveParent,
/* 13631*/      OPC_CheckType, MVT::v8i16,
/* 13633*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                    MVT::v8i16, 3/*#Ops*/, 0, 2, 1, 
                // Src: (or:{ *:[v8i16] } (and:{ *:[v8i16] } V128:{ *:[v8i16] }:$v1, V128:{ *:[v8i16] }:$c), (and:{ *:[v8i16] } (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$c, immAllOnesV:{ *:[v8i16] }), V128:{ *:[v8i16] }:$v2)) - Complexity = 16
                // Dst: (BITSELECT:{ *:[v8i16] } ?:{ *:[v8i16] }:$v1, ?:{ *:[v8i16] }:$v2, ?:{ *:[v8i16] }:$c)
/* 13641*/     /*Scope*/ 22, /*->13664*/
/* 13642*/      OPC_RecordChild0, // #2 = $v2
/* 13643*/      OPC_MoveChild1,
/* 13644*/      OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 13647*/      OPC_CheckChild0Same, 1,
/* 13649*/      OPC_MoveChild1,
/* 13650*/      OPC_CheckImmAllOnesV,
/* 13651*/      OPC_MoveParent,
/* 13652*/      OPC_MoveParent,
/* 13653*/      OPC_MoveParent,
/* 13654*/      OPC_CheckType, MVT::v8i16,
/* 13656*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                    MVT::v8i16, 3/*#Ops*/, 0, 2, 1, 
                // Src: (or:{ *:[v8i16] } (and:{ *:[v8i16] } V128:{ *:[v8i16] }:$v1, V128:{ *:[v8i16] }:$c), (and:{ *:[v8i16] } V128:{ *:[v8i16] }:$v2, (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$c, immAllOnesV:{ *:[v8i16] }))) - Complexity = 16
                // Dst: (BITSELECT:{ *:[v8i16] } ?:{ *:[v8i16] }:$v1, ?:{ *:[v8i16] }:$v2, ?:{ *:[v8i16] }:$c)
/* 13664*/     0, /*End of Scope*/
/* 13665*/    0, /*End of Scope*/
/* 13666*/   /*Scope*/ 46, /*->13713*/
/* 13667*/    OPC_MoveChild0,
/* 13668*/    OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 13671*/    OPC_RecordChild0, // #0 = $c
/* 13672*/    OPC_MoveChild1,
/* 13673*/    OPC_CheckImmAllOnesV,
/* 13674*/    OPC_MoveParent,
/* 13675*/    OPC_MoveParent,
/* 13676*/    OPC_RecordChild1, // #1 = $v2
/* 13677*/    OPC_MoveSibling1,
/* 13678*/    OPC_CheckOpcode, TARGET_VAL(ISD::AND),
/* 13681*/    OPC_Scope, 14, /*->13697*/ // 2 children in Scope
/* 13683*/     OPC_CheckChild0Same, 0,
/* 13685*/     OPC_RecordChild1, // #2 = $v1
/* 13686*/     OPC_MoveParent,
/* 13687*/     OPC_CheckType, MVT::v8i16,
/* 13689*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                   MVT::v8i16, 3/*#Ops*/, 2, 1, 0, 
               // Src: (or:{ *:[v8i16] } (and:{ *:[v8i16] } (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$c, immAllOnesV:{ *:[v8i16] }), V128:{ *:[v8i16] }:$v2), (and:{ *:[v8i16] } V128:{ *:[v8i16] }:$c, V128:{ *:[v8i16] }:$v1)) - Complexity = 16
               // Dst: (BITSELECT:{ *:[v8i16] } ?:{ *:[v8i16] }:$v1, ?:{ *:[v8i16] }:$v2, ?:{ *:[v8i16] }:$c)
/* 13697*/    /*Scope*/ 14, /*->13712*/
/* 13698*/     OPC_RecordChild0, // #2 = $v1
/* 13699*/     OPC_CheckChild1Same, 0,
/* 13701*/     OPC_MoveParent,
/* 13702*/     OPC_CheckType, MVT::v8i16,
/* 13704*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                   MVT::v8i16, 3/*#Ops*/, 2, 1, 0, 
               // Src: (or:{ *:[v8i16] } (and:{ *:[v8i16] } (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$c, immAllOnesV:{ *:[v8i16] }), V128:{ *:[v8i16] }:$v2), (and:{ *:[v8i16] } V128:{ *:[v8i16] }:$v1, V128:{ *:[v8i16] }:$c)) - Complexity = 16
               // Dst: (BITSELECT:{ *:[v8i16] } ?:{ *:[v8i16] }:$v1, ?:{ *:[v8i16] }:$v2, ?:{ *:[v8i16] }:$c)
/* 13712*/    0, /*End of Scope*/
/* 13713*/   /*Scope*/ 126, /*->13840*/
/* 13714*/    OPC_RecordChild0, // #0 = $v2
/* 13715*/    OPC_Scope, 45, /*->13762*/ // 2 children in Scope
/* 13717*/     OPC_MoveChild1,
/* 13718*/     OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 13721*/     OPC_RecordChild0, // #1 = $c
/* 13722*/     OPC_MoveChild1,
/* 13723*/     OPC_CheckImmAllOnesV,
/* 13724*/     OPC_MoveParent,
/* 13725*/     OPC_MoveParent,
/* 13726*/     OPC_MoveSibling1,
/* 13727*/     OPC_CheckOpcode, TARGET_VAL(ISD::AND),
/* 13730*/     OPC_Scope, 14, /*->13746*/ // 2 children in Scope
/* 13732*/      OPC_CheckChild0Same, 1,
/* 13734*/      OPC_RecordChild1, // #2 = $v1
/* 13735*/      OPC_MoveParent,
/* 13736*/      OPC_CheckType, MVT::v8i16,
/* 13738*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                    MVT::v8i16, 3/*#Ops*/, 2, 0, 1, 
                // Src: (or:{ *:[v8i16] } (and:{ *:[v8i16] } V128:{ *:[v8i16] }:$v2, (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$c, immAllOnesV:{ *:[v8i16] })), (and:{ *:[v8i16] } V128:{ *:[v8i16] }:$c, V128:{ *:[v8i16] }:$v1)) - Complexity = 16
                // Dst: (BITSELECT:{ *:[v8i16] } ?:{ *:[v8i16] }:$v1, ?:{ *:[v8i16] }:$v2, ?:{ *:[v8i16] }:$c)
/* 13746*/     /*Scope*/ 14, /*->13761*/
/* 13747*/      OPC_RecordChild0, // #2 = $v1
/* 13748*/      OPC_CheckChild1Same, 1,
/* 13750*/      OPC_MoveParent,
/* 13751*/      OPC_CheckType, MVT::v8i16,
/* 13753*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                    MVT::v8i16, 3/*#Ops*/, 2, 0, 1, 
                // Src: (or:{ *:[v8i16] } (and:{ *:[v8i16] } V128:{ *:[v8i16] }:$v2, (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$c, immAllOnesV:{ *:[v8i16] })), (and:{ *:[v8i16] } V128:{ *:[v8i16] }:$v1, V128:{ *:[v8i16] }:$c)) - Complexity = 16
                // Dst: (BITSELECT:{ *:[v8i16] } ?:{ *:[v8i16] }:$v1, ?:{ *:[v8i16] }:$v2, ?:{ *:[v8i16] }:$c)
/* 13761*/     0, /*End of Scope*/
/* 13762*/    /*Scope*/ 76, /*->13839*/
/* 13763*/     OPC_RecordChild1, // #1 = $v1
/* 13764*/     OPC_MoveSibling1,
/* 13765*/     OPC_CheckOpcode, TARGET_VAL(ISD::AND),
/* 13768*/     OPC_Scope, 22, /*->13792*/ // 3 children in Scope
/* 13770*/      OPC_RecordChild0, // #2 = $v2
/* 13771*/      OPC_MoveChild1,
/* 13772*/      OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 13775*/      OPC_CheckChild0Same, 0,
/* 13777*/      OPC_MoveChild1,
/* 13778*/      OPC_CheckImmAllOnesV,
/* 13779*/      OPC_MoveParent,
/* 13780*/      OPC_MoveParent,
/* 13781*/      OPC_MoveParent,
/* 13782*/      OPC_CheckType, MVT::v4i32,
/* 13784*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                    MVT::v4i32, 3/*#Ops*/, 1, 2, 0, 
                // Src: (or:{ *:[v4i32] } (and:{ *:[v4i32] } V128:{ *:[v4i32] }:$c, V128:{ *:[v4i32] }:$v1), (and:{ *:[v4i32] } V128:{ *:[v4i32] }:$v2, (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$c, immAllOnesV:{ *:[v4i32] }))) - Complexity = 16
                // Dst: (BITSELECT:{ *:[v4i32] } ?:{ *:[v4i32] }:$v1, ?:{ *:[v4i32] }:$v2, ?:{ *:[v4i32] }:$c)
/* 13792*/     /*Scope*/ 22, /*->13815*/
/* 13793*/      OPC_MoveChild0,
/* 13794*/      OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 13797*/      OPC_CheckChild0Same, 1,
/* 13799*/      OPC_MoveChild1,
/* 13800*/      OPC_CheckImmAllOnesV,
/* 13801*/      OPC_MoveParent,
/* 13802*/      OPC_MoveParent,
/* 13803*/      OPC_RecordChild1, // #2 = $v2
/* 13804*/      OPC_MoveParent,
/* 13805*/      OPC_CheckType, MVT::v4i32,
/* 13807*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                    MVT::v4i32, 3/*#Ops*/, 0, 2, 1, 
                // Src: (or:{ *:[v4i32] } (and:{ *:[v4i32] } V128:{ *:[v4i32] }:$v1, V128:{ *:[v4i32] }:$c), (and:{ *:[v4i32] } (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$c, immAllOnesV:{ *:[v4i32] }), V128:{ *:[v4i32] }:$v2)) - Complexity = 16
                // Dst: (BITSELECT:{ *:[v4i32] } ?:{ *:[v4i32] }:$v1, ?:{ *:[v4i32] }:$v2, ?:{ *:[v4i32] }:$c)
/* 13815*/     /*Scope*/ 22, /*->13838*/
/* 13816*/      OPC_RecordChild0, // #2 = $v2
/* 13817*/      OPC_MoveChild1,
/* 13818*/      OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 13821*/      OPC_CheckChild0Same, 1,
/* 13823*/      OPC_MoveChild1,
/* 13824*/      OPC_CheckImmAllOnesV,
/* 13825*/      OPC_MoveParent,
/* 13826*/      OPC_MoveParent,
/* 13827*/      OPC_MoveParent,
/* 13828*/      OPC_CheckType, MVT::v4i32,
/* 13830*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                    MVT::v4i32, 3/*#Ops*/, 0, 2, 1, 
                // Src: (or:{ *:[v4i32] } (and:{ *:[v4i32] } V128:{ *:[v4i32] }:$v1, V128:{ *:[v4i32] }:$c), (and:{ *:[v4i32] } V128:{ *:[v4i32] }:$v2, (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$c, immAllOnesV:{ *:[v4i32] }))) - Complexity = 16
                // Dst: (BITSELECT:{ *:[v4i32] } ?:{ *:[v4i32] }:$v1, ?:{ *:[v4i32] }:$v2, ?:{ *:[v4i32] }:$c)
/* 13838*/     0, /*End of Scope*/
/* 13839*/    0, /*End of Scope*/
/* 13840*/   /*Scope*/ 46, /*->13887*/
/* 13841*/    OPC_MoveChild0,
/* 13842*/    OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 13845*/    OPC_RecordChild0, // #0 = $c
/* 13846*/    OPC_MoveChild1,
/* 13847*/    OPC_CheckImmAllOnesV,
/* 13848*/    OPC_MoveParent,
/* 13849*/    OPC_MoveParent,
/* 13850*/    OPC_RecordChild1, // #1 = $v2
/* 13851*/    OPC_MoveSibling1,
/* 13852*/    OPC_CheckOpcode, TARGET_VAL(ISD::AND),
/* 13855*/    OPC_Scope, 14, /*->13871*/ // 2 children in Scope
/* 13857*/     OPC_CheckChild0Same, 0,
/* 13859*/     OPC_RecordChild1, // #2 = $v1
/* 13860*/     OPC_MoveParent,
/* 13861*/     OPC_CheckType, MVT::v4i32,
/* 13863*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                   MVT::v4i32, 3/*#Ops*/, 2, 1, 0, 
               // Src: (or:{ *:[v4i32] } (and:{ *:[v4i32] } (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$c, immAllOnesV:{ *:[v4i32] }), V128:{ *:[v4i32] }:$v2), (and:{ *:[v4i32] } V128:{ *:[v4i32] }:$c, V128:{ *:[v4i32] }:$v1)) - Complexity = 16
               // Dst: (BITSELECT:{ *:[v4i32] } ?:{ *:[v4i32] }:$v1, ?:{ *:[v4i32] }:$v2, ?:{ *:[v4i32] }:$c)
/* 13871*/    /*Scope*/ 14, /*->13886*/
/* 13872*/     OPC_RecordChild0, // #2 = $v1
/* 13873*/     OPC_CheckChild1Same, 0,
/* 13875*/     OPC_MoveParent,
/* 13876*/     OPC_CheckType, MVT::v4i32,
/* 13878*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                   MVT::v4i32, 3/*#Ops*/, 2, 1, 0, 
               // Src: (or:{ *:[v4i32] } (and:{ *:[v4i32] } (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$c, immAllOnesV:{ *:[v4i32] }), V128:{ *:[v4i32] }:$v2), (and:{ *:[v4i32] } V128:{ *:[v4i32] }:$v1, V128:{ *:[v4i32] }:$c)) - Complexity = 16
               // Dst: (BITSELECT:{ *:[v4i32] } ?:{ *:[v4i32] }:$v1, ?:{ *:[v4i32] }:$v2, ?:{ *:[v4i32] }:$c)
/* 13886*/    0, /*End of Scope*/
/* 13887*/   /*Scope*/ 126, /*->14014*/
/* 13888*/    OPC_RecordChild0, // #0 = $v2
/* 13889*/    OPC_Scope, 45, /*->13936*/ // 2 children in Scope
/* 13891*/     OPC_MoveChild1,
/* 13892*/     OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 13895*/     OPC_RecordChild0, // #1 = $c
/* 13896*/     OPC_MoveChild1,
/* 13897*/     OPC_CheckImmAllOnesV,
/* 13898*/     OPC_MoveParent,
/* 13899*/     OPC_MoveParent,
/* 13900*/     OPC_MoveSibling1,
/* 13901*/     OPC_CheckOpcode, TARGET_VAL(ISD::AND),
/* 13904*/     OPC_Scope, 14, /*->13920*/ // 2 children in Scope
/* 13906*/      OPC_CheckChild0Same, 1,
/* 13908*/      OPC_RecordChild1, // #2 = $v1
/* 13909*/      OPC_MoveParent,
/* 13910*/      OPC_CheckType, MVT::v4i32,
/* 13912*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                    MVT::v4i32, 3/*#Ops*/, 2, 0, 1, 
                // Src: (or:{ *:[v4i32] } (and:{ *:[v4i32] } V128:{ *:[v4i32] }:$v2, (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$c, immAllOnesV:{ *:[v4i32] })), (and:{ *:[v4i32] } V128:{ *:[v4i32] }:$c, V128:{ *:[v4i32] }:$v1)) - Complexity = 16
                // Dst: (BITSELECT:{ *:[v4i32] } ?:{ *:[v4i32] }:$v1, ?:{ *:[v4i32] }:$v2, ?:{ *:[v4i32] }:$c)
/* 13920*/     /*Scope*/ 14, /*->13935*/
/* 13921*/      OPC_RecordChild0, // #2 = $v1
/* 13922*/      OPC_CheckChild1Same, 1,
/* 13924*/      OPC_MoveParent,
/* 13925*/      OPC_CheckType, MVT::v4i32,
/* 13927*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                    MVT::v4i32, 3/*#Ops*/, 2, 0, 1, 
                // Src: (or:{ *:[v4i32] } (and:{ *:[v4i32] } V128:{ *:[v4i32] }:$v2, (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$c, immAllOnesV:{ *:[v4i32] })), (and:{ *:[v4i32] } V128:{ *:[v4i32] }:$v1, V128:{ *:[v4i32] }:$c)) - Complexity = 16
                // Dst: (BITSELECT:{ *:[v4i32] } ?:{ *:[v4i32] }:$v1, ?:{ *:[v4i32] }:$v2, ?:{ *:[v4i32] }:$c)
/* 13935*/     0, /*End of Scope*/
/* 13936*/    /*Scope*/ 76, /*->14013*/
/* 13937*/     OPC_RecordChild1, // #1 = $v1
/* 13938*/     OPC_MoveSibling1,
/* 13939*/     OPC_CheckOpcode, TARGET_VAL(ISD::AND),
/* 13942*/     OPC_Scope, 22, /*->13966*/ // 3 children in Scope
/* 13944*/      OPC_RecordChild0, // #2 = $v2
/* 13945*/      OPC_MoveChild1,
/* 13946*/      OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 13949*/      OPC_CheckChild0Same, 0,
/* 13951*/      OPC_MoveChild1,
/* 13952*/      OPC_CheckImmAllOnesV,
/* 13953*/      OPC_MoveParent,
/* 13954*/      OPC_MoveParent,
/* 13955*/      OPC_MoveParent,
/* 13956*/      OPC_CheckType, MVT::v2i64,
/* 13958*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                    MVT::v2i64, 3/*#Ops*/, 1, 2, 0, 
                // Src: (or:{ *:[v2i64] } (and:{ *:[v2i64] } V128:{ *:[v2i64] }:$c, V128:{ *:[v2i64] }:$v1), (and:{ *:[v2i64] } V128:{ *:[v2i64] }:$v2, (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$c, immAllOnesV:{ *:[v2i64] }))) - Complexity = 16
                // Dst: (BITSELECT:{ *:[v2i64] } ?:{ *:[v2i64] }:$v1, ?:{ *:[v2i64] }:$v2, ?:{ *:[v2i64] }:$c)
/* 13966*/     /*Scope*/ 22, /*->13989*/
/* 13967*/      OPC_MoveChild0,
/* 13968*/      OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 13971*/      OPC_CheckChild0Same, 1,
/* 13973*/      OPC_MoveChild1,
/* 13974*/      OPC_CheckImmAllOnesV,
/* 13975*/      OPC_MoveParent,
/* 13976*/      OPC_MoveParent,
/* 13977*/      OPC_RecordChild1, // #2 = $v2
/* 13978*/      OPC_MoveParent,
/* 13979*/      OPC_CheckType, MVT::v2i64,
/* 13981*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                    MVT::v2i64, 3/*#Ops*/, 0, 2, 1, 
                // Src: (or:{ *:[v2i64] } (and:{ *:[v2i64] } V128:{ *:[v2i64] }:$v1, V128:{ *:[v2i64] }:$c), (and:{ *:[v2i64] } (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$c, immAllOnesV:{ *:[v2i64] }), V128:{ *:[v2i64] }:$v2)) - Complexity = 16
                // Dst: (BITSELECT:{ *:[v2i64] } ?:{ *:[v2i64] }:$v1, ?:{ *:[v2i64] }:$v2, ?:{ *:[v2i64] }:$c)
/* 13989*/     /*Scope*/ 22, /*->14012*/
/* 13990*/      OPC_RecordChild0, // #2 = $v2
/* 13991*/      OPC_MoveChild1,
/* 13992*/      OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 13995*/      OPC_CheckChild0Same, 1,
/* 13997*/      OPC_MoveChild1,
/* 13998*/      OPC_CheckImmAllOnesV,
/* 13999*/      OPC_MoveParent,
/* 14000*/      OPC_MoveParent,
/* 14001*/      OPC_MoveParent,
/* 14002*/      OPC_CheckType, MVT::v2i64,
/* 14004*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                    MVT::v2i64, 3/*#Ops*/, 0, 2, 1, 
                // Src: (or:{ *:[v2i64] } (and:{ *:[v2i64] } V128:{ *:[v2i64] }:$v1, V128:{ *:[v2i64] }:$c), (and:{ *:[v2i64] } V128:{ *:[v2i64] }:$v2, (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$c, immAllOnesV:{ *:[v2i64] }))) - Complexity = 16
                // Dst: (BITSELECT:{ *:[v2i64] } ?:{ *:[v2i64] }:$v1, ?:{ *:[v2i64] }:$v2, ?:{ *:[v2i64] }:$c)
/* 14012*/     0, /*End of Scope*/
/* 14013*/    0, /*End of Scope*/
/* 14014*/   /*Scope*/ 46, /*->14061*/
/* 14015*/    OPC_MoveChild0,
/* 14016*/    OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 14019*/    OPC_RecordChild0, // #0 = $c
/* 14020*/    OPC_MoveChild1,
/* 14021*/    OPC_CheckImmAllOnesV,
/* 14022*/    OPC_MoveParent,
/* 14023*/    OPC_MoveParent,
/* 14024*/    OPC_RecordChild1, // #1 = $v2
/* 14025*/    OPC_MoveSibling1,
/* 14026*/    OPC_CheckOpcode, TARGET_VAL(ISD::AND),
/* 14029*/    OPC_Scope, 14, /*->14045*/ // 2 children in Scope
/* 14031*/     OPC_CheckChild0Same, 0,
/* 14033*/     OPC_RecordChild1, // #2 = $v1
/* 14034*/     OPC_MoveParent,
/* 14035*/     OPC_CheckType, MVT::v2i64,
/* 14037*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                   MVT::v2i64, 3/*#Ops*/, 2, 1, 0, 
               // Src: (or:{ *:[v2i64] } (and:{ *:[v2i64] } (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$c, immAllOnesV:{ *:[v2i64] }), V128:{ *:[v2i64] }:$v2), (and:{ *:[v2i64] } V128:{ *:[v2i64] }:$c, V128:{ *:[v2i64] }:$v1)) - Complexity = 16
               // Dst: (BITSELECT:{ *:[v2i64] } ?:{ *:[v2i64] }:$v1, ?:{ *:[v2i64] }:$v2, ?:{ *:[v2i64] }:$c)
/* 14045*/    /*Scope*/ 14, /*->14060*/
/* 14046*/     OPC_RecordChild0, // #2 = $v1
/* 14047*/     OPC_CheckChild1Same, 0,
/* 14049*/     OPC_MoveParent,
/* 14050*/     OPC_CheckType, MVT::v2i64,
/* 14052*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                   MVT::v2i64, 3/*#Ops*/, 2, 1, 0, 
               // Src: (or:{ *:[v2i64] } (and:{ *:[v2i64] } (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$c, immAllOnesV:{ *:[v2i64] }), V128:{ *:[v2i64] }:$v2), (and:{ *:[v2i64] } V128:{ *:[v2i64] }:$v1, V128:{ *:[v2i64] }:$c)) - Complexity = 16
               // Dst: (BITSELECT:{ *:[v2i64] } ?:{ *:[v2i64] }:$v1, ?:{ *:[v2i64] }:$v2, ?:{ *:[v2i64] }:$c)
/* 14060*/    0, /*End of Scope*/
/* 14061*/   /*Scope*/ 46, /*->14108*/
/* 14062*/    OPC_RecordChild0, // #0 = $v2
/* 14063*/    OPC_MoveChild1,
/* 14064*/    OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 14067*/    OPC_RecordChild0, // #1 = $c
/* 14068*/    OPC_MoveChild1,
/* 14069*/    OPC_CheckImmAllOnesV,
/* 14070*/    OPC_MoveParent,
/* 14071*/    OPC_MoveParent,
/* 14072*/    OPC_MoveSibling1,
/* 14073*/    OPC_CheckOpcode, TARGET_VAL(ISD::AND),
/* 14076*/    OPC_Scope, 14, /*->14092*/ // 2 children in Scope
/* 14078*/     OPC_CheckChild0Same, 1,
/* 14080*/     OPC_RecordChild1, // #2 = $v1
/* 14081*/     OPC_MoveParent,
/* 14082*/     OPC_CheckType, MVT::v2i64,
/* 14084*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                   MVT::v2i64, 3/*#Ops*/, 2, 0, 1, 
               // Src: (or:{ *:[v2i64] } (and:{ *:[v2i64] } V128:{ *:[v2i64] }:$v2, (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$c, immAllOnesV:{ *:[v2i64] })), (and:{ *:[v2i64] } V128:{ *:[v2i64] }:$c, V128:{ *:[v2i64] }:$v1)) - Complexity = 16
               // Dst: (BITSELECT:{ *:[v2i64] } ?:{ *:[v2i64] }:$v1, ?:{ *:[v2i64] }:$v2, ?:{ *:[v2i64] }:$c)
/* 14092*/    /*Scope*/ 14, /*->14107*/
/* 14093*/     OPC_RecordChild0, // #2 = $v1
/* 14094*/     OPC_CheckChild1Same, 1,
/* 14096*/     OPC_MoveParent,
/* 14097*/     OPC_CheckType, MVT::v2i64,
/* 14099*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                   MVT::v2i64, 3/*#Ops*/, 2, 0, 1, 
               // Src: (or:{ *:[v2i64] } (and:{ *:[v2i64] } V128:{ *:[v2i64] }:$v2, (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$c, immAllOnesV:{ *:[v2i64] })), (and:{ *:[v2i64] } V128:{ *:[v2i64] }:$v1, V128:{ *:[v2i64] }:$c)) - Complexity = 16
               // Dst: (BITSELECT:{ *:[v2i64] } ?:{ *:[v2i64] }:$v1, ?:{ *:[v2i64] }:$v2, ?:{ *:[v2i64] }:$c)
/* 14107*/    0, /*End of Scope*/
/* 14108*/   0, /*End of Scope*/
/* 14109*/  /*Scope*/ 40, /*->14150*/
/* 14110*/   OPC_RecordChild0, // #0 = $lhs
/* 14111*/   OPC_RecordChild1, // #1 = $rhs
/* 14112*/   OPC_SwitchType /*4 cases */, 7, MVT::v16i8,// ->14122
/* 14115*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::OR),
                  MVT::v16i8, 2/*#Ops*/, 0, 1, 
              // Src: (or:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs) - Complexity = 3
              // Dst: (OR:{ *:[v16i8] } ?:{ *:[v16i8] }:$lhs, ?:{ *:[v16i8] }:$rhs)
/* 14122*/   /*SwitchType*/ 7, MVT::v8i16,// ->14131
/* 14124*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::OR),
                  MVT::v8i16, 2/*#Ops*/, 0, 1, 
              // Src: (or:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs) - Complexity = 3
              // Dst: (OR:{ *:[v8i16] } ?:{ *:[v8i16] }:$lhs, ?:{ *:[v8i16] }:$rhs)
/* 14131*/   /*SwitchType*/ 7, MVT::v4i32,// ->14140
/* 14133*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::OR),
                  MVT::v4i32, 2/*#Ops*/, 0, 1, 
              // Src: (or:{ *:[v4i32] } V128:{ *:[v4i32] }:$lhs, V128:{ *:[v4i32] }:$rhs) - Complexity = 3
              // Dst: (OR:{ *:[v4i32] } ?:{ *:[v4i32] }:$lhs, ?:{ *:[v4i32] }:$rhs)
/* 14140*/   /*SwitchType*/ 7, MVT::v2i64,// ->14149
/* 14142*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::OR),
                  MVT::v2i64, 2/*#Ops*/, 0, 1, 
              // Src: (or:{ *:[v2i64] } V128:{ *:[v2i64] }:$lhs, V128:{ *:[v2i64] }:$rhs) - Complexity = 3
              // Dst: (OR:{ *:[v2i64] } ?:{ *:[v2i64] }:$lhs, ?:{ *:[v2i64] }:$rhs)
/* 14149*/   0, // EndSwitchType
/* 14150*/  0, /*End of Scope*/
/* 14151*/ /*SwitchOpcode*/ 121|128,11/*1529*/, TARGET_VAL(ISD::XOR),// ->15684
/* 14155*/  OPC_Scope, 22, /*->14179*/ // 17 children in Scope
/* 14157*/   OPC_RecordChild0, // #0 = $lhs
/* 14158*/   OPC_RecordChild1, // #1 = $rhs
/* 14159*/   OPC_SwitchType /*2 cases */, 7, MVT::i32,// ->14169
/* 14162*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::XOR_I32),
                  MVT::i32, 2/*#Ops*/, 0, 1, 
              // Src: (xor:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs) - Complexity = 3
              // Dst: (XOR_I32:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs)
/* 14169*/   /*SwitchType*/ 7, MVT::i64,// ->14178
/* 14171*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::XOR_I64),
                  MVT::i64, 2/*#Ops*/, 0, 1, 
              // Src: (xor:{ *:[i64] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs) - Complexity = 3
              // Dst: (XOR_I64:{ *:[i64] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs)
/* 14178*/   0, // EndSwitchType
/* 14179*/  /*Scope*/ 121, /*->14301*/
/* 14180*/   OPC_MoveChild0,
/* 14181*/   OPC_CheckOpcode, TARGET_VAL(ISD::AND),
/* 14184*/   OPC_MoveChild0,
/* 14185*/   OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 14188*/   OPC_RecordChild0, // #0 = $v1
/* 14189*/   OPC_Scope, 71, /*->14262*/ // 2 children in Scope
/* 14191*/    OPC_RecordChild1, // #1 = $v2
/* 14192*/    OPC_MoveSibling1,
/* 14193*/    OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 14196*/    OPC_RecordChild0, // #2 = $c
/* 14197*/    OPC_MoveChild1,
/* 14198*/    OPC_CheckImmAllOnesV,
/* 14199*/    OPC_MoveParent,
/* 14200*/    OPC_MoveParent,
/* 14201*/    OPC_MoveParent,
/* 14202*/    OPC_Scope, 44, /*->14248*/ // 2 children in Scope
/* 14204*/     OPC_CheckChild1Same, 1,
/* 14206*/     OPC_SwitchType /*4 cases */, 8, MVT::v16i8,// ->14217
/* 14209*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                    MVT::v16i8, 3/*#Ops*/, 1, 0, 2, 
                // Src: (xor:{ *:[v16i8] } (and:{ *:[v16i8] } (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$v1, V128:{ *:[v16i8] }:$v2), (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$c, immAllOnesV:{ *:[v16i8] })), V128:{ *:[v16i8] }:$v2) - Complexity = 16
                // Dst: (BITSELECT:{ *:[v16i8] } ?:{ *:[v16i8] }:$v2, ?:{ *:[v16i8] }:$v1, ?:{ *:[v16i8] }:$c)
/* 14217*/     /*SwitchType*/ 8, MVT::v8i16,// ->14227
/* 14219*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                    MVT::v8i16, 3/*#Ops*/, 1, 0, 2, 
                // Src: (xor:{ *:[v8i16] } (and:{ *:[v8i16] } (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$v1, V128:{ *:[v8i16] }:$v2), (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$c, immAllOnesV:{ *:[v8i16] })), V128:{ *:[v8i16] }:$v2) - Complexity = 16
                // Dst: (BITSELECT:{ *:[v8i16] } ?:{ *:[v8i16] }:$v2, ?:{ *:[v8i16] }:$v1, ?:{ *:[v8i16] }:$c)
/* 14227*/     /*SwitchType*/ 8, MVT::v4i32,// ->14237
/* 14229*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                    MVT::v4i32, 3/*#Ops*/, 1, 0, 2, 
                // Src: (xor:{ *:[v4i32] } (and:{ *:[v4i32] } (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$v1, V128:{ *:[v4i32] }:$v2), (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$c, immAllOnesV:{ *:[v4i32] })), V128:{ *:[v4i32] }:$v2) - Complexity = 16
                // Dst: (BITSELECT:{ *:[v4i32] } ?:{ *:[v4i32] }:$v2, ?:{ *:[v4i32] }:$v1, ?:{ *:[v4i32] }:$c)
/* 14237*/     /*SwitchType*/ 8, MVT::v2i64,// ->14247
/* 14239*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                    MVT::v2i64, 3/*#Ops*/, 1, 0, 2, 
                // Src: (xor:{ *:[v2i64] } (and:{ *:[v2i64] } (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$v1, V128:{ *:[v2i64] }:$v2), (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$c, immAllOnesV:{ *:[v2i64] })), V128:{ *:[v2i64] }:$v2) - Complexity = 16
                // Dst: (BITSELECT:{ *:[v2i64] } ?:{ *:[v2i64] }:$v2, ?:{ *:[v2i64] }:$v1, ?:{ *:[v2i64] }:$c)
/* 14247*/     0, // EndSwitchType
/* 14248*/    /*Scope*/ 12, /*->14261*/
/* 14249*/     OPC_CheckChild1Same, 0,
/* 14251*/     OPC_CheckType, MVT::v16i8,
/* 14253*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                   MVT::v16i8, 3/*#Ops*/, 0, 1, 2, 
               // Src: (xor:{ *:[v16i8] } (and:{ *:[v16i8] } (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$v2, V128:{ *:[v16i8] }:$v1), (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$c, immAllOnesV:{ *:[v16i8] })), V128:{ *:[v16i8] }:$v2) - Complexity = 16
               // Dst: (BITSELECT:{ *:[v16i8] } ?:{ *:[v16i8] }:$v2, ?:{ *:[v16i8] }:$v1, ?:{ *:[v16i8] }:$c)
/* 14261*/    0, /*End of Scope*/
/* 14262*/   /*Scope*/ 37, /*->14300*/
/* 14263*/    OPC_MoveChild1,
/* 14264*/    OPC_CheckImmAllOnesV,
/* 14265*/    OPC_MoveParent,
/* 14266*/    OPC_MoveSibling1,
/* 14267*/    OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 14270*/    OPC_RecordChild0, // #1 = $v1
/* 14271*/    OPC_RecordChild1, // #2 = $v2
/* 14272*/    OPC_MoveParent,
/* 14273*/    OPC_MoveParent,
/* 14274*/    OPC_CheckType, MVT::v16i8,
/* 14276*/    OPC_Scope, 10, /*->14288*/ // 2 children in Scope
/* 14278*/     OPC_CheckChild1Same, 2,
/* 14280*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                   MVT::v16i8, 3/*#Ops*/, 2, 1, 0, 
               // Src: (xor:{ *:[v16i8] } (and:{ *:[v16i8] } (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$c, immAllOnesV:{ *:[v16i8] }), (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$v1, V128:{ *:[v16i8] }:$v2)), V128:{ *:[v16i8] }:$v2) - Complexity = 16
               // Dst: (BITSELECT:{ *:[v16i8] } ?:{ *:[v16i8] }:$v2, ?:{ *:[v16i8] }:$v1, ?:{ *:[v16i8] }:$c)
/* 14288*/    /*Scope*/ 10, /*->14299*/
/* 14289*/     OPC_CheckChild1Same, 1,
/* 14291*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                   MVT::v16i8, 3/*#Ops*/, 1, 2, 0, 
               // Src: (xor:{ *:[v16i8] } (and:{ *:[v16i8] } (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$c, immAllOnesV:{ *:[v16i8] }), (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$v2, V128:{ *:[v16i8] }:$v1)), V128:{ *:[v16i8] }:$v2) - Complexity = 16
               // Dst: (BITSELECT:{ *:[v16i8] } ?:{ *:[v16i8] }:$v2, ?:{ *:[v16i8] }:$v1, ?:{ *:[v16i8] }:$c)
/* 14299*/    0, /*End of Scope*/
/* 14300*/   0, /*End of Scope*/
/* 14301*/  /*Scope*/ 102, /*->14404*/
/* 14302*/   OPC_RecordChild0, // #0 = $v2
/* 14303*/   OPC_MoveChild1,
/* 14304*/   OPC_CheckOpcode, TARGET_VAL(ISD::AND),
/* 14307*/   OPC_MoveChild0,
/* 14308*/   OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 14311*/   OPC_Scope, 23, /*->14336*/ // 3 children in Scope
/* 14313*/    OPC_RecordChild0, // #1 = $v1
/* 14314*/    OPC_CheckChild1Same, 0,
/* 14316*/    OPC_MoveSibling1,
/* 14317*/    OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 14320*/    OPC_RecordChild0, // #2 = $c
/* 14321*/    OPC_MoveChild1,
/* 14322*/    OPC_CheckImmAllOnesV,
/* 14323*/    OPC_MoveParent,
/* 14324*/    OPC_MoveParent,
/* 14325*/    OPC_MoveParent,
/* 14326*/    OPC_CheckType, MVT::v16i8,
/* 14328*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                  MVT::v16i8, 3/*#Ops*/, 0, 1, 2, 
              // Src: (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$v2, (and:{ *:[v16i8] } (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$v1, V128:{ *:[v16i8] }:$v2), (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$c, immAllOnesV:{ *:[v16i8] }))) - Complexity = 16
              // Dst: (BITSELECT:{ *:[v16i8] } ?:{ *:[v16i8] }:$v2, ?:{ *:[v16i8] }:$v1, ?:{ *:[v16i8] }:$c)
/* 14336*/   /*Scope*/ 23, /*->14360*/
/* 14337*/    OPC_CheckChild0Same, 0,
/* 14339*/    OPC_RecordChild1, // #1 = $v1
/* 14340*/    OPC_MoveSibling1,
/* 14341*/    OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 14344*/    OPC_RecordChild0, // #2 = $c
/* 14345*/    OPC_MoveChild1,
/* 14346*/    OPC_CheckImmAllOnesV,
/* 14347*/    OPC_MoveParent,
/* 14348*/    OPC_MoveParent,
/* 14349*/    OPC_MoveParent,
/* 14350*/    OPC_CheckType, MVT::v16i8,
/* 14352*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                  MVT::v16i8, 3/*#Ops*/, 0, 1, 2, 
              // Src: (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$v2, (and:{ *:[v16i8] } (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$v2, V128:{ *:[v16i8] }:$v1), (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$c, immAllOnesV:{ *:[v16i8] }))) - Complexity = 16
              // Dst: (BITSELECT:{ *:[v16i8] } ?:{ *:[v16i8] }:$v2, ?:{ *:[v16i8] }:$v1, ?:{ *:[v16i8] }:$c)
/* 14360*/   /*Scope*/ 42, /*->14403*/
/* 14361*/    OPC_RecordChild0, // #1 = $c
/* 14362*/    OPC_MoveChild1,
/* 14363*/    OPC_CheckImmAllOnesV,
/* 14364*/    OPC_MoveParent,
/* 14365*/    OPC_MoveSibling1,
/* 14366*/    OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 14369*/    OPC_Scope, 15, /*->14386*/ // 2 children in Scope
/* 14371*/     OPC_RecordChild0, // #2 = $v1
/* 14372*/     OPC_CheckChild1Same, 0,
/* 14374*/     OPC_MoveParent,
/* 14375*/     OPC_MoveParent,
/* 14376*/     OPC_CheckType, MVT::v16i8,
/* 14378*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                   MVT::v16i8, 3/*#Ops*/, 0, 2, 1, 
               // Src: (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$v2, (and:{ *:[v16i8] } (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$c, immAllOnesV:{ *:[v16i8] }), (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$v1, V128:{ *:[v16i8] }:$v2))) - Complexity = 16
               // Dst: (BITSELECT:{ *:[v16i8] } ?:{ *:[v16i8] }:$v2, ?:{ *:[v16i8] }:$v1, ?:{ *:[v16i8] }:$c)
/* 14386*/    /*Scope*/ 15, /*->14402*/
/* 14387*/     OPC_CheckChild0Same, 0,
/* 14389*/     OPC_RecordChild1, // #2 = $v1
/* 14390*/     OPC_MoveParent,
/* 14391*/     OPC_MoveParent,
/* 14392*/     OPC_CheckType, MVT::v16i8,
/* 14394*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                   MVT::v16i8, 3/*#Ops*/, 0, 2, 1, 
               // Src: (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$v2, (and:{ *:[v16i8] } (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$c, immAllOnesV:{ *:[v16i8] }), (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$v2, V128:{ *:[v16i8] }:$v1))) - Complexity = 16
               // Dst: (BITSELECT:{ *:[v16i8] } ?:{ *:[v16i8] }:$v2, ?:{ *:[v16i8] }:$v1, ?:{ *:[v16i8] }:$c)
/* 14402*/    0, /*End of Scope*/
/* 14403*/   0, /*End of Scope*/
/* 14404*/  /*Scope*/ 73, /*->14478*/
/* 14405*/   OPC_MoveChild0,
/* 14406*/   OPC_CheckOpcode, TARGET_VAL(ISD::AND),
/* 14409*/   OPC_MoveChild0,
/* 14410*/   OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 14413*/   OPC_RecordChild0, // #0 = $v2
/* 14414*/   OPC_Scope, 23, /*->14439*/ // 2 children in Scope
/* 14416*/    OPC_RecordChild1, // #1 = $v1
/* 14417*/    OPC_MoveSibling1,
/* 14418*/    OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 14421*/    OPC_RecordChild0, // #2 = $c
/* 14422*/    OPC_MoveChild1,
/* 14423*/    OPC_CheckImmAllOnesV,
/* 14424*/    OPC_MoveParent,
/* 14425*/    OPC_MoveParent,
/* 14426*/    OPC_MoveParent,
/* 14427*/    OPC_CheckChild1Same, 0,
/* 14429*/    OPC_CheckType, MVT::v8i16,
/* 14431*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                  MVT::v8i16, 3/*#Ops*/, 0, 1, 2, 
              // Src: (xor:{ *:[v8i16] } (and:{ *:[v8i16] } (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$v2, V128:{ *:[v8i16] }:$v1), (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$c, immAllOnesV:{ *:[v8i16] })), V128:{ *:[v8i16] }:$v2) - Complexity = 16
              // Dst: (BITSELECT:{ *:[v8i16] } ?:{ *:[v8i16] }:$v2, ?:{ *:[v8i16] }:$v1, ?:{ *:[v8i16] }:$c)
/* 14439*/   /*Scope*/ 37, /*->14477*/
/* 14440*/    OPC_MoveChild1,
/* 14441*/    OPC_CheckImmAllOnesV,
/* 14442*/    OPC_MoveParent,
/* 14443*/    OPC_MoveSibling1,
/* 14444*/    OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 14447*/    OPC_RecordChild0, // #1 = $v1
/* 14448*/    OPC_RecordChild1, // #2 = $v2
/* 14449*/    OPC_MoveParent,
/* 14450*/    OPC_MoveParent,
/* 14451*/    OPC_CheckType, MVT::v8i16,
/* 14453*/    OPC_Scope, 10, /*->14465*/ // 2 children in Scope
/* 14455*/     OPC_CheckChild1Same, 2,
/* 14457*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                   MVT::v8i16, 3/*#Ops*/, 2, 1, 0, 
               // Src: (xor:{ *:[v8i16] } (and:{ *:[v8i16] } (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$c, immAllOnesV:{ *:[v8i16] }), (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$v1, V128:{ *:[v8i16] }:$v2)), V128:{ *:[v8i16] }:$v2) - Complexity = 16
               // Dst: (BITSELECT:{ *:[v8i16] } ?:{ *:[v8i16] }:$v2, ?:{ *:[v8i16] }:$v1, ?:{ *:[v8i16] }:$c)
/* 14465*/    /*Scope*/ 10, /*->14476*/
/* 14466*/     OPC_CheckChild1Same, 1,
/* 14468*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                   MVT::v8i16, 3/*#Ops*/, 1, 2, 0, 
               // Src: (xor:{ *:[v8i16] } (and:{ *:[v8i16] } (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$c, immAllOnesV:{ *:[v8i16] }), (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$v2, V128:{ *:[v8i16] }:$v1)), V128:{ *:[v8i16] }:$v2) - Complexity = 16
               // Dst: (BITSELECT:{ *:[v8i16] } ?:{ *:[v8i16] }:$v2, ?:{ *:[v8i16] }:$v1, ?:{ *:[v8i16] }:$c)
/* 14476*/    0, /*End of Scope*/
/* 14477*/   0, /*End of Scope*/
/* 14478*/  /*Scope*/ 102, /*->14581*/
/* 14479*/   OPC_RecordChild0, // #0 = $v2
/* 14480*/   OPC_MoveChild1,
/* 14481*/   OPC_CheckOpcode, TARGET_VAL(ISD::AND),
/* 14484*/   OPC_MoveChild0,
/* 14485*/   OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 14488*/   OPC_Scope, 23, /*->14513*/ // 3 children in Scope
/* 14490*/    OPC_RecordChild0, // #1 = $v1
/* 14491*/    OPC_CheckChild1Same, 0,
/* 14493*/    OPC_MoveSibling1,
/* 14494*/    OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 14497*/    OPC_RecordChild0, // #2 = $c
/* 14498*/    OPC_MoveChild1,
/* 14499*/    OPC_CheckImmAllOnesV,
/* 14500*/    OPC_MoveParent,
/* 14501*/    OPC_MoveParent,
/* 14502*/    OPC_MoveParent,
/* 14503*/    OPC_CheckType, MVT::v8i16,
/* 14505*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                  MVT::v8i16, 3/*#Ops*/, 0, 1, 2, 
              // Src: (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$v2, (and:{ *:[v8i16] } (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$v1, V128:{ *:[v8i16] }:$v2), (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$c, immAllOnesV:{ *:[v8i16] }))) - Complexity = 16
              // Dst: (BITSELECT:{ *:[v8i16] } ?:{ *:[v8i16] }:$v2, ?:{ *:[v8i16] }:$v1, ?:{ *:[v8i16] }:$c)
/* 14513*/   /*Scope*/ 23, /*->14537*/
/* 14514*/    OPC_CheckChild0Same, 0,
/* 14516*/    OPC_RecordChild1, // #1 = $v1
/* 14517*/    OPC_MoveSibling1,
/* 14518*/    OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 14521*/    OPC_RecordChild0, // #2 = $c
/* 14522*/    OPC_MoveChild1,
/* 14523*/    OPC_CheckImmAllOnesV,
/* 14524*/    OPC_MoveParent,
/* 14525*/    OPC_MoveParent,
/* 14526*/    OPC_MoveParent,
/* 14527*/    OPC_CheckType, MVT::v8i16,
/* 14529*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                  MVT::v8i16, 3/*#Ops*/, 0, 1, 2, 
              // Src: (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$v2, (and:{ *:[v8i16] } (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$v2, V128:{ *:[v8i16] }:$v1), (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$c, immAllOnesV:{ *:[v8i16] }))) - Complexity = 16
              // Dst: (BITSELECT:{ *:[v8i16] } ?:{ *:[v8i16] }:$v2, ?:{ *:[v8i16] }:$v1, ?:{ *:[v8i16] }:$c)
/* 14537*/   /*Scope*/ 42, /*->14580*/
/* 14538*/    OPC_RecordChild0, // #1 = $c
/* 14539*/    OPC_MoveChild1,
/* 14540*/    OPC_CheckImmAllOnesV,
/* 14541*/    OPC_MoveParent,
/* 14542*/    OPC_MoveSibling1,
/* 14543*/    OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 14546*/    OPC_Scope, 15, /*->14563*/ // 2 children in Scope
/* 14548*/     OPC_RecordChild0, // #2 = $v1
/* 14549*/     OPC_CheckChild1Same, 0,
/* 14551*/     OPC_MoveParent,
/* 14552*/     OPC_MoveParent,
/* 14553*/     OPC_CheckType, MVT::v8i16,
/* 14555*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                   MVT::v8i16, 3/*#Ops*/, 0, 2, 1, 
               // Src: (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$v2, (and:{ *:[v8i16] } (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$c, immAllOnesV:{ *:[v8i16] }), (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$v1, V128:{ *:[v8i16] }:$v2))) - Complexity = 16
               // Dst: (BITSELECT:{ *:[v8i16] } ?:{ *:[v8i16] }:$v2, ?:{ *:[v8i16] }:$v1, ?:{ *:[v8i16] }:$c)
/* 14563*/    /*Scope*/ 15, /*->14579*/
/* 14564*/     OPC_CheckChild0Same, 0,
/* 14566*/     OPC_RecordChild1, // #2 = $v1
/* 14567*/     OPC_MoveParent,
/* 14568*/     OPC_MoveParent,
/* 14569*/     OPC_CheckType, MVT::v8i16,
/* 14571*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                   MVT::v8i16, 3/*#Ops*/, 0, 2, 1, 
               // Src: (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$v2, (and:{ *:[v8i16] } (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$c, immAllOnesV:{ *:[v8i16] }), (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$v2, V128:{ *:[v8i16] }:$v1))) - Complexity = 16
               // Dst: (BITSELECT:{ *:[v8i16] } ?:{ *:[v8i16] }:$v2, ?:{ *:[v8i16] }:$v1, ?:{ *:[v8i16] }:$c)
/* 14579*/    0, /*End of Scope*/
/* 14580*/   0, /*End of Scope*/
/* 14581*/  /*Scope*/ 73, /*->14655*/
/* 14582*/   OPC_MoveChild0,
/* 14583*/   OPC_CheckOpcode, TARGET_VAL(ISD::AND),
/* 14586*/   OPC_MoveChild0,
/* 14587*/   OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 14590*/   OPC_RecordChild0, // #0 = $v2
/* 14591*/   OPC_Scope, 23, /*->14616*/ // 2 children in Scope
/* 14593*/    OPC_RecordChild1, // #1 = $v1
/* 14594*/    OPC_MoveSibling1,
/* 14595*/    OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 14598*/    OPC_RecordChild0, // #2 = $c
/* 14599*/    OPC_MoveChild1,
/* 14600*/    OPC_CheckImmAllOnesV,
/* 14601*/    OPC_MoveParent,
/* 14602*/    OPC_MoveParent,
/* 14603*/    OPC_MoveParent,
/* 14604*/    OPC_CheckChild1Same, 0,
/* 14606*/    OPC_CheckType, MVT::v4i32,
/* 14608*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                  MVT::v4i32, 3/*#Ops*/, 0, 1, 2, 
              // Src: (xor:{ *:[v4i32] } (and:{ *:[v4i32] } (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$v2, V128:{ *:[v4i32] }:$v1), (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$c, immAllOnesV:{ *:[v4i32] })), V128:{ *:[v4i32] }:$v2) - Complexity = 16
              // Dst: (BITSELECT:{ *:[v4i32] } ?:{ *:[v4i32] }:$v2, ?:{ *:[v4i32] }:$v1, ?:{ *:[v4i32] }:$c)
/* 14616*/   /*Scope*/ 37, /*->14654*/
/* 14617*/    OPC_MoveChild1,
/* 14618*/    OPC_CheckImmAllOnesV,
/* 14619*/    OPC_MoveParent,
/* 14620*/    OPC_MoveSibling1,
/* 14621*/    OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 14624*/    OPC_RecordChild0, // #1 = $v1
/* 14625*/    OPC_RecordChild1, // #2 = $v2
/* 14626*/    OPC_MoveParent,
/* 14627*/    OPC_MoveParent,
/* 14628*/    OPC_CheckType, MVT::v4i32,
/* 14630*/    OPC_Scope, 10, /*->14642*/ // 2 children in Scope
/* 14632*/     OPC_CheckChild1Same, 2,
/* 14634*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                   MVT::v4i32, 3/*#Ops*/, 2, 1, 0, 
               // Src: (xor:{ *:[v4i32] } (and:{ *:[v4i32] } (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$c, immAllOnesV:{ *:[v4i32] }), (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$v1, V128:{ *:[v4i32] }:$v2)), V128:{ *:[v4i32] }:$v2) - Complexity = 16
               // Dst: (BITSELECT:{ *:[v4i32] } ?:{ *:[v4i32] }:$v2, ?:{ *:[v4i32] }:$v1, ?:{ *:[v4i32] }:$c)
/* 14642*/    /*Scope*/ 10, /*->14653*/
/* 14643*/     OPC_CheckChild1Same, 1,
/* 14645*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                   MVT::v4i32, 3/*#Ops*/, 1, 2, 0, 
               // Src: (xor:{ *:[v4i32] } (and:{ *:[v4i32] } (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$c, immAllOnesV:{ *:[v4i32] }), (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$v2, V128:{ *:[v4i32] }:$v1)), V128:{ *:[v4i32] }:$v2) - Complexity = 16
               // Dst: (BITSELECT:{ *:[v4i32] } ?:{ *:[v4i32] }:$v2, ?:{ *:[v4i32] }:$v1, ?:{ *:[v4i32] }:$c)
/* 14653*/    0, /*End of Scope*/
/* 14654*/   0, /*End of Scope*/
/* 14655*/  /*Scope*/ 102, /*->14758*/
/* 14656*/   OPC_RecordChild0, // #0 = $v2
/* 14657*/   OPC_MoveChild1,
/* 14658*/   OPC_CheckOpcode, TARGET_VAL(ISD::AND),
/* 14661*/   OPC_MoveChild0,
/* 14662*/   OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 14665*/   OPC_Scope, 23, /*->14690*/ // 3 children in Scope
/* 14667*/    OPC_RecordChild0, // #1 = $v1
/* 14668*/    OPC_CheckChild1Same, 0,
/* 14670*/    OPC_MoveSibling1,
/* 14671*/    OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 14674*/    OPC_RecordChild0, // #2 = $c
/* 14675*/    OPC_MoveChild1,
/* 14676*/    OPC_CheckImmAllOnesV,
/* 14677*/    OPC_MoveParent,
/* 14678*/    OPC_MoveParent,
/* 14679*/    OPC_MoveParent,
/* 14680*/    OPC_CheckType, MVT::v4i32,
/* 14682*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                  MVT::v4i32, 3/*#Ops*/, 0, 1, 2, 
              // Src: (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$v2, (and:{ *:[v4i32] } (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$v1, V128:{ *:[v4i32] }:$v2), (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$c, immAllOnesV:{ *:[v4i32] }))) - Complexity = 16
              // Dst: (BITSELECT:{ *:[v4i32] } ?:{ *:[v4i32] }:$v2, ?:{ *:[v4i32] }:$v1, ?:{ *:[v4i32] }:$c)
/* 14690*/   /*Scope*/ 23, /*->14714*/
/* 14691*/    OPC_CheckChild0Same, 0,
/* 14693*/    OPC_RecordChild1, // #1 = $v1
/* 14694*/    OPC_MoveSibling1,
/* 14695*/    OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 14698*/    OPC_RecordChild0, // #2 = $c
/* 14699*/    OPC_MoveChild1,
/* 14700*/    OPC_CheckImmAllOnesV,
/* 14701*/    OPC_MoveParent,
/* 14702*/    OPC_MoveParent,
/* 14703*/    OPC_MoveParent,
/* 14704*/    OPC_CheckType, MVT::v4i32,
/* 14706*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                  MVT::v4i32, 3/*#Ops*/, 0, 1, 2, 
              // Src: (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$v2, (and:{ *:[v4i32] } (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$v2, V128:{ *:[v4i32] }:$v1), (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$c, immAllOnesV:{ *:[v4i32] }))) - Complexity = 16
              // Dst: (BITSELECT:{ *:[v4i32] } ?:{ *:[v4i32] }:$v2, ?:{ *:[v4i32] }:$v1, ?:{ *:[v4i32] }:$c)
/* 14714*/   /*Scope*/ 42, /*->14757*/
/* 14715*/    OPC_RecordChild0, // #1 = $c
/* 14716*/    OPC_MoveChild1,
/* 14717*/    OPC_CheckImmAllOnesV,
/* 14718*/    OPC_MoveParent,
/* 14719*/    OPC_MoveSibling1,
/* 14720*/    OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 14723*/    OPC_Scope, 15, /*->14740*/ // 2 children in Scope
/* 14725*/     OPC_RecordChild0, // #2 = $v1
/* 14726*/     OPC_CheckChild1Same, 0,
/* 14728*/     OPC_MoveParent,
/* 14729*/     OPC_MoveParent,
/* 14730*/     OPC_CheckType, MVT::v4i32,
/* 14732*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                   MVT::v4i32, 3/*#Ops*/, 0, 2, 1, 
               // Src: (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$v2, (and:{ *:[v4i32] } (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$c, immAllOnesV:{ *:[v4i32] }), (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$v1, V128:{ *:[v4i32] }:$v2))) - Complexity = 16
               // Dst: (BITSELECT:{ *:[v4i32] } ?:{ *:[v4i32] }:$v2, ?:{ *:[v4i32] }:$v1, ?:{ *:[v4i32] }:$c)
/* 14740*/    /*Scope*/ 15, /*->14756*/
/* 14741*/     OPC_CheckChild0Same, 0,
/* 14743*/     OPC_RecordChild1, // #2 = $v1
/* 14744*/     OPC_MoveParent,
/* 14745*/     OPC_MoveParent,
/* 14746*/     OPC_CheckType, MVT::v4i32,
/* 14748*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                   MVT::v4i32, 3/*#Ops*/, 0, 2, 1, 
               // Src: (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$v2, (and:{ *:[v4i32] } (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$c, immAllOnesV:{ *:[v4i32] }), (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$v2, V128:{ *:[v4i32] }:$v1))) - Complexity = 16
               // Dst: (BITSELECT:{ *:[v4i32] } ?:{ *:[v4i32] }:$v2, ?:{ *:[v4i32] }:$v1, ?:{ *:[v4i32] }:$c)
/* 14756*/    0, /*End of Scope*/
/* 14757*/   0, /*End of Scope*/
/* 14758*/  /*Scope*/ 73, /*->14832*/
/* 14759*/   OPC_MoveChild0,
/* 14760*/   OPC_CheckOpcode, TARGET_VAL(ISD::AND),
/* 14763*/   OPC_MoveChild0,
/* 14764*/   OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 14767*/   OPC_RecordChild0, // #0 = $v2
/* 14768*/   OPC_Scope, 23, /*->14793*/ // 2 children in Scope
/* 14770*/    OPC_RecordChild1, // #1 = $v1
/* 14771*/    OPC_MoveSibling1,
/* 14772*/    OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 14775*/    OPC_RecordChild0, // #2 = $c
/* 14776*/    OPC_MoveChild1,
/* 14777*/    OPC_CheckImmAllOnesV,
/* 14778*/    OPC_MoveParent,
/* 14779*/    OPC_MoveParent,
/* 14780*/    OPC_MoveParent,
/* 14781*/    OPC_CheckChild1Same, 0,
/* 14783*/    OPC_CheckType, MVT::v2i64,
/* 14785*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                  MVT::v2i64, 3/*#Ops*/, 0, 1, 2, 
              // Src: (xor:{ *:[v2i64] } (and:{ *:[v2i64] } (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$v2, V128:{ *:[v2i64] }:$v1), (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$c, immAllOnesV:{ *:[v2i64] })), V128:{ *:[v2i64] }:$v2) - Complexity = 16
              // Dst: (BITSELECT:{ *:[v2i64] } ?:{ *:[v2i64] }:$v2, ?:{ *:[v2i64] }:$v1, ?:{ *:[v2i64] }:$c)
/* 14793*/   /*Scope*/ 37, /*->14831*/
/* 14794*/    OPC_MoveChild1,
/* 14795*/    OPC_CheckImmAllOnesV,
/* 14796*/    OPC_MoveParent,
/* 14797*/    OPC_MoveSibling1,
/* 14798*/    OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 14801*/    OPC_RecordChild0, // #1 = $v1
/* 14802*/    OPC_RecordChild1, // #2 = $v2
/* 14803*/    OPC_MoveParent,
/* 14804*/    OPC_MoveParent,
/* 14805*/    OPC_CheckType, MVT::v2i64,
/* 14807*/    OPC_Scope, 10, /*->14819*/ // 2 children in Scope
/* 14809*/     OPC_CheckChild1Same, 2,
/* 14811*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                   MVT::v2i64, 3/*#Ops*/, 2, 1, 0, 
               // Src: (xor:{ *:[v2i64] } (and:{ *:[v2i64] } (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$c, immAllOnesV:{ *:[v2i64] }), (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$v1, V128:{ *:[v2i64] }:$v2)), V128:{ *:[v2i64] }:$v2) - Complexity = 16
               // Dst: (BITSELECT:{ *:[v2i64] } ?:{ *:[v2i64] }:$v2, ?:{ *:[v2i64] }:$v1, ?:{ *:[v2i64] }:$c)
/* 14819*/    /*Scope*/ 10, /*->14830*/
/* 14820*/     OPC_CheckChild1Same, 1,
/* 14822*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                   MVT::v2i64, 3/*#Ops*/, 1, 2, 0, 
               // Src: (xor:{ *:[v2i64] } (and:{ *:[v2i64] } (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$c, immAllOnesV:{ *:[v2i64] }), (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$v2, V128:{ *:[v2i64] }:$v1)), V128:{ *:[v2i64] }:$v2) - Complexity = 16
               // Dst: (BITSELECT:{ *:[v2i64] } ?:{ *:[v2i64] }:$v2, ?:{ *:[v2i64] }:$v1, ?:{ *:[v2i64] }:$c)
/* 14830*/    0, /*End of Scope*/
/* 14831*/   0, /*End of Scope*/
/* 14832*/  /*Scope*/ 102, /*->14935*/
/* 14833*/   OPC_RecordChild0, // #0 = $v2
/* 14834*/   OPC_MoveChild1,
/* 14835*/   OPC_CheckOpcode, TARGET_VAL(ISD::AND),
/* 14838*/   OPC_MoveChild0,
/* 14839*/   OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 14842*/   OPC_Scope, 23, /*->14867*/ // 3 children in Scope
/* 14844*/    OPC_RecordChild0, // #1 = $v1
/* 14845*/    OPC_CheckChild1Same, 0,
/* 14847*/    OPC_MoveSibling1,
/* 14848*/    OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 14851*/    OPC_RecordChild0, // #2 = $c
/* 14852*/    OPC_MoveChild1,
/* 14853*/    OPC_CheckImmAllOnesV,
/* 14854*/    OPC_MoveParent,
/* 14855*/    OPC_MoveParent,
/* 14856*/    OPC_MoveParent,
/* 14857*/    OPC_CheckType, MVT::v2i64,
/* 14859*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                  MVT::v2i64, 3/*#Ops*/, 0, 1, 2, 
              // Src: (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$v2, (and:{ *:[v2i64] } (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$v1, V128:{ *:[v2i64] }:$v2), (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$c, immAllOnesV:{ *:[v2i64] }))) - Complexity = 16
              // Dst: (BITSELECT:{ *:[v2i64] } ?:{ *:[v2i64] }:$v2, ?:{ *:[v2i64] }:$v1, ?:{ *:[v2i64] }:$c)
/* 14867*/   /*Scope*/ 23, /*->14891*/
/* 14868*/    OPC_CheckChild0Same, 0,
/* 14870*/    OPC_RecordChild1, // #1 = $v1
/* 14871*/    OPC_MoveSibling1,
/* 14872*/    OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 14875*/    OPC_RecordChild0, // #2 = $c
/* 14876*/    OPC_MoveChild1,
/* 14877*/    OPC_CheckImmAllOnesV,
/* 14878*/    OPC_MoveParent,
/* 14879*/    OPC_MoveParent,
/* 14880*/    OPC_MoveParent,
/* 14881*/    OPC_CheckType, MVT::v2i64,
/* 14883*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                  MVT::v2i64, 3/*#Ops*/, 0, 1, 2, 
              // Src: (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$v2, (and:{ *:[v2i64] } (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$v2, V128:{ *:[v2i64] }:$v1), (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$c, immAllOnesV:{ *:[v2i64] }))) - Complexity = 16
              // Dst: (BITSELECT:{ *:[v2i64] } ?:{ *:[v2i64] }:$v2, ?:{ *:[v2i64] }:$v1, ?:{ *:[v2i64] }:$c)
/* 14891*/   /*Scope*/ 42, /*->14934*/
/* 14892*/    OPC_RecordChild0, // #1 = $c
/* 14893*/    OPC_MoveChild1,
/* 14894*/    OPC_CheckImmAllOnesV,
/* 14895*/    OPC_MoveParent,
/* 14896*/    OPC_MoveSibling1,
/* 14897*/    OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 14900*/    OPC_Scope, 15, /*->14917*/ // 2 children in Scope
/* 14902*/     OPC_RecordChild0, // #2 = $v1
/* 14903*/     OPC_CheckChild1Same, 0,
/* 14905*/     OPC_MoveParent,
/* 14906*/     OPC_MoveParent,
/* 14907*/     OPC_CheckType, MVT::v2i64,
/* 14909*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                   MVT::v2i64, 3/*#Ops*/, 0, 2, 1, 
               // Src: (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$v2, (and:{ *:[v2i64] } (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$c, immAllOnesV:{ *:[v2i64] }), (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$v1, V128:{ *:[v2i64] }:$v2))) - Complexity = 16
               // Dst: (BITSELECT:{ *:[v2i64] } ?:{ *:[v2i64] }:$v2, ?:{ *:[v2i64] }:$v1, ?:{ *:[v2i64] }:$c)
/* 14917*/    /*Scope*/ 15, /*->14933*/
/* 14918*/     OPC_CheckChild0Same, 0,
/* 14920*/     OPC_RecordChild1, // #2 = $v1
/* 14921*/     OPC_MoveParent,
/* 14922*/     OPC_MoveParent,
/* 14923*/     OPC_CheckType, MVT::v2i64,
/* 14925*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                   MVT::v2i64, 3/*#Ops*/, 0, 2, 1, 
               // Src: (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$v2, (and:{ *:[v2i64] } (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$c, immAllOnesV:{ *:[v2i64] }), (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$v2, V128:{ *:[v2i64] }:$v1))) - Complexity = 16
               // Dst: (BITSELECT:{ *:[v2i64] } ?:{ *:[v2i64] }:$v2, ?:{ *:[v2i64] }:$v1, ?:{ *:[v2i64] }:$c)
/* 14933*/    0, /*End of Scope*/
/* 14934*/   0, /*End of Scope*/
/* 14935*/  /*Scope*/ 112, /*->15048*/
/* 14936*/   OPC_MoveChild0,
/* 14937*/   OPC_CheckOpcode, TARGET_VAL(ISD::AND),
/* 14940*/   OPC_Scope, 69, /*->15011*/ // 2 children in Scope
/* 14942*/    OPC_MoveChild0,
/* 14943*/    OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 14946*/    OPC_RecordChild0, // #0 = $v1
/* 14947*/    OPC_RecordChild1, // #1 = $v2
/* 14948*/    OPC_MoveParent,
/* 14949*/    OPC_RecordChild1, // #2 = $c
/* 14950*/    OPC_MoveParent,
/* 14951*/    OPC_Scope, 44, /*->14997*/ // 2 children in Scope
/* 14953*/     OPC_CheckChild1Same, 1,
/* 14955*/     OPC_SwitchType /*4 cases */, 8, MVT::v16i8,// ->14966
/* 14958*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                    MVT::v16i8, 3/*#Ops*/, 0, 1, 2, 
                // Src: (xor:{ *:[v16i8] } (and:{ *:[v16i8] } (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$v1, V128:{ *:[v16i8] }:$v2), V128:{ *:[v16i8] }:$c), V128:{ *:[v16i8] }:$v2) - Complexity = 9
                // Dst: (BITSELECT:{ *:[v16i8] } ?:{ *:[v16i8] }:$v1, ?:{ *:[v16i8] }:$v2, ?:{ *:[v16i8] }:$c)
/* 14966*/     /*SwitchType*/ 8, MVT::v8i16,// ->14976
/* 14968*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                    MVT::v8i16, 3/*#Ops*/, 0, 1, 2, 
                // Src: (xor:{ *:[v8i16] } (and:{ *:[v8i16] } (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$v1, V128:{ *:[v8i16] }:$v2), V128:{ *:[v8i16] }:$c), V128:{ *:[v8i16] }:$v2) - Complexity = 9
                // Dst: (BITSELECT:{ *:[v8i16] } ?:{ *:[v8i16] }:$v1, ?:{ *:[v8i16] }:$v2, ?:{ *:[v8i16] }:$c)
/* 14976*/     /*SwitchType*/ 8, MVT::v4i32,// ->14986
/* 14978*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                    MVT::v4i32, 3/*#Ops*/, 0, 1, 2, 
                // Src: (xor:{ *:[v4i32] } (and:{ *:[v4i32] } (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$v1, V128:{ *:[v4i32] }:$v2), V128:{ *:[v4i32] }:$c), V128:{ *:[v4i32] }:$v2) - Complexity = 9
                // Dst: (BITSELECT:{ *:[v4i32] } ?:{ *:[v4i32] }:$v1, ?:{ *:[v4i32] }:$v2, ?:{ *:[v4i32] }:$c)
/* 14986*/     /*SwitchType*/ 8, MVT::v2i64,// ->14996
/* 14988*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                    MVT::v2i64, 3/*#Ops*/, 0, 1, 2, 
                // Src: (xor:{ *:[v2i64] } (and:{ *:[v2i64] } (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$v1, V128:{ *:[v2i64] }:$v2), V128:{ *:[v2i64] }:$c), V128:{ *:[v2i64] }:$v2) - Complexity = 9
                // Dst: (BITSELECT:{ *:[v2i64] } ?:{ *:[v2i64] }:$v1, ?:{ *:[v2i64] }:$v2, ?:{ *:[v2i64] }:$c)
/* 14996*/     0, // EndSwitchType
/* 14997*/    /*Scope*/ 12, /*->15010*/
/* 14998*/     OPC_CheckChild1Same, 0,
/* 15000*/     OPC_CheckType, MVT::v16i8,
/* 15002*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                   MVT::v16i8, 3/*#Ops*/, 1, 0, 2, 
               // Src: (xor:{ *:[v16i8] } (and:{ *:[v16i8] } (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$v2, V128:{ *:[v16i8] }:$v1), V128:{ *:[v16i8] }:$c), V128:{ *:[v16i8] }:$v2) - Complexity = 9
               // Dst: (BITSELECT:{ *:[v16i8] } ?:{ *:[v16i8] }:$v1, ?:{ *:[v16i8] }:$v2, ?:{ *:[v16i8] }:$c)
/* 15010*/    0, /*End of Scope*/
/* 15011*/   /*Scope*/ 35, /*->15047*/
/* 15012*/    OPC_RecordChild0, // #0 = $c
/* 15013*/    OPC_MoveChild1,
/* 15014*/    OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 15017*/    OPC_RecordChild0, // #1 = $v1
/* 15018*/    OPC_RecordChild1, // #2 = $v2
/* 15019*/    OPC_MoveParent,
/* 15020*/    OPC_MoveParent,
/* 15021*/    OPC_CheckType, MVT::v16i8,
/* 15023*/    OPC_Scope, 10, /*->15035*/ // 2 children in Scope
/* 15025*/     OPC_CheckChild1Same, 2,
/* 15027*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                   MVT::v16i8, 3/*#Ops*/, 1, 2, 0, 
               // Src: (xor:{ *:[v16i8] } (and:{ *:[v16i8] } V128:{ *:[v16i8] }:$c, (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$v1, V128:{ *:[v16i8] }:$v2)), V128:{ *:[v16i8] }:$v2) - Complexity = 9
               // Dst: (BITSELECT:{ *:[v16i8] } ?:{ *:[v16i8] }:$v1, ?:{ *:[v16i8] }:$v2, ?:{ *:[v16i8] }:$c)
/* 15035*/    /*Scope*/ 10, /*->15046*/
/* 15036*/     OPC_CheckChild1Same, 1,
/* 15038*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                   MVT::v16i8, 3/*#Ops*/, 2, 1, 0, 
               // Src: (xor:{ *:[v16i8] } (and:{ *:[v16i8] } V128:{ *:[v16i8] }:$c, (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$v2, V128:{ *:[v16i8] }:$v1)), V128:{ *:[v16i8] }:$v2) - Complexity = 9
               // Dst: (BITSELECT:{ *:[v16i8] } ?:{ *:[v16i8] }:$v1, ?:{ *:[v16i8] }:$v2, ?:{ *:[v16i8] }:$c)
/* 15046*/    0, /*End of Scope*/
/* 15047*/   0, /*End of Scope*/
/* 15048*/  /*Scope*/ 88, /*->15137*/
/* 15049*/   OPC_RecordChild0, // #0 = $v2
/* 15050*/   OPC_MoveChild1,
/* 15051*/   OPC_CheckOpcode, TARGET_VAL(ISD::AND),
/* 15054*/   OPC_Scope, 40, /*->15096*/ // 2 children in Scope
/* 15056*/    OPC_MoveChild0,
/* 15057*/    OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 15060*/    OPC_Scope, 16, /*->15078*/ // 2 children in Scope
/* 15062*/     OPC_RecordChild0, // #1 = $v1
/* 15063*/     OPC_CheckChild1Same, 0,
/* 15065*/     OPC_MoveParent,
/* 15066*/     OPC_RecordChild1, // #2 = $c
/* 15067*/     OPC_MoveParent,
/* 15068*/     OPC_CheckType, MVT::v16i8,
/* 15070*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                   MVT::v16i8, 3/*#Ops*/, 1, 0, 2, 
               // Src: (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$v2, (and:{ *:[v16i8] } (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$v1, V128:{ *:[v16i8] }:$v2), V128:{ *:[v16i8] }:$c)) - Complexity = 9
               // Dst: (BITSELECT:{ *:[v16i8] } ?:{ *:[v16i8] }:$v1, ?:{ *:[v16i8] }:$v2, ?:{ *:[v16i8] }:$c)
/* 15078*/    /*Scope*/ 16, /*->15095*/
/* 15079*/     OPC_CheckChild0Same, 0,
/* 15081*/     OPC_RecordChild1, // #1 = $v1
/* 15082*/     OPC_MoveParent,
/* 15083*/     OPC_RecordChild1, // #2 = $c
/* 15084*/     OPC_MoveParent,
/* 15085*/     OPC_CheckType, MVT::v16i8,
/* 15087*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                   MVT::v16i8, 3/*#Ops*/, 1, 0, 2, 
               // Src: (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$v2, (and:{ *:[v16i8] } (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$v2, V128:{ *:[v16i8] }:$v1), V128:{ *:[v16i8] }:$c)) - Complexity = 9
               // Dst: (BITSELECT:{ *:[v16i8] } ?:{ *:[v16i8] }:$v1, ?:{ *:[v16i8] }:$v2, ?:{ *:[v16i8] }:$c)
/* 15095*/    0, /*End of Scope*/
/* 15096*/   /*Scope*/ 39, /*->15136*/
/* 15097*/    OPC_RecordChild0, // #1 = $c
/* 15098*/    OPC_MoveChild1,
/* 15099*/    OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 15102*/    OPC_Scope, 15, /*->15119*/ // 2 children in Scope
/* 15104*/     OPC_RecordChild0, // #2 = $v1
/* 15105*/     OPC_CheckChild1Same, 0,
/* 15107*/     OPC_MoveParent,
/* 15108*/     OPC_MoveParent,
/* 15109*/     OPC_CheckType, MVT::v16i8,
/* 15111*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                   MVT::v16i8, 3/*#Ops*/, 2, 0, 1, 
               // Src: (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$v2, (and:{ *:[v16i8] } V128:{ *:[v16i8] }:$c, (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$v1, V128:{ *:[v16i8] }:$v2))) - Complexity = 9
               // Dst: (BITSELECT:{ *:[v16i8] } ?:{ *:[v16i8] }:$v1, ?:{ *:[v16i8] }:$v2, ?:{ *:[v16i8] }:$c)
/* 15119*/    /*Scope*/ 15, /*->15135*/
/* 15120*/     OPC_CheckChild0Same, 0,
/* 15122*/     OPC_RecordChild1, // #2 = $v1
/* 15123*/     OPC_MoveParent,
/* 15124*/     OPC_MoveParent,
/* 15125*/     OPC_CheckType, MVT::v16i8,
/* 15127*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                   MVT::v16i8, 3/*#Ops*/, 2, 0, 1, 
               // Src: (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$v2, (and:{ *:[v16i8] } V128:{ *:[v16i8] }:$c, (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$v2, V128:{ *:[v16i8] }:$v1))) - Complexity = 9
               // Dst: (BITSELECT:{ *:[v16i8] } ?:{ *:[v16i8] }:$v1, ?:{ *:[v16i8] }:$v2, ?:{ *:[v16i8] }:$c)
/* 15135*/    0, /*End of Scope*/
/* 15136*/   0, /*End of Scope*/
/* 15137*/  /*Scope*/ 64, /*->15202*/
/* 15138*/   OPC_MoveChild0,
/* 15139*/   OPC_CheckOpcode, TARGET_VAL(ISD::AND),
/* 15142*/   OPC_Scope, 21, /*->15165*/ // 2 children in Scope
/* 15144*/    OPC_MoveChild0,
/* 15145*/    OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 15148*/    OPC_RecordChild0, // #0 = $v2
/* 15149*/    OPC_RecordChild1, // #1 = $v1
/* 15150*/    OPC_MoveParent,
/* 15151*/    OPC_RecordChild1, // #2 = $c
/* 15152*/    OPC_MoveParent,
/* 15153*/    OPC_CheckChild1Same, 0,
/* 15155*/    OPC_CheckType, MVT::v8i16,
/* 15157*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                  MVT::v8i16, 3/*#Ops*/, 1, 0, 2, 
              // Src: (xor:{ *:[v8i16] } (and:{ *:[v8i16] } (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$v2, V128:{ *:[v8i16] }:$v1), V128:{ *:[v8i16] }:$c), V128:{ *:[v8i16] }:$v2) - Complexity = 9
              // Dst: (BITSELECT:{ *:[v8i16] } ?:{ *:[v8i16] }:$v1, ?:{ *:[v8i16] }:$v2, ?:{ *:[v8i16] }:$c)
/* 15165*/   /*Scope*/ 35, /*->15201*/
/* 15166*/    OPC_RecordChild0, // #0 = $c
/* 15167*/    OPC_MoveChild1,
/* 15168*/    OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 15171*/    OPC_RecordChild0, // #1 = $v1
/* 15172*/    OPC_RecordChild1, // #2 = $v2
/* 15173*/    OPC_MoveParent,
/* 15174*/    OPC_MoveParent,
/* 15175*/    OPC_CheckType, MVT::v8i16,
/* 15177*/    OPC_Scope, 10, /*->15189*/ // 2 children in Scope
/* 15179*/     OPC_CheckChild1Same, 2,
/* 15181*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                   MVT::v8i16, 3/*#Ops*/, 1, 2, 0, 
               // Src: (xor:{ *:[v8i16] } (and:{ *:[v8i16] } V128:{ *:[v8i16] }:$c, (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$v1, V128:{ *:[v8i16] }:$v2)), V128:{ *:[v8i16] }:$v2) - Complexity = 9
               // Dst: (BITSELECT:{ *:[v8i16] } ?:{ *:[v8i16] }:$v1, ?:{ *:[v8i16] }:$v2, ?:{ *:[v8i16] }:$c)
/* 15189*/    /*Scope*/ 10, /*->15200*/
/* 15190*/     OPC_CheckChild1Same, 1,
/* 15192*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                   MVT::v8i16, 3/*#Ops*/, 2, 1, 0, 
               // Src: (xor:{ *:[v8i16] } (and:{ *:[v8i16] } V128:{ *:[v8i16] }:$c, (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$v2, V128:{ *:[v8i16] }:$v1)), V128:{ *:[v8i16] }:$v2) - Complexity = 9
               // Dst: (BITSELECT:{ *:[v8i16] } ?:{ *:[v8i16] }:$v1, ?:{ *:[v8i16] }:$v2, ?:{ *:[v8i16] }:$c)
/* 15200*/    0, /*End of Scope*/
/* 15201*/   0, /*End of Scope*/
/* 15202*/  /*Scope*/ 88, /*->15291*/
/* 15203*/   OPC_RecordChild0, // #0 = $v2
/* 15204*/   OPC_MoveChild1,
/* 15205*/   OPC_CheckOpcode, TARGET_VAL(ISD::AND),
/* 15208*/   OPC_Scope, 40, /*->15250*/ // 2 children in Scope
/* 15210*/    OPC_MoveChild0,
/* 15211*/    OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 15214*/    OPC_Scope, 16, /*->15232*/ // 2 children in Scope
/* 15216*/     OPC_RecordChild0, // #1 = $v1
/* 15217*/     OPC_CheckChild1Same, 0,
/* 15219*/     OPC_MoveParent,
/* 15220*/     OPC_RecordChild1, // #2 = $c
/* 15221*/     OPC_MoveParent,
/* 15222*/     OPC_CheckType, MVT::v8i16,
/* 15224*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                   MVT::v8i16, 3/*#Ops*/, 1, 0, 2, 
               // Src: (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$v2, (and:{ *:[v8i16] } (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$v1, V128:{ *:[v8i16] }:$v2), V128:{ *:[v8i16] }:$c)) - Complexity = 9
               // Dst: (BITSELECT:{ *:[v8i16] } ?:{ *:[v8i16] }:$v1, ?:{ *:[v8i16] }:$v2, ?:{ *:[v8i16] }:$c)
/* 15232*/    /*Scope*/ 16, /*->15249*/
/* 15233*/     OPC_CheckChild0Same, 0,
/* 15235*/     OPC_RecordChild1, // #1 = $v1
/* 15236*/     OPC_MoveParent,
/* 15237*/     OPC_RecordChild1, // #2 = $c
/* 15238*/     OPC_MoveParent,
/* 15239*/     OPC_CheckType, MVT::v8i16,
/* 15241*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                   MVT::v8i16, 3/*#Ops*/, 1, 0, 2, 
               // Src: (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$v2, (and:{ *:[v8i16] } (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$v2, V128:{ *:[v8i16] }:$v1), V128:{ *:[v8i16] }:$c)) - Complexity = 9
               // Dst: (BITSELECT:{ *:[v8i16] } ?:{ *:[v8i16] }:$v1, ?:{ *:[v8i16] }:$v2, ?:{ *:[v8i16] }:$c)
/* 15249*/    0, /*End of Scope*/
/* 15250*/   /*Scope*/ 39, /*->15290*/
/* 15251*/    OPC_RecordChild0, // #1 = $c
/* 15252*/    OPC_MoveChild1,
/* 15253*/    OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 15256*/    OPC_Scope, 15, /*->15273*/ // 2 children in Scope
/* 15258*/     OPC_RecordChild0, // #2 = $v1
/* 15259*/     OPC_CheckChild1Same, 0,
/* 15261*/     OPC_MoveParent,
/* 15262*/     OPC_MoveParent,
/* 15263*/     OPC_CheckType, MVT::v8i16,
/* 15265*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                   MVT::v8i16, 3/*#Ops*/, 2, 0, 1, 
               // Src: (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$v2, (and:{ *:[v8i16] } V128:{ *:[v8i16] }:$c, (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$v1, V128:{ *:[v8i16] }:$v2))) - Complexity = 9
               // Dst: (BITSELECT:{ *:[v8i16] } ?:{ *:[v8i16] }:$v1, ?:{ *:[v8i16] }:$v2, ?:{ *:[v8i16] }:$c)
/* 15273*/    /*Scope*/ 15, /*->15289*/
/* 15274*/     OPC_CheckChild0Same, 0,
/* 15276*/     OPC_RecordChild1, // #2 = $v1
/* 15277*/     OPC_MoveParent,
/* 15278*/     OPC_MoveParent,
/* 15279*/     OPC_CheckType, MVT::v8i16,
/* 15281*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                   MVT::v8i16, 3/*#Ops*/, 2, 0, 1, 
               // Src: (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$v2, (and:{ *:[v8i16] } V128:{ *:[v8i16] }:$c, (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$v2, V128:{ *:[v8i16] }:$v1))) - Complexity = 9
               // Dst: (BITSELECT:{ *:[v8i16] } ?:{ *:[v8i16] }:$v1, ?:{ *:[v8i16] }:$v2, ?:{ *:[v8i16] }:$c)
/* 15289*/    0, /*End of Scope*/
/* 15290*/   0, /*End of Scope*/
/* 15291*/  /*Scope*/ 64, /*->15356*/
/* 15292*/   OPC_MoveChild0,
/* 15293*/   OPC_CheckOpcode, TARGET_VAL(ISD::AND),
/* 15296*/   OPC_Scope, 21, /*->15319*/ // 2 children in Scope
/* 15298*/    OPC_MoveChild0,
/* 15299*/    OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 15302*/    OPC_RecordChild0, // #0 = $v2
/* 15303*/    OPC_RecordChild1, // #1 = $v1
/* 15304*/    OPC_MoveParent,
/* 15305*/    OPC_RecordChild1, // #2 = $c
/* 15306*/    OPC_MoveParent,
/* 15307*/    OPC_CheckChild1Same, 0,
/* 15309*/    OPC_CheckType, MVT::v4i32,
/* 15311*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                  MVT::v4i32, 3/*#Ops*/, 1, 0, 2, 
              // Src: (xor:{ *:[v4i32] } (and:{ *:[v4i32] } (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$v2, V128:{ *:[v4i32] }:$v1), V128:{ *:[v4i32] }:$c), V128:{ *:[v4i32] }:$v2) - Complexity = 9
              // Dst: (BITSELECT:{ *:[v4i32] } ?:{ *:[v4i32] }:$v1, ?:{ *:[v4i32] }:$v2, ?:{ *:[v4i32] }:$c)
/* 15319*/   /*Scope*/ 35, /*->15355*/
/* 15320*/    OPC_RecordChild0, // #0 = $c
/* 15321*/    OPC_MoveChild1,
/* 15322*/    OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 15325*/    OPC_RecordChild0, // #1 = $v1
/* 15326*/    OPC_RecordChild1, // #2 = $v2
/* 15327*/    OPC_MoveParent,
/* 15328*/    OPC_MoveParent,
/* 15329*/    OPC_CheckType, MVT::v4i32,
/* 15331*/    OPC_Scope, 10, /*->15343*/ // 2 children in Scope
/* 15333*/     OPC_CheckChild1Same, 2,
/* 15335*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                   MVT::v4i32, 3/*#Ops*/, 1, 2, 0, 
               // Src: (xor:{ *:[v4i32] } (and:{ *:[v4i32] } V128:{ *:[v4i32] }:$c, (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$v1, V128:{ *:[v4i32] }:$v2)), V128:{ *:[v4i32] }:$v2) - Complexity = 9
               // Dst: (BITSELECT:{ *:[v4i32] } ?:{ *:[v4i32] }:$v1, ?:{ *:[v4i32] }:$v2, ?:{ *:[v4i32] }:$c)
/* 15343*/    /*Scope*/ 10, /*->15354*/
/* 15344*/     OPC_CheckChild1Same, 1,
/* 15346*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                   MVT::v4i32, 3/*#Ops*/, 2, 1, 0, 
               // Src: (xor:{ *:[v4i32] } (and:{ *:[v4i32] } V128:{ *:[v4i32] }:$c, (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$v2, V128:{ *:[v4i32] }:$v1)), V128:{ *:[v4i32] }:$v2) - Complexity = 9
               // Dst: (BITSELECT:{ *:[v4i32] } ?:{ *:[v4i32] }:$v1, ?:{ *:[v4i32] }:$v2, ?:{ *:[v4i32] }:$c)
/* 15354*/    0, /*End of Scope*/
/* 15355*/   0, /*End of Scope*/
/* 15356*/  /*Scope*/ 88, /*->15445*/
/* 15357*/   OPC_RecordChild0, // #0 = $v2
/* 15358*/   OPC_MoveChild1,
/* 15359*/   OPC_CheckOpcode, TARGET_VAL(ISD::AND),
/* 15362*/   OPC_Scope, 40, /*->15404*/ // 2 children in Scope
/* 15364*/    OPC_MoveChild0,
/* 15365*/    OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 15368*/    OPC_Scope, 16, /*->15386*/ // 2 children in Scope
/* 15370*/     OPC_RecordChild0, // #1 = $v1
/* 15371*/     OPC_CheckChild1Same, 0,
/* 15373*/     OPC_MoveParent,
/* 15374*/     OPC_RecordChild1, // #2 = $c
/* 15375*/     OPC_MoveParent,
/* 15376*/     OPC_CheckType, MVT::v4i32,
/* 15378*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                   MVT::v4i32, 3/*#Ops*/, 1, 0, 2, 
               // Src: (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$v2, (and:{ *:[v4i32] } (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$v1, V128:{ *:[v4i32] }:$v2), V128:{ *:[v4i32] }:$c)) - Complexity = 9
               // Dst: (BITSELECT:{ *:[v4i32] } ?:{ *:[v4i32] }:$v1, ?:{ *:[v4i32] }:$v2, ?:{ *:[v4i32] }:$c)
/* 15386*/    /*Scope*/ 16, /*->15403*/
/* 15387*/     OPC_CheckChild0Same, 0,
/* 15389*/     OPC_RecordChild1, // #1 = $v1
/* 15390*/     OPC_MoveParent,
/* 15391*/     OPC_RecordChild1, // #2 = $c
/* 15392*/     OPC_MoveParent,
/* 15393*/     OPC_CheckType, MVT::v4i32,
/* 15395*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                   MVT::v4i32, 3/*#Ops*/, 1, 0, 2, 
               // Src: (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$v2, (and:{ *:[v4i32] } (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$v2, V128:{ *:[v4i32] }:$v1), V128:{ *:[v4i32] }:$c)) - Complexity = 9
               // Dst: (BITSELECT:{ *:[v4i32] } ?:{ *:[v4i32] }:$v1, ?:{ *:[v4i32] }:$v2, ?:{ *:[v4i32] }:$c)
/* 15403*/    0, /*End of Scope*/
/* 15404*/   /*Scope*/ 39, /*->15444*/
/* 15405*/    OPC_RecordChild0, // #1 = $c
/* 15406*/    OPC_MoveChild1,
/* 15407*/    OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 15410*/    OPC_Scope, 15, /*->15427*/ // 2 children in Scope
/* 15412*/     OPC_RecordChild0, // #2 = $v1
/* 15413*/     OPC_CheckChild1Same, 0,
/* 15415*/     OPC_MoveParent,
/* 15416*/     OPC_MoveParent,
/* 15417*/     OPC_CheckType, MVT::v4i32,
/* 15419*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                   MVT::v4i32, 3/*#Ops*/, 2, 0, 1, 
               // Src: (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$v2, (and:{ *:[v4i32] } V128:{ *:[v4i32] }:$c, (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$v1, V128:{ *:[v4i32] }:$v2))) - Complexity = 9
               // Dst: (BITSELECT:{ *:[v4i32] } ?:{ *:[v4i32] }:$v1, ?:{ *:[v4i32] }:$v2, ?:{ *:[v4i32] }:$c)
/* 15427*/    /*Scope*/ 15, /*->15443*/
/* 15428*/     OPC_CheckChild0Same, 0,
/* 15430*/     OPC_RecordChild1, // #2 = $v1
/* 15431*/     OPC_MoveParent,
/* 15432*/     OPC_MoveParent,
/* 15433*/     OPC_CheckType, MVT::v4i32,
/* 15435*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                   MVT::v4i32, 3/*#Ops*/, 2, 0, 1, 
               // Src: (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$v2, (and:{ *:[v4i32] } V128:{ *:[v4i32] }:$c, (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$v2, V128:{ *:[v4i32] }:$v1))) - Complexity = 9
               // Dst: (BITSELECT:{ *:[v4i32] } ?:{ *:[v4i32] }:$v1, ?:{ *:[v4i32] }:$v2, ?:{ *:[v4i32] }:$c)
/* 15443*/    0, /*End of Scope*/
/* 15444*/   0, /*End of Scope*/
/* 15445*/  /*Scope*/ 64, /*->15510*/
/* 15446*/   OPC_MoveChild0,
/* 15447*/   OPC_CheckOpcode, TARGET_VAL(ISD::AND),
/* 15450*/   OPC_Scope, 21, /*->15473*/ // 2 children in Scope
/* 15452*/    OPC_MoveChild0,
/* 15453*/    OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 15456*/    OPC_RecordChild0, // #0 = $v2
/* 15457*/    OPC_RecordChild1, // #1 = $v1
/* 15458*/    OPC_MoveParent,
/* 15459*/    OPC_RecordChild1, // #2 = $c
/* 15460*/    OPC_MoveParent,
/* 15461*/    OPC_CheckChild1Same, 0,
/* 15463*/    OPC_CheckType, MVT::v2i64,
/* 15465*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                  MVT::v2i64, 3/*#Ops*/, 1, 0, 2, 
              // Src: (xor:{ *:[v2i64] } (and:{ *:[v2i64] } (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$v2, V128:{ *:[v2i64] }:$v1), V128:{ *:[v2i64] }:$c), V128:{ *:[v2i64] }:$v2) - Complexity = 9
              // Dst: (BITSELECT:{ *:[v2i64] } ?:{ *:[v2i64] }:$v1, ?:{ *:[v2i64] }:$v2, ?:{ *:[v2i64] }:$c)
/* 15473*/   /*Scope*/ 35, /*->15509*/
/* 15474*/    OPC_RecordChild0, // #0 = $c
/* 15475*/    OPC_MoveChild1,
/* 15476*/    OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 15479*/    OPC_RecordChild0, // #1 = $v1
/* 15480*/    OPC_RecordChild1, // #2 = $v2
/* 15481*/    OPC_MoveParent,
/* 15482*/    OPC_MoveParent,
/* 15483*/    OPC_CheckType, MVT::v2i64,
/* 15485*/    OPC_Scope, 10, /*->15497*/ // 2 children in Scope
/* 15487*/     OPC_CheckChild1Same, 2,
/* 15489*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                   MVT::v2i64, 3/*#Ops*/, 1, 2, 0, 
               // Src: (xor:{ *:[v2i64] } (and:{ *:[v2i64] } V128:{ *:[v2i64] }:$c, (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$v1, V128:{ *:[v2i64] }:$v2)), V128:{ *:[v2i64] }:$v2) - Complexity = 9
               // Dst: (BITSELECT:{ *:[v2i64] } ?:{ *:[v2i64] }:$v1, ?:{ *:[v2i64] }:$v2, ?:{ *:[v2i64] }:$c)
/* 15497*/    /*Scope*/ 10, /*->15508*/
/* 15498*/     OPC_CheckChild1Same, 1,
/* 15500*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                   MVT::v2i64, 3/*#Ops*/, 2, 1, 0, 
               // Src: (xor:{ *:[v2i64] } (and:{ *:[v2i64] } V128:{ *:[v2i64] }:$c, (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$v2, V128:{ *:[v2i64] }:$v1)), V128:{ *:[v2i64] }:$v2) - Complexity = 9
               // Dst: (BITSELECT:{ *:[v2i64] } ?:{ *:[v2i64] }:$v1, ?:{ *:[v2i64] }:$v2, ?:{ *:[v2i64] }:$c)
/* 15508*/    0, /*End of Scope*/
/* 15509*/   0, /*End of Scope*/
/* 15510*/  /*Scope*/ 43|128,1/*171*/, /*->15683*/
/* 15512*/   OPC_RecordChild0, // #0 = $v2
/* 15513*/   OPC_Scope, 127, /*->15642*/ // 2 children in Scope
/* 15515*/    OPC_MoveChild1,
/* 15516*/    OPC_Scope, 86, /*->15604*/ // 2 children in Scope
/* 15518*/     OPC_CheckOpcode, TARGET_VAL(ISD::AND),
/* 15521*/     OPC_Scope, 40, /*->15563*/ // 2 children in Scope
/* 15523*/      OPC_MoveChild0,
/* 15524*/      OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 15527*/      OPC_Scope, 16, /*->15545*/ // 2 children in Scope
/* 15529*/       OPC_RecordChild0, // #1 = $v1
/* 15530*/       OPC_CheckChild1Same, 0,
/* 15532*/       OPC_MoveParent,
/* 15533*/       OPC_RecordChild1, // #2 = $c
/* 15534*/       OPC_MoveParent,
/* 15535*/       OPC_CheckType, MVT::v2i64,
/* 15537*/       OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                     MVT::v2i64, 3/*#Ops*/, 1, 0, 2, 
                 // Src: (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$v2, (and:{ *:[v2i64] } (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$v1, V128:{ *:[v2i64] }:$v2), V128:{ *:[v2i64] }:$c)) - Complexity = 9
                 // Dst: (BITSELECT:{ *:[v2i64] } ?:{ *:[v2i64] }:$v1, ?:{ *:[v2i64] }:$v2, ?:{ *:[v2i64] }:$c)
/* 15545*/      /*Scope*/ 16, /*->15562*/
/* 15546*/       OPC_CheckChild0Same, 0,
/* 15548*/       OPC_RecordChild1, // #1 = $v1
/* 15549*/       OPC_MoveParent,
/* 15550*/       OPC_RecordChild1, // #2 = $c
/* 15551*/       OPC_MoveParent,
/* 15552*/       OPC_CheckType, MVT::v2i64,
/* 15554*/       OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                     MVT::v2i64, 3/*#Ops*/, 1, 0, 2, 
                 // Src: (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$v2, (and:{ *:[v2i64] } (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$v2, V128:{ *:[v2i64] }:$v1), V128:{ *:[v2i64] }:$c)) - Complexity = 9
                 // Dst: (BITSELECT:{ *:[v2i64] } ?:{ *:[v2i64] }:$v1, ?:{ *:[v2i64] }:$v2, ?:{ *:[v2i64] }:$c)
/* 15562*/      0, /*End of Scope*/
/* 15563*/     /*Scope*/ 39, /*->15603*/
/* 15564*/      OPC_RecordChild0, // #1 = $c
/* 15565*/      OPC_MoveChild1,
/* 15566*/      OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 15569*/      OPC_Scope, 15, /*->15586*/ // 2 children in Scope
/* 15571*/       OPC_RecordChild0, // #2 = $v1
/* 15572*/       OPC_CheckChild1Same, 0,
/* 15574*/       OPC_MoveParent,
/* 15575*/       OPC_MoveParent,
/* 15576*/       OPC_CheckType, MVT::v2i64,
/* 15578*/       OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                     MVT::v2i64, 3/*#Ops*/, 2, 0, 1, 
                 // Src: (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$v2, (and:{ *:[v2i64] } V128:{ *:[v2i64] }:$c, (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$v1, V128:{ *:[v2i64] }:$v2))) - Complexity = 9
                 // Dst: (BITSELECT:{ *:[v2i64] } ?:{ *:[v2i64] }:$v1, ?:{ *:[v2i64] }:$v2, ?:{ *:[v2i64] }:$c)
/* 15586*/      /*Scope*/ 15, /*->15602*/
/* 15587*/       OPC_CheckChild0Same, 0,
/* 15589*/       OPC_RecordChild1, // #2 = $v1
/* 15590*/       OPC_MoveParent,
/* 15591*/       OPC_MoveParent,
/* 15592*/       OPC_CheckType, MVT::v2i64,
/* 15594*/       OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                     MVT::v2i64, 3/*#Ops*/, 2, 0, 1, 
                 // Src: (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$v2, (and:{ *:[v2i64] } V128:{ *:[v2i64] }:$c, (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$v2, V128:{ *:[v2i64] }:$v1))) - Complexity = 9
                 // Dst: (BITSELECT:{ *:[v2i64] } ?:{ *:[v2i64] }:$v1, ?:{ *:[v2i64] }:$v2, ?:{ *:[v2i64] }:$c)
/* 15602*/      0, /*End of Scope*/
/* 15603*/     0, /*End of Scope*/
/* 15604*/    /*Scope*/ 36, /*->15641*/
/* 15605*/     OPC_CheckImmAllOnesV,
/* 15606*/     OPC_MoveParent,
/* 15607*/     OPC_SwitchType /*4 cases */, 6, MVT::v16i8,// ->15616
/* 15610*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::NOT),
                    MVT::v16i8, 1/*#Ops*/, 0, 
                // Src: (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$v, immAllOnesV:{ *:[v16i8] }) - Complexity = 7
                // Dst: (NOT:{ *:[v16i8] } ?:{ *:[v16i8] }:$v)
/* 15616*/     /*SwitchType*/ 6, MVT::v8i16,// ->15624
/* 15618*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::NOT),
                    MVT::v8i16, 1/*#Ops*/, 0, 
                // Src: (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$v, immAllOnesV:{ *:[v8i16] }) - Complexity = 7
                // Dst: (NOT:{ *:[v8i16] } ?:{ *:[v8i16] }:$v)
/* 15624*/     /*SwitchType*/ 6, MVT::v4i32,// ->15632
/* 15626*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::NOT),
                    MVT::v4i32, 1/*#Ops*/, 0, 
                // Src: (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$v, immAllOnesV:{ *:[v4i32] }) - Complexity = 7
                // Dst: (NOT:{ *:[v4i32] } ?:{ *:[v4i32] }:$v)
/* 15632*/     /*SwitchType*/ 6, MVT::v2i64,// ->15640
/* 15634*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::NOT),
                    MVT::v2i64, 1/*#Ops*/, 0, 
                // Src: (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$v, immAllOnesV:{ *:[v2i64] }) - Complexity = 7
                // Dst: (NOT:{ *:[v2i64] } ?:{ *:[v2i64] }:$v)
/* 15640*/     0, // EndSwitchType
/* 15641*/    0, /*End of Scope*/
/* 15642*/   /*Scope*/ 39, /*->15682*/
/* 15643*/    OPC_RecordChild1, // #1 = $rhs
/* 15644*/    OPC_SwitchType /*4 cases */, 7, MVT::v16i8,// ->15654
/* 15647*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::XOR),
                   MVT::v16i8, 2/*#Ops*/, 0, 1, 
               // Src: (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs) - Complexity = 3
               // Dst: (XOR:{ *:[v16i8] } ?:{ *:[v16i8] }:$lhs, ?:{ *:[v16i8] }:$rhs)
/* 15654*/    /*SwitchType*/ 7, MVT::v8i16,// ->15663
/* 15656*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::XOR),
                   MVT::v8i16, 2/*#Ops*/, 0, 1, 
               // Src: (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs) - Complexity = 3
               // Dst: (XOR:{ *:[v8i16] } ?:{ *:[v8i16] }:$lhs, ?:{ *:[v8i16] }:$rhs)
/* 15663*/    /*SwitchType*/ 7, MVT::v4i32,// ->15672
/* 15665*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::XOR),
                   MVT::v4i32, 2/*#Ops*/, 0, 1, 
               // Src: (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$lhs, V128:{ *:[v4i32] }:$rhs) - Complexity = 3
               // Dst: (XOR:{ *:[v4i32] } ?:{ *:[v4i32] }:$lhs, ?:{ *:[v4i32] }:$rhs)
/* 15672*/    /*SwitchType*/ 7, MVT::v2i64,// ->15681
/* 15674*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::XOR),
                   MVT::v2i64, 2/*#Ops*/, 0, 1, 
               // Src: (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$lhs, V128:{ *:[v2i64] }:$rhs) - Complexity = 3
               // Dst: (XOR:{ *:[v2i64] } ?:{ *:[v2i64] }:$lhs, ?:{ *:[v2i64] }:$rhs)
/* 15681*/    0, // EndSwitchType
/* 15682*/   0, /*End of Scope*/
/* 15683*/  0, /*End of Scope*/
/* 15684*/ /*SwitchOpcode*/ 21, TARGET_VAL(ISD::CTLZ),// ->15708
/* 15687*/  OPC_RecordChild0, // #0 = $src
/* 15688*/  OPC_SwitchType /*2 cases */, 7, MVT::i32,// ->15698
/* 15691*/   OPC_CheckChild0TypeI32,
/* 15692*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::CLZ_I32),
                 MVT::i32, 1/*#Ops*/, 0, 
             // Src: (ctlz:{ *:[i32] } I32:{ *:[i32] }:$src) - Complexity = 3
             // Dst: (CLZ_I32:{ *:[i32] } I32:{ *:[i32] }:$src)
/* 15698*/  /*SwitchType*/ 7, MVT::i64,// ->15707
/* 15700*/   OPC_CheckChild0TypeI64,
/* 15701*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::CLZ_I64),
                 MVT::i64, 1/*#Ops*/, 0, 
             // Src: (ctlz:{ *:[i64] } I64:{ *:[i64] }:$src) - Complexity = 3
             // Dst: (CLZ_I64:{ *:[i64] } I64:{ *:[i64] }:$src)
/* 15707*/  0, // EndSwitchType
/* 15708*/ /*SwitchOpcode*/ 21, TARGET_VAL(ISD::CTTZ),// ->15732
/* 15711*/  OPC_RecordChild0, // #0 = $src
/* 15712*/  OPC_SwitchType /*2 cases */, 7, MVT::i32,// ->15722
/* 15715*/   OPC_CheckChild0TypeI32,
/* 15716*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::CTZ_I32),
                 MVT::i32, 1/*#Ops*/, 0, 
             // Src: (cttz:{ *:[i32] } I32:{ *:[i32] }:$src) - Complexity = 3
             // Dst: (CTZ_I32:{ *:[i32] } I32:{ *:[i32] }:$src)
/* 15722*/  /*SwitchType*/ 7, MVT::i64,// ->15731
/* 15724*/   OPC_CheckChild0TypeI64,
/* 15725*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::CTZ_I64),
                 MVT::i64, 1/*#Ops*/, 0, 
             // Src: (cttz:{ *:[i64] } I64:{ *:[i64] }:$src) - Complexity = 3
             // Dst: (CTZ_I64:{ *:[i64] } I64:{ *:[i64] }:$src)
/* 15731*/  0, // EndSwitchType
/* 15732*/ /*SwitchOpcode*/ 32, TARGET_VAL(ISD::CTPOP),// ->15767
/* 15735*/  OPC_RecordChild0, // #0 = $src
/* 15736*/  OPC_SwitchType /*3 cases */, 7, MVT::i32,// ->15746
/* 15739*/   OPC_CheckChild0TypeI32,
/* 15740*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::POPCNT_I32),
                 MVT::i32, 1/*#Ops*/, 0, 
             // Src: (ctpop:{ *:[i32] } I32:{ *:[i32] }:$src) - Complexity = 3
             // Dst: (POPCNT_I32:{ *:[i32] } I32:{ *:[i32] }:$src)
/* 15746*/  /*SwitchType*/ 7, MVT::i64,// ->15755
/* 15748*/   OPC_CheckChild0TypeI64,
/* 15749*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::POPCNT_I64),
                 MVT::i64, 1/*#Ops*/, 0, 
             // Src: (ctpop:{ *:[i64] } I64:{ *:[i64] }:$src) - Complexity = 3
             // Dst: (POPCNT_I64:{ *:[i64] } I64:{ *:[i64] }:$src)
/* 15755*/  /*SwitchType*/ 9, MVT::v16i8,// ->15766
/* 15757*/   OPC_CheckChild0Type, MVT::v16i8,
/* 15759*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 15760*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::POPCNT_I8x16),
                 MVT::v16i8, 1/*#Ops*/, 0, 
             // Src: (ctpop:{ *:[v16i8] } V128:{ *:[v16i8] }:$v) - Complexity = 3
             // Dst: (POPCNT_I8x16:{ *:[v16i8] } V128:{ *:[v16i8] }:$v)
/* 15766*/  0, // EndSwitchType
/* 15767*/ /*SwitchOpcode*/ 7, TARGET_VAL(ISD::TRUNCATE),// ->15777
/* 15770*/  OPC_RecordChild0, // #0 = $src
/* 15771*/  OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::I32_WRAP_I64),
                MVT::i32, 1/*#Ops*/, 0, 
            // Src: (trunc:{ *:[i32] } I64:{ *:[i64] }:$src) - Complexity = 3
            // Dst: (I32_WRAP_I64:{ *:[i32] } I64:{ *:[i64] }:$src)
/* 15777*/ /*SwitchOpcode*/ 7, TARGET_VAL(ISD::SIGN_EXTEND),// ->15787
/* 15780*/  OPC_RecordChild0, // #0 = $src
/* 15781*/  OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::I64_EXTEND_S_I32),
                MVT::i64, 1/*#Ops*/, 0, 
            // Src: (sext:{ *:[i64] } I32:{ *:[i32] }:$src) - Complexity = 3
            // Dst: (I64_EXTEND_S_I32:{ *:[i64] } I32:{ *:[i32] }:$src)
/* 15787*/ /*SwitchOpcode*/ 107, TARGET_VAL(ISD::FP_TO_SINT),// ->15897
/* 15790*/  OPC_RecordChild0, // #0 = $src
/* 15791*/  OPC_Scope, 46, /*->15839*/ // 3 children in Scope
/* 15793*/   OPC_CheckChild0Type, MVT::f32,
/* 15795*/   OPC_SwitchType /*2 cases */, 19, MVT::i32,// ->15817
/* 15798*/    OPC_Scope, 7, /*->15807*/ // 2 children in Scope
/* 15800*/     OPC_CheckPatternPredicate7, // (Subtarget->hasNontrappingFPToInt())
/* 15801*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::I32_TRUNC_S_SAT_F32),
                   MVT::i32, 1/*#Ops*/, 0, 
               // Src: (fp_to_sint:{ *:[i32] } F32:{ *:[f32] }:$src) - Complexity = 3
               // Dst: (I32_TRUNC_S_SAT_F32:{ *:[i32] } F32:{ *:[f32] }:$src)
/* 15807*/    /*Scope*/ 8, /*->15816*/
/* 15808*/     OPC_CheckPatternPredicate, 8, // (!Subtarget->hasNontrappingFPToInt())
/* 15810*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::FP_TO_SINT_I32_F32),
                   MVT::i32, 1/*#Ops*/, 0, 
               // Src: (fp_to_sint:{ *:[i32] } F32:{ *:[f32] }:$src) - Complexity = 3
               // Dst: (FP_TO_SINT_I32_F32:{ *:[i32] } F32:{ *:[f32] }:$src)
/* 15816*/    0, /*End of Scope*/
/* 15817*/   /*SwitchType*/ 19, MVT::i64,// ->15838
/* 15819*/    OPC_Scope, 7, /*->15828*/ // 2 children in Scope
/* 15821*/     OPC_CheckPatternPredicate7, // (Subtarget->hasNontrappingFPToInt())
/* 15822*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::I64_TRUNC_S_SAT_F32),
                   MVT::i64, 1/*#Ops*/, 0, 
               // Src: (fp_to_sint:{ *:[i64] } F32:{ *:[f32] }:$src) - Complexity = 3
               // Dst: (I64_TRUNC_S_SAT_F32:{ *:[i64] } F32:{ *:[f32] }:$src)
/* 15828*/    /*Scope*/ 8, /*->15837*/
/* 15829*/     OPC_CheckPatternPredicate, 8, // (!Subtarget->hasNontrappingFPToInt())
/* 15831*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::FP_TO_SINT_I64_F32),
                   MVT::i64, 1/*#Ops*/, 0, 
               // Src: (fp_to_sint:{ *:[i64] } F32:{ *:[f32] }:$src) - Complexity = 3
               // Dst: (FP_TO_SINT_I64_F32:{ *:[i64] } F32:{ *:[f32] }:$src)
/* 15837*/    0, /*End of Scope*/
/* 15838*/   0, // EndSwitchType
/* 15839*/  /*Scope*/ 46, /*->15886*/
/* 15840*/   OPC_CheckChild0Type, MVT::f64,
/* 15842*/   OPC_SwitchType /*2 cases */, 19, MVT::i32,// ->15864
/* 15845*/    OPC_Scope, 7, /*->15854*/ // 2 children in Scope
/* 15847*/     OPC_CheckPatternPredicate7, // (Subtarget->hasNontrappingFPToInt())
/* 15848*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::I32_TRUNC_S_SAT_F64),
                   MVT::i32, 1/*#Ops*/, 0, 
               // Src: (fp_to_sint:{ *:[i32] } F64:{ *:[f64] }:$src) - Complexity = 3
               // Dst: (I32_TRUNC_S_SAT_F64:{ *:[i32] } F64:{ *:[f64] }:$src)
/* 15854*/    /*Scope*/ 8, /*->15863*/
/* 15855*/     OPC_CheckPatternPredicate, 8, // (!Subtarget->hasNontrappingFPToInt())
/* 15857*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::FP_TO_SINT_I32_F64),
                   MVT::i32, 1/*#Ops*/, 0, 
               // Src: (fp_to_sint:{ *:[i32] } F64:{ *:[f64] }:$src) - Complexity = 3
               // Dst: (FP_TO_SINT_I32_F64:{ *:[i32] } F64:{ *:[f64] }:$src)
/* 15863*/    0, /*End of Scope*/
/* 15864*/   /*SwitchType*/ 19, MVT::i64,// ->15885
/* 15866*/    OPC_Scope, 7, /*->15875*/ // 2 children in Scope
/* 15868*/     OPC_CheckPatternPredicate7, // (Subtarget->hasNontrappingFPToInt())
/* 15869*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::I64_TRUNC_S_SAT_F64),
                   MVT::i64, 1/*#Ops*/, 0, 
               // Src: (fp_to_sint:{ *:[i64] } F64:{ *:[f64] }:$src) - Complexity = 3
               // Dst: (I64_TRUNC_S_SAT_F64:{ *:[i64] } F64:{ *:[f64] }:$src)
/* 15875*/    /*Scope*/ 8, /*->15884*/
/* 15876*/     OPC_CheckPatternPredicate, 8, // (!Subtarget->hasNontrappingFPToInt())
/* 15878*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::FP_TO_SINT_I64_F64),
                   MVT::i64, 1/*#Ops*/, 0, 
               // Src: (fp_to_sint:{ *:[i64] } F64:{ *:[f64] }:$src) - Complexity = 3
               // Dst: (FP_TO_SINT_I64_F64:{ *:[i64] } F64:{ *:[f64] }:$src)
/* 15884*/    0, /*End of Scope*/
/* 15885*/   0, // EndSwitchType
/* 15886*/  /*Scope*/ 9, /*->15896*/
/* 15887*/   OPC_CheckType, MVT::v4i32,
/* 15889*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 15890*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::fp_to_sint_I32x4),
                 MVT::v4i32, 1/*#Ops*/, 0, 
             // Src: (fp_to_sint:{ *:[v4i32] } V128:{ *:[v4f32] }:$vec) - Complexity = 3
             // Dst: (fp_to_sint_I32x4:{ *:[v4i32] } V128:{ *:[v4f32] }:$vec)
/* 15896*/  0, /*End of Scope*/
/* 15897*/ /*SwitchOpcode*/ 107, TARGET_VAL(ISD::FP_TO_UINT),// ->16007
/* 15900*/  OPC_RecordChild0, // #0 = $src
/* 15901*/  OPC_Scope, 46, /*->15949*/ // 3 children in Scope
/* 15903*/   OPC_CheckChild0Type, MVT::f32,
/* 15905*/   OPC_SwitchType /*2 cases */, 19, MVT::i32,// ->15927
/* 15908*/    OPC_Scope, 7, /*->15917*/ // 2 children in Scope
/* 15910*/     OPC_CheckPatternPredicate7, // (Subtarget->hasNontrappingFPToInt())
/* 15911*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::I32_TRUNC_U_SAT_F32),
                   MVT::i32, 1/*#Ops*/, 0, 
               // Src: (fp_to_uint:{ *:[i32] } F32:{ *:[f32] }:$src) - Complexity = 3
               // Dst: (I32_TRUNC_U_SAT_F32:{ *:[i32] } F32:{ *:[f32] }:$src)
/* 15917*/    /*Scope*/ 8, /*->15926*/
/* 15918*/     OPC_CheckPatternPredicate, 8, // (!Subtarget->hasNontrappingFPToInt())
/* 15920*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::FP_TO_UINT_I32_F32),
                   MVT::i32, 1/*#Ops*/, 0, 
               // Src: (fp_to_uint:{ *:[i32] } F32:{ *:[f32] }:$src) - Complexity = 3
               // Dst: (FP_TO_UINT_I32_F32:{ *:[i32] } F32:{ *:[f32] }:$src)
/* 15926*/    0, /*End of Scope*/
/* 15927*/   /*SwitchType*/ 19, MVT::i64,// ->15948
/* 15929*/    OPC_Scope, 7, /*->15938*/ // 2 children in Scope
/* 15931*/     OPC_CheckPatternPredicate7, // (Subtarget->hasNontrappingFPToInt())
/* 15932*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::I64_TRUNC_U_SAT_F32),
                   MVT::i64, 1/*#Ops*/, 0, 
               // Src: (fp_to_uint:{ *:[i64] } F32:{ *:[f32] }:$src) - Complexity = 3
               // Dst: (I64_TRUNC_U_SAT_F32:{ *:[i64] } F32:{ *:[f32] }:$src)
/* 15938*/    /*Scope*/ 8, /*->15947*/
/* 15939*/     OPC_CheckPatternPredicate, 8, // (!Subtarget->hasNontrappingFPToInt())
/* 15941*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::FP_TO_UINT_I64_F32),
                   MVT::i64, 1/*#Ops*/, 0, 
               // Src: (fp_to_uint:{ *:[i64] } F32:{ *:[f32] }:$src) - Complexity = 3
               // Dst: (FP_TO_UINT_I64_F32:{ *:[i64] } F32:{ *:[f32] }:$src)
/* 15947*/    0, /*End of Scope*/
/* 15948*/   0, // EndSwitchType
/* 15949*/  /*Scope*/ 46, /*->15996*/
/* 15950*/   OPC_CheckChild0Type, MVT::f64,
/* 15952*/   OPC_SwitchType /*2 cases */, 19, MVT::i32,// ->15974
/* 15955*/    OPC_Scope, 7, /*->15964*/ // 2 children in Scope
/* 15957*/     OPC_CheckPatternPredicate7, // (Subtarget->hasNontrappingFPToInt())
/* 15958*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::I32_TRUNC_U_SAT_F64),
                   MVT::i32, 1/*#Ops*/, 0, 
               // Src: (fp_to_uint:{ *:[i32] } F64:{ *:[f64] }:$src) - Complexity = 3
               // Dst: (I32_TRUNC_U_SAT_F64:{ *:[i32] } F64:{ *:[f64] }:$src)
/* 15964*/    /*Scope*/ 8, /*->15973*/
/* 15965*/     OPC_CheckPatternPredicate, 8, // (!Subtarget->hasNontrappingFPToInt())
/* 15967*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::FP_TO_UINT_I32_F64),
                   MVT::i32, 1/*#Ops*/, 0, 
               // Src: (fp_to_uint:{ *:[i32] } F64:{ *:[f64] }:$src) - Complexity = 3
               // Dst: (FP_TO_UINT_I32_F64:{ *:[i32] } F64:{ *:[f64] }:$src)
/* 15973*/    0, /*End of Scope*/
/* 15974*/   /*SwitchType*/ 19, MVT::i64,// ->15995
/* 15976*/    OPC_Scope, 7, /*->15985*/ // 2 children in Scope
/* 15978*/     OPC_CheckPatternPredicate7, // (Subtarget->hasNontrappingFPToInt())
/* 15979*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::I64_TRUNC_U_SAT_F64),
                   MVT::i64, 1/*#Ops*/, 0, 
               // Src: (fp_to_uint:{ *:[i64] } F64:{ *:[f64] }:$src) - Complexity = 3
               // Dst: (I64_TRUNC_U_SAT_F64:{ *:[i64] } F64:{ *:[f64] }:$src)
/* 15985*/    /*Scope*/ 8, /*->15994*/
/* 15986*/     OPC_CheckPatternPredicate, 8, // (!Subtarget->hasNontrappingFPToInt())
/* 15988*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::FP_TO_UINT_I64_F64),
                   MVT::i64, 1/*#Ops*/, 0, 
               // Src: (fp_to_uint:{ *:[i64] } F64:{ *:[f64] }:$src) - Complexity = 3
               // Dst: (FP_TO_UINT_I64_F64:{ *:[i64] } F64:{ *:[f64] }:$src)
/* 15994*/    0, /*End of Scope*/
/* 15995*/   0, // EndSwitchType
/* 15996*/  /*Scope*/ 9, /*->16006*/
/* 15997*/   OPC_CheckType, MVT::v4i32,
/* 15999*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 16000*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::fp_to_uint_I32x4),
                 MVT::v4i32, 1/*#Ops*/, 0, 
             // Src: (fp_to_uint:{ *:[v4i32] } V128:{ *:[v4f32] }:$vec) - Complexity = 3
             // Dst: (fp_to_uint_I32x4:{ *:[v4i32] } V128:{ *:[v4f32] }:$vec)
/* 16006*/  0, /*End of Scope*/
/* 16007*/ /*SwitchOpcode*/ 72, TARGET_VAL(ISD::FP_TO_SINT_SAT),// ->16082
/* 16010*/  OPC_RecordChild0, // #0 = $src
/* 16011*/  OPC_Scope, 27, /*->16040*/ // 3 children in Scope
/* 16013*/   OPC_CheckChild0Type, MVT::f32,
/* 16015*/   OPC_MoveChild1,
/* 16016*/   OPC_Scope, 10, /*->16028*/ // 2 children in Scope
/* 16018*/    OPC_CheckValueType, MVT::i32,
/* 16020*/    OPC_MoveParent,
/* 16021*/    OPC_CheckTypeI32,
/* 16022*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::I32_TRUNC_S_SAT_F32),
                  MVT::i32, 1/*#Ops*/, 0, 
              // Src: (fp_to_sint_sat:{ *:[i32] } F32:{ *:[f32] }:$src, i32:{ *:[Other] }) - Complexity = 3
              // Dst: (I32_TRUNC_S_SAT_F32:{ *:[i32] } F32:{ *:[f32] }:$src)
/* 16028*/   /*Scope*/ 10, /*->16039*/
/* 16029*/    OPC_CheckValueType, MVT::i64,
/* 16031*/    OPC_MoveParent,
/* 16032*/    OPC_CheckTypeI64,
/* 16033*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::I64_TRUNC_S_SAT_F32),
                  MVT::i64, 1/*#Ops*/, 0, 
              // Src: (fp_to_sint_sat:{ *:[i64] } F32:{ *:[f32] }:$src, i64:{ *:[Other] }) - Complexity = 3
              // Dst: (I64_TRUNC_S_SAT_F32:{ *:[i64] } F32:{ *:[f32] }:$src)
/* 16039*/   0, /*End of Scope*/
/* 16040*/  /*Scope*/ 27, /*->16068*/
/* 16041*/   OPC_CheckChild0Type, MVT::f64,
/* 16043*/   OPC_MoveChild1,
/* 16044*/   OPC_Scope, 10, /*->16056*/ // 2 children in Scope
/* 16046*/    OPC_CheckValueType, MVT::i32,
/* 16048*/    OPC_MoveParent,
/* 16049*/    OPC_CheckTypeI32,
/* 16050*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::I32_TRUNC_S_SAT_F64),
                  MVT::i32, 1/*#Ops*/, 0, 
              // Src: (fp_to_sint_sat:{ *:[i32] } F64:{ *:[f64] }:$src, i32:{ *:[Other] }) - Complexity = 3
              // Dst: (I32_TRUNC_S_SAT_F64:{ *:[i32] } F64:{ *:[f64] }:$src)
/* 16056*/   /*Scope*/ 10, /*->16067*/
/* 16057*/    OPC_CheckValueType, MVT::i64,
/* 16059*/    OPC_MoveParent,
/* 16060*/    OPC_CheckTypeI64,
/* 16061*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::I64_TRUNC_S_SAT_F64),
                  MVT::i64, 1/*#Ops*/, 0, 
              // Src: (fp_to_sint_sat:{ *:[i64] } F64:{ *:[f64] }:$src, i64:{ *:[Other] }) - Complexity = 3
              // Dst: (I64_TRUNC_S_SAT_F64:{ *:[i64] } F64:{ *:[f64] }:$src)
/* 16067*/   0, /*End of Scope*/
/* 16068*/  /*Scope*/ 12, /*->16081*/
/* 16069*/   OPC_MoveChild1,
/* 16070*/   OPC_CheckValueType, MVT::i32,
/* 16072*/   OPC_MoveParent,
/* 16073*/   OPC_CheckType, MVT::v4i32,
/* 16075*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::fp_to_sint_I32x4),
                 MVT::v4i32, 1/*#Ops*/, 0, 
             // Src: (fp_to_sint_sat:{ *:[v4i32] } V128:{ *:[v4f32] }:$src, i32:{ *:[Other] }) - Complexity = 3
             // Dst: (fp_to_sint_I32x4:{ *:[v4i32] } ?:{ *:[v4f32] }:$src)
/* 16081*/  0, /*End of Scope*/
/* 16082*/ /*SwitchOpcode*/ 72, TARGET_VAL(ISD::FP_TO_UINT_SAT),// ->16157
/* 16085*/  OPC_RecordChild0, // #0 = $src
/* 16086*/  OPC_Scope, 27, /*->16115*/ // 3 children in Scope
/* 16088*/   OPC_CheckChild0Type, MVT::f32,
/* 16090*/   OPC_MoveChild1,
/* 16091*/   OPC_Scope, 10, /*->16103*/ // 2 children in Scope
/* 16093*/    OPC_CheckValueType, MVT::i32,
/* 16095*/    OPC_MoveParent,
/* 16096*/    OPC_CheckTypeI32,
/* 16097*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::I32_TRUNC_U_SAT_F32),
                  MVT::i32, 1/*#Ops*/, 0, 
              // Src: (fp_to_uint_sat:{ *:[i32] } F32:{ *:[f32] }:$src, i32:{ *:[Other] }) - Complexity = 3
              // Dst: (I32_TRUNC_U_SAT_F32:{ *:[i32] } F32:{ *:[f32] }:$src)
/* 16103*/   /*Scope*/ 10, /*->16114*/
/* 16104*/    OPC_CheckValueType, MVT::i64,
/* 16106*/    OPC_MoveParent,
/* 16107*/    OPC_CheckTypeI64,
/* 16108*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::I64_TRUNC_U_SAT_F32),
                  MVT::i64, 1/*#Ops*/, 0, 
              // Src: (fp_to_uint_sat:{ *:[i64] } F32:{ *:[f32] }:$src, i64:{ *:[Other] }) - Complexity = 3
              // Dst: (I64_TRUNC_U_SAT_F32:{ *:[i64] } F32:{ *:[f32] }:$src)
/* 16114*/   0, /*End of Scope*/
/* 16115*/  /*Scope*/ 27, /*->16143*/
/* 16116*/   OPC_CheckChild0Type, MVT::f64,
/* 16118*/   OPC_MoveChild1,
/* 16119*/   OPC_Scope, 10, /*->16131*/ // 2 children in Scope
/* 16121*/    OPC_CheckValueType, MVT::i32,
/* 16123*/    OPC_MoveParent,
/* 16124*/    OPC_CheckTypeI32,
/* 16125*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::I32_TRUNC_U_SAT_F64),
                  MVT::i32, 1/*#Ops*/, 0, 
              // Src: (fp_to_uint_sat:{ *:[i32] } F64:{ *:[f64] }:$src, i32:{ *:[Other] }) - Complexity = 3
              // Dst: (I32_TRUNC_U_SAT_F64:{ *:[i32] } F64:{ *:[f64] }:$src)
/* 16131*/   /*Scope*/ 10, /*->16142*/
/* 16132*/    OPC_CheckValueType, MVT::i64,
/* 16134*/    OPC_MoveParent,
/* 16135*/    OPC_CheckTypeI64,
/* 16136*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::I64_TRUNC_U_SAT_F64),
                  MVT::i64, 1/*#Ops*/, 0, 
              // Src: (fp_to_uint_sat:{ *:[i64] } F64:{ *:[f64] }:$src, i64:{ *:[Other] }) - Complexity = 3
              // Dst: (I64_TRUNC_U_SAT_F64:{ *:[i64] } F64:{ *:[f64] }:$src)
/* 16142*/   0, /*End of Scope*/
/* 16143*/  /*Scope*/ 12, /*->16156*/
/* 16144*/   OPC_MoveChild1,
/* 16145*/   OPC_CheckValueType, MVT::i32,
/* 16147*/   OPC_MoveParent,
/* 16148*/   OPC_CheckType, MVT::v4i32,
/* 16150*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::fp_to_uint_I32x4),
                 MVT::v4i32, 1/*#Ops*/, 0, 
             // Src: (fp_to_uint_sat:{ *:[v4i32] } V128:{ *:[v4f32] }:$src, i32:{ *:[Other] }) - Complexity = 3
             // Dst: (fp_to_uint_I32x4:{ *:[v4i32] } ?:{ *:[v4f32] }:$src)
/* 16156*/  0, /*End of Scope*/
/* 16157*/ /*SwitchOpcode*/ 95|128,1/*223*/, TARGET_VAL(ISD::BITCAST),// ->16384
/* 16161*/  OPC_RecordChild0, // #0 = $src
/* 16162*/  OPC_Scope, 9, /*->16173*/ // 10 children in Scope
/* 16164*/   OPC_CheckChild0Type, MVT::f32,
/* 16166*/   OPC_CheckTypeI32,
/* 16167*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::I32_REINTERPRET_F32),
                 MVT::i32, 1/*#Ops*/, 0, 
             // Src: (bitconvert:{ *:[i32] } F32:{ *:[f32] }:$src) - Complexity = 3
             // Dst: (I32_REINTERPRET_F32:{ *:[i32] } F32:{ *:[f32] }:$src)
/* 16173*/  /*Scope*/ 9, /*->16183*/
/* 16174*/   OPC_CheckChild0Type, MVT::f64,
/* 16176*/   OPC_CheckTypeI64,
/* 16177*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::I64_REINTERPRET_F64),
                 MVT::i64, 1/*#Ops*/, 0, 
             // Src: (bitconvert:{ *:[i64] } F64:{ *:[f64] }:$src) - Complexity = 3
             // Dst: (I64_REINTERPRET_F64:{ *:[i64] } F64:{ *:[f64] }:$src)
/* 16183*/  /*Scope*/ 9, /*->16193*/
/* 16184*/   OPC_CheckChild0TypeI32,
/* 16185*/   OPC_CheckType, MVT::f32,
/* 16187*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::F32_REINTERPRET_I32),
                 MVT::f32, 1/*#Ops*/, 0, 
             // Src: (bitconvert:{ *:[f32] } I32:{ *:[i32] }:$src) - Complexity = 3
             // Dst: (F32_REINTERPRET_I32:{ *:[f32] } I32:{ *:[i32] }:$src)
/* 16193*/  /*Scope*/ 9, /*->16203*/
/* 16194*/   OPC_CheckChild0TypeI64,
/* 16195*/   OPC_CheckType, MVT::f64,
/* 16197*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::F64_REINTERPRET_I64),
                 MVT::f64, 1/*#Ops*/, 0, 
             // Src: (bitconvert:{ *:[f64] } I64:{ *:[i64] }:$src) - Complexity = 3
             // Dst: (F64_REINTERPRET_I64:{ *:[f64] } I64:{ *:[i64] }:$src)
/* 16203*/  /*Scope*/ 29, /*->16233*/
/* 16204*/   OPC_CheckChild0Type, MVT::v8i16,
/* 16206*/   OPC_SwitchType /*5 cases */, 3, MVT::v16i8,// ->16212
/* 16209*/    OPC_CompleteMatch, 1, 0, 
               // Src: (bitconvert:{ *:[v16i8] } V128:{ *:[v8i16] }:$v) - Complexity = 3
               // Dst: V128:{ *:[v16i8] }:$v
/* 16212*/   /*SwitchType*/ 3, MVT::v4i32,// ->16217
/* 16214*/    OPC_CompleteMatch, 1, 0, 
               // Src: (bitconvert:{ *:[v4i32] } V128:{ *:[v8i16] }:$v) - Complexity = 3
               // Dst: V128:{ *:[v4i32] }:$v
/* 16217*/   /*SwitchType*/ 3, MVT::v2i64,// ->16222
/* 16219*/    OPC_CompleteMatch, 1, 0, 
               // Src: (bitconvert:{ *:[v2i64] } V128:{ *:[v8i16] }:$v) - Complexity = 3
               // Dst: V128:{ *:[v2i64] }:$v
/* 16222*/   /*SwitchType*/ 3, MVT::v4f32,// ->16227
/* 16224*/    OPC_CompleteMatch, 1, 0, 
               // Src: (bitconvert:{ *:[v4f32] } V128:{ *:[v8i16] }:$v) - Complexity = 3
               // Dst: V128:{ *:[v4f32] }:$v
/* 16227*/   /*SwitchType*/ 3, MVT::v2f64,// ->16232
/* 16229*/    OPC_CompleteMatch, 1, 0, 
               // Src: (bitconvert:{ *:[v2f64] } V128:{ *:[v8i16] }:$v) - Complexity = 3
               // Dst: V128:{ *:[v2f64] }:$v
/* 16232*/   0, // EndSwitchType
/* 16233*/  /*Scope*/ 29, /*->16263*/
/* 16234*/   OPC_CheckChild0Type, MVT::v4i32,
/* 16236*/   OPC_SwitchType /*5 cases */, 3, MVT::v16i8,// ->16242
/* 16239*/    OPC_CompleteMatch, 1, 0, 
               // Src: (bitconvert:{ *:[v16i8] } V128:{ *:[v4i32] }:$v) - Complexity = 3
               // Dst: V128:{ *:[v16i8] }:$v
/* 16242*/   /*SwitchType*/ 3, MVT::v8i16,// ->16247
/* 16244*/    OPC_CompleteMatch, 1, 0, 
               // Src: (bitconvert:{ *:[v8i16] } V128:{ *:[v4i32] }:$v) - Complexity = 3
               // Dst: V128:{ *:[v8i16] }:$v
/* 16247*/   /*SwitchType*/ 3, MVT::v2i64,// ->16252
/* 16249*/    OPC_CompleteMatch, 1, 0, 
               // Src: (bitconvert:{ *:[v2i64] } V128:{ *:[v4i32] }:$v) - Complexity = 3
               // Dst: V128:{ *:[v2i64] }:$v
/* 16252*/   /*SwitchType*/ 3, MVT::v4f32,// ->16257
/* 16254*/    OPC_CompleteMatch, 1, 0, 
               // Src: (bitconvert:{ *:[v4f32] } V128:{ *:[v4i32] }:$v) - Complexity = 3
               // Dst: V128:{ *:[v4f32] }:$v
/* 16257*/   /*SwitchType*/ 3, MVT::v2f64,// ->16262
/* 16259*/    OPC_CompleteMatch, 1, 0, 
               // Src: (bitconvert:{ *:[v2f64] } V128:{ *:[v4i32] }:$v) - Complexity = 3
               // Dst: V128:{ *:[v2f64] }:$v
/* 16262*/   0, // EndSwitchType
/* 16263*/  /*Scope*/ 29, /*->16293*/
/* 16264*/   OPC_CheckChild0Type, MVT::v2i64,
/* 16266*/   OPC_SwitchType /*5 cases */, 3, MVT::v16i8,// ->16272
/* 16269*/    OPC_CompleteMatch, 1, 0, 
               // Src: (bitconvert:{ *:[v16i8] } V128:{ *:[v2i64] }:$v) - Complexity = 3
               // Dst: V128:{ *:[v16i8] }:$v
/* 16272*/   /*SwitchType*/ 3, MVT::v8i16,// ->16277
/* 16274*/    OPC_CompleteMatch, 1, 0, 
               // Src: (bitconvert:{ *:[v8i16] } V128:{ *:[v2i64] }:$v) - Complexity = 3
               // Dst: V128:{ *:[v8i16] }:$v
/* 16277*/   /*SwitchType*/ 3, MVT::v4i32,// ->16282
/* 16279*/    OPC_CompleteMatch, 1, 0, 
               // Src: (bitconvert:{ *:[v4i32] } V128:{ *:[v2i64] }:$v) - Complexity = 3
               // Dst: V128:{ *:[v4i32] }:$v
/* 16282*/   /*SwitchType*/ 3, MVT::v4f32,// ->16287
/* 16284*/    OPC_CompleteMatch, 1, 0, 
               // Src: (bitconvert:{ *:[v4f32] } V128:{ *:[v2i64] }:$v) - Complexity = 3
               // Dst: V128:{ *:[v4f32] }:$v
/* 16287*/   /*SwitchType*/ 3, MVT::v2f64,// ->16292
/* 16289*/    OPC_CompleteMatch, 1, 0, 
               // Src: (bitconvert:{ *:[v2f64] } V128:{ *:[v2i64] }:$v) - Complexity = 3
               // Dst: V128:{ *:[v2f64] }:$v
/* 16292*/   0, // EndSwitchType
/* 16293*/  /*Scope*/ 29, /*->16323*/
/* 16294*/   OPC_CheckChild0Type, MVT::v4f32,
/* 16296*/   OPC_SwitchType /*5 cases */, 3, MVT::v16i8,// ->16302
/* 16299*/    OPC_CompleteMatch, 1, 0, 
               // Src: (bitconvert:{ *:[v16i8] } V128:{ *:[v4f32] }:$v) - Complexity = 3
               // Dst: V128:{ *:[v16i8] }:$v
/* 16302*/   /*SwitchType*/ 3, MVT::v8i16,// ->16307
/* 16304*/    OPC_CompleteMatch, 1, 0, 
               // Src: (bitconvert:{ *:[v8i16] } V128:{ *:[v4f32] }:$v) - Complexity = 3
               // Dst: V128:{ *:[v8i16] }:$v
/* 16307*/   /*SwitchType*/ 3, MVT::v4i32,// ->16312
/* 16309*/    OPC_CompleteMatch, 1, 0, 
               // Src: (bitconvert:{ *:[v4i32] } V128:{ *:[v4f32] }:$v) - Complexity = 3
               // Dst: V128:{ *:[v4i32] }:$v
/* 16312*/   /*SwitchType*/ 3, MVT::v2i64,// ->16317
/* 16314*/    OPC_CompleteMatch, 1, 0, 
               // Src: (bitconvert:{ *:[v2i64] } V128:{ *:[v4f32] }:$v) - Complexity = 3
               // Dst: V128:{ *:[v2i64] }:$v
/* 16317*/   /*SwitchType*/ 3, MVT::v2f64,// ->16322
/* 16319*/    OPC_CompleteMatch, 1, 0, 
               // Src: (bitconvert:{ *:[v2f64] } V128:{ *:[v4f32] }:$v) - Complexity = 3
               // Dst: V128:{ *:[v2f64] }:$v
/* 16322*/   0, // EndSwitchType
/* 16323*/  /*Scope*/ 29, /*->16353*/
/* 16324*/   OPC_CheckChild0Type, MVT::v2f64,
/* 16326*/   OPC_SwitchType /*5 cases */, 3, MVT::v16i8,// ->16332
/* 16329*/    OPC_CompleteMatch, 1, 0, 
               // Src: (bitconvert:{ *:[v16i8] } V128:{ *:[v2f64] }:$v) - Complexity = 3
               // Dst: V128:{ *:[v16i8] }:$v
/* 16332*/   /*SwitchType*/ 3, MVT::v8i16,// ->16337
/* 16334*/    OPC_CompleteMatch, 1, 0, 
               // Src: (bitconvert:{ *:[v8i16] } V128:{ *:[v2f64] }:$v) - Complexity = 3
               // Dst: V128:{ *:[v8i16] }:$v
/* 16337*/   /*SwitchType*/ 3, MVT::v4i32,// ->16342
/* 16339*/    OPC_CompleteMatch, 1, 0, 
               // Src: (bitconvert:{ *:[v4i32] } V128:{ *:[v2f64] }:$v) - Complexity = 3
               // Dst: V128:{ *:[v4i32] }:$v
/* 16342*/   /*SwitchType*/ 3, MVT::v2i64,// ->16347
/* 16344*/    OPC_CompleteMatch, 1, 0, 
               // Src: (bitconvert:{ *:[v2i64] } V128:{ *:[v2f64] }:$v) - Complexity = 3
               // Dst: V128:{ *:[v2i64] }:$v
/* 16347*/   /*SwitchType*/ 3, MVT::v4f32,// ->16352
/* 16349*/    OPC_CompleteMatch, 1, 0, 
               // Src: (bitconvert:{ *:[v4f32] } V128:{ *:[v2f64] }:$v) - Complexity = 3
               // Dst: V128:{ *:[v4f32] }:$v
/* 16352*/   0, // EndSwitchType
/* 16353*/  /*Scope*/ 29, /*->16383*/
/* 16354*/   OPC_CheckChild0Type, MVT::v16i8,
/* 16356*/   OPC_SwitchType /*5 cases */, 3, MVT::v8i16,// ->16362
/* 16359*/    OPC_CompleteMatch, 1, 0, 
               // Src: (bitconvert:{ *:[v8i16] } V128:{ *:[v16i8] }:$v) - Complexity = 3
               // Dst: V128:{ *:[v8i16] }:$v
/* 16362*/   /*SwitchType*/ 3, MVT::v4i32,// ->16367
/* 16364*/    OPC_CompleteMatch, 1, 0, 
               // Src: (bitconvert:{ *:[v4i32] } V128:{ *:[v16i8] }:$v) - Complexity = 3
               // Dst: V128:{ *:[v4i32] }:$v
/* 16367*/   /*SwitchType*/ 3, MVT::v2i64,// ->16372
/* 16369*/    OPC_CompleteMatch, 1, 0, 
               // Src: (bitconvert:{ *:[v2i64] } V128:{ *:[v16i8] }:$v) - Complexity = 3
               // Dst: V128:{ *:[v2i64] }:$v
/* 16372*/   /*SwitchType*/ 3, MVT::v4f32,// ->16377
/* 16374*/    OPC_CompleteMatch, 1, 0, 
               // Src: (bitconvert:{ *:[v4f32] } V128:{ *:[v16i8] }:$v) - Complexity = 3
               // Dst: V128:{ *:[v4f32] }:$v
/* 16377*/   /*SwitchType*/ 3, MVT::v2f64,// ->16382
/* 16379*/    OPC_CompleteMatch, 1, 0, 
               // Src: (bitconvert:{ *:[v2f64] } V128:{ *:[v16i8] }:$v) - Complexity = 3
               // Dst: V128:{ *:[v2f64] }:$v
/* 16382*/   0, // EndSwitchType
/* 16383*/  0, /*End of Scope*/
/* 16384*/ /*SwitchOpcode*/ 21, TARGET_VAL(ISD::ConstantFP),// ->16408
/* 16387*/  OPC_RecordNode, // #0 = $imm
/* 16388*/  OPC_SwitchType /*2 cases */, 7, MVT::f32,// ->16398
/* 16391*/   OPC_EmitConvertToTarget0,
/* 16392*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::CONST_F32),
                 MVT::f32, 1/*#Ops*/, 1, 
             // Src: (fpimm:{ *:[f32] }):$imm - Complexity = 3
             // Dst: (CONST_F32:{ *:[f32] } (fpimm:{ *:[f32] }):$imm)
/* 16398*/  /*SwitchType*/ 7, MVT::f64,// ->16407
/* 16400*/   OPC_EmitConvertToTarget0,
/* 16401*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::CONST_F64),
                 MVT::f64, 1/*#Ops*/, 1, 
             // Src: (fpimm:{ *:[f64] }):$imm - Complexity = 3
             // Dst: (CONST_F64:{ *:[f64] } (fpimm:{ *:[f64] }):$imm)
/* 16407*/  0, // EndSwitchType
/* 16408*/ /*SwitchOpcode*/ 53, TARGET_VAL(ISD::SINT_TO_FP),// ->16464
/* 16411*/  OPC_RecordChild0, // #0 = $src
/* 16412*/  OPC_Scope, 19, /*->16433*/ // 3 children in Scope
/* 16414*/   OPC_CheckChild0TypeI32,
/* 16415*/   OPC_SwitchType /*2 cases */, 6, MVT::f32,// ->16424
/* 16418*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::F32_CONVERT_S_I32),
                  MVT::f32, 1/*#Ops*/, 0, 
              // Src: (sint_to_fp:{ *:[f32] } I32:{ *:[i32] }:$src) - Complexity = 3
              // Dst: (F32_CONVERT_S_I32:{ *:[f32] } I32:{ *:[i32] }:$src)
/* 16424*/   /*SwitchType*/ 6, MVT::f64,// ->16432
/* 16426*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::F64_CONVERT_S_I32),
                  MVT::f64, 1/*#Ops*/, 0, 
              // Src: (sint_to_fp:{ *:[f64] } I32:{ *:[i32] }:$src) - Complexity = 3
              // Dst: (F64_CONVERT_S_I32:{ *:[f64] } I32:{ *:[i32] }:$src)
/* 16432*/   0, // EndSwitchType
/* 16433*/  /*Scope*/ 19, /*->16453*/
/* 16434*/   OPC_CheckChild0TypeI64,
/* 16435*/   OPC_SwitchType /*2 cases */, 6, MVT::f32,// ->16444
/* 16438*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::F32_CONVERT_S_I64),
                  MVT::f32, 1/*#Ops*/, 0, 
              // Src: (sint_to_fp:{ *:[f32] } I64:{ *:[i64] }:$src) - Complexity = 3
              // Dst: (F32_CONVERT_S_I64:{ *:[f32] } I64:{ *:[i64] }:$src)
/* 16444*/   /*SwitchType*/ 6, MVT::f64,// ->16452
/* 16446*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::F64_CONVERT_S_I64),
                  MVT::f64, 1/*#Ops*/, 0, 
              // Src: (sint_to_fp:{ *:[f64] } I64:{ *:[i64] }:$src) - Complexity = 3
              // Dst: (F64_CONVERT_S_I64:{ *:[f64] } I64:{ *:[i64] }:$src)
/* 16452*/   0, // EndSwitchType
/* 16453*/  /*Scope*/ 9, /*->16463*/
/* 16454*/   OPC_CheckType, MVT::v4f32,
/* 16456*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 16457*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::sint_to_fp_F32x4),
                 MVT::v4f32, 1/*#Ops*/, 0, 
             // Src: (sint_to_fp:{ *:[v4f32] } V128:{ *:[v4i32] }:$vec) - Complexity = 3
             // Dst: (sint_to_fp_F32x4:{ *:[v4f32] } V128:{ *:[v4i32] }:$vec)
/* 16463*/  0, /*End of Scope*/
/* 16464*/ /*SwitchOpcode*/ 53, TARGET_VAL(ISD::UINT_TO_FP),// ->16520
/* 16467*/  OPC_RecordChild0, // #0 = $src
/* 16468*/  OPC_Scope, 19, /*->16489*/ // 3 children in Scope
/* 16470*/   OPC_CheckChild0TypeI32,
/* 16471*/   OPC_SwitchType /*2 cases */, 6, MVT::f32,// ->16480
/* 16474*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::F32_CONVERT_U_I32),
                  MVT::f32, 1/*#Ops*/, 0, 
              // Src: (uint_to_fp:{ *:[f32] } I32:{ *:[i32] }:$src) - Complexity = 3
              // Dst: (F32_CONVERT_U_I32:{ *:[f32] } I32:{ *:[i32] }:$src)
/* 16480*/   /*SwitchType*/ 6, MVT::f64,// ->16488
/* 16482*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::F64_CONVERT_U_I32),
                  MVT::f64, 1/*#Ops*/, 0, 
              // Src: (uint_to_fp:{ *:[f64] } I32:{ *:[i32] }:$src) - Complexity = 3
              // Dst: (F64_CONVERT_U_I32:{ *:[f64] } I32:{ *:[i32] }:$src)
/* 16488*/   0, // EndSwitchType
/* 16489*/  /*Scope*/ 19, /*->16509*/
/* 16490*/   OPC_CheckChild0TypeI64,
/* 16491*/   OPC_SwitchType /*2 cases */, 6, MVT::f32,// ->16500
/* 16494*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::F32_CONVERT_U_I64),
                  MVT::f32, 1/*#Ops*/, 0, 
              // Src: (uint_to_fp:{ *:[f32] } I64:{ *:[i64] }:$src) - Complexity = 3
              // Dst: (F32_CONVERT_U_I64:{ *:[f32] } I64:{ *:[i64] }:$src)
/* 16500*/   /*SwitchType*/ 6, MVT::f64,// ->16508
/* 16502*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::F64_CONVERT_U_I64),
                  MVT::f64, 1/*#Ops*/, 0, 
              // Src: (uint_to_fp:{ *:[f64] } I64:{ *:[i64] }:$src) - Complexity = 3
              // Dst: (F64_CONVERT_U_I64:{ *:[f64] } I64:{ *:[i64] }:$src)
/* 16508*/   0, // EndSwitchType
/* 16509*/  /*Scope*/ 9, /*->16519*/
/* 16510*/   OPC_CheckType, MVT::v4f32,
/* 16512*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 16513*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::uint_to_fp_F32x4),
                 MVT::v4f32, 1/*#Ops*/, 0, 
             // Src: (uint_to_fp:{ *:[v4f32] } V128:{ *:[v4i32] }:$vec) - Complexity = 3
             // Dst: (uint_to_fp_F32x4:{ *:[v4f32] } V128:{ *:[v4i32] }:$vec)
/* 16519*/  0, /*End of Scope*/
/* 16520*/ /*SwitchOpcode*/ 7, TARGET_VAL(ISD::FP_EXTEND),// ->16530
/* 16523*/  OPC_RecordChild0, // #0 = $src
/* 16524*/  OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::F64_PROMOTE_F32),
                MVT::f64, 1/*#Ops*/, 0, 
            // Src: (fpextend:{ *:[f64] } F32:{ *:[f32] }:$src) - Complexity = 3
            // Dst: (F64_PROMOTE_F32:{ *:[f64] } F32:{ *:[f32] }:$src)
/* 16530*/ /*SwitchOpcode*/ 7, TARGET_VAL(ISD::FP_ROUND),// ->16540
/* 16533*/  OPC_RecordChild0, // #0 = $src
/* 16534*/  OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::F32_DEMOTE_F64),
                MVT::f32, 1/*#Ops*/, 0, 
            // Src: (fpround:{ *:[f32] } F64:{ *:[f64] }:$src) - Complexity = 3
            // Dst: (F32_DEMOTE_F64:{ *:[f32] } F64:{ *:[f64] }:$src)
/* 16540*/ /*SwitchOpcode*/ 42, TARGET_VAL(ISD::FADD),// ->16585
/* 16543*/  OPC_RecordChild0, // #0 = $lhs
/* 16544*/  OPC_RecordChild1, // #1 = $rhs
/* 16545*/  OPC_SwitchType /*4 cases */, 7, MVT::f32,// ->16555
/* 16548*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ADD_F32),
                 MVT::f32, 2/*#Ops*/, 0, 1, 
             // Src: (fadd:{ *:[f32] } F32:{ *:[f32] }:$lhs, F32:{ *:[f32] }:$rhs) - Complexity = 3
             // Dst: (ADD_F32:{ *:[f32] } F32:{ *:[f32] }:$lhs, F32:{ *:[f32] }:$rhs)
/* 16555*/  /*SwitchType*/ 7, MVT::f64,// ->16564
/* 16557*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ADD_F64),
                 MVT::f64, 2/*#Ops*/, 0, 1, 
             // Src: (fadd:{ *:[f64] } F64:{ *:[f64] }:$lhs, F64:{ *:[f64] }:$rhs) - Complexity = 3
             // Dst: (ADD_F64:{ *:[f64] } F64:{ *:[f64] }:$lhs, F64:{ *:[f64] }:$rhs)
/* 16564*/  /*SwitchType*/ 8, MVT::v4f32,// ->16574
/* 16566*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 16567*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ADD_F32x4),
                 MVT::v4f32, 2/*#Ops*/, 0, 1, 
             // Src: (fadd:{ *:[v4f32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs) - Complexity = 3
             // Dst: (ADD_F32x4:{ *:[v4f32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs)
/* 16574*/  /*SwitchType*/ 8, MVT::v2f64,// ->16584
/* 16576*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 16577*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ADD_F64x2),
                 MVT::v2f64, 2/*#Ops*/, 0, 1, 
             // Src: (fadd:{ *:[v2f64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs) - Complexity = 3
             // Dst: (ADD_F64x2:{ *:[v2f64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs)
/* 16584*/  0, // EndSwitchType
/* 16585*/ /*SwitchOpcode*/ 42, TARGET_VAL(ISD::FSUB),// ->16630
/* 16588*/  OPC_RecordChild0, // #0 = $lhs
/* 16589*/  OPC_RecordChild1, // #1 = $rhs
/* 16590*/  OPC_SwitchType /*4 cases */, 7, MVT::f32,// ->16600
/* 16593*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SUB_F32),
                 MVT::f32, 2/*#Ops*/, 0, 1, 
             // Src: (fsub:{ *:[f32] } F32:{ *:[f32] }:$lhs, F32:{ *:[f32] }:$rhs) - Complexity = 3
             // Dst: (SUB_F32:{ *:[f32] } F32:{ *:[f32] }:$lhs, F32:{ *:[f32] }:$rhs)
/* 16600*/  /*SwitchType*/ 7, MVT::f64,// ->16609
/* 16602*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SUB_F64),
                 MVT::f64, 2/*#Ops*/, 0, 1, 
             // Src: (fsub:{ *:[f64] } F64:{ *:[f64] }:$lhs, F64:{ *:[f64] }:$rhs) - Complexity = 3
             // Dst: (SUB_F64:{ *:[f64] } F64:{ *:[f64] }:$lhs, F64:{ *:[f64] }:$rhs)
/* 16609*/  /*SwitchType*/ 8, MVT::v4f32,// ->16619
/* 16611*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 16612*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SUB_F32x4),
                 MVT::v4f32, 2/*#Ops*/, 0, 1, 
             // Src: (fsub:{ *:[v4f32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs) - Complexity = 3
             // Dst: (SUB_F32x4:{ *:[v4f32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs)
/* 16619*/  /*SwitchType*/ 8, MVT::v2f64,// ->16629
/* 16621*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 16622*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SUB_F64x2),
                 MVT::v2f64, 2/*#Ops*/, 0, 1, 
             // Src: (fsub:{ *:[v2f64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs) - Complexity = 3
             // Dst: (SUB_F64x2:{ *:[v2f64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs)
/* 16629*/  0, // EndSwitchType
/* 16630*/ /*SwitchOpcode*/ 42, TARGET_VAL(ISD::FMUL),// ->16675
/* 16633*/  OPC_RecordChild0, // #0 = $lhs
/* 16634*/  OPC_RecordChild1, // #1 = $rhs
/* 16635*/  OPC_SwitchType /*4 cases */, 7, MVT::f32,// ->16645
/* 16638*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::MUL_F32),
                 MVT::f32, 2/*#Ops*/, 0, 1, 
             // Src: (fmul:{ *:[f32] } F32:{ *:[f32] }:$lhs, F32:{ *:[f32] }:$rhs) - Complexity = 3
             // Dst: (MUL_F32:{ *:[f32] } F32:{ *:[f32] }:$lhs, F32:{ *:[f32] }:$rhs)
/* 16645*/  /*SwitchType*/ 7, MVT::f64,// ->16654
/* 16647*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::MUL_F64),
                 MVT::f64, 2/*#Ops*/, 0, 1, 
             // Src: (fmul:{ *:[f64] } F64:{ *:[f64] }:$lhs, F64:{ *:[f64] }:$rhs) - Complexity = 3
             // Dst: (MUL_F64:{ *:[f64] } F64:{ *:[f64] }:$lhs, F64:{ *:[f64] }:$rhs)
/* 16654*/  /*SwitchType*/ 8, MVT::v4f32,// ->16664
/* 16656*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 16657*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::MUL_F32x4),
                 MVT::v4f32, 2/*#Ops*/, 0, 1, 
             // Src: (fmul:{ *:[v4f32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs) - Complexity = 3
             // Dst: (MUL_F32x4:{ *:[v4f32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs)
/* 16664*/  /*SwitchType*/ 8, MVT::v2f64,// ->16674
/* 16666*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 16667*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::MUL_F64x2),
                 MVT::v2f64, 2/*#Ops*/, 0, 1, 
             // Src: (fmul:{ *:[v2f64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs) - Complexity = 3
             // Dst: (MUL_F64x2:{ *:[v2f64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs)
/* 16674*/  0, // EndSwitchType
/* 16675*/ /*SwitchOpcode*/ 42, TARGET_VAL(ISD::FDIV),// ->16720
/* 16678*/  OPC_RecordChild0, // #0 = $lhs
/* 16679*/  OPC_RecordChild1, // #1 = $rhs
/* 16680*/  OPC_SwitchType /*4 cases */, 7, MVT::f32,// ->16690
/* 16683*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::DIV_F32),
                 MVT::f32, 2/*#Ops*/, 0, 1, 
             // Src: (fdiv:{ *:[f32] } F32:{ *:[f32] }:$lhs, F32:{ *:[f32] }:$rhs) - Complexity = 3
             // Dst: (DIV_F32:{ *:[f32] } F32:{ *:[f32] }:$lhs, F32:{ *:[f32] }:$rhs)
/* 16690*/  /*SwitchType*/ 7, MVT::f64,// ->16699
/* 16692*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::DIV_F64),
                 MVT::f64, 2/*#Ops*/, 0, 1, 
             // Src: (fdiv:{ *:[f64] } F64:{ *:[f64] }:$lhs, F64:{ *:[f64] }:$rhs) - Complexity = 3
             // Dst: (DIV_F64:{ *:[f64] } F64:{ *:[f64] }:$lhs, F64:{ *:[f64] }:$rhs)
/* 16699*/  /*SwitchType*/ 8, MVT::v4f32,// ->16709
/* 16701*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 16702*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::DIV_F32x4),
                 MVT::v4f32, 2/*#Ops*/, 0, 1, 
             // Src: (fdiv:{ *:[v4f32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs) - Complexity = 3
             // Dst: (DIV_F32x4:{ *:[v4f32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs)
/* 16709*/  /*SwitchType*/ 8, MVT::v2f64,// ->16719
/* 16711*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 16712*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::DIV_F64x2),
                 MVT::v2f64, 2/*#Ops*/, 0, 1, 
             // Src: (fdiv:{ *:[v2f64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs) - Complexity = 3
             // Dst: (DIV_F64x2:{ *:[v2f64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs)
/* 16719*/  0, // EndSwitchType
/* 16720*/ /*SwitchOpcode*/ 37, TARGET_VAL(ISD::FSQRT),// ->16760
/* 16723*/  OPC_RecordChild0, // #0 = $src
/* 16724*/  OPC_SwitchType /*4 cases */, 6, MVT::f32,// ->16733
/* 16727*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SQRT_F32),
                 MVT::f32, 1/*#Ops*/, 0, 
             // Src: (fsqrt:{ *:[f32] } F32:{ *:[f32] }:$src) - Complexity = 3
             // Dst: (SQRT_F32:{ *:[f32] } F32:{ *:[f32] }:$src)
/* 16733*/  /*SwitchType*/ 6, MVT::f64,// ->16741
/* 16735*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SQRT_F64),
                 MVT::f64, 1/*#Ops*/, 0, 
             // Src: (fsqrt:{ *:[f64] } F64:{ *:[f64] }:$src) - Complexity = 3
             // Dst: (SQRT_F64:{ *:[f64] } F64:{ *:[f64] }:$src)
/* 16741*/  /*SwitchType*/ 7, MVT::v4f32,// ->16750
/* 16743*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 16744*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SQRT_F32x4),
                 MVT::v4f32, 1/*#Ops*/, 0, 
             // Src: (fsqrt:{ *:[v4f32] } V128:{ *:[v4f32] }:$v) - Complexity = 3
             // Dst: (SQRT_F32x4:{ *:[v4f32] } V128:{ *:[v4f32] }:$v)
/* 16750*/  /*SwitchType*/ 7, MVT::v2f64,// ->16759
/* 16752*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 16753*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SQRT_F64x2),
                 MVT::v2f64, 1/*#Ops*/, 0, 
             // Src: (fsqrt:{ *:[v2f64] } V128:{ *:[v2f64] }:$v) - Complexity = 3
             // Dst: (SQRT_F64x2:{ *:[v2f64] } V128:{ *:[v2f64] }:$v)
/* 16759*/  0, // EndSwitchType
/* 16760*/ /*SwitchOpcode*/ 37, TARGET_VAL(ISD::FABS),// ->16800
/* 16763*/  OPC_RecordChild0, // #0 = $src
/* 16764*/  OPC_SwitchType /*4 cases */, 6, MVT::f32,// ->16773
/* 16767*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ABS_F32),
                 MVT::f32, 1/*#Ops*/, 0, 
             // Src: (fabs:{ *:[f32] } F32:{ *:[f32] }:$src) - Complexity = 3
             // Dst: (ABS_F32:{ *:[f32] } F32:{ *:[f32] }:$src)
/* 16773*/  /*SwitchType*/ 6, MVT::f64,// ->16781
/* 16775*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ABS_F64),
                 MVT::f64, 1/*#Ops*/, 0, 
             // Src: (fabs:{ *:[f64] } F64:{ *:[f64] }:$src) - Complexity = 3
             // Dst: (ABS_F64:{ *:[f64] } F64:{ *:[f64] }:$src)
/* 16781*/  /*SwitchType*/ 7, MVT::v4f32,// ->16790
/* 16783*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 16784*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ABS_F32x4),
                 MVT::v4f32, 1/*#Ops*/, 0, 
             // Src: (fabs:{ *:[v4f32] } V128:{ *:[v4f32] }:$v) - Complexity = 3
             // Dst: (ABS_F32x4:{ *:[v4f32] } V128:{ *:[v4f32] }:$v)
/* 16790*/  /*SwitchType*/ 7, MVT::v2f64,// ->16799
/* 16792*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 16793*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ABS_F64x2),
                 MVT::v2f64, 1/*#Ops*/, 0, 
             // Src: (fabs:{ *:[v2f64] } V128:{ *:[v2f64] }:$v) - Complexity = 3
             // Dst: (ABS_F64x2:{ *:[v2f64] } V128:{ *:[v2f64] }:$v)
/* 16799*/  0, // EndSwitchType
/* 16800*/ /*SwitchOpcode*/ 37, TARGET_VAL(ISD::FNEG),// ->16840
/* 16803*/  OPC_RecordChild0, // #0 = $src
/* 16804*/  OPC_SwitchType /*4 cases */, 6, MVT::f32,// ->16813
/* 16807*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::NEG_F32),
                 MVT::f32, 1/*#Ops*/, 0, 
             // Src: (fneg:{ *:[f32] } F32:{ *:[f32] }:$src) - Complexity = 3
             // Dst: (NEG_F32:{ *:[f32] } F32:{ *:[f32] }:$src)
/* 16813*/  /*SwitchType*/ 6, MVT::f64,// ->16821
/* 16815*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::NEG_F64),
                 MVT::f64, 1/*#Ops*/, 0, 
             // Src: (fneg:{ *:[f64] } F64:{ *:[f64] }:$src) - Complexity = 3
             // Dst: (NEG_F64:{ *:[f64] } F64:{ *:[f64] }:$src)
/* 16821*/  /*SwitchType*/ 7, MVT::v4f32,// ->16830
/* 16823*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 16824*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::NEG_F32x4),
                 MVT::v4f32, 1/*#Ops*/, 0, 
             // Src: (fneg:{ *:[v4f32] } V128:{ *:[v4f32] }:$v) - Complexity = 3
             // Dst: (NEG_F32x4:{ *:[v4f32] } V128:{ *:[v4f32] }:$v)
/* 16830*/  /*SwitchType*/ 7, MVT::v2f64,// ->16839
/* 16832*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 16833*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::NEG_F64x2),
                 MVT::v2f64, 1/*#Ops*/, 0, 
             // Src: (fneg:{ *:[v2f64] } V128:{ *:[v2f64] }:$v) - Complexity = 3
             // Dst: (NEG_F64x2:{ *:[v2f64] } V128:{ *:[v2f64] }:$v)
/* 16839*/  0, // EndSwitchType
/* 16840*/ /*SwitchOpcode*/ 62, TARGET_VAL(ISD::FCOPYSIGN),// ->16905
/* 16843*/  OPC_RecordChild0, // #0 = $lhs
/* 16844*/  OPC_RecordChild1, // #1 = $rhs
/* 16845*/  OPC_Scope, 28, /*->16875*/ // 2 children in Scope
/* 16847*/   OPC_CheckChild1Type, MVT::f32,
/* 16849*/   OPC_SwitchType /*2 cases */, 7, MVT::f32,// ->16859
/* 16852*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::COPYSIGN_F32),
                  MVT::f32, 2/*#Ops*/, 0, 1, 
              // Src: (fcopysign:{ *:[f32] } F32:{ *:[f32] }:$lhs, F32:{ *:[f32] }:$rhs) - Complexity = 3
              // Dst: (COPYSIGN_F32:{ *:[f32] } F32:{ *:[f32] }:$lhs, F32:{ *:[f32] }:$rhs)
/* 16859*/   /*SwitchType*/ 13, MVT::f64,// ->16874
/* 16861*/    OPC_EmitNode1None, TARGET_VAL(WebAssembly::F64_PROMOTE_F32),
                  MVT::f64, 1/*#Ops*/, 1,  // Results = #2
/* 16867*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::COPYSIGN_F64),
                  MVT::f64, 2/*#Ops*/, 0, 2, 
              // Src: (fcopysign:{ *:[f64] } F64:{ *:[f64] }:$lhs, F32:{ *:[f32] }:$rhs) - Complexity = 3
              // Dst: (COPYSIGN_F64:{ *:[f64] } F64:{ *:[f64] }:$lhs, (F64_PROMOTE_F32:{ *:[f64] } F32:{ *:[f32] }:$rhs))
/* 16874*/   0, // EndSwitchType
/* 16875*/  /*Scope*/ 28, /*->16904*/
/* 16876*/   OPC_CheckChild1Type, MVT::f64,
/* 16878*/   OPC_SwitchType /*2 cases */, 7, MVT::f64,// ->16888
/* 16881*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::COPYSIGN_F64),
                  MVT::f64, 2/*#Ops*/, 0, 1, 
              // Src: (fcopysign:{ *:[f64] } F64:{ *:[f64] }:$lhs, F64:{ *:[f64] }:$rhs) - Complexity = 3
              // Dst: (COPYSIGN_F64:{ *:[f64] } F64:{ *:[f64] }:$lhs, F64:{ *:[f64] }:$rhs)
/* 16888*/   /*SwitchType*/ 13, MVT::f32,// ->16903
/* 16890*/    OPC_EmitNode1None, TARGET_VAL(WebAssembly::F32_DEMOTE_F64),
                  MVT::f32, 1/*#Ops*/, 1,  // Results = #2
/* 16896*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::COPYSIGN_F32),
                  MVT::f32, 2/*#Ops*/, 0, 2, 
              // Src: (fcopysign:{ *:[f32] } F32:{ *:[f32] }:$lhs, F64:{ *:[f64] }:$rhs) - Complexity = 3
              // Dst: (COPYSIGN_F32:{ *:[f32] } F32:{ *:[f32] }:$lhs, (F32_DEMOTE_F64:{ *:[f32] } F64:{ *:[f64] }:$rhs))
/* 16903*/   0, // EndSwitchType
/* 16904*/  0, /*End of Scope*/
/* 16905*/ /*SwitchOpcode*/ 42, TARGET_VAL(ISD::FMINIMUM),// ->16950
/* 16908*/  OPC_RecordChild0, // #0 = $lhs
/* 16909*/  OPC_RecordChild1, // #1 = $rhs
/* 16910*/  OPC_SwitchType /*4 cases */, 7, MVT::f32,// ->16920
/* 16913*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::MIN_F32),
                 MVT::f32, 2/*#Ops*/, 0, 1, 
             // Src: (fminimum:{ *:[f32] } F32:{ *:[f32] }:$lhs, F32:{ *:[f32] }:$rhs) - Complexity = 3
             // Dst: (MIN_F32:{ *:[f32] } F32:{ *:[f32] }:$lhs, F32:{ *:[f32] }:$rhs)
/* 16920*/  /*SwitchType*/ 7, MVT::f64,// ->16929
/* 16922*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::MIN_F64),
                 MVT::f64, 2/*#Ops*/, 0, 1, 
             // Src: (fminimum:{ *:[f64] } F64:{ *:[f64] }:$lhs, F64:{ *:[f64] }:$rhs) - Complexity = 3
             // Dst: (MIN_F64:{ *:[f64] } F64:{ *:[f64] }:$lhs, F64:{ *:[f64] }:$rhs)
/* 16929*/  /*SwitchType*/ 8, MVT::v4f32,// ->16939
/* 16931*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 16932*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::MIN_F32x4),
                 MVT::v4f32, 2/*#Ops*/, 0, 1, 
             // Src: (fminimum:{ *:[v4f32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs) - Complexity = 3
             // Dst: (MIN_F32x4:{ *:[v4f32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs)
/* 16939*/  /*SwitchType*/ 8, MVT::v2f64,// ->16949
/* 16941*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 16942*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::MIN_F64x2),
                 MVT::v2f64, 2/*#Ops*/, 0, 1, 
             // Src: (fminimum:{ *:[v2f64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs) - Complexity = 3
             // Dst: (MIN_F64x2:{ *:[v2f64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs)
/* 16949*/  0, // EndSwitchType
/* 16950*/ /*SwitchOpcode*/ 42, TARGET_VAL(ISD::FMAXIMUM),// ->16995
/* 16953*/  OPC_RecordChild0, // #0 = $lhs
/* 16954*/  OPC_RecordChild1, // #1 = $rhs
/* 16955*/  OPC_SwitchType /*4 cases */, 7, MVT::f32,// ->16965
/* 16958*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::MAX_F32),
                 MVT::f32, 2/*#Ops*/, 0, 1, 
             // Src: (fmaximum:{ *:[f32] } F32:{ *:[f32] }:$lhs, F32:{ *:[f32] }:$rhs) - Complexity = 3
             // Dst: (MAX_F32:{ *:[f32] } F32:{ *:[f32] }:$lhs, F32:{ *:[f32] }:$rhs)
/* 16965*/  /*SwitchType*/ 7, MVT::f64,// ->16974
/* 16967*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::MAX_F64),
                 MVT::f64, 2/*#Ops*/, 0, 1, 
             // Src: (fmaximum:{ *:[f64] } F64:{ *:[f64] }:$lhs, F64:{ *:[f64] }:$rhs) - Complexity = 3
             // Dst: (MAX_F64:{ *:[f64] } F64:{ *:[f64] }:$lhs, F64:{ *:[f64] }:$rhs)
/* 16974*/  /*SwitchType*/ 8, MVT::v4f32,// ->16984
/* 16976*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 16977*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::MAX_F32x4),
                 MVT::v4f32, 2/*#Ops*/, 0, 1, 
             // Src: (fmaximum:{ *:[v4f32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs) - Complexity = 3
             // Dst: (MAX_F32x4:{ *:[v4f32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs)
/* 16984*/  /*SwitchType*/ 8, MVT::v2f64,// ->16994
/* 16986*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 16987*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::MAX_F64x2),
                 MVT::v2f64, 2/*#Ops*/, 0, 1, 
             // Src: (fmaximum:{ *:[v2f64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs) - Complexity = 3
             // Dst: (MAX_F64x2:{ *:[v2f64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs)
/* 16994*/  0, // EndSwitchType
/* 16995*/ /*SwitchOpcode*/ 37, TARGET_VAL(ISD::FCEIL),// ->17035
/* 16998*/  OPC_RecordChild0, // #0 = $src
/* 16999*/  OPC_SwitchType /*4 cases */, 6, MVT::f32,// ->17008
/* 17002*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::CEIL_F32),
                 MVT::f32, 1/*#Ops*/, 0, 
             // Src: (fceil:{ *:[f32] } F32:{ *:[f32] }:$src) - Complexity = 3
             // Dst: (CEIL_F32:{ *:[f32] } F32:{ *:[f32] }:$src)
/* 17008*/  /*SwitchType*/ 6, MVT::f64,// ->17016
/* 17010*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::CEIL_F64),
                 MVT::f64, 1/*#Ops*/, 0, 
             // Src: (fceil:{ *:[f64] } F64:{ *:[f64] }:$src) - Complexity = 3
             // Dst: (CEIL_F64:{ *:[f64] } F64:{ *:[f64] }:$src)
/* 17016*/  /*SwitchType*/ 7, MVT::v4f32,// ->17025
/* 17018*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 17019*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::CEIL_F32x4),
                 MVT::v4f32, 1/*#Ops*/, 0, 
             // Src: (fceil:{ *:[v4f32] } V128:{ *:[v4f32] }:$v) - Complexity = 3
             // Dst: (CEIL_F32x4:{ *:[v4f32] } V128:{ *:[v4f32] }:$v)
/* 17025*/  /*SwitchType*/ 7, MVT::v2f64,// ->17034
/* 17027*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 17028*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::CEIL_F64x2),
                 MVT::v2f64, 1/*#Ops*/, 0, 
             // Src: (fceil:{ *:[v2f64] } V128:{ *:[v2f64] }:$v) - Complexity = 3
             // Dst: (CEIL_F64x2:{ *:[v2f64] } V128:{ *:[v2f64] }:$v)
/* 17034*/  0, // EndSwitchType
/* 17035*/ /*SwitchOpcode*/ 37, TARGET_VAL(ISD::FFLOOR),// ->17075
/* 17038*/  OPC_RecordChild0, // #0 = $src
/* 17039*/  OPC_SwitchType /*4 cases */, 6, MVT::f32,// ->17048
/* 17042*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::FLOOR_F32),
                 MVT::f32, 1/*#Ops*/, 0, 
             // Src: (ffloor:{ *:[f32] } F32:{ *:[f32] }:$src) - Complexity = 3
             // Dst: (FLOOR_F32:{ *:[f32] } F32:{ *:[f32] }:$src)
/* 17048*/  /*SwitchType*/ 6, MVT::f64,// ->17056
/* 17050*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::FLOOR_F64),
                 MVT::f64, 1/*#Ops*/, 0, 
             // Src: (ffloor:{ *:[f64] } F64:{ *:[f64] }:$src) - Complexity = 3
             // Dst: (FLOOR_F64:{ *:[f64] } F64:{ *:[f64] }:$src)
/* 17056*/  /*SwitchType*/ 7, MVT::v4f32,// ->17065
/* 17058*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 17059*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::FLOOR_F32x4),
                 MVT::v4f32, 1/*#Ops*/, 0, 
             // Src: (ffloor:{ *:[v4f32] } V128:{ *:[v4f32] }:$v) - Complexity = 3
             // Dst: (FLOOR_F32x4:{ *:[v4f32] } V128:{ *:[v4f32] }:$v)
/* 17065*/  /*SwitchType*/ 7, MVT::v2f64,// ->17074
/* 17067*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 17068*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::FLOOR_F64x2),
                 MVT::v2f64, 1/*#Ops*/, 0, 
             // Src: (ffloor:{ *:[v2f64] } V128:{ *:[v2f64] }:$v) - Complexity = 3
             // Dst: (FLOOR_F64x2:{ *:[v2f64] } V128:{ *:[v2f64] }:$v)
/* 17074*/  0, // EndSwitchType
/* 17075*/ /*SwitchOpcode*/ 37, TARGET_VAL(ISD::FTRUNC),// ->17115
/* 17078*/  OPC_RecordChild0, // #0 = $src
/* 17079*/  OPC_SwitchType /*4 cases */, 6, MVT::f32,// ->17088
/* 17082*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::TRUNC_F32),
                 MVT::f32, 1/*#Ops*/, 0, 
             // Src: (ftrunc:{ *:[f32] } F32:{ *:[f32] }:$src) - Complexity = 3
             // Dst: (TRUNC_F32:{ *:[f32] } F32:{ *:[f32] }:$src)
/* 17088*/  /*SwitchType*/ 6, MVT::f64,// ->17096
/* 17090*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::TRUNC_F64),
                 MVT::f64, 1/*#Ops*/, 0, 
             // Src: (ftrunc:{ *:[f64] } F64:{ *:[f64] }:$src) - Complexity = 3
             // Dst: (TRUNC_F64:{ *:[f64] } F64:{ *:[f64] }:$src)
/* 17096*/  /*SwitchType*/ 7, MVT::v4f32,// ->17105
/* 17098*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 17099*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::TRUNC_F32x4),
                 MVT::v4f32, 1/*#Ops*/, 0, 
             // Src: (ftrunc:{ *:[v4f32] } V128:{ *:[v4f32] }:$v) - Complexity = 3
             // Dst: (TRUNC_F32x4:{ *:[v4f32] } V128:{ *:[v4f32] }:$v)
/* 17105*/  /*SwitchType*/ 7, MVT::v2f64,// ->17114
/* 17107*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 17108*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::TRUNC_F64x2),
                 MVT::v2f64, 1/*#Ops*/, 0, 
             // Src: (ftrunc:{ *:[v2f64] } V128:{ *:[v2f64] }:$v) - Complexity = 3
             // Dst: (TRUNC_F64x2:{ *:[v2f64] } V128:{ *:[v2f64] }:$v)
/* 17114*/  0, // EndSwitchType
/* 17115*/ /*SwitchOpcode*/ 37, TARGET_VAL(ISD::FNEARBYINT),// ->17155
/* 17118*/  OPC_RecordChild0, // #0 = $src
/* 17119*/  OPC_SwitchType /*4 cases */, 6, MVT::f32,// ->17128
/* 17122*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::NEAREST_F32),
                 MVT::f32, 1/*#Ops*/, 0, 
             // Src: (fnearbyint:{ *:[f32] } F32:{ *:[f32] }:$src) - Complexity = 3
             // Dst: (NEAREST_F32:{ *:[f32] } F32:{ *:[f32] }:$src)
/* 17128*/  /*SwitchType*/ 6, MVT::f64,// ->17136
/* 17130*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::NEAREST_F64),
                 MVT::f64, 1/*#Ops*/, 0, 
             // Src: (fnearbyint:{ *:[f64] } F64:{ *:[f64] }:$src) - Complexity = 3
             // Dst: (NEAREST_F64:{ *:[f64] } F64:{ *:[f64] }:$src)
/* 17136*/  /*SwitchType*/ 7, MVT::v4f32,// ->17145
/* 17138*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 17139*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::NEAREST_F32x4),
                 MVT::v4f32, 1/*#Ops*/, 0, 
             // Src: (fnearbyint:{ *:[v4f32] } V128:{ *:[v4f32] }:$v) - Complexity = 3
             // Dst: (NEAREST_F32x4:{ *:[v4f32] } V128:{ *:[v4f32] }:$v)
/* 17145*/  /*SwitchType*/ 7, MVT::v2f64,// ->17154
/* 17147*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 17148*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::NEAREST_F64x2),
                 MVT::v2f64, 1/*#Ops*/, 0, 
             // Src: (fnearbyint:{ *:[v2f64] } V128:{ *:[v2f64] }:$v) - Complexity = 3
             // Dst: (NEAREST_F64x2:{ *:[v2f64] } V128:{ *:[v2f64] }:$v)
/* 17154*/  0, // EndSwitchType
/* 17155*/ /*SwitchOpcode*/ 35, TARGET_VAL(ISD::FRINT),// ->17193
/* 17158*/  OPC_RecordChild0, // #0 = $src
/* 17159*/  OPC_SwitchType /*4 cases */, 6, MVT::f32,// ->17168
/* 17162*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::NEAREST_F32),
                 MVT::f32, 1/*#Ops*/, 0, 
             // Src: (frint:{ *:[f32] } f32:{ *:[f32] }:$src) - Complexity = 3
             // Dst: (NEAREST_F32:{ *:[f32] } f32:{ *:[f32] }:$src)
/* 17168*/  /*SwitchType*/ 6, MVT::f64,// ->17176
/* 17170*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::NEAREST_F64),
                 MVT::f64, 1/*#Ops*/, 0, 
             // Src: (frint:{ *:[f64] } f64:{ *:[f64] }:$src) - Complexity = 3
             // Dst: (NEAREST_F64:{ *:[f64] } f64:{ *:[f64] }:$src)
/* 17176*/  /*SwitchType*/ 6, MVT::v4f32,// ->17184
/* 17178*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::NEAREST_F32x4),
                 MVT::v4f32, 1/*#Ops*/, 0, 
             // Src: (frint:{ *:[v4f32] } V128:{ *:[v4f32] }:$src) - Complexity = 3
             // Dst: (NEAREST_F32x4:{ *:[v4f32] } V128:{ *:[v4f32] }:$src)
/* 17184*/  /*SwitchType*/ 6, MVT::v2f64,// ->17192
/* 17186*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::NEAREST_F64x2),
                 MVT::v2f64, 1/*#Ops*/, 0, 
             // Src: (frint:{ *:[v2f64] } V128:{ *:[v2f64] }:$src) - Complexity = 3
             // Dst: (NEAREST_F64x2:{ *:[v2f64] } V128:{ *:[v2f64] }:$src)
/* 17192*/  0, // EndSwitchType
/* 17193*/ /*SwitchOpcode*/ 35, TARGET_VAL(ISD::FROUNDEVEN),// ->17231
/* 17196*/  OPC_RecordChild0, // #0 = $src
/* 17197*/  OPC_SwitchType /*4 cases */, 6, MVT::f32,// ->17206
/* 17200*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::NEAREST_F32),
                 MVT::f32, 1/*#Ops*/, 0, 
             // Src: (froundeven:{ *:[f32] } f32:{ *:[f32] }:$src) - Complexity = 3
             // Dst: (NEAREST_F32:{ *:[f32] } f32:{ *:[f32] }:$src)
/* 17206*/  /*SwitchType*/ 6, MVT::f64,// ->17214
/* 17208*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::NEAREST_F64),
                 MVT::f64, 1/*#Ops*/, 0, 
             // Src: (froundeven:{ *:[f64] } f64:{ *:[f64] }:$src) - Complexity = 3
             // Dst: (NEAREST_F64:{ *:[f64] } f64:{ *:[f64] }:$src)
/* 17214*/  /*SwitchType*/ 6, MVT::v4f32,// ->17222
/* 17216*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::NEAREST_F32x4),
                 MVT::v4f32, 1/*#Ops*/, 0, 
             // Src: (froundeven:{ *:[v4f32] } V128:{ *:[v4f32] }:$src) - Complexity = 3
             // Dst: (NEAREST_F32x4:{ *:[v4f32] } V128:{ *:[v4f32] }:$src)
/* 17222*/  /*SwitchType*/ 6, MVT::v2f64,// ->17230
/* 17224*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::NEAREST_F64x2),
                 MVT::v2f64, 1/*#Ops*/, 0, 
             // Src: (froundeven:{ *:[v2f64] } V128:{ *:[v2f64] }:$src) - Complexity = 3
             // Dst: (NEAREST_F64x2:{ *:[v2f64] } V128:{ *:[v2f64] }:$src)
/* 17230*/  0, // EndSwitchType
/* 17231*/ /*SwitchOpcode*/ 20|128,3/*404*/, TARGET_VAL(ISD::BUILD_VECTOR),// ->17639
/* 17235*/  OPC_RecordChild0, // #0 = $i0
/* 17236*/  OPC_MoveChild0,
/* 17237*/  OPC_SwitchOpcode /*2 cases */, 73|128,2/*329*/, TARGET_VAL(ISD::Constant),// ->17571
/* 17242*/   OPC_SwitchType /*2 cases */, 47|128,2/*303*/, MVT::i32,// ->17549
/* 17246*/    OPC_Scope, 51|128,1/*179*/, /*->17428*/ // 3 children in Scope
/* 17249*/     OPC_CheckPredicate, 8, // Predicate_ImmI8
/* 17251*/     OPC_MoveSibling1,
/* 17252*/     OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 17255*/     OPC_RecordNode, // #1 = $i1
/* 17256*/     OPC_CheckPredicate, 8, // Predicate_ImmI8
/* 17258*/     OPC_CheckTypeI32,
/* 17259*/     OPC_MoveSibling2,
/* 17260*/     OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 17263*/     OPC_RecordNode, // #2 = $i2
/* 17264*/     OPC_CheckPredicate, 8, // Predicate_ImmI8
/* 17266*/     OPC_CheckTypeI32,
/* 17267*/     OPC_MoveSibling3,
/* 17268*/     OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 17271*/     OPC_RecordNode, // #3 = $i3
/* 17272*/     OPC_CheckPredicate, 8, // Predicate_ImmI8
/* 17274*/     OPC_CheckTypeI32,
/* 17275*/     OPC_MoveSibling4,
/* 17276*/     OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 17279*/     OPC_RecordNode, // #4 = $i4
/* 17280*/     OPC_CheckPredicate, 8, // Predicate_ImmI8
/* 17282*/     OPC_CheckTypeI32,
/* 17283*/     OPC_MoveSibling5,
/* 17284*/     OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 17287*/     OPC_RecordNode, // #5 = $i5
/* 17288*/     OPC_CheckPredicate, 8, // Predicate_ImmI8
/* 17290*/     OPC_CheckTypeI32,
/* 17291*/     OPC_MoveSibling6,
/* 17292*/     OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 17295*/     OPC_RecordNode, // #6 = $i6
/* 17296*/     OPC_CheckPredicate, 8, // Predicate_ImmI8
/* 17298*/     OPC_CheckTypeI32,
/* 17299*/     OPC_MoveSibling7,
/* 17300*/     OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 17303*/     OPC_RecordNode, // #7 = $i7
/* 17304*/     OPC_CheckPredicate, 8, // Predicate_ImmI8
/* 17306*/     OPC_CheckTypeI32,
/* 17307*/     OPC_MoveSibling, 8,
/* 17309*/     OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 17312*/     OPC_RecordNode, // #8 = $i8
/* 17313*/     OPC_CheckPredicate, 8, // Predicate_ImmI8
/* 17315*/     OPC_CheckTypeI32,
/* 17316*/     OPC_MoveSibling, 9,
/* 17318*/     OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 17321*/     OPC_RecordNode, // #9 = $i9
/* 17322*/     OPC_CheckPredicate, 8, // Predicate_ImmI8
/* 17324*/     OPC_CheckTypeI32,
/* 17325*/     OPC_MoveSibling, 10,
/* 17327*/     OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 17330*/     OPC_RecordNode, // #10 = $iA
/* 17331*/     OPC_CheckPredicate, 8, // Predicate_ImmI8
/* 17333*/     OPC_CheckTypeI32,
/* 17334*/     OPC_MoveSibling, 11,
/* 17336*/     OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 17339*/     OPC_RecordNode, // #11 = $iB
/* 17340*/     OPC_CheckPredicate, 8, // Predicate_ImmI8
/* 17342*/     OPC_CheckTypeI32,
/* 17343*/     OPC_MoveSibling, 12,
/* 17345*/     OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 17348*/     OPC_RecordNode, // #12 = $iC
/* 17349*/     OPC_CheckPredicate, 8, // Predicate_ImmI8
/* 17351*/     OPC_CheckTypeI32,
/* 17352*/     OPC_MoveSibling, 13,
/* 17354*/     OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 17357*/     OPC_RecordNode, // #13 = $iD
/* 17358*/     OPC_CheckPredicate, 8, // Predicate_ImmI8
/* 17360*/     OPC_CheckTypeI32,
/* 17361*/     OPC_MoveSibling, 14,
/* 17363*/     OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 17366*/     OPC_RecordNode, // #14 = $iE
/* 17367*/     OPC_CheckPredicate, 8, // Predicate_ImmI8
/* 17369*/     OPC_CheckTypeI32,
/* 17370*/     OPC_MoveSibling, 15,
/* 17372*/     OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 17375*/     OPC_RecordNode, // #15 = $iF
/* 17376*/     OPC_CheckPredicate, 8, // Predicate_ImmI8
/* 17378*/     OPC_CheckTypeI32,
/* 17379*/     OPC_MoveParent,
/* 17380*/     OPC_CheckType, MVT::v16i8,
/* 17382*/     OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 17383*/     OPC_EmitConvertToTarget0,
/* 17384*/     OPC_EmitConvertToTarget1,
/* 17385*/     OPC_EmitConvertToTarget2,
/* 17386*/     OPC_EmitConvertToTarget3,
/* 17387*/     OPC_EmitConvertToTarget4,
/* 17388*/     OPC_EmitConvertToTarget5,
/* 17389*/     OPC_EmitConvertToTarget6,
/* 17390*/     OPC_EmitConvertToTarget7,
/* 17391*/     OPC_EmitConvertToTarget, 8,
/* 17393*/     OPC_EmitConvertToTarget, 9,
/* 17395*/     OPC_EmitConvertToTarget, 10,
/* 17397*/     OPC_EmitConvertToTarget, 11,
/* 17399*/     OPC_EmitConvertToTarget, 12,
/* 17401*/     OPC_EmitConvertToTarget, 13,
/* 17403*/     OPC_EmitConvertToTarget, 14,
/* 17405*/     OPC_EmitConvertToTarget, 15,
/* 17407*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::CONST_V128_I8x16),
                   MVT::v16i8, 16/*#Ops*/, 16, 17, 18, 19, 20, 21, 22, 23, 24, 25, 26, 27, 28, 29, 30, 31, 
               // Src: (build_vector:{ *:[v16i8] } (imm:{ *:[i32] })<<P:Predicate_ImmI8>>:$i0, (imm:{ *:[i32] })<<P:Predicate_ImmI8>>:$i1, (imm:{ *:[i32] })<<P:Predicate_ImmI8>>:$i2, (imm:{ *:[i32] })<<P:Predicate_ImmI8>>:$i3, (imm:{ *:[i32] })<<P:Predicate_ImmI8>>:$i4, (imm:{ *:[i32] })<<P:Predicate_ImmI8>>:$i5, (imm:{ *:[i32] })<<P:Predicate_ImmI8>>:$i6, (imm:{ *:[i32] })<<P:Predicate_ImmI8>>:$i7, (imm:{ *:[i32] })<<P:Predicate_ImmI8>>:$i8, (imm:{ *:[i32] })<<P:Predicate_ImmI8>>:$i9, (imm:{ *:[i32] })<<P:Predicate_ImmI8>>:$iA, (imm:{ *:[i32] })<<P:Predicate_ImmI8>>:$iB, (imm:{ *:[i32] })<<P:Predicate_ImmI8>>:$iC, (imm:{ *:[i32] })<<P:Predicate_ImmI8>>:$iD, (imm:{ *:[i32] })<<P:Predicate_ImmI8>>:$iE, (imm:{ *:[i32] })<<P:Predicate_ImmI8>>:$iF) - Complexity = 67
               // Dst: (CONST_V128_I8x16:{ *:[v16i8] } (imm:{ *:[i32] }):$i0, (imm:{ *:[i32] }):$i1, (imm:{ *:[i32] }):$i2, (imm:{ *:[i32] }):$i3, (imm:{ *:[i32] }):$i4, (imm:{ *:[i32] }):$i5, (imm:{ *:[i32] }):$i6, (imm:{ *:[i32] }):$i7, (imm:{ *:[i32] }):$i8, (imm:{ *:[i32] }):$i9, (imm:{ *:[i32] }):$iA, (imm:{ *:[i32] }):$iB, (imm:{ *:[i32] }):$iC, (imm:{ *:[i32] }):$iD, (imm:{ *:[i32] }):$iE, (imm:{ *:[i32] }):$iF)
/* 17428*/    /*Scope*/ 83, /*->17512*/
/* 17429*/     OPC_CheckPredicate, 14, // Predicate_ImmI16
/* 17431*/     OPC_MoveSibling1,
/* 17432*/     OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 17435*/     OPC_RecordNode, // #1 = $i1
/* 17436*/     OPC_CheckPredicate, 14, // Predicate_ImmI16
/* 17438*/     OPC_CheckTypeI32,
/* 17439*/     OPC_MoveSibling2,
/* 17440*/     OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 17443*/     OPC_RecordNode, // #2 = $i2
/* 17444*/     OPC_CheckPredicate, 14, // Predicate_ImmI16
/* 17446*/     OPC_CheckTypeI32,
/* 17447*/     OPC_MoveSibling3,
/* 17448*/     OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 17451*/     OPC_RecordNode, // #3 = $i3
/* 17452*/     OPC_CheckPredicate, 14, // Predicate_ImmI16
/* 17454*/     OPC_CheckTypeI32,
/* 17455*/     OPC_MoveSibling4,
/* 17456*/     OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 17459*/     OPC_RecordNode, // #4 = $i4
/* 17460*/     OPC_CheckPredicate, 14, // Predicate_ImmI16
/* 17462*/     OPC_CheckTypeI32,
/* 17463*/     OPC_MoveSibling5,
/* 17464*/     OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 17467*/     OPC_RecordNode, // #5 = $i5
/* 17468*/     OPC_CheckPredicate, 14, // Predicate_ImmI16
/* 17470*/     OPC_CheckTypeI32,
/* 17471*/     OPC_MoveSibling6,
/* 17472*/     OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 17475*/     OPC_RecordNode, // #6 = $i6
/* 17476*/     OPC_CheckPredicate, 14, // Predicate_ImmI16
/* 17478*/     OPC_CheckTypeI32,
/* 17479*/     OPC_MoveSibling7,
/* 17480*/     OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 17483*/     OPC_RecordNode, // #7 = $i7
/* 17484*/     OPC_CheckPredicate, 14, // Predicate_ImmI16
/* 17486*/     OPC_CheckTypeI32,
/* 17487*/     OPC_MoveParent,
/* 17488*/     OPC_CheckType, MVT::v8i16,
/* 17490*/     OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 17491*/     OPC_EmitConvertToTarget0,
/* 17492*/     OPC_EmitConvertToTarget1,
/* 17493*/     OPC_EmitConvertToTarget2,
/* 17494*/     OPC_EmitConvertToTarget3,
/* 17495*/     OPC_EmitConvertToTarget4,
/* 17496*/     OPC_EmitConvertToTarget5,
/* 17497*/     OPC_EmitConvertToTarget6,
/* 17498*/     OPC_EmitConvertToTarget7,
/* 17499*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::CONST_V128_I16x8),
                   MVT::v8i16, 8/*#Ops*/, 8, 9, 10, 11, 12, 13, 14, 15, 
               // Src: (build_vector:{ *:[v8i16] } (imm:{ *:[i32] })<<P:Predicate_ImmI16>>:$i0, (imm:{ *:[i32] })<<P:Predicate_ImmI16>>:$i1, (imm:{ *:[i32] })<<P:Predicate_ImmI16>>:$i2, (imm:{ *:[i32] })<<P:Predicate_ImmI16>>:$i3, (imm:{ *:[i32] })<<P:Predicate_ImmI16>>:$i4, (imm:{ *:[i32] })<<P:Predicate_ImmI16>>:$i5, (imm:{ *:[i32] })<<P:Predicate_ImmI16>>:$i6, (imm:{ *:[i32] })<<P:Predicate_ImmI16>>:$i7) - Complexity = 35
               // Dst: (CONST_V128_I16x8:{ *:[v8i16] } (imm:{ *:[i32] }):$i0, (imm:{ *:[i32] }):$i1, (imm:{ *:[i32] }):$i2, (imm:{ *:[i32] }):$i3, (imm:{ *:[i32] }):$i4, (imm:{ *:[i32] }):$i5, (imm:{ *:[i32] }):$i6, (imm:{ *:[i32] }):$i7)
/* 17512*/    /*Scope*/ 35, /*->17548*/
/* 17513*/     OPC_MoveSibling1,
/* 17514*/     OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 17517*/     OPC_RecordNode, // #1 = $i1
/* 17518*/     OPC_CheckTypeI32,
/* 17519*/     OPC_MoveSibling2,
/* 17520*/     OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 17523*/     OPC_RecordNode, // #2 = $i2
/* 17524*/     OPC_CheckTypeI32,
/* 17525*/     OPC_MoveSibling3,
/* 17526*/     OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 17529*/     OPC_RecordNode, // #3 = $i3
/* 17530*/     OPC_CheckTypeI32,
/* 17531*/     OPC_MoveParent,
/* 17532*/     OPC_CheckType, MVT::v4i32,
/* 17534*/     OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 17535*/     OPC_EmitConvertToTarget0,
/* 17536*/     OPC_EmitConvertToTarget1,
/* 17537*/     OPC_EmitConvertToTarget2,
/* 17538*/     OPC_EmitConvertToTarget3,
/* 17539*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::CONST_V128_I32x4),
                   MVT::v4i32, 4/*#Ops*/, 4, 5, 6, 7, 
               // Src: (build_vector:{ *:[v4i32] } (imm:{ *:[i32] }):$i0, (imm:{ *:[i32] }):$i1, (imm:{ *:[i32] }):$i2, (imm:{ *:[i32] }):$i3) - Complexity = 15
               // Dst: (CONST_V128_I32x4:{ *:[v4i32] } (imm:{ *:[i32] }):$i0, (imm:{ *:[i32] }):$i1, (imm:{ *:[i32] }):$i2, (imm:{ *:[i32] }):$i3)
/* 17548*/    0, /*End of Scope*/
/* 17549*/   /*SwitchType*/ 19, MVT::i64,// ->17570
/* 17551*/    OPC_MoveSibling1,
/* 17552*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 17555*/    OPC_RecordNode, // #1 = $i1
/* 17556*/    OPC_CheckTypeI64,
/* 17557*/    OPC_MoveParent,
/* 17558*/    OPC_CheckType, MVT::v2i64,
/* 17560*/    OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 17561*/    OPC_EmitConvertToTarget0,
/* 17562*/    OPC_EmitConvertToTarget1,
/* 17563*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::CONST_V128_I64x2),
                  MVT::v2i64, 2/*#Ops*/, 2, 3, 
              // Src: (build_vector:{ *:[v2i64] } (imm:{ *:[i64] }):$i0, (imm:{ *:[i64] }):$i1) - Complexity = 9
              // Dst: (CONST_V128_I64x2:{ *:[v2i64] } (imm:{ *:[i64] }):$i0, (imm:{ *:[i64] }):$i1)
/* 17570*/   0, // EndSwitchType
/* 17571*/  /*SwitchOpcode*/ 64, TARGET_VAL(ISD::ConstantFP),// ->17638
/* 17574*/   OPC_SwitchType /*2 cases */, 38, MVT::f32,// ->17615
/* 17577*/    OPC_MoveSibling1,
/* 17578*/    OPC_CheckOpcode, TARGET_VAL(ISD::ConstantFP),
/* 17581*/    OPC_RecordNode, // #1 = $i1
/* 17582*/    OPC_CheckType, MVT::f32,
/* 17584*/    OPC_MoveSibling2,
/* 17585*/    OPC_CheckOpcode, TARGET_VAL(ISD::ConstantFP),
/* 17588*/    OPC_RecordNode, // #2 = $i2
/* 17589*/    OPC_CheckType, MVT::f32,
/* 17591*/    OPC_MoveSibling3,
/* 17592*/    OPC_CheckOpcode, TARGET_VAL(ISD::ConstantFP),
/* 17595*/    OPC_RecordNode, // #3 = $i3
/* 17596*/    OPC_CheckType, MVT::f32,
/* 17598*/    OPC_MoveParent,
/* 17599*/    OPC_CheckType, MVT::v4f32,
/* 17601*/    OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 17602*/    OPC_EmitConvertToTarget0,
/* 17603*/    OPC_EmitConvertToTarget1,
/* 17604*/    OPC_EmitConvertToTarget2,
/* 17605*/    OPC_EmitConvertToTarget3,
/* 17606*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::CONST_V128_F32x4),
                  MVT::v4f32, 4/*#Ops*/, 4, 5, 6, 7, 
              // Src: (build_vector:{ *:[v4f32] } (fpimm:{ *:[f32] }):$i0, (fpimm:{ *:[f32] }):$i1, (fpimm:{ *:[f32] }):$i2, (fpimm:{ *:[f32] }):$i3) - Complexity = 15
              // Dst: (CONST_V128_F32x4:{ *:[v4f32] } (fpimm:{ *:[f32] }):$i0, (fpimm:{ *:[f32] }):$i1, (fpimm:{ *:[f32] }):$i2, (fpimm:{ *:[f32] }):$i3)
/* 17615*/   /*SwitchType*/ 20, MVT::f64,// ->17637
/* 17617*/    OPC_MoveSibling1,
/* 17618*/    OPC_CheckOpcode, TARGET_VAL(ISD::ConstantFP),
/* 17621*/    OPC_RecordNode, // #1 = $i1
/* 17622*/    OPC_CheckType, MVT::f64,
/* 17624*/    OPC_MoveParent,
/* 17625*/    OPC_CheckType, MVT::v2f64,
/* 17627*/    OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 17628*/    OPC_EmitConvertToTarget0,
/* 17629*/    OPC_EmitConvertToTarget1,
/* 17630*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::CONST_V128_F64x2),
                  MVT::v2f64, 2/*#Ops*/, 2, 3, 
              // Src: (build_vector:{ *:[v2f64] } (fpimm:{ *:[f64] }):$i0, (fpimm:{ *:[f64] }):$i1) - Complexity = 9
              // Dst: (CONST_V128_F64x2:{ *:[v2f64] } (fpimm:{ *:[f64] }):$i0, (fpimm:{ *:[f64] }):$i1)
/* 17637*/   0, // EndSwitchType
/* 17638*/  0, // EndSwitchOpcode
/* 17639*/ /*SwitchOpcode*/ 1|128,16/*2049*/, TARGET_VAL(WebAssemblyISD::SHUFFLE),// ->19692
/* 17643*/  OPC_RecordChild0, // #0 = $x
/* 17644*/  OPC_Scope, 83|128,2/*339*/, /*->17986*/ // 6 children in Scope
/* 17647*/   OPC_CheckChild0Type, MVT::v16i8,
/* 17649*/   OPC_RecordChild1, // #1 = $y
/* 17650*/   OPC_CheckChild1Type, MVT::v16i8,
/* 17652*/   OPC_RecordChild2, // #2 = $m0
/* 17653*/   OPC_MoveChild2,
/* 17654*/   OPC_SwitchOpcode /*2 cases */, 41|128,1/*169*/, TARGET_VAL(ISD::Constant),// ->17828
/* 17659*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 17660*/    OPC_CheckTypeI32,
/* 17661*/    OPC_MoveSibling3,
/* 17662*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 17665*/    OPC_RecordNode, // #3 = $m1
/* 17666*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 17667*/    OPC_CheckTypeI32,
/* 17668*/    OPC_MoveSibling4,
/* 17669*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 17672*/    OPC_RecordNode, // #4 = $m2
/* 17673*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 17674*/    OPC_CheckTypeI32,
/* 17675*/    OPC_MoveSibling5,
/* 17676*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 17679*/    OPC_RecordNode, // #5 = $m3
/* 17680*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 17681*/    OPC_CheckTypeI32,
/* 17682*/    OPC_MoveSibling6,
/* 17683*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 17686*/    OPC_RecordNode, // #6 = $m4
/* 17687*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 17688*/    OPC_CheckTypeI32,
/* 17689*/    OPC_MoveSibling7,
/* 17690*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 17693*/    OPC_RecordNode, // #7 = $m5
/* 17694*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 17695*/    OPC_CheckTypeI32,
/* 17696*/    OPC_MoveSibling, 8,
/* 17698*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 17701*/    OPC_RecordNode, // #8 = $m6
/* 17702*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 17703*/    OPC_CheckTypeI32,
/* 17704*/    OPC_MoveSibling, 9,
/* 17706*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 17709*/    OPC_RecordNode, // #9 = $m7
/* 17710*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 17711*/    OPC_CheckTypeI32,
/* 17712*/    OPC_MoveSibling, 10,
/* 17714*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 17717*/    OPC_RecordNode, // #10 = $m8
/* 17718*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 17719*/    OPC_CheckTypeI32,
/* 17720*/    OPC_MoveSibling, 11,
/* 17722*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 17725*/    OPC_RecordNode, // #11 = $m9
/* 17726*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 17727*/    OPC_CheckTypeI32,
/* 17728*/    OPC_MoveSibling, 12,
/* 17730*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 17733*/    OPC_RecordNode, // #12 = $mA
/* 17734*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 17735*/    OPC_CheckTypeI32,
/* 17736*/    OPC_MoveSibling, 13,
/* 17738*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 17741*/    OPC_RecordNode, // #13 = $mB
/* 17742*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 17743*/    OPC_CheckTypeI32,
/* 17744*/    OPC_MoveSibling, 14,
/* 17746*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 17749*/    OPC_RecordNode, // #14 = $mC
/* 17750*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 17751*/    OPC_CheckTypeI32,
/* 17752*/    OPC_MoveSibling, 15,
/* 17754*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 17757*/    OPC_RecordNode, // #15 = $mD
/* 17758*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 17759*/    OPC_CheckTypeI32,
/* 17760*/    OPC_MoveSibling, 16,
/* 17762*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 17765*/    OPC_RecordNode, // #16 = $mE
/* 17766*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 17767*/    OPC_CheckTypeI32,
/* 17768*/    OPC_MoveSibling, 17,
/* 17770*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 17773*/    OPC_RecordNode, // #17 = $mF
/* 17774*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 17775*/    OPC_CheckTypeI32,
/* 17776*/    OPC_MoveParent,
/* 17777*/    OPC_CheckType, MVT::v16i8,
/* 17779*/    OPC_EmitConvertToTarget2,
/* 17780*/    OPC_EmitConvertToTarget3,
/* 17781*/    OPC_EmitConvertToTarget4,
/* 17782*/    OPC_EmitConvertToTarget5,
/* 17783*/    OPC_EmitConvertToTarget6,
/* 17784*/    OPC_EmitConvertToTarget7,
/* 17785*/    OPC_EmitConvertToTarget, 8,
/* 17787*/    OPC_EmitConvertToTarget, 9,
/* 17789*/    OPC_EmitConvertToTarget, 10,
/* 17791*/    OPC_EmitConvertToTarget, 11,
/* 17793*/    OPC_EmitConvertToTarget, 12,
/* 17795*/    OPC_EmitConvertToTarget, 13,
/* 17797*/    OPC_EmitConvertToTarget, 14,
/* 17799*/    OPC_EmitConvertToTarget, 15,
/* 17801*/    OPC_EmitConvertToTarget, 16,
/* 17803*/    OPC_EmitConvertToTarget, 17,
/* 17805*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SHUFFLE),
                  MVT::v16i8, 18/*#Ops*/, 0, 1, 18, 19, 20, 21, 22, 23, 24, 25, 26, 27, 28, 29, 30, 31, 32, 33, 
              // Src: (wasm_shuffle:{ *:[v16i8] } V128:{ *:[v16i8] }:$x, V128:{ *:[v16i8] }:$y, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m0, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m1, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m2, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m3, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m4, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m5, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m6, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m7, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m8, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m9, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$mA, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$mB, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$mC, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$mD, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$mE, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$mF) - Complexity = 67
              // Dst: (SHUFFLE:{ *:[v16i8] } ?:{ *:[v16i8] }:$x, ?:{ *:[v16i8] }:$y, (imm:{ *:[i32] }):$m0, (imm:{ *:[i32] }):$m1, (imm:{ *:[i32] }):$m2, (imm:{ *:[i32] }):$m3, (imm:{ *:[i32] }):$m4, (imm:{ *:[i32] }):$m5, (imm:{ *:[i32] }):$m6, (imm:{ *:[i32] }):$m7, (imm:{ *:[i32] }):$m8, (imm:{ *:[i32] }):$m9, (imm:{ *:[i32] }):$mA, (imm:{ *:[i32] }):$mB, (imm:{ *:[i32] }):$mC, (imm:{ *:[i32] }):$mD, (imm:{ *:[i32] }):$mE, (imm:{ *:[i32] }):$mF)
/* 17828*/   /*SwitchOpcode*/ 25|128,1/*153*/, TARGET_VAL(ISD::TargetConstant),// ->17985
/* 17832*/    OPC_CheckTypeI32,
/* 17833*/    OPC_MoveSibling3,
/* 17834*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 17837*/    OPC_RecordNode, // #3 = $m1
/* 17838*/    OPC_CheckTypeI32,
/* 17839*/    OPC_MoveSibling4,
/* 17840*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 17843*/    OPC_RecordNode, // #4 = $m2
/* 17844*/    OPC_CheckTypeI32,
/* 17845*/    OPC_MoveSibling5,
/* 17846*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 17849*/    OPC_RecordNode, // #5 = $m3
/* 17850*/    OPC_CheckTypeI32,
/* 17851*/    OPC_MoveSibling6,
/* 17852*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 17855*/    OPC_RecordNode, // #6 = $m4
/* 17856*/    OPC_CheckTypeI32,
/* 17857*/    OPC_MoveSibling7,
/* 17858*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 17861*/    OPC_RecordNode, // #7 = $m5
/* 17862*/    OPC_CheckTypeI32,
/* 17863*/    OPC_MoveSibling, 8,
/* 17865*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 17868*/    OPC_RecordNode, // #8 = $m6
/* 17869*/    OPC_CheckTypeI32,
/* 17870*/    OPC_MoveSibling, 9,
/* 17872*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 17875*/    OPC_RecordNode, // #9 = $m7
/* 17876*/    OPC_CheckTypeI32,
/* 17877*/    OPC_MoveSibling, 10,
/* 17879*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 17882*/    OPC_RecordNode, // #10 = $m8
/* 17883*/    OPC_CheckTypeI32,
/* 17884*/    OPC_MoveSibling, 11,
/* 17886*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 17889*/    OPC_RecordNode, // #11 = $m9
/* 17890*/    OPC_CheckTypeI32,
/* 17891*/    OPC_MoveSibling, 12,
/* 17893*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 17896*/    OPC_RecordNode, // #12 = $mA
/* 17897*/    OPC_CheckTypeI32,
/* 17898*/    OPC_MoveSibling, 13,
/* 17900*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 17903*/    OPC_RecordNode, // #13 = $mB
/* 17904*/    OPC_CheckTypeI32,
/* 17905*/    OPC_MoveSibling, 14,
/* 17907*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 17910*/    OPC_RecordNode, // #14 = $mC
/* 17911*/    OPC_CheckTypeI32,
/* 17912*/    OPC_MoveSibling, 15,
/* 17914*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 17917*/    OPC_RecordNode, // #15 = $mD
/* 17918*/    OPC_CheckTypeI32,
/* 17919*/    OPC_MoveSibling, 16,
/* 17921*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 17924*/    OPC_RecordNode, // #16 = $mE
/* 17925*/    OPC_CheckTypeI32,
/* 17926*/    OPC_MoveSibling, 17,
/* 17928*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 17931*/    OPC_RecordNode, // #17 = $mF
/* 17932*/    OPC_CheckTypeI32,
/* 17933*/    OPC_MoveParent,
/* 17934*/    OPC_CheckType, MVT::v16i8,
/* 17936*/    OPC_EmitConvertToTarget2,
/* 17937*/    OPC_EmitConvertToTarget3,
/* 17938*/    OPC_EmitConvertToTarget4,
/* 17939*/    OPC_EmitConvertToTarget5,
/* 17940*/    OPC_EmitConvertToTarget6,
/* 17941*/    OPC_EmitConvertToTarget7,
/* 17942*/    OPC_EmitConvertToTarget, 8,
/* 17944*/    OPC_EmitConvertToTarget, 9,
/* 17946*/    OPC_EmitConvertToTarget, 10,
/* 17948*/    OPC_EmitConvertToTarget, 11,
/* 17950*/    OPC_EmitConvertToTarget, 12,
/* 17952*/    OPC_EmitConvertToTarget, 13,
/* 17954*/    OPC_EmitConvertToTarget, 14,
/* 17956*/    OPC_EmitConvertToTarget, 15,
/* 17958*/    OPC_EmitConvertToTarget, 16,
/* 17960*/    OPC_EmitConvertToTarget, 17,
/* 17962*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SHUFFLE),
                  MVT::v16i8, 18/*#Ops*/, 0, 1, 18, 19, 20, 21, 22, 23, 24, 25, 26, 27, 28, 29, 30, 31, 32, 33, 
              // Src: (wasm_shuffle:{ *:[v16i8] } V128:{ *:[v16i8] }:$x, V128:{ *:[v16i8] }:$y, (timm:{ *:[i32] }):$m0, (timm:{ *:[i32] }):$m1, (timm:{ *:[i32] }):$m2, (timm:{ *:[i32] }):$m3, (timm:{ *:[i32] }):$m4, (timm:{ *:[i32] }):$m5, (timm:{ *:[i32] }):$m6, (timm:{ *:[i32] }):$m7, (timm:{ *:[i32] }):$m8, (timm:{ *:[i32] }):$m9, (timm:{ *:[i32] }):$mA, (timm:{ *:[i32] }):$mB, (timm:{ *:[i32] }):$mC, (timm:{ *:[i32] }):$mD, (timm:{ *:[i32] }):$mE, (timm:{ *:[i32] }):$mF) - Complexity = 51
              // Dst: (SHUFFLE:{ *:[v16i8] } ?:{ *:[v16i8] }:$x, ?:{ *:[v16i8] }:$y, (imm:{ *:[i32] }):$m0, (imm:{ *:[i32] }):$m1, (imm:{ *:[i32] }):$m2, (imm:{ *:[i32] }):$m3, (imm:{ *:[i32] }):$m4, (imm:{ *:[i32] }):$m5, (imm:{ *:[i32] }):$m6, (imm:{ *:[i32] }):$m7, (imm:{ *:[i32] }):$m8, (imm:{ *:[i32] }):$m9, (imm:{ *:[i32] }):$mA, (imm:{ *:[i32] }):$mB, (imm:{ *:[i32] }):$mC, (imm:{ *:[i32] }):$mD, (imm:{ *:[i32] }):$mE, (imm:{ *:[i32] }):$mF)
/* 17985*/   0, // EndSwitchOpcode
/* 17986*/  /*Scope*/ 83|128,2/*339*/, /*->18327*/
/* 17988*/   OPC_CheckChild0Type, MVT::v8i16,
/* 17990*/   OPC_RecordChild1, // #1 = $y
/* 17991*/   OPC_CheckChild1Type, MVT::v8i16,
/* 17993*/   OPC_RecordChild2, // #2 = $m0
/* 17994*/   OPC_MoveChild2,
/* 17995*/   OPC_SwitchOpcode /*2 cases */, 41|128,1/*169*/, TARGET_VAL(ISD::Constant),// ->18169
/* 18000*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 18001*/    OPC_CheckTypeI32,
/* 18002*/    OPC_MoveSibling3,
/* 18003*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 18006*/    OPC_RecordNode, // #3 = $m1
/* 18007*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 18008*/    OPC_CheckTypeI32,
/* 18009*/    OPC_MoveSibling4,
/* 18010*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 18013*/    OPC_RecordNode, // #4 = $m2
/* 18014*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 18015*/    OPC_CheckTypeI32,
/* 18016*/    OPC_MoveSibling5,
/* 18017*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 18020*/    OPC_RecordNode, // #5 = $m3
/* 18021*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 18022*/    OPC_CheckTypeI32,
/* 18023*/    OPC_MoveSibling6,
/* 18024*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 18027*/    OPC_RecordNode, // #6 = $m4
/* 18028*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 18029*/    OPC_CheckTypeI32,
/* 18030*/    OPC_MoveSibling7,
/* 18031*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 18034*/    OPC_RecordNode, // #7 = $m5
/* 18035*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 18036*/    OPC_CheckTypeI32,
/* 18037*/    OPC_MoveSibling, 8,
/* 18039*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 18042*/    OPC_RecordNode, // #8 = $m6
/* 18043*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 18044*/    OPC_CheckTypeI32,
/* 18045*/    OPC_MoveSibling, 9,
/* 18047*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 18050*/    OPC_RecordNode, // #9 = $m7
/* 18051*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 18052*/    OPC_CheckTypeI32,
/* 18053*/    OPC_MoveSibling, 10,
/* 18055*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 18058*/    OPC_RecordNode, // #10 = $m8
/* 18059*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 18060*/    OPC_CheckTypeI32,
/* 18061*/    OPC_MoveSibling, 11,
/* 18063*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 18066*/    OPC_RecordNode, // #11 = $m9
/* 18067*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 18068*/    OPC_CheckTypeI32,
/* 18069*/    OPC_MoveSibling, 12,
/* 18071*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 18074*/    OPC_RecordNode, // #12 = $mA
/* 18075*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 18076*/    OPC_CheckTypeI32,
/* 18077*/    OPC_MoveSibling, 13,
/* 18079*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 18082*/    OPC_RecordNode, // #13 = $mB
/* 18083*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 18084*/    OPC_CheckTypeI32,
/* 18085*/    OPC_MoveSibling, 14,
/* 18087*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 18090*/    OPC_RecordNode, // #14 = $mC
/* 18091*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 18092*/    OPC_CheckTypeI32,
/* 18093*/    OPC_MoveSibling, 15,
/* 18095*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 18098*/    OPC_RecordNode, // #15 = $mD
/* 18099*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 18100*/    OPC_CheckTypeI32,
/* 18101*/    OPC_MoveSibling, 16,
/* 18103*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 18106*/    OPC_RecordNode, // #16 = $mE
/* 18107*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 18108*/    OPC_CheckTypeI32,
/* 18109*/    OPC_MoveSibling, 17,
/* 18111*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 18114*/    OPC_RecordNode, // #17 = $mF
/* 18115*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 18116*/    OPC_CheckTypeI32,
/* 18117*/    OPC_MoveParent,
/* 18118*/    OPC_CheckType, MVT::v8i16,
/* 18120*/    OPC_EmitConvertToTarget2,
/* 18121*/    OPC_EmitConvertToTarget3,
/* 18122*/    OPC_EmitConvertToTarget4,
/* 18123*/    OPC_EmitConvertToTarget5,
/* 18124*/    OPC_EmitConvertToTarget6,
/* 18125*/    OPC_EmitConvertToTarget7,
/* 18126*/    OPC_EmitConvertToTarget, 8,
/* 18128*/    OPC_EmitConvertToTarget, 9,
/* 18130*/    OPC_EmitConvertToTarget, 10,
/* 18132*/    OPC_EmitConvertToTarget, 11,
/* 18134*/    OPC_EmitConvertToTarget, 12,
/* 18136*/    OPC_EmitConvertToTarget, 13,
/* 18138*/    OPC_EmitConvertToTarget, 14,
/* 18140*/    OPC_EmitConvertToTarget, 15,
/* 18142*/    OPC_EmitConvertToTarget, 16,
/* 18144*/    OPC_EmitConvertToTarget, 17,
/* 18146*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SHUFFLE),
                  MVT::v8i16, 18/*#Ops*/, 0, 1, 18, 19, 20, 21, 22, 23, 24, 25, 26, 27, 28, 29, 30, 31, 32, 33, 
              // Src: (wasm_shuffle:{ *:[v8i16] } V128:{ *:[v8i16] }:$x, V128:{ *:[v8i16] }:$y, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m0, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m1, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m2, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m3, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m4, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m5, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m6, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m7, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m8, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m9, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$mA, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$mB, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$mC, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$mD, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$mE, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$mF) - Complexity = 67
              // Dst: (SHUFFLE:{ *:[v8i16] } ?:{ *:[v8i16] }:$x, ?:{ *:[v8i16] }:$y, (imm:{ *:[i32] }):$m0, (imm:{ *:[i32] }):$m1, (imm:{ *:[i32] }):$m2, (imm:{ *:[i32] }):$m3, (imm:{ *:[i32] }):$m4, (imm:{ *:[i32] }):$m5, (imm:{ *:[i32] }):$m6, (imm:{ *:[i32] }):$m7, (imm:{ *:[i32] }):$m8, (imm:{ *:[i32] }):$m9, (imm:{ *:[i32] }):$mA, (imm:{ *:[i32] }):$mB, (imm:{ *:[i32] }):$mC, (imm:{ *:[i32] }):$mD, (imm:{ *:[i32] }):$mE, (imm:{ *:[i32] }):$mF)
/* 18169*/   /*SwitchOpcode*/ 25|128,1/*153*/, TARGET_VAL(ISD::TargetConstant),// ->18326
/* 18173*/    OPC_CheckTypeI32,
/* 18174*/    OPC_MoveSibling3,
/* 18175*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 18178*/    OPC_RecordNode, // #3 = $m1
/* 18179*/    OPC_CheckTypeI32,
/* 18180*/    OPC_MoveSibling4,
/* 18181*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 18184*/    OPC_RecordNode, // #4 = $m2
/* 18185*/    OPC_CheckTypeI32,
/* 18186*/    OPC_MoveSibling5,
/* 18187*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 18190*/    OPC_RecordNode, // #5 = $m3
/* 18191*/    OPC_CheckTypeI32,
/* 18192*/    OPC_MoveSibling6,
/* 18193*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 18196*/    OPC_RecordNode, // #6 = $m4
/* 18197*/    OPC_CheckTypeI32,
/* 18198*/    OPC_MoveSibling7,
/* 18199*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 18202*/    OPC_RecordNode, // #7 = $m5
/* 18203*/    OPC_CheckTypeI32,
/* 18204*/    OPC_MoveSibling, 8,
/* 18206*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 18209*/    OPC_RecordNode, // #8 = $m6
/* 18210*/    OPC_CheckTypeI32,
/* 18211*/    OPC_MoveSibling, 9,
/* 18213*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 18216*/    OPC_RecordNode, // #9 = $m7
/* 18217*/    OPC_CheckTypeI32,
/* 18218*/    OPC_MoveSibling, 10,
/* 18220*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 18223*/    OPC_RecordNode, // #10 = $m8
/* 18224*/    OPC_CheckTypeI32,
/* 18225*/    OPC_MoveSibling, 11,
/* 18227*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 18230*/    OPC_RecordNode, // #11 = $m9
/* 18231*/    OPC_CheckTypeI32,
/* 18232*/    OPC_MoveSibling, 12,
/* 18234*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 18237*/    OPC_RecordNode, // #12 = $mA
/* 18238*/    OPC_CheckTypeI32,
/* 18239*/    OPC_MoveSibling, 13,
/* 18241*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 18244*/    OPC_RecordNode, // #13 = $mB
/* 18245*/    OPC_CheckTypeI32,
/* 18246*/    OPC_MoveSibling, 14,
/* 18248*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 18251*/    OPC_RecordNode, // #14 = $mC
/* 18252*/    OPC_CheckTypeI32,
/* 18253*/    OPC_MoveSibling, 15,
/* 18255*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 18258*/    OPC_RecordNode, // #15 = $mD
/* 18259*/    OPC_CheckTypeI32,
/* 18260*/    OPC_MoveSibling, 16,
/* 18262*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 18265*/    OPC_RecordNode, // #16 = $mE
/* 18266*/    OPC_CheckTypeI32,
/* 18267*/    OPC_MoveSibling, 17,
/* 18269*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 18272*/    OPC_RecordNode, // #17 = $mF
/* 18273*/    OPC_CheckTypeI32,
/* 18274*/    OPC_MoveParent,
/* 18275*/    OPC_CheckType, MVT::v8i16,
/* 18277*/    OPC_EmitConvertToTarget2,
/* 18278*/    OPC_EmitConvertToTarget3,
/* 18279*/    OPC_EmitConvertToTarget4,
/* 18280*/    OPC_EmitConvertToTarget5,
/* 18281*/    OPC_EmitConvertToTarget6,
/* 18282*/    OPC_EmitConvertToTarget7,
/* 18283*/    OPC_EmitConvertToTarget, 8,
/* 18285*/    OPC_EmitConvertToTarget, 9,
/* 18287*/    OPC_EmitConvertToTarget, 10,
/* 18289*/    OPC_EmitConvertToTarget, 11,
/* 18291*/    OPC_EmitConvertToTarget, 12,
/* 18293*/    OPC_EmitConvertToTarget, 13,
/* 18295*/    OPC_EmitConvertToTarget, 14,
/* 18297*/    OPC_EmitConvertToTarget, 15,
/* 18299*/    OPC_EmitConvertToTarget, 16,
/* 18301*/    OPC_EmitConvertToTarget, 17,
/* 18303*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SHUFFLE),
                  MVT::v8i16, 18/*#Ops*/, 0, 1, 18, 19, 20, 21, 22, 23, 24, 25, 26, 27, 28, 29, 30, 31, 32, 33, 
              // Src: (wasm_shuffle:{ *:[v8i16] } V128:{ *:[v8i16] }:$x, V128:{ *:[v8i16] }:$y, (timm:{ *:[i32] }):$m0, (timm:{ *:[i32] }):$m1, (timm:{ *:[i32] }):$m2, (timm:{ *:[i32] }):$m3, (timm:{ *:[i32] }):$m4, (timm:{ *:[i32] }):$m5, (timm:{ *:[i32] }):$m6, (timm:{ *:[i32] }):$m7, (timm:{ *:[i32] }):$m8, (timm:{ *:[i32] }):$m9, (timm:{ *:[i32] }):$mA, (timm:{ *:[i32] }):$mB, (timm:{ *:[i32] }):$mC, (timm:{ *:[i32] }):$mD, (timm:{ *:[i32] }):$mE, (timm:{ *:[i32] }):$mF) - Complexity = 51
              // Dst: (SHUFFLE:{ *:[v8i16] } ?:{ *:[v8i16] }:$x, ?:{ *:[v8i16] }:$y, (imm:{ *:[i32] }):$m0, (imm:{ *:[i32] }):$m1, (imm:{ *:[i32] }):$m2, (imm:{ *:[i32] }):$m3, (imm:{ *:[i32] }):$m4, (imm:{ *:[i32] }):$m5, (imm:{ *:[i32] }):$m6, (imm:{ *:[i32] }):$m7, (imm:{ *:[i32] }):$m8, (imm:{ *:[i32] }):$m9, (imm:{ *:[i32] }):$mA, (imm:{ *:[i32] }):$mB, (imm:{ *:[i32] }):$mC, (imm:{ *:[i32] }):$mD, (imm:{ *:[i32] }):$mE, (imm:{ *:[i32] }):$mF)
/* 18326*/   0, // EndSwitchOpcode
/* 18327*/  /*Scope*/ 83|128,2/*339*/, /*->18668*/
/* 18329*/   OPC_CheckChild0Type, MVT::v4i32,
/* 18331*/   OPC_RecordChild1, // #1 = $y
/* 18332*/   OPC_CheckChild1Type, MVT::v4i32,
/* 18334*/   OPC_RecordChild2, // #2 = $m0
/* 18335*/   OPC_MoveChild2,
/* 18336*/   OPC_SwitchOpcode /*2 cases */, 41|128,1/*169*/, TARGET_VAL(ISD::Constant),// ->18510
/* 18341*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 18342*/    OPC_CheckTypeI32,
/* 18343*/    OPC_MoveSibling3,
/* 18344*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 18347*/    OPC_RecordNode, // #3 = $m1
/* 18348*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 18349*/    OPC_CheckTypeI32,
/* 18350*/    OPC_MoveSibling4,
/* 18351*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 18354*/    OPC_RecordNode, // #4 = $m2
/* 18355*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 18356*/    OPC_CheckTypeI32,
/* 18357*/    OPC_MoveSibling5,
/* 18358*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 18361*/    OPC_RecordNode, // #5 = $m3
/* 18362*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 18363*/    OPC_CheckTypeI32,
/* 18364*/    OPC_MoveSibling6,
/* 18365*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 18368*/    OPC_RecordNode, // #6 = $m4
/* 18369*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 18370*/    OPC_CheckTypeI32,
/* 18371*/    OPC_MoveSibling7,
/* 18372*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 18375*/    OPC_RecordNode, // #7 = $m5
/* 18376*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 18377*/    OPC_CheckTypeI32,
/* 18378*/    OPC_MoveSibling, 8,
/* 18380*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 18383*/    OPC_RecordNode, // #8 = $m6
/* 18384*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 18385*/    OPC_CheckTypeI32,
/* 18386*/    OPC_MoveSibling, 9,
/* 18388*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 18391*/    OPC_RecordNode, // #9 = $m7
/* 18392*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 18393*/    OPC_CheckTypeI32,
/* 18394*/    OPC_MoveSibling, 10,
/* 18396*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 18399*/    OPC_RecordNode, // #10 = $m8
/* 18400*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 18401*/    OPC_CheckTypeI32,
/* 18402*/    OPC_MoveSibling, 11,
/* 18404*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 18407*/    OPC_RecordNode, // #11 = $m9
/* 18408*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 18409*/    OPC_CheckTypeI32,
/* 18410*/    OPC_MoveSibling, 12,
/* 18412*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 18415*/    OPC_RecordNode, // #12 = $mA
/* 18416*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 18417*/    OPC_CheckTypeI32,
/* 18418*/    OPC_MoveSibling, 13,
/* 18420*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 18423*/    OPC_RecordNode, // #13 = $mB
/* 18424*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 18425*/    OPC_CheckTypeI32,
/* 18426*/    OPC_MoveSibling, 14,
/* 18428*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 18431*/    OPC_RecordNode, // #14 = $mC
/* 18432*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 18433*/    OPC_CheckTypeI32,
/* 18434*/    OPC_MoveSibling, 15,
/* 18436*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 18439*/    OPC_RecordNode, // #15 = $mD
/* 18440*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 18441*/    OPC_CheckTypeI32,
/* 18442*/    OPC_MoveSibling, 16,
/* 18444*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 18447*/    OPC_RecordNode, // #16 = $mE
/* 18448*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 18449*/    OPC_CheckTypeI32,
/* 18450*/    OPC_MoveSibling, 17,
/* 18452*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 18455*/    OPC_RecordNode, // #17 = $mF
/* 18456*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 18457*/    OPC_CheckTypeI32,
/* 18458*/    OPC_MoveParent,
/* 18459*/    OPC_CheckType, MVT::v4i32,
/* 18461*/    OPC_EmitConvertToTarget2,
/* 18462*/    OPC_EmitConvertToTarget3,
/* 18463*/    OPC_EmitConvertToTarget4,
/* 18464*/    OPC_EmitConvertToTarget5,
/* 18465*/    OPC_EmitConvertToTarget6,
/* 18466*/    OPC_EmitConvertToTarget7,
/* 18467*/    OPC_EmitConvertToTarget, 8,
/* 18469*/    OPC_EmitConvertToTarget, 9,
/* 18471*/    OPC_EmitConvertToTarget, 10,
/* 18473*/    OPC_EmitConvertToTarget, 11,
/* 18475*/    OPC_EmitConvertToTarget, 12,
/* 18477*/    OPC_EmitConvertToTarget, 13,
/* 18479*/    OPC_EmitConvertToTarget, 14,
/* 18481*/    OPC_EmitConvertToTarget, 15,
/* 18483*/    OPC_EmitConvertToTarget, 16,
/* 18485*/    OPC_EmitConvertToTarget, 17,
/* 18487*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SHUFFLE),
                  MVT::v4i32, 18/*#Ops*/, 0, 1, 18, 19, 20, 21, 22, 23, 24, 25, 26, 27, 28, 29, 30, 31, 32, 33, 
              // Src: (wasm_shuffle:{ *:[v4i32] } V128:{ *:[v4i32] }:$x, V128:{ *:[v4i32] }:$y, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m0, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m1, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m2, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m3, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m4, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m5, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m6, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m7, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m8, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m9, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$mA, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$mB, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$mC, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$mD, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$mE, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$mF) - Complexity = 67
              // Dst: (SHUFFLE:{ *:[v4i32] } ?:{ *:[v4i32] }:$x, ?:{ *:[v4i32] }:$y, (imm:{ *:[i32] }):$m0, (imm:{ *:[i32] }):$m1, (imm:{ *:[i32] }):$m2, (imm:{ *:[i32] }):$m3, (imm:{ *:[i32] }):$m4, (imm:{ *:[i32] }):$m5, (imm:{ *:[i32] }):$m6, (imm:{ *:[i32] }):$m7, (imm:{ *:[i32] }):$m8, (imm:{ *:[i32] }):$m9, (imm:{ *:[i32] }):$mA, (imm:{ *:[i32] }):$mB, (imm:{ *:[i32] }):$mC, (imm:{ *:[i32] }):$mD, (imm:{ *:[i32] }):$mE, (imm:{ *:[i32] }):$mF)
/* 18510*/   /*SwitchOpcode*/ 25|128,1/*153*/, TARGET_VAL(ISD::TargetConstant),// ->18667
/* 18514*/    OPC_CheckTypeI32,
/* 18515*/    OPC_MoveSibling3,
/* 18516*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 18519*/    OPC_RecordNode, // #3 = $m1
/* 18520*/    OPC_CheckTypeI32,
/* 18521*/    OPC_MoveSibling4,
/* 18522*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 18525*/    OPC_RecordNode, // #4 = $m2
/* 18526*/    OPC_CheckTypeI32,
/* 18527*/    OPC_MoveSibling5,
/* 18528*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 18531*/    OPC_RecordNode, // #5 = $m3
/* 18532*/    OPC_CheckTypeI32,
/* 18533*/    OPC_MoveSibling6,
/* 18534*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 18537*/    OPC_RecordNode, // #6 = $m4
/* 18538*/    OPC_CheckTypeI32,
/* 18539*/    OPC_MoveSibling7,
/* 18540*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 18543*/    OPC_RecordNode, // #7 = $m5
/* 18544*/    OPC_CheckTypeI32,
/* 18545*/    OPC_MoveSibling, 8,
/* 18547*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 18550*/    OPC_RecordNode, // #8 = $m6
/* 18551*/    OPC_CheckTypeI32,
/* 18552*/    OPC_MoveSibling, 9,
/* 18554*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 18557*/    OPC_RecordNode, // #9 = $m7
/* 18558*/    OPC_CheckTypeI32,
/* 18559*/    OPC_MoveSibling, 10,
/* 18561*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 18564*/    OPC_RecordNode, // #10 = $m8
/* 18565*/    OPC_CheckTypeI32,
/* 18566*/    OPC_MoveSibling, 11,
/* 18568*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 18571*/    OPC_RecordNode, // #11 = $m9
/* 18572*/    OPC_CheckTypeI32,
/* 18573*/    OPC_MoveSibling, 12,
/* 18575*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 18578*/    OPC_RecordNode, // #12 = $mA
/* 18579*/    OPC_CheckTypeI32,
/* 18580*/    OPC_MoveSibling, 13,
/* 18582*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 18585*/    OPC_RecordNode, // #13 = $mB
/* 18586*/    OPC_CheckTypeI32,
/* 18587*/    OPC_MoveSibling, 14,
/* 18589*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 18592*/    OPC_RecordNode, // #14 = $mC
/* 18593*/    OPC_CheckTypeI32,
/* 18594*/    OPC_MoveSibling, 15,
/* 18596*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 18599*/    OPC_RecordNode, // #15 = $mD
/* 18600*/    OPC_CheckTypeI32,
/* 18601*/    OPC_MoveSibling, 16,
/* 18603*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 18606*/    OPC_RecordNode, // #16 = $mE
/* 18607*/    OPC_CheckTypeI32,
/* 18608*/    OPC_MoveSibling, 17,
/* 18610*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 18613*/    OPC_RecordNode, // #17 = $mF
/* 18614*/    OPC_CheckTypeI32,
/* 18615*/    OPC_MoveParent,
/* 18616*/    OPC_CheckType, MVT::v4i32,
/* 18618*/    OPC_EmitConvertToTarget2,
/* 18619*/    OPC_EmitConvertToTarget3,
/* 18620*/    OPC_EmitConvertToTarget4,
/* 18621*/    OPC_EmitConvertToTarget5,
/* 18622*/    OPC_EmitConvertToTarget6,
/* 18623*/    OPC_EmitConvertToTarget7,
/* 18624*/    OPC_EmitConvertToTarget, 8,
/* 18626*/    OPC_EmitConvertToTarget, 9,
/* 18628*/    OPC_EmitConvertToTarget, 10,
/* 18630*/    OPC_EmitConvertToTarget, 11,
/* 18632*/    OPC_EmitConvertToTarget, 12,
/* 18634*/    OPC_EmitConvertToTarget, 13,
/* 18636*/    OPC_EmitConvertToTarget, 14,
/* 18638*/    OPC_EmitConvertToTarget, 15,
/* 18640*/    OPC_EmitConvertToTarget, 16,
/* 18642*/    OPC_EmitConvertToTarget, 17,
/* 18644*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SHUFFLE),
                  MVT::v4i32, 18/*#Ops*/, 0, 1, 18, 19, 20, 21, 22, 23, 24, 25, 26, 27, 28, 29, 30, 31, 32, 33, 
              // Src: (wasm_shuffle:{ *:[v4i32] } V128:{ *:[v4i32] }:$x, V128:{ *:[v4i32] }:$y, (timm:{ *:[i32] }):$m0, (timm:{ *:[i32] }):$m1, (timm:{ *:[i32] }):$m2, (timm:{ *:[i32] }):$m3, (timm:{ *:[i32] }):$m4, (timm:{ *:[i32] }):$m5, (timm:{ *:[i32] }):$m6, (timm:{ *:[i32] }):$m7, (timm:{ *:[i32] }):$m8, (timm:{ *:[i32] }):$m9, (timm:{ *:[i32] }):$mA, (timm:{ *:[i32] }):$mB, (timm:{ *:[i32] }):$mC, (timm:{ *:[i32] }):$mD, (timm:{ *:[i32] }):$mE, (timm:{ *:[i32] }):$mF) - Complexity = 51
              // Dst: (SHUFFLE:{ *:[v4i32] } ?:{ *:[v4i32] }:$x, ?:{ *:[v4i32] }:$y, (imm:{ *:[i32] }):$m0, (imm:{ *:[i32] }):$m1, (imm:{ *:[i32] }):$m2, (imm:{ *:[i32] }):$m3, (imm:{ *:[i32] }):$m4, (imm:{ *:[i32] }):$m5, (imm:{ *:[i32] }):$m6, (imm:{ *:[i32] }):$m7, (imm:{ *:[i32] }):$m8, (imm:{ *:[i32] }):$m9, (imm:{ *:[i32] }):$mA, (imm:{ *:[i32] }):$mB, (imm:{ *:[i32] }):$mC, (imm:{ *:[i32] }):$mD, (imm:{ *:[i32] }):$mE, (imm:{ *:[i32] }):$mF)
/* 18667*/   0, // EndSwitchOpcode
/* 18668*/  /*Scope*/ 83|128,2/*339*/, /*->19009*/
/* 18670*/   OPC_CheckChild0Type, MVT::v2i64,
/* 18672*/   OPC_RecordChild1, // #1 = $y
/* 18673*/   OPC_CheckChild1Type, MVT::v2i64,
/* 18675*/   OPC_RecordChild2, // #2 = $m0
/* 18676*/   OPC_MoveChild2,
/* 18677*/   OPC_SwitchOpcode /*2 cases */, 41|128,1/*169*/, TARGET_VAL(ISD::Constant),// ->18851
/* 18682*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 18683*/    OPC_CheckTypeI32,
/* 18684*/    OPC_MoveSibling3,
/* 18685*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 18688*/    OPC_RecordNode, // #3 = $m1
/* 18689*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 18690*/    OPC_CheckTypeI32,
/* 18691*/    OPC_MoveSibling4,
/* 18692*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 18695*/    OPC_RecordNode, // #4 = $m2
/* 18696*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 18697*/    OPC_CheckTypeI32,
/* 18698*/    OPC_MoveSibling5,
/* 18699*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 18702*/    OPC_RecordNode, // #5 = $m3
/* 18703*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 18704*/    OPC_CheckTypeI32,
/* 18705*/    OPC_MoveSibling6,
/* 18706*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 18709*/    OPC_RecordNode, // #6 = $m4
/* 18710*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 18711*/    OPC_CheckTypeI32,
/* 18712*/    OPC_MoveSibling7,
/* 18713*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 18716*/    OPC_RecordNode, // #7 = $m5
/* 18717*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 18718*/    OPC_CheckTypeI32,
/* 18719*/    OPC_MoveSibling, 8,
/* 18721*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 18724*/    OPC_RecordNode, // #8 = $m6
/* 18725*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 18726*/    OPC_CheckTypeI32,
/* 18727*/    OPC_MoveSibling, 9,
/* 18729*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 18732*/    OPC_RecordNode, // #9 = $m7
/* 18733*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 18734*/    OPC_CheckTypeI32,
/* 18735*/    OPC_MoveSibling, 10,
/* 18737*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 18740*/    OPC_RecordNode, // #10 = $m8
/* 18741*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 18742*/    OPC_CheckTypeI32,
/* 18743*/    OPC_MoveSibling, 11,
/* 18745*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 18748*/    OPC_RecordNode, // #11 = $m9
/* 18749*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 18750*/    OPC_CheckTypeI32,
/* 18751*/    OPC_MoveSibling, 12,
/* 18753*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 18756*/    OPC_RecordNode, // #12 = $mA
/* 18757*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 18758*/    OPC_CheckTypeI32,
/* 18759*/    OPC_MoveSibling, 13,
/* 18761*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 18764*/    OPC_RecordNode, // #13 = $mB
/* 18765*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 18766*/    OPC_CheckTypeI32,
/* 18767*/    OPC_MoveSibling, 14,
/* 18769*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 18772*/    OPC_RecordNode, // #14 = $mC
/* 18773*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 18774*/    OPC_CheckTypeI32,
/* 18775*/    OPC_MoveSibling, 15,
/* 18777*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 18780*/    OPC_RecordNode, // #15 = $mD
/* 18781*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 18782*/    OPC_CheckTypeI32,
/* 18783*/    OPC_MoveSibling, 16,
/* 18785*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 18788*/    OPC_RecordNode, // #16 = $mE
/* 18789*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 18790*/    OPC_CheckTypeI32,
/* 18791*/    OPC_MoveSibling, 17,
/* 18793*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 18796*/    OPC_RecordNode, // #17 = $mF
/* 18797*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 18798*/    OPC_CheckTypeI32,
/* 18799*/    OPC_MoveParent,
/* 18800*/    OPC_CheckType, MVT::v2i64,
/* 18802*/    OPC_EmitConvertToTarget2,
/* 18803*/    OPC_EmitConvertToTarget3,
/* 18804*/    OPC_EmitConvertToTarget4,
/* 18805*/    OPC_EmitConvertToTarget5,
/* 18806*/    OPC_EmitConvertToTarget6,
/* 18807*/    OPC_EmitConvertToTarget7,
/* 18808*/    OPC_EmitConvertToTarget, 8,
/* 18810*/    OPC_EmitConvertToTarget, 9,
/* 18812*/    OPC_EmitConvertToTarget, 10,
/* 18814*/    OPC_EmitConvertToTarget, 11,
/* 18816*/    OPC_EmitConvertToTarget, 12,
/* 18818*/    OPC_EmitConvertToTarget, 13,
/* 18820*/    OPC_EmitConvertToTarget, 14,
/* 18822*/    OPC_EmitConvertToTarget, 15,
/* 18824*/    OPC_EmitConvertToTarget, 16,
/* 18826*/    OPC_EmitConvertToTarget, 17,
/* 18828*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SHUFFLE),
                  MVT::v2i64, 18/*#Ops*/, 0, 1, 18, 19, 20, 21, 22, 23, 24, 25, 26, 27, 28, 29, 30, 31, 32, 33, 
              // Src: (wasm_shuffle:{ *:[v2i64] } V128:{ *:[v2i64] }:$x, V128:{ *:[v2i64] }:$y, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m0, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m1, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m2, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m3, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m4, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m5, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m6, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m7, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m8, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m9, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$mA, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$mB, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$mC, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$mD, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$mE, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$mF) - Complexity = 67
              // Dst: (SHUFFLE:{ *:[v2i64] } ?:{ *:[v2i64] }:$x, ?:{ *:[v2i64] }:$y, (imm:{ *:[i32] }):$m0, (imm:{ *:[i32] }):$m1, (imm:{ *:[i32] }):$m2, (imm:{ *:[i32] }):$m3, (imm:{ *:[i32] }):$m4, (imm:{ *:[i32] }):$m5, (imm:{ *:[i32] }):$m6, (imm:{ *:[i32] }):$m7, (imm:{ *:[i32] }):$m8, (imm:{ *:[i32] }):$m9, (imm:{ *:[i32] }):$mA, (imm:{ *:[i32] }):$mB, (imm:{ *:[i32] }):$mC, (imm:{ *:[i32] }):$mD, (imm:{ *:[i32] }):$mE, (imm:{ *:[i32] }):$mF)
/* 18851*/   /*SwitchOpcode*/ 25|128,1/*153*/, TARGET_VAL(ISD::TargetConstant),// ->19008
/* 18855*/    OPC_CheckTypeI32,
/* 18856*/    OPC_MoveSibling3,
/* 18857*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 18860*/    OPC_RecordNode, // #3 = $m1
/* 18861*/    OPC_CheckTypeI32,
/* 18862*/    OPC_MoveSibling4,
/* 18863*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 18866*/    OPC_RecordNode, // #4 = $m2
/* 18867*/    OPC_CheckTypeI32,
/* 18868*/    OPC_MoveSibling5,
/* 18869*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 18872*/    OPC_RecordNode, // #5 = $m3
/* 18873*/    OPC_CheckTypeI32,
/* 18874*/    OPC_MoveSibling6,
/* 18875*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 18878*/    OPC_RecordNode, // #6 = $m4
/* 18879*/    OPC_CheckTypeI32,
/* 18880*/    OPC_MoveSibling7,
/* 18881*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 18884*/    OPC_RecordNode, // #7 = $m5
/* 18885*/    OPC_CheckTypeI32,
/* 18886*/    OPC_MoveSibling, 8,
/* 18888*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 18891*/    OPC_RecordNode, // #8 = $m6
/* 18892*/    OPC_CheckTypeI32,
/* 18893*/    OPC_MoveSibling, 9,
/* 18895*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 18898*/    OPC_RecordNode, // #9 = $m7
/* 18899*/    OPC_CheckTypeI32,
/* 18900*/    OPC_MoveSibling, 10,
/* 18902*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 18905*/    OPC_RecordNode, // #10 = $m8
/* 18906*/    OPC_CheckTypeI32,
/* 18907*/    OPC_MoveSibling, 11,
/* 18909*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 18912*/    OPC_RecordNode, // #11 = $m9
/* 18913*/    OPC_CheckTypeI32,
/* 18914*/    OPC_MoveSibling, 12,
/* 18916*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 18919*/    OPC_RecordNode, // #12 = $mA
/* 18920*/    OPC_CheckTypeI32,
/* 18921*/    OPC_MoveSibling, 13,
/* 18923*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 18926*/    OPC_RecordNode, // #13 = $mB
/* 18927*/    OPC_CheckTypeI32,
/* 18928*/    OPC_MoveSibling, 14,
/* 18930*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 18933*/    OPC_RecordNode, // #14 = $mC
/* 18934*/    OPC_CheckTypeI32,
/* 18935*/    OPC_MoveSibling, 15,
/* 18937*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 18940*/    OPC_RecordNode, // #15 = $mD
/* 18941*/    OPC_CheckTypeI32,
/* 18942*/    OPC_MoveSibling, 16,
/* 18944*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 18947*/    OPC_RecordNode, // #16 = $mE
/* 18948*/    OPC_CheckTypeI32,
/* 18949*/    OPC_MoveSibling, 17,
/* 18951*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 18954*/    OPC_RecordNode, // #17 = $mF
/* 18955*/    OPC_CheckTypeI32,
/* 18956*/    OPC_MoveParent,
/* 18957*/    OPC_CheckType, MVT::v2i64,
/* 18959*/    OPC_EmitConvertToTarget2,
/* 18960*/    OPC_EmitConvertToTarget3,
/* 18961*/    OPC_EmitConvertToTarget4,
/* 18962*/    OPC_EmitConvertToTarget5,
/* 18963*/    OPC_EmitConvertToTarget6,
/* 18964*/    OPC_EmitConvertToTarget7,
/* 18965*/    OPC_EmitConvertToTarget, 8,
/* 18967*/    OPC_EmitConvertToTarget, 9,
/* 18969*/    OPC_EmitConvertToTarget, 10,
/* 18971*/    OPC_EmitConvertToTarget, 11,
/* 18973*/    OPC_EmitConvertToTarget, 12,
/* 18975*/    OPC_EmitConvertToTarget, 13,
/* 18977*/    OPC_EmitConvertToTarget, 14,
/* 18979*/    OPC_EmitConvertToTarget, 15,
/* 18981*/    OPC_EmitConvertToTarget, 16,
/* 18983*/    OPC_EmitConvertToTarget, 17,
/* 18985*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SHUFFLE),
                  MVT::v2i64, 18/*#Ops*/, 0, 1, 18, 19, 20, 21, 22, 23, 24, 25, 26, 27, 28, 29, 30, 31, 32, 33, 
              // Src: (wasm_shuffle:{ *:[v2i64] } V128:{ *:[v2i64] }:$x, V128:{ *:[v2i64] }:$y, (timm:{ *:[i32] }):$m0, (timm:{ *:[i32] }):$m1, (timm:{ *:[i32] }):$m2, (timm:{ *:[i32] }):$m3, (timm:{ *:[i32] }):$m4, (timm:{ *:[i32] }):$m5, (timm:{ *:[i32] }):$m6, (timm:{ *:[i32] }):$m7, (timm:{ *:[i32] }):$m8, (timm:{ *:[i32] }):$m9, (timm:{ *:[i32] }):$mA, (timm:{ *:[i32] }):$mB, (timm:{ *:[i32] }):$mC, (timm:{ *:[i32] }):$mD, (timm:{ *:[i32] }):$mE, (timm:{ *:[i32] }):$mF) - Complexity = 51
              // Dst: (SHUFFLE:{ *:[v2i64] } ?:{ *:[v2i64] }:$x, ?:{ *:[v2i64] }:$y, (imm:{ *:[i32] }):$m0, (imm:{ *:[i32] }):$m1, (imm:{ *:[i32] }):$m2, (imm:{ *:[i32] }):$m3, (imm:{ *:[i32] }):$m4, (imm:{ *:[i32] }):$m5, (imm:{ *:[i32] }):$m6, (imm:{ *:[i32] }):$m7, (imm:{ *:[i32] }):$m8, (imm:{ *:[i32] }):$m9, (imm:{ *:[i32] }):$mA, (imm:{ *:[i32] }):$mB, (imm:{ *:[i32] }):$mC, (imm:{ *:[i32] }):$mD, (imm:{ *:[i32] }):$mE, (imm:{ *:[i32] }):$mF)
/* 19008*/   0, // EndSwitchOpcode
/* 19009*/  /*Scope*/ 83|128,2/*339*/, /*->19350*/
/* 19011*/   OPC_CheckChild0Type, MVT::v4f32,
/* 19013*/   OPC_RecordChild1, // #1 = $y
/* 19014*/   OPC_CheckChild1Type, MVT::v4f32,
/* 19016*/   OPC_RecordChild2, // #2 = $m0
/* 19017*/   OPC_MoveChild2,
/* 19018*/   OPC_SwitchOpcode /*2 cases */, 41|128,1/*169*/, TARGET_VAL(ISD::Constant),// ->19192
/* 19023*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 19024*/    OPC_CheckTypeI32,
/* 19025*/    OPC_MoveSibling3,
/* 19026*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 19029*/    OPC_RecordNode, // #3 = $m1
/* 19030*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 19031*/    OPC_CheckTypeI32,
/* 19032*/    OPC_MoveSibling4,
/* 19033*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 19036*/    OPC_RecordNode, // #4 = $m2
/* 19037*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 19038*/    OPC_CheckTypeI32,
/* 19039*/    OPC_MoveSibling5,
/* 19040*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 19043*/    OPC_RecordNode, // #5 = $m3
/* 19044*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 19045*/    OPC_CheckTypeI32,
/* 19046*/    OPC_MoveSibling6,
/* 19047*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 19050*/    OPC_RecordNode, // #6 = $m4
/* 19051*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 19052*/    OPC_CheckTypeI32,
/* 19053*/    OPC_MoveSibling7,
/* 19054*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 19057*/    OPC_RecordNode, // #7 = $m5
/* 19058*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 19059*/    OPC_CheckTypeI32,
/* 19060*/    OPC_MoveSibling, 8,
/* 19062*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 19065*/    OPC_RecordNode, // #8 = $m6
/* 19066*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 19067*/    OPC_CheckTypeI32,
/* 19068*/    OPC_MoveSibling, 9,
/* 19070*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 19073*/    OPC_RecordNode, // #9 = $m7
/* 19074*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 19075*/    OPC_CheckTypeI32,
/* 19076*/    OPC_MoveSibling, 10,
/* 19078*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 19081*/    OPC_RecordNode, // #10 = $m8
/* 19082*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 19083*/    OPC_CheckTypeI32,
/* 19084*/    OPC_MoveSibling, 11,
/* 19086*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 19089*/    OPC_RecordNode, // #11 = $m9
/* 19090*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 19091*/    OPC_CheckTypeI32,
/* 19092*/    OPC_MoveSibling, 12,
/* 19094*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 19097*/    OPC_RecordNode, // #12 = $mA
/* 19098*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 19099*/    OPC_CheckTypeI32,
/* 19100*/    OPC_MoveSibling, 13,
/* 19102*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 19105*/    OPC_RecordNode, // #13 = $mB
/* 19106*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 19107*/    OPC_CheckTypeI32,
/* 19108*/    OPC_MoveSibling, 14,
/* 19110*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 19113*/    OPC_RecordNode, // #14 = $mC
/* 19114*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 19115*/    OPC_CheckTypeI32,
/* 19116*/    OPC_MoveSibling, 15,
/* 19118*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 19121*/    OPC_RecordNode, // #15 = $mD
/* 19122*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 19123*/    OPC_CheckTypeI32,
/* 19124*/    OPC_MoveSibling, 16,
/* 19126*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 19129*/    OPC_RecordNode, // #16 = $mE
/* 19130*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 19131*/    OPC_CheckTypeI32,
/* 19132*/    OPC_MoveSibling, 17,
/* 19134*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 19137*/    OPC_RecordNode, // #17 = $mF
/* 19138*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 19139*/    OPC_CheckTypeI32,
/* 19140*/    OPC_MoveParent,
/* 19141*/    OPC_CheckType, MVT::v4f32,
/* 19143*/    OPC_EmitConvertToTarget2,
/* 19144*/    OPC_EmitConvertToTarget3,
/* 19145*/    OPC_EmitConvertToTarget4,
/* 19146*/    OPC_EmitConvertToTarget5,
/* 19147*/    OPC_EmitConvertToTarget6,
/* 19148*/    OPC_EmitConvertToTarget7,
/* 19149*/    OPC_EmitConvertToTarget, 8,
/* 19151*/    OPC_EmitConvertToTarget, 9,
/* 19153*/    OPC_EmitConvertToTarget, 10,
/* 19155*/    OPC_EmitConvertToTarget, 11,
/* 19157*/    OPC_EmitConvertToTarget, 12,
/* 19159*/    OPC_EmitConvertToTarget, 13,
/* 19161*/    OPC_EmitConvertToTarget, 14,
/* 19163*/    OPC_EmitConvertToTarget, 15,
/* 19165*/    OPC_EmitConvertToTarget, 16,
/* 19167*/    OPC_EmitConvertToTarget, 17,
/* 19169*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SHUFFLE),
                  MVT::v4f32, 18/*#Ops*/, 0, 1, 18, 19, 20, 21, 22, 23, 24, 25, 26, 27, 28, 29, 30, 31, 32, 33, 
              // Src: (wasm_shuffle:{ *:[v4f32] } V128:{ *:[v4f32] }:$x, V128:{ *:[v4f32] }:$y, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m0, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m1, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m2, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m3, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m4, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m5, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m6, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m7, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m8, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m9, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$mA, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$mB, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$mC, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$mD, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$mE, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$mF) - Complexity = 67
              // Dst: (SHUFFLE:{ *:[v4f32] } ?:{ *:[v4f32] }:$x, ?:{ *:[v4f32] }:$y, (imm:{ *:[i32] }):$m0, (imm:{ *:[i32] }):$m1, (imm:{ *:[i32] }):$m2, (imm:{ *:[i32] }):$m3, (imm:{ *:[i32] }):$m4, (imm:{ *:[i32] }):$m5, (imm:{ *:[i32] }):$m6, (imm:{ *:[i32] }):$m7, (imm:{ *:[i32] }):$m8, (imm:{ *:[i32] }):$m9, (imm:{ *:[i32] }):$mA, (imm:{ *:[i32] }):$mB, (imm:{ *:[i32] }):$mC, (imm:{ *:[i32] }):$mD, (imm:{ *:[i32] }):$mE, (imm:{ *:[i32] }):$mF)
/* 19192*/   /*SwitchOpcode*/ 25|128,1/*153*/, TARGET_VAL(ISD::TargetConstant),// ->19349
/* 19196*/    OPC_CheckTypeI32,
/* 19197*/    OPC_MoveSibling3,
/* 19198*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 19201*/    OPC_RecordNode, // #3 = $m1
/* 19202*/    OPC_CheckTypeI32,
/* 19203*/    OPC_MoveSibling4,
/* 19204*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 19207*/    OPC_RecordNode, // #4 = $m2
/* 19208*/    OPC_CheckTypeI32,
/* 19209*/    OPC_MoveSibling5,
/* 19210*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 19213*/    OPC_RecordNode, // #5 = $m3
/* 19214*/    OPC_CheckTypeI32,
/* 19215*/    OPC_MoveSibling6,
/* 19216*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 19219*/    OPC_RecordNode, // #6 = $m4
/* 19220*/    OPC_CheckTypeI32,
/* 19221*/    OPC_MoveSibling7,
/* 19222*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 19225*/    OPC_RecordNode, // #7 = $m5
/* 19226*/    OPC_CheckTypeI32,
/* 19227*/    OPC_MoveSibling, 8,
/* 19229*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 19232*/    OPC_RecordNode, // #8 = $m6
/* 19233*/    OPC_CheckTypeI32,
/* 19234*/    OPC_MoveSibling, 9,
/* 19236*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 19239*/    OPC_RecordNode, // #9 = $m7
/* 19240*/    OPC_CheckTypeI32,
/* 19241*/    OPC_MoveSibling, 10,
/* 19243*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 19246*/    OPC_RecordNode, // #10 = $m8
/* 19247*/    OPC_CheckTypeI32,
/* 19248*/    OPC_MoveSibling, 11,
/* 19250*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 19253*/    OPC_RecordNode, // #11 = $m9
/* 19254*/    OPC_CheckTypeI32,
/* 19255*/    OPC_MoveSibling, 12,
/* 19257*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 19260*/    OPC_RecordNode, // #12 = $mA
/* 19261*/    OPC_CheckTypeI32,
/* 19262*/    OPC_MoveSibling, 13,
/* 19264*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 19267*/    OPC_RecordNode, // #13 = $mB
/* 19268*/    OPC_CheckTypeI32,
/* 19269*/    OPC_MoveSibling, 14,
/* 19271*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 19274*/    OPC_RecordNode, // #14 = $mC
/* 19275*/    OPC_CheckTypeI32,
/* 19276*/    OPC_MoveSibling, 15,
/* 19278*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 19281*/    OPC_RecordNode, // #15 = $mD
/* 19282*/    OPC_CheckTypeI32,
/* 19283*/    OPC_MoveSibling, 16,
/* 19285*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 19288*/    OPC_RecordNode, // #16 = $mE
/* 19289*/    OPC_CheckTypeI32,
/* 19290*/    OPC_MoveSibling, 17,
/* 19292*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 19295*/    OPC_RecordNode, // #17 = $mF
/* 19296*/    OPC_CheckTypeI32,
/* 19297*/    OPC_MoveParent,
/* 19298*/    OPC_CheckType, MVT::v4f32,
/* 19300*/    OPC_EmitConvertToTarget2,
/* 19301*/    OPC_EmitConvertToTarget3,
/* 19302*/    OPC_EmitConvertToTarget4,
/* 19303*/    OPC_EmitConvertToTarget5,
/* 19304*/    OPC_EmitConvertToTarget6,
/* 19305*/    OPC_EmitConvertToTarget7,
/* 19306*/    OPC_EmitConvertToTarget, 8,
/* 19308*/    OPC_EmitConvertToTarget, 9,
/* 19310*/    OPC_EmitConvertToTarget, 10,
/* 19312*/    OPC_EmitConvertToTarget, 11,
/* 19314*/    OPC_EmitConvertToTarget, 12,
/* 19316*/    OPC_EmitConvertToTarget, 13,
/* 19318*/    OPC_EmitConvertToTarget, 14,
/* 19320*/    OPC_EmitConvertToTarget, 15,
/* 19322*/    OPC_EmitConvertToTarget, 16,
/* 19324*/    OPC_EmitConvertToTarget, 17,
/* 19326*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SHUFFLE),
                  MVT::v4f32, 18/*#Ops*/, 0, 1, 18, 19, 20, 21, 22, 23, 24, 25, 26, 27, 28, 29, 30, 31, 32, 33, 
              // Src: (wasm_shuffle:{ *:[v4f32] } V128:{ *:[v4f32] }:$x, V128:{ *:[v4f32] }:$y, (timm:{ *:[i32] }):$m0, (timm:{ *:[i32] }):$m1, (timm:{ *:[i32] }):$m2, (timm:{ *:[i32] }):$m3, (timm:{ *:[i32] }):$m4, (timm:{ *:[i32] }):$m5, (timm:{ *:[i32] }):$m6, (timm:{ *:[i32] }):$m7, (timm:{ *:[i32] }):$m8, (timm:{ *:[i32] }):$m9, (timm:{ *:[i32] }):$mA, (timm:{ *:[i32] }):$mB, (timm:{ *:[i32] }):$mC, (timm:{ *:[i32] }):$mD, (timm:{ *:[i32] }):$mE, (timm:{ *:[i32] }):$mF) - Complexity = 51
              // Dst: (SHUFFLE:{ *:[v4f32] } ?:{ *:[v4f32] }:$x, ?:{ *:[v4f32] }:$y, (imm:{ *:[i32] }):$m0, (imm:{ *:[i32] }):$m1, (imm:{ *:[i32] }):$m2, (imm:{ *:[i32] }):$m3, (imm:{ *:[i32] }):$m4, (imm:{ *:[i32] }):$m5, (imm:{ *:[i32] }):$m6, (imm:{ *:[i32] }):$m7, (imm:{ *:[i32] }):$m8, (imm:{ *:[i32] }):$m9, (imm:{ *:[i32] }):$mA, (imm:{ *:[i32] }):$mB, (imm:{ *:[i32] }):$mC, (imm:{ *:[i32] }):$mD, (imm:{ *:[i32] }):$mE, (imm:{ *:[i32] }):$mF)
/* 19349*/   0, // EndSwitchOpcode
/* 19350*/  /*Scope*/ 83|128,2/*339*/, /*->19691*/
/* 19352*/   OPC_CheckChild0Type, MVT::v2f64,
/* 19354*/   OPC_RecordChild1, // #1 = $y
/* 19355*/   OPC_CheckChild1Type, MVT::v2f64,
/* 19357*/   OPC_RecordChild2, // #2 = $m0
/* 19358*/   OPC_MoveChild2,
/* 19359*/   OPC_SwitchOpcode /*2 cases */, 41|128,1/*169*/, TARGET_VAL(ISD::Constant),// ->19533
/* 19364*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 19365*/    OPC_CheckTypeI32,
/* 19366*/    OPC_MoveSibling3,
/* 19367*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 19370*/    OPC_RecordNode, // #3 = $m1
/* 19371*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 19372*/    OPC_CheckTypeI32,
/* 19373*/    OPC_MoveSibling4,
/* 19374*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 19377*/    OPC_RecordNode, // #4 = $m2
/* 19378*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 19379*/    OPC_CheckTypeI32,
/* 19380*/    OPC_MoveSibling5,
/* 19381*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 19384*/    OPC_RecordNode, // #5 = $m3
/* 19385*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 19386*/    OPC_CheckTypeI32,
/* 19387*/    OPC_MoveSibling6,
/* 19388*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 19391*/    OPC_RecordNode, // #6 = $m4
/* 19392*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 19393*/    OPC_CheckTypeI32,
/* 19394*/    OPC_MoveSibling7,
/* 19395*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 19398*/    OPC_RecordNode, // #7 = $m5
/* 19399*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 19400*/    OPC_CheckTypeI32,
/* 19401*/    OPC_MoveSibling, 8,
/* 19403*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 19406*/    OPC_RecordNode, // #8 = $m6
/* 19407*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 19408*/    OPC_CheckTypeI32,
/* 19409*/    OPC_MoveSibling, 9,
/* 19411*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 19414*/    OPC_RecordNode, // #9 = $m7
/* 19415*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 19416*/    OPC_CheckTypeI32,
/* 19417*/    OPC_MoveSibling, 10,
/* 19419*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 19422*/    OPC_RecordNode, // #10 = $m8
/* 19423*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 19424*/    OPC_CheckTypeI32,
/* 19425*/    OPC_MoveSibling, 11,
/* 19427*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 19430*/    OPC_RecordNode, // #11 = $m9
/* 19431*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 19432*/    OPC_CheckTypeI32,
/* 19433*/    OPC_MoveSibling, 12,
/* 19435*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 19438*/    OPC_RecordNode, // #12 = $mA
/* 19439*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 19440*/    OPC_CheckTypeI32,
/* 19441*/    OPC_MoveSibling, 13,
/* 19443*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 19446*/    OPC_RecordNode, // #13 = $mB
/* 19447*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 19448*/    OPC_CheckTypeI32,
/* 19449*/    OPC_MoveSibling, 14,
/* 19451*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 19454*/    OPC_RecordNode, // #14 = $mC
/* 19455*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 19456*/    OPC_CheckTypeI32,
/* 19457*/    OPC_MoveSibling, 15,
/* 19459*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 19462*/    OPC_RecordNode, // #15 = $mD
/* 19463*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 19464*/    OPC_CheckTypeI32,
/* 19465*/    OPC_MoveSibling, 16,
/* 19467*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 19470*/    OPC_RecordNode, // #16 = $mE
/* 19471*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 19472*/    OPC_CheckTypeI32,
/* 19473*/    OPC_MoveSibling, 17,
/* 19475*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 19478*/    OPC_RecordNode, // #17 = $mF
/* 19479*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 19480*/    OPC_CheckTypeI32,
/* 19481*/    OPC_MoveParent,
/* 19482*/    OPC_CheckType, MVT::v2f64,
/* 19484*/    OPC_EmitConvertToTarget2,
/* 19485*/    OPC_EmitConvertToTarget3,
/* 19486*/    OPC_EmitConvertToTarget4,
/* 19487*/    OPC_EmitConvertToTarget5,
/* 19488*/    OPC_EmitConvertToTarget6,
/* 19489*/    OPC_EmitConvertToTarget7,
/* 19490*/    OPC_EmitConvertToTarget, 8,
/* 19492*/    OPC_EmitConvertToTarget, 9,
/* 19494*/    OPC_EmitConvertToTarget, 10,
/* 19496*/    OPC_EmitConvertToTarget, 11,
/* 19498*/    OPC_EmitConvertToTarget, 12,
/* 19500*/    OPC_EmitConvertToTarget, 13,
/* 19502*/    OPC_EmitConvertToTarget, 14,
/* 19504*/    OPC_EmitConvertToTarget, 15,
/* 19506*/    OPC_EmitConvertToTarget, 16,
/* 19508*/    OPC_EmitConvertToTarget, 17,
/* 19510*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SHUFFLE),
                  MVT::v2f64, 18/*#Ops*/, 0, 1, 18, 19, 20, 21, 22, 23, 24, 25, 26, 27, 28, 29, 30, 31, 32, 33, 
              // Src: (wasm_shuffle:{ *:[v2f64] } V128:{ *:[v2f64] }:$x, V128:{ *:[v2f64] }:$y, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m0, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m1, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m2, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m3, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m4, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m5, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m6, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m7, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m8, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m9, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$mA, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$mB, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$mC, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$mD, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$mE, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$mF) - Complexity = 67
              // Dst: (SHUFFLE:{ *:[v2f64] } ?:{ *:[v2f64] }:$x, ?:{ *:[v2f64] }:$y, (imm:{ *:[i32] }):$m0, (imm:{ *:[i32] }):$m1, (imm:{ *:[i32] }):$m2, (imm:{ *:[i32] }):$m3, (imm:{ *:[i32] }):$m4, (imm:{ *:[i32] }):$m5, (imm:{ *:[i32] }):$m6, (imm:{ *:[i32] }):$m7, (imm:{ *:[i32] }):$m8, (imm:{ *:[i32] }):$m9, (imm:{ *:[i32] }):$mA, (imm:{ *:[i32] }):$mB, (imm:{ *:[i32] }):$mC, (imm:{ *:[i32] }):$mD, (imm:{ *:[i32] }):$mE, (imm:{ *:[i32] }):$mF)
/* 19533*/   /*SwitchOpcode*/ 25|128,1/*153*/, TARGET_VAL(ISD::TargetConstant),// ->19690
/* 19537*/    OPC_CheckTypeI32,
/* 19538*/    OPC_MoveSibling3,
/* 19539*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 19542*/    OPC_RecordNode, // #3 = $m1
/* 19543*/    OPC_CheckTypeI32,
/* 19544*/    OPC_MoveSibling4,
/* 19545*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 19548*/    OPC_RecordNode, // #4 = $m2
/* 19549*/    OPC_CheckTypeI32,
/* 19550*/    OPC_MoveSibling5,
/* 19551*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 19554*/    OPC_RecordNode, // #5 = $m3
/* 19555*/    OPC_CheckTypeI32,
/* 19556*/    OPC_MoveSibling6,
/* 19557*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 19560*/    OPC_RecordNode, // #6 = $m4
/* 19561*/    OPC_CheckTypeI32,
/* 19562*/    OPC_MoveSibling7,
/* 19563*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 19566*/    OPC_RecordNode, // #7 = $m5
/* 19567*/    OPC_CheckTypeI32,
/* 19568*/    OPC_MoveSibling, 8,
/* 19570*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 19573*/    OPC_RecordNode, // #8 = $m6
/* 19574*/    OPC_CheckTypeI32,
/* 19575*/    OPC_MoveSibling, 9,
/* 19577*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 19580*/    OPC_RecordNode, // #9 = $m7
/* 19581*/    OPC_CheckTypeI32,
/* 19582*/    OPC_MoveSibling, 10,
/* 19584*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 19587*/    OPC_RecordNode, // #10 = $m8
/* 19588*/    OPC_CheckTypeI32,
/* 19589*/    OPC_MoveSibling, 11,
/* 19591*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 19594*/    OPC_RecordNode, // #11 = $m9
/* 19595*/    OPC_CheckTypeI32,
/* 19596*/    OPC_MoveSibling, 12,
/* 19598*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 19601*/    OPC_RecordNode, // #12 = $mA
/* 19602*/    OPC_CheckTypeI32,
/* 19603*/    OPC_MoveSibling, 13,
/* 19605*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 19608*/    OPC_RecordNode, // #13 = $mB
/* 19609*/    OPC_CheckTypeI32,
/* 19610*/    OPC_MoveSibling, 14,
/* 19612*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 19615*/    OPC_RecordNode, // #14 = $mC
/* 19616*/    OPC_CheckTypeI32,
/* 19617*/    OPC_MoveSibling, 15,
/* 19619*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 19622*/    OPC_RecordNode, // #15 = $mD
/* 19623*/    OPC_CheckTypeI32,
/* 19624*/    OPC_MoveSibling, 16,
/* 19626*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 19629*/    OPC_RecordNode, // #16 = $mE
/* 19630*/    OPC_CheckTypeI32,
/* 19631*/    OPC_MoveSibling, 17,
/* 19633*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 19636*/    OPC_RecordNode, // #17 = $mF
/* 19637*/    OPC_CheckTypeI32,
/* 19638*/    OPC_MoveParent,
/* 19639*/    OPC_CheckType, MVT::v2f64,
/* 19641*/    OPC_EmitConvertToTarget2,
/* 19642*/    OPC_EmitConvertToTarget3,
/* 19643*/    OPC_EmitConvertToTarget4,
/* 19644*/    OPC_EmitConvertToTarget5,
/* 19645*/    OPC_EmitConvertToTarget6,
/* 19646*/    OPC_EmitConvertToTarget7,
/* 19647*/    OPC_EmitConvertToTarget, 8,
/* 19649*/    OPC_EmitConvertToTarget, 9,
/* 19651*/    OPC_EmitConvertToTarget, 10,
/* 19653*/    OPC_EmitConvertToTarget, 11,
/* 19655*/    OPC_EmitConvertToTarget, 12,
/* 19657*/    OPC_EmitConvertToTarget, 13,
/* 19659*/    OPC_EmitConvertToTarget, 14,
/* 19661*/    OPC_EmitConvertToTarget, 15,
/* 19663*/    OPC_EmitConvertToTarget, 16,
/* 19665*/    OPC_EmitConvertToTarget, 17,
/* 19667*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SHUFFLE),
                  MVT::v2f64, 18/*#Ops*/, 0, 1, 18, 19, 20, 21, 22, 23, 24, 25, 26, 27, 28, 29, 30, 31, 32, 33, 
              // Src: (wasm_shuffle:{ *:[v2f64] } V128:{ *:[v2f64] }:$x, V128:{ *:[v2f64] }:$y, (timm:{ *:[i32] }):$m0, (timm:{ *:[i32] }):$m1, (timm:{ *:[i32] }):$m2, (timm:{ *:[i32] }):$m3, (timm:{ *:[i32] }):$m4, (timm:{ *:[i32] }):$m5, (timm:{ *:[i32] }):$m6, (timm:{ *:[i32] }):$m7, (timm:{ *:[i32] }):$m8, (timm:{ *:[i32] }):$m9, (timm:{ *:[i32] }):$mA, (timm:{ *:[i32] }):$mB, (timm:{ *:[i32] }):$mC, (timm:{ *:[i32] }):$mD, (timm:{ *:[i32] }):$mE, (timm:{ *:[i32] }):$mF) - Complexity = 51
              // Dst: (SHUFFLE:{ *:[v2f64] } ?:{ *:[v2f64] }:$x, ?:{ *:[v2f64] }:$y, (imm:{ *:[i32] }):$m0, (imm:{ *:[i32] }):$m1, (imm:{ *:[i32] }):$m2, (imm:{ *:[i32] }):$m3, (imm:{ *:[i32] }):$m4, (imm:{ *:[i32] }):$m5, (imm:{ *:[i32] }):$m6, (imm:{ *:[i32] }):$m7, (imm:{ *:[i32] }):$m8, (imm:{ *:[i32] }):$m9, (imm:{ *:[i32] }):$mA, (imm:{ *:[i32] }):$mB, (imm:{ *:[i32] }):$mC, (imm:{ *:[i32] }):$mD, (imm:{ *:[i32] }):$mE, (imm:{ *:[i32] }):$mF)
/* 19690*/   0, // EndSwitchOpcode
/* 19691*/  0, /*End of Scope*/
/* 19692*/ /*SwitchOpcode*/ 41|128,5/*681*/, TARGET_VAL(ISD::INSERT_VECTOR_ELT),// ->20377
/* 19696*/  OPC_Scope, 6|128,1/*134*/, /*->19833*/ // 2 children in Scope
/* 19699*/   OPC_MoveChild0,
/* 19700*/   OPC_CheckOpcode, TARGET_VAL(ISD::SPLAT_VECTOR),
/* 19703*/   OPC_CheckChild0Integer, 0, 
/* 19705*/   OPC_Scope, 62, /*->19769*/ // 2 children in Scope
/* 19707*/    OPC_CheckChild0TypeI32,
/* 19708*/    OPC_MoveSibling1,
/* 19709*/    OPC_CheckOpcode, TARGET_VAL(ISD::LOAD),
/* 19712*/    OPC_RecordMemRef,
/* 19713*/    OPC_RecordNode, // #0 = 'ld' chained node
/* 19714*/    OPC_CheckFoldableChainNode,
/* 19715*/    OPC_RecordChild1, // #1 = $AddrOps32:offset:addr
/* 19716*/    OPC_CheckTypeI32,
/* 19717*/    OPC_Scope, 24, /*->19743*/ // 2 children in Scope
/* 19719*/     OPC_CheckChild1TypeI32,
/* 19720*/     OPC_CheckPredicate, 9, // Predicate_unindexedload
/* 19722*/     OPC_CheckPredicate7,  // Predicate_load
/* 19723*/     OPC_MoveParent,
/* 19724*/     OPC_CheckChild2Integer, 0, 
/* 19726*/     OPC_CheckType, MVT::v4i32,
/* 19728*/     OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64())
/* 19729*/     OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #2 #3
/* 19731*/     OPC_EmitMergeInputChains1_0,
/* 19732*/     OPC_EmitInteger32, 0, 
/* 19734*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_ZERO_I32x4_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::v4i32, 3/*#Ops*/, 4, 2, 3, 
               // Src: (vector_insert:{ *:[v4i32] } (splat_vector:{ *:[v4i32] } 0:{ *:[i32] }), (ld:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[iPTR] }) - Complexity = 29
               // Dst: (LOAD_ZERO_I32x4_A32:{ *:[v4i32] } 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr)
/* 19743*/    /*Scope*/ 24, /*->19768*/
/* 19744*/     OPC_CheckChild1TypeI64,
/* 19745*/     OPC_CheckPredicate, 9, // Predicate_unindexedload
/* 19747*/     OPC_CheckPredicate7,  // Predicate_load
/* 19748*/     OPC_MoveParent,
/* 19749*/     OPC_CheckChild2Integer, 0, 
/* 19751*/     OPC_CheckType, MVT::v4i32,
/* 19753*/     OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64())
/* 19754*/     OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #2 #3
/* 19756*/     OPC_EmitMergeInputChains1_0,
/* 19757*/     OPC_EmitInteger32, 0, 
/* 19759*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_ZERO_I32x4_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::v4i32, 3/*#Ops*/, 4, 2, 3, 
               // Src: (vector_insert:{ *:[v4i32] } (splat_vector:{ *:[v4i32] } 0:{ *:[i32] }), (ld:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[iPTR] }) - Complexity = 29
               // Dst: (LOAD_ZERO_I32x4_A64:{ *:[v4i32] } 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr)
/* 19768*/    0, /*End of Scope*/
/* 19769*/   /*Scope*/ 62, /*->19832*/
/* 19770*/    OPC_CheckChild0TypeI64,
/* 19771*/    OPC_MoveSibling1,
/* 19772*/    OPC_CheckOpcode, TARGET_VAL(ISD::LOAD),
/* 19775*/    OPC_RecordMemRef,
/* 19776*/    OPC_RecordNode, // #0 = 'ld' chained node
/* 19777*/    OPC_CheckFoldableChainNode,
/* 19778*/    OPC_RecordChild1, // #1 = $AddrOps32:offset:addr
/* 19779*/    OPC_CheckTypeI64,
/* 19780*/    OPC_Scope, 24, /*->19806*/ // 2 children in Scope
/* 19782*/     OPC_CheckChild1TypeI32,
/* 19783*/     OPC_CheckPredicate, 9, // Predicate_unindexedload
/* 19785*/     OPC_CheckPredicate7,  // Predicate_load
/* 19786*/     OPC_MoveParent,
/* 19787*/     OPC_CheckChild2Integer, 0, 
/* 19789*/     OPC_CheckType, MVT::v2i64,
/* 19791*/     OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64())
/* 19792*/     OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #2 #3
/* 19794*/     OPC_EmitMergeInputChains1_0,
/* 19795*/     OPC_EmitInteger32, 0, 
/* 19797*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_ZERO_I64x2_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::v2i64, 3/*#Ops*/, 4, 2, 3, 
               // Src: (vector_insert:{ *:[v2i64] } (splat_vector:{ *:[v2i64] } 0:{ *:[i64] }), (ld:{ *:[i64] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[iPTR] }) - Complexity = 29
               // Dst: (LOAD_ZERO_I64x2_A32:{ *:[v2i64] } 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr)
/* 19806*/    /*Scope*/ 24, /*->19831*/
/* 19807*/     OPC_CheckChild1TypeI64,
/* 19808*/     OPC_CheckPredicate, 9, // Predicate_unindexedload
/* 19810*/     OPC_CheckPredicate7,  // Predicate_load
/* 19811*/     OPC_MoveParent,
/* 19812*/     OPC_CheckChild2Integer, 0, 
/* 19814*/     OPC_CheckType, MVT::v2i64,
/* 19816*/     OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64())
/* 19817*/     OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #2 #3
/* 19819*/     OPC_EmitMergeInputChains1_0,
/* 19820*/     OPC_EmitInteger32, 0, 
/* 19822*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_ZERO_I64x2_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::v2i64, 3/*#Ops*/, 4, 2, 3, 
               // Src: (vector_insert:{ *:[v2i64] } (splat_vector:{ *:[v2i64] } 0:{ *:[i64] }), (ld:{ *:[i64] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[iPTR] }) - Complexity = 29
               // Dst: (LOAD_ZERO_I64x2_A64:{ *:[v2i64] } 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr)
/* 19831*/    0, /*End of Scope*/
/* 19832*/   0, /*End of Scope*/
/* 19833*/  /*Scope*/ 29|128,4/*541*/, /*->20376*/
/* 19835*/   OPC_RecordChild0, // #0 = $vec
/* 19836*/   OPC_Scope, 36|128,2/*292*/, /*->20131*/ // 2 children in Scope
/* 19839*/    OPC_MoveChild1,
/* 19840*/    OPC_CheckOpcode, TARGET_VAL(ISD::LOAD),
/* 19843*/    OPC_RecordMemRef,
/* 19844*/    OPC_RecordNode, // #1 = 'ld' chained node
/* 19845*/    OPC_CheckFoldableChainNode,
/* 19846*/    OPC_RecordChild1, // #2 = $addr
/* 19847*/    OPC_Scope, 11|128,1/*139*/, /*->19989*/ // 2 children in Scope
/* 19850*/     OPC_CheckChild1TypeI32,
/* 19851*/     OPC_CheckPredicate, 9, // Predicate_unindexedload
/* 19853*/     OPC_Scope, 67, /*->19922*/ // 2 children in Scope
/* 19855*/      OPC_CheckPredicate, 10, // Predicate_extload
/* 19857*/      OPC_CheckTypeI32,
/* 19858*/      OPC_Scope, 30, /*->19890*/ // 2 children in Scope
/* 19860*/       OPC_CheckPredicate1,  // Predicate_extloadi8
/* 19861*/       OPC_MoveSibling2,
/* 19862*/       OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 19865*/       OPC_RecordNode, // #3 = $idx
/* 19866*/       OPC_CheckPredicate, 15, // Predicate_LaneIdx16
/* 19868*/       OPC_CheckTypeI32,
/* 19869*/       OPC_MoveParent,
/* 19870*/       OPC_CheckType, MVT::v16i8,
/* 19872*/       OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64())
/* 19873*/       OPC_EmitMergeInputChains1_1,
/* 19874*/       OPC_EmitInteger32, 0, 
/* 19876*/       OPC_EmitInteger32, 0, 
/* 19878*/       OPC_EmitConvertToTarget3,
/* 19879*/       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_LANE_I8x16_A32), 0|OPFL_Chain|OPFL_MemRefs,
                     MVT::v16i8, 5/*#Ops*/, 4, 5, 6, 2, 0, 
                 // Src: (vector_insert:{ *:[v16i8] } V128:{ *:[v16i8] }:$vec, (ld:{ *:[i32] } I32:{ *:[i32] }:$addr)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>, (imm:{ *:[i32] })<<P:Predicate_LaneIdx16>>:$idx) - Complexity = 11
                 // Dst: (LOAD_LANE_I8x16_A32:{ *:[v16i8] } 0:{ *:[i32] }, 0:{ *:[i32] }, (imm:{ *:[i32] }):$idx, ?:{ *:[i32] }:$addr, ?:{ *:[v16i8] }:$vec)
/* 19890*/      /*Scope*/ 30, /*->19921*/
/* 19891*/       OPC_CheckPredicate2,  // Predicate_extloadi16
/* 19892*/       OPC_MoveSibling2,
/* 19893*/       OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 19896*/       OPC_RecordNode, // #3 = $idx
/* 19897*/       OPC_CheckPredicate, 16, // Predicate_LaneIdx8
/* 19899*/       OPC_CheckTypeI32,
/* 19900*/       OPC_MoveParent,
/* 19901*/       OPC_CheckType, MVT::v8i16,
/* 19903*/       OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64())
/* 19904*/       OPC_EmitMergeInputChains1_1,
/* 19905*/       OPC_EmitInteger32, 0, 
/* 19907*/       OPC_EmitInteger32, 0, 
/* 19909*/       OPC_EmitConvertToTarget3,
/* 19910*/       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_LANE_I16x8_A32), 0|OPFL_Chain|OPFL_MemRefs,
                     MVT::v8i16, 5/*#Ops*/, 4, 5, 6, 2, 0, 
                 // Src: (vector_insert:{ *:[v8i16] } V128:{ *:[v8i16] }:$vec, (ld:{ *:[i32] } I32:{ *:[i32] }:$addr)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>, (imm:{ *:[i32] })<<P:Predicate_LaneIdx8>>:$idx) - Complexity = 11
                 // Dst: (LOAD_LANE_I16x8_A32:{ *:[v8i16] } 0:{ *:[i32] }, 0:{ *:[i32] }, (imm:{ *:[i32] }):$idx, ?:{ *:[i32] }:$addr, ?:{ *:[v8i16] }:$vec)
/* 19921*/      0, /*End of Scope*/
/* 19922*/     /*Scope*/ 65, /*->19988*/
/* 19923*/      OPC_CheckPredicate7,  // Predicate_load
/* 19924*/      OPC_SwitchType /*2 cases */, 29, MVT::i32,// ->19956
/* 19927*/       OPC_MoveSibling2,
/* 19928*/       OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 19931*/       OPC_RecordNode, // #3 = $idx
/* 19932*/       OPC_CheckPredicate, 17, // Predicate_LaneIdx4
/* 19934*/       OPC_CheckTypeI32,
/* 19935*/       OPC_MoveParent,
/* 19936*/       OPC_CheckType, MVT::v4i32,
/* 19938*/       OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64())
/* 19939*/       OPC_EmitMergeInputChains1_1,
/* 19940*/       OPC_EmitInteger32, 0, 
/* 19942*/       OPC_EmitInteger32, 0, 
/* 19944*/       OPC_EmitConvertToTarget3,
/* 19945*/       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_LANE_I32x4_A32), 0|OPFL_Chain|OPFL_MemRefs,
                     MVT::v4i32, 5/*#Ops*/, 4, 5, 6, 2, 0, 
                 // Src: (vector_insert:{ *:[v4i32] } V128:{ *:[v4i32] }:$vec, (ld:{ *:[i32] } I32:{ *:[i32] }:$addr)<<P:Predicate_unindexedload>><<P:Predicate_load>>, (imm:{ *:[i32] })<<P:Predicate_LaneIdx4>>:$idx) - Complexity = 11
                 // Dst: (LOAD_LANE_I32x4_A32:{ *:[v4i32] } 0:{ *:[i32] }, 0:{ *:[i32] }, (imm:{ *:[i32] }):$idx, ?:{ *:[i32] }:$addr, ?:{ *:[v4i32] }:$vec)
/* 19956*/      /*SwitchType*/ 29, MVT::i64,// ->19987
/* 19958*/       OPC_MoveSibling2,
/* 19959*/       OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 19962*/       OPC_RecordNode, // #3 = $idx
/* 19963*/       OPC_CheckPredicate, 18, // Predicate_LaneIdx2
/* 19965*/       OPC_CheckTypeI32,
/* 19966*/       OPC_MoveParent,
/* 19967*/       OPC_CheckType, MVT::v2i64,
/* 19969*/       OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64())
/* 19970*/       OPC_EmitMergeInputChains1_1,
/* 19971*/       OPC_EmitInteger32, 0, 
/* 19973*/       OPC_EmitInteger32, 0, 
/* 19975*/       OPC_EmitConvertToTarget3,
/* 19976*/       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_LANE_I64x2_A32), 0|OPFL_Chain|OPFL_MemRefs,
                     MVT::v2i64, 5/*#Ops*/, 4, 5, 6, 2, 0, 
                 // Src: (vector_insert:{ *:[v2i64] } V128:{ *:[v2i64] }:$vec, (ld:{ *:[i64] } I32:{ *:[i32] }:$addr)<<P:Predicate_unindexedload>><<P:Predicate_load>>, (imm:{ *:[i32] })<<P:Predicate_LaneIdx2>>:$idx) - Complexity = 11
                 // Dst: (LOAD_LANE_I64x2_A32:{ *:[v2i64] } 0:{ *:[i32] }, 0:{ *:[i32] }, (imm:{ *:[i32] }):$idx, ?:{ *:[i32] }:$addr, ?:{ *:[v2i64] }:$vec)
/* 19987*/      0, // EndSwitchType
/* 19988*/     0, /*End of Scope*/
/* 19989*/    /*Scope*/ 11|128,1/*139*/, /*->20130*/
/* 19991*/     OPC_CheckChild1TypeI64,
/* 19992*/     OPC_CheckPredicate, 9, // Predicate_unindexedload
/* 19994*/     OPC_Scope, 67, /*->20063*/ // 2 children in Scope
/* 19996*/      OPC_CheckPredicate, 10, // Predicate_extload
/* 19998*/      OPC_CheckTypeI32,
/* 19999*/      OPC_Scope, 30, /*->20031*/ // 2 children in Scope
/* 20001*/       OPC_CheckPredicate1,  // Predicate_extloadi8
/* 20002*/       OPC_MoveSibling2,
/* 20003*/       OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 20006*/       OPC_RecordNode, // #3 = $idx
/* 20007*/       OPC_CheckPredicate, 15, // Predicate_LaneIdx16
/* 20009*/       OPC_CheckTypeI32,
/* 20010*/       OPC_MoveParent,
/* 20011*/       OPC_CheckType, MVT::v16i8,
/* 20013*/       OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64())
/* 20014*/       OPC_EmitMergeInputChains1_1,
/* 20015*/       OPC_EmitInteger32, 0, 
/* 20017*/       OPC_EmitInteger64, 0, 
/* 20019*/       OPC_EmitConvertToTarget3,
/* 20020*/       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_LANE_I8x16_A64), 0|OPFL_Chain|OPFL_MemRefs,
                     MVT::v16i8, 5/*#Ops*/, 4, 5, 6, 2, 0, 
                 // Src: (vector_insert:{ *:[v16i8] } V128:{ *:[v16i8] }:$vec, (ld:{ *:[i32] } I64:{ *:[i64] }:$addr)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>, (imm:{ *:[i32] })<<P:Predicate_LaneIdx16>>:$idx) - Complexity = 11
                 // Dst: (LOAD_LANE_I8x16_A64:{ *:[v16i8] } 0:{ *:[i32] }, 0:{ *:[i64] }, (imm:{ *:[i32] }):$idx, ?:{ *:[i64] }:$addr, ?:{ *:[v16i8] }:$vec)
/* 20031*/      /*Scope*/ 30, /*->20062*/
/* 20032*/       OPC_CheckPredicate2,  // Predicate_extloadi16
/* 20033*/       OPC_MoveSibling2,
/* 20034*/       OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 20037*/       OPC_RecordNode, // #3 = $idx
/* 20038*/       OPC_CheckPredicate, 16, // Predicate_LaneIdx8
/* 20040*/       OPC_CheckTypeI32,
/* 20041*/       OPC_MoveParent,
/* 20042*/       OPC_CheckType, MVT::v8i16,
/* 20044*/       OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64())
/* 20045*/       OPC_EmitMergeInputChains1_1,
/* 20046*/       OPC_EmitInteger32, 0, 
/* 20048*/       OPC_EmitInteger64, 0, 
/* 20050*/       OPC_EmitConvertToTarget3,
/* 20051*/       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_LANE_I16x8_A64), 0|OPFL_Chain|OPFL_MemRefs,
                     MVT::v8i16, 5/*#Ops*/, 4, 5, 6, 2, 0, 
                 // Src: (vector_insert:{ *:[v8i16] } V128:{ *:[v8i16] }:$vec, (ld:{ *:[i32] } I64:{ *:[i64] }:$addr)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>, (imm:{ *:[i32] })<<P:Predicate_LaneIdx8>>:$idx) - Complexity = 11
                 // Dst: (LOAD_LANE_I16x8_A64:{ *:[v8i16] } 0:{ *:[i32] }, 0:{ *:[i64] }, (imm:{ *:[i32] }):$idx, ?:{ *:[i64] }:$addr, ?:{ *:[v8i16] }:$vec)
/* 20062*/      0, /*End of Scope*/
/* 20063*/     /*Scope*/ 65, /*->20129*/
/* 20064*/      OPC_CheckPredicate7,  // Predicate_load
/* 20065*/      OPC_SwitchType /*2 cases */, 29, MVT::i32,// ->20097
/* 20068*/       OPC_MoveSibling2,
/* 20069*/       OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 20072*/       OPC_RecordNode, // #3 = $idx
/* 20073*/       OPC_CheckPredicate, 17, // Predicate_LaneIdx4
/* 20075*/       OPC_CheckTypeI32,
/* 20076*/       OPC_MoveParent,
/* 20077*/       OPC_CheckType, MVT::v4i32,
/* 20079*/       OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64())
/* 20080*/       OPC_EmitMergeInputChains1_1,
/* 20081*/       OPC_EmitInteger32, 0, 
/* 20083*/       OPC_EmitInteger64, 0, 
/* 20085*/       OPC_EmitConvertToTarget3,
/* 20086*/       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_LANE_I32x4_A64), 0|OPFL_Chain|OPFL_MemRefs,
                     MVT::v4i32, 5/*#Ops*/, 4, 5, 6, 2, 0, 
                 // Src: (vector_insert:{ *:[v4i32] } V128:{ *:[v4i32] }:$vec, (ld:{ *:[i32] } I64:{ *:[i64] }:$addr)<<P:Predicate_unindexedload>><<P:Predicate_load>>, (imm:{ *:[i32] })<<P:Predicate_LaneIdx4>>:$idx) - Complexity = 11
                 // Dst: (LOAD_LANE_I32x4_A64:{ *:[v4i32] } 0:{ *:[i32] }, 0:{ *:[i64] }, (imm:{ *:[i32] }):$idx, ?:{ *:[i64] }:$addr, ?:{ *:[v4i32] }:$vec)
/* 20097*/      /*SwitchType*/ 29, MVT::i64,// ->20128
/* 20099*/       OPC_MoveSibling2,
/* 20100*/       OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 20103*/       OPC_RecordNode, // #3 = $idx
/* 20104*/       OPC_CheckPredicate, 18, // Predicate_LaneIdx2
/* 20106*/       OPC_CheckTypeI32,
/* 20107*/       OPC_MoveParent,
/* 20108*/       OPC_CheckType, MVT::v2i64,
/* 20110*/       OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64())
/* 20111*/       OPC_EmitMergeInputChains1_1,
/* 20112*/       OPC_EmitInteger32, 0, 
/* 20114*/       OPC_EmitInteger64, 0, 
/* 20116*/       OPC_EmitConvertToTarget3,
/* 20117*/       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_LANE_I64x2_A64), 0|OPFL_Chain|OPFL_MemRefs,
                     MVT::v2i64, 5/*#Ops*/, 4, 5, 6, 2, 0, 
                 // Src: (vector_insert:{ *:[v2i64] } V128:{ *:[v2i64] }:$vec, (ld:{ *:[i64] } I64:{ *:[i64] }:$addr)<<P:Predicate_unindexedload>><<P:Predicate_load>>, (imm:{ *:[i32] })<<P:Predicate_LaneIdx2>>:$idx) - Complexity = 11
                 // Dst: (LOAD_LANE_I64x2_A64:{ *:[v2i64] } 0:{ *:[i32] }, 0:{ *:[i64] }, (imm:{ *:[i32] }):$idx, ?:{ *:[i64] }:$addr, ?:{ *:[v2i64] }:$vec)
/* 20128*/      0, // EndSwitchType
/* 20129*/     0, /*End of Scope*/
/* 20130*/    0, /*End of Scope*/
/* 20131*/   /*Scope*/ 114|128,1/*242*/, /*->20375*/
/* 20133*/    OPC_RecordChild1, // #1 = $x
/* 20134*/    OPC_Scope, 104, /*->20240*/ // 4 children in Scope
/* 20136*/     OPC_CheckChild1TypeI32,
/* 20137*/     OPC_Scope, 56, /*->20195*/ // 2 children in Scope
/* 20139*/      OPC_RecordChild2, // #2 = $idx
/* 20140*/      OPC_MoveChild2,
/* 20141*/      OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 20144*/      OPC_CheckTypeI32,
/* 20145*/      OPC_Scope, 15, /*->20162*/ // 3 children in Scope
/* 20147*/       OPC_CheckPredicate, 15, // Predicate_LaneIdx16
/* 20149*/       OPC_MoveParent,
/* 20150*/       OPC_CheckType, MVT::v16i8,
/* 20152*/       OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 20153*/       OPC_EmitConvertToTarget2,
/* 20154*/       OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::REPLACE_LANE_I8x16),
                     MVT::v16i8, 3/*#Ops*/, 0, 3, 1, 
                 // Src: (vector_insert:{ *:[v16i8] } V128:{ *:[v16i8] }:$vec, I32:{ *:[i32] }:$x, (imm:{ *:[i32] })<<P:Predicate_LaneIdx16>>:$idx) - Complexity = 7
                 // Dst: (REPLACE_LANE_I8x16:{ *:[v16i8] } V128:{ *:[v16i8] }:$vec, (imm:{ *:[i32] }):$idx, I32:{ *:[i32] }:$x)
/* 20162*/      /*Scope*/ 15, /*->20178*/
/* 20163*/       OPC_CheckPredicate, 16, // Predicate_LaneIdx8
/* 20165*/       OPC_MoveParent,
/* 20166*/       OPC_CheckType, MVT::v8i16,
/* 20168*/       OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 20169*/       OPC_EmitConvertToTarget2,
/* 20170*/       OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::REPLACE_LANE_I16x8),
                     MVT::v8i16, 3/*#Ops*/, 0, 3, 1, 
                 // Src: (vector_insert:{ *:[v8i16] } V128:{ *:[v8i16] }:$vec, I32:{ *:[i32] }:$x, (imm:{ *:[i32] })<<P:Predicate_LaneIdx8>>:$idx) - Complexity = 7
                 // Dst: (REPLACE_LANE_I16x8:{ *:[v8i16] } V128:{ *:[v8i16] }:$vec, (imm:{ *:[i32] }):$idx, I32:{ *:[i32] }:$x)
/* 20178*/      /*Scope*/ 15, /*->20194*/
/* 20179*/       OPC_CheckPredicate, 17, // Predicate_LaneIdx4
/* 20181*/       OPC_MoveParent,
/* 20182*/       OPC_CheckType, MVT::v4i32,
/* 20184*/       OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 20185*/       OPC_EmitConvertToTarget2,
/* 20186*/       OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::REPLACE_LANE_I32x4),
                     MVT::v4i32, 3/*#Ops*/, 0, 3, 1, 
                 // Src: (vector_insert:{ *:[v4i32] } V128:{ *:[v4i32] }:$vec, I32:{ *:[i32] }:$x, (imm:{ *:[i32] })<<P:Predicate_LaneIdx4>>:$idx) - Complexity = 7
                 // Dst: (REPLACE_LANE_I32x4:{ *:[v4i32] } V128:{ *:[v4i32] }:$vec, (imm:{ *:[i32] }):$idx, I32:{ *:[i32] }:$x)
/* 20194*/      0, /*End of Scope*/
/* 20195*/     /*Scope*/ 43, /*->20239*/
/* 20196*/      OPC_MoveChild2,
/* 20197*/      OPC_CheckOpcode, TARGET_VAL(ISD::UNDEF),
/* 20200*/      OPC_MoveParent,
/* 20201*/      OPC_SwitchType /*3 cases */, 10, MVT::v16i8,// ->20214
/* 20204*/       OPC_EmitInteger32, 0, 
/* 20206*/       OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::REPLACE_LANE_I8x16),
                     MVT::v16i8, 3/*#Ops*/, 0, 2, 1, 
                 // Src: (vector_insert:{ *:[v16i8] } V128:{ *:[v16i8] }:$vec, I32:{ *:[i32] }:$x, (undef:{ *:[iPTR] })) - Complexity = 6
                 // Dst: (REPLACE_LANE_I8x16:{ *:[v16i8] } ?:{ *:[v16i8] }:$vec, 0:{ *:[i32] }, ?:{ *:[i32] }:$x)
/* 20214*/      /*SwitchType*/ 10, MVT::v8i16,// ->20226
/* 20216*/       OPC_EmitInteger32, 0, 
/* 20218*/       OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::REPLACE_LANE_I16x8),
                     MVT::v8i16, 3/*#Ops*/, 0, 2, 1, 
                 // Src: (vector_insert:{ *:[v8i16] } V128:{ *:[v8i16] }:$vec, I32:{ *:[i32] }:$x, (undef:{ *:[iPTR] })) - Complexity = 6
                 // Dst: (REPLACE_LANE_I16x8:{ *:[v8i16] } ?:{ *:[v8i16] }:$vec, 0:{ *:[i32] }, ?:{ *:[i32] }:$x)
/* 20226*/      /*SwitchType*/ 10, MVT::v4i32,// ->20238
/* 20228*/       OPC_EmitInteger32, 0, 
/* 20230*/       OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::REPLACE_LANE_I32x4),
                     MVT::v4i32, 3/*#Ops*/, 0, 2, 1, 
                 // Src: (vector_insert:{ *:[v4i32] } V128:{ *:[v4i32] }:$vec, I32:{ *:[i32] }:$x, (undef:{ *:[iPTR] })) - Complexity = 6
                 // Dst: (REPLACE_LANE_I32x4:{ *:[v4i32] } ?:{ *:[v4i32] }:$vec, 0:{ *:[i32] }, ?:{ *:[i32] }:$x)
/* 20238*/      0, // EndSwitchType
/* 20239*/     0, /*End of Scope*/
/* 20240*/    /*Scope*/ 43, /*->20284*/
/* 20241*/     OPC_CheckChild1TypeI64,
/* 20242*/     OPC_Scope, 21, /*->20265*/ // 2 children in Scope
/* 20244*/      OPC_RecordChild2, // #2 = $idx
/* 20245*/      OPC_MoveChild2,
/* 20246*/      OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 20249*/      OPC_CheckPredicate, 18, // Predicate_LaneIdx2
/* 20251*/      OPC_CheckTypeI32,
/* 20252*/      OPC_MoveParent,
/* 20253*/      OPC_CheckType, MVT::v2i64,
/* 20255*/      OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 20256*/      OPC_EmitConvertToTarget2,
/* 20257*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::REPLACE_LANE_I64x2),
                    MVT::v2i64, 3/*#Ops*/, 0, 3, 1, 
                // Src: (vector_insert:{ *:[v2i64] } V128:{ *:[v2i64] }:$vec, I64:{ *:[i64] }:$x, (imm:{ *:[i32] })<<P:Predicate_LaneIdx2>>:$idx) - Complexity = 7
                // Dst: (REPLACE_LANE_I64x2:{ *:[v2i64] } V128:{ *:[v2i64] }:$vec, (imm:{ *:[i32] }):$idx, I64:{ *:[i64] }:$x)
/* 20265*/     /*Scope*/ 17, /*->20283*/
/* 20266*/      OPC_MoveChild2,
/* 20267*/      OPC_CheckOpcode, TARGET_VAL(ISD::UNDEF),
/* 20270*/      OPC_MoveParent,
/* 20271*/      OPC_CheckType, MVT::v2i64,
/* 20273*/      OPC_EmitInteger32, 0, 
/* 20275*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::REPLACE_LANE_I64x2),
                    MVT::v2i64, 3/*#Ops*/, 0, 2, 1, 
                // Src: (vector_insert:{ *:[v2i64] } V128:{ *:[v2i64] }:$vec, I64:{ *:[i64] }:$x, (undef:{ *:[iPTR] })) - Complexity = 6
                // Dst: (REPLACE_LANE_I64x2:{ *:[v2i64] } ?:{ *:[v2i64] }:$vec, 0:{ *:[i32] }, ?:{ *:[i64] }:$x)
/* 20283*/     0, /*End of Scope*/
/* 20284*/    /*Scope*/ 44, /*->20329*/
/* 20285*/     OPC_CheckChild1Type, MVT::f32,
/* 20287*/     OPC_Scope, 21, /*->20310*/ // 2 children in Scope
/* 20289*/      OPC_RecordChild2, // #2 = $idx
/* 20290*/      OPC_MoveChild2,
/* 20291*/      OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 20294*/      OPC_CheckPredicate, 17, // Predicate_LaneIdx4
/* 20296*/      OPC_CheckTypeI32,
/* 20297*/      OPC_MoveParent,
/* 20298*/      OPC_CheckType, MVT::v4f32,
/* 20300*/      OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 20301*/      OPC_EmitConvertToTarget2,
/* 20302*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::REPLACE_LANE_F32x4),
                    MVT::v4f32, 3/*#Ops*/, 0, 3, 1, 
                // Src: (vector_insert:{ *:[v4f32] } V128:{ *:[v4f32] }:$vec, F32:{ *:[f32] }:$x, (imm:{ *:[i32] })<<P:Predicate_LaneIdx4>>:$idx) - Complexity = 7
                // Dst: (REPLACE_LANE_F32x4:{ *:[v4f32] } V128:{ *:[v4f32] }:$vec, (imm:{ *:[i32] }):$idx, F32:{ *:[f32] }:$x)
/* 20310*/     /*Scope*/ 17, /*->20328*/
/* 20311*/      OPC_MoveChild2,
/* 20312*/      OPC_CheckOpcode, TARGET_VAL(ISD::UNDEF),
/* 20315*/      OPC_MoveParent,
/* 20316*/      OPC_CheckType, MVT::v4f32,
/* 20318*/      OPC_EmitInteger32, 0, 
/* 20320*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::REPLACE_LANE_F32x4),
                    MVT::v4f32, 3/*#Ops*/, 0, 2, 1, 
                // Src: (vector_insert:{ *:[v4f32] } V128:{ *:[v4f32] }:$vec, F32:{ *:[f32] }:$x, (undef:{ *:[iPTR] })) - Complexity = 6
                // Dst: (REPLACE_LANE_F32x4:{ *:[v4f32] } ?:{ *:[v4f32] }:$vec, 0:{ *:[i32] }, ?:{ *:[f32] }:$x)
/* 20328*/     0, /*End of Scope*/
/* 20329*/    /*Scope*/ 44, /*->20374*/
/* 20330*/     OPC_CheckChild1Type, MVT::f64,
/* 20332*/     OPC_Scope, 21, /*->20355*/ // 2 children in Scope
/* 20334*/      OPC_RecordChild2, // #2 = $idx
/* 20335*/      OPC_MoveChild2,
/* 20336*/      OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 20339*/      OPC_CheckPredicate, 18, // Predicate_LaneIdx2
/* 20341*/      OPC_CheckTypeI32,
/* 20342*/      OPC_MoveParent,
/* 20343*/      OPC_CheckType, MVT::v2f64,
/* 20345*/      OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 20346*/      OPC_EmitConvertToTarget2,
/* 20347*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::REPLACE_LANE_F64x2),
                    MVT::v2f64, 3/*#Ops*/, 0, 3, 1, 
                // Src: (vector_insert:{ *:[v2f64] } V128:{ *:[v2f64] }:$vec, F64:{ *:[f64] }:$x, (imm:{ *:[i32] })<<P:Predicate_LaneIdx2>>:$idx) - Complexity = 7
                // Dst: (REPLACE_LANE_F64x2:{ *:[v2f64] } V128:{ *:[v2f64] }:$vec, (imm:{ *:[i32] }):$idx, F64:{ *:[f64] }:$x)
/* 20355*/     /*Scope*/ 17, /*->20373*/
/* 20356*/      OPC_MoveChild2,
/* 20357*/      OPC_CheckOpcode, TARGET_VAL(ISD::UNDEF),
/* 20360*/      OPC_MoveParent,
/* 20361*/      OPC_CheckType, MVT::v2f64,
/* 20363*/      OPC_EmitInteger32, 0, 
/* 20365*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::REPLACE_LANE_F64x2),
                    MVT::v2f64, 3/*#Ops*/, 0, 2, 1, 
                // Src: (vector_insert:{ *:[v2f64] } V128:{ *:[v2f64] }:$vec, F64:{ *:[f64] }:$x, (undef:{ *:[iPTR] })) - Complexity = 6
                // Dst: (REPLACE_LANE_F64x2:{ *:[v2f64] } ?:{ *:[v2f64] }:$vec, 0:{ *:[i32] }, ?:{ *:[f64] }:$x)
/* 20373*/     0, /*End of Scope*/
/* 20374*/    0, /*End of Scope*/
/* 20375*/   0, /*End of Scope*/
/* 20376*/  0, /*End of Scope*/
/* 20377*/ /*SwitchOpcode*/ 96|128,1/*224*/, TARGET_VAL(WebAssemblyISD::VEC_SHR_U),// ->20605
/* 20381*/  OPC_Scope, 87, /*->20470*/ // 2 children in Scope
/* 20383*/   OPC_MoveChild0,
/* 20384*/   OPC_CheckOpcode, TARGET_VAL(ISD::ADD),
/* 20387*/   OPC_MoveChild0,
/* 20388*/   OPC_SwitchOpcode /*2 cases */, 37, TARGET_VAL(ISD::ADD),// ->20429
/* 20392*/    OPC_RecordChild0, // #0 = $lhs
/* 20393*/    OPC_RecordChild1, // #1 = $rhs
/* 20394*/    OPC_CheckPredicate, 24, // Predicate_add_nuw
/* 20396*/    OPC_MoveSibling1,
/* 20397*/    OPC_CheckOpcode, TARGET_VAL(ISD::SPLAT_VECTOR),
/* 20400*/    OPC_CheckChild0Integer, 2, 
/* 20402*/    OPC_CheckChild0TypeI32,
/* 20403*/    OPC_MoveParent,
/* 20404*/    OPC_CheckPredicate, 24, // Predicate_add_nuw
/* 20406*/    OPC_MoveParent,
/* 20407*/    OPC_CheckChild1Integer, 2, 
/* 20409*/    OPC_SwitchType /*2 cases */, 7, MVT::v16i8,// ->20419
/* 20412*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::AVGR_U_I8x16),
                   MVT::v16i8, 2/*#Ops*/, 0, 1, 
               // Src: (wasm_shr_u:{ *:[v16i8] } (add:{ *:[v16i8] } (add:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs)<<P:Predicate_add_nuw>>, (splat_vector:{ *:[v16i8] } 1:{ *:[i32] }))<<P:Predicate_add_nuw>>, 1:{ *:[i32] }) - Complexity = 24
               // Dst: (AVGR_U_I8x16:{ *:[v16i8] } ?:{ *:[v16i8] }:$lhs, ?:{ *:[v16i8] }:$rhs)
/* 20419*/    /*SwitchType*/ 7, MVT::v8i16,// ->20428
/* 20421*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::AVGR_U_I16x8),
                   MVT::v8i16, 2/*#Ops*/, 0, 1, 
               // Src: (wasm_shr_u:{ *:[v8i16] } (add:{ *:[v8i16] } (add:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs)<<P:Predicate_add_nuw>>, (splat_vector:{ *:[v8i16] } 1:{ *:[i32] }))<<P:Predicate_add_nuw>>, 1:{ *:[i32] }) - Complexity = 24
               // Dst: (AVGR_U_I16x8:{ *:[v8i16] } ?:{ *:[v8i16] }:$lhs, ?:{ *:[v8i16] }:$rhs)
/* 20428*/    0, // EndSwitchType
/* 20429*/   /*SwitchOpcode*/ 37, TARGET_VAL(ISD::SPLAT_VECTOR),// ->20469
/* 20432*/    OPC_CheckChild0Integer, 2, 
/* 20434*/    OPC_CheckChild0TypeI32,
/* 20435*/    OPC_MoveSibling1,
/* 20436*/    OPC_CheckOpcode, TARGET_VAL(ISD::ADD),
/* 20439*/    OPC_RecordChild0, // #0 = $lhs
/* 20440*/    OPC_RecordChild1, // #1 = $rhs
/* 20441*/    OPC_CheckPredicate, 24, // Predicate_add_nuw
/* 20443*/    OPC_MoveParent,
/* 20444*/    OPC_CheckPredicate, 24, // Predicate_add_nuw
/* 20446*/    OPC_MoveParent,
/* 20447*/    OPC_CheckChild1Integer, 2, 
/* 20449*/    OPC_SwitchType /*2 cases */, 7, MVT::v16i8,// ->20459
/* 20452*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::AVGR_U_I8x16),
                   MVT::v16i8, 2/*#Ops*/, 0, 1, 
               // Src: (wasm_shr_u:{ *:[v16i8] } (add:{ *:[v16i8] } (splat_vector:{ *:[v16i8] } 1:{ *:[i32] }), (add:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs)<<P:Predicate_add_nuw>>)<<P:Predicate_add_nuw>>, 1:{ *:[i32] }) - Complexity = 24
               // Dst: (AVGR_U_I8x16:{ *:[v16i8] } ?:{ *:[v16i8] }:$lhs, ?:{ *:[v16i8] }:$rhs)
/* 20459*/    /*SwitchType*/ 7, MVT::v8i16,// ->20468
/* 20461*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::AVGR_U_I16x8),
                   MVT::v8i16, 2/*#Ops*/, 0, 1, 
               // Src: (wasm_shr_u:{ *:[v8i16] } (add:{ *:[v8i16] } (splat_vector:{ *:[v8i16] } 1:{ *:[i32] }), (add:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs)<<P:Predicate_add_nuw>>)<<P:Predicate_add_nuw>>, 1:{ *:[i32] }) - Complexity = 24
               // Dst: (AVGR_U_I16x8:{ *:[v8i16] } ?:{ *:[v8i16] }:$lhs, ?:{ *:[v8i16] }:$rhs)
/* 20468*/    0, // EndSwitchType
/* 20469*/   0, // EndSwitchOpcode
/* 20470*/  /*Scope*/ 4|128,1/*132*/, /*->20604*/
/* 20472*/   OPC_RecordChild0, // #0 = $lhs
/* 20473*/   OPC_Scope, 84, /*->20559*/ // 2 children in Scope
/* 20475*/    OPC_MoveChild1,
/* 20476*/    OPC_Scope, 24, /*->20502*/ // 5 children in Scope
/* 20478*/     OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/* 20481*/     OPC_MoveChild0,
/* 20482*/     OPC_CheckAndImm, 63, 
/* 20484*/     OPC_RecordChild0, // #1 = $rhs
/* 20485*/     OPC_MoveParent,
/* 20486*/     OPC_MoveParent,
/* 20487*/     OPC_CheckType, MVT::v2i64,
/* 20489*/     OPC_EmitNode1None, TARGET_VAL(WebAssembly::I32_WRAP_I64),
                   MVT::i32, 1/*#Ops*/, 1,  // Results = #2
/* 20495*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SHR_U_I64x2),
                   MVT::v2i64, 2/*#Ops*/, 0, 2, 
               // Src: (wasm_shr_u:{ *:[v2i64] } V128:{ *:[v2i64] }:$lhs, (trunc:{ *:[i32] } (and:{ *:[i64] } I64:{ *:[i64] }:$rhs, 63:{ *:[i64] }))) - Complexity = 14
               // Dst: (SHR_U_I64x2:{ *:[v2i64] } V128:{ *:[v2i64] }:$lhs, (I32_WRAP_I64:{ *:[i32] } I64:{ *:[i64] }:$rhs))
/* 20502*/    /*Scope*/ 13, /*->20516*/
/* 20503*/     OPC_CheckAndImm, 7, 
/* 20505*/     OPC_RecordChild0, // #1 = $rhs
/* 20506*/     OPC_MoveParent,
/* 20507*/     OPC_CheckType, MVT::v16i8,
/* 20509*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SHR_U_I8x16),
                   MVT::v16i8, 2/*#Ops*/, 0, 1, 
               // Src: (wasm_shr_u:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, (and:{ *:[i32] } I32:{ *:[i32] }:$rhs, 7:{ *:[i32] })) - Complexity = 11
               // Dst: (SHR_U_I8x16:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, I32:{ *:[i32] }:$rhs)
/* 20516*/    /*Scope*/ 13, /*->20530*/
/* 20517*/     OPC_CheckAndImm, 15, 
/* 20519*/     OPC_RecordChild0, // #1 = $rhs
/* 20520*/     OPC_MoveParent,
/* 20521*/     OPC_CheckType, MVT::v8i16,
/* 20523*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SHR_U_I16x8),
                   MVT::v8i16, 2/*#Ops*/, 0, 1, 
               // Src: (wasm_shr_u:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, (and:{ *:[i32] } I32:{ *:[i32] }:$rhs, 15:{ *:[i32] })) - Complexity = 11
               // Dst: (SHR_U_I16x8:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, I32:{ *:[i32] }:$rhs)
/* 20530*/    /*Scope*/ 13, /*->20544*/
/* 20531*/     OPC_CheckAndImm, 31, 
/* 20533*/     OPC_RecordChild0, // #1 = $rhs
/* 20534*/     OPC_MoveParent,
/* 20535*/     OPC_CheckType, MVT::v4i32,
/* 20537*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SHR_U_I32x4),
                   MVT::v4i32, 2/*#Ops*/, 0, 1, 
               // Src: (wasm_shr_u:{ *:[v4i32] } V128:{ *:[v4i32] }:$lhs, (and:{ *:[i32] } I32:{ *:[i32] }:$rhs, 31:{ *:[i32] })) - Complexity = 11
               // Dst: (SHR_U_I32x4:{ *:[v4i32] } V128:{ *:[v4i32] }:$lhs, I32:{ *:[i32] }:$rhs)
/* 20544*/    /*Scope*/ 13, /*->20558*/
/* 20545*/     OPC_CheckAndImm, 63, 
/* 20547*/     OPC_RecordChild0, // #1 = $rhs
/* 20548*/     OPC_MoveParent,
/* 20549*/     OPC_CheckType, MVT::v2i64,
/* 20551*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SHR_U_I64x2),
                   MVT::v2i64, 2/*#Ops*/, 0, 1, 
               // Src: (wasm_shr_u:{ *:[v2i64] } V128:{ *:[v2i64] }:$lhs, (and:{ *:[i32] } I32:{ *:[i32] }:$rhs, 63:{ *:[i32] })) - Complexity = 11
               // Dst: (SHR_U_I64x2:{ *:[v2i64] } V128:{ *:[v2i64] }:$lhs, I32:{ *:[i32] }:$rhs)
/* 20558*/    0, /*End of Scope*/
/* 20559*/   /*Scope*/ 43, /*->20603*/
/* 20560*/    OPC_RecordChild1, // #1 = $x
/* 20561*/    OPC_SwitchType /*4 cases */, 8, MVT::v16i8,// ->20572
/* 20564*/     OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 20565*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SHR_U_I8x16),
                   MVT::v16i8, 2/*#Ops*/, 0, 1, 
               // Src: (wasm_shr_u:{ *:[v16i8] } V128:{ *:[v16i8] }:$vec, I32:{ *:[i32] }:$x) - Complexity = 3
               // Dst: (SHR_U_I8x16:{ *:[v16i8] } V128:{ *:[v16i8] }:$vec, I32:{ *:[i32] }:$x)
/* 20572*/    /*SwitchType*/ 8, MVT::v8i16,// ->20582
/* 20574*/     OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 20575*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SHR_U_I16x8),
                   MVT::v8i16, 2/*#Ops*/, 0, 1, 
               // Src: (wasm_shr_u:{ *:[v8i16] } V128:{ *:[v8i16] }:$vec, I32:{ *:[i32] }:$x) - Complexity = 3
               // Dst: (SHR_U_I16x8:{ *:[v8i16] } V128:{ *:[v8i16] }:$vec, I32:{ *:[i32] }:$x)
/* 20582*/    /*SwitchType*/ 8, MVT::v4i32,// ->20592
/* 20584*/     OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 20585*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SHR_U_I32x4),
                   MVT::v4i32, 2/*#Ops*/, 0, 1, 
               // Src: (wasm_shr_u:{ *:[v4i32] } V128:{ *:[v4i32] }:$vec, I32:{ *:[i32] }:$x) - Complexity = 3
               // Dst: (SHR_U_I32x4:{ *:[v4i32] } V128:{ *:[v4i32] }:$vec, I32:{ *:[i32] }:$x)
/* 20592*/    /*SwitchType*/ 8, MVT::v2i64,// ->20602
/* 20594*/     OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 20595*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SHR_U_I64x2),
                   MVT::v2i64, 2/*#Ops*/, 0, 1, 
               // Src: (wasm_shr_u:{ *:[v2i64] } V128:{ *:[v2i64] }:$vec, I32:{ *:[i32] }:$x) - Complexity = 3
               // Dst: (SHR_U_I64x2:{ *:[v2i64] } V128:{ *:[v2i64] }:$vec, I32:{ *:[i32] }:$x)
/* 20602*/    0, // EndSwitchType
/* 20603*/   0, /*End of Scope*/
/* 20604*/  0, /*End of Scope*/
/* 20605*/ /*SwitchOpcode*/ 14|128,4/*526*/, TARGET_VAL(ISD::SPLAT_VECTOR),// ->21135
/* 20609*/  OPC_Scope, 73|128,1/*201*/, /*->20813*/ // 4 children in Scope
/* 20612*/   OPC_MoveChild0,
/* 20613*/   OPC_CheckOpcode, TARGET_VAL(ISD::LOAD),
/* 20616*/   OPC_RecordMemRef,
/* 20617*/   OPC_RecordNode, // #0 = 'ld' chained node
/* 20618*/   OPC_RecordChild1, // #1 = $AddrOps32:offset:addr
/* 20619*/   OPC_Scope, 95, /*->20716*/ // 2 children in Scope
/* 20621*/    OPC_CheckChild1TypeI32,
/* 20622*/    OPC_CheckPredicate, 9, // Predicate_unindexedload
/* 20624*/    OPC_Scope, 45, /*->20671*/ // 2 children in Scope
/* 20626*/     OPC_CheckPredicate, 10, // Predicate_extload
/* 20628*/     OPC_CheckTypeI32,
/* 20629*/     OPC_Scope, 19, /*->20650*/ // 2 children in Scope
/* 20631*/      OPC_CheckPredicate1,  // Predicate_extloadi8
/* 20632*/      OPC_MoveParent,
/* 20633*/      OPC_CheckType, MVT::v16i8,
/* 20635*/      OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64())
/* 20636*/      OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #2 #3
/* 20638*/      OPC_EmitMergeInputChains1_0,
/* 20639*/      OPC_EmitInteger32, 0, 
/* 20641*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD8_SPLAT_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::v16i8, 3/*#Ops*/, 4, 2, 3, 
                // Src: (splat_vector:{ *:[v16i8] } (ld:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>) - Complexity = 16
                // Dst: (LOAD8_SPLAT_A32:{ *:[v16i8] } 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr)
/* 20650*/     /*Scope*/ 19, /*->20670*/
/* 20651*/      OPC_CheckPredicate2,  // Predicate_extloadi16
/* 20652*/      OPC_MoveParent,
/* 20653*/      OPC_CheckType, MVT::v8i16,
/* 20655*/      OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64())
/* 20656*/      OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #2 #3
/* 20658*/      OPC_EmitMergeInputChains1_0,
/* 20659*/      OPC_EmitInteger32, 0, 
/* 20661*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD16_SPLAT_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::v8i16, 3/*#Ops*/, 4, 2, 3, 
                // Src: (splat_vector:{ *:[v8i16] } (ld:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>) - Complexity = 16
                // Dst: (LOAD16_SPLAT_A32:{ *:[v8i16] } 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr)
/* 20670*/     0, /*End of Scope*/
/* 20671*/    /*Scope*/ 43, /*->20715*/
/* 20672*/     OPC_CheckPredicate7,  // Predicate_load
/* 20673*/     OPC_SwitchType /*2 cases */, 18, MVT::i32,// ->20694
/* 20676*/      OPC_MoveParent,
/* 20677*/      OPC_CheckType, MVT::v4i32,
/* 20679*/      OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64())
/* 20680*/      OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #2 #3
/* 20682*/      OPC_EmitMergeInputChains1_0,
/* 20683*/      OPC_EmitInteger32, 0, 
/* 20685*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD32_SPLAT_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::v4i32, 3/*#Ops*/, 4, 2, 3, 
                // Src: (splat_vector:{ *:[v4i32] } (ld:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_load>>) - Complexity = 16
                // Dst: (LOAD32_SPLAT_A32:{ *:[v4i32] } 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr)
/* 20694*/     /*SwitchType*/ 18, MVT::i64,// ->20714
/* 20696*/      OPC_MoveParent,
/* 20697*/      OPC_CheckType, MVT::v2i64,
/* 20699*/      OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64())
/* 20700*/      OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #2 #3
/* 20702*/      OPC_EmitMergeInputChains1_0,
/* 20703*/      OPC_EmitInteger32, 0, 
/* 20705*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD64_SPLAT_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::v2i64, 3/*#Ops*/, 4, 2, 3, 
                // Src: (splat_vector:{ *:[v2i64] } (ld:{ *:[i64] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_load>>) - Complexity = 16
                // Dst: (LOAD64_SPLAT_A32:{ *:[v2i64] } 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr)
/* 20714*/     0, // EndSwitchType
/* 20715*/    0, /*End of Scope*/
/* 20716*/   /*Scope*/ 95, /*->20812*/
/* 20717*/    OPC_CheckChild1TypeI64,
/* 20718*/    OPC_CheckPredicate, 9, // Predicate_unindexedload
/* 20720*/    OPC_Scope, 45, /*->20767*/ // 2 children in Scope
/* 20722*/     OPC_CheckPredicate, 10, // Predicate_extload
/* 20724*/     OPC_CheckTypeI32,
/* 20725*/     OPC_Scope, 19, /*->20746*/ // 2 children in Scope
/* 20727*/      OPC_CheckPredicate1,  // Predicate_extloadi8
/* 20728*/      OPC_MoveParent,
/* 20729*/      OPC_CheckType, MVT::v16i8,
/* 20731*/      OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64())
/* 20732*/      OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #2 #3
/* 20734*/      OPC_EmitMergeInputChains1_0,
/* 20735*/      OPC_EmitInteger32, 0, 
/* 20737*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD8_SPLAT_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::v16i8, 3/*#Ops*/, 4, 2, 3, 
                // Src: (splat_vector:{ *:[v16i8] } (ld:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>) - Complexity = 16
                // Dst: (LOAD8_SPLAT_A64:{ *:[v16i8] } 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr)
/* 20746*/     /*Scope*/ 19, /*->20766*/
/* 20747*/      OPC_CheckPredicate2,  // Predicate_extloadi16
/* 20748*/      OPC_MoveParent,
/* 20749*/      OPC_CheckType, MVT::v8i16,
/* 20751*/      OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64())
/* 20752*/      OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #2 #3
/* 20754*/      OPC_EmitMergeInputChains1_0,
/* 20755*/      OPC_EmitInteger32, 0, 
/* 20757*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD16_SPLAT_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::v8i16, 3/*#Ops*/, 4, 2, 3, 
                // Src: (splat_vector:{ *:[v8i16] } (ld:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>) - Complexity = 16
                // Dst: (LOAD16_SPLAT_A64:{ *:[v8i16] } 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr)
/* 20766*/     0, /*End of Scope*/
/* 20767*/    /*Scope*/ 43, /*->20811*/
/* 20768*/     OPC_CheckPredicate7,  // Predicate_load
/* 20769*/     OPC_SwitchType /*2 cases */, 18, MVT::i32,// ->20790
/* 20772*/      OPC_MoveParent,
/* 20773*/      OPC_CheckType, MVT::v4i32,
/* 20775*/      OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64())
/* 20776*/      OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #2 #3
/* 20778*/      OPC_EmitMergeInputChains1_0,
/* 20779*/      OPC_EmitInteger32, 0, 
/* 20781*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD32_SPLAT_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::v4i32, 3/*#Ops*/, 4, 2, 3, 
                // Src: (splat_vector:{ *:[v4i32] } (ld:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_load>>) - Complexity = 16
                // Dst: (LOAD32_SPLAT_A64:{ *:[v4i32] } 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr)
/* 20790*/     /*SwitchType*/ 18, MVT::i64,// ->20810
/* 20792*/      OPC_MoveParent,
/* 20793*/      OPC_CheckType, MVT::v2i64,
/* 20795*/      OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64())
/* 20796*/      OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #2 #3
/* 20798*/      OPC_EmitMergeInputChains1_0,
/* 20799*/      OPC_EmitInteger32, 0, 
/* 20801*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD64_SPLAT_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::v2i64, 3/*#Ops*/, 4, 2, 3, 
                // Src: (splat_vector:{ *:[v2i64] } (ld:{ *:[i64] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_load>>) - Complexity = 16
                // Dst: (LOAD64_SPLAT_A64:{ *:[v2i64] } 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr)
/* 20810*/     0, // EndSwitchType
/* 20811*/    0, /*End of Scope*/
/* 20812*/   0, /*End of Scope*/
/* 20813*/  /*Scope*/ 20|128,1/*148*/, /*->20963*/
/* 20815*/   OPC_RecordChild0, // #0 = $x
/* 20816*/   OPC_Scope, 102, /*->20920*/ // 3 children in Scope
/* 20818*/    OPC_MoveChild0,
/* 20819*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 20822*/    OPC_SwitchType /*2 cases */, 80, MVT::i32,// ->20905
/* 20825*/     OPC_MoveParent,
/* 20826*/     OPC_SwitchType /*3 cases */, 37, MVT::v16i8,// ->20866
/* 20829*/      OPC_EmitConvertToTarget0,
/* 20830*/      OPC_EmitConvertToTarget0,
/* 20831*/      OPC_EmitConvertToTarget0,
/* 20832*/      OPC_EmitConvertToTarget0,
/* 20833*/      OPC_EmitConvertToTarget0,
/* 20834*/      OPC_EmitConvertToTarget0,
/* 20835*/      OPC_EmitConvertToTarget0,
/* 20836*/      OPC_EmitConvertToTarget0,
/* 20837*/      OPC_EmitConvertToTarget0,
/* 20838*/      OPC_EmitConvertToTarget0,
/* 20839*/      OPC_EmitConvertToTarget0,
/* 20840*/      OPC_EmitConvertToTarget0,
/* 20841*/      OPC_EmitConvertToTarget0,
/* 20842*/      OPC_EmitConvertToTarget0,
/* 20843*/      OPC_EmitConvertToTarget0,
/* 20844*/      OPC_EmitConvertToTarget0,
/* 20845*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::CONST_V128_I8x16),
                    MVT::v16i8, 16/*#Ops*/, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13, 14, 15, 16, 
                // Src: (splat_vector:{ *:[v16i8] } (imm:{ *:[i32] }):$x) - Complexity = 6
                // Dst: (CONST_V128_I8x16:{ *:[v16i8] } (imm:{ *:[i32] }):$x, (imm:{ *:[i32] }):$x, (imm:{ *:[i32] }):$x, (imm:{ *:[i32] }):$x, (imm:{ *:[i32] }):$x, (imm:{ *:[i32] }):$x, (imm:{ *:[i32] }):$x, (imm:{ *:[i32] }):$x, (imm:{ *:[i32] }):$x, (imm:{ *:[i32] }):$x, (imm:{ *:[i32] }):$x, (imm:{ *:[i32] }):$x, (imm:{ *:[i32] }):$x, (imm:{ *:[i32] }):$x, (imm:{ *:[i32] }):$x, (imm:{ *:[i32] }):$x)
/* 20866*/     /*SwitchType*/ 21, MVT::v8i16,// ->20889
/* 20868*/      OPC_EmitConvertToTarget0,
/* 20869*/      OPC_EmitConvertToTarget0,
/* 20870*/      OPC_EmitConvertToTarget0,
/* 20871*/      OPC_EmitConvertToTarget0,
/* 20872*/      OPC_EmitConvertToTarget0,
/* 20873*/      OPC_EmitConvertToTarget0,
/* 20874*/      OPC_EmitConvertToTarget0,
/* 20875*/      OPC_EmitConvertToTarget0,
/* 20876*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::CONST_V128_I16x8),
                    MVT::v8i16, 8/*#Ops*/, 1, 2, 3, 4, 5, 6, 7, 8, 
                // Src: (splat_vector:{ *:[v8i16] } (imm:{ *:[i32] }):$x) - Complexity = 6
                // Dst: (CONST_V128_I16x8:{ *:[v8i16] } (imm:{ *:[i32] }):$x, (imm:{ *:[i32] }):$x, (imm:{ *:[i32] }):$x, (imm:{ *:[i32] }):$x, (imm:{ *:[i32] }):$x, (imm:{ *:[i32] }):$x, (imm:{ *:[i32] }):$x, (imm:{ *:[i32] }):$x)
/* 20889*/     /*SwitchType*/ 13, MVT::v4i32,// ->20904
/* 20891*/      OPC_EmitConvertToTarget0,
/* 20892*/      OPC_EmitConvertToTarget0,
/* 20893*/      OPC_EmitConvertToTarget0,
/* 20894*/      OPC_EmitConvertToTarget0,
/* 20895*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::CONST_V128_I32x4),
                    MVT::v4i32, 4/*#Ops*/, 1, 2, 3, 4, 
                // Src: (splat_vector:{ *:[v4i32] } (imm:{ *:[i32] }):$x) - Complexity = 6
                // Dst: (CONST_V128_I32x4:{ *:[v4i32] } (imm:{ *:[i32] }):$x, (imm:{ *:[i32] }):$x, (imm:{ *:[i32] }):$x, (imm:{ *:[i32] }):$x)
/* 20904*/     0, // EndSwitchType
/* 20905*/    /*SwitchType*/ 12, MVT::i64,// ->20919
/* 20907*/     OPC_MoveParent,
/* 20908*/     OPC_CheckType, MVT::v2i64,
/* 20910*/     OPC_EmitConvertToTarget0,
/* 20911*/     OPC_EmitConvertToTarget0,
/* 20912*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::CONST_V128_I64x2),
                   MVT::v2i64, 2/*#Ops*/, 1, 2, 
               // Src: (splat_vector:{ *:[v2i64] } (imm:{ *:[i64] }):$x) - Complexity = 6
               // Dst: (CONST_V128_I64x2:{ *:[v2i64] } (imm:{ *:[i64] }):$x, (imm:{ *:[i64] }):$x)
/* 20919*/    0, // EndSwitchType
/* 20920*/   /*Scope*/ 30, /*->20951*/
/* 20921*/    OPC_CheckChild0TypeI32,
/* 20922*/    OPC_SwitchType /*3 cases */, 7, MVT::v16i8,// ->20932
/* 20925*/     OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 20926*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SPLAT_I8x16),
                   MVT::v16i8, 1/*#Ops*/, 0, 
               // Src: (splat_vector:{ *:[v16i8] } I32:{ *:[i32] }:$x) - Complexity = 3
               // Dst: (SPLAT_I8x16:{ *:[v16i8] } I32:{ *:[i32] }:$x)
/* 20932*/    /*SwitchType*/ 7, MVT::v8i16,// ->20941
/* 20934*/     OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 20935*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SPLAT_I16x8),
                   MVT::v8i16, 1/*#Ops*/, 0, 
               // Src: (splat_vector:{ *:[v8i16] } I32:{ *:[i32] }:$x) - Complexity = 3
               // Dst: (SPLAT_I16x8:{ *:[v8i16] } I32:{ *:[i32] }:$x)
/* 20941*/    /*SwitchType*/ 7, MVT::v4i32,// ->20950
/* 20943*/     OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 20944*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SPLAT_I32x4),
                   MVT::v4i32, 1/*#Ops*/, 0, 
               // Src: (splat_vector:{ *:[v4i32] } I32:{ *:[i32] }:$x) - Complexity = 3
               // Dst: (SPLAT_I32x4:{ *:[v4i32] } I32:{ *:[i32] }:$x)
/* 20950*/    0, // EndSwitchType
/* 20951*/   /*Scope*/ 10, /*->20962*/
/* 20952*/    OPC_CheckChild0TypeI64,
/* 20953*/    OPC_CheckType, MVT::v2i64,
/* 20955*/    OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 20956*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SPLAT_I64x2),
                  MVT::v2i64, 1/*#Ops*/, 0, 
              // Src: (splat_vector:{ *:[v2i64] } I64:{ *:[i64] }:$x) - Complexity = 3
              // Dst: (SPLAT_I64x2:{ *:[v2i64] } I64:{ *:[i64] }:$x)
/* 20962*/   0, /*End of Scope*/
/* 20963*/  /*Scope*/ 103, /*->21067*/
/* 20964*/   OPC_MoveChild0,
/* 20965*/   OPC_CheckOpcode, TARGET_VAL(ISD::LOAD),
/* 20968*/   OPC_RecordMemRef,
/* 20969*/   OPC_RecordNode, // #0 = 'ld' chained node
/* 20970*/   OPC_RecordChild1, // #1 = $AddrOps32:offset:addr
/* 20971*/   OPC_Scope, 46, /*->21019*/ // 2 children in Scope
/* 20973*/    OPC_CheckChild1TypeI32,
/* 20974*/    OPC_CheckPredicate, 9, // Predicate_unindexedload
/* 20976*/    OPC_CheckPredicate7,  // Predicate_load
/* 20977*/    OPC_SwitchType /*2 cases */, 18, MVT::f32,// ->20998
/* 20980*/     OPC_MoveParent,
/* 20981*/     OPC_CheckType, MVT::v4f32,
/* 20983*/     OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64())
/* 20984*/     OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #2 #3
/* 20986*/     OPC_EmitMergeInputChains1_0,
/* 20987*/     OPC_EmitInteger32, 0, 
/* 20989*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD32_SPLAT_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::v4f32, 3/*#Ops*/, 4, 2, 3, 
               // Src: (splat_vector:{ *:[v4f32] } (ld:{ *:[f32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_load>>) - Complexity = 16
               // Dst: (LOAD32_SPLAT_A32:{ *:[v4f32] } 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr)
/* 20998*/    /*SwitchType*/ 18, MVT::f64,// ->21018
/* 21000*/     OPC_MoveParent,
/* 21001*/     OPC_CheckType, MVT::v2f64,
/* 21003*/     OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64())
/* 21004*/     OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #2 #3
/* 21006*/     OPC_EmitMergeInputChains1_0,
/* 21007*/     OPC_EmitInteger32, 0, 
/* 21009*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD64_SPLAT_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::v2f64, 3/*#Ops*/, 4, 2, 3, 
               // Src: (splat_vector:{ *:[v2f64] } (ld:{ *:[f64] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_load>>) - Complexity = 16
               // Dst: (LOAD64_SPLAT_A32:{ *:[v2f64] } 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr)
/* 21018*/    0, // EndSwitchType
/* 21019*/   /*Scope*/ 46, /*->21066*/
/* 21020*/    OPC_CheckChild1TypeI64,
/* 21021*/    OPC_CheckPredicate, 9, // Predicate_unindexedload
/* 21023*/    OPC_CheckPredicate7,  // Predicate_load
/* 21024*/    OPC_SwitchType /*2 cases */, 18, MVT::f32,// ->21045
/* 21027*/     OPC_MoveParent,
/* 21028*/     OPC_CheckType, MVT::v4f32,
/* 21030*/     OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64())
/* 21031*/     OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #2 #3
/* 21033*/     OPC_EmitMergeInputChains1_0,
/* 21034*/     OPC_EmitInteger32, 0, 
/* 21036*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD32_SPLAT_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::v4f32, 3/*#Ops*/, 4, 2, 3, 
               // Src: (splat_vector:{ *:[v4f32] } (ld:{ *:[f32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_load>>) - Complexity = 16
               // Dst: (LOAD32_SPLAT_A64:{ *:[v4f32] } 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr)
/* 21045*/    /*SwitchType*/ 18, MVT::f64,// ->21065
/* 21047*/     OPC_MoveParent,
/* 21048*/     OPC_CheckType, MVT::v2f64,
/* 21050*/     OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64())
/* 21051*/     OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #2 #3
/* 21053*/     OPC_EmitMergeInputChains1_0,
/* 21054*/     OPC_EmitInteger32, 0, 
/* 21056*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD64_SPLAT_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::v2f64, 3/*#Ops*/, 4, 2, 3, 
               // Src: (splat_vector:{ *:[v2f64] } (ld:{ *:[f64] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_load>>) - Complexity = 16
               // Dst: (LOAD64_SPLAT_A64:{ *:[v2f64] } 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr)
/* 21065*/    0, // EndSwitchType
/* 21066*/   0, /*End of Scope*/
/* 21067*/  /*Scope*/ 66, /*->21134*/
/* 21068*/   OPC_RecordChild0, // #0 = $x
/* 21069*/   OPC_Scope, 38, /*->21109*/ // 3 children in Scope
/* 21071*/    OPC_MoveChild0,
/* 21072*/    OPC_CheckOpcode, TARGET_VAL(ISD::ConstantFP),
/* 21075*/    OPC_SwitchType /*2 cases */, 16, MVT::f32,// ->21094
/* 21078*/     OPC_MoveParent,
/* 21079*/     OPC_CheckType, MVT::v4f32,
/* 21081*/     OPC_EmitConvertToTarget0,
/* 21082*/     OPC_EmitConvertToTarget0,
/* 21083*/     OPC_EmitConvertToTarget0,
/* 21084*/     OPC_EmitConvertToTarget0,
/* 21085*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::CONST_V128_F32x4),
                   MVT::v4f32, 4/*#Ops*/, 1, 2, 3, 4, 
               // Src: (splat_vector:{ *:[v4f32] } (fpimm:{ *:[f32] }):$x) - Complexity = 6
               // Dst: (CONST_V128_F32x4:{ *:[v4f32] } (fpimm:{ *:[f32] }):$x, (fpimm:{ *:[f32] }):$x, (fpimm:{ *:[f32] }):$x, (fpimm:{ *:[f32] }):$x)
/* 21094*/    /*SwitchType*/ 12, MVT::f64,// ->21108
/* 21096*/     OPC_MoveParent,
/* 21097*/     OPC_CheckType, MVT::v2f64,
/* 21099*/     OPC_EmitConvertToTarget0,
/* 21100*/     OPC_EmitConvertToTarget0,
/* 21101*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::CONST_V128_F64x2),
                   MVT::v2f64, 2/*#Ops*/, 1, 2, 
               // Src: (splat_vector:{ *:[v2f64] } (fpimm:{ *:[f64] }):$x) - Complexity = 6
               // Dst: (CONST_V128_F64x2:{ *:[v2f64] } (fpimm:{ *:[f64] }):$x, (fpimm:{ *:[f64] }):$x)
/* 21108*/    0, // EndSwitchType
/* 21109*/   /*Scope*/ 11, /*->21121*/
/* 21110*/    OPC_CheckChild0Type, MVT::f32,
/* 21112*/    OPC_CheckType, MVT::v4f32,
/* 21114*/    OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 21115*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SPLAT_F32x4),
                  MVT::v4f32, 1/*#Ops*/, 0, 
              // Src: (splat_vector:{ *:[v4f32] } F32:{ *:[f32] }:$x) - Complexity = 3
              // Dst: (SPLAT_F32x4:{ *:[v4f32] } F32:{ *:[f32] }:$x)
/* 21121*/   /*Scope*/ 11, /*->21133*/
/* 21122*/    OPC_CheckChild0Type, MVT::f64,
/* 21124*/    OPC_CheckType, MVT::v2f64,
/* 21126*/    OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 21127*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SPLAT_F64x2),
                  MVT::v2f64, 1/*#Ops*/, 0, 
              // Src: (splat_vector:{ *:[v2f64] } F64:{ *:[f64] }:$x) - Complexity = 3
              // Dst: (SPLAT_F64x2:{ *:[v2f64] } F64:{ *:[f64] }:$x)
/* 21133*/   0, /*End of Scope*/
/* 21134*/  0, /*End of Scope*/
/* 21135*/ /*SwitchOpcode*/ 42|128,1/*170*/, TARGET_VAL(ISD::SCALAR_TO_VECTOR),// ->21309
/* 21139*/  OPC_Scope, 103, /*->21244*/ // 2 children in Scope
/* 21141*/   OPC_MoveChild0,
/* 21142*/   OPC_CheckOpcode, TARGET_VAL(ISD::LOAD),
/* 21145*/   OPC_RecordMemRef,
/* 21146*/   OPC_RecordNode, // #0 = 'ld' chained node
/* 21147*/   OPC_RecordChild1, // #1 = $AddrOps32:offset:addr
/* 21148*/   OPC_Scope, 46, /*->21196*/ // 2 children in Scope
/* 21150*/    OPC_CheckChild1TypeI32,
/* 21151*/    OPC_CheckPredicate, 9, // Predicate_unindexedload
/* 21153*/    OPC_CheckPredicate7,  // Predicate_load
/* 21154*/    OPC_SwitchType /*2 cases */, 18, MVT::i32,// ->21175
/* 21157*/     OPC_MoveParent,
/* 21158*/     OPC_CheckType, MVT::v4i32,
/* 21160*/     OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64())
/* 21161*/     OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #2 #3
/* 21163*/     OPC_EmitMergeInputChains1_0,
/* 21164*/     OPC_EmitInteger32, 0, 
/* 21166*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_ZERO_I32x4_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::v4i32, 3/*#Ops*/, 4, 2, 3, 
               // Src: (scalar_to_vector:{ *:[v4i32] } (ld:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_load>>) - Complexity = 16
               // Dst: (LOAD_ZERO_I32x4_A32:{ *:[v4i32] } 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr)
/* 21175*/    /*SwitchType*/ 18, MVT::i64,// ->21195
/* 21177*/     OPC_MoveParent,
/* 21178*/     OPC_CheckType, MVT::v2i64,
/* 21180*/     OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64())
/* 21181*/     OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #2 #3
/* 21183*/     OPC_EmitMergeInputChains1_0,
/* 21184*/     OPC_EmitInteger32, 0, 
/* 21186*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_ZERO_I64x2_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::v2i64, 3/*#Ops*/, 4, 2, 3, 
               // Src: (scalar_to_vector:{ *:[v2i64] } (ld:{ *:[i64] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_load>>) - Complexity = 16
               // Dst: (LOAD_ZERO_I64x2_A32:{ *:[v2i64] } 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr)
/* 21195*/    0, // EndSwitchType
/* 21196*/   /*Scope*/ 46, /*->21243*/
/* 21197*/    OPC_CheckChild1TypeI64,
/* 21198*/    OPC_CheckPredicate, 9, // Predicate_unindexedload
/* 21200*/    OPC_CheckPredicate7,  // Predicate_load
/* 21201*/    OPC_SwitchType /*2 cases */, 18, MVT::i32,// ->21222
/* 21204*/     OPC_MoveParent,
/* 21205*/     OPC_CheckType, MVT::v4i32,
/* 21207*/     OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64())
/* 21208*/     OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #2 #3
/* 21210*/     OPC_EmitMergeInputChains1_0,
/* 21211*/     OPC_EmitInteger32, 0, 
/* 21213*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_ZERO_I32x4_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::v4i32, 3/*#Ops*/, 4, 2, 3, 
               // Src: (scalar_to_vector:{ *:[v4i32] } (ld:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_load>>) - Complexity = 16
               // Dst: (LOAD_ZERO_I32x4_A64:{ *:[v4i32] } 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr)
/* 21222*/    /*SwitchType*/ 18, MVT::i64,// ->21242
/* 21224*/     OPC_MoveParent,
/* 21225*/     OPC_CheckType, MVT::v2i64,
/* 21227*/     OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64())
/* 21228*/     OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #2 #3
/* 21230*/     OPC_EmitMergeInputChains1_0,
/* 21231*/     OPC_EmitInteger32, 0, 
/* 21233*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_ZERO_I64x2_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::v2i64, 3/*#Ops*/, 4, 2, 3, 
               // Src: (scalar_to_vector:{ *:[v2i64] } (ld:{ *:[i64] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_load>>) - Complexity = 16
               // Dst: (LOAD_ZERO_I64x2_A64:{ *:[v2i64] } 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr)
/* 21242*/    0, // EndSwitchType
/* 21243*/   0, /*End of Scope*/
/* 21244*/  /*Scope*/ 63, /*->21308*/
/* 21245*/   OPC_RecordChild0, // #0 = $x
/* 21246*/   OPC_Scope, 27, /*->21275*/ // 4 children in Scope
/* 21248*/    OPC_CheckChild0TypeI32,
/* 21249*/    OPC_SwitchType /*3 cases */, 6, MVT::v16i8,// ->21258
/* 21252*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SPLAT_I8x16),
                   MVT::v16i8, 1/*#Ops*/, 0, 
               // Src: (scalar_to_vector:{ *:[v16i8] } I32:{ *:[i32] }:$x) - Complexity = 3
               // Dst: (SPLAT_I8x16:{ *:[v16i8] } ?:{ *:[i32] }:$x)
/* 21258*/    /*SwitchType*/ 6, MVT::v8i16,// ->21266
/* 21260*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SPLAT_I16x8),
                   MVT::v8i16, 1/*#Ops*/, 0, 
               // Src: (scalar_to_vector:{ *:[v8i16] } I32:{ *:[i32] }:$x) - Complexity = 3
               // Dst: (SPLAT_I16x8:{ *:[v8i16] } ?:{ *:[i32] }:$x)
/* 21266*/    /*SwitchType*/ 6, MVT::v4i32,// ->21274
/* 21268*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SPLAT_I32x4),
                   MVT::v4i32, 1/*#Ops*/, 0, 
               // Src: (scalar_to_vector:{ *:[v4i32] } I32:{ *:[i32] }:$x) - Complexity = 3
               // Dst: (SPLAT_I32x4:{ *:[v4i32] } ?:{ *:[i32] }:$x)
/* 21274*/    0, // EndSwitchType
/* 21275*/   /*Scope*/ 9, /*->21285*/
/* 21276*/    OPC_CheckChild0TypeI64,
/* 21277*/    OPC_CheckType, MVT::v2i64,
/* 21279*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SPLAT_I64x2),
                  MVT::v2i64, 1/*#Ops*/, 0, 
              // Src: (scalar_to_vector:{ *:[v2i64] } I64:{ *:[i64] }:$x) - Complexity = 3
              // Dst: (SPLAT_I64x2:{ *:[v2i64] } ?:{ *:[i64] }:$x)
/* 21285*/   /*Scope*/ 10, /*->21296*/
/* 21286*/    OPC_CheckChild0Type, MVT::f32,
/* 21288*/    OPC_CheckType, MVT::v4f32,
/* 21290*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SPLAT_F32x4),
                  MVT::v4f32, 1/*#Ops*/, 0, 
              // Src: (scalar_to_vector:{ *:[v4f32] } F32:{ *:[f32] }:$x) - Complexity = 3
              // Dst: (SPLAT_F32x4:{ *:[v4f32] } ?:{ *:[f32] }:$x)
/* 21296*/   /*Scope*/ 10, /*->21307*/
/* 21297*/    OPC_CheckChild0Type, MVT::f64,
/* 21299*/    OPC_CheckType, MVT::v2f64,
/* 21301*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SPLAT_F64x2),
                  MVT::v2f64, 1/*#Ops*/, 0, 
              // Src: (scalar_to_vector:{ *:[v2f64] } F64:{ *:[f64] }:$x) - Complexity = 3
              // Dst: (SPLAT_F64x2:{ *:[v2f64] } ?:{ *:[f64] }:$x)
/* 21307*/   0, /*End of Scope*/
/* 21308*/  0, /*End of Scope*/
/* 21309*/ /*SwitchOpcode*/ 4|128,1/*132*/, TARGET_VAL(WebAssemblyISD::VEC_SHL),// ->21445
/* 21313*/  OPC_RecordChild0, // #0 = $lhs
/* 21314*/  OPC_Scope, 84, /*->21400*/ // 2 children in Scope
/* 21316*/   OPC_MoveChild1,
/* 21317*/   OPC_Scope, 24, /*->21343*/ // 5 children in Scope
/* 21319*/    OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/* 21322*/    OPC_MoveChild0,
/* 21323*/    OPC_CheckAndImm, 63, 
/* 21325*/    OPC_RecordChild0, // #1 = $rhs
/* 21326*/    OPC_MoveParent,
/* 21327*/    OPC_MoveParent,
/* 21328*/    OPC_CheckType, MVT::v2i64,
/* 21330*/    OPC_EmitNode1None, TARGET_VAL(WebAssembly::I32_WRAP_I64),
                  MVT::i32, 1/*#Ops*/, 1,  // Results = #2
/* 21336*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SHL_I64x2),
                  MVT::v2i64, 2/*#Ops*/, 0, 2, 
              // Src: (wasm_shl:{ *:[v2i64] } V128:{ *:[v2i64] }:$lhs, (trunc:{ *:[i32] } (and:{ *:[i64] } I64:{ *:[i64] }:$rhs, 63:{ *:[i64] }))) - Complexity = 14
              // Dst: (SHL_I64x2:{ *:[v2i64] } V128:{ *:[v2i64] }:$lhs, (I32_WRAP_I64:{ *:[i32] } I64:{ *:[i64] }:$rhs))
/* 21343*/   /*Scope*/ 13, /*->21357*/
/* 21344*/    OPC_CheckAndImm, 7, 
/* 21346*/    OPC_RecordChild0, // #1 = $rhs
/* 21347*/    OPC_MoveParent,
/* 21348*/    OPC_CheckType, MVT::v16i8,
/* 21350*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SHL_I8x16),
                  MVT::v16i8, 2/*#Ops*/, 0, 1, 
              // Src: (wasm_shl:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, (and:{ *:[i32] } I32:{ *:[i32] }:$rhs, 7:{ *:[i32] })) - Complexity = 11
              // Dst: (SHL_I8x16:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, I32:{ *:[i32] }:$rhs)
/* 21357*/   /*Scope*/ 13, /*->21371*/
/* 21358*/    OPC_CheckAndImm, 15, 
/* 21360*/    OPC_RecordChild0, // #1 = $rhs
/* 21361*/    OPC_MoveParent,
/* 21362*/    OPC_CheckType, MVT::v8i16,
/* 21364*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SHL_I16x8),
                  MVT::v8i16, 2/*#Ops*/, 0, 1, 
              // Src: (wasm_shl:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, (and:{ *:[i32] } I32:{ *:[i32] }:$rhs, 15:{ *:[i32] })) - Complexity = 11
              // Dst: (SHL_I16x8:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, I32:{ *:[i32] }:$rhs)
/* 21371*/   /*Scope*/ 13, /*->21385*/
/* 21372*/    OPC_CheckAndImm, 31, 
/* 21374*/    OPC_RecordChild0, // #1 = $rhs
/* 21375*/    OPC_MoveParent,
/* 21376*/    OPC_CheckType, MVT::v4i32,
/* 21378*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SHL_I32x4),
                  MVT::v4i32, 2/*#Ops*/, 0, 1, 
              // Src: (wasm_shl:{ *:[v4i32] } V128:{ *:[v4i32] }:$lhs, (and:{ *:[i32] } I32:{ *:[i32] }:$rhs, 31:{ *:[i32] })) - Complexity = 11
              // Dst: (SHL_I32x4:{ *:[v4i32] } V128:{ *:[v4i32] }:$lhs, I32:{ *:[i32] }:$rhs)
/* 21385*/   /*Scope*/ 13, /*->21399*/
/* 21386*/    OPC_CheckAndImm, 63, 
/* 21388*/    OPC_RecordChild0, // #1 = $rhs
/* 21389*/    OPC_MoveParent,
/* 21390*/    OPC_CheckType, MVT::v2i64,
/* 21392*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SHL_I64x2),
                  MVT::v2i64, 2/*#Ops*/, 0, 1, 
              // Src: (wasm_shl:{ *:[v2i64] } V128:{ *:[v2i64] }:$lhs, (and:{ *:[i32] } I32:{ *:[i32] }:$rhs, 63:{ *:[i32] })) - Complexity = 11
              // Dst: (SHL_I64x2:{ *:[v2i64] } V128:{ *:[v2i64] }:$lhs, I32:{ *:[i32] }:$rhs)
/* 21399*/   0, /*End of Scope*/
/* 21400*/  /*Scope*/ 43, /*->21444*/
/* 21401*/   OPC_RecordChild1, // #1 = $x
/* 21402*/   OPC_SwitchType /*4 cases */, 8, MVT::v16i8,// ->21413
/* 21405*/    OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 21406*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SHL_I8x16),
                  MVT::v16i8, 2/*#Ops*/, 0, 1, 
              // Src: (wasm_shl:{ *:[v16i8] } V128:{ *:[v16i8] }:$vec, I32:{ *:[i32] }:$x) - Complexity = 3
              // Dst: (SHL_I8x16:{ *:[v16i8] } V128:{ *:[v16i8] }:$vec, I32:{ *:[i32] }:$x)
/* 21413*/   /*SwitchType*/ 8, MVT::v8i16,// ->21423
/* 21415*/    OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 21416*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SHL_I16x8),
                  MVT::v8i16, 2/*#Ops*/, 0, 1, 
              // Src: (wasm_shl:{ *:[v8i16] } V128:{ *:[v8i16] }:$vec, I32:{ *:[i32] }:$x) - Complexity = 3
              // Dst: (SHL_I16x8:{ *:[v8i16] } V128:{ *:[v8i16] }:$vec, I32:{ *:[i32] }:$x)
/* 21423*/   /*SwitchType*/ 8, MVT::v4i32,// ->21433
/* 21425*/    OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 21426*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SHL_I32x4),
                  MVT::v4i32, 2/*#Ops*/, 0, 1, 
              // Src: (wasm_shl:{ *:[v4i32] } V128:{ *:[v4i32] }:$vec, I32:{ *:[i32] }:$x) - Complexity = 3
              // Dst: (SHL_I32x4:{ *:[v4i32] } V128:{ *:[v4i32] }:$vec, I32:{ *:[i32] }:$x)
/* 21433*/   /*SwitchType*/ 8, MVT::v2i64,// ->21443
/* 21435*/    OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 21436*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SHL_I64x2),
                  MVT::v2i64, 2/*#Ops*/, 0, 1, 
              // Src: (wasm_shl:{ *:[v2i64] } V128:{ *:[v2i64] }:$vec, I32:{ *:[i32] }:$x) - Complexity = 3
              // Dst: (SHL_I64x2:{ *:[v2i64] } V128:{ *:[v2i64] }:$vec, I32:{ *:[i32] }:$x)
/* 21443*/   0, // EndSwitchType
/* 21444*/  0, /*End of Scope*/
/* 21445*/ /*SwitchOpcode*/ 4|128,1/*132*/, TARGET_VAL(WebAssemblyISD::VEC_SHR_S),// ->21581
/* 21449*/  OPC_RecordChild0, // #0 = $lhs
/* 21450*/  OPC_Scope, 84, /*->21536*/ // 2 children in Scope
/* 21452*/   OPC_MoveChild1,
/* 21453*/   OPC_Scope, 24, /*->21479*/ // 5 children in Scope
/* 21455*/    OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/* 21458*/    OPC_MoveChild0,
/* 21459*/    OPC_CheckAndImm, 63, 
/* 21461*/    OPC_RecordChild0, // #1 = $rhs
/* 21462*/    OPC_MoveParent,
/* 21463*/    OPC_MoveParent,
/* 21464*/    OPC_CheckType, MVT::v2i64,
/* 21466*/    OPC_EmitNode1None, TARGET_VAL(WebAssembly::I32_WRAP_I64),
                  MVT::i32, 1/*#Ops*/, 1,  // Results = #2
/* 21472*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SHR_S_I64x2),
                  MVT::v2i64, 2/*#Ops*/, 0, 2, 
              // Src: (wasm_shr_s:{ *:[v2i64] } V128:{ *:[v2i64] }:$lhs, (trunc:{ *:[i32] } (and:{ *:[i64] } I64:{ *:[i64] }:$rhs, 63:{ *:[i64] }))) - Complexity = 14
              // Dst: (SHR_S_I64x2:{ *:[v2i64] } V128:{ *:[v2i64] }:$lhs, (I32_WRAP_I64:{ *:[i32] } I64:{ *:[i64] }:$rhs))
/* 21479*/   /*Scope*/ 13, /*->21493*/
/* 21480*/    OPC_CheckAndImm, 7, 
/* 21482*/    OPC_RecordChild0, // #1 = $rhs
/* 21483*/    OPC_MoveParent,
/* 21484*/    OPC_CheckType, MVT::v16i8,
/* 21486*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SHR_S_I8x16),
                  MVT::v16i8, 2/*#Ops*/, 0, 1, 
              // Src: (wasm_shr_s:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, (and:{ *:[i32] } I32:{ *:[i32] }:$rhs, 7:{ *:[i32] })) - Complexity = 11
              // Dst: (SHR_S_I8x16:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, I32:{ *:[i32] }:$rhs)
/* 21493*/   /*Scope*/ 13, /*->21507*/
/* 21494*/    OPC_CheckAndImm, 15, 
/* 21496*/    OPC_RecordChild0, // #1 = $rhs
/* 21497*/    OPC_MoveParent,
/* 21498*/    OPC_CheckType, MVT::v8i16,
/* 21500*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SHR_S_I16x8),
                  MVT::v8i16, 2/*#Ops*/, 0, 1, 
              // Src: (wasm_shr_s:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, (and:{ *:[i32] } I32:{ *:[i32] }:$rhs, 15:{ *:[i32] })) - Complexity = 11
              // Dst: (SHR_S_I16x8:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, I32:{ *:[i32] }:$rhs)
/* 21507*/   /*Scope*/ 13, /*->21521*/
/* 21508*/    OPC_CheckAndImm, 31, 
/* 21510*/    OPC_RecordChild0, // #1 = $rhs
/* 21511*/    OPC_MoveParent,
/* 21512*/    OPC_CheckType, MVT::v4i32,
/* 21514*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SHR_S_I32x4),
                  MVT::v4i32, 2/*#Ops*/, 0, 1, 
              // Src: (wasm_shr_s:{ *:[v4i32] } V128:{ *:[v4i32] }:$lhs, (and:{ *:[i32] } I32:{ *:[i32] }:$rhs, 31:{ *:[i32] })) - Complexity = 11
              // Dst: (SHR_S_I32x4:{ *:[v4i32] } V128:{ *:[v4i32] }:$lhs, I32:{ *:[i32] }:$rhs)
/* 21521*/   /*Scope*/ 13, /*->21535*/
/* 21522*/    OPC_CheckAndImm, 63, 
/* 21524*/    OPC_RecordChild0, // #1 = $rhs
/* 21525*/    OPC_MoveParent,
/* 21526*/    OPC_CheckType, MVT::v2i64,
/* 21528*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SHR_S_I64x2),
                  MVT::v2i64, 2/*#Ops*/, 0, 1, 
              // Src: (wasm_shr_s:{ *:[v2i64] } V128:{ *:[v2i64] }:$lhs, (and:{ *:[i32] } I32:{ *:[i32] }:$rhs, 63:{ *:[i32] })) - Complexity = 11
              // Dst: (SHR_S_I64x2:{ *:[v2i64] } V128:{ *:[v2i64] }:$lhs, I32:{ *:[i32] }:$rhs)
/* 21535*/   0, /*End of Scope*/
/* 21536*/  /*Scope*/ 43, /*->21580*/
/* 21537*/   OPC_RecordChild1, // #1 = $x
/* 21538*/   OPC_SwitchType /*4 cases */, 8, MVT::v16i8,// ->21549
/* 21541*/    OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 21542*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SHR_S_I8x16),
                  MVT::v16i8, 2/*#Ops*/, 0, 1, 
              // Src: (wasm_shr_s:{ *:[v16i8] } V128:{ *:[v16i8] }:$vec, I32:{ *:[i32] }:$x) - Complexity = 3
              // Dst: (SHR_S_I8x16:{ *:[v16i8] } V128:{ *:[v16i8] }:$vec, I32:{ *:[i32] }:$x)
/* 21549*/   /*SwitchType*/ 8, MVT::v8i16,// ->21559
/* 21551*/    OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 21552*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SHR_S_I16x8),
                  MVT::v8i16, 2/*#Ops*/, 0, 1, 
              // Src: (wasm_shr_s:{ *:[v8i16] } V128:{ *:[v8i16] }:$vec, I32:{ *:[i32] }:$x) - Complexity = 3
              // Dst: (SHR_S_I16x8:{ *:[v8i16] } V128:{ *:[v8i16] }:$vec, I32:{ *:[i32] }:$x)
/* 21559*/   /*SwitchType*/ 8, MVT::v4i32,// ->21569
/* 21561*/    OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 21562*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SHR_S_I32x4),
                  MVT::v4i32, 2/*#Ops*/, 0, 1, 
              // Src: (wasm_shr_s:{ *:[v4i32] } V128:{ *:[v4i32] }:$vec, I32:{ *:[i32] }:$x) - Complexity = 3
              // Dst: (SHR_S_I32x4:{ *:[v4i32] } V128:{ *:[v4i32] }:$vec, I32:{ *:[i32] }:$x)
/* 21569*/   /*SwitchType*/ 8, MVT::v2i64,// ->21579
/* 21571*/    OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 21572*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SHR_S_I64x2),
                  MVT::v2i64, 2/*#Ops*/, 0, 1, 
              // Src: (wasm_shr_s:{ *:[v2i64] } V128:{ *:[v2i64] }:$vec, I32:{ *:[i32] }:$x) - Complexity = 3
              // Dst: (SHR_S_I64x2:{ *:[v2i64] } V128:{ *:[v2i64] }:$vec, I32:{ *:[i32] }:$x)
/* 21579*/   0, // EndSwitchType
/* 21580*/  0, /*End of Scope*/
/* 21581*/ /*SwitchOpcode*/ 83|128,3/*467*/, TARGET_VAL(ISD::VSELECT),// ->22052
/* 21585*/  OPC_Scope, 97, /*->21684*/ // 4 children in Scope
/* 21587*/   OPC_MoveChild0,
/* 21588*/   OPC_CheckOpcode, TARGET_VAL(ISD::SETCC),
/* 21591*/   OPC_MoveChild0,
/* 21592*/   OPC_CheckOpcode, TARGET_VAL(ISD::BITCAST),
/* 21595*/   OPC_RecordChild0, // #0 = $rhs
/* 21596*/   OPC_SwitchType /*2 cases */, 41, MVT::v4f32,// ->21640
/* 21599*/    OPC_CheckChild0Type, MVT::v4i32,
/* 21601*/    OPC_MoveSibling1,
/* 21602*/    OPC_CheckOpcode, TARGET_VAL(ISD::BITCAST),
/* 21605*/    OPC_RecordChild0, // #1 = $lhs
/* 21606*/    OPC_CheckChild0Type, MVT::v4i32,
/* 21608*/    OPC_MoveParent,
/* 21609*/    OPC_CheckChild2CondCode, ISD::SETOLT,
/* 21611*/    OPC_MoveParent,
/* 21612*/    OPC_CheckType, MVT::v4i32,
/* 21614*/    OPC_Scope, 11, /*->21627*/ // 2 children in Scope
/* 21616*/     OPC_CheckChild1Same, 0,
/* 21618*/     OPC_CheckChild2Same, 1,
/* 21620*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::PMIN_F32x4),
                   MVT::v4i32, 2/*#Ops*/, 1, 0, 
               // Src: (vselect:{ *:[v4i32] } (setcc:{ *:[v4i32] } (bitconvert:{ *:[v4f32] } V128:{ *:[v4i32] }:$rhs), (bitconvert:{ *:[v4f32] } V128:{ *:[v4i32] }:$lhs), SETOLT:{ *:[Other] }), V128:{ *:[v4i32] }:$rhs, V128:{ *:[v4i32] }:$lhs) - Complexity = 12
               // Dst: (PMIN_F32x4:{ *:[v4i32] } ?:{ *:[v4i32] }:$lhs, ?:{ *:[v4i32] }:$rhs)
/* 21627*/    /*Scope*/ 11, /*->21639*/
/* 21628*/     OPC_CheckChild1Same, 1,
/* 21630*/     OPC_CheckChild2Same, 0,
/* 21632*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::PMAX_F32x4),
                   MVT::v4i32, 2/*#Ops*/, 0, 1, 
               // Src: (vselect:{ *:[v4i32] } (setcc:{ *:[v4i32] } (bitconvert:{ *:[v4f32] } V128:{ *:[v4i32] }:$lhs), (bitconvert:{ *:[v4f32] } V128:{ *:[v4i32] }:$rhs), SETOLT:{ *:[Other] }), V128:{ *:[v4i32] }:$rhs, V128:{ *:[v4i32] }:$lhs) - Complexity = 12
               // Dst: (PMAX_F32x4:{ *:[v4i32] } ?:{ *:[v4i32] }:$lhs, ?:{ *:[v4i32] }:$rhs)
/* 21639*/    0, /*End of Scope*/
/* 21640*/   /*SwitchType*/ 41, MVT::v2f64,// ->21683
/* 21642*/    OPC_CheckChild0Type, MVT::v2i64,
/* 21644*/    OPC_MoveSibling1,
/* 21645*/    OPC_CheckOpcode, TARGET_VAL(ISD::BITCAST),
/* 21648*/    OPC_RecordChild0, // #1 = $lhs
/* 21649*/    OPC_CheckChild0Type, MVT::v2i64,
/* 21651*/    OPC_MoveParent,
/* 21652*/    OPC_CheckChild2CondCode, ISD::SETOLT,
/* 21654*/    OPC_MoveParent,
/* 21655*/    OPC_CheckType, MVT::v2i64,
/* 21657*/    OPC_Scope, 11, /*->21670*/ // 2 children in Scope
/* 21659*/     OPC_CheckChild1Same, 0,
/* 21661*/     OPC_CheckChild2Same, 1,
/* 21663*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::PMIN_F64x2),
                   MVT::v2i64, 2/*#Ops*/, 1, 0, 
               // Src: (vselect:{ *:[v2i64] } (setcc:{ *:[v2i64] } (bitconvert:{ *:[v2f64] } V128:{ *:[v2i64] }:$rhs), (bitconvert:{ *:[v2f64] } V128:{ *:[v2i64] }:$lhs), SETOLT:{ *:[Other] }), V128:{ *:[v2i64] }:$rhs, V128:{ *:[v2i64] }:$lhs) - Complexity = 12
               // Dst: (PMIN_F64x2:{ *:[v2i64] } ?:{ *:[v2i64] }:$lhs, ?:{ *:[v2i64] }:$rhs)
/* 21670*/    /*Scope*/ 11, /*->21682*/
/* 21671*/     OPC_CheckChild1Same, 1,
/* 21673*/     OPC_CheckChild2Same, 0,
/* 21675*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::PMAX_F64x2),
                   MVT::v2i64, 2/*#Ops*/, 0, 1, 
               // Src: (vselect:{ *:[v2i64] } (setcc:{ *:[v2i64] } (bitconvert:{ *:[v2f64] } V128:{ *:[v2i64] }:$lhs), (bitconvert:{ *:[v2f64] } V128:{ *:[v2i64] }:$rhs), SETOLT:{ *:[Other] }), V128:{ *:[v2i64] }:$rhs, V128:{ *:[v2i64] }:$lhs) - Complexity = 12
               // Dst: (PMAX_F64x2:{ *:[v2i64] } ?:{ *:[v2i64] }:$lhs, ?:{ *:[v2i64] }:$rhs)
/* 21682*/    0, /*End of Scope*/
/* 21683*/   0, // EndSwitchType
/* 21684*/  /*Scope*/ 45, /*->21730*/
/* 21685*/   OPC_RecordChild0, // #0 = $c
/* 21686*/   OPC_RecordChild1, // #1 = $v1
/* 21687*/   OPC_RecordChild2, // #2 = $v2
/* 21688*/   OPC_SwitchType /*4 cases */, 8, MVT::v16i8,// ->21699
/* 21691*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                  MVT::v16i8, 3/*#Ops*/, 1, 2, 0, 
              // Src: (vselect:{ *:[v16i8] } V128:{ *:[v16i8] }:$c, V128:{ *:[v16i8] }:$v1, V128:{ *:[v16i8] }:$v2) - Complexity = 3
              // Dst: (BITSELECT:{ *:[v16i8] } ?:{ *:[v16i8] }:$v1, ?:{ *:[v16i8] }:$v2, ?:{ *:[v16i8] }:$c)
/* 21699*/   /*SwitchType*/ 8, MVT::v8i16,// ->21709
/* 21701*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                  MVT::v8i16, 3/*#Ops*/, 1, 2, 0, 
              // Src: (vselect:{ *:[v8i16] } V128:{ *:[v8i16] }:$c, V128:{ *:[v8i16] }:$v1, V128:{ *:[v8i16] }:$v2) - Complexity = 3
              // Dst: (BITSELECT:{ *:[v8i16] } ?:{ *:[v8i16] }:$v1, ?:{ *:[v8i16] }:$v2, ?:{ *:[v8i16] }:$c)
/* 21709*/   /*SwitchType*/ 8, MVT::v4i32,// ->21719
/* 21711*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                  MVT::v4i32, 3/*#Ops*/, 1, 2, 0, 
              // Src: (vselect:{ *:[v4i32] } V128:{ *:[v4i32] }:$c, V128:{ *:[v4i32] }:$v1, V128:{ *:[v4i32] }:$v2) - Complexity = 3
              // Dst: (BITSELECT:{ *:[v4i32] } ?:{ *:[v4i32] }:$v1, ?:{ *:[v4i32] }:$v2, ?:{ *:[v4i32] }:$c)
/* 21719*/   /*SwitchType*/ 8, MVT::v2i64,// ->21729
/* 21721*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                  MVT::v2i64, 3/*#Ops*/, 1, 2, 0, 
              // Src: (vselect:{ *:[v2i64] } V128:{ *:[v2i64] }:$c, V128:{ *:[v2i64] }:$v1, V128:{ *:[v2i64] }:$v2) - Complexity = 3
              // Dst: (BITSELECT:{ *:[v2i64] } ?:{ *:[v2i64] }:$v1, ?:{ *:[v2i64] }:$v2, ?:{ *:[v2i64] }:$c)
/* 21729*/   0, // EndSwitchType
/* 21730*/  /*Scope*/ 37|128,2/*293*/, /*->22025*/
/* 21732*/   OPC_MoveChild0,
/* 21733*/   OPC_CheckOpcode, TARGET_VAL(ISD::SETCC),
/* 21736*/   OPC_RecordChild0, // #0 = $rhs
/* 21737*/   OPC_Scope, 13|128,1/*141*/, /*->21881*/ // 2 children in Scope
/* 21740*/    OPC_CheckChild0Type, MVT::v4f32,
/* 21742*/    OPC_RecordChild1, // #1 = $lhs
/* 21743*/    OPC_Scope, 33, /*->21778*/ // 4 children in Scope
/* 21745*/     OPC_CheckChild2CondCode, ISD::SETOLT,
/* 21747*/     OPC_MoveParent,
/* 21748*/     OPC_CheckType, MVT::v4f32,
/* 21750*/     OPC_Scope, 12, /*->21764*/ // 2 children in Scope
/* 21752*/      OPC_CheckChild1Same, 0,
/* 21754*/      OPC_CheckChild2Same, 1,
/* 21756*/      OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 21757*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::PMIN_F32x4),
                    MVT::v4f32, 2/*#Ops*/, 1, 0, 
                // Src: (vselect:{ *:[v4f32] } (setcc:{ *:[v4i32] } V128:{ *:[v4f32] }:$rhs, V128:{ *:[v4f32] }:$lhs, SETOLT:{ *:[Other] }), V128:{ *:[v4f32] }:$rhs, V128:{ *:[v4f32] }:$lhs) - Complexity = 6
                // Dst: (PMIN_F32x4:{ *:[v4f32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs)
/* 21764*/     /*Scope*/ 12, /*->21777*/
/* 21765*/      OPC_CheckChild1Same, 1,
/* 21767*/      OPC_CheckChild2Same, 0,
/* 21769*/      OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 21770*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::PMAX_F32x4),
                    MVT::v4f32, 2/*#Ops*/, 0, 1, 
                // Src: (vselect:{ *:[v4f32] } (setcc:{ *:[v4i32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs, SETOLT:{ *:[Other] }), V128:{ *:[v4f32] }:$rhs, V128:{ *:[v4f32] }:$lhs) - Complexity = 6
                // Dst: (PMAX_F32x4:{ *:[v4f32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs)
/* 21777*/     0, /*End of Scope*/
/* 21778*/    /*Scope*/ 33, /*->21812*/
/* 21779*/     OPC_CheckChild2CondCode, ISD::SETOLE,
/* 21781*/     OPC_MoveParent,
/* 21782*/     OPC_CheckType, MVT::v4f32,
/* 21784*/     OPC_Scope, 12, /*->21798*/ // 2 children in Scope
/* 21786*/      OPC_CheckChild1Same, 0,
/* 21788*/      OPC_CheckChild2Same, 1,
/* 21790*/      OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 21791*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::PMIN_F32x4),
                    MVT::v4f32, 2/*#Ops*/, 1, 0, 
                // Src: (vselect:{ *:[v4f32] } (setcc:{ *:[v4i32] } V128:{ *:[v4f32] }:$rhs, V128:{ *:[v4f32] }:$lhs, SETOLE:{ *:[Other] }), V128:{ *:[v4f32] }:$rhs, V128:{ *:[v4f32] }:$lhs) - Complexity = 6
                // Dst: (PMIN_F32x4:{ *:[v4f32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs)
/* 21798*/     /*Scope*/ 12, /*->21811*/
/* 21799*/      OPC_CheckChild1Same, 1,
/* 21801*/      OPC_CheckChild2Same, 0,
/* 21803*/      OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 21804*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::PMAX_F32x4),
                    MVT::v4f32, 2/*#Ops*/, 0, 1, 
                // Src: (vselect:{ *:[v4f32] } (setcc:{ *:[v4i32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs, SETOLE:{ *:[Other] }), V128:{ *:[v4f32] }:$rhs, V128:{ *:[v4f32] }:$lhs) - Complexity = 6
                // Dst: (PMAX_F32x4:{ *:[v4f32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs)
/* 21811*/     0, /*End of Scope*/
/* 21812*/    /*Scope*/ 33, /*->21846*/
/* 21813*/     OPC_CheckChild2CondCode, ISD::SETOGT,
/* 21815*/     OPC_MoveParent,
/* 21816*/     OPC_CheckType, MVT::v4f32,
/* 21818*/     OPC_Scope, 12, /*->21832*/ // 2 children in Scope
/* 21820*/      OPC_CheckChild1Same, 1,
/* 21822*/      OPC_CheckChild2Same, 0,
/* 21824*/      OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 21825*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::PMIN_F32x4),
                    MVT::v4f32, 2/*#Ops*/, 0, 1, 
                // Src: (vselect:{ *:[v4f32] } (setcc:{ *:[v4i32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs, SETOGT:{ *:[Other] }), V128:{ *:[v4f32] }:$rhs, V128:{ *:[v4f32] }:$lhs) - Complexity = 6
                // Dst: (PMIN_F32x4:{ *:[v4f32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs)
/* 21832*/     /*Scope*/ 12, /*->21845*/
/* 21833*/      OPC_CheckChild1Same, 0,
/* 21835*/      OPC_CheckChild2Same, 1,
/* 21837*/      OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 21838*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::PMAX_F32x4),
                    MVT::v4f32, 2/*#Ops*/, 1, 0, 
                // Src: (vselect:{ *:[v4f32] } (setcc:{ *:[v4i32] } V128:{ *:[v4f32] }:$rhs, V128:{ *:[v4f32] }:$lhs, SETOGT:{ *:[Other] }), V128:{ *:[v4f32] }:$rhs, V128:{ *:[v4f32] }:$lhs) - Complexity = 6
                // Dst: (PMAX_F32x4:{ *:[v4f32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs)
/* 21845*/     0, /*End of Scope*/
/* 21846*/    /*Scope*/ 33, /*->21880*/
/* 21847*/     OPC_CheckChild2CondCode, ISD::SETOGE,
/* 21849*/     OPC_MoveParent,
/* 21850*/     OPC_CheckType, MVT::v4f32,
/* 21852*/     OPC_Scope, 12, /*->21866*/ // 2 children in Scope
/* 21854*/      OPC_CheckChild1Same, 1,
/* 21856*/      OPC_CheckChild2Same, 0,
/* 21858*/      OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 21859*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::PMIN_F32x4),
                    MVT::v4f32, 2/*#Ops*/, 0, 1, 
                // Src: (vselect:{ *:[v4f32] } (setcc:{ *:[v4i32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs, SETOGE:{ *:[Other] }), V128:{ *:[v4f32] }:$rhs, V128:{ *:[v4f32] }:$lhs) - Complexity = 6
                // Dst: (PMIN_F32x4:{ *:[v4f32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs)
/* 21866*/     /*Scope*/ 12, /*->21879*/
/* 21867*/      OPC_CheckChild1Same, 0,
/* 21869*/      OPC_CheckChild2Same, 1,
/* 21871*/      OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 21872*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::PMAX_F32x4),
                    MVT::v4f32, 2/*#Ops*/, 1, 0, 
                // Src: (vselect:{ *:[v4f32] } (setcc:{ *:[v4i32] } V128:{ *:[v4f32] }:$rhs, V128:{ *:[v4f32] }:$lhs, SETOGE:{ *:[Other] }), V128:{ *:[v4f32] }:$rhs, V128:{ *:[v4f32] }:$lhs) - Complexity = 6
                // Dst: (PMAX_F32x4:{ *:[v4f32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs)
/* 21879*/     0, /*End of Scope*/
/* 21880*/    0, /*End of Scope*/
/* 21881*/   /*Scope*/ 13|128,1/*141*/, /*->22024*/
/* 21883*/    OPC_CheckChild0Type, MVT::v2f64,
/* 21885*/    OPC_RecordChild1, // #1 = $lhs
/* 21886*/    OPC_Scope, 33, /*->21921*/ // 4 children in Scope
/* 21888*/     OPC_CheckChild2CondCode, ISD::SETOLT,
/* 21890*/     OPC_MoveParent,
/* 21891*/     OPC_CheckType, MVT::v2f64,
/* 21893*/     OPC_Scope, 12, /*->21907*/ // 2 children in Scope
/* 21895*/      OPC_CheckChild1Same, 0,
/* 21897*/      OPC_CheckChild2Same, 1,
/* 21899*/      OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 21900*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::PMIN_F64x2),
                    MVT::v2f64, 2/*#Ops*/, 1, 0, 
                // Src: (vselect:{ *:[v2f64] } (setcc:{ *:[v2i64] } V128:{ *:[v2f64] }:$rhs, V128:{ *:[v2f64] }:$lhs, SETOLT:{ *:[Other] }), V128:{ *:[v2f64] }:$rhs, V128:{ *:[v2f64] }:$lhs) - Complexity = 6
                // Dst: (PMIN_F64x2:{ *:[v2f64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs)
/* 21907*/     /*Scope*/ 12, /*->21920*/
/* 21908*/      OPC_CheckChild1Same, 1,
/* 21910*/      OPC_CheckChild2Same, 0,
/* 21912*/      OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 21913*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::PMAX_F64x2),
                    MVT::v2f64, 2/*#Ops*/, 0, 1, 
                // Src: (vselect:{ *:[v2f64] } (setcc:{ *:[v2i64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs, SETOLT:{ *:[Other] }), V128:{ *:[v2f64] }:$rhs, V128:{ *:[v2f64] }:$lhs) - Complexity = 6
                // Dst: (PMAX_F64x2:{ *:[v2f64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs)
/* 21920*/     0, /*End of Scope*/
/* 21921*/    /*Scope*/ 33, /*->21955*/
/* 21922*/     OPC_CheckChild2CondCode, ISD::SETOLE,
/* 21924*/     OPC_MoveParent,
/* 21925*/     OPC_CheckType, MVT::v2f64,
/* 21927*/     OPC_Scope, 12, /*->21941*/ // 2 children in Scope
/* 21929*/      OPC_CheckChild1Same, 0,
/* 21931*/      OPC_CheckChild2Same, 1,
/* 21933*/      OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 21934*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::PMIN_F64x2),
                    MVT::v2f64, 2/*#Ops*/, 1, 0, 
                // Src: (vselect:{ *:[v2f64] } (setcc:{ *:[v2i64] } V128:{ *:[v2f64] }:$rhs, V128:{ *:[v2f64] }:$lhs, SETOLE:{ *:[Other] }), V128:{ *:[v2f64] }:$rhs, V128:{ *:[v2f64] }:$lhs) - Complexity = 6
                // Dst: (PMIN_F64x2:{ *:[v2f64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs)
/* 21941*/     /*Scope*/ 12, /*->21954*/
/* 21942*/      OPC_CheckChild1Same, 1,
/* 21944*/      OPC_CheckChild2Same, 0,
/* 21946*/      OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 21947*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::PMAX_F64x2),
                    MVT::v2f64, 2/*#Ops*/, 0, 1, 
                // Src: (vselect:{ *:[v2f64] } (setcc:{ *:[v2i64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs, SETOLE:{ *:[Other] }), V128:{ *:[v2f64] }:$rhs, V128:{ *:[v2f64] }:$lhs) - Complexity = 6
                // Dst: (PMAX_F64x2:{ *:[v2f64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs)
/* 21954*/     0, /*End of Scope*/
/* 21955*/    /*Scope*/ 33, /*->21989*/
/* 21956*/     OPC_CheckChild2CondCode, ISD::SETOGT,
/* 21958*/     OPC_MoveParent,
/* 21959*/     OPC_CheckType, MVT::v2f64,
/* 21961*/     OPC_Scope, 12, /*->21975*/ // 2 children in Scope
/* 21963*/      OPC_CheckChild1Same, 1,
/* 21965*/      OPC_CheckChild2Same, 0,
/* 21967*/      OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 21968*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::PMIN_F64x2),
                    MVT::v2f64, 2/*#Ops*/, 0, 1, 
                // Src: (vselect:{ *:[v2f64] } (setcc:{ *:[v2i64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs, SETOGT:{ *:[Other] }), V128:{ *:[v2f64] }:$rhs, V128:{ *:[v2f64] }:$lhs) - Complexity = 6
                // Dst: (PMIN_F64x2:{ *:[v2f64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs)
/* 21975*/     /*Scope*/ 12, /*->21988*/
/* 21976*/      OPC_CheckChild1Same, 0,
/* 21978*/      OPC_CheckChild2Same, 1,
/* 21980*/      OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 21981*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::PMAX_F64x2),
                    MVT::v2f64, 2/*#Ops*/, 1, 0, 
                // Src: (vselect:{ *:[v2f64] } (setcc:{ *:[v2i64] } V128:{ *:[v2f64] }:$rhs, V128:{ *:[v2f64] }:$lhs, SETOGT:{ *:[Other] }), V128:{ *:[v2f64] }:$rhs, V128:{ *:[v2f64] }:$lhs) - Complexity = 6
                // Dst: (PMAX_F64x2:{ *:[v2f64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs)
/* 21988*/     0, /*End of Scope*/
/* 21989*/    /*Scope*/ 33, /*->22023*/
/* 21990*/     OPC_CheckChild2CondCode, ISD::SETOGE,
/* 21992*/     OPC_MoveParent,
/* 21993*/     OPC_CheckType, MVT::v2f64,
/* 21995*/     OPC_Scope, 12, /*->22009*/ // 2 children in Scope
/* 21997*/      OPC_CheckChild1Same, 1,
/* 21999*/      OPC_CheckChild2Same, 0,
/* 22001*/      OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 22002*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::PMIN_F64x2),
                    MVT::v2f64, 2/*#Ops*/, 0, 1, 
                // Src: (vselect:{ *:[v2f64] } (setcc:{ *:[v2i64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs, SETOGE:{ *:[Other] }), V128:{ *:[v2f64] }:$rhs, V128:{ *:[v2f64] }:$lhs) - Complexity = 6
                // Dst: (PMIN_F64x2:{ *:[v2f64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs)
/* 22009*/     /*Scope*/ 12, /*->22022*/
/* 22010*/      OPC_CheckChild1Same, 0,
/* 22012*/      OPC_CheckChild2Same, 1,
/* 22014*/      OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 22015*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::PMAX_F64x2),
                    MVT::v2f64, 2/*#Ops*/, 1, 0, 
                // Src: (vselect:{ *:[v2f64] } (setcc:{ *:[v2i64] } V128:{ *:[v2f64] }:$rhs, V128:{ *:[v2f64] }:$lhs, SETOGE:{ *:[Other] }), V128:{ *:[v2f64] }:$rhs, V128:{ *:[v2f64] }:$lhs) - Complexity = 6
                // Dst: (PMAX_F64x2:{ *:[v2f64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs)
/* 22022*/     0, /*End of Scope*/
/* 22023*/    0, /*End of Scope*/
/* 22024*/   0, /*End of Scope*/
/* 22025*/  /*Scope*/ 25, /*->22051*/
/* 22026*/   OPC_RecordChild0, // #0 = $c
/* 22027*/   OPC_RecordChild1, // #1 = $v1
/* 22028*/   OPC_RecordChild2, // #2 = $v2
/* 22029*/   OPC_SwitchType /*2 cases */, 8, MVT::v4f32,// ->22040
/* 22032*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                  MVT::v4f32, 3/*#Ops*/, 1, 2, 0, 
              // Src: (vselect:{ *:[v4f32] } V128:{ *:[v4i32] }:$c, V128:{ *:[v4f32] }:$v1, V128:{ *:[v4f32] }:$v2) - Complexity = 3
              // Dst: (BITSELECT:{ *:[v4f32] } ?:{ *:[v4f32] }:$v1, ?:{ *:[v4f32] }:$v2, ?:{ *:[v4i32] }:$c)
/* 22040*/   /*SwitchType*/ 8, MVT::v2f64,// ->22050
/* 22042*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                  MVT::v2f64, 3/*#Ops*/, 1, 2, 0, 
              // Src: (vselect:{ *:[v2f64] } V128:{ *:[v2i64] }:$c, V128:{ *:[v2f64] }:$v1, V128:{ *:[v2f64] }:$v2) - Complexity = 3
              // Dst: (BITSELECT:{ *:[v2f64] } ?:{ *:[v2f64] }:$v1, ?:{ *:[v2f64] }:$v2, ?:{ *:[v2i64] }:$c)
/* 22050*/   0, // EndSwitchType
/* 22051*/  0, /*End of Scope*/
/* 22052*/ /*SwitchOpcode*/ 16, TARGET_VAL(WebAssemblyISD::SWIZZLE),// ->22071
/* 22055*/  OPC_RecordChild0, // #0 = $src
/* 22056*/  OPC_CheckChild0Type, MVT::v16i8,
/* 22058*/  OPC_RecordChild1, // #1 = $mask
/* 22059*/  OPC_CheckChild1Type, MVT::v16i8,
/* 22061*/  OPC_CheckType, MVT::v16i8,
/* 22063*/  OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 22064*/  OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SWIZZLE),
                MVT::v16i8, 2/*#Ops*/, 0, 1, 
            // Src: (wasm_swizzle:{ *:[v16i8] } V128:{ *:[v16i8] }:$src, V128:{ *:[v16i8] }:$mask) - Complexity = 3
            // Dst: (SWIZZLE:{ *:[v16i8] } V128:{ *:[v16i8] }:$src, V128:{ *:[v16i8] }:$mask)
/* 22071*/ /*SwitchOpcode*/ 39, TARGET_VAL(ISD::ABS),// ->22113
/* 22074*/  OPC_RecordChild0, // #0 = $v
/* 22075*/  OPC_SwitchType /*4 cases */, 7, MVT::v16i8,// ->22085
/* 22078*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 22079*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ABS_I8x16),
                 MVT::v16i8, 1/*#Ops*/, 0, 
             // Src: (abs:{ *:[v16i8] } V128:{ *:[v16i8] }:$v) - Complexity = 3
             // Dst: (ABS_I8x16:{ *:[v16i8] } V128:{ *:[v16i8] }:$v)
/* 22085*/  /*SwitchType*/ 7, MVT::v8i16,// ->22094
/* 22087*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 22088*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ABS_I16x8),
                 MVT::v8i16, 1/*#Ops*/, 0, 
             // Src: (abs:{ *:[v8i16] } V128:{ *:[v8i16] }:$v) - Complexity = 3
             // Dst: (ABS_I16x8:{ *:[v8i16] } V128:{ *:[v8i16] }:$v)
/* 22094*/  /*SwitchType*/ 7, MVT::v4i32,// ->22103
/* 22096*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 22097*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ABS_I32x4),
                 MVT::v4i32, 1/*#Ops*/, 0, 
             // Src: (abs:{ *:[v4i32] } V128:{ *:[v4i32] }:$v) - Complexity = 3
             // Dst: (ABS_I32x4:{ *:[v4i32] } V128:{ *:[v4i32] }:$v)
/* 22103*/  /*SwitchType*/ 7, MVT::v2i64,// ->22112
/* 22105*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 22106*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ABS_I64x2),
                 MVT::v2i64, 1/*#Ops*/, 0, 
             // Src: (abs:{ *:[v2i64] } V128:{ *:[v2i64] }:$v) - Complexity = 3
             // Dst: (ABS_I64x2:{ *:[v2i64] } V128:{ *:[v2i64] }:$v)
/* 22112*/  0, // EndSwitchType
/* 22113*/ /*SwitchOpcode*/ 24, TARGET_VAL(ISD::SADDSAT),// ->22140
/* 22116*/  OPC_RecordChild0, // #0 = $lhs
/* 22117*/  OPC_RecordChild1, // #1 = $rhs
/* 22118*/  OPC_SwitchType /*2 cases */, 8, MVT::v16i8,// ->22129
/* 22121*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 22122*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ADD_SAT_S_I8x16),
                 MVT::v16i8, 2/*#Ops*/, 0, 1, 
             // Src: (saddsat:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs) - Complexity = 3
             // Dst: (ADD_SAT_S_I8x16:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs)
/* 22129*/  /*SwitchType*/ 8, MVT::v8i16,// ->22139
/* 22131*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 22132*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ADD_SAT_S_I16x8),
                 MVT::v8i16, 2/*#Ops*/, 0, 1, 
             // Src: (saddsat:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs) - Complexity = 3
             // Dst: (ADD_SAT_S_I16x8:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs)
/* 22139*/  0, // EndSwitchType
/* 22140*/ /*SwitchOpcode*/ 24, TARGET_VAL(ISD::UADDSAT),// ->22167
/* 22143*/  OPC_RecordChild0, // #0 = $lhs
/* 22144*/  OPC_RecordChild1, // #1 = $rhs
/* 22145*/  OPC_SwitchType /*2 cases */, 8, MVT::v16i8,// ->22156
/* 22148*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 22149*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ADD_SAT_U_I8x16),
                 MVT::v16i8, 2/*#Ops*/, 0, 1, 
             // Src: (uaddsat:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs) - Complexity = 3
             // Dst: (ADD_SAT_U_I8x16:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs)
/* 22156*/  /*SwitchType*/ 8, MVT::v8i16,// ->22166
/* 22158*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 22159*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ADD_SAT_U_I16x8),
                 MVT::v8i16, 2/*#Ops*/, 0, 1, 
             // Src: (uaddsat:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs) - Complexity = 3
             // Dst: (ADD_SAT_U_I16x8:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs)
/* 22166*/  0, // EndSwitchType
/* 22167*/ /*SwitchOpcode*/ 34, TARGET_VAL(ISD::SMIN),// ->22204
/* 22170*/  OPC_RecordChild0, // #0 = $lhs
/* 22171*/  OPC_RecordChild1, // #1 = $rhs
/* 22172*/  OPC_SwitchType /*3 cases */, 8, MVT::v16i8,// ->22183
/* 22175*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 22176*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::MIN_S_I8x16),
                 MVT::v16i8, 2/*#Ops*/, 0, 1, 
             // Src: (smin:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs) - Complexity = 3
             // Dst: (MIN_S_I8x16:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs)
/* 22183*/  /*SwitchType*/ 8, MVT::v8i16,// ->22193
/* 22185*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 22186*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::MIN_S_I16x8),
                 MVT::v8i16, 2/*#Ops*/, 0, 1, 
             // Src: (smin:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs) - Complexity = 3
             // Dst: (MIN_S_I16x8:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs)
/* 22193*/  /*SwitchType*/ 8, MVT::v4i32,// ->22203
/* 22195*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 22196*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::MIN_S_I32x4),
                 MVT::v4i32, 2/*#Ops*/, 0, 1, 
             // Src: (smin:{ *:[v4i32] } V128:{ *:[v4i32] }:$lhs, V128:{ *:[v4i32] }:$rhs) - Complexity = 3
             // Dst: (MIN_S_I32x4:{ *:[v4i32] } V128:{ *:[v4i32] }:$lhs, V128:{ *:[v4i32] }:$rhs)
/* 22203*/  0, // EndSwitchType
/* 22204*/ /*SwitchOpcode*/ 34, TARGET_VAL(ISD::UMIN),// ->22241
/* 22207*/  OPC_RecordChild0, // #0 = $lhs
/* 22208*/  OPC_RecordChild1, // #1 = $rhs
/* 22209*/  OPC_SwitchType /*3 cases */, 8, MVT::v16i8,// ->22220
/* 22212*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 22213*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::MIN_U_I8x16),
                 MVT::v16i8, 2/*#Ops*/, 0, 1, 
             // Src: (umin:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs) - Complexity = 3
             // Dst: (MIN_U_I8x16:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs)
/* 22220*/  /*SwitchType*/ 8, MVT::v8i16,// ->22230
/* 22222*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 22223*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::MIN_U_I16x8),
                 MVT::v8i16, 2/*#Ops*/, 0, 1, 
             // Src: (umin:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs) - Complexity = 3
             // Dst: (MIN_U_I16x8:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs)
/* 22230*/  /*SwitchType*/ 8, MVT::v4i32,// ->22240
/* 22232*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 22233*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::MIN_U_I32x4),
                 MVT::v4i32, 2/*#Ops*/, 0, 1, 
             // Src: (umin:{ *:[v4i32] } V128:{ *:[v4i32] }:$lhs, V128:{ *:[v4i32] }:$rhs) - Complexity = 3
             // Dst: (MIN_U_I32x4:{ *:[v4i32] } V128:{ *:[v4i32] }:$lhs, V128:{ *:[v4i32] }:$rhs)
/* 22240*/  0, // EndSwitchType
/* 22241*/ /*SwitchOpcode*/ 34, TARGET_VAL(ISD::SMAX),// ->22278
/* 22244*/  OPC_RecordChild0, // #0 = $lhs
/* 22245*/  OPC_RecordChild1, // #1 = $rhs
/* 22246*/  OPC_SwitchType /*3 cases */, 8, MVT::v16i8,// ->22257
/* 22249*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 22250*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::MAX_S_I8x16),
                 MVT::v16i8, 2/*#Ops*/, 0, 1, 
             // Src: (smax:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs) - Complexity = 3
             // Dst: (MAX_S_I8x16:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs)
/* 22257*/  /*SwitchType*/ 8, MVT::v8i16,// ->22267
/* 22259*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 22260*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::MAX_S_I16x8),
                 MVT::v8i16, 2/*#Ops*/, 0, 1, 
             // Src: (smax:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs) - Complexity = 3
             // Dst: (MAX_S_I16x8:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs)
/* 22267*/  /*SwitchType*/ 8, MVT::v4i32,// ->22277
/* 22269*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 22270*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::MAX_S_I32x4),
                 MVT::v4i32, 2/*#Ops*/, 0, 1, 
             // Src: (smax:{ *:[v4i32] } V128:{ *:[v4i32] }:$lhs, V128:{ *:[v4i32] }:$rhs) - Complexity = 3
             // Dst: (MAX_S_I32x4:{ *:[v4i32] } V128:{ *:[v4i32] }:$lhs, V128:{ *:[v4i32] }:$rhs)
/* 22277*/  0, // EndSwitchType
/* 22278*/ /*SwitchOpcode*/ 34, TARGET_VAL(ISD::UMAX),// ->22315
/* 22281*/  OPC_RecordChild0, // #0 = $lhs
/* 22282*/  OPC_RecordChild1, // #1 = $rhs
/* 22283*/  OPC_SwitchType /*3 cases */, 8, MVT::v16i8,// ->22294
/* 22286*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 22287*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::MAX_U_I8x16),
                 MVT::v16i8, 2/*#Ops*/, 0, 1, 
             // Src: (umax:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs) - Complexity = 3
             // Dst: (MAX_U_I8x16:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs)
/* 22294*/  /*SwitchType*/ 8, MVT::v8i16,// ->22304
/* 22296*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 22297*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::MAX_U_I16x8),
                 MVT::v8i16, 2/*#Ops*/, 0, 1, 
             // Src: (umax:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs) - Complexity = 3
             // Dst: (MAX_U_I16x8:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs)
/* 22304*/  /*SwitchType*/ 8, MVT::v4i32,// ->22314
/* 22306*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 22307*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::MAX_U_I32x4),
                 MVT::v4i32, 2/*#Ops*/, 0, 1, 
             // Src: (umax:{ *:[v4i32] } V128:{ *:[v4i32] }:$lhs, V128:{ *:[v4i32] }:$rhs) - Complexity = 3
             // Dst: (MAX_U_I32x4:{ *:[v4i32] } V128:{ *:[v4i32] }:$lhs, V128:{ *:[v4i32] }:$rhs)
/* 22314*/  0, // EndSwitchType
/* 22315*/ /*SwitchOpcode*/ 12, TARGET_VAL(WebAssemblyISD::TRUNC_SAT_ZERO_S),// ->22330
/* 22318*/  OPC_RecordChild0, // #0 = $vec
/* 22319*/  OPC_CheckChild0Type, MVT::v2f64,
/* 22321*/  OPC_CheckType, MVT::v4i32,
/* 22323*/  OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 22324*/  OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::trunc_sat_zero_s_I32x4),
                MVT::v4i32, 1/*#Ops*/, 0, 
            // Src: (trunc_sat_zero_s:{ *:[v4i32] } V128:{ *:[v2f64] }:$vec) - Complexity = 3
            // Dst: (trunc_sat_zero_s_I32x4:{ *:[v4i32] } V128:{ *:[v2f64] }:$vec)
/* 22330*/ /*SwitchOpcode*/ 12, TARGET_VAL(WebAssemblyISD::TRUNC_SAT_ZERO_U),// ->22345
/* 22333*/  OPC_RecordChild0, // #0 = $vec
/* 22334*/  OPC_CheckChild0Type, MVT::v2f64,
/* 22336*/  OPC_CheckType, MVT::v4i32,
/* 22338*/  OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 22339*/  OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::trunc_sat_zero_u_I32x4),
                MVT::v4i32, 1/*#Ops*/, 0, 
            // Src: (trunc_sat_zero_u:{ *:[v4i32] } V128:{ *:[v2f64] }:$vec) - Complexity = 3
            // Dst: (trunc_sat_zero_u_I32x4:{ *:[v4i32] } V128:{ *:[v2f64] }:$vec)
/* 22345*/ /*SwitchOpcode*/ 36, TARGET_VAL(WebAssemblyISD::EXTEND_LOW_S),// ->22384
/* 22348*/  OPC_RecordChild0, // #0 = $vec
/* 22349*/  OPC_SwitchType /*3 cases */, 9, MVT::v8i16,// ->22361
/* 22352*/   OPC_CheckChild0Type, MVT::v16i8,
/* 22354*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 22355*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::extend_low_s_I16x8),
                 MVT::v8i16, 1/*#Ops*/, 0, 
             // Src: (extend_low_s:{ *:[v8i16] } V128:{ *:[v16i8] }:$vec) - Complexity = 3
             // Dst: (extend_low_s_I16x8:{ *:[v8i16] } V128:{ *:[v16i8] }:$vec)
/* 22361*/  /*SwitchType*/ 9, MVT::v4i32,// ->22372
/* 22363*/   OPC_CheckChild0Type, MVT::v8i16,
/* 22365*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 22366*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::extend_low_s_I32x4),
                 MVT::v4i32, 1/*#Ops*/, 0, 
             // Src: (extend_low_s:{ *:[v4i32] } V128:{ *:[v8i16] }:$vec) - Complexity = 3
             // Dst: (extend_low_s_I32x4:{ *:[v4i32] } V128:{ *:[v8i16] }:$vec)
/* 22372*/  /*SwitchType*/ 9, MVT::v2i64,// ->22383
/* 22374*/   OPC_CheckChild0Type, MVT::v4i32,
/* 22376*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 22377*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::extend_low_s_I64x2),
                 MVT::v2i64, 1/*#Ops*/, 0, 
             // Src: (extend_low_s:{ *:[v2i64] } V128:{ *:[v4i32] }:$vec) - Complexity = 3
             // Dst: (extend_low_s_I64x2:{ *:[v2i64] } V128:{ *:[v4i32] }:$vec)
/* 22383*/  0, // EndSwitchType
/* 22384*/ /*SwitchOpcode*/ 36, TARGET_VAL(WebAssemblyISD::EXTEND_HIGH_S),// ->22423
/* 22387*/  OPC_RecordChild0, // #0 = $vec
/* 22388*/  OPC_SwitchType /*3 cases */, 9, MVT::v8i16,// ->22400
/* 22391*/   OPC_CheckChild0Type, MVT::v16i8,
/* 22393*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 22394*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::extend_high_s_I16x8),
                 MVT::v8i16, 1/*#Ops*/, 0, 
             // Src: (extend_high_s:{ *:[v8i16] } V128:{ *:[v16i8] }:$vec) - Complexity = 3
             // Dst: (extend_high_s_I16x8:{ *:[v8i16] } V128:{ *:[v16i8] }:$vec)
/* 22400*/  /*SwitchType*/ 9, MVT::v4i32,// ->22411
/* 22402*/   OPC_CheckChild0Type, MVT::v8i16,
/* 22404*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 22405*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::extend_high_s_I32x4),
                 MVT::v4i32, 1/*#Ops*/, 0, 
             // Src: (extend_high_s:{ *:[v4i32] } V128:{ *:[v8i16] }:$vec) - Complexity = 3
             // Dst: (extend_high_s_I32x4:{ *:[v4i32] } V128:{ *:[v8i16] }:$vec)
/* 22411*/  /*SwitchType*/ 9, MVT::v2i64,// ->22422
/* 22413*/   OPC_CheckChild0Type, MVT::v4i32,
/* 22415*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 22416*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::extend_high_s_I64x2),
                 MVT::v2i64, 1/*#Ops*/, 0, 
             // Src: (extend_high_s:{ *:[v2i64] } V128:{ *:[v4i32] }:$vec) - Complexity = 3
             // Dst: (extend_high_s_I64x2:{ *:[v2i64] } V128:{ *:[v4i32] }:$vec)
/* 22422*/  0, // EndSwitchType
/* 22423*/ /*SwitchOpcode*/ 36, TARGET_VAL(WebAssemblyISD::EXTEND_LOW_U),// ->22462
/* 22426*/  OPC_RecordChild0, // #0 = $vec
/* 22427*/  OPC_SwitchType /*3 cases */, 9, MVT::v8i16,// ->22439
/* 22430*/   OPC_CheckChild0Type, MVT::v16i8,
/* 22432*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 22433*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::extend_low_u_I16x8),
                 MVT::v8i16, 1/*#Ops*/, 0, 
             // Src: (extend_low_u:{ *:[v8i16] } V128:{ *:[v16i8] }:$vec) - Complexity = 3
             // Dst: (extend_low_u_I16x8:{ *:[v8i16] } V128:{ *:[v16i8] }:$vec)
/* 22439*/  /*SwitchType*/ 9, MVT::v4i32,// ->22450
/* 22441*/   OPC_CheckChild0Type, MVT::v8i16,
/* 22443*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 22444*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::extend_low_u_I32x4),
                 MVT::v4i32, 1/*#Ops*/, 0, 
             // Src: (extend_low_u:{ *:[v4i32] } V128:{ *:[v8i16] }:$vec) - Complexity = 3
             // Dst: (extend_low_u_I32x4:{ *:[v4i32] } V128:{ *:[v8i16] }:$vec)
/* 22450*/  /*SwitchType*/ 9, MVT::v2i64,// ->22461
/* 22452*/   OPC_CheckChild0Type, MVT::v4i32,
/* 22454*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 22455*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::extend_low_u_I64x2),
                 MVT::v2i64, 1/*#Ops*/, 0, 
             // Src: (extend_low_u:{ *:[v2i64] } V128:{ *:[v4i32] }:$vec) - Complexity = 3
             // Dst: (extend_low_u_I64x2:{ *:[v2i64] } V128:{ *:[v4i32] }:$vec)
/* 22461*/  0, // EndSwitchType
/* 22462*/ /*SwitchOpcode*/ 36, TARGET_VAL(WebAssemblyISD::EXTEND_HIGH_U),// ->22501
/* 22465*/  OPC_RecordChild0, // #0 = $vec
/* 22466*/  OPC_SwitchType /*3 cases */, 9, MVT::v8i16,// ->22478
/* 22469*/   OPC_CheckChild0Type, MVT::v16i8,
/* 22471*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 22472*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::extend_high_u_I16x8),
                 MVT::v8i16, 1/*#Ops*/, 0, 
             // Src: (extend_high_u:{ *:[v8i16] } V128:{ *:[v16i8] }:$vec) - Complexity = 3
             // Dst: (extend_high_u_I16x8:{ *:[v8i16] } V128:{ *:[v16i8] }:$vec)
/* 22478*/  /*SwitchType*/ 9, MVT::v4i32,// ->22489
/* 22480*/   OPC_CheckChild0Type, MVT::v8i16,
/* 22482*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 22483*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::extend_high_u_I32x4),
                 MVT::v4i32, 1/*#Ops*/, 0, 
             // Src: (extend_high_u:{ *:[v4i32] } V128:{ *:[v8i16] }:$vec) - Complexity = 3
             // Dst: (extend_high_u_I32x4:{ *:[v4i32] } V128:{ *:[v8i16] }:$vec)
/* 22489*/  /*SwitchType*/ 9, MVT::v2i64,// ->22500
/* 22491*/   OPC_CheckChild0Type, MVT::v4i32,
/* 22493*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 22494*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::extend_high_u_I64x2),
                 MVT::v2i64, 1/*#Ops*/, 0, 
             // Src: (extend_high_u:{ *:[v2i64] } V128:{ *:[v4i32] }:$vec) - Complexity = 3
             // Dst: (extend_high_u_I64x2:{ *:[v2i64] } V128:{ *:[v4i32] }:$vec)
/* 22500*/  0, // EndSwitchType
/* 22501*/ /*SwitchOpcode*/ 31, TARGET_VAL(WebAssemblyISD::NARROW_U),// ->22535
/* 22504*/  OPC_RecordChild0, // #0 = $left
/* 22505*/  OPC_SwitchType /*2 cases */, 12, MVT::v16i8,// ->22520
/* 22508*/   OPC_CheckChild0Type, MVT::v8i16,
/* 22510*/   OPC_RecordChild1, // #1 = $right
/* 22511*/   OPC_CheckChild1Type, MVT::v8i16,
/* 22513*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::NARROW_U_I8x16),
                 MVT::v16i8, 2/*#Ops*/, 0, 1, 
             // Src: (wasm_narrow_u:{ *:[v16i8] } V128:{ *:[v8i16] }:$left, V128:{ *:[v8i16] }:$right) - Complexity = 3
             // Dst: (NARROW_U_I8x16:{ *:[v16i8] } ?:{ *:[v8i16] }:$left, ?:{ *:[v8i16] }:$right)
/* 22520*/  /*SwitchType*/ 12, MVT::v8i16,// ->22534
/* 22522*/   OPC_CheckChild0Type, MVT::v4i32,
/* 22524*/   OPC_RecordChild1, // #1 = $right
/* 22525*/   OPC_CheckChild1Type, MVT::v4i32,
/* 22527*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::NARROW_U_I16x8),
                 MVT::v8i16, 2/*#Ops*/, 0, 1, 
             // Src: (wasm_narrow_u:{ *:[v8i16] } V128:{ *:[v4i32] }:$left, V128:{ *:[v4i32] }:$right) - Complexity = 3
             // Dst: (NARROW_U_I16x8:{ *:[v8i16] } ?:{ *:[v4i32] }:$left, ?:{ *:[v4i32] }:$right)
/* 22534*/  0, // EndSwitchType
/* 22535*/ /*SwitchOpcode*/ 12, TARGET_VAL(WebAssemblyISD::CONVERT_LOW_S),// ->22550
/* 22538*/  OPC_RecordChild0, // #0 = $vec
/* 22539*/  OPC_CheckChild0Type, MVT::v4i32,
/* 22541*/  OPC_CheckType, MVT::v2f64,
/* 22543*/  OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 22544*/  OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::convert_low_s_F64x2),
                MVT::v2f64, 1/*#Ops*/, 0, 
            // Src: (convert_low_s:{ *:[v2f64] } V128:{ *:[v4i32] }:$vec) - Complexity = 3
            // Dst: (convert_low_s_F64x2:{ *:[v2f64] } V128:{ *:[v4i32] }:$vec)
/* 22550*/ /*SwitchOpcode*/ 12, TARGET_VAL(WebAssemblyISD::CONVERT_LOW_U),// ->22565
/* 22553*/  OPC_RecordChild0, // #0 = $vec
/* 22554*/  OPC_CheckChild0Type, MVT::v4i32,
/* 22556*/  OPC_CheckType, MVT::v2f64,
/* 22558*/  OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 22559*/  OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::convert_low_u_F64x2),
                MVT::v2f64, 1/*#Ops*/, 0, 
            // Src: (convert_low_u:{ *:[v2f64] } V128:{ *:[v4i32] }:$vec) - Complexity = 3
            // Dst: (convert_low_u_F64x2:{ *:[v2f64] } V128:{ *:[v4i32] }:$vec)
/* 22565*/ /*SwitchOpcode*/ 12, TARGET_VAL(WebAssemblyISD::DEMOTE_ZERO),// ->22580
/* 22568*/  OPC_RecordChild0, // #0 = $vec
/* 22569*/  OPC_CheckChild0Type, MVT::v2f64,
/* 22571*/  OPC_CheckType, MVT::v4f32,
/* 22573*/  OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 22574*/  OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::demote_zero_F32x4),
                MVT::v4f32, 1/*#Ops*/, 0, 
            // Src: (demote_zero:{ *:[v4f32] } V128:{ *:[v2f64] }:$vec) - Complexity = 3
            // Dst: (demote_zero_F32x4:{ *:[v4f32] } V128:{ *:[v2f64] }:$vec)
/* 22580*/ /*SwitchOpcode*/ 12, TARGET_VAL(WebAssemblyISD::PROMOTE_LOW),// ->22595
/* 22583*/  OPC_RecordChild0, // #0 = $vec
/* 22584*/  OPC_CheckChild0Type, MVT::v4f32,
/* 22586*/  OPC_CheckType, MVT::v2f64,
/* 22588*/  OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 22589*/  OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::promote_low_F64x2),
                MVT::v2f64, 1/*#Ops*/, 0, 
            // Src: (promote_low:{ *:[v2f64] } V128:{ *:[v4f32] }:$vec) - Complexity = 3
            // Dst: (promote_low_F64x2:{ *:[v2f64] } V128:{ *:[v4f32] }:$vec)
/* 22595*/ 0, // EndSwitchOpcode
    0
  }; // Total Array size is 22597 bytes

  // Opcode Histogram:
  // #OPC_Scope                                = 331
  // #OPC_RecordNode                           = 282
  // #OPC_RecordChild                          = 710
  // #OPC_RecordMemRef                         = 39
  // #OPC_CaptureGlueInput                     = 1
  // #OPC_MoveChild                            = 281
  // #OPC_MoveSibling                          = 284
  // #OPC_MoveParent                           = 561
  // #OPC_CheckSame                            = 0
  // #OPC_CheckChildSame                       = 127
  // #OPC_CheckPatternPredicate                = 661
  // #OPC_CheckPredicate                       = 531
  // #OPC_CheckOpcode                          = 489
  // #OPC_SwitchOpcode                         = 15
  // #OPC_CheckType                            = 517
  // #OPC_SwitchType                           = 178
  // #OPC_CheckChildType                       = 433
  // #OPC_CheckInteger                         = 0
  // #OPC_CheckChildInteger                    = 97
  // #OPC_CheckCondCode                        = 0
  // #OPC_CheckChild2CondCode                  = 142
  // #OPC_CheckValueType                       = 15
  // #OPC_CheckComplexPat                      = 318
  // #OPC_CheckAndImm                          = 27
  // #OPC_CheckOrImm                           = 0
  // #OPC_CheckImmAllOnesV                     = 44
  // #OPC_CheckImmAllZerosV                    = 1
  // #OPC_CheckFoldableChainNode               = 5
  // #OPC_EmitInteger                          = 345
  // #OPC_EmitStringInteger                    = 0
  // #OPC_EmitRegister                         = 0
  // #OPC_EmitConvertToTarget                  = 310
  // #OPC_EmitMergeInputChains                 = 414
  // #OPC_EmitCopyToReg                        = 0
  // #OPC_EmitNode                             = 9
  // #OPC_EmitNodeXForm                        = 0
  // #OPC_CompleteMatch                        = 32
  // #OPC_MorphNodeTo                          = 1149

  #undef TARGET_VAL
  SelectCodeCommon(N, MatcherTable,sizeof(MatcherTable));
}
#endif // GET_DAGISEL_BODY

#ifdef GET_DAGISEL_DECL
bool CheckPatternPredicate(unsigned PredNo) const override;
#endif
#if defined(GET_DAGISEL_BODY) || DAGISEL_INLINE
bool DAGISEL_CLASS_COLONCOLON CheckPatternPredicate(unsigned PredNo) const
#if DAGISEL_INLINE
  override
#endif
{
  switch (PredNo) {
  default: llvm_unreachable("Invalid predicate in table?");
  case 0: return (Subtarget->hasSIMD128());
  case 1: return (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics());
  case 2: return (Subtarget->hasAddr64()) && (Subtarget->hasAtomics());
  case 3: return (!Subtarget->hasAddr64());
  case 4: return (Subtarget->hasAddr64());
  case 5: return (Subtarget->hasReferenceTypes());
  case 6: return (Subtarget->hasRelaxedSIMD());
  case 7: return (Subtarget->hasNontrappingFPToInt());
  case 8: return (!Subtarget->hasNontrappingFPToInt());
  case 9: return (Subtarget->hasSignExt());
  case 10: return (Subtarget->hasBulkMemory());
  case 11: return (!Subtarget->hasAddr64()) && (TM.isPositionIndependent());
  case 12: return (Subtarget->hasAddr64()) && (TM.isPositionIndependent());
  case 13: return (Subtarget->hasExceptionHandling());
  case 14: return (!Subtarget->hasAddr64()) && (!TM.isPositionIndependent());
  case 15: return (Subtarget->hasAddr64()) && (!TM.isPositionIndependent());
  }
}
#endif // GET_DAGISEL_BODY

#ifdef GET_DAGISEL_DECL
bool CheckNodePredicate(SDNode *Node, unsigned PredNo) const override;
#endif
#if defined(GET_DAGISEL_BODY) || DAGISEL_INLINE
bool DAGISEL_CLASS_COLONCOLON CheckNodePredicate(SDNode *Node, unsigned PredNo) const
#if DAGISEL_INLINE
  override
#endif
{
  switch (PredNo) {
  default: llvm_unreachable("Invalid predicate in table?");
  case 0: {
    // Predicate_LaneIdx32
    int64_t Imm = cast<ConstantSDNode>(Node)->getSExtValue();
return 0 <= Imm && Imm < 32;
  }
  case 1: {
    // Predicate_atomic_cmp_swap_8
    // Predicate_atomic_load_8
    // Predicate_atomic_load_add_8
    // Predicate_atomic_load_and_8
    // Predicate_atomic_load_or_8
    // Predicate_atomic_load_sub_8
    // Predicate_atomic_load_xor_8
    // Predicate_atomic_store_8
    // Predicate_atomic_swap_8
    // Predicate_extloadi8
    // Predicate_sextloadi8
    // Predicate_zextloadi8
    SDNode *N = Node;
    (void)N;
if (cast<MemSDNode>(N)->getMemoryVT() != MVT::i8) return false;
return true;

  }
  case 2: {
    // Predicate_atomic_cmp_swap_16
    // Predicate_atomic_load_16
    // Predicate_atomic_load_add_16
    // Predicate_atomic_load_and_16
    // Predicate_atomic_load_or_16
    // Predicate_atomic_load_sub_16
    // Predicate_atomic_load_xor_16
    // Predicate_atomic_store_16
    // Predicate_atomic_swap_16
    // Predicate_extloadi16
    // Predicate_sextloadi16
    // Predicate_zextloadi16
    SDNode *N = Node;
    (void)N;
if (cast<MemSDNode>(N)->getMemoryVT() != MVT::i16) return false;
return true;

  }
  case 3: {
    // Predicate_atomic_cmp_swap_32
    // Predicate_atomic_load_32
    // Predicate_atomic_load_add_32
    // Predicate_atomic_load_and_32
    // Predicate_atomic_load_or_32
    // Predicate_atomic_load_sub_32
    // Predicate_atomic_load_xor_32
    // Predicate_atomic_store_32
    // Predicate_atomic_swap_32
    // Predicate_extloadi32
    // Predicate_sextloadi32
    // Predicate_zextloadi32
    SDNode *N = Node;
    (void)N;
if (cast<MemSDNode>(N)->getMemoryVT() != MVT::i32) return false;
return true;

  }
  case 4: {
    // Predicate_unindexedstore
    SDNode *N = Node;
    (void)N;
if (cast<StoreSDNode>(N)->getAddressingMode() != ISD::UNINDEXED) return false;
return true;

  }
  case 5: {
    // Predicate_store
    SDNode *N = Node;
    (void)N;
 if (cast<StoreSDNode>(N)->isTruncatingStore()) return false;
return true;

  }
  case 6: {
    // Predicate_atomic_cmp_swap_64
    // Predicate_atomic_load_64
    // Predicate_atomic_load_add_64
    // Predicate_atomic_load_and_64
    // Predicate_atomic_load_or_64
    // Predicate_atomic_load_sub_64
    // Predicate_atomic_load_xor_64
    // Predicate_atomic_store_64
    // Predicate_atomic_swap_64
    SDNode *N = Node;
    (void)N;
if (cast<MemSDNode>(N)->getMemoryVT() != MVT::i64) return false;
return true;

  }
  case 7: {
    // Predicate_load
    SDNode *N = Node;
    (void)N;
if (cast<LoadSDNode>(N)->getExtensionType() != ISD::NON_EXTLOAD) return false;
return true;

  }
  case 8: {
    // Predicate_ImmI8
    int64_t Imm = cast<ConstantSDNode>(Node)->getSExtValue();
return -(1 << (8 - 1)) <= Imm && Imm < (1 << (8 - 1));
  }
  case 9: {
    // Predicate_unindexedload
    SDNode *N = Node;
    (void)N;
if (cast<LoadSDNode>(N)->getAddressingMode() != ISD::UNINDEXED) return false;
return true;

  }
  case 10: {
    // Predicate_extload
    SDNode *N = Node;
    (void)N;
if (cast<LoadSDNode>(N)->getExtensionType() != ISD::EXTLOAD) return false;
return true;

  }
  case 11: {
    // Predicate_truncstore
    SDNode *N = Node;
    (void)N;
 if (!cast<StoreSDNode>(N)->isTruncatingStore()) return false;
return true;

  }
  case 12: {
    // Predicate_sextload
    SDNode *N = Node;
    (void)N;
if (cast<LoadSDNode>(N)->getExtensionType() != ISD::SEXTLOAD) return false;
return true;

  }
  case 13: {
    // Predicate_zextload
    SDNode *N = Node;
    (void)N;
if (cast<LoadSDNode>(N)->getExtensionType() != ISD::ZEXTLOAD) return false;
return true;

  }
  case 14: {
    // Predicate_ImmI16
    int64_t Imm = cast<ConstantSDNode>(Node)->getSExtValue();
return -(1 << (16 - 1)) <= Imm && Imm < (1 << (16 - 1));
  }
  case 15: {
    // Predicate_LaneIdx16
    int64_t Imm = cast<ConstantSDNode>(Node)->getSExtValue();
return 0 <= Imm && Imm < 16;
  }
  case 16: {
    // Predicate_LaneIdx8
    int64_t Imm = cast<ConstantSDNode>(Node)->getSExtValue();
return 0 <= Imm && Imm < 8;
  }
  case 17: {
    // Predicate_LaneIdx4
    int64_t Imm = cast<ConstantSDNode>(Node)->getSExtValue();
return 0 <= Imm && Imm < 4;
  }
  case 18: {
    // Predicate_LaneIdx2
    int64_t Imm = cast<ConstantSDNode>(Node)->getSExtValue();
return 0 <= Imm && Imm < 2;
  }
  case 19: {
    // Predicate_truncstorei8
    SDNode *N = Node;
    (void)N;
if (cast<MemSDNode>(N)->getMemoryVT() != MVT::i8) return false;
 if (!cast<StoreSDNode>(N)->isTruncatingStore()) return false;
return true;

  }
  case 20: {
    // Predicate_truncstorei16
    SDNode *N = Node;
    (void)N;
if (cast<MemSDNode>(N)->getMemoryVT() != MVT::i16) return false;
 if (!cast<StoreSDNode>(N)->isTruncatingStore()) return false;
return true;

  }
  case 21: {
    // Predicate_extloadvi8
    // Predicate_sextloadvi8
    // Predicate_zextloadvi8
    SDNode *N = Node;
    (void)N;
if (cast<LoadSDNode>(N)->getMemoryVT().getScalarType() != MVT::i8) return false;
return true;

  }
  case 22: {
    // Predicate_extloadvi16
    // Predicate_sextloadvi16
    // Predicate_zextloadvi16
    SDNode *N = Node;
    (void)N;
if (cast<LoadSDNode>(N)->getMemoryVT().getScalarType() != MVT::i16) return false;
return true;

  }
  case 23: {
    // Predicate_extloadvi32
    // Predicate_sextloadvi32
    // Predicate_zextloadvi32
    SDNode *N = Node;
    (void)N;
if (cast<LoadSDNode>(N)->getMemoryVT().getScalarType() != MVT::i32) return false;
return true;

  }
  case 24: {
    // Predicate_add_nuw
    SDNode *N = Node;
    (void)N;
return N->getFlags().hasNoUnsignedWrap();
  }
  case 25: {
    // Predicate_truncstorei32
    SDNode *N = Node;
    (void)N;
if (cast<MemSDNode>(N)->getMemoryVT() != MVT::i32) return false;
 if (!cast<StoreSDNode>(N)->isTruncatingStore()) return false;
return true;

  }
  case 26: {
    // Predicate_bool_node
    SDNode *N = Node;
    (void)N;

  return CurDAG->computeKnownBits(SDValue(N, 0)).countMinLeadingZeros() == 31;

  }
  }
}
#endif // GET_DAGISEL_BODY

#ifdef GET_DAGISEL_DECL
bool CheckComplexPattern(SDNode *Root, SDNode *Parent,
      SDValue N, unsigned PatternNo,
      SmallVectorImpl<std::pair<SDValue, SDNode *>> &Result) override;
#endif
#if defined(GET_DAGISEL_BODY) || DAGISEL_INLINE
bool DAGISEL_CLASS_COLONCOLON CheckComplexPattern(SDNode *Root, SDNode *Parent,
      SDValue N, unsigned PatternNo,
      SmallVectorImpl<std::pair<SDValue, SDNode *>> &Result)
#if DAGISEL_INLINE
  override
#endif
{
  unsigned NextRes = Result.size();
  switch (PatternNo) {
  default: llvm_unreachable("Invalid pattern # in table?");
  case 0:
    Result.resize(NextRes+2);
  return SelectAddrOperands32(N, Result[NextRes+0].first, Result[NextRes+1].first);
  case 1:
    Result.resize(NextRes+2);
  return SelectAddrOperands64(N, Result[NextRes+0].first, Result[NextRes+1].first);
  }
}
#endif // GET_DAGISEL_BODY


#ifdef DAGISEL_INLINE
#undef DAGISEL_INLINE
#endif
#ifdef DAGISEL_CLASS_COLONCOLON
#undef DAGISEL_CLASS_COLONCOLON
#endif
#ifdef GET_DAGISEL_DECL
#undef GET_DAGISEL_DECL
#endif
#ifdef GET_DAGISEL_BODY
#undef GET_DAGISEL_BODY
#endif
